/** 
*
*   Configurator.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _CONFIGURATOR_H_
#define _CONFIGURATOR_H_

#include "Global.h"

struct Parameter{

  string keyword;
  string value;

};

class Configurator {

    public:

        // constructor

        Configurator();

        // destructor

        ~Configurator();

        // functions

        string  GetParameter(string aKeyword);
        void    SetParameter(string aKeyword, string aVal);
        void    AddParameter(Parameter* aParameter);
        int     GetInt(string aKeyword);
        double  GetDouble(string aKeyword);
        void    PrintParameters(void);
        void    OutputParametersToFile(ofstream& aFile);

    private:

        vector<Parameter> mParameters;
};
#endif

