/** 
*
*   EquationOfState.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _EQUATION_OF_STATE_H_
#define _EQUATION_OF_STATE_H_

#include "Global.h"

/// abstract class

class EquationOfState {

    public:

        // destructor

        virtual  ~EquationOfState(){}

        // functions

        virtual double CsT(double aTemperature) = 0;
        virtual double TP(double aPressure) = 0;
        virtual double TE(double aEnergy) = 0;
        virtual double TS(double aEntropy) = 0;

        virtual double ET(double aTemperature) = 0;
        virtual double ST(double aTemperature) = 0;
        virtual double PT(double aTemperature) = 0;

        virtual double EpT(double aTemperature) = 0;
        virtual double SpT(double aTemperature) = 0;

        virtual void PrintInfo(void) = 0;
};
#endif // _EQUATION_OF_STATE_H_
