/** 
*
*   FlatInitialAnisotropy.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _FLAT_INITIAL_ANISOTROPY_H_
#define _FLAT_INITIAL_ANISOTROPY_H_

#include "Global.h"

class FlatInitialAnisotropy : public InitialAnisotropy {

    public:

        // constructor

        FlatInitialAnisotropy(Configurator *aConfigurator, Grid *aGrid, string aKey);

        // destructor

        virtual ~FlatInitialAnisotropy();

        // functions

        virtual double GetValue(int i, int j, int k); // returns xi value
        virtual void   PrintInfo(void);

    private:

        double mInitialAnisotropy;
    
        Grid *mGrid;
        Configurator *mConfigurator;

};
#endif // _FLAT_INITIAL_ANISOTROPY_H_
