/** 
*
*   GaussianInitialSource.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _GAUSSIAN_INITIAL_SOURCE_H_
#define _GAUSSIAN_INITIAL_SOURCE_H_

#include "Global.h"

class GaussianInitialSource : public InitialSource {

    public:

        // constructor

        GaussianInitialSource(Configurator *aConfigurator, Grid *aGrid);

        // destructor

        virtual ~GaussianInitialSource();

        // functions

        virtual double GetValue(int i, int j, int k);
        virtual void    PrintInfo(void);

    private:

        double mNormalizationFactor;
        double mSigmaX;
        double mSigmaY;
        double mSigmaZ;
//
//        int mEquationsChoice;

        Grid *mGrid;
        Configurator *mConfigurator;

//        double (GaussianInitialSource::*aFunction)(double x, double y, double z);
//        double  GetTemperature(double x, double y, double z);
//        double  GetLogTemperature(double x, double y, double z);
        double  Gauss3D(double x, double y, double z);
};

#endif // _GAUSSIAN_INITIAL_SOURCE_H_
