/** 
*
*   GlobalFunctions.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _GLOBAL_FUNCTIONS_H_
#define _GLOBAL_FUNCTIONS_H_

#include "Global.h"

// global types

enum Error_Type {
    EXIT_OK = 0,
    ERROR_FILE_NOT_FOUND = 1,
    ERROR_OPTION_MISSING = 2,
    ERROR_MEMORY_BAD_ALLOCATION = 3,
    ERROR_INPUT_PARAMETER_MISSING = 4,
    ERROR_INCORRECT_VALUE = 5,
    ERROR_FILE_CORRUPTED = 6,
    ERROR_VALUE_NOT_FOUND = 7,
};

// global functions

int     ProgramStatus(Error_Type mError, string mWhere);
void    PrintValue(double aValue);
void    PrintRawMessage(string aMessage);
void    PrintRawMessage(string aMessage1, string aMessage2);
void    PrintRawMessage(string aMessage, double aValue);
void    PrintMessage(string aMessage);
void    PrintMessage(string aMessage1, string aMessage2);
void    PrintMessage(string aMessage1, double aValue);
void    PrintEvolutionOutroMessage(string aMessage, const double *aDate);

bool    FileExists(const string& aFileName);
bool    MakeDirectory(string aPath);
void    ClearDirectory(string aPath);
bool    CopyFile(string aInputFile, string aOutputFile);
string  GetFilename(const string& str);
string  GetDirectory(const string& str);
double  s2d(const string& aString);
string  d2s(const double& aNumber);
string  delwhite(string aString);

#endif // _GLOBAL_FUNCTIONS_H_
