/**
*
*   HyperCube.h
*
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#ifndef _HYPERCUBE_H_
#define _HYPERCUBE_H_

#include "Global.h"

class HyperCube{

    public:

        inline double& operator()(unsigned int i1,unsigned int i2, unsigned int i3, unsigned int i4);

        HyperCube();
        ~HyperCube();
        void SetHyperCube(Vector4D *aVec, int x1, int x2, int x3, int x4);
        double**** GetHyperCube(void);

    private:

        double****	mHyp;

};

inline double& HyperCube::operator()(const unsigned int i1, const unsigned int i2, const unsigned int i3, const unsigned int i4)
{
  return mHyp[i1][i2][i3][i4];
}

#endif //_HYPERCUBE_H_
