/**
 *
 *   thermalmass.h
 *
 *   Copyright (C) 2015 Michael Strickland and Mubarak Alqahtani
 *
 *   This file is part of aHydro3p1.
 *
 *   aHydro3p1 is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   aHydro3p1 is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _LINEARTRANSPORTCOEFFICIENT_H_
#define _LINEARTRANSPORTCOEFFICIENT_H_

#include "Global.h"

class LinearTransportCoefficient {
    
public:
    
    // constructors
    
    LinearTransportCoefficient();
    
    LinearTransportCoefficient(double aEtabar, double aSlope1, double aSlope2, double aTc);
    
    // destructor
    
    ~LinearTransportCoefficient();
    
    // functions

    virtual double Value(double T);

private:
    
    double mEtabar;
    double mSlope1;
    double mSlope2;
    double mTc;
    
};

#endif // _LINEARTRANSPORTCOEFFICIENT_H_
