/** 
*
*   MCGlauber.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _MC_GLAUBER_H_
#define _MC_GLAUBER_H_

#include "Global.h"

class MCGlauber {

    public:

        // contructor

        MCGlauber(Configurator *aConfigurator, usi aSeed);

        // destructor

        ~MCGlauber();

        // functions

        void PrintInfo(void);
        usi GetNumberOfParticipants(void);
        double * GetXPointsArray(void);
        double * GetYPointsArray(void);
    
    private:

        Nucleus *mNucleusA;
        Nucleus *mNucleusB;

        double mb;      // Impact Parameter
        double mcross;  // Inelastic Cross Section
    
        usi mNpart; // number of participants in the event
        double *mxp; // x points
        double *myp; // y points

        usi LoadCollisionPointsArrays();
        void SampleNuclearDensity(Nucleus *nucleus, double *x, double *y);
    
};

#endif // _MC_GLAUBER_H_
