/** 
*
*   MCGlauberInitialSource.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _MC_GLAUBER_INITIAL_SOURCE_H_
#define _MC_GLAUBER_INITIAL_SOURCE_H_

#include "Global.h"

class MCGlauberInitialSource : public InitialSource {

    public:

        // constructor

        MCGlauberInitialSource(Configurator *aConfigurator, Grid *aGrid, usi aSeed);

        // destructor

        virtual ~MCGlauberInitialSource();

        // functions

        virtual double GetValue(int i, int j, int k);
        virtual void   PrintInfo(void);

    private:
//
//        int mEquationsChoice;

        Grid *mGrid;
        Configurator *mConfigurator;

        MCGlauber *mMCGlauber;

        double mNormalizationFactor;
        double mMCSig0;
        double mGaussianWidth;
        double mPlateauWidth;

        double (MCGlauberInitialSource::*aFunction)(double x, double y, double z);
        double GetTemperature(double x, double y, double z);
        double GetLogTemperature(double x, double y, double z);
        double SpatialRapidityProfile(double z);
        double GetProfile(double x, double y, double z);
};

#endif // _MC_GLAUBER_INITIAL_SOURCE_H_
