/** 
*
*   Nucleus.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _NUCLEUS_H_
#define _NUCLEUS_H_

#include "Global.h"

class Nucleus {

    public:

        // constructor

        Nucleus(unsigned short int aNumberOfNucleons, double aSurfaceDiffuseness, double aNuclearSaturationDensity, double aRadius = 0);

        // destructor

        ~Nucleus();

        // functions

        usi      GetNumberOfNucleons();
        double   GetNuclearThickness(double x, double y);
        double   GetNuclearDensity(double x, double y, double z);
        double   SetRadius(int aA);
        void     PrintInfo(void);

    private:

        double   Integrate(double (Nucleus::*aFunction)(double, double, double), double x, double y, double zMin, double zMax, double zPts);

        unsigned short int mA;
        double mR;
        double ma;
        double mrho0;
};

#endif // _NUCLEUS_H_
