/** 
*
*   OpticalGlauber.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _OPTICAL_GLAUBER_H_
#define _OPTICAL_GLAUBER_H_

#include "Global.h"

class OpticalGlauber {

    public:

        // contructor

        OpticalGlauber(Configurator *aConfigurator);

        // destructor

        ~OpticalGlauber();

        // functions

        double GetBC(double x, double y);
        double GetWNA(double x, double y);
        double GetWNB(double x, double y);
        double GetImpactParameter(void);
        double SetImpactParameter(double ab);
        void      PrintInfo(void);

    private:

        Nucleus *mNucleusA;
        Nucleus *mNucleusB;

        double mb;      // Impact Parameter
        double mcross;  // Inelastic Cross Section

};

#endif // _OPTICAL_GLAUBER_H_
