/** 
*
*   Parser.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _PARSER_H_
#define _PARSER_H_

#include "Global.h"

class Parser {

    public:

        // constructor

        Parser();
        Parser(string aFileName);

        // destructor

        ~Parser();

        // functions

        Configurator* ReadINI(void);
        Vector1D ** ReadEOS(const int &aN, const string* aNames);
        Vector4D*   ReadBIN(Configurator *aConfigurator, bool PrintInfoQ = 1);
        void   ReadHfuncsFile(vector<Vector3D> *hfuncInts);
    
    private:

        string      mFileName;
        ifstream    mFile;
    
        void IgnoreFileHeader(void);

};
#endif


