/** 
*
*   Stepper.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _STEPPER_H_
#define _STEPPER_H_

#include "Global.h"

/// abstract class

class Stepper {

    public:

        // destructor

        virtual ~Stepper(){}

        // functions

        virtual void    MakeTimeStep(double aTau) = 0;
        virtual void    AllocateMemory(Equations *aEquations) = 0;
        virtual void    Initialize(Initializer **aIArr) = 0;
        virtual void    FreeMemory(void) = 0;
        virtual         Vector3D *** GetArrays(void) = 0;
        virtual void    CopyArrays(const unsigned short int aFrom, const unsigned short int aTo) = 0;
        virtual usi     GetNumberOfVectors(void) = 0;
        virtual void    PrintInfo(void) = 0;

};
#endif //_STEPPER_H_
