/** 
*
*   WeightedLAXSmoother.h
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#ifndef _WEIGHTED_LAX_SMOOTHER_H_
#define _WEIGHTED_LAX_SMOOTHER_H_

#include "Global.h"

class WeightedLAXSmoother : public Smoother {

    public:

        // constructor

        WeightedLAXSmoother(Configurator *aConfigurator, Grid *aGrid, Stepper *aStepper, Equations *aEquations);

        // destructor

        virtual ~WeightedLAXSmoother();

        // functions

        virtual void Smooth(void);
        virtual void PrintInfo(void);

    private:

        // member functions

        inline void     CopyArrays(const usi aFrom, const usi aTo);

        // member variables

        Vector3D ***mVArr;

        // optimization variables

        const usi mXP;
        const usi mYP;
        const usi mZP;

        const usi mNEq;

        const double mLAXfrac;

};
#endif //_WEIGHTED_LAX_SMOOTHER_H_
