/** 
*
*   FlatInitialAnisotropy.cxx
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#include "Global.h"

FlatInitialAnisotropy::FlatInitialAnisotropy(Configurator *aConfigurator,  Grid *aGrid, string aKey):
mConfigurator(aConfigurator), mGrid(aGrid){

    PRINT_DEBUG_3("<FlatInitialAnisotropy::FlatInitialAnisotropy>");
    
    mInitialAnisotropy = mConfigurator->GetDouble(aKey);
    
}

FlatInitialAnisotropy::~FlatInitialAnisotropy(){

    PRINT_DEBUG_3("<FlatInitialAnisotropy::~FlatInitialAnisotropy>");

    // nothing to clean

}

double FlatInitialAnisotropy::GetValue(int i, int j, int k){

    PRINT_DEBUG_3("<FlatInitialAnisotropy::GetValue>");

    //return mInitialAnisotropy + small;
    return mInitialAnisotropy;

}

void FlatInitialAnisotropy::PrintInfo(void){

    PRINT_DEBUG_3("<FlatInitialAnisotropy::PrintInfo>");

    PrintRawMessage("-> Flat");
    PrintRawMessage("\tInitial Xi", d2s(mInitialAnisotropy));

}
