/** 
*
*   FlatInitialSource.cxx
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#include "Global.h"

FlatInitialSource::FlatInitialSource(Configurator *aConfigurator,  Grid *aGrid)
: mConfigurator(aConfigurator), mGrid(aGrid){

    PRINT_DEBUG_3("<FlatInitialSource::FlatInitialSource>");

    // InitialTemperatureFlat in [GeV]
    // all variables are transformed to [fm]

    mNormalizationFactor    = mConfigurator->GetDouble("InitialTemperature") / hbarc;
//    mEquationsChoice        = aConfigurator->GetInt("Equations");
//
//    switch(mEquationsChoice){
//
//        case 1:
//            // for PerfectFluidEquations
//            aFunction = &FlatInitialSource::GetLogTemperature;
//            break;
//
//        case 2:
//            // for AnisotropicFluidEquations
//            aFunction = &FlatInitialSource::GetTemperature;
//            break;
//
//        default:
//
//            exit(ProgramStatus(ERROR_OPTION_MISSING,
//            "FlatInitialSource::FlatInitialSource: Cannot find Equations for " + d2s(mEquationsChoice)));
//
//    }

}

FlatInitialSource::~FlatInitialSource(){

    PRINT_DEBUG_3("<FlatInitialSource::~FlatInitialSource>");

    // nothing to clean

}

double FlatInitialSource::GetValue(int i, int j, int k){

    PRINT_DEBUG_3("<FlatInitialSource::GetValue>");

    return mNormalizationFactor;
//
//   return (this->*aFunction)(mGrid->GetX(i), mGrid->GetY(j), mGrid->GetZ(k));

}
//
//double FlatInitialSource::GetTemperature(double x, double y, double z){
//
//    PRINT_DEBUG_3("<FlatInitialSource::GetTemperature>");
//
//    return mNormalizationFactor;
//
//}
//
//double FlatInitialSource::GetLogTemperature(double x, double y, double z){
//
//    PRINT_DEBUG_3("<FlatInitialSource::GetLogTemperature>");
//
//    return log(mNormalizationFactor);
//
//}

void FlatInitialSource::PrintInfo(void){

    PRINT_DEBUG_3("<FlatInitialSource::PrintInfo>");

    PrintRawMessage("-> Flat");
    PrintRawMessage("\tInitial Lambda", d2s(mNormalizationFactor) + " [1/fm] (" + d2s(mNormalizationFactor * hbarc) + " [GeV])");

}
