/**
 *
 *   LinearTransportCoefficient.cxx
 *
 *   Copyright (C) 2016 Mubarak Alqahtani and Michael Strickland
 *
 *   This file is part of aHydro3p1.
 *
 *   aHydro3p1 is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   aHydro3p1 is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "Global.h"

/*!
 *
 *  \brief Default constructor
 *
 */

LinearTransportCoefficient::LinearTransportCoefficient() {
    PRINT_DEBUG_3("<LinearTransportCoefficient:LinearTransportCoefficient>");
}

LinearTransportCoefficient::LinearTransportCoefficient(double aEtabar, double aSlope1, double aSlope2, double aTc) : mEtabar(aEtabar), mSlope1(aSlope1), mSlope2(aSlope2), mTc(aTc) {
    PRINT_DEBUG_3("<LinearTransportCoefficient:LinearTransportCoefficient>");
}


/*!
 *
 *  \brief Destructor
 *
 */

LinearTransportCoefficient::~LinearTransportCoefficient(){
    PRINT_DEBUG_3("<LinearTransportCoefficient::~LinearTransportCoefficient>");

}

double LinearTransportCoefficient::Value(double aT) {
    if (aT <= mTc) return mSlope1*(aT-mTc) + mEtabar;
    return mSlope2*(aT-mTc) + mEtabar;
}
