/** 
*
*   NoInitialFlowX.cxx
*	
*   Copyright (C) 2017 Radoslaw Ryblewski and Michael Strickland
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*    
*/

#include "Global.h"

NoInitialFlowX::NoInitialFlowX(Configurator *aConfigurator, Grid *aGrid)
: mConfigurator(aConfigurator), mGrid(aGrid){

    PRINT_DEBUG_3("<NoInitialFlowX::NoInitialFlowX>");

}

NoInitialFlowX::~NoInitialFlowX(){

    PRINT_DEBUG_3("<NoInitialFlowX::~NoInitialFlowX>");

    // nothing to clean

}

double NoInitialFlowX::GetValue(int i, int j, int k){

    PRINT_DEBUG_3("<NoInitialFlowX::GetValue>");

    return small * mGrid->GetX(i);

}

void NoInitialFlowX::PrintInfo(void){

    PRINT_DEBUG_3("<NoInitialFlowX::PrintInfo>");

    PrintRawMessage("-> No flow");

}
