/**
*
*   SpecialFunctions.cxx
*
*   Copyright (C) 2013 Radoslaw Ryblewski, Michael Strickland and Mubarak Alqahtani
*
*   This file is part of aHydro3p1.
*
*   aHydro3p1 is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   aHydro3p1 is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with aHydro3p1.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include "SpecialFunctions.h"

complex<double> atanh(complex<double> x){ // checked against MATHEMATICA

    return (complex<double>(0.5,0) * log((complex<double>(1,0) + x) / (complex<double>(1,0) - x)));
}

complex<double> acoth(complex<double> x){ // checked against MATHEMATICA

    return (complex<double>(0.5,0) * log((x + complex<double>(1,0)) / (x - complex<double>(1,0))));
}

double unitstep(double x){

    if(x < 0) return 0.0;
    else return 1.0;

}

//************************************************************************
// modified Bessel functions
//************************************************************************

double K(int n,double x){
	

	//gsl_sf_result result;
	if(x<0)return 0;
else return gsl_sf_bessel_Kn(n,x);
}

