#!/bin/bash

############################################################################################################
#SBATCH --job-name=fohse
#SBATCH --nodes=25
#SBATCH --ntasks=1
#SBATCH --ntasks-per-node=1
############################################################################################################

if (( $# != 2 )); then
    echo "Usage: freezeJobs.sh <RUNDIR> <TFO in GeV>"
    exit
fi

DIR=${1%/}
TFO=$2

RUN=$(basename $DIR)
CWD=$(pwd)

echo "Processing $RUN"
echo "Freezeout temperaure $TFO GeV"

for i in $(ls -d $DIR/*/) # lists only subdirs of $DIR
do
  j=${i%/}
  echo "Freezing $i"
  cd $i
  ID=$(ls -d output/bin/*/)
  ID=$(basename $ID)
  cp output/bin/$ID/$ID.ini ini/general.ini
  srun -n1 -N1 --exclusive ./aHydro3p1 -TFO $TFO -BINDir ./output/bin/$ID/ -EvaluationMode 10 > freezelog.out &
  cd $CWD
  sleep 2
done
wait
