(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     52999,       1128]
NotebookOptionsPosition[     50934,       1071]
NotebookOutlinePosition[     51345,       1087]
CellTagsIndexPosition[     51302,       1084]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 StyleBox["R Functions",
  FontSize->16,
  FontWeight->"Bold"],
 "\n\nwritten by:\nRadoslaw Ryblewski (rryblews@kent.edu)\n Michael \
Strickland (mstrick6@kent.edu) \n This notebook contains the form of R \
functions used in aHydro3p1 code and derived in arXiv:1007.0889."
}], "Text",
 CellChangeTimes->{{3.595944073727169*^9, 3.595944077014946*^9}, {
   3.595944109492612*^9, 3.5959441671140757`*^9}, 3.595944226538465*^9, {
   3.5980497076758547`*^9, 3.598049722998184*^9}},
 TextAlignment->Center,
 Background->RGBColor[0.88, 1, 0.88]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["(* FUNCTIONS *)",
 FontSize->12,
 FontWeight->"Bold"]], "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.595944073727169*^9, 3.595944077014946*^9}, {
  3.595944109492612*^9, 3.5959441671140757`*^9}, {3.595944226538465*^9, 
  3.5959442887286777`*^9}},
 FontSize->10,
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Ra", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"1", "+", "\[Xi]"}]], "+", 
       FractionBox[
        RowBox[{"ArcTan", "[", 
         SqrtBox["\[Xi]"], "]"}], 
        SqrtBox["\[Xi]"]]}], ")"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RTa", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     FractionBox["3", 
      RowBox[{"2", "\[Xi]"}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Xi]", "2"], "-", "1"}], ")"}], 
         RowBox[{"Ra", "[", "\[Xi]", "]"}]}]}], 
       RowBox[{"1", "+", "\[Xi]"}]], ")"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RLa", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     FractionBox["3", "\[Xi]"], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "\[Xi]"}], ")"}], 
         RowBox[{"Ra", "[", "\[Xi]", "]"}]}], "-", "1"}], 
       RowBox[{"1", "+", "\[Xi]"}]], ")"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rpa", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"Ra", "[", "\[Xi]", "]"}], ",", "\[Xi]"}], "]"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RTpa", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"RTa", "[", "\[Xi]", "]"}], ",", "\[Xi]"}], "]"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RLpa", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"RLa", "[", "\[Xi]", "]"}], ",", "\[Xi]"}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.592051178586387*^9, 3.592051353845251*^9}, {
   3.592051390453368*^9, 3.592051414713408*^9}, {3.592051582254715*^9, 
   3.592051629555202*^9}, {3.5929876042582083`*^9, 3.592987606337427*^9}, 
   3.594558257006535*^9, {3.595849201520916*^9, 3.5958492106136513`*^9}, 
   3.5959442373053627`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ra", "[", "X", "]"}], "//", "CForm"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.5945582570070343`*^9, 3.595944237305457*^9}],

Cell["(1/(1 + X) + ArcTan(Sqrt(X))/Sqrt(X))/2.", "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.59299084637038*^9, 3.5945582570074472`*^9, 
  3.59594423730553*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RTa", "[", "X", "]"}], "//", "CForm"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.59455825700879*^9, 3.595944237305601*^9}],

Cell["(3*(Sqrt(X) + (-1 + X)*ArcTan(Sqrt(X))))/(4.*Power(X,1.5))", "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5929908946378393`*^9, 3.594558257009285*^9, 
  3.5959442373056498`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RLa", "[", "X", "]"}], "//", "CForm"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.594558257009684*^9, 3.595944237305694*^9}],

Cell["(3*(-(Sqrt(X)/(1 + X)) + ArcTan(Sqrt(X))))/(2.*Power(X,1.5))", "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5929908947127037`*^9, 3.594558257010045*^9, 
  3.595944237305739*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Rpa", "[", "X", "]"}], "//", "CForm"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.594558257010373*^9, 3.595944237305784*^9}],

Cell["\<\
-(-1 + X)/(4.*X*Power(1 + X,2)) - ArcTan(Sqrt(X))/(4.*Power(X,1.5))\
\>", "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.59299089475419*^9, 3.594558257010734*^9, 
  3.595944237305829*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RTpa", "[", "X", "]"}], "//", "CForm"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.594558257011057*^9, 3.595944237305873*^9}],

Cell["\<\
(-3*(3 + X))/(8.*Power(X,2)*(1 + X)) - (3*(-3 + \
X)*ArcTan(Sqrt(X)))/(8.*Power(X,2.5))\
\>", "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.592990895028042*^9, 3.5945582570116253`*^9, 
  3.5959442373059177`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RLpa", "[", "X", "]"}], "//", "CForm"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.594558257011984*^9, 3.595944237305962*^9}],

Cell["\<\
(3*(3 + 5*X))/(4.*Power(X,2)*Power(1 + X,2)) - \
(9*ArcTan(Sqrt(X)))/(4.*Power(X,2.5))\
\>", "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.592990895259788*^9, 3.5945582570123158`*^9, 
  3.595944237306005*^9}],

Cell[BoxData[{
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Re", "[", 
      RowBox[{"Ra", "[", "\[Xi]", "]"}], "]"}], ",", 
     RowBox[{"Re", "[", 
      RowBox[{"RLa", "[", "\[Xi]", "]"}], "]"}], ",", 
     RowBox[{"Re", "[", 
      RowBox[{"RTa", "[", "\[Xi]", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Xi]", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Re", "[", 
       RowBox[{"Rpa", "[", "\[Xi]", "]"}], "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"Re", "[", 
       RowBox[{"RLpa", "[", "\[Xi]", "]"}], "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"Re", "[", 
       RowBox[{"RTpa", "[", "\[Xi]", "]"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Xi]", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.592051424393719*^9, 3.592051474604593*^9}, {
   3.592051644610726*^9, 3.592051645555205*^9}, {3.592990910964212*^9, 
   3.592990931049212*^9}, {3.595849243392449*^9, 3.595849363544717*^9}, {
   3.595849423814108*^9, 3.595849432114091*^9}, 3.5959442373060493`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVknk81Ykahx1LY0mEk6xTUgmXqGS97xlbWZo6SpRka7GmtJA0IrpqXGun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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwVxXk01AkcAPBxNVY5sg8JiWIV6yqaDn0n5UyJXFu56qUyso1yrxzZHj3S
OkrSsTmig1CODF85Gnkk5GoQk5H5TebnyjnW7v7xeR+t0787nxWnUChO//l/
m1R6gMpLATpuoGU/thCn85U2yub8IcB3Sya79veK0V8zGqXkBwk0xVLKUjmF
TtscaJLfS6Crv8bDthcU+ptPKp4WnQS2fk+5+DSXQq+zYLxisAmkMA87RqdS
6C3yimeaSwiceTm6JT2QQh8u866LvU7guTWTpSf0KHQZ0VLErBGBLWID+7oP
roJPkslkfxwfz5an7Td0WYGIV6nX26L4GMwas4qwXoGMgRn1t2F8PHpB+uJH
2gq0GJTbFQTy0VLz1GCWxgrsaNuTE3KCj50bfR7lfxPBGrlDbj+b8jGz/b4w
KUoEz1PcWA4j45gtT6WavVyGhdTIBIRxJI/T9B0NlyBHbkg1c2QM3Ubyfz1t
Mw/Z9iZBXYk8XPWPPPD0wyzEBfiGbbMbRb87j8VC6qchUuJpaNAEF5cHmKEL
9ZPgG9O+tadgBJna6fZS2kLIqOFlZvsPo1Ne6PZlRQG8+aK37rn2EMbe/OtC
stg4bFGgW7o84OD03wtjdh48KN2e4M/92oc6MQEU33wufGkq2Wxu3oOXrnUx
p/WHgWeQYYrlXWiZQTUlljmw/mqhuaFYB/bTFFIa43rBwJw0yJtpRcu1fq7v
k7rg2qGJj1VhbMy8Sblzk/wASi5Ft35TqUe96dmx9iNsKJ1rkm/e+gYj4lVO
9VytgzwOL5kfX4TfaVdcW/tKwdNJ/RXnTDrWNjN3+ZVlQpVMZHd9cBoIn6QV
7NS5g2ZcsU2xHsUw41Y5KWFXilsmqxf31FdBWbWfQmxCDdrl9Lcd9agHhixT
tzW/Ea2OKEr8eM2GBHPHdJW9LZji3RtjXNEKTE1P6X8OtSP7qIbsMcUOiHrm
dd7ZthMntJSudmZ1gZWakc2aok8YfEXfN0W5B3ZHFTb0z/Vg74CCs19zH4iU
nD+We/ejT/i+b1QHDuhUUswSUzjYoL/rRoPUEOjx7HJpQ4Oo+xNrPNd2GI6L
iG7f+S+owWJYSSWMgErl3Oe7omGkLIkXBnG5kBH93DZ4HRfnnWq8mnRGoWz3
ooOq5Ffk7PRW04nngXGy1VpdmVG85K6wXntgDGgZcabuUjxUTR/1kNQYhyl1
LTKC4GHRyUdPZsL4ME9Ns70xOIbuFtG2zTUE0O0F0dnV37DE66L2HpEAysZr
i+dujeOCzEGJKtcJsLlEEzVc5qNzx15zjUwh+F0/mWV8kECZvWvfsu4LQZnB
bW+yJvBt7ufDp3KEIL34uOKEPYHGYeG+94qEcHYH9cE1JwLlNCuSVJuEkOjQ
w+7wJvB9gOlXpWkhXK5xuef9B4F06W235BxIWPrF5uGB1wQuMBc2FjmRcNto
0aytksBiDjvviDsJIftTYjxYBG4q9qtOOk2CVfc9k8AGAkWuuWMy4SQoDeVK
3u4gsCJH04KaT0Ii+Tm8d4LAQFmSnf+MBCMK4eI1RaBuaK2zdQkJkmovRkdn
CUy39zz/J4uED4tx2lPLBAZNZaVJdJHgGNC9YY2MALef9N+U00fCux/fs27I
CnCkcXeh5RAJBraanXLrBXgss682lk+C6BzVR3mDAKXFC+y0SBIcanrK76oJ
EBmhn+pmSbAQzNSrawowpNva22eJhOQXjPiH2gI0BGVidZWEuyz7ZS1dAf4L
JGyz+Q==
     "]]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], LineBox[CompressedData["
1:eJwVkHk81Pkfx525cuTaamMLSdKBUsp4l9VBVFSuDrFp3XbZoiSRyopS1Eqq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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{-1, -0.8484048755689343},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  FrameTicks->{{{{0., 
       FormBox[
        TagBox[
         InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.302585092994046, 
       FormBox[
        TagBox[
         InterpretationBox["\"10.0\"", 10., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.6094379124341003`, 
       FormBox[
        TagBox[
         InterpretationBox["\"5.0\"", 5., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {3.912023005428146, 
       FormBox[
        TagBox[
         InterpretationBox["\"50.0\"", 50., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"2.0\"", 2., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.995732273553991, 
       FormBox[
        TagBox[
         InterpretationBox["\"20.0\"", 20., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.0986122886681098`, 
       FormBox[
        TagBox[
         InterpretationBox["\"3.0\"", 3., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {3.4011973816621555`, 
       FormBox[
        TagBox[
         InterpretationBox["\"30.0\"", 30., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0.4054651081081644, 
       FormBox[
        TagBox[
         InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.70805020110221, 
       FormBox[
        TagBox[
         InterpretationBox["\"15.0\"", 15., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.9459101490553132`, 
       FormBox[
        TagBox[
         InterpretationBox["\"7.0\"", 7., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {4.248495242049359, 
       FormBox[
        TagBox[
         InterpretationBox["\"70.0\"", 70., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0.09531017980432493, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.1823215567939548, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.26236426446749106`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.336472236621213, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.47000362924573563`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5306282510621705, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5877866649021191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6418538861723948, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.3978952727983707`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.4849066497880004`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.5649493574615367`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.6390573296152584`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.772588722239781, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.833213344056216, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.8903717578961645`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.9444389791664403`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{0., 
       FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm]}, {0.4054651081081644, 
       FormBox["\"\"", TraditionalForm]}, {2.70805020110221, 
       FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm]}, {0.09531017980432493, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.1823215567939548, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.26236426446749106`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.336472236621213, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.47000362924573563`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5306282510621705, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5877866649021191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6418538861723948, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.3978952727983707`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.4849066497880004`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.5649493574615367`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.6390573296152584`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.772588722239781, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.833213344056216, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.8903717578961645`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.9444389791664403`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}, {Automatic, Automatic}},
  GridLines->{None, None},
  Method->{},
  PlotRange->{{-1, 1}, {-0.8484048755689343, 2.280095310651667}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{Automatic, {{0., 
      FormBox[
       TagBox[
        InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.302585092994046, 
      FormBox[
       TagBox[
        InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.6094379124341003`, 
      FormBox[
       TagBox[
        InterpretationBox["\"5.0\"", 5., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {3.912023005428146, 
      FormBox[
       TagBox[
        InterpretationBox["\"50.0\"", 50., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0.6931471805599453, 
      FormBox[
       TagBox[
        InterpretationBox["\"2.0\"", 2., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.995732273553991, 
      FormBox[
       TagBox[
        InterpretationBox["\"20.0\"", 20., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.0986122886681098`, 
      FormBox[
       TagBox[
        InterpretationBox["\"3.0\"", 3., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {3.4011973816621555`, 
      FormBox[
       TagBox[
        InterpretationBox["\"30.0\"", 30., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0.4054651081081644, 
      FormBox[
       TagBox[
        InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.70805020110221, 
      FormBox[
       TagBox[
        InterpretationBox["\"15.0\"", 15., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.9459101490553132`, 
      FormBox[
       TagBox[
        InterpretationBox["\"7.0\"", 7., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {4.248495242049359, 
      FormBox[
       TagBox[
        InterpretationBox["\"70.0\"", 70., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0.09531017980432493, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.1823215567939548, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.26236426446749106`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.336472236621213, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.47000362924573563`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.5306282510621705, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.5877866649021191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.6418538861723948, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.3862943611198906`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.791759469228055, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.0794415416798357`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.1972245773362196`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.3978952727983707`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.4849066497880004`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.5649493574615367`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.6390573296152584`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.772588722239781, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.833213344056216, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.8903717578961645`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.9444389791664403`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.6888794541139363`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.0943445622221, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{
  3.592051475876592*^9, {3.592051637548903*^9, 3.592051646066723*^9}, 
   3.5929102741095448`*^9, {3.5929909058566*^9, 3.592990931807517*^9}, {
   3.5958492315478888`*^9, 3.595849364283617*^9}, {3.595849425709341*^9, 
   3.595849432701292*^9}, 3.595944237306096*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVxXk81HkfAHD3MeMYBl0I4XHMy5XkiO+3lshW68ysW8mWHNElanWotdLy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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwVink81HkfwK0jN3OYkaJkacvKOqeyeb7fSjKusEQaobQrwmY7HD05K+2q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     "]]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], LineBox[CompressedData["
1:eJwVjmk81Gsfh+37zuh0DjmVnEJkl6X7thw1Ex50IkoiSjlUCClEthCyfVRK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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{-1, -1.8266529356629715`},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  FrameTicks->{{{{-2.302585092994046, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.1\"", 0.1, AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.5\"", 0.5, AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0., 
       FormBox[
        TagBox[
         InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.6094379124341003`, 
       FormBox[
        TagBox[
         InterpretationBox["\"5.0\"", 5., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.302585092994046, 
       FormBox[
        TagBox[
         InterpretationBox["\"10.0\"", 10., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {3.912023005428146, 
       FormBox[
        TagBox[
         InterpretationBox["\"50.0\"", 50., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {4.605170185988092, 
       FormBox[
        TagBox[
         InterpretationBox["\"100.0\"", 100., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {6.214608098422191, 
       FormBox[
        TagBox[
         InterpretationBox["\"500.0\"", 500., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.5108256237659907, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.35667494393873245`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{-2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {0., 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.5108256237659907, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.35667494393873245`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}, {Automatic, Automatic}},
  GridLines->{None, None},
  Method->{},
  PlotRange->{{-1, 1}, {-1.8266529356629715`, 5.568779331227562}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{Automatic, {{-2.302585092994046, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.1\"", 0.1, AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-0.6931471805599453, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.5\"", 0.5, AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0., 
      FormBox[
       TagBox[
        InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.6094379124341003`, 
      FormBox[
       TagBox[
        InterpretationBox["\"5.0\"", 5., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.302585092994046, 
      FormBox[
       TagBox[
        InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {3.912023005428146, 
      FormBox[
       TagBox[
        InterpretationBox["\"50.0\"", 50., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {4.605170185988092, 
      FormBox[
       TagBox[
        InterpretationBox["\"100.0\"", 100., AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {6.214608098422191, 
      FormBox[
       TagBox[
        InterpretationBox["\"500.0\"", 500., AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-1.6094379124341003`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-1.203972804325936, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.916290731874155, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.5108256237659907, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.35667494393873245`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.2231435513142097, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.10536051565782628`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.6931471805599453, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.0986122886681098`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.3862943611198906`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.791759469228055, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.9459101490553132`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.0794415416798357`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.1972245773362196`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.995732273553991, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.4011973816621555`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.6888794541139363`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.0943445622221, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.248495242049359, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.382026634673881, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.499809670330265, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{
  3.592051475876592*^9, {3.592051637548903*^9, 3.592051646066723*^9}, 
   3.5929102741095448`*^9, {3.5929909058566*^9, 3.592990931807517*^9}, {
   3.5958492315478888`*^9, 3.595849364283617*^9}, {3.595849425709341*^9, 
   3.595849432717092*^9}, 3.595944237306136*^9}]
}, Open  ]]
},
WindowSize->{1301, 744},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "iso8859-1"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 554, 12, 157, "Text"],
Cell[CellGroupData[{
Cell[979, 29, 361, 8, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[1343, 39, 2406, 76, 263, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[3752, 117, 202, 4, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[3957, 123, 250, 5, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[4210, 130, 200, 4, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[4413, 136, 272, 5, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[4688, 143, 201, 4, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[4892, 149, 272, 5, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5167, 156, 201, 4, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5371, 162, 284, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5658, 171, 202, 4, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5863, 177, 309, 8, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6175, 187, 202, 4, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6380, 193, 306, 8, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6689, 203, 1284, 34, 65, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[7976, 239, 21907, 425, 254, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[29886, 666, 21032, 402, 252, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]]
}
]
*)

