(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     25380,        633]
NotebookOptionsPosition[     23396,        578]
NotebookOutlinePosition[     23807,        594]
CellTagsIndexPosition[     23764,        591]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 StyleBox["Operators",
  FontSize->16,
  FontWeight->"Bold"],
 "\n\n\nwritten by: \nRadoslaw Ryblewski (rryblews@kent.edu)\nMichael \
Strickland (mstrick6@kent.edu)\n\nThis notebook contains derivation and check \
of operators used in evolution equations contained in aHydro3p1_equations.nb \
and arXiv:1207.0629.\n"
}], "Text",
 CellChangeTimes->{{3.59204670566858*^9, 3.592046710383903*^9}, 
   3.59473556569312*^9, {3.595943452097937*^9, 3.595943513646103*^9}, {
   3.595943750008525*^9, 3.595943762445745*^9}, {3.5959439587670317`*^9, 
   3.5959439790272217`*^9}, {3.598049740397081*^9, 3.598049748888302*^9}},
 TextAlignment->Center,
 Background->RGBColor[0.88, 1, 0.88]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["(* OPERATORS *)",
 FontWeight->"Bold"]], "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.59204670566858*^9, 3.592046710383903*^9}, {
   3.594735549493971*^9, 3.594735555429001*^9}, 3.594735658419179*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   SubscriptBox["g", 
    RowBox[{"\[Mu]\[Nu]", " "}]], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"g", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "partial", " ", "derivatives", " ", "with", " ", "respect", " ", "to", 
     " ", "z", " ", "and", " ", "t"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    SubscriptBox["\[PartialD]", "\[Mu]"], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"dt", "[", "X_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"+", " ", 
        RowBox[{"Cosh", "[", "\[Eta]", "]"}]}], 
       RowBox[{"D", "[", 
        RowBox[{"X", ",", "\[Tau]"}], "]"}]}], "-", 
      RowBox[{
       FractionBox[
        RowBox[{"Sinh", "[", "\[Eta]", "]"}], "\[Tau]"], 
       RowBox[{"D", "[", 
        RowBox[{"X", ",", "\[Eta]"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"dx", "[", "X_", "]"}], ":=", 
     RowBox[{"D", "[", 
      RowBox[{"X", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"dy", "[", "X_", "]"}], ":=", 
     RowBox[{"D", "[", 
      RowBox[{"X", ",", "y"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"dz", "[", "X_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Sinh", "[", "\[Eta]", "]"}]}], 
       RowBox[{"D", "[", 
        RowBox[{"X", ",", "\[Tau]"}], "]"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"Cosh", "[", "\[Eta]", "]"}], "\[Tau]"], 
       RowBox[{"D", "[", 
        RowBox[{"X", ",", "\[Eta]"}], "]"}]}]}]}], ";"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.5947356584206963`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Subs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"u0", "\[Rule]", " ", 
      RowBox[{"u0", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ux", "\[Rule]", " ", 
      RowBox[{"ux", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"uy", "\[Rule]", 
      RowBox[{"uy", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Theta]", "\[Rule]", " ", 
      RowBox[{"\[Theta]", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.594731671459627*^9, 3.5947317556370363`*^9}, 
   3.594735658421908*^9, {3.594735996669034*^9, 3.594736035752529*^9}, {
   3.5947361458559103`*^9, 3.5947361517549067`*^9}, {3.594736363159357*^9, 
   3.594736365628231*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "parametrization", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   SuperscriptBox["U", "\[Mu]"], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"U", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"u0", " ", 
         RowBox[{"Cosh", "[", "\[Theta]", "]"}]}], ",", "ux", ",", "uy", ",", 
        RowBox[{"u0", " ", 
         RowBox[{"Sinh", "[", "\[Theta]", "]"}]}]}], "}"}], "/.", "Subs"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    SuperscriptBox["V", "\[Mu]"], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"V", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Sinh", "[", "\[Theta]", "]"}], ",", "0", ",", "0", ",", 
        RowBox[{"Cosh", "[", "\[Theta]", "]"}]}], "}"}], "/.", "Subs"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    SubscriptBox["U", "\[Mu]"], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"u", "=", 
     RowBox[{"g", ".", "U"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    SubscriptBox["V", "\[Mu]"], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"v", "=", 
     RowBox[{"g", ".", "V"}]}], ";"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947311158187733`*^9, 3.5947313216800013`*^9}, {
   3.594731516424604*^9, 3.59473162958458*^9}, {3.594731661911435*^9, 
   3.5947316690401506`*^9}, {3.5947317606141653`*^9, 
   3.5947317922981987`*^9}, {3.594731823307968*^9, 3.59473201462123*^9}, 
   3.594732168763628*^9, {3.594734940602982*^9, 3.594735158949073*^9}, {
   3.59473559159138*^9, 3.5947356144596453`*^9}, 3.5947356584314337`*^9, {
   3.5959435823250017`*^9, 3.5959435849375*^9}}],

Cell["(* (1) derivation of operators *)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.59204670566858*^9, 3.592046710383903*^9}, {
   3.594735549493971*^9, 3.594735555429001*^9}, 3.594735658419179*^9, {
   3.595943815252083*^9, 3.595943892523423*^9}, 3.59594393713888*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UD2", "[", "X_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"U", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     RowBox[{"dt", "[", "X", "]"}]}], "+", 
    RowBox[{
     RowBox[{"U", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
     RowBox[{"dx", "[", "X", "]"}]}], "+", 
    RowBox[{
     RowBox[{"U", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
     RowBox[{"dy", "[", "X", "]"}]}], "+", 
    RowBox[{
     RowBox[{"U", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
     RowBox[{"dz", "[", "X", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VD2", "[", "X_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"V", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     RowBox[{"dt", "[", "X", "]"}]}], "+", 
    RowBox[{
     RowBox[{"V", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
     RowBox[{"dx", "[", "X", "]"}]}], "+", 
    RowBox[{
     RowBox[{"V", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
     RowBox[{"dy", "[", "X", "]"}]}], "+", 
    RowBox[{
     RowBox[{"V", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
     RowBox[{"dz", "[", "X", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DU2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"dt", "[", 
      RowBox[{"U", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "]"}], "+", 
     RowBox[{"dx", "[", 
      RowBox[{"U", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "]"}], "+", 
     RowBox[{"dy", "[", 
      RowBox[{"U", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
      "]"}], "+", 
     RowBox[{"dz", "[", 
      RowBox[{"U", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
      "]"}]}], "//", "TrigReduce"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DV2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"dt", "[", 
      RowBox[{"V", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "]"}], "+", 
     RowBox[{"dx", "[", 
      RowBox[{"V", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "]"}], "+", 
     RowBox[{"dy", "[", 
      RowBox[{"V", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
      "]"}], "+", 
     RowBox[{"dz", "[", 
      RowBox[{"V", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
      "]"}]}], "//", "TrigReduce"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UVDV2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"u", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      RowBox[{"VD2", "[", 
       RowBox[{"V", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       "]"}]}], "+", 
     RowBox[{
      RowBox[{"u", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      RowBox[{"VD2", "[", 
       RowBox[{"V", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}]}], "+", 
     RowBox[{
      RowBox[{"u", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
      RowBox[{"VD2", "[", 
       RowBox[{"V", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
       "]"}]}], "+", 
     RowBox[{
      RowBox[{"u", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
      RowBox[{"VD2", "[", 
       RowBox[{"V", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
       "]"}]}]}], "//", "TrigReduce"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VUDU2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"v", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      RowBox[{"UD2", "[", 
       RowBox[{"U", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       "]"}]}], "+", 
     RowBox[{
      RowBox[{"v", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      RowBox[{"UD2", "[", 
       RowBox[{"U", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}]}], "+", 
     RowBox[{
      RowBox[{"v", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
      RowBox[{"UD2", "[", 
       RowBox[{"U", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
       "]"}]}], "+", 
     RowBox[{
      RowBox[{"v", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
      RowBox[{"UD2", "[", 
       RowBox[{"U", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
       "]"}]}]}], "//", "TrigReduce"}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{
  3.594731898373954*^9, {3.594732027270402*^9, 3.594732313463151*^9}, 
   3.594732465948265*^9, {3.594732500221753*^9, 3.594732503983881*^9}, 
   3.594732549335693*^9, 3.594734014776123*^9, 3.5947342775479193`*^9, {
   3.5947348386586027`*^9, 3.5947349180385637`*^9}, {3.5947351749106617`*^9, 
   3.594735195917199*^9}, {3.594735360663878*^9, 3.594735415059065*^9}, 
   3.594735536241825*^9, {3.594735621993556*^9, 3.594735658431534*^9}, {
   3.594736659989973*^9, 3.594736665331661*^9}, {3.595943595321347*^9, 
   3.5959436219806633`*^9}, {3.595943834136353*^9, 3.595943851864786*^9}}],

Cell["\<\
(* (2) form of operators used in arXiv:1207.0629 and in the \
aHydro3p1_equations.nb file. *)\
\>", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.59204670566858*^9, 3.592046710383903*^9}, {
   3.594735549493971*^9, 3.594735555429001*^9}, 3.594735658419179*^9, {
   3.595943815252083*^9, 3.595943827768712*^9}, {3.595943894388022*^9, 
   3.595943900011621*^9}, 3.5959439371389513`*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"form", " ", "of", " ", "operators", " ", "used", " ", "in", " ", 
    RowBox[{"arXiv", ":", 
     RowBox[{"1207.0629", " ", "and", " ", "in", " ", "the", " ", 
      RowBox[{"aHydro3p1_equations", ".", "nb"}], " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[CapitalDelta]", "=", 
     RowBox[{"\[Eta]", "-", 
      RowBox[{"\[Theta]", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"L1", "[", "X_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "\[Tau]"]}], 
       RowBox[{"Sinh", "[", "\[CapitalDelta]", "]"}], " ", 
       RowBox[{
        SubscriptBox["\[PartialD]", "\[Eta]"], "X"}]}], "+", 
      RowBox[{
       RowBox[{"Cosh", "[", "\[CapitalDelta]", "]"}], 
       RowBox[{
        SubscriptBox["\[PartialD]", "\[Tau]"], "X"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"L2", "[", "X_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"+", 
        FractionBox["1", "\[Tau]"]}], " ", 
       RowBox[{"Cosh", "[", "\[CapitalDelta]", "]"}], 
       RowBox[{
        SubscriptBox["\[PartialD]", "\[Eta]"], "X"}]}], "-", 
      RowBox[{
       RowBox[{"Sinh", "[", "\[CapitalDelta]", "]"}], " ", 
       RowBox[{
        SubscriptBox["\[PartialD]", "\[Tau]"], "X"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DpUp", "=", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[PartialD]", "x"], 
       RowBox[{"ux", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}], "+", 
      RowBox[{
       SubscriptBox["\[PartialD]", "y"], 
       RowBox[{"uy", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpDp", "[", "X_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"ux", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], " ", 
       RowBox[{
        SubscriptBox["\[PartialD]", "x"], "X"}]}], "+", 
      RowBox[{
       RowBox[{"uy", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
       RowBox[{
        SubscriptBox["\[PartialD]", "y"], "X"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UD", "[", "X_", "]"}], ":=", " ", 
     RowBox[{
      RowBox[{"UpDp", "[", "X", "]"}], "+", 
      RowBox[{
       RowBox[{"u0", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
       RowBox[{"L1", "[", "X", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VD", "[", "X_", "]"}], ":=", 
     RowBox[{"L2", "[", "X", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DU", "=", 
     RowBox[{"DpUp", "+", 
      RowBox[{"L1", "[", 
       RowBox[{"u0", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}], 
      "+", 
      RowBox[{
       RowBox[{"u0", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
       RowBox[{"L2", "[", 
        RowBox[{"\[Theta]", "[", 
         RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
        "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DV", "=", 
     RowBox[{"L1", "[", 
      RowBox[{"\[Theta]", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"UVDV", "=", 
     RowBox[{
      RowBox[{"u0", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
      RowBox[{"L2", "[", 
       RowBox[{"\[Theta]", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"VUDU", "=", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"u0", "[", 
        RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}]}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"UpDp", "[", 
         RowBox[{"\[Theta]", "[", 
          RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}],
         "+", 
        RowBox[{
         RowBox[{"u0", "[", 
          RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
         RowBox[{"L1", "[", 
          RowBox[{"\[Theta]", "[", 
           RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], 
          "]"}]}]}], ")"}]}]}], ";"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.594732451478382*^9, 3.5947324555122213`*^9}, {
   3.5947325671618547`*^9, 3.5947325973365927`*^9}, {3.5947326511318827`*^9, 
   3.5947326714250603`*^9}, 3.594732866962226*^9, {3.594732917286675*^9, 
   3.594732930218255*^9}, {3.594733019742096*^9, 3.5947330241007032`*^9}, {
   3.594733060390937*^9, 3.594733099106649*^9}, {3.594733385613022*^9, 
   3.59473338960798*^9}, 3.594733451728963*^9, 3.594733486279674*^9, {
   3.594733640547624*^9, 3.594733657662939*^9}, {3.594734115837618*^9, 
   3.594734234007477*^9}, {3.5947342960573063`*^9, 3.594734303583251*^9}, {
   3.594734368612153*^9, 3.594734369905889*^9}, {3.594734425621709*^9, 
   3.5947344265518503`*^9}, 3.5947344661598063`*^9, {3.5947345206185503`*^9, 
   3.5947345974963627`*^9}, {3.5947347104747066`*^9, 3.5947348435095*^9}, {
   3.5947353113891697`*^9, 3.5947353286478643`*^9}, {3.594735506182358*^9, 
   3.5947355305480947`*^9}, 3.594735658431628*^9, {3.594736671941555*^9, 
   3.594736675985826*^9}, {3.595943636377582*^9, 3.595943655473609*^9}, {
   3.595943694001707*^9, 3.595943739637142*^9}, 3.595943815252151*^9, 
   3.595943937139016*^9}],

Cell["(* check that operators defined in (1) agrees with (2) *)", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.59204670566858*^9, 3.592046710383903*^9}, {
   3.594735549493971*^9, 3.594735555429001*^9}, 3.594735658419179*^9, {
   3.595943815252083*^9, 3.595943827768712*^9}, {3.595943882925359*^9, 
   3.595943937139077*^9}},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"check", " ", "that", " ", "operators", " ", "defined"}], "  ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DU", "-", "DU2"}], "//", "Simplify"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DV", "-", "DV2"}], "//", "Simplify"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UD", "[", 
      RowBox[{"X", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}], 
     "-", 
     RowBox[{"UD2", "[", 
      RowBox[{"X", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}]}], 
    "//", "Simplify"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VD", "[", 
      RowBox[{"X", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}], 
     "-", 
     RowBox[{"VD2", "[", 
      RowBox[{"X", "[", 
       RowBox[{"\[Tau]", ",", "x", ",", "y", ",", "\[Eta]"}], "]"}], "]"}]}], 
    "//", "Simplify"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"UVDV", "-", "UVDV2"}], "//", "Simplify"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"VUDU", "-", "VUDU2"}], "//", "Simplify"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.594734240262622*^9, 3.594734263933134*^9}, {
   3.594734342703863*^9, 3.594734364884557*^9}, {3.594734407807575*^9, 
   3.594734408948586*^9}, 3.594734443438323*^9, {3.594734475375256*^9, 
   3.594734498201982*^9}, {3.594735217920966*^9, 3.594735244106387*^9}, {
   3.594735341897704*^9, 3.59473535445669*^9}, {3.594735490513612*^9, 
   3.594735499374127*^9}, 3.594735658431809*^9, {3.5959437691281652`*^9, 
   3.595943779104467*^9}}],

Cell[BoxData["0"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947342437932987`*^9, 3.594734264878827*^9}, {
   3.594734438567255*^9, 3.594734445125599*^9}, {3.594734480155136*^9, 
   3.5947345011715717`*^9}, {3.5947352308953543`*^9, 3.594735246793047*^9}, 
   3.594735335846848*^9, 3.594735436534276*^9, {3.594735646372197*^9, 
   3.594735658431889*^9}, 3.5947357109880733`*^9, 3.594736487604253*^9, 
   3.5947366793221807`*^9, 3.595943926908186*^9}],

Cell[BoxData["0"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947342437932987`*^9, 3.594734264878827*^9}, {
   3.594734438567255*^9, 3.594734445125599*^9}, {3.594734480155136*^9, 
   3.5947345011715717`*^9}, {3.5947352308953543`*^9, 3.594735246793047*^9}, 
   3.594735335846848*^9, 3.594735436534276*^9, {3.594735646372197*^9, 
   3.594735658431889*^9}, 3.5947357109880733`*^9, 3.594736487604253*^9, 
   3.5947366793221807`*^9, 3.5959439269107533`*^9}],

Cell[BoxData["0"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947342437932987`*^9, 3.594734264878827*^9}, {
   3.594734438567255*^9, 3.594734445125599*^9}, {3.594734480155136*^9, 
   3.5947345011715717`*^9}, {3.5947352308953543`*^9, 3.594735246793047*^9}, 
   3.594735335846848*^9, 3.594735436534276*^9, {3.594735646372197*^9, 
   3.594735658431889*^9}, 3.5947357109880733`*^9, 3.594736487604253*^9, 
   3.5947366793221807`*^9, 3.595943926923321*^9}],

Cell[BoxData["0"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947342437932987`*^9, 3.594734264878827*^9}, {
   3.594734438567255*^9, 3.594734445125599*^9}, {3.594734480155136*^9, 
   3.5947345011715717`*^9}, {3.5947352308953543`*^9, 3.594735246793047*^9}, 
   3.594735335846848*^9, 3.594735436534276*^9, {3.594735646372197*^9, 
   3.594735658431889*^9}, 3.5947357109880733`*^9, 3.594736487604253*^9, 
   3.5947366793221807`*^9, 3.5959439269279222`*^9}],

Cell[BoxData["0"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947342437932987`*^9, 3.594734264878827*^9}, {
   3.594734438567255*^9, 3.594734445125599*^9}, {3.594734480155136*^9, 
   3.5947345011715717`*^9}, {3.5947352308953543`*^9, 3.594735246793047*^9}, 
   3.594735335846848*^9, 3.594735436534276*^9, {3.594735646372197*^9, 
   3.594735658431889*^9}, 3.5947357109880733`*^9, 3.594736487604253*^9, 
   3.5947366793221807`*^9, 3.5959439269449778`*^9}],

Cell[BoxData["0"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5947342437932987`*^9, 3.594734264878827*^9}, {
   3.594734438567255*^9, 3.594734445125599*^9}, {3.594734480155136*^9, 
   3.5947345011715717`*^9}, {3.5947352308953543`*^9, 3.594735246793047*^9}, 
   3.594735335846848*^9, 3.594735436534276*^9, {3.594735646372197*^9, 
   3.594735658431889*^9}, 3.5947357109880733`*^9, 3.594736487604253*^9, 
   3.5947366793221807`*^9, 3.595943926962434*^9}]
}, Closed]]
},
WindowSize->{1301, 744},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "iso8859-1"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 692, 14, 220, "Text"],
Cell[CellGroupData[{
Cell[1117, 31, 300, 5, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[1420, 38, 2282, 67, 242, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[3705, 107, 1097, 25, 153, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[4805, 134, 1791, 43, 219, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6599, 179, 348, 5, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6950, 186, 5055, 122, 153, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[12008, 310, 469, 9, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[12480, 321, 5802, 149, 329, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[18285, 472, 401, 6, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[18689, 480, 1709, 41, 175, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[20401, 523, 493, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[20897, 532, 495, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[21395, 541, 493, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[21891, 550, 495, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[22389, 559, 495, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[22887, 568, 493, 7, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Closed]]
}
]
*)

