(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.4' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    683429,      12315]
NotebookOptionsPosition[    679105,      12171]
NotebookOutlinePosition[    679463,      12187]
CellTagsIndexPosition[    679420,      12184]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Directories", "Section",
 CellChangeTimes->{{3.705224841322744*^9, 3.705224845651436*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wd", " ", "=", 
  RowBox[{"SetDirectory", "@", 
   RowBox[{"NotebookDirectory", "[", "]"}]}]}]], "Input",
 CellChangeTimes->{3.705147415773847*^9}],

Cell[BoxData["\<\"/Users/mstrick6/Documents/code/aHydro3p1/addons/\
visualization/cornelius\"\>"], "Output",
 CellChangeTimes->{
  3.7051474161282682`*^9, 3.705186045017815*^9, 3.7052410452519836`*^9, 
   3.705245322826489*^9, 3.7052463864628563`*^9, {3.705267497964426*^9, 
   3.7052675108985033`*^9}, 3.705271586257327*^9, 3.705277837419097*^9, 
   3.7052812474749002`*^9, 3.705283540176188*^9, 3.705284488981248*^9, 
   3.7053155651020527`*^9, 3.705321961593162*^9, 3.705329467269397*^9, 
   3.705331346620963*^9, 3.7053514538559628`*^9, 3.7054248954101*^9, {
   3.705488146810379*^9, 3.705488166297776*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Import FOHS XML file", "Section",
 CellChangeTimes->{{3.705224841322744*^9, 3.705224859243433*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"myImport", "[", "s_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"ImportString", "[", 
     RowBox[{"s", ",", "\"\<Table\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.705226810282681*^9, 3.705226823300473*^9}, 
   3.70522688224102*^9, {3.705227299085005*^9, 3.705227299250945*^9}, {
   3.705227373633277*^9, 3.7052273749446774`*^9}, {3.70522747788686*^9, 
   3.705227478293244*^9}, {3.705227693463423*^9, 3.7052276954632883`*^9}, {
   3.705227778728641*^9, 3.705227794046524*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"xmlData", " ", "=", " ", 
     RowBox[{"Import", "[", 
      RowBox[{"wd", "<>", "\"\</../../../output/xml/test_FOHS.xml\>\""}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"allVars", "=", 
     RowBox[{"Cases", "[", 
      RowBox[{"xmlData", ",", 
       RowBox[{"XMLElement", "[", 
        RowBox[{"\"\<VECTOR\>\"", ",", "_", ",", "_"}], "]"}], ",", 
       "Infinity"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"centroidData", " ", "=", " ", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"allVars", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "1"}], "]"}], "]"}], " ", "//", "myImport"}], ",",
        "4"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"normalData", " ", "=", " ", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"allVars", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "1"}], "]"}], "]"}], " ", "//", "myImport"}], ",",
        "4"}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nVars", "=", 
     RowBox[{"Length", "[", "allVars", "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{"Clear", "[", "varData", "]"}], "\[IndentingNewLine]", 
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", 
     RowBox[{"i", "\[LessEqual]", 
      RowBox[{"nVars", "-", "2"}]}], ",", 
     RowBox[{"i", "++"}], ",", 
     RowBox[{
      RowBox[{"varData", "[", "i", "]"}], " ", "=", 
      RowBox[{"Partition", "[", " ", 
       RowBox[{
        RowBox[{"Riffle", "[", 
         RowBox[{"centroidData", ",", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"allVars", "[", 
              RowBox[{"[", 
               RowBox[{"i", "+", "2"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"3", ",", "1"}], "]"}], "]"}], "//", "myImport"}], 
           ")"}]}], "]"}], ",", "2"}], "]"}]}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", 
     RowBox[{"i", "\[LessEqual]", 
      RowBox[{"nVars", "-", "2"}]}], ",", 
     RowBox[{"i", "++"}], ",", 
     RowBox[{
      RowBox[{"varDataRaw", "[", "i", "]"}], " ", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"allVars", "[", 
         RowBox[{"[", 
          RowBox[{"i", "+", "2"}], "]"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"3", ",", "1"}], "]"}], "]"}], "//", "myImport"}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.705225003415875*^9, 3.705225025394787*^9}, {
   3.7052254313223352`*^9, 3.7052254346804*^9}, {3.7052257895330467`*^9, 
   3.705225792180746*^9}, {3.705225973611023*^9, 3.705225984689794*^9}, {
   3.705226077269061*^9, 3.705226099106041*^9}, {3.705226722993231*^9, 
   3.705226793725699*^9}, {3.705226826518504*^9, 3.705226898535568*^9}, {
   3.705227897678225*^9, 3.70522799675506*^9}, {3.705229465653419*^9, 
   3.705229479594243*^9}, {3.705230647748666*^9, 3.7052306580524807`*^9}, {
   3.7053307366208773`*^9, 3.7053307367960663`*^9}, {3.705425462124145*^9, 
   3.7054256340213623`*^9}, {3.705425744258891*^9, 3.705425759464993*^9}, {
   3.705488149412278*^9, 3.705488150554636*^9}, 3.7054882447213917`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Setup", "Section",
 CellChangeTimes->{{3.705224884688384*^9, 3.7052249001056232`*^9}, {
  3.70524338747202*^9, 3.705243387846182*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dtau", " ", "=", " ", "0.2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"selectTau", "[", 
   RowBox[{"data_", ",", "tau_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"data", ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "\[GreaterEqual]", "tau"}], " ", "&&",
        " ", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "<", 
        RowBox[{"tau", "+", "dtau"}]}]}], "&"}]}], "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"selectTauPos", "[", 
   RowBox[{"data_", ",", "tau_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"data", ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "\[GreaterEqual]", "tau"}], " ", "&&",
        " ", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "<", 
        RowBox[{"tau", "+", "dtau"}]}], "&&", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "4", "]"}], "]"}], "\[GreaterEqual]", "0"}]}], "&"}]}], 
    "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"selectTauNeg", "[", 
   RowBox[{"data_", ",", "tau_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"data", ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "\[GreaterEqual]", "tau"}], " ", "&&",
        " ", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "<", 
        RowBox[{"tau", "+", "dtau"}]}], "&&", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "4", "]"}], "]"}], "\[LessEqual]", "0"}]}], "&"}]}], 
    "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.705147632816841*^9, 3.705147752551455*^9}, 
   3.7051477922384157`*^9, {3.7052239746506557`*^9, 3.705223974984147*^9}, {
   3.705224038647703*^9, 3.705224043622229*^9}, {3.7052249627595577`*^9, 
   3.7052249702605467`*^9}, {3.705240780585225*^9, 3.705240821014717*^9}, {
   3.705245487888953*^9, 3.705245494493923*^9}, {3.7052455306469793`*^9, 
   3.7052455422288*^9}, {3.705246788915584*^9, 3.705246813240364*^9}, {
   3.7052679436408043`*^9, 3.705267966710163*^9}, {3.705267999287053*^9, 
   3.705268031340425*^9}, {3.705268063557929*^9, 3.705268063995623*^9}, {
   3.705282582156191*^9, 3.705282582625898*^9}, {3.705282860612267*^9, 
   3.7052828610677156`*^9}, 3.70531557223463*^9, {3.705316000246221*^9, 
   3.705316000580799*^9}, {3.705316068435725*^9, 3.705316070994173*^9}, {
   3.7053978655869017`*^9, 3.705397978702364*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"tauMin", ",", "tauMax"}], "}"}], "=", 
  RowBox[{
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"MinMax", "[", 
      RowBox[{"centroidData", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], ",", "dtau"}], "]"}], 
   "-", 
   RowBox[{"{", 
    RowBox[{"0", ",", "dtau"}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.705242422257209*^9, 3.705242477437842*^9}, {
  3.705242867746045*^9, 3.7052428815280027`*^9}, {3.7052433567534733`*^9, 
  3.705243370743292*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2`", ",", "13.8`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.705242477760798*^9, {3.705242872730152*^9, 3.705242887875162*^9}, 
   3.7052429670705967`*^9, 3.70524307891221*^9, {3.705243365803196*^9, 
   3.705243393562224*^9}, 3.705245363042939*^9, 3.705245544289563*^9, 
   3.705246396513217*^9, 3.7052675159772167`*^9, 3.7052715907344913`*^9, 
   3.705277870492401*^9, 3.705281291066175*^9, {3.705282763902079*^9, 
   3.705282782283589*^9}, 3.7052828654314528`*^9, 3.7052835491519814`*^9, 
   3.705284499724492*^9, 3.705315574244841*^9, 3.70531600334454*^9, 
   3.7053160741398373`*^9, 3.705321966173513*^9, 3.705331349733142*^9, 
   3.705351460570606*^9, 3.705363707566931*^9, {3.7053979051763906`*^9, 
   3.705397929358004*^9}, 3.705397980343911*^9, 3.705425642078479*^9, 
   3.705488260782289*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"xMax", "=", 
   RowBox[{"Max", "[", 
    RowBox[{"Abs", "@", 
     RowBox[{"centroidData", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"yMax", "=", 
   RowBox[{"Max", "[", 
    RowBox[{"Abs", "@", 
     RowBox[{"centroidData", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "3"}], "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"perpMax", " ", "=", " ", 
   RowBox[{
    RowBox[{"Max", "[", 
     RowBox[{"xMax", ",", "yMax"}], "]"}], "//", "Ceiling"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zMax", "=", 
   RowBox[{
    RowBox[{"Max", "[", 
     RowBox[{"Abs", "@", 
      RowBox[{"centroidData", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4"}], "]"}], "]"}]}], "]"}], "//", "Ceiling"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{"plotrange", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "perpMax"}], ",", "perpMax"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "perpMax"}], ",", "perpMax"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "zMax"}], ",", "zMax"}], "}"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.7052429301675863`*^9, 3.705242934414524*^9}, {
  3.705242987508919*^9, 3.70524308434519*^9}, {3.705243115417471*^9, 
  3.705243231131958*^9}, {3.705243275980155*^9, 3.7052432874901037`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "11"}], ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "11"}], ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "9"}], ",", "9"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7052432834357967`*^9, 3.705243287755171*^9}, 
   3.705243394140957*^9, 3.705245364352192*^9, 3.7052455449767523`*^9, 
   3.70524639792197*^9, 3.705267517844208*^9, 3.705271590822871*^9, 
   3.705277870690074*^9, 3.705281291270788*^9, {3.705282764098205*^9, 
   3.705282782490138*^9}, 3.7052828656347733`*^9, 3.7052835502251453`*^9, 
   3.705284499929537*^9, {3.705315575639903*^9, 3.7053155960886087`*^9}, 
   3.705316006496922*^9, 3.705316075267395*^9, 3.705321966229817*^9, 
   3.705331349789168*^9, 3.705351460690605*^9, 3.705363707692889*^9, {
   3.705397905295665*^9, 3.7053979295202847`*^9}, 3.705397981546797*^9, 
   3.7054256430720863`*^9, 3.705488260907209*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualize centroid surface", "Section",
 CellChangeTimes->{{3.705224841322744*^9, 3.7052248728109913`*^9}}],

Cell[CellGroupData[{

Cell["Centroids scatter plot", "Subsection",
 CellChangeTimes->{{3.705224884688384*^9, 3.7052249001056232`*^9}, {
  3.7052485776440983`*^9, 3.705248599282927*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"centroidScatterPlot", "[", "tau_", "]"}], ":=", 
  RowBox[{"ListPointPlot3D", "[", 
   RowBox[{
    RowBox[{"selectTau", "[", 
     RowBox[{"centroidData", ",", "tau"}], "]"}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "plotrange"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<rapidity\>\""}], 
      "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"PointSize", "[", "0.01", "]"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.705147800238151*^9, 3.705147803532564*^9}, {
   3.7051479012014217`*^9, 3.705147909456308*^9}, {3.7051479748595047`*^9, 
   3.705147992529005*^9}, {3.705148043159308*^9, 3.7051480878364353`*^9}, {
   3.7051482202992496`*^9, 3.7051482260825377`*^9}, {3.7051483123028097`*^9, 
   3.705148347995346*^9}, {3.705224047055529*^9, 3.7052240487423573`*^9}, {
   3.7052413689331837`*^9, 3.705241369068371*^9}, {3.7052414725711517`*^9, 
   3.7052414730725307`*^9}, {3.705241904706936*^9, 3.705241909601564*^9}, {
   3.705241982609927*^9, 3.705241994358699*^9}, {3.705242028415175*^9, 
   3.7052420844676743`*^9}, 3.7052425114476852`*^9, 3.7052433000388613`*^9, {
   3.705245387915159*^9, 3.705245388262711*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"centroidScatterPlot", "[", "tau", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"tau", ",", "tauMin", ",", "tauMax", ",", "dtau"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.705148124010538*^9, 3.7051481330882177`*^9}, 
   3.705242487778001*^9, {3.705315607954747*^9, 3.705315610146888*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`tau$$ = 6.6000000000000005`, 
    Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`tau$$], 0.2, 9.8, 0.2}}, Typeset`size$$ = {
    360., {156., 160.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`tau$409046$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`tau$$ = 0.2}, 
      "ControllerVariables" :> {
        Hold[$CellContext`tau$$, $CellContext`tau$409046$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> $CellContext`centroidScatterPlot[$CellContext`tau$$], 
      "Specifications" :> {{$CellContext`tau$$, 0.2, 9.8, 0.2}}, 
      "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{405., {200., 205.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.705148134290361*^9, 3.705148355944489*^9, 3.7051860529590178`*^9, 
   3.7052238477866163`*^9, 3.705224057867024*^9, 3.7052278482610188`*^9, 
   3.705240823821456*^9, 3.705241187219949*^9, 3.705241321226549*^9, 
   3.7052420710569687`*^9, {3.7052424921250362`*^9, 3.705242519592041*^9}, 
   3.705242891822212*^9, 3.705243398613805*^9, 3.705245548731764*^9, 
   3.7052464135470867`*^9, 3.70526752366919*^9, 3.705277877840262*^9, 
   3.7053156110787077`*^9, 3.705316011029161*^9, 3.7053224013785458`*^9, 
   3.7053514678267517`*^9, 3.70536371406847*^9, {3.705397934079645*^9, 
   3.70539798570516*^9}, 3.705425646870137*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Centroids surface plot", "Subsection",
 CellChangeTimes->{{3.705224884688384*^9, 3.705224897129682*^9}, {
  3.705248581457491*^9, 3.7052486012265863`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"centroidPlot3D", "[", "tau_", "]"}], ":=", 
  RowBox[{"ListPlot3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"selectTauPos", "[", 
       RowBox[{"centroidData", ",", "tau"}], "]"}], ",", 
      RowBox[{"selectTauNeg", "[", 
       RowBox[{"centroidData", ",", "tau"}], "]"}]}], "}"}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "plotrange"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<rapidity\>\""}], 
      "}"}]}], ",", 
    RowBox[{"Mesh", "\[Rule]", "All"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.705224095085915*^9, 3.7052241004927387`*^9}, {
   3.7052241604910727`*^9, 3.705224160986952*^9}, {3.705224280926729*^9, 
   3.70522428723103*^9}, {3.705241283832158*^9, 3.7052413021119003`*^9}, 
   3.705242527518367*^9, {3.705243317819098*^9, 3.705243335526561*^9}, {
   3.7052464551742*^9, 3.705246510762979*^9}, {3.705246850512439*^9, 
   3.705246851360672*^9}, {3.705246934037651*^9, 3.705246946203714*^9}, {
   3.705247790400334*^9, 3.70524779320607*^9}, {3.705247855565094*^9, 
   3.70524791341004*^9}, {3.705248082861271*^9, 3.705248112547058*^9}, {
   3.70524844956739*^9, 3.705248455962884*^9}, {3.7052675552947598`*^9, 
   3.705267556586379*^9}, {3.7052679810943613`*^9, 3.705268014631938*^9}, {
   3.705268056260989*^9, 3.7052680575089273`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"centroidPlot3D", "[", "tau", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"tau", ",", "tauMin", ",", "tauMax", ",", "dtau"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7052241029589157`*^9, 3.705224107491981*^9}, {
  3.705224212939869*^9, 3.705224218498046*^9}, {3.705242538764462*^9, 
  3.70524254483683*^9}, {3.70531563425114*^9, 3.705315637257679*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`tau$$ = 0.2, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`tau$$], 0.2, 9.8, 0.2}}, Typeset`size$$ = {
    360., {154., 158.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`tau$409952$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`tau$$ = 0.2}, 
      "ControllerVariables" :> {
        Hold[$CellContext`tau$$, $CellContext`tau$409952$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> $CellContext`centroidPlot3D[$CellContext`tau$$], 
      "Specifications" :> {{$CellContext`tau$$, 0.2, 9.8, 0.2}}, 
      "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{405., {198., 203.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.705224107956966*^9, {3.7052241643411837`*^9, 3.7052242422105417`*^9}, 
   3.705224331562729*^9, 3.70522786874866*^9, 3.7052307511094427`*^9, 
   3.705240833709668*^9, 3.705241512288395*^9, {3.70524253081758*^9, 
   3.705242545895307*^9}, 3.7052434181201487`*^9, 3.705245408994668*^9, 
   3.705245553526656*^9, 3.705246466541789*^9, 3.705246823537958*^9, {
   3.7052478699504023`*^9, 3.705247890188429*^9}, 3.7052675422114677`*^9, 
   3.705268036460606*^9, 3.705277894788475*^9, 3.705315638084722*^9, 
   3.705351488230459*^9, 3.7054256643894043`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Centroids - Delaunay triangulation method", "Subsection",
 CellChangeTimes->{{3.705224884688384*^9, 3.705224897129682*^9}, {
   3.70522964744569*^9, 3.705229649564056*^9}, {3.705229924845533*^9, 
   3.70522992880319*^9}, {3.705246764069357*^9, 3.705246772653866*^9}, {
   3.705248588609192*^9, 3.705248591985148*^9}, 3.705250746687107*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"MeshRegion", ",", 
    RowBox[{"MeshCellStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "All"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Darker", "[", "Orange", "]"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "All"}], "}"}], "\[Rule]", 
        RowBox[{"Lighter", "[", "Orange", "]"}]}]}], "}"}]}]}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.705241657195017*^9, 3.705241713383794*^9}, {
   3.705241762647843*^9, 3.705241831900755*^9}, {3.705242583323749*^9, 
   3.7052426316881332`*^9}, {3.705242671208788*^9, 3.70524279744283*^9}, {
   3.705243520812635*^9, 3.705243535313717*^9}, {3.705268077797421*^9, 
   3.705268082210589*^9}, 3.705268244557815*^9, {3.705283550661762*^9, 
   3.705283551306301*^9}, 3.7052844961519613`*^9, {3.705311709426979*^9, 
   3.705311719089794*^9}, {3.705311756608494*^9, 3.705311757289071*^9}, {
   3.70531236080156*^9, 3.705312363256233*^9}, {3.70532537840205*^9, 
   3.705325378831174*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DelaunayMeshPlot", "[", "tau_", "]"}], ":=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"RegionBoundary", 
     RowBox[{"(*", 
      RowBox[{"@", "TriangulateMesh"}], "*)"}], "@", 
     RowBox[{"DelaunayMesh", "@", 
      RowBox[{"selectTau", "[", 
       RowBox[{"centroidData", ",", "tau"}], "]"}]}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "plotrange"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<rapidity\>\""}], 
      "}"}]}], ",", 
    RowBox[{"Boxed", "\[Rule]", "True"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7052296580150623`*^9, 3.705229710356667*^9}, {
   3.705229807448835*^9, 3.705229818224263*^9}, {3.705229880830379*^9, 
   3.705229881325541*^9}, {3.705236292243568*^9, 3.7052363264509974`*^9}, {
   3.7052372671801977`*^9, 3.7052372687631903`*^9}, {3.70523731225668*^9, 
   3.705237342224842*^9}, {3.705237398822052*^9, 3.70523743278056*^9}, 
   3.705242598931862*^9, {3.705242835969598*^9, 3.705242836122024*^9}, {
   3.705243433438696*^9, 3.705243435594903*^9}, {3.7052434660945663`*^9, 
   3.70524348040373*^9}, {3.7052455713231583`*^9, 3.7052455713950787`*^9}, {
   3.705246547834764*^9, 3.705246572984703*^9}, {3.705268269488957*^9, 
   3.7052682786992073`*^9}, {3.705268340952532*^9, 3.705268346318513*^9}, 
   3.7052779477785797`*^9, {3.7052826384089518`*^9, 3.705282641127667*^9}, 
   3.7052827166743717`*^9, {3.705316209575534*^9, 3.7053162118528957`*^9}, {
   3.705395790566551*^9, 3.7053957943891773`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DelaunayMeshPlot", "[", "0.25", "]"}]], "Input",
 CellChangeTimes->{
  3.7053254518300953`*^9, {3.705395782799522*^9, 3.705395783861161*^9}}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1m3dcU1nQ9wMEEoQEcpNQgw1FFBEQ0dUVz1ix994AyyqgYsXeULGAvaGI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   "], 
   {Hue[0.6, 0.3, 0.85], EdgeForm[Hue[0.6, 0.3, 0.75]], 
    Polygon3DBox[CompressedData["
1:eJxdm3fUFUXSh2deQImCgkiQJChJRJAkSBRQkgSRpOQlKybUNYK6JjBnVIyI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     "]], 
    {RGBColor[1, 0.6666666666666666, 
      NCache[
       Rational[1, 3], 0.3333333333333333]], Polygon3DBox[CompressedData["
1:eJxdm3fUFUXSh2deQImCgkiQJChJRJAkSBRQkgSRpOQlKybUNYK6JjBnVIyI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      "]]}, 
    {RGBColor[
      NCache[
       Rational[2, 3], 0.6666666666666666], 0.33333333333333337`, 0], 
     Line3DBox[CompressedData["
1:eJxNm3ncV1Mex+/9JVq0KFnbqGiRkEi0UbRKjyyhTdoeqRCyF2OyjVASw0xm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      "]]}}],
  AxesLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"y\"", TraditionalForm], 
    FormBox["\"rapidity\"", TraditionalForm]},
  Boxed->True,
  Lighting->{{"Ambient", 
     GrayLevel[0.45]}, {"Directional", 
     GrayLevel[0.3], 
     ImageScaled[{2, 0, 2}]}, {"Directional", 
     GrayLevel[0.33], 
     ImageScaled[{2, 2, 2}]}, {"Directional", 
     GrayLevel[0.3], 
     ImageScaled[{0, 2, 2}]}},
  Method->{"ShrinkWrap" -> True},
  PlotRange->{{-8, 8}, {-8, 8}, {-8, 8}}]], "Output",
 CellChangeTimes->{
  3.70532545343756*^9, 3.705351508735725*^9, {3.70539578860623*^9, 
   3.705395797562035*^9}, 
   3.705425671978649*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJx8nQV4lFf69qfB3d0hIYoluFuFohFCjAiB4K7B3d3dA0SQEMHdSnFaaKm3
K93tdnf/a92uPt99P+e8wyTL9XFdw8y8M+/JzHt+537kPOdM/6Rpo0aMT5o2
Ojmp4btTkiaNGp08teE7E6fgUJG3XK63RuG2vKGLj8Xlcv77o+Cfq6g8ffpU
Fi1aJGvWrJGff/55uh52/ah3JeRPf/qTXL58WdatW6fvOHnypIwYMUKys7Nd
9q0/6F1p+eKLL+TIkSOyePFifevDhw/ZoPzlL3+RCRMmyIwZM+T777+fZs76
Xu+Ky08//aQfYf369TJ79mw5evSofP3110X05WLyxz/+UZYvXy5paWmyadMm
+c9//uOaalr4lW3hD3/4g+Tm5sq8efNk1apVcu7cOfnd735XzLbAP7906VL5
5ptvZPXq1fLhhx86LfzCtvDpp5/K4cOHZcmSJbJ37155/vy5/Otf/yphX/7b
3/6mn+HXv/61fPbZZ/qH/vznP08xjXxj34Ujcu3aNf0i8+fPl4yMDH7d0vbl
f/zjH/rnX716xSOyf/9+OXHihG3kK/su/onTp0/rn+C7P/jgA36BsrY3/v3v
f8vGjRvlo48+0kZ4debOnctL75psWvrc460ff/yxbN68Wd/Cv/fy5Uu9gOX1
PUXkv//9r77+4MEDl5c9duXKFVm7dq2+b5Jp8pX9cGTh/Pnz+sFWrlypF/o3
v/lNZfsXt23bJjdu3BDnH1rQlq5fv+609Ilt6fPPP1dUHO4ePXpEVKraz7B7
9265dOmSPnM+15dffimpqany448/uiaa1j4uhNCGDRv0qx47dkx+8Ytf1LBn
kqi8vDz7zPyfnp4uBw4c0GcTTGvPbWu//e1v9e3sQ35TfHwiVsueiT6TrKys
Aq2x6+fMmSMvXrxwWntqW/vkk09k165d2tq+ffsUrX/+85917Jm8hETbDEVz
DIAqbrggrvGmtUdvYGzBggX6NcBYfXsmByr5NeCbY+xfDFZ9Ns609qAQbGyJ
3/TevXuEraE98+7du7J169YCrfEU9sIPP/zgtPaB7X4Czm+3ZcsWvRi87Ow0
QOZqbE9nL3EUm79vjuXk5MiOHTsUuLGmybsewOXn5+u45BXh1UL3+NgzORY5
4PkXnNb+/ve/62jnKLet3X4DdOTSQudrz/zlL3+p9GDguErYYxxA7DkogGuM
ae1GIej4dal4FroAeyYw1dZwVdytcbjt3LmTyuC0ds2jKxwNY1fcunWLXRFk
z6TE8XPggrhK2mO///3vtec49keb1q7Y1sChXlJ+AEfPAF1zD1z5kXEpXaU8
QOS1ZC+MMq1d9OgFxwTw81HYMOxb2TOpjitWrOCXd7dG8bFfw2ntvG3tV7/6
lZw5c8ZtJazChdgzaTD4OdBZrtL2GOWZ0OEbu0aa1vI8euHZs2faC7xAhA5C
39aeCRHXsQK9dJWxx44fP65v47MU01qObe3//u//lDcS4mFJ2tszKWjUGIDj
bs1z6NvWsm1rxJO8sZMo2o8fP2YvdLJnsoPu3Lmjz5zW+JwXBW9zjTCtnbKt
/fWvf1WLym+6cOFCbRmXvKs9c8+ePSrdfFbWHuMfdYRvuGkty7YG0dBvSkL4
B6nb+Crd7Zk0FsTRszX8MX07h75tLcO2RrtCkXPsjLWfPe2ZlExHgsrZY0SA
V4BjN9m0dty2xkvKr8KO41Cm2oK3t+2ZZ8+edfef0xptPDvtyZMnTmtptrVv
v/1WnRZqCJHkJYZIvGvPJNiHDh3SZ45ZRCt6iTnqh5nWDtvWKC/8drR1RJK9
8NVXX71vz6Rk8kJ4tuaM+szMTKe1g7Y1mm8yxrHAIcQeAW/97JkUKPYhn1Ww
x/CyDkJA7koyre334I1eDFvbvn27ng75GWDPpCjQavOKV7TH2Mcc1hz1iaa1
PR688VqxFxzeoFKh9szvvvtOD/NMpzVQ6x71trVdtjXqG78dhwo/hOUt3J5J
taTzR7WsZI/RcvLtuEiuBNPajv8/b4PtmVRGXiNQ4apsjx08eFAlms/iTWtb
PXgjBvym/Gz8nJDGKHsm5Y9s4cq7W2PHcVjDmXNa22xbo8kjnuwFXgwiAZWK
sWfysi5btkzVsoo9dvv2bZUbfAXXUNPaBg/eqG/EwOEN3vFQeyblj+Dgj7pb
I2/8KhcvXnRaW/f/5y3Bnkm1pL5RyxxXjF+HPUO3K860tqYQbxxZlB/2Ajow
yZ5JtaStx8d3VbPH6G044yPWtLbStsYhTFfL4Y0yDZUaYc+k7Dlq6Xw2nsJe
4Ki3rS334I1CQUJ4aXkq+nmkPZPK46il89koruwZul2mt1xL9K6EfhUyx1HF
i0FHjq4BXYXR9nRyeOHCBX1W3R6j90Tt4bNo0+QiD+j4doqv0xWAbpw9kz4h
JdKzNQivfl18N6e1BR7QeYZedCGBzgR7Jluiq8hnjlfMoU+q+B0M6q65haBj
7zmeHHidbM8EWG7JdFrjKRw7dLtsa7NtaxzbhI4jkm+hY48ROtWeSSWgPPJZ
TXuM15o9h4vkGmJam+UBHcMDIuIB3XR7JiIZRcWzNQ4I+vowQ05r0/8/0MHU
zLJnUjIpj5RMx/93Qi46KJGmtamFoGNLjqnBX5htz8S4VSGhZNa2xzyjLSNf
NlQqoWrKb0foOPQ51Bhi861z7en4rNpDVA6nSfpeZABNO01O8ICOARytKm/W
n15gz6RuOt6uE6B4jv8I09q4N0DH72ChW+RxoYgrvba69hhdRw4UPjPab8fP
a+g4ZniVLHRL7ZnUTYYAcB/drVGZ+dno3dnWRnp0BYcUvw6HFzsZ3365PdNT
N+vZY55hV5hpbYRtzQni+Mcc6PC2lfZM9hSvOHXTCcU8wy5jM63xN9AxiCNZ
/HwWujUe/UceqZtOa3Sa+cfpsdvWEm1rfInQUYXZIo0J/sI6D/g5IOBmuxrY
Y4y4SBWH/iDT2lCPXnCgI1jWv9lkz/TUTeez8RTqJoe+bS3WtkZ/moyxP3m5
rT+9xZ7JS0kc+cz5bMxsOAwONK1Fewx9DgIOL0fkMPS32TP5UR2f1WnN0/ey
rUXa1ogAPSReHA/edtozT506pbTymRMQO+ODEZfxquyQKMgbhz5VDb2w257J
b8nPx2eN7DG6HHwre6G/aS2sEG/sASdpgCG+157JxqmBnq3RdvOi0PeyrQ30
4M3xbzhWcTHI2wF7JiWTtPKZE6czScU/zrFrvFHbaHFNozn+NP8geUNnHbJn
MiSmGFAym9hjND3Ot+9rWnu/EG8Ea+bMmdq/0Mmj9kx2OYWKmue0xlHvRFy2
tfcK8cZv6eQLwNsxeyYzO7RCVEtve8wz4jIfyvWObY35Ak9/mvEbRv0JeyY9
cX4Okuq0Rt7oQQEFp7VetjXHn+alJm+8IBi7mfZMqiUPM8J38hueEVcf01qP
QrzxZY4sy9tJeya7nB1EtWxqj9H3cka9uWCubm/gjfLMQYiLdNqeyaFCy41Q
yt2aE3HhojitdfbgjSJBNWLncVDi0p+1Z1It+RKiepeTe/GMuExk5upoW4P6
FHBtyBuoybVnUi15xWkD/OwxO+L1melMVzsP3px8AXmz/vQ5j/6j18OEqNOa
Z8RlW2vjwRuHdiHeLtozCbVNiLpb48XgQGQvmIjWFeLBG/0qT38avF22ZzKR
4ziYTmueEZdtraUHb/zjvNTsKAY/8Kev2TMpd7QDfOZvjzkRF76Wq7dprbkH
b3w7XyZvNj91w55JtXQcXScDRpfLibjMIHAF6t1rf5oXiK6NB3OuW/Z0z8yo
0yQHCbuCQ9826V8IOmqPR6rwrj3TMzMaaI85YReHvklVWB4LQscWmaQCOh/Y
MymZzAB4tkZ0eK3h3jqteb8BOlpxigrG9gN7pmdS1En4OdluDn0z5q02F1cr
ROhoavhNrT/9yJ7pmRRtZo+xa5xki0nxWJtmviltCVvzgO6JPdMzKeq05hl2
2dYa6F1RjaGmTJmiHQfYntszGAKw3xjeO0lIJ9zCxbE65LbavBicMEKnuT6y
x5gB5R+lPjpN8JKzG/D1nCaMU1JMBwbHEa8tFRfDzuV8GnrBfI3OVAuPQe7E
Vl09myquYRcHEL8Ec50cvWjumT3TmRyiOLa0xzhSnNiqi2drJbR7qKXMlvMf
L6Zt0c4ZvM6BMrvgNEmGeIzKVKDJIjoWKYF85syWsFnSmJeX53L60nEsEbm6
nOQtIxxnyHcu2Cy/hDN+nYkOCh71hpA7zZJqOlJ85nxa9gwHNVzbws2SQ3rj
BpjXncthxmYf22Ps2Js3b+qzVh7vI0c0HSaN6vbeKSk0NpSG4m9o1hkeZJ1i
wGfB9hh1w/HEOhZslqywWcDsTuOTFQrD/fv3XQ/tMYqFk2p1mnWS4MS4ULN0
ogg/M1ROPp9Djc3Sj3akgZ6TM9nkZMidiIy+WYeCzXJMsdf5rFShZgnOfueq
o3v+/Y+/yz//9n/yn3/+7FgTT8lt7fEJnIitfcG/xu/ruKGlPf4apYRuwVo9
Vkv++59/y7/+/mf5x58xgH74Wv7861fy+88/lN99clO+f3pefnkvS76+dlA+
P7dZPj2zSp6npcqjvWPkg00xcmtFH7mxqIdcnBIoeWMaSu7o+pI3trHcXjlA
vrq8W/7w1SN8mf+4HTCKoZObcL6C4zCS+0JfgW/lt+YzJwfvhOmMv+bpsQBe
JPkLPvaPn96RHz6+Ir9+mC3f3U6TLy/tks/yNsiLzEXy9NAUebAjWe6uDZcb
S96WK3M7Sv54b8kd00ByR9aR7OSqciapkpyMLSVZ0cUkY7BLToS65Fh/lxzH
7QTvB+A2EMcGueRw6FtyILy47B5cQbZG1pR1UU1kR2Q1OW5fOxlXVi5NaybP
jkyX3350RX7+0w9OMMCJPGfmro095oS31FvjDbnjaI5WahIFvVyhqwABtbmX
0vLff/9T/vL9Z/KL20fl0c7hcn56iGQmVsO3KSlHhpSRw+FF5ehAaBC+Eihz
vozeBuHw8VAXWj4ehu+H29Gwt3AsLfwtL0mPcGF0ZUS4JH3wW3IsspgcGlJW
9kVVkV3RNWVLTEO8cX2sXxFZGxuIT7g+1l82xPrK0chSsh9v2hldS/YNLidH
8IcyhxSVsym15fbqUPnmxmH562++xIf/b4Eh4hjbNh7fn8cQRhe+NJRdXobv
vvvOndCnyXQujSlmKCc//99v5NePcgDCYrk4q41kJNaQ3aElZMuAUrJmUFXZ
FFZZjoV7yZGIYpIWgWE1mJciczBzIniIg4OLycHBZfA9yuv9scFF8aVPDPaC
PvCikBbejkUWl6NDSslhXO9DQ8rx3osXwlUVXVBaLwnfcmIw/4aX+96cWgKn
lsYpZfE+XG90wglcshMA6kxiVbmU2lZenlwuP7y4Jv/++a9OPomzb45D4cyr
cZg7+Yi2Ba8YPUVyRotS4Q1XzMzdl5V//OVHKMBteZG1RG4uf1/OjKwrR3GF
9mIY7AktJnvDS8rBCIA1uLgcH+zlxYuFLjgQWU42D6krW6Jqy9YhtWXbkFqy
Y0h1ORhZVq8T3qX3abhGJyIBIW4nIovoFUCwzMMHosFVbF3ZEddQtsU1xq2J
bB3qjZuPbMP97tg6sh/v4WVOj/TScw5FV5ZdcfVlD85LwzXcGu8vO/S99eRA
TDU5HFVBjg0xXZUebgZ2Gvg/EVVa8iY3kw+3JUEwjsnffvzOnTPlRXTyge3s
MRpd+is81qbghaVn5lgpZ8bFU6vGWNH79z//Ln/86rF8lr9Z7q0fLDmj6mCE
FpdjA3QYynF+PDvUiEUaLjBHD5+DN9mPx0cHl5BVUX6yNLoZ7n1lc1Rd2RNZ
Sa/ykcgyuISVZGdMPdkc5yvr4lvIrpg6wK+sbIoPkO24pHtiasnBqIp6jJfx
IN7PS749rpHsjqkth/RyldDXD+qlbaCXdFNiC9mQ2ErWJ7aWfbE1ZH9MdYz8
pBBXJdmQFCwbE1uih5rK3pia2ivpoPsEmkmPLKJfibJyzMpndnINub1qoHx+
fqv8/jN47rASzhQJLbgz3dTOY6STW9rJQlee7oqToq70hitv0oT15D//+of8
8Ztn8u2to/Lh9mGSN66xnIJK88qn4SOl4eNB6pRRHZCDi+rV3ja4uqyJbCQb
B9fRntgLxefzvZEVcMXLyE7wfSSypKRh0B6OwusxNWRrnI9sGBoEjVgb3xJu
7Lr4ltoT6+Ob44qX0Su9PqG5bB7qp6Dvj66KS1bSjg8vhfV4pLVCGCOH0Ft7
Y2vJzqGNZHu8j2xJCNDe4CU/ElVewd+a4Ce7MQjYYxwExwB3WmxlOZRQT/Yl
B8ieES0lLaa8nEyoJJnRRtDZvg6IQcbSZcWUlIvTWsBqzZDvn5yj1XLT7FQ0
IHR1tfegng4Fj7Uu2C0MYR3nyJmYo3NEbwehrJ0ebaD+BzXt2eHpcnFmMLoE
sIcau5QeZj7ecZB0BNBzABweXFK7ZG1kQ1ka6ScLIpvJ8sim2h3sst0YCDsi
q6pMG1l+y92lemkjDdgwifyUQ0p76cMKepDXmm+iLvGETA8ejgPlo1E4EX3M
e48+chn9MxoHPdPjRuOKaFvp/ON4zP7YP6yp9sXukW28ZNfItnCId45qL4dj
4YCk1JOz09rKSeg9usdYn1JK5Ql7SfhJzg6vaVysK3vlz7/8RF0spw6A7hQv
MUNTp5ecPCunWAr1EiMOhs985ow/JhroVbOXzPRpSf4J+fXjPLmx+B3IT2lV
T/bSsfC38LyYF785GjCKVUw7y4yhYtpZKyO9ZRk6aTs9JHRmFrlmp1JhYiqD
23pqGLcPbSKbwfaWBH9c0y3x/l6yLb4prtDWeF/cmmIANFTAqfwnIovpSGE2
A2p0JFpF3kVj8hZsEV7WsXEA43EPxsVujJ29+DsHY6rq+HAML5s6HlVKjsZU
ZP/DosRWwvU5Fl0Ot7J4Cd0cVQZDB4IZV00OxdeT/Uk+cjiuupxMqio5qd0l
Z1YXOT3GRzKjiruHVUYULgGHGdyv9KhiciK6lByPeEs78nR8Bbk4NUg+Oj4X
7F+Xf/38VycgcAJWmB8bP5iR59QRmjjDPQHESJrdDRvunipl/zGCZhxmJoXf
UUyotxkcQcBoW1gFORAB6R9cSjtsw+C6snJwExW5XYMr6SgjzOwoDoAsa7jd
nYfOonXdGu+nIgQrgFuwWu89sbVlXWKINRW8BetrGyBYO+MaqrlR8xJdUfbE
N5Stw1rIfojbIXTM5uTWsmVYsGxNai47Ev1ld3xjdG51DLjyGEjFdWAdRW/w
8TF02pHYKnJwaB3Zm+gtu5KDZOfwlrJjRLCkoec40HaNait7UlphwLWQvcOD
9NjBpEZyOL62HIspZxyP6pIBBk6NqCvZU0IkZ3Z3OTu1jTMI8RrGYVx5yUyq
JZkJOBaLcR5bTk4k15MTibXkeFxFNW2Z6ORzE3zkg43RcCaO07d1Ql2mDJgd
5YRWR49YyHEYggt2KucNqbT035zpZSbgmIMlF2bKxY/uiiJ0JqmKuor7w4rL
gkEN5XBECdmPzt0eUVlWh9fXzuSIPISBS1ncb63YzsG4eDjGDj4UWRqdW1RH
Bi8w1Ws/XKcdQxvLpoRm6MQQfXwEyrfBdio7dBvcMr6P1usYztsfV0s7bsuw
Vl6yeVgItP8QBvi+uDro2xAcCeZRvIx+SvDVt/NP0k84QmOFvuTIOzEEUcbQ
WrJnmL9sT2mNG8Ryx4gQ+OJHYiqpTds1qg00NAS31hjzeAZjsnd4oBweWgNd
Cy1HvxxPro+BWBRxRxHtx1NJNSR7cksdsGfG+qod5KDNhB/Avs1KaSyZw+tL
5tBKkhFTRk4MqyMnRvrK8TGBcjypjhEEGCRe8dsr+sqr7DXyuxc31Pt2kjtO
VRtzHR09hqmTCS7U2ZzMYc6WeU7H92QYxFHNzjYzYm3VTv7qQbbkj/PR2C2D
ZhujefHA+jJlQICsDa2uusPOnx/uL3sjysmmyNpqI5dE+svCyEBIsK9sgwQf
Rmdvh4u+IqaZui+HMGo3JTbXDqa/TPOWpo4hpBmuBUcdR+5ejGy6LzR9lNyd
CU3Z0bIpuY2OXNPDIXqMbeyK99bHuxJ89P3H0CZH7dHYSrI/obHsGt4CvZrS
Bqq2c0QIOjtQJZYwpEHN9yU2xoAGYyPbYpDXliNDq+uAhuXUQX0wsYG+70Q0
eiq+ihwbHShpE9pL2vg2OkrzJgbKKXg76XZ0nkyoItmTWmB0twYJ1SUztoxk
4VgmXA7t/bFBcnJCS8lMrg3ZLm0ISG4gx8cHy/EJreXYmGZyLAHOLby9dED7
AF4kEzX851l96NQQMjZz5ulaFex1ZgUJCZ/VLNTrnBaKsCHw7z+7J1cXvwsX
oIhajgyrxRtCq8jUAX4yfYCvzBjQVPaHl9JhvCa8ng51ekT0jBah19dD248y
jBhSSdZE+8nymBa4NZe10U3V6G5OCFL93oAhvSUhUHWd+prlWDIPD4q9Sp0+
GFtNe5Tjd19cXdk7tL5qNY3s8SHF5TC0XSMuDDoOGo5rjmX0OAfr8Fb4vrug
1Tuh1eh6HNs5orUL3ltyMzkQX98MtCElvORgfB1XCfVb9w0PgGxDb/FSekw5
7Zm0cTw1bWJ7Bo8T2mnPp8eWl3wEdRdmY4wPh2bDp2VvZ6GXs9DLZ8YHyOnR
3nheXrKG1ZCT6O1MGOfMRLxnQis5OaWdZI3xM1oPCtKhBSdSmoCANnJ8Smc5
NraZhjEfbo2X//zT9L6tf7LZVFNT6VRBtizY85zocxK3TtUKsz+02CxiMwUE
peSnH7+Vj0/MwYAA9P293EEhe5+9PXOAD746+t/VWElYMqieEXJE5Qcg8uz5
1ZGNVfAPITDcEN1YlmnPt9BxvzImUNbE+OE1vA6LvA9uEt0ljnvtZYz9fRjv
+2NrqhrvSfCWvRiz++IbyP6hdeUgev4gCDgE63wECn98SEljTUsa5yyKgV8x
8xhA0BtT75rRfnpkUVdpbZVDnbfjeiupjlgaPS8EL9YB59u94AKaiPgt1fS0
cTDxEzuw59n9Hdj9E9vroRNDK0vuWG+5OK+nXJjTTXLwOAsD/ew4P8nG7WR8
RRWC0yn18Rih0NCKcmqsv2Ql1wEGCMGSasrJSa3l5PSuuG8jWSO9IRTlYEbw
xYDEiVG+kg5cKCrPESbxny3vdXc/E/FOTrNQ93sm2J0cDqe6mG+mz24qF8rI
f//9L/n2+n45OaqJrH+/hGwfVFq//aGI4u5cwMKBDWTaAD+0QAxq8bFsCauk
iNCu09tOw0DeO6SybIpuKFui6ssuyP3+IRURuZbTiJVeuDPAGe1QnnfFN5Et
jC6HtZZNuPExpXtnUiB6Y2tya9e7snU4jg9vK9sg+bsh74chCDyXbbG/4VxB
o1sax2tEM4xef7fzdTARPkl8HTkaV0X5yLRCc4Kudgy8+NiKkobXjg6tJkcS
aksa7tkuvbSMeDj/0Hp6YNoN9MSGVpHjw2CmRnjDBgSpEhxPqCFnR9U3GMzt
hlt3yZsUpChkj/GW/NQucna8PxCoAIUorSqhNiKloZye1Ao4QBVioArD68rJ
yW0MDlM7GvuAY5lDK6gzfXpYNbRZSr65uFUOHk7TKZ0utl9ZUMAZDpp2M5Xl
7nJnQuSzzz5zx2KeGPSzGPz48rpcR8y1ZWA5Wdy3muwJK63dq5fLqsH60Koe
GJRRDKYOgMWHZ3DCdq074ILlZ4ro4JByzOCiO3dE1YYFOoxjzE5uj66rNmEX
4ywbKB1FwLsHgdO2xCDgEILj0H74c1th9dn9O5KaQRHq65hlpETFOgbhPAJH
jH42urmoemne6rOpSw4qDiY2BCXlcasgh2HJj+Px4aQGsm90W9zayN7R7WTv
mPayP6WF0sTX+P50DMATkzvJCejxifGtJH20v6TDF08HGRkYzOn0z1V9isrJ
oeU1wXd+Vnul4OL8XnJ+Zjs5hV4/Nay6FzHAFVMQ4ChkRL6lflUmTAMhOD25
NUxELQtCPYKAK3ZyeheYJMKQhWNMaWen1JGzieVlU2qS5OSdcwPgFPvm5OQU
BoBxOuM8+Pru7LcnAKaipJ/89Ltv5emBCTpmF/SpJisGwo2KKOKGIM0+Niah
qToE03CjSaBjsGhQA9UEnsP374MWbI5uJOtjfGVtTICsiQ2SlbEtcGspW6AR
9G32RFWXNXEwH3HNDRRw1DfAQdiSGIgIuo7GB+oCwmQQhjSYi92JTTWFwbHP
UHl/EsxFcoCK+ZGhNWV3ShuAUE0tuNtzH9WaXEAbHL+vuI79Q8k+sg+vs/fT
4PMdja9pqMD794GegyMC4AWUARFwSce2h05UBQF1SQWMzaQOLh887GAggcE+
MbGtnBjOQAA+TUwp49NAcrLg/J9KrCxnYSHOzWwr51M7qcNAEnKntZFzc3qo
TORMak5YjPxgPJ1MaSBnpncCHSGSlQRponyMqO+WiawJLTTgODW0rGQnlJfl
UQge0jNdzmIQFufTOrCbmxekggkyOgLMp9V/AxXvWIfxv//5l3x9eZecgnVY
0aesTOvbWDaGVnY7CLzn873hpdVSLICloCRQGuYMbCKrQ2uCmNIIFoqrPDCV
nxZRjNM4siK2pReRgFNOKNbF+Ct8RwDClpjGsiquBcBooXAcgEdJH2EjovtN
Sa1gMILxuJVsTfBXD9ARduZQGJbtTYYHCBAIxjF04KEEGCQ487sR4REaSsIu
DPvdI4NhLHwBTFXjESAyPAgDsg/guEHAPWXjWFxl9/NDyU3ViBwa1hjw4H1j
zHtgMOiUTWrvQqA8uSOIaKcuXQaMB3s7e2IQboFyMq6MTgQyLcyJwezkajhW
WmUke2R9OY2wj9NpORObSf6c7tCCc3N7uAwtp0fUUS2gr3B6QnM5M6Oz3mfB
38iIhWqPbCxZE4PVAJ2b5C/Z8WVkTXwrWTU5Rv70zRM3HSzWcQrBmhWkg/P4
zgRyg0J00HU0VUENNdNN73RLvxIy4/36MrN/E9kZVha9XUzJ4DTXogF1ZcGA
+pqZZOhIMhYNqi9bwyrK0QjodXg5WR9WXfZFwI8IryhLQhvovMOa2EBZFdtc
NYP3W6Prqx+xN6qarI0LIh5eZMNVVlbGtZTdUbABCNE2Qj5IxhbYkN1xDZQO
2pbDmguClCQ2Qggwsq0LUV9SUwXmQFJjNxy7ER0SmP3DEEgmNdEUwXGYmyMJ
deRASnMLRRtcD6CAa0NQDiYjbocZIhyHkr0BBgLa4U0Vin2jAcwYvGcEbAeG
rwLxP2BUlLMTAiR3VmfJnd0NUWOIzg5fX9BFckfXkzPDqsqVuZ3lKm7nJwfJ
2eE1YFfKM/8Y+ZarmpwZ1RAOp6+cGd0IcNSVU8k11cE0OaW31OvISqyiMUgm
AKFDqQlDqOC5qc3k6uy2siWppcyO6SyXprVAQPCd27B4rqgqBAnn/Z2SgIZv
gMRUZnWWz/M3ShrCmBmQjsWA4UB4CfUu0tD5O8LKKTQT+/rrY8rE6tAask8l
o4RsCa8sC0MbydxQb9kTXka2hleRmYP8ZVVYbZ0bXm0BWYf4gtpx9A3awcer
QMjKOFAR00iNyo54JpNqwKAYr4PastXxOqKragIAkMC4NFZd2MeIEs93p4TA
pWileVmdbcIlpHN2jLqRjM8wsiXJCPFSPEoaHYEhwXGNPuhaMKw8MAIGbmy7
ImQE1xVnyAkQdGJsc1Dh879UpHY197NgJKa11dmTa/M7yc3FPSVvLPzIoeXk
cmo7OHC95frCnnJ1Xhe5NKutlkpkwphwaiMTJJwZXlNyxvnAPw2UczNCVGb4
us6Wj6wL6akL2qrBoJTXbBW9l8uzQPXM/jI76V2dvbmx5B359z9+chPCcljm
C2lJggoSwko7p6zCqUlwimyYqjAVbVXlz7/6RM4kVZYjYW9pvoGyQRmhQdmF
+yUD68jigXVl9aDqkh7B3LAXaEDvh9WSOYN8ZMqgQFkU2hAhSwlISQ0vmTHI
H0ZlcxjsUlRVNS7bouupeuyBTKyJa6YwGECaybrYANkU6w2XtJ7KyMEhFUwU
YFMSdE+ZYNqa2Ew2Y5wQEub51ZDAsBCQg4mNNepgtJEGP5PGQRPxseXlBHMI
MWXhd+Ir4arSX0y3ISnPpYfBc2h80mCIjgK+dJ3veQtgVZIjiXVdRRmfIDY9
Aq8mndChDUYR2WObkgwvCge8kVx4EW5QpreDDSitw/vG4h649ZTzk5rC5pSR
SzOC5RpAubagh73vLqfjy+ufzBpCd7acxrMXZneUywvf1gAne0QtyRndUE4l
VAA8reXS/B5ycW5XyZ/STGXmVHRROFMtJXV0tNo35g4f7RnttjcMSJ15OlMt
6U5L0H0lFJxFbeIBClPZBKWbHqum9ub2yn6yo7+XHI+wsypMFkFK9oeXVFj2
hpmA/iR9UEgG5WPmID+ZPigAN39ZCemgzKwIrauceMmsQX6u1vBgyqhtURcE
BmNbTH3ZGOtjqUAsG2XkJU3LJ0rpjBJnU/fBL2XOgamKQ3E15AiooJ/KJAMN
DksCaHwoF7y87H0jGy6328IogrlFJQT3GlWgG5hRzuC9nd7JoFOJqCMjrhwi
EFDKtEJCFTMFxBlEvJaZjDBiWM0ikplUAw4/HuqplAx6F/RLmY04hbedQXh6
dlILyZnR3pLTCa+Vl8szg5WWG4u6y80lPXUGiZ7KBfT09UW9lJar87vKafi0
uaPqKFGckMjGGEb7uKRnxzSCgVXDtaCX5E8K0L+bM7YJwuTucgk3nnt+XH05
OjJQpqTESO54HzV6zD1+d/uYW15YdumUXReihjNYtE1cQ+ldiJo//OEPFrwW
8u3No1optRtk7EX0wswGw1VKypR+TWXegAbqvzrZCcrKNEjKDFBDctaG1dBk
19LQ+jgWoAYI5Mj8QU1UqtwVFCQDhLymg1NUtXQOflO8v2yMD5L1CTBWCcGy
Gc+Zxdg+vJVsG9Ea9whvk1vKzmHNZHeSnxyOqUw6XCbTVcdtyzk/lIFgMCOl
sWSM9sPNXzLGBuAWJBnjW0rGhGDJmBiCW2vJmNQGt7aSMZm39pIxhbcOkoGA
MmNqF8lIQEgRV0GtTeaoppI5rQtunTnHPLWzCxZgWjfJSKqFwd9ALszpIuem
tZbcCf5yBkLAcIaDXHGCb3F6ZAN9fGFKQBGaJQQVN5f0glEKUTryxzdVw0Ry
qPQXpwXJhUl+cgZG7vqCrnJ5Riv1hzOjiyup56e2lMvzu8uFWQyhESMnV5eL
+AjUpJzkKnJuYR+ZnBIrWSD6dIJJkJxJqi5//PqJAw4ND/PkLKEJKAgOK27o
pbA2yVlkwbVTjKB/+uknm12rKX//4/cwr43kIOChvGwPMwq5flAVgOMrawZV
UwDY+ZtDK+pjyg1lhuBsDa+kc5/z4b0QqNRBvureboFhgvdj5o+L6fwwpzM3
x/vJhgTYo4SW6IN1Ca3gQOAxmGmp3Bh2WPrSRBVmx3DET9uHB7sqy7bhrfG0
lRyMq6kZEU5bpcMEZY5oaMSBpozoUDww+hUf4qI4dMKtM+/xVaZ0LMqjrg7m
GNSD+YjMCa1M9MkcBc7JnNLR3PM9eJ3RLBNfTgLs4rwemhM9n9oRtqItEGro
nq9mxEoG8hD3XJreXN3cm0t7wb3tABtUDvFQQ3Vk6Oaen9hUOcodVVfOIkai
HaMiXZ7Zyky1oTdO0VaNaSTnp7WUM8lwjcEUbdKpuFKSO7OjzBg3DJ8Hdmp0
XXV0WNxA5+ifP/3JnUflVBoNEPzXwrBwTQqnzRgmOateaMZYKUhYzBxMY3l2
dLqaPCrLQbi4VBKqysIB9fSeLi9d362hFWRe//qaR5kFIFIHNZUd4eVlZ3gF
BWQuHJo1YSZq5mQKo+yjg4upqrA4YY+dGmP+hPaHJWus8AEvJKUIMcGHJygs
+EmLLq8iA06Ukj2JTRUeJsP2jWgue+DRMmDJhGhkUjSSasBewMwk1zWUUCRI
DY8lVofg+BqBASNeZKa4PixpcGG+kohQSSa1NvYpvjIbpqh0YqHJyCaq/Rfm
dMUz/l/fkDMboxtBDMtZc1Jqqy05jR48GV1M8kZUh1KUR0+XMVRAOS7NQG8n
VlQXl8fOjWuspNBmGbqMApEuUsXzs2BOzw6vps/xGbyYmHHhT8SUkJOjvGUm
QVnUR+4uf0euwARSWAjLw90j3eaIhfKskKB0+BcEhatsnEXtvh6gsI6PoDhF
Fn/65SfqWMMpt/Le3Xq6ZQAIhvygqgrJNqgNVWYVvN5dAGTOIG/1encgSF4G
U8TYiGDsG1xW1kfUkb2Dy8mOwZVkXXgdOB3l3ZPnGxM439rElmuV0on1PTE1
ITe+VlIUHL3fFVtPp71VT2COOO9CF/VQYgPZMxL0IEzem9JK6xkzmaCGdlAL
Msb4KyWcymLHZ9Lc8NiwOsbE0Hnh/YgGxlTxdTVDnSg5XsqQfcqZcTZDiZlq
ZEZhZGp0XHPDFqweLyGtEhAysgO5yUW8RICyEdewB28vfVtyYK0uT/KWSxOb
SG5Kdbm3qLPcmd9en+cMA2RDy8LxKK0xEuUkb2wDubW0t4FnfmeF5cLkAAMW
gLs8ozngqod2a8iN+XCPpzdDu7W0tlKnyuHxzxoVLZnjW8mFid5yfoK35CGK
z4w0E6tfXt7jwMTVAlz1K+Is5XLDxDk9Z92wU5fPGnzO/7Fc0VRc1ZEH25PM
JL3N0jp1r/SE5/ZvKBsGVYaylJVp/XxkMmBiOc6+CIAGf4ZeMB9zGnd7RBVZ
Ft5YJ/R3RlSSXYMrytzwQNkYXlNTKIAJsG5IbOmqZEptmIiDreJE/iE7BUuf
h0Wz9G3WJoZohefh2CrwZ3w1O5uGWGZfSgvZPao92to9qi0CRc6ws4Yic7zt
WaiI3ju9TqhSmhhjM72bAY7yA38lI9FKEwyTytZIRM4Tg18btWlQpNFNqUJF
2ICrjZ6eMdLb2LJRPmA4WGMkqg8hyp/OoBgBcGwZ9U9uLuohtxb3kltLeqsN
ujSxkTxa865cGFsffkhlub+0uzxc9a58uLwXwOoi12e2kHOwM6fpGgGIfATn
VxBAM1C/gjiMmVraLqrQpSn+cmdZb8lT21ZVbi/uJnfx/OaCznJ5WiBCxjIy
LWkAM1aSl1JTckfWxnvrqLIRvuzh1eVvP3zjtmGeq+IK0eRZfGdeKqoxF1d5
sF4PRJny7bryw8sb+OSmFJAgMbRipoaxN9Vo9cDqCKtKyYz+3gDKT6b2a6q+
0UkbLFOF1kGNFob7yuzwZrIg3E/2RJRToAjXnPAg2RZeRQ7EVCdERZWp15U+
vG2ypQEUMZZv0codiiqvpWAs9T0aVxUO07CmrhKaojuY1BjhdyPN6TLsVhRS
uFYgY0RDllylNFKrk5Fgy6w4x8pjkHxilDk20AjLmABlQq0csWKN3dCKRrPG
BRk9Y2JE/Z6OxqCVMbSOb2FOsVM4eVNawEuuo67JuXFNoBNdiBE+EoCCcSBO
eaPhVY9vIA9XvwOE3pZLExpJNlzduws7yYOVb8uHK3rLgxVv4/V35erUAFMx
HOkCWqW1Kuji1GYwhL66loS6dH5CE8XpztKewK6BGjzqE4/dXd4brnMjmZHY
V3YnNEHg1QCfpLvcWf4uNLI3br2gg2UQro9yWzoWjtAl4pyiMWfu+hEWGXFO
8euvv7be0v/gZKo/m2nEfmvZe1pxnmmnEpm+YSKQSb9VA2uoJ5Tav7FMAk6z
+zeCe1xRDeK2iKqqSfPCA4BNoOrRovCm0K4yWnFGnPgaj++MqCj7EGuZarGW
BUsCcc9jmxKCWOSpBUYsQmBa2F2wy3wMI/DYCkzgx1bwYlkX3RrOxeDS06yc
QqDDtBzjaGZIsuLKeDHNTkPPWV24KplRxVyaT3MBMjqoGsUXNwaQ95Fe7mkh
vcff5fsyCW1iTTpIw2pzEQxjvMQabl3XGWBYoqtzqJ3gB8Ewhenmop5GpEBU
Pkg7N6q20vRgZW/cw4+Z0lSyEyvInQUdDVUQKlJ1fWZzOZtUQc7Sok32kWvT
AyUnqaK6WPwutIZ5ELI7y0lHT6WKloyf4ca89ipUV2YFS+qwvpIxC4I4sroR
N7hlt2A5SdVlOPeZCEZ+fHXXLVLOZpBci1eIKhYjMpzn9FPgG6j6+eefTU1q
DfnFvUxTpGSvIgMvuk6M5pcPrKWPZ4EoihODNc5JUqC4iITUkBiHHBK1P6K0
bIqowef4IHjFVUX2RpSVXSBFXajE5lotTGuny0Jiqmp1NotJjtlCkkNx1bRk
ZZdG75Xk2DAo2Lg2cngsqwbxCCp3eFw7PXYsvrr6CemwfMzx5s3uLnmzuuDW
GbdOkjeTN0hM7owOruL4v73kTm9nbtPa6ixQ7jS41LlTg12l5ezEZprKYcEJ
aw8ZGBFPzf2DtzMpdeXMyAZ4MLKeq6IK0+nhdXQeiTaKA/+U3vBh4Gmfn+CD
uKyFOj9Ei11Jjzt/ZC2i5UW2XE1Ut65O84fOlANdHZQuknVjVgvJHV4VPlY7
bfouXnsEEm/ObiXnR+NPMq8Mk3tpaqDcXAhfbFkvUPa2XJzsZ+nqoKZw/shB
kj4/XJ6u7i03ZuIboi2un7sB83gbhJ0EpVfnddZctEMX98Xhgg4i1LQgXaxV
5jQ45SzozXS1smH/v37+q1zEBSBh1Iet8JmYjqZjzmiOdM3r30DT0pyUYLR3
DHaJ6YF9oMZTl5aGe0Ov3HTxuJdiVg4WEqCwWBZ+OcN/Z7Kbxa30wQ8OrSl7
E5vIrmGB8MWbwycPZlGMVq9tGx6iKaJjwxvL4fHtyVdbiBUeypExIXJ8aGU5
Hl9NjoxFcBdXScsO8lK7FiNgRUmaCwFSahcew62b8sZEoJYqQeBYwcaJ6LMI
yPKmt5c8AEg36RTDawRveTM7cEJS8md385Jzc7q7QuTc7G44tbJcg7DcWdxV
rs8OkYt0uUdUg3mqgC4vpaaKrjA9GWZxPlzRS0WKKD2AaD2EZ3VtRqCcAQZ3
5ndQz+rWnNZ4XlYer4ZozQjS1+4v7SqPYBYfr34PuDXXqQ0K1qmhpdU1vzKz
pZq9SzCbdO9vzQmRpZPjZN/0vvJ0VU/gCI9taTeIZS05BXN6eXpLuTglQKc3
vrl5xG0CuV7eWfDjUxAnLkl2dktp9macTD1WI/niwnZ3ReWG0Mpq4g6FF0dc
V0NRWgkTSMQ4e0Evaw8Cf86BrRxUU2trHfO3HKaQaciNETX1OT0porYivJGa
w8N4zUlhMtnMXNCOYUEe3BSRreBmm7kpRcHg8Gh0BUkb7q3wACMVqSOjm+u0
xfGEmnJkfBvc2mqZswUJmgSS9H8Hoq7UKkhRELSltrGKReUUXGk9Bfzkz+7q
RWBg3PLwTuKUN72tnBnVSLIgVrnTQvTVIlopE6IsXZ3RTD6ArHwAo/UBpOUD
uER3l3SXW2DjKiQhGwZLwzZObcHdOQ+v/EZqS/XKaQAfre0DQxekMsSQjx46
cwoPV/aUx2veUS8+L6UGnvdWibozrw34guc/po4axwuja+Pc0pI9DO7WZH8N
53ITy8qSUf1ky6gu8mRld3vu20bi8LfJJzOZFOL8CU252tktT86OCVz/WIgn
z2LN5h48MQ60LlVzy6FmJcc0kBNhLs1ATurrJysGop/gpXPi/QA4IlecSePc
KkO+zWGVZPIAf11/ugOs0DNfGd5Q9Wd1RD19vjjcRzaE14IxLKMT8HsiK8vG
IfV1HRNT0lz9cHxIKc0eHRhaW3ZCl0CQklVMWSqP/1tpRW1aii94grEb30GO
pvhLOtyAY8kNwFE7ZYlMefBURHEq8xonTmHB0LGMkhMVWXC+Tg6tALRqGXs5
k8kn4lIJuHTV4hnnBrtJxwy2MYSlE2ij6evnECnzvq5gs6pcmepPqLhUellP
WAwFbGkPuTjJW0Unf2RNTUBlDvGSPAhWHuwaATo7rLJ6TXcWtIdgBakNvKpi
U1o+XNZNxerhyl6SM6wS/PrGeP6ufLCok577GPBdHFsPkNWVR8u7ye3UFup5
EdLsuJKycGgHWZnQTu4vaK1QoR2Y3BW9cI3vLeyAJquY2IxVoWkz3VrFvUho
35hp8i7IFpeAO3smtrBscVMC7szCG0yikbCmbJFLt6E9NdQdpwPFaO+kk1YI
LytzBzaQSf19ZXNoJZjFcjJ9QFOZMsBPOdsEbaJOcbUPueJjapMua44sK1uG
1JEVUX6yOKq5rIzy1XzUjuQW7nwTV9ccja6ok2ecl2cd8PbkFl4ULC9lrCSe
t9QSDc4cka+0Ed46eZ6W0lSOTIAtBGCwb27EaMNUol6zlQMHSj0mOPRcmUG2
zsD25U5uKfnwv2DSLCtdi6selbRYlZUcvmU2kOPinfF+Zl5rcgtDY2VVvEuT
m6pcgSncIF3woa+lBpvkNhwsekaUoxxIzO1ZgZI7rKI8XNJRHi3rIjem+8n5
UTW9JDuhnKuh5rC1EiymOCxWV3my9l1VrvuLO2sgSMX5cFl3Va2HgOnpmrcl
PwUfAYHl8/V99PmHizvItQn1ZV1KV1k8tL3+uXyoXi6Axl/Rv0HYWVfIdugy
noqrIP/3zTNHuJwdVk6dOuXA5awgYeacXjs3KWll4WJ8yI1WecNj48w3kL/9
+AudTjkKdHfDb6K/xGkTgkXRWjSwnkzp31Qm9/dTQ8i0wsyBPlphyEpD+loO
TLsjjK+VBqHaGVlV1gzxlqVRQbIkqhnum+n9ahyzgLleT5SE6FzbThjGA0Pr
qvHjMoJDsdVkZ1KAI2iArJVZqzeqGTz5BvDUAdyoAAJGvghZOy7lnNBOi4I5
Da82cCq8lTFNNFLUGVe45NmwcCo+AM+ARcHq6iqlZDVXh5/zWG6yKFAsA5oQ
qFaS9+fm9oRDVlMuQkwcS0gvKx8ONS3OtWmB0Ije6tlQlNiPH69HcJ/aDP1a
Th4t7SIvN/bFsffk6coecn9+a7k6Cd4ZhIz9TW/sJoSI4vVkXR+5PTdExezO
/LZQnIpyf1F7ebYO7MF7oghemoBw4tnadyH5L9a/IwfnRMrixK6mpBXNXUbT
FKv7SzrDGHfRZh+u6IG4oIqu/r2/JdZzfpcJdU7iNimIFovbncrVYA+0qFnc
OwmxpMk+lJNvbxySPf3fkrlwy1lwRrRORQKzsDIyvb8PkPJVrJYOrK0liHMG
NgYSAAu9MGOAj3sWj1NxeyMryqYh9aBT/sCoOVHChwFc+PPEat2QRrCBZTj9
VlSpqqtEmVncYNmT6KP1qboqOpoS1hC0BWjlB31yxn1Hx7Q0phCx4JFxIXJ0
bEs5OroZCAvU14kNkaATQdE540aoExEpquQUNaZPtajba1e8l7ri+Z43AMUW
cyZpMeFriwkJo+IRshw4bqeG11bA7q98R65MD1KXKj+lpnywpKu64gSMUR4z
6LRkz9b0khcbAUtqkIFsSScF7COI1Mfr3pMXG96XZ6t6aQEinZVsiIy6V7B+
t+cBwCm+OK+CitA9AAme5OnaApDpsY/X9pZj8yJkUUpfyeIcOItNYkrIlSk+
1pV7F+HA2xDH9zSLpqEAIhjmHRzMnK2YOBvcuCBmDBqdHVGczXW4LRNT7VlZ
WTbDVVEe7x4ha98vKRP6+ssycLSPO1Mg9FsPP2sS2CJjCyBhTKtTyuhv0S7O
G9gQclfWrFwurq7V1iG1oE4+bsUCZp6EbRjSQK3fjuGtiilhJd2EbRvRRm87
k5tBs2oosOnOvhZlFZ4T0G7mjnXRAtcE6+KFsibVxGpkTneZNI8X01peWrNR
VZ0kpg1YHULvmw4Sg0D485orYHBIELNHN5HsMT7qWNEZY9VyDoJHgnqW5UjT
29Hh9yKtrtJKW86UYHXyM/GxckHUOTjeLFhmruDhSvo4TCvAESttAeui6vN0
dQ/5CCr2YsNryB4uVci8QNk7MJDPV/c2nllyZbjrNeXJ8s4QtkZyFq3To0q3
ubY7c4PlOXh8CuNZmLEX696RrAVhsnhcJM4rJxdG1YD7X1HOjawOZsvJTXzK
RwhRyRmFUZdE6LqsBAcvbo3IzVHu3btXGC/PWlpnKyIu02X0yB3LTD6+mq7w
Oj8lSBdfrIVbT+u3YEA9zTysQChIxOYMaKTILRtURyYNCKCMaZWbs1ia88Vr
orzVzYK7BYk7Mrgk6HFcebpeDnOLo1rgmFpAGscQl68BTA1ksHplu2AQ6YEx
kmRGgqkuyhqLYlmwxgLSjOEwjiN9dLFE+pgASR/fQtInBEv6xDZmQoaTMyAw
D7HQpXld5eKcjnJxdge5kNpeLsxqK+dntpbzM4LlHGLwfHz9vIl+kov35o73
lhzO7bLyLKUOvsqZ4TVcveVMMojUOqPXBa5myU4Rd0EKX6OoadhAKeVniDA7
PFA4riOu/HBZDxU0oKfiRgwf4PYBrCpF6snKbsreR4DjDfwRP3lObwsQfTCv
lZyD13Vrhp+82tIP4tcbFjZYLo2tIyejimmS9eaMAHX3aUXpmT2GMOaNqCpX
JzaQ7EWhsmB8nJlRwnnnUqrLtalN5c6cVgogwxCa0AcwofQE6fufSawkf/n+
cwdArtrmRoGcl25UEEDW6dJc8lmbQgDSofO1gcHvXt7Q1Zg7Q8toDiLVJlCp
Z/Pg83PGh4UMq0JrqkvGYm7azT1ww47gPZyX5hrAZVGBajcJ2nLY0PWwl7sj
q6j/z01mDumCsRrqsm2BEHI7hJ3JzRFjNpX9Q+vpOj8azuO2PJKkHYmrKofi
62rd7Z7heO8IGNrhgRpXpk9qy6V7nEVOn9LBVYIPgaSZ5EsfizclVFP8Ls/v
gTdemtetmFya381VBf931yoj921BD9x6yuWFvfQx+cwd5y2nca3JFghUPlm/
wPLY7BHwyGYrx2gYFMNKnJvaXM5NaabVktkJZTXlyTCQ6UsVldF1Ybh85ebs
YM1T0LhqfmtFV/l4A3Vt3TsIxAxyzTyQ62NwAzJE5DmkkXb1Q0SJn256Xz7Z
1Edebe2vyGWE2907oGUXx9WXu/NCoHnvaDBwLqWqHB8FozR5uOSNrCG3Z/rL
81WmrbuwyU+A5cWxdfUjXZvujyChslkLOQDh5rFUz/VG9perCuPmuT9pWw/c
nN0NTV62irw8uVR3xGGpAzHjZCKROwiUUgc01tCS6QpqHUPQvQg9l4fWB2YV
ZEt4FVkWVl8ODC5L3Kx7VsmxpYoew8vNcOP2RVZwb3/FNYCsv9TwMa6KHB5a
Uw4mNNBlIrtHQPBSdIHwyDZF8JD5Mr5A1z99Ekv+0ye356JT4gXV0+0ZxjXT
5yx0YZUjKCpFmcNnceCi6J2f0VpLlE4nWJAgYgTp4uyORBGwdYeoVVXhY/31
2VH1eC43bwCoFRXKnPE+cn5MHbjn78mjlb0gCF3lNgTiymRvyYNgZCN8o1fG
2Z6T0cVVcJ6s6EaevEgWodrYxyMi6AzXvY/q1t3ZzVS3PlwQoq89X9VNPtn4
nny6ua9cGgdecctDFHBzirfcmNxYshF50nheByAMXLNG+8h0Fs+MbySXx9XR
8wjpGdjwhwhqqXeEMBfjgOEBI01OaHHVy99+940DFfdpZCjA7UTMggL3phTk
jT4a57adzWY897b0tlBx06tLM0O4xZxsAVg6rdjXT2MCLb4Kq6AGdI9dX7A6
rLaWc24Or4qQspzMCvXXY/sjy7uKESMvdf/LWZrq6r5jRyO5y0UpXXnsbNpy
IBFO3oiWumgA/Cg+xZSnonzsCZKbo+R6WpOXPiHEMDW5nSdHxUmOFzHC97o4
p5Ocm9ZSi/RZD8nZyDPDHYg6GIgUtm4KHJ+z+jZ3oq8+p2KdHVUX7+mmEtgV
V5Hvz4G6nRtdW3MKTFrx/gncHOYZ6E4/XtUbgPlIVlQRnbpk5ul0bEnt/Wtw
v5mkeg73/OXG9+XunBbas4/R4+dH1ZJbkBYjTe/LNVBD0l6sf1vpuDKxodyc
6iMvIGM5OOfhwjby6YZ35UNY0jxQkpNQRk7Bx5w0Ilp90LzhleUlXv908/tq
ZamolCpaU8ra5QkN5RQ+15l4BF0IMF/lrHPKzj1/WqFBQaq4qyeXLnBXvw5v
oKqJdc3+/KtXOju2emBVJYj1EJwMYpLCWfNKK7kprJqW700fFChrw2pp7efc
UB+ZERqgS5wORJbX5ATFyoAFeYvCa0MAD1y0Y5olKydbo+rLypggs+HX0BrE
SC0fNydg6TiXMO4b5ovjwQ5sRZS1CoY1vKSrlie1pUXEfTtJZ1ED16y6YWtf
GDiqjUNcGUMcbFl2Sm2VLJZIqWzhzUa2HHnrBsRJVNnX1NHYLuDqgM6GvJFK
npKo1I1visCyelEih8iewD1Y0V3Ow+4wKrg5s5kmHc7B1uUklZc7M/Enx9bW
OJEx5EXYuDuA7RrkKDe5kqbqCQXheLnhPQUlH3aOccCrrf3kOkC7Mr6efAH7
+AzxQQ4k7sHC1vLltgHyGezmxys760K5qcMH6w42JwH7U5hjgkoZvDgGcfG4
eohF35FncP1upzaXLM7ZD/FSV+zC1CD5989/c2TMqSXlOv1CwLHwmLWk3O+1
4xuAM6FDXd2x8hgkbC5CR4aRXFXJjBmrJ5gt2x5eSYuKZ9pqdFamU84WhTVS
CZsJ4DZB0uj3L4Kfb7JhPrpD4mFWqEPBuD5/fbQPt2jw4l4NMFm7h1RV3gxT
baxw+YM37sxQUjP7RuhauF8nmx7Q0ROb1A5E0OlixY3CN6WDl4pe0cLMGdqK
KG2s2TWePnhDoExvK39ykNKmpBnaSrwJNn25W0Hg5hlJzJ3gR9i8FLbWRuGg
brdSW6rJ5Bzgw+Xd5QnUj6rycFE7uQZwLo6uJZ8Aphdr35ZHSzrI9clNoEJV
1FGiDaOFuQLfncDR+SJ8z1Z1h9NVVu0oE7u0hZ/j+OewrQSPrz2EYn4BKL/Y
8j4C0gEyd0KinJvZTk5HF9OM7h2cx5QalZK2+Mb0APkIgev16X4amJ4bUcXM
eUUU4S49jsoxieHsAFO/IHQsYOa2rhTATm+Azpha7tz7X/lgQ6TsH/AW9/zQ
3AXTrnTCqHIECsBxvYw/fJIFg5qo6K0KqwPe/CU11E/vN8M3o7u/AaIGM6qs
HRhSQTZFNZRVMYHOpjBeBA9AcH+YPUOq6Pr9nbpRXQq3ciJSxJCo0UPzlD7a
UmJHW7uPC/FU14Khb5W0eEu1jbo3uUMRDQlK62YO+ZMD5NLcLqpqBERVjcWi
8NSVszmdvF57XcaMgrSS+n/P/+XNmlmHOQolRS8XJpmB3WPNSL2rQdv5MXU1
TXsLyvF0zbuahXgMH47e9QOYvlcwn1fG11foXiLofAWT+YrqA7iewYe7Py9Y
zSSdJnr1Vyc20vMI3sNFbdTsXgOgl3D+ZwCOqkbonixpr2r3aFFb+XJLXwS0
78vCyYlye+VAuTCismbl6KRxJoIO2yO8n4Df55TBVF+5BjP9fGUXnQOjr35/
S3w3SxA3nuFvkvBZvYLAcV9tpxC68xuAM6JYi3s+annAztCSChuzGXvCyqiH
z9VYa2BCqW6pg/xkNm6MADaGV/OgLUDNK4uiM3WnkiKqaquj/WVZTEsVtWIe
mHF3ksMIIsFVUcWshBsz4rRvmJ/GmcdNhgM6tD+xCXwvLtvVBVfDaqt8qaJN
bGOyHONamBCTS3HwHpaMcx03S3BOJ1TULAadf3JHjIrwkXHAihpnjaQZU1qE
+LiqajBgotGeqoH00S4v7FnAtyN0hDF7ZB3JA7tMrD8BVLdmF1S1p2vf9aK0
geIncOXotpGlV5vAFizZhVE11TJ+uvF9L8IGR/dTxAifbekvt6b7qrdHA0z/
n1hQ/27iOA0i8y7n4dFB33ClABy6/wsg9whYUueer+gM76+fLJkcL1dXhMqV
0TUkFyheGlMTGthKA1km2Ig8h8F5eKE3pjSRL7cPkA/mNofGvSXZ+PY//f6X
jsZxPoAFrtzsphByLLtw9l137DC9Ozp+/BGW+taw/u7lTZj3orJ+UGU1qhSw
DfDMZgEvLkBfHlrPjRyN7M7w8jCoRthmh/oiNqijuQ6zkV1Z3auAO53shYJt
jmogq6IDAFxzR+SKKH1FZD/0j1sQADWNB0Ioc6010rQ+257hzRQ+3TjYqRHk
PTWNC3e4/II1hNEeKwCHFLULCJq6yyAI3SktUSxrdhjn+iwKHdTnFHOiiZXk
NMBh8MD0hW4ogmgzZ3QDgNZEl+Hlwj3Lgz90bmoLOYX3UyyZCuFiLE3fAT4C
TaPNaJVJY6Y2Loyrr/l8QsgcK1SuiMJXysJXBT3bUmMCUvZy3TtyHgRcndCA
z12GwLoK5y1Yu0uja6q1ezC/Ffh6D9SEwKLWVbpIZjaE66OVXa3Y9cX9+0rg
h/NaavxA4Vw+NVEurBgs18bVlrszfeXCyGrywZwg+XJrX3kwr4XkJVcy244X
V6NPrXuwIBiwmzDii4s7HL1z5tc5S2D20XFvg8ng1P7wmct5O4uxnU3/Datl
mT9RFaUnx0moFWH1dB0hV/3opEFoY/XoCOT+iNJeFDnoAde6k00md1kWe3Rw
UbBWH2gFycaoRmo9ySCXH+4bUlG2RdXRHde495azAxsNMevId41sa6gLtI5b
sKbTGExwu1GzoU5ZLaPWHElsJU32ahI3heXSkLkxgZIB2ctAJJExobVZYchN
TxDdks58JnDHNNa9imhe80AT6bkEN+4ik76Qw/PTgzVJlj8pUENYvof5EVJ4
NgViM7ymbtxMuk4ncfMgcAu51jUWXNurW2UUIBzv4Z4IHQpU116f5icfLums
yVY6eE8R0loyVS45VX5vdnOjh7C1xPLFOmbZqoCHxtRFPe4gSa18vryTiuHH
q7vJV9v6w5nrK682vA2sTFRwlnUjQJ24fgpHjmh+icjjPl7PhZ1dNHaw5C4f
IrenNJLb07zlkzVdlbePV3WRr3f0B8bvyL3UQITZpbS93GEVNBKi2LJA7fqi
nm7KnN/W5LY/haDkDJZTo+38nC8TLFwcSyjruKcdfpb8aS3UFeBWnvMQVnCR
KxWRxpVhBWPalWF13fEsw4y9duHIpvDqenwj7nlsUzQr78Gcq7bSxzh2bbSv
bI+qpbEt93ziHlA7htRE+OGtxxhTUAAPJDaWw0NrKXa6MD6qhJlr4CJ4purw
PmeDaW7Ywa1/MoZW5uqhTkW4johF11M66ZyEiua4lhr0nsf34zrkSxCs3HFc
f1ZF8dRtu2axoPrKgp5wFa7M78Eksd7rDfa4iL5Wl4/N6/NgmRnHwhpTQDnX
wG0UVBxnd0B77Qzi04LV08wZ21hrH5m6o5Vmt3J+ASGJXJ7QCC5hC7m/qKO6
i+dG1lAcP9vc34hhgBLIEITm0iGSNN5Nbaam88tt/ZSWfMTBrza+q2EFiXy5
pgeEsgzo6qbCdx7xMAWTJvbjVd00BHk0r7nMTXxbTi2Nlgep/nJtQj35xa6B
8kFqAAiuLJ9vehfkvi/f7Bwg1yc1VER4PolmOMM882nYlL/8+jMHSO76z226
uaFsnYJAsrybOw7xFyR7FALy2rVrdtOI6vKn7z7SXRO44fORwcVkbVhNNceE
ckFoEyhnKVkO5WQpJJMsXAbH0snN8Aznh/nKNjzfGVFB5ob5GTCjG782xZVU
DY0qNlNHkUpKS05ldYyvs7UU5VBnHYaZWQfu/GE3gYWEFjMbxlBGwSLVFVEG
C/gnd+AG1ZM7QhrtIiayyPmwyR10Fdx5cKEeHli6wvkGsHRuSnOz6w94yh5R
W5+TMzCH+AXvgPzxvWQu10rlmWHV1RCbiQ2GLpXUazw3vZUaZEocM3gPl3WT
e/PbytUpTcFYTfW3zkBCtfoHf4+TBo+XdFTpM5YYNtrlVwC8V5v7wXVsBYtN
n6+PQnYJfiDBYGhB8BS6xLLyBSTsu10DII995Mni1nJ1vLHanCt7vjhE1k2N
ka2ju8i96d5wQavLtzv6ydfb3lfrfGeGL87rK19t7+eGjuHHB7ObwafsotLO
atpf3j/lyBp/1paT9VyhW7sgdKz6ZuzLXxRzfoacFSfOL+HUstB9eXm37lFz
MLykrq2kknFRAFdrLwltqOaZSsgyb95zucnCMB+ZGRYk68NraYn3PMBH6FhT
uS7a5zV0FdzQUQy5PSYTLfzpjUy7aIq7zhG6o7FVNNFHsMx2M23gmew2mT1A
xkhYlzERLsKkkLV/vZKfkE2xx16DxpgMAJVWcSN4FCmKn9Z0J1SCzfZXcbSv
l9C397a8mV0/qJ9n7fYwl+Z0tvyaFAt/AEbnsFYaM0vuzEQ7wlfc+JwT8Ke1
mg3jK9ylUxRk4tLYujCdLeF6dTPmFuEvM8U3p/nKh/NDXvMGvj5d31vN4f25
LdT0vlzbU8Pbzzb0lK+391WGyNK3O/vLp+t6qPBdQpi7ZFh3bjYmZ6KKaAzC
93yH97yk6YUoPl/RSb7ZMUBuTfXW/WUuj2aepbKGv4wWuAj45cklJrAorrWT
zLdwfSZdwnHjxjGzVwg9Lgd2foK4l0f+j8VyRM9UZ9aQ22sGSTrsOpGbaTcO
YLKY+sbVmc4uNFxEtzy8ocwOC5BU3JaHNVDUFoc31mPET+f/Y/w0BCF5xhBX
UneQBviIzf3tjqqmj7lRL13H/cn+ulPiofg64LCU2Ug3Hm5ncqDum7db4xZy
WMSTQ0YfkzsyvaIMVjUcIjx281mQw2JuDLurLSVH+ZMDNSih7pEvomlfN28v
+T8YUjY9UHSSNhdmtHEodJm4o7Jx9EDkNS5UwWvXpwfofEeepo3L6/Tnjak+
ULlqmghhKQnJuzenBUxqFdCnGTcvIohPQtF7tqwjhLOMvID/R78vD0DSh/tm
e98iJBAA4CH4GiC/3NFH9qVGyvKkzvorO2Tp6ZI2YK2f/GLPIGiaMbQ0sjen
NpHLiI3zkyvIy5UdlMuz8BPOxhWXW8v72XRxKc0uO/BR2WhSGf3ydxSdX94u
RCJ/v9ZZZty7EIkPHz60QXRZzcdkj6ghmRiezMEwNplld85ZFNrIBh/FQWED
EOfvRexcDeANept9u8LrKphzwvxlAbSR3uGqmAArfIGyNaqeHBhSXuMUJgS3
RNeX1Xid8Qs3i1wVG6ibHCh0zC5z823utTWsqW7Hye2SuE8frfFuBC60wV4K
ZSkLZX0D4ZTOJigZWtms5TRCqbB2AMYElBvlXEAQ4ha7MsYYq4NnjDGJY5zB
aDl/UpAxxgtUH2lsddqjIJk9ebg77LSnTrJJTzJNOqaa6uL9xZ0kD+Qx7/zB
wnbyfH1fuQA9vAUbeB/hQw7Qer6qO2zv+/IMke49hBDMvTAnwzoQ2sbTcSXV
oft8C/MwcAfRI/dSg5Qr6iNJf7GqszJJfaROUv/4/PONveXZopayY3wvWZrc
U1OCOtMHubk4qoZ8vLKTvvci9PAenMLb05vK7amNEZlXlycLW8nHy9vBny0u
+cPKSx786v/862c75V9SCzX5I4fcZZB7rZBTLmZgoQpiaGcPe6YQnd9+rlUQ
W8+y9bftMf5gHldQPH/+3L6vjHx7Kw1X4i3dRXxzWBV1FIkubTc3gHLsdWoY
NxUGna7yaqdZPrwpopqKJ5nlveG2pG5irLMhEElGKzujasraGF8vmJHm6GAi
y32iVsYGAdsgXaW8LzmIdtsiWcntHO5FYMOg5sQQM1PMIEZ/lcXa+INwMDO5
0pOxNG14Us1CyBZ323nFdkaIKVSZ172UYljBxiw9Nbwmipyr0+wjYo+LqR3c
Zr8Qrnq2YbYrmK2jzF6e00VnXBizPFrZ0x0qc66f/uLliY3Vp2QamwyzwOQ6
goLPYI/vwS4zTU1WX8EnJLecF3mxrrc8gWxyFphskVmGs3dnBUBGu6usXkXw
cXVCfTmHGOmjFR3VfyR7n296Wx4vaq05SNr6SylVZM+E7rJxRpx8uam3HuN8
zEX4CdTLaxPry6MFrRBqlwe3NeXO9CbyeEELOY+Q/gv4CZm2XoyBC0KNEIsr
95Lib7NySwYGMAyduR6HO+sD12KWP6puwT3VXVXtS56F8O/aY/x1KE4wE9eq
FtfH+8ab3+CCmq5DbENc14XV0LTiKgTZDKgL4loDalxJdkWUp+q6UeX92vDa
qsq6Fwx43BjTRJlcEduCpOJxM01NUm5X6f67zWU1ZJZB+F6WUaW0tna9puWx
jbJpZlwqvJ5xAcPKKfnUJfENC9p42nz6nswJjWuhdZ70KWnMCaBaac18X57b
tYib2u6vo22Y9asLe6v4np/awlT4MUIfWU8uzGxryE2p7ZBrBNigW8HIbXJ1
fSOX8z1e3VseLO2iITfni+8taKtZnyerjTOg2I5vwIwfGnq1ua8rSO5AMrkw
4hmkVIsWNr6HWx9F+KM1PU2ycUVnuQOHgdJ6Bq4s3VRKIgsiKJtPFoXI82Xt
NY7WdDmkly4o3czvtveR88sHy9oZ8fLl5neBfxW5MraWXB2HGH5jT7kDWSWy
bJe/jHhnWhP5dut7+EwYTgiZmAnSZT/hXvLrR7ktLbacVuH8HkviWTrj/MIz
sf3555+d3xS9e/eu+0cgCmHrWWT/3huwrWyxZZ6Ii2I5Lc2qP07ObGPFH0Ls
JWGNZGZokJZlbYuojItKeEtrZMSVQHRN6RkQ26XhjdStTRtcVEOgtbF+qqpF
CCvdy6gaurMnvAEXdwduDkDp0nJlLF1UYFpMie3oJnbXyHb6+ICWSFTQxY+s
8tIsINfcU13pGJDcWJvN1B9NKmUeR+pOqpqtNCWkJVVCmWHUzccgpdxxgRMu
5ExL+1LqSA7z5gjFc8c20Qxm/kQ4l5ODcLy+2Q8An4NVXWyDIIN9E67rzaSQ
jC9bT6MwLsS5OTNIc+iXJjTUcAoya3zZVoot1Vfz5RZRpx6GUREx/XRTH3Mc
9/QciO2n69+GX9BfoygmLYkwywBPxdhkKreRZGpockO1+F8BO0ZQ6sUC24vL
w2XltAQ9Tmw/XtoGaltVHs9vLj/sC5OvNvZSXLOGFAPOteU3+0Ll1pRGchV4
n0LkfgZqfxqe74usxXap7P9yS7nl9jb87XNw6/wGKx1d56cRC3HLl1hKwXx8
n0LcchtJ8wN9JbgIQGNN/mTRQXgC3DGJlarzQn3JaWgAvAHK65bwqjIL0bwT
Vi0Kb0KKZXFYE9kBOeaxTRHV1cvlL1lATg2yTVRpd1psV8cGuJWXalsQ3TZu
Zo13EKxqy5Smpj4RcTHVyf1Ata6MvzZDTsnnsNomrck9g5mFHx0ApW1uFJfb
dvE+1smCV9NJR5rxi9BEk45sCTabad1F3gRfLWvNGd3IbuxZWzPuZNtk3Kuq
AOtcUVJlHRdZMSV0X4siaNs9pzS0nI6N0zo2EEAlV7Pl2CZiJcOPbGkF3QgC
TLfhiX3MwjKdfdxE1xXYYqgTaA3I4Aa8WPc2M1F9XD5a7spswcu1PejpujMC
X20fIJ+s6wWeq+if1KzW0FKI5JtArjvYjMBrlm+tDpV5E5PA8vvwcKvJx8va
yqs1XfScrzb1ku93D5Df7B0kD+cGaTbw3sym8mJFexBUVMdLblI5uT6uutzf
MtSuCzEsc3aI9bCFWf7HP/7h/Fzsb3/7W3WEuTNlIZa5NY/zy93vv4Hlipbl
l6eWyQm4DtwpmfvyMEUwN9RXZoVSK2eH0rPlwrj14TXVk6XnuzK8nj5mWpTb
X2yNqCoLw30kNRyuK16zLHspy8WU3R3RtdTpXRPjr/6uea2avraWPEeVBrfN
1StgcOY5c2TqIU3R9lGnaJu/Q2i8DX2uu57Sg5jaxaW5ey+7Bxg83hLu8IxJ
JXVmhxqf15p9RF/FCibpCyTqi9okfncnUU+Xowsu+CX4tQzhCDwBPTcpEIOj
DQZGKw33ODDyJ/ghjvHRP8tBp0t9uTQXVDFG4xw1yyLuzA3RnCqLqvn88vi6
dBSYb9yoSXtAzOnE1xWPxolg3EYF/sIhGH7vc/jFdDyuwzdm/vP+7CD5bH0v
uTGpoU4l0U++N8tfXq3vIb/Y2U+ebBwkM8cPQxzXX+fSqcK/3R+GuKyRqu/3
u/orxc+XtFaHgQrM4zkYPaT8MmK3/KQy3G3R1wLMiXL+MBArt7l7BgHOzMxU
gBHGOT91+te//lUB5oxSIYA59e78YnjfNzgRFSzAt1cP1F804vI8OgDcY4U5
+tVhdawYl9I81zr4tQR5C8KzjeE1VLT3Di4L56GxzA5Xvzg8AA7GmvA6mlIw
atvMg97SDr08bsK2sppt2BFVSx0EM79katqOxlY2peAIzfYmB9rwLETT/F7q
JBdX0eZ7+Cs+OtVJwZ3SsZhGaCWhwW11n3V6vHRWnS1vObuJaK2iO4PfS+nS
+Wv4szahYDP4zPV30UiOUZj+3gcIeLCsK9zZznI7taVcGtdA8kdUN5n72BIm
k68TjpXl6fLO8nLDO0qbRl6sStv0msSXrCpb97bS9hzvJX1fIErjfDkrzTiN
RD29NLa2TgFxKug7aCfd1UcLgjUy45TSzUkNdJOWVFK4MxSRWW35cLY/7P4g
aOx7kgeNfLYoWHX0JbST35WZhXvTG2t29TQ+95MFzeVMbDHd0OXvf/rBVtqW
VG/0/v37qqWEh9Pq3EORcT9QdHhjBpZOKzdSKIQid5nmLx7yWb9CKL58+dL+
sHll+dvvvtV9HbjnOJdYcVHxXPipq2DfqZv0ERaGeauvyudcYsUZAWK4IqIB
AOReZrqZCyO02eEBGo0ZGpsXItFPltuIjEmuTdGNtBaJ7i8TDPrDFbD1JiIL
1oyr+gjGT7AzABbBuBq6IWvGsLomueUgWNoDwbbuDCvVjQJK1bPuZnlFsbhS
Sk9VKzhiy6jeAkMTnXVR+bw0u5PWPXO+kjr3bF0fd9xPg/5oRU+dXucyhPyR
NXSxHTWThNFL5XwRdY8e6Wdb+qnGseLjI1jz3GRS2BHxfR8cb6TayDz8l1v7
6aQm8wGcC/puxwD5ZltfWPB+SiMfv4IXcAveKmtMp6ZEy625reXSqOrywSxf
pe77PQPko2VtQGJ5+W5bH/l8XTd4BiWUzG839ZBHcwNgzYvJC7znTGxx/Y5/
/OaprYQ0FNIm7969W91PLhzNz89XEw5X1NlXgSvir169qs/MMfcv27IkhN4p
1ysMsMecX7vl8gbzI7rltdA3I9Sli/0OhxczFj3MD55ooEZNrEGi1WbFeZbd
wGpVRD0vqmBRRa8KH8qGiJpaZETMHOyodkwErI9pqu6p2by8pG5mvj7GRzE8
plvPV9Ign6iVVtRKvEaNs5cM7OmGsvBjSidmUMFbmf/hzcwG9VC3kwWRmgGd
rZNKGHWvoSOLOfbGIo8r87oXsfLoQHdaq8ADdV+Nh5A/wGYTp7U1ildvEjCy
0oiTSSwLeriordZQMoXPBBMnLlnE9nhpR32dqXzWOT6YH6y7lRFETlhSBmmM
Cd01GF3WZAC6oiTNVV2+BXe/hBK+2Nhf5oyLk4MY4Cz6ZgT09ebeYG2gfL93
oKogmWQ0xHzorUn15C4U7/cHBkE5K8oV2Gra3hMI4H/z9EK9N6BGiaIbSPni
JCUg0jl0L1rjWgUBc359mT/cOfANgJkIyk8e7krRtVtcQWX2WSilgDGTlKoz
Sf5qcc3PdnnJIYQ52yKqyNqI2rIsopHMD/dTqZutGw4F6D3DoH1RlWVLNEKl
IWUAk7dsja6nP/XlVPtuxmvMNBFAQknYuKhPfxuc5RyAa9fI1qWstNE1ZPlb
JkMcbk1uKjiKOSn7gqh5WZqUOgTTDKAZjDDPDtUr6za2PTQ+p6Fl9RHtMQXx
dQbfg7j4cipl50fVRpDdiFOX+LvOJNK7cnt2K50gOgMX6tmKrvIZZIoLVjgl
zUkkToUzCOd70m310SlIy82p3krWl1v7mkmkovr05jQfjbe/5S8ZELSaChrF
7msI3MuVHeXa9ACZOSJCTqR4A6gKyjlN570ZPvLNlrflm63vaDjydFErBeyT
5W217O3XO99T0E4jXMkDiNxv4asreww/pVSZWJzGzDo3FmKyk/p28eJFB7r/
x9dZB1R9f/+fAaLYoojYYncndiddoojdXYggdoAogoFdm1Nnz+7u7p5zTtfx
2eezfXrnd57P1/t9ufLx+/uDXbhcr04fnHOeJx0HoVDChD/9gIGDQwZrmGQI
cuIPaX4cHzZXpstiOxtPA6BdHkuJMIWHQSubvySVJshsYukQjqrPDS0n80PL
qEwpzOVXn6DwrkwiGgR388LKwuxJhkaGPM2Mm/URecmdSdT7ykLV4JYPNtIl
F10vkASCSMqvHlSXnUWQ3MpeLmKY630MWUZqYjJGQypZPUYfwtHNxtGqICEX
hPwR9LYavzzZcRxU3MSBQ8uYjPs0G8dcWV5Xcbwyo4kiaZYGAU1HO2Uui8g6
HAjAYAIm358i3FuCXrUurvIso5v+8D9a1J5m8dxEk6RE7d3Ou0OH2GYPtfQL
k6vKmTGl6WNtn/tkYStqjyNqSuFLj40qK0kj1N8uDJO7M+pScaOefnZ0SUaG
V6dUoQ/G5wf65ZU3yzuo3fNRP9tAX1NCrsdXlgP6vS3dUU+fU9RCEl1s6A5C
HQj2D3MMGE5GHzkukgNJ+3wMEpuwe3guG5LIJ6GZCMmiYKfn4MFx6dYkQ/Nx
wy1Op/CifFgO1i5XhRWQOPW5c0PLspcDd4ZQ19wUnkvVciUXOlz9J4YpnB5a
iYX4jLCiRFTRxZy9h4tpC7ZdbJpaRaNJaucghZ6kcCkO0UQXNBSi8VcN4lZe
KCvFdo+cVpndCUUjksEdEj84ATIGBx2aOQqa6qBx7wk2TgHKYftaxn91WMSE
5qAgTrKKRrnex9Fy21mnF9rYBhI1THS1X5nemC4XSXXoYLhkg2NO4nhpWkNT
a0xt65iBeUZNrFAqi2itxFgD4kC43j3RKgc1vkOHL5LeSPhcUtZQD4ISOTmy
hLxM7yg3kmqrry3K16AmeTOpjvrdTlQq8yf0lTMp4XJvVj3648MaU96ZUUde
Lm7LeBB6lxcCerrL2xUaMsyopabRW86MKq6f15GnyapO1DBdzxxY2PLHYBG1
cYR7EB+YqUeHJaYIlUX7WsSbN2+IIY4eZcMQs8/w5vgqxHrO+eByTgtDzD/D
M2M3KcK7laH5WPdZFOpLwYHkDBKQs0PLMywEhibky01PjAQOLGFamC/18Var
gQ1mbl6vOoAtJ7nLTSe8LKokHa9dlsQjBIcTezZ6kMM8HKHQGcbcTO4cwaDj
uf/hzsPhlc3kPBa07xvoa3cL5foAd3ZREngi66jvYltCZ+7QR3RtjtndB6uo
vLk6WUKghzlAWMBL8TW4Te0xhHB6F3fS50ktjHZJuOZbMxvS6qGBA5YQzbX7
+iB1qu/vUoKZEgSI1xJqyLNFbR2O+bX+GljF5Il95Nj8CKoHUPdEnTWs4JcZ
HeVbjQYfzmsiRwcX4Xjg4/mN5NvV3eTIwELs7Lg9rYb8ZXOYnBpWWM7O6Wxl
9nLRK2fHDs1DWDP5888/2xvg4bihe9+9e5cdO2x4OHDgAL8KtZ5DVhLY4eU5
bGOLOs7keuwdgKbFInhMeMExIxBUzetiOjvcLGvoqRavsn6lsJm8i6ekKJsb
1UyCS5Uj5BbRH2RHmkoLUyUHfO6EDy3pFnymPJ7jA/zZQje/ARC3J9DLixIj
WtqQ7MYAhMm7mOffBzDne2FhS9ZpMAtxlG66jfm2mzOAVkIxH30umskPG+NH
LWMIzC+XkxpagqOznBzjx87d2w5B4sbvXZnZFCtnOMPQCeuGVGhcVLaQFTQM
unOg64Q1SXN8WDFXpAHVr720hgEfqhY5M7YcEUU1EU2T9+Y0llfLutIpA0Pg
92ZFV0mdFCN7Z0fKs4XNWTX8ZnWgnB9fVk7rrwGC364Jkrcru2lcWIhpa2B4
Na4iY8gbU6vKm6XtZK8aYCyo/PPP/1py1Fg/HA3FtqQPYFjd4gq9HcgEIp9i
YejlJHzRhoTr9OFO6W3EijgK6M7nCshv754y5ub/rXrNFaEFZEWIubtmW76p
VqV7fmhppl6SQivT/hkK8zJWXK2OG41GS8J8LK1SjRjj3hsajBAXsiOuVy0P
JyBXRBXn4efVWPWQDcio3Kx/r+YEv20RC9lAWtbP00DYz1c+iy36fwHpkssp
MuQs6gg/Vk4w+6CYGYtZygoaK3Lay6StW9Es4uUoOtrPoXi4p29B5p/tQsrN
+W2YAbwESlnk7uAgEqQ9XtwB0aAZE1TL9jC1HQyl5Zc96I/R/4u9DiYz6I+s
oBErZUgnOt6YxBuM9txKHNBHq8VFVcpPFrYmld+s6i5LJsfIzllR8sXiVvr9
3PJ1JmjtwtDx/uwGTM28W9WD6uRaXCU1noUZHuLfHOHhcTWmJ9U9HxxWWv75
158tDWGofP36NanEkqUpU6bwcKlFZW0LM6gYu1/I530qMQwBu6nv4hJhPYf9
9vapSjc+5y1fnt3EAve2MLNGd0mIOUZoLmZ4ygq1c0khlVgoRCEQp1cSTSKQ
fjozrBAVNEJDhIlTlVOTIczJXDdUMnwz8LMzg7CVOSw0oZSRqgGaqzCl6Ixm
DeaszRRPVjsmYkkew3BGE60ZsJNZWZv/QTO3IyPThjii2wJFQat04s5ve30Q
TT4mNmdi0TaY/4Om1WeBtOGBgYVd7TkwJROtGZDRj1AZSadgoW8+O74CdYsz
mbCXFyZVlnPjy5sR/iwyOUA931/2qibe3zev3FdKUea7O7sR110CdgSXD2fX
k2WTo2TrzF7yKr0dXfVXyzrLd0ojOitgP7/O7Eo6T0Cs6Ou/XdVNTo0oZt1c
cJUL48vIV+ltuHTpL28e6h/OkIk8NC4p2/YSUgNVFJxB/e233+pZqGFWFk3q
HyBTI0LaRlQFIz9ApumTKyxXlsXKlgCzhBWRHpYvbaOtLMmpB0w82OU+VEVg
A2eFVuC+TCQN8YiyH2SMiSJz0aYujS5LWQKjmAkqIx11P3cnKFepoMFpylVD
GuWwoESKcN2AKiyioGcdULp9AEojmnO+P5gDQEeZ0yvHE/xd8tp2EkuX4qzQ
EXd7ONxgCWz37DCaULGYMZWKrm0qjye2ZO0a67NsFpE1xBQYJqVRSKGpzA4j
1XNXFlKY50EbG9Q0eCymPHZjVvu8qml0XEKRPFTz98KpHg1VjfgR9RM0Bhvn
HcBuYFT1oKZPDC4sc/v6y7Kxalpnmk61VxntXVG201DkpHJ3eVJF+WFDqPrz
EgwZf9WQ8Ye1ajmHevOI1dsVneTt8o4MiH94fM6yX1k84pgdLCWyMQgMcaP1
jz/+sLd/IcG4Zs2aD/GINmJYSgxMRPG5Ig4ef/zxR5E//61RQ2X5NMTFuued
k5ec8Tn6go3frkYfjhlHRIhQJ2AQpRO1knTfhkFPmRZqTelE+zn6JuYTOB9G
lMm9sBQxy3GvivSWT7ASZUhDDycQccObIGIriqMv2M1sqbNAdLebKdGshqTO
0MpsurQgzOckXxD6cdEcDpWxIb2N6/+PQStxo7+K3n1cTb4MvRMXptbOGsLO
T+zOTq7OGW3T3tORlWTU+R5oAPjESuLAY4M1dPsqkgbB2nwa+R7EiV+oHEH+
B0MLL60cNuPIlNZMwDxf0kHjPy+5OrW6I6FDKYPGdPXKnySGyfzB7WW/emow
BeEM7/zdumB2pMGDv0xrIxcmlGfi5tdNYfI6vS09P+PIhKpqJ7vKnp5u8u76
XiXmf9lDw++9e/fQ0uNY24SvQdgH4INDh2PHVz3530KEb/6CFHl59wLvB2wO
cWXACLmMhcCQznOtsQi0RMI1zw0pa9Z9wUCGlTIBoweJcydxyCgiP+PIELoR
PhTlNkTmfw84eyeKUpXTqdkcPQ1wxxZwrNt92jO/6csZ3ywLNlg9pm1yy2cj
avMou8KW3+pfVPHhyXEucIPcNAvCCP/ex8zFrpDYtg6bxKBxnBiz0jFl2J4L
wDD9Ch/8IcDgdB8sbMt89a3ZTUzB2ALvrBo4OFuI5NuqQOBJn6R1kOdLDWFo
wsFzGPN6oB4YLbgvlDaly8Vks4vLW/WoO2ZGScaUPvIirb163fzsh0ObLppu
4H3RuoA0zSW1dpcnlZfv1/TQGLOwXBhXhuIZKujR3AZyuK96j+ShMi9lEeWs
E1X2PhOEhwAO3WDZoMLkAxwwvoq2RPD5S1dk/vhevLO7xbojvEqBggrhJLZD
BOdgVRdpwE1qpbhhIqyA/rwblqBIMBGxKLpSlsd041iNaQ+vaTXPuJMvs+ek
BICxM87OLGEBBUI9J45MASSHcZh9vDhgYyHkYnoKPGmwMEgNhJB6tptj8Dla
spzxcTZTmLxB/vl9fHLRRl3g5sm8VBdo4YKSeM8dutEdovXw0EA0fOK5gqQH
z5lQzbhFtCZcSahJG4Xn0K4FYp6ktqItQqLv3LhyWaUQH4Zj+2eHq8ztI1+q
B8VwK8K26wnV1bvmk2MKDbIsgAfPX5pYjt0F58aUolsEOMj9wRN/jtPJs3rJ
w8dPaYbsZRJwZnBqOBWTjRgoXltI9OJ/C8qN7XNkTXeTrdvKY435ZHGwN/3f
dFUEqKmhxQq+DC2uS8OKsIaBuEuJyWkBA1FghrSqokSRwypPABbAscDhAbO2
lSghnlZVFg2EG/pVoERdr7BgKsbE981MmGV6qDxM7WJUXXa/Yt0vLMVJ+jDz
HwOEHc0TIod1Qbcg8GDHKtAaUw2RlYsjrayvAVq7rc4/dKzeSe3s7sgFd+RM
CwJ/eDgEXHfnt6DmNJjUoBFCNwq6Tq4kGLcGA4TkHZQA6xIqPDHnh6IaegTs
+b+DmI9KbkGX9jS1tQneFjQ3XX7q4r5e0VUOzw1jx+qXihwyceg6ebqwObm6
rAIWLmy/tUVid08Pdqd8t7q7vFvRmf1S+yFuNeTHCogHW+LsOVM1Lizqv3jx
wkbG7o1C8z/C+OfPn7v05nNecnvDGFmj74BD5WjuXxeaW2YGlTarHzRUgqhE
KSyJ3dHmhBmEI8QkQiXgo5/nsNBB9I7d0Qt7vYcOViqhAIYI3QRQtWh/sG7k
PXSsaZO+5a2+0lzqj2rSvLgiJHKxRpSxRwlj8/gebkvjNjSuX+i/OHqbIRXR
oH9kcn2N1Bti5MQNFsVstrHamls6+vPp30yHXls5iQZ/fRHWumD/iInZvZ3G
l3Nl05gt2DuNRqhzU2q9T1knuTy9MfugMEWFdXG35zRzymxU5yIkTExhYRIq
YaAMtNkTpegjhVuDMbo1qxGJQ680Nl0+mNeMRMFAXZpcmZN5Xzol4M4lB8uM
sX31uR4asBfnhPJ5dVtIvMG1fZnRgYVaFGxB3/OUZgziv8nsIkcGFOShjyfz
G8vxQQXkcnpvx0A8mvSRtcVXRd9HDJUwGCw06ve2/Bg2B60OdONYMqqr8GEz
Asua5nqNuheH+lp+LBeDIzaHhvmyij+dl/Rys6qqmLlZmIG+WaHluQgvpVc1
D6cC6sLoasxaoIUOohC9Tji8uNrKVJhWuYLZ+ptrq0qsSrOFVjtOPCP4xl4b
nhV27sXPg++5QiLqv/EODUoRgLPFuG9Bs/cyJq+17GNndC4Xb+ZsYax2x+Sn
aDStyKYdmUtEBhenIUOBAUtJsN4GLXk4zAisdscWyI4z9mMqz8wWy8HRVbha
BysJMZ1nLQ+xfKUHOcSuS0xBoRfPYtDdSmEgykLBFbtDni/rwfWWip9JYXiT
OGQ3TihB6MTDAgfMHSOFYad8X2Z0po+7NaOeUZJK3/XUQJkysr98mRlo3OfY
Miz1K3UuRkbmUQqD5aEGWqDv5LCi8i6zs0rIADk13IfViEsacF0aX0ouJAc5
6EPXnT2Ml40+jPLB9uH2rPGJueU///ib7BxaQTYGuzJqQjF1UXBRmRNU0spN
MI/rxiGmXEyApYaVIGH4mKkGDYsbUPBSIF2dAJwd6qcAegJAU0YoZwFY1ewO
UQDR7bSxr5/C18ipWa4+J0bXDqzOKVG4z096e2c1JsPwRXpYy5WsRvV+xU1t
AStt0EgPI4j6KseYm/J5UAcmOL6EXmJs89IoCiPzZq1NU6Ytjr7XT1ydI1Bm
tY0fCUTnE9fbDPIl2Vmraj5iRfp/CS9kNdrnIbHwV9ihe2ZCFa6SQy0MM3pm
tU0n1mfRKYDOUOwZuTmrsVMFgtUIuTWnqSMPjN4A1GyxXcmWj5gZNTPxzfk1
FodgZtnuvQOD2JyErMUXGZ3kTWZ3uZMWyG7QlysC5czoUnItviot5g2N12AR
31k9yeiNwqI28Hd0sJc8X+jPBDBKE0cGKZMTSsvJxOY2jiiG2cN22XBEScEe
aLJx/OPH1xyexHmZTaE5ieR0NYYrQ/JTMZr5ZAvH/LR9cMMJvNRXlR2cqCiY
LFppx/N4RLkf4KX0qp6LPBZ3NMNvjsxtrq31LUMxiFoWmuG3OHbY5GKnCVY7
YAwUgx5onN8UW9KUGnC1FkZwkJ8awLzm5rq5iv1ejZ8lMAeKTM8yhnOzGqLU
h5Z38rTtzKQ81h2Oq0kzCIAwxQQgMbGEbBlBTrRAthfzY9NXXAOaRi7WDzdD
xvbtKywyx35DnBhCj97VmU3ZEACQAddzuNH0Li4OG6jQocCARfe3rWZ3Bc7Y
wCJsv4P9Oz3GFBtQeb01vV5W36dVdWVvfHx1+Vo98t20AEkY3V+eLQtiz92V
uErsOD48sJArYHPJS9xepbfn/8GtxOrsjkJb3p7oXGxHQe3hmCJ3eAwrYHaI
h7Df5iobciiu2j3uvSz/+/OLG+z0wXARBjKwtXBmYBnZRk35EUI8F8ObOxUC
agNgydE47E7sgCGwmxdW1tS23JjHtUYzXIwPLunI00IhQHGu1zCPN3Ujc1iN
nKpeY3zok+01SdagvDUjV8+a08jH78NcblNEPxtV36gF+OX+vvb08f+Bnikc
FMyal0e+bKo/Z+T3DvChwUJ2Au4WBpHZDOURkSOyslyelGQFh6XMKHNSSzPE
OchH9qjnxt09RHQXE+oxaQs7d3piFWIGDLHwd5fKGqB5bLgv94QgmWEnMJxa
objLHEmOi8oOZpOfpXdyMezlJHt35jalhoC2wMa564k1EfVZiQxf2j1Eg9AL
L9LaycOMQEkc00/upgcrd5U56QbNAf/7JMWfpVjA93ppR/YYHx1UWH7eGMK+
Y+xNR+8x7N1e/R6ug//r73917OfCTBsSHFhkk40+tOGhRc9Zk767eZA/dWtC
TG9nWkgRSQ8pTGPHtnWlDakwOzUGAiE+UalyRHw5GQzCL5uptwoSr1/DVm6M
zGcVpvI4BoqB3YqexWWT1eoJ4fqpvuX6/hUUt3oUG2Y7ko9Tp0l9emcgZ5bK
ecmawXWpZoEokjCUHVaViqEhxjXtZTaODoAsT5zTKk+ZwqoThCpREPcxJsTJ
I/W6MGamomoPBpk+ZScgXbkYvbTZ6wqFog4a+d+TM9oolL48xoEFSii02o1Q
DAWx3EadL5zwtVnNObmJSzT7cdVIRSR6js9PrEy7+AjLlSBklwewLxktAnjN
syWd3MijB2NAhItXptZg5QtVBGXRzdEh2oOzxWfHlJanSwNlpgqQG2khcm1q
NTkzqgSHMbFV7syYUuwCAIaodCGTCxQhb/+yOVwuTfRjxvfWtOq0H1yz+eNX
NoX2oBpWCVsUFrS+5dzW3tui8IuTa3kyEDM9oBD3GlAz3aTud3mYFzs1IW2n
OlaDVLJQq5hVCPCgm4U02Wj6TezRHtes+Z08HK5EexP07acROah7EQumsOGz
hnysvhhiI6t0b2qn8M2I+6CJs1Y0uGXRN6aBtcrG09CGFQwwhjaVoG94DfYY
g74ctrrFai5gZx/84NQwziANLiFHMU9hFfKVK7ugmo087kXHxtfj3OhqVAvs
IUzmXv381LgKci+tG9s9iR/6n1KtoeCCjnTLtaR6NHn3FrSUC9iXPsyX5g6m
D0UEpFbgfRHaoSPkmb5WBbCrRR487w31ukjWHVeLijrVe+R1l+dp7dUI5tZ3
aSFzxveTCwvD5HZSLQZ6oO1Zakv2H79e2olN8ZDJxwYX5tIbSF2Qd2Wy6UHB
IAYMIALev7x5aJOHCTOUBjBhlo089LsjwYJWJpu8xztnyZruH1nHHDwkPdiL
5QAcokQP+8yQ8qw7YVEX6OOimizyTGKlCO0f0nXo5cTkpJmjqMP2dY7qRBV2
ai/2oQ20y1R4xEjPlshc1t6aBm5OLe0QIxitsBN2q4dY387vzN7767zAGmJB
CGJl7rMJzfkIdXuCGxQUo7xOK5T8s7bVWPRxfZyKWlgyy+gZe1n4f+mzyEMZ
AdCetHYPn5zR1kEfp31SO7Ns6kSg1f9UzFqkWZS5Ftv7mseuNHpQIbj1gBk0
ZPxgerAfGXNnT5d0pMqwm6CwyxUMYrvN5bgqWYMYPkzF4CnQPm98rJxm42d9
JoNtgYGR3ltJtZmCQfcJ6vlgDRYP6RdEglhYgwZQyHrsE/3hyQWHA7a7lzBX
lg1A54Z3A2ABublqkKR1z0UVuzo0L686I8uHgiiIwhQPHDFWekxhK6efo5XT
lBCsg5YKLfZgLu9ZgpSBNtg4s86jpu19XdysWkLy+ys8XJ2IA4TmPFdBWWtm
zg1x7lYXSU3eg1PfaipUXsbAYX01nkaf+/CaBjazfJCPmA3jkEWvPHStoM1B
mHG/ue1CqDNhWG5t0zW0tK1UsPwDgO3Dlv7RZbPalhQyrMPEySusxLSfN4D5
yCWMxjoaRAqZlmKs11/egytmMF4G22Z3bcC7Ym0MQHu8qC3b3K8l1uYsAqZ8
Xmf2cLHpgoWDnIVXntK/mxxPjpTH85uwiP92ZXd2h9yeXpsddaDtndIGy4fO
EPQt/bQ+SB7Mrseo/7FaO1TqYem+uXPMkV7BTvTTp0/zK+/36cKROBRN0btu
03V2bhdZ3CMPSw4oN2zRx0XB3qQrLcyHlU6kWCBk4VixucDyni4eTo3CUBgY
nEVS0F44iH1GoMg0Ctf2sMI8OFKce7bAcjQKr2fRIReLV9ZzVgNSdqwacZbb
jQX3/Gq8Whplwb0xXtSU8ItcwoqNF33M9hactrF1gupWTsK6faBOkcMuYzkg
86IFdAA2nb8iiYX69wmzO5BgzewKPJo/uI5fQcONNXRsZgHmRQsGpwrniWoY
hnxwHwL5E2wEwM42dIMchiZR2HDv4bJCujMqh5wdW0berAxE1tgeJYOUuDuz
vsTHdpCDC6Ll5aJW9Jjgy47VMNHzbGFLxnIYGUPlHf1zkA9PFjRmdxritq+W
tuWetq8ubrfxwpwsVr19AC/MZ9s96bZ6kD//y3uiiwPysaKF1Zd2ygS4oe4J
r5moaKH+CUUKxNaHsxPTPasf2Mxlo/cNE2Rcja7yAAbMngZb3rMkkyWWgnWz
+tI/vCCjvmLm6yiuOzo0PZz2vZj88toBNeBClbgRtWDIUAmDAcPpt0HlTLt6
/xLyWZ/ClEk7uObF3DBigUv9HXPCIyuYvPDoyih2uYIsJQ2JPNTCsEGDB28S
/K3UsJdzqcNpCWY9o33V8B0YUc6wPKMtNQS9MBYIz2yvTJaymbQL9uDvNI6h
4hA0bgQu7kIeIRNQZrUbk+BZUayHJ4XEwHwtDCBqafCaGDZD9QJa1nQjteaC
IsxbgElwe2dWA85VsLqhBtCEeN7ydnlnWTguUrZNC5Ev0lqTZ8zOwtAhlwyd
i1yLaUsqKXeSajJ3d3dGbXmV1opLi86OKSnfr+0h+3q6yovjqxyGD3Nkdl9H
NjI3bdrkSDn3sgzff/75u+zUf8TVQTlJJrIqaPeYElCJ7hVGz96CCXWBqobV
jencpl7RasksyFIIsMUjLCSai2D5UEqDmgWiW9SfQs0CVas661C9qdGVlVFP
K7dci86VKpZ7qBtlFTx4lbA2uUUSBn0jeC02FzLXG5kDOqN3Pv3f/yymgFXR
L2IGuZF4GVSG2gNhCYI5NkdzH7Av97Nh9y8q+nv6FzEb0Rtbu/7zWWnj3NZG
9FxW2tjaX6REIvPH4shAs1Udf5ydKHWiMMK9/xXMD8DYasp/DdKMABBX6rG8
397ZYgognaz9LRVM0SOlPceCzitqyP4ByduqeKFBYDZx0uaxImp6TLqw1w4q
+e48fzWfFbkCGMU4BoLLuzMtczUBe0ewmb8Et6OfGVOGZRE21GkkCH/9LrOr
LJ8aK6n9GsqjeY3oqzGEAWShQJCO2cc+5K7qp/0Y/d1WbM+PLS1fL+tozlvo
j8R3a7rJob655NGe+Q5knz59ShGMOTML2QLZgsRbt245CnH/+PVb2TawtHwS
8hGNIBpJ0oMLy6SAKrIh1BOtcVYhzp1yBBEj6rtrwvKZRKCZsEX6BZoZoK4K
L8BcIbo0IUvwPMC1ZYd5rGUg5m7X3DwgBojRZwz3DqmCbS0b+pZnEQQJaFOR
q8bEMxZaIDHNnf84t4ksooKN24hchA2BgrPBGLwYVFr/53eMb6p/ETsmNNMP
f/1oLjsmtlDTW80EfIn+LK9hMTVzgEoWDmTSDlKJmIWDuDKW2NwlWP9rEs/H
ExSXeJN4PjKpLjen414PjgkASySw0aGMlVufDzbrilhG7l/ErCnSQAAJbmCN
DX/QKcgWnhxbgbU7JG2wrQBy+dQ41SJDi/G0NSws0EToiCT3ydGl1Wq2Ye0Y
qMLyGmQ7ckINdWJUSrA/C+jaw+N4hH5G9Q6Z6uPDfOScWkzUljE9iTVwT1Jb
K7LdZP30WJnbu76GjV5yaEBBebG4Nd2/LWKwXRPC5vrUanJZhcsXi1syu4jm
O5wmwz6tLzUcODYwv9zaMNaBLOaHoFB+++237MiicwHtUSpiLGRLyt++fSG7
+ppjUrCqsLAzg8pIXEBltitg8ZXzakzj393MbsLQGux9Qu0Yieu14fk4mYtw
E99fGV6Qo5IYq8zsiWJJbdMbVYrYJiu+aL/DGmJb76CYzPAB+70jPShiiCTO
qOMCbIy3bIotIesHVFJho+HpkPqybmA19sDAziLvgyvXO1DLw3GUASUAq340
s7DNT2QhdUDMSXXdp+iaW/M+wF7eFPakrUU1GNoFrtvWLG72iZ7WLmWNL7c/
ZrTlfiJYWrzZKf36lP09vAlyioo4UN2pP0c4QAzUIK2P8iiAF+sqe6yjmjgK
gBoL/l1Q7EOBDosxkdmx5LUprVTGrBGn127MqE9xw67kGE+NERpZ7VbdOO2G
Gh66j0Eb6siop8CYcq5SX39qmLdkjukkSyeEyoFYTyYLsTPDphLi59a0Wuyl
QQ8WdhugWQ/TbyisHB5QQA70zStPk5vKmRHecim9l4NKLBdCTufNmzfZqcSx
AHwLN4ttKn96cZ2uDwEb8tmQ1VMCKkp8QAWSZudyEqz5cUSkiDhB3cKwEpTX
OEhs0whSMRsEKzrtvfkg1lNMfjsfvfw8GtQazDDCmCKNjsoe11jFlpQN/fw4
hcHc9RDmuYc2xMatoab6bGcZ8ajf0deak587xjWRHdxHrF4/trD5GvuuAKV7
diihfbAj2+DVmjPmsHomo11AHXRVNaCOxI6npXaQyIHhBIX6bTe+SzGTz0Fm
UenGxQAU/o6qikEAekRt4D3rfuatBW1UcjdhVRnrD3CJAlXk7aHm3iea+tDb
gD6aJ478jqMX0AZRlTaWEC/r7uLHsz3s89NgFDDentOERWN4bphCfA4YsVwD
z2HU8pqqnRVD/WXuoI7yuYKJf9mn6sXRk2ybxy+XduQo5aVJFZjH+XVTKBv/
cEzg1AgfBqVQSOfHFJfzKUE2h2iNx0EezKxl4xAriZHVRtmlt1VM/v7BaSaq
NoR6UHQvDSkkEwKqSmKgnzOHpriXg4U9WC/0OCwIK+00ppaLxWSzqL28o6iM
rNDS6DJZDcj5nap7NdQ4lpe1UV5c2YINQUh2bw13p1FcPbQ+8Vo9tIGVT1QW
vbk0CGR+HFOEUh2jGYZMJIUqm0aucY1BHu3iZ/18GIPuGFPfuHLYSqJY2UaR
3e6GRTVrSGOrGTuIEbZehkUoJ5g2czcbScYPsWiIzuNgEb56/7DSNJQHRlYk
j3dSO7CP5uiwEnKXs5V3Uzu6NDTX0hd11o8u3H0JBY4LKY70du/crADiROid
uf4c+0WYidkhNMdfTazF3KLpKOzGKjO2WVMdLTCHd14t7cJq82NrdgMKyRFi
KnQH5kbIglFhqn7KsVsQ3ajoPqVl1DAT6ujC+LLsOAV8v2wMoSrCxTN02yD5
eFLBvDyhNAIkxx0KjJXbbaZF3ifSefGGnQ56d+MAnWNqkLdkKI0Lgn1lohKZ
FFiOXaeYS7MnJqfxDopZiWgWsgLFYu/NqlmrhJgewvNmEiO3ZHAiKGt/MLa7
IF1kO+q1quvBJxoO4bSXRpXidcbVQ+rlIIt5TbVvYHX6ZoxOrhlc2zojUP8D
PDZ1tZ005E90bnXhaJtWGNHUOrQiG7qAkIeNY1JreliYQQSKe3k2JacGib6m
4my8bw7iWNjgCAcdk89YTjjl7CzScbchj4gb70LmqKxBshm9XeZ8OrhUa6nq
DUyeGl+R8SIOLTLXvdjKdSMjNNi6J6AOHEuJrk+vby5tx1eXV5mBZvbXjw1f
aHDFGDobbxTHLzI6W402PeT+3CZseH6U0pKIotB8xGpufZMZwIL1UXXCHFnH
skHFkrWYhS34b4/METKTXy1tr4Lek44aCgidEJcmlJFDqvr+/PO/to10nlPL
RiS66JFgyiKyoLw+u0k2BbjItIByskr9dEJgeRI5K9DM606zGltnhfjxgBnG
zeFUF4cVc274AnhY/wI3PdVujCjIpyHWwRqSRJiZxIZVnA+AxsnoWdZKYZqV
V9y+Gl2dq9s1YDQsetBMbuhfUU1nbtms8aPFoCu/7W7hWMnG0USKOY1FxNyQ
RoQ71DlT5BgUCaCzhz7Cu9wlKL/RAIEatJOHdnXC8OiUhnTkQI8IInfphCDQ
BNlZGHYkeredUXRg6E7zyAWUI0tkueNa1p4NkzdCYvyGUnlqTFmGmRS96pYv
qEfH+OSzdOzS6MHJNe7twPU8xQYDHXbHK6zhLY0x8TysJBKWpxaEyMxxfeV1
JhLhvnJnRl2OnF+Nq6KWkBPu8nh+M/Z6odv1B40X0WMNBFEmRrL85PCicnaU
r/qUsvKvP/5qY+g8npYNQ8z4ovfLGcNn+xfKkq45ZHZQKeruSbxbW4VtiPCz
00KqmKUaHBMvymQmGmax4srRiIO5joLU3AmOmd1ctJWmZR/F5nxMEuERmmZh
dFX7HACHJ3sWZy8YckfILZk9LwVc3GwOaf/qceMQc5tqA9U/uztxiCYKZMo1
QHQnhx6GwxE12Bq7Y0h5zrIpg3mJoCcRgxuFYz4wvKxaQWytzk8Nbjlm6O3p
OErhYA85y0R/ttRa3LkYF+1m2DPHuS3Gchv+ktvxeBk2+tI0asiYjT13qyjD
6p+y9yC1nZwYVYrd1+ANivnECF9+ftDKVd6d25S7XqBBYPqemm0bWb03yh02
TyJUfL64jVxfHCIJo/vJ65WBfC8oZHhflPu+Wt6ZHddIqKPkDObAG8JDzIeg
ReHR3IbqxUsrkwVkv6r/33/4yqFTnMfSLOjszb1Yd4C2HPT9x/A5d3m8e67M
6lxQlgQXluQgX1cQhyAuqDidKIQvnDIqftiCvi7c3JNKCSvpWKO2RM3gBrPW
wA4VYfOMijGLa1ax3FzZzveYULGgWamhAga8ITdph45mx0vB93zt2kE19bkC
1NAsCA5pkONDzNENq8vNZZI6TO5YHxohYmgXWmYvMo8IDXEsr6XDlZoAETt4
lUb+tw1ZOkX+8N/85PSkmkWkc6iFVeV9PtRcFqWGjm/ERYzHlFMEoPuVZ2XT
zQlNYA003YhmLprHWwtaczcvWnTusge2E9sSjw4tZpAszGQOhAtEDEwYWmuw
ghLnnS5MqshVus+W6FvNasi1k0AUfRIoGCDhgvMpXACT2cPF3taGr9Gec3RQ
IbmR0kXiRg1QMxrIFVpXJld6r+0ViEK1HNbAkQtoEqtrkBjK2bZPg1zk3sw6
9MqfK7L79G/mr++e2VRirg05Hcy1ZaPyhx9+IJWYB4ix1PPdzRNldtdCsjok
D73xpIDKVC0pwWbLApLhqOfAJG4OMzUduN4FuOijSCY7pEoFfo24MFnlzIZw
002GfbyYQUFrxAK7jlOI7EE1Q64sNqNwjhSlWf1imIRsQV827B/uOcIeWqyi
JwdeGZK6moF3cD2V3OXYFLtjeDW6XzbH4tYotqFz94a3fNbX2yR8kPqLdGOY
x4w3NvXjY6CPI4EOeweusFgD05WYZD48rrqZaplYW45OrifH4hoY25noz0w4
7CQS8qhTYmRuZ8+c5FTfw5245yDup2e049FcFKrVZFqM5iSjqOlgDurs5Gpy
L60rR6aODCnqYo/12rUdNPHgdZDSaNZhcXtZd27w5Z295cjpdOEjxn/hu2FD
AbW9HhCbzx8uaO6YPIeKQa0HY7w7BxSX+FF92Td7UcHHLR+Ei7aSebO8C9fI
YGwY74X3vDShHDOPUD4oRr5c3EJ24a9ZXcnPL2847KfzPF02Uu3ZAbWjDlKv
LI2V1O55ZXlIQYfDRvZxS1gO1nNMfac6tz8jX5NgVSFRaZxlqRcIbeR3kCVf
o79ms7UHBlZ0hnptHPKxpqWc15sjcISQsQaArQnNIu/thVmlUSM6ublxo5+f
ft3IiG4FEyobVhUeHEl0VnmUcGQqsWGPtcYoD1fZ2beIGuudyueuAb6ya1Ap
2TVEJeSwCrJnpHI0sITsicnDJVefhX0ke5WzwyP95MgYlQ+jysvBYaXkwNAS
ruqpfF0qyOfAGAco+nlxDnqv/jJsCdytb7GrVy7ZZRV9gCbEkKPiGW7aXPgj
gGkYHq3I+hEA/nxObSg4vZ3Sji4fCofqe3FnuT63BbYbyfkpNXnHT325K0et
8rAciSvi6OqGMEcmyC6bI0kEMcTWbrWaUD1dVPXg3BkwPq8IIrsJ148/JgT0
wX4FuLUDQ1fYLcP1q5gSnVRL4oZEyv2MYK4ZRCkSrbaws+g8A7J47qtlnZjm
RArz3NjS7EBD/yPGQzGtjnW/n0W4yXf3T9nkIjkOzw/3no1c7PGw28HtDKXI
n3J6bldZHpCTWzgmBFRjzRwbVqFuUNZBawb6HFHmwXA6Om9B7BwlFykirOsF
yQgTNjm2F1WmFncewFrYq9qHyEVfUFY/kBnGylSJ/inv5PqwnAPNs25gVUeZ
B2Udc9rZlHnw2k/6+MqWmCL8C9mK2QM1bTtw3GGYKp3JLfWjheyNwyMm+vQr
DTn3xrWSXUP95MAQXzk/W0PPOLVZg5AtzM3FPacTMVB4YU5HtX3nZ6vTndVO
zs1qK+dmttGP1nJuRms5OwNloLPTW7qUlzNJLfSjuZxOaMKPU/EN5WRcff0x
qEyuj45VEz26ghwaWU5/HErq71scPxGyX3/PffqzgGqPWZnlbu3o95WT48qT
VVR9ELpii+aB/l5yeKivHMYA+sK23K6AzOZZjUMfmR1Jjl2F9hgzVnDZsCJ7
9FQ10Ul9DnsIHy1sxcIlggDclsJMzN3Zjdm/i3gWr7k9o548VHufMCJaDk+q
LzfU8eMS+XdsJqpDaX8zsSaLldBUyKfj/wftkggKdkS4K8SluEMY8zJYnf/1
1V12AglkYm8/vir8PrhYwmCf/Iux6u4I2DZquDEt0E+SrCaPtOAiDAxwPBfQ
4goKzG88b6FVIrTQULjiA1jxCFjfX25k+owwPINkpenGrWltuyzjbGudunlN
/xGOU5meJBfaT4wjbFVKYYNB5+Z+ZWXjoKqyfmgdWTesvqwb3kg2DajI8dWP
B1SQTQMryY4+hWTPuLqyA2XwgSVl7yR//Wjuhk/0rwIg7xpcFsDqH/f87HYK
8TkF92R8A0KEivnnA4sSOkCqr9DHtiq+9CtXfOoGgPVHEDgDUZhcoHx+TjuN
os/Paa9m4+zMVrJf0dxlnXeG1D43qapcjK8lJ1U1HeYKy9x8/qAqqQMDCpsz
qFZbBqZjHqS0tZJJlpqqwggA5XP05L5QEnEZF61sh1RVw6w+z+hMQjmlNasB
FZRZhtSU+/tR9cEewxOqxnfq30/cwBBZ09NHDuDyqtJ7UaMCbM18ktLcEQm8
WxXAixFHBnlxWyYU1J3ptbix8+sVHeUi1FRXF+wut0ncuHEjdyB9gESkMZHO
zDKh3vLnf/7Nn+vVQR4yI7AMizx4XKI07kKCiPdLTJs4qEIggIQ7EkigxXb0
hkIspq5qGj8syc55mojcPHmWFZuSQvsUhClDmmwROpWg7JFd/VSl0qb+5Qx0
Q2rLuqH1FDwNTJU8lwL6aUP9TKNYZfHjWF/Zhu2Fg6vJ+hFNDIsxBRS45rJn
YmPZGVuIzn/vxGZ4DhZ0ErbQwKLuHFhKDg4tDngUsVnoIyd3yuWZaRp3jqpg
4lh9iyNjq8Bg2lx6Akt9F9jUU1MbE8azM1q68V0a8h3UsPK0Aczl0XFV5aia
RBw0RW/j3WSs41d5Dteurv7mnOZyWV06jp4eUtOFHR1ovoVPPzO+AhOa9uTC
e6M1GK7GDXI1c4Dy7rymlOmX4qrQVNJs8siOj9xIqiNfrw6Su9gloj8bD5Nb
sDWOSXb+Wn+ZMSJS1sb6maKbRkMogkPSq3ZyMTNdZqQVYCIMRVrpdXo77ppD
0AVQ7yTV4Lbr54eXOpLsmCFEj5ETmfmsb2GtHCJWHOwzNjK//PNvv9C7rAjK
QypnBZWWySqi4MiRtcJUAjp7YQtBJRx7eqg3p73UQqwIK8Tu8sSsjekWmF4E
0z64A/OI1nKYSzhzJIwWsChe3rrNm1s+UXG/iUVxN8L7cWxxWTOiiSsYdAeT
+oO0blgjpbSOfKrifquSu3FYXdmgJnLDiEZZOE5S/OKa62NT2dUfZqCA7Bnf
0Dh3mEriWFKdd0naMneLR5AEi3dmegs64z0x+cgk4tOz6rTxPYUwpxOPJyHd
NSZVY2io9jNE6zvsU9d8aHgZ/A5ydHw1TsY8WqJSaFIVVrnB5cPFXcjlQw05
H6bhkFl3uTHLcPVgQQu5mlCThpD63DqNg8lq7OtCEwd2siPRjgaMm1a6Em5Z
WTShpxuviuMtrk6toVhhzqs4L5Tv75dPHiW3NFPXvDbRg0n2o/NCuBgJPhIp
Aaw8hJTnlQlL2tvdcJcnlqdaerO0A5vOL+rnRwcX4rWA+1sTbSKxkhqFyA8Q
iWMAaNPAmmBDZDX546ev1T15y6YQN2Y4IednB5YyPeNKZZraSkr2kPK884Tw
cgcvReTkPM3KsEL8HIVx9JpDziPUtLNQCDmtaS9Z0tOPdhOPSDuhxIOFcLjK
uz6qsCzrVUGW9K6qz+WVzOjSsgarCvsUk7XDG+UgkYVI5EYNO9lJpN/aoMaS
ROIxO5WT/Wks98b5q4cuIzt6qd8cU8cKNd0oVzEiByo9bCoVM/W79LfHJtZU
he9NMg+qhDk1tQnDzfOz2uYglYUNlerYsccVv0TfxEKyOVUU3362eUuYSmD5
cHEneaT4YQ0S1grfXdAGSOofS+HU9wSeN2c3M2uP1P9+wfX+mF3oSDV+UU0g
GEP7+YF+BZluQvYdOyLwa+7P95dXypmaR0sSlWEG3r67A7NoZ93tS6bw69zM
vrwr9w/vnxuppq81s51P1XdjBwWmCy9ZfKJLE+oepvKLtFbszniZ2kIO9c/H
TQCIJrHd5OaaYQ5TieVdWGAImZ4NzC+++IK5pt9//90C003+9s1zKFyZFYA1
ukh/5uYiYeyhWB/myTUnOF9it6hjpQnA3BCe26Q7fSnSkRFF6h2lHgj81eFm
RUUSZ8CK0/ThUM5mmsN8LIVvjCokK6LLyqKYmrIwpq6kxtSiqVzTs5ik9Kmn
XBa1uXQxpjIHPTeiSUSOmzVyVCj1f0Kx1FdkAxMxIxKhe+NayK7hFSmJdqti
h/RxYtKTSHqSHXB1Ykp9BpJQ2wgsoWSI42zcIweP+f6XR8s87lVOoHDo5GeZ
INTiUf9ylUj9y320pAtdMrLncN3g0DaXNo/P0zu5ESkvemGYuxcWmvcX+FOw
YPqB56cUT7Sw8QgPFqrzEEA3onhqTGm5OKkSEkh2Lh45JIzfoPqN/uF3K7vJ
okkxsosLX1tbjexdNYoMkCfJzRhxgkjMyIJE7JtAZRxrNa/HV2HUiTWGb5a1
lz2ROeRiaqiDROcJxGwkYlBi0aJFTsKmgPz68pqs7VlUJnavxIxnXEAldrKj
Z2Oj5biRfAeRyBWhV8j0CeWzvHMxh/JG7gghJ/qKkRmFAEK/BwTKdvXEGyML
yMroUpKmZjA1po6FXx1Z1LumIqgBYk9v/bo2n3fC0JUUepDC9UPrq7bx4dT/
pkHVlb7G7h8G0Z0g5iSIu0fX5M0JaPOd/X00RPSjYcxDCr1IDCzZqakNFdAy
zAPtwyz1uGpO4WOb9wg8N6u1RZ9awpF++PXGb7u9B6AbAfRUo9hZjo8sxcYh
gPdgUWfCd3u+GbFWyvQHDfQVJElP09qTMBiw48OM30YsiFM52AeH4jhEzHV9
DkIGZ6Au6OuzjbwCROibN8s6yLL4GNk+M0pepbU1zUTwxWvghwPl29U95Gmy
P++Ofqb/VCANSwvvz6rLFBBCRtD2NrOT7FbZdWZWexs4XH+2T9tlAw5j//bo
hA3c93ePyLJQL5nQwyQuESUCMrRkYA0AJ2w0QsRmJ3uHelqoDyYMHZM58L2Y
tLa7g/Br4FfTeldzAKRgueIL/WPA1Fl8uZjn8uhLVBRjOLFvCTAGxChONgyu
KVuj1VTGFLEjQv13AWE5shGG6I/CJK6FaiKmeuJa8GPP2Dqyo3de+SzSg9nI
szNbQmYQJaZxZrV2hfUy+teLRtAg2I4x3vk5HazIsSJTxYgcjzqUTAcNFRsw
hXl6WjNn/Nz+P/g9VPweqG8+in07I0p+ED9j/IowQw6ffC2xFkNFbMl5nNpG
Hi9sQ338ZWZ3XhfHTVtcG0fW/KBapM95JTGP2ciTNSXh6jQlhsOMZ0f6SGZ8
tGxOiuaWCXSev0xrTRS/Wd2Dj9+vC5ab08wwEBKxCAe/XmZCQxQoMTSB5M7u
KA+NZGq7tLOAs+YP+ZXX+yyuW7eO5yWyWMwr39zYJxnBBR0soiCJoQlsGsMY
tj3GgwT6WnSbLwr11bfCsKvVjGaSOMYn56R2xjc3hXvK4vCSsjTcWzZEeYFH
NVA2jLX0uUIaE3rpV3gu9wdgNKBtVSu3RZ+zAkHjcmtZKqWx+RjZ2DDZWxXv
+AbKXl31t1Vl19DysnNQKdnZT51qrJcym58rrJnS1r/BXb1yMt8CCYxU+J4+
+ZkihxM+oGrm4PDSdKpgEDAdn1BDjk+qrezVl1MJjZl2BI9nkvxVZVfmdme8
x5HRFeXYhJpMaYJNfE2mZ7cj85bacWLUnYgWMYgu6sh7PLCU2fC0EokmjXN7
TiMqGLaVz2igKHaTV+qDgSj7gJZ1ccVCa5fyvMZMsazEXomvahJHPd25gRiR
HxTMq2Vd+Bp7T8+ZET6SHKsGYVqMvMrowJbJ54taqnLBhVtkerozYY7dd6ij
44TUpQllGRmic21H5EdcKoBl7TfiK3Kk6b///ofDR2OY0T5+Z2Ga1/qWvSVA
lY5LHz6nWv3sBkntlofyZUqgGYDAXM/CYB8OJtpL8KiQeQSvKsdmuTnAVCJd
7OsTc1nvycdwMT28mMwKryyJ4TUlI7yoA1WDZQ76ZsQGG6MKMEzUry37mTMb
so3l476l6JQ3D6yE0HBEYw3MYS83DG+gdrSebBpcg6EjXg/bCo3DNVKRbkyu
7YrFvWRv2TvQVz4fVk72j1QBMbaGHJpYj/e9T42vIpemN5Vz8XXl9KQacmJs
BTk6sowcHqKv7+/Fkg1T2fp+OyJdoYAi3bAG1d3FmBHsPMGBexhOlItQ7kSH
LnyHPSsEQ0rYJ9ViivOMGlioHRhtGGAjvCGuu/IRTh2YQvEAXSQqT40tT0G+
D4tfF7djaIjHc+P9mNvGnZ4X6Z0U1x7yEleYFd0nvPuTRxVRJ3Bq0PVTJHvI
vbmNORiBkPD0qOLyVIUIWjVgNQ8NUN+hb4uSJZfrLe8sa8Z2kCXjI1TIdOLB
cYSTP6wP4fb240O9eW7qa33dF2lteGbq5w1BPO2D2d9t/PtT67qktTycXZcl
r3/89oNN7a5duxwzktmoxfIByB/cCOhj1Xqe7U+V+V0MteizhJPHhhXs2UNk
iA43GNZ1qOmog4+zUujLVXSjMmnS4mWZUkc9J8OiNSm8ukwP12gzvIYsyzKw
rha0ABNZ2s2qd+D4Aa0BuqgFbREGlp/EFGXaZ9NgjSKH1ecjAY31lU97F+b3
tqvewWjudqxdR7kc4zwATNUo6oR7B5WQw/H+rnIkoZWLKoRExSShFb6SI1Nb
kFvwejO5k9xY0FFuJHfk5zdTOsuV2S3lII7R9i0g56fWk2tz28jlWfpvO6u5
XJ7hT9YvJTWRi/pxPrGhnI2rLcfH+Mk+FTvOgzrYmrJHLeSJ0YquOna85/4B
hTmiu7tXLkXek2klNNjh3/i4CuozEyoyt35jVhMVQ23lfmp7y/p24OVHIIx4
E8lydFdC7eAqwKOFrQ22y1CPVHg1yCS++rrPNTB4nt6BZpYHw5VdnJ9CF+Wj
5OZyS8U4ZnJxXpQbLjK7ymNl8+yYUtbJswJyM7G67EgKkmn9OsoV/TE5NrSo
KwDWqBGjvWhw/w7BwdogRbQtN/v9sBZdSiGc80GO/eyYEvLr5lB5PL8hB5v/
+s0zh9VFJh1nRz/ALy4JIIb9y1/+YvFbVB7vmiOzuxQgv6lqaaG/YXE/YfLI
k+zaB29tC4w5M6Q40bq0xuJ2abiPg9uk8GqugFd9PvBdHl6EosfEq7XJ52rV
4WB3ce8aWTFscX7LfpmGDma7mP68bo3Or6jmV9sLVHPL9phCsr1fMdk+UMPq
oZVl+4hasm1MI/1oINv7FJEdfb1lx7BKam8LyOHJ9bkyapf67YPj6yq3rd0A
rjrjw1P8ORp5QdG7saCDXJ/fXq7rIzA+M7mmmREbUUquzWlDrPk94J3SiY/X
5rVVdBvLSTXbBwf7uIJzl7JyGEfAJ1bTbzXSt2rPtzqocv+W/rJb+OX63I35
7eTGvDZyfW5rffuWSnUph5FGYwVUDxadgUrM+iAzf2hQYcYMx4aXoFeBF0B1
HM0gSCuB2i+WdXcntHkJ7dPFZpUyboMD2q9WBXDdO5YUYDfu29WBcntmPSTT
lY9VapQVXQUe5yOxzOD0cB9ZEavOc0BX/nY4pYHzA1BKD+Y0UEqNqgKxrzPa
8wzlO1VPqAg9T2lqGqTUjiDD9FVGGwb5v3x5x4YVfR9oXsJSg2ywotsO+w4w
cmFgzSN3Nk+QGV0LM4q1N7tjxfIGI9WZa8cUr1lqqqiqC8dQ2qc8L5BTDWlR
QgoqFVRsWw5H+t2JUv11CA68ZBU2bUTmodoClja5eEzvVZkEf6xqDFvk0ZK+
vX8J2T5IHcDQKrJtVF2D49jGbrJtXDN1ztvG++vT9dTIqlPu5yO7JjaTnaPr
cBvL0YTmcmxaK/b0cph3aBla1iMJLflITPV1F6c1JqZA7+rsVnJIZc6+WGNZ
b8DiWhYYVvbitEZyYlxl9gTjRi6s58HBReXkuIpyYVpDua7s4b2A8s1kPHaU
UxOqsDnp5oIOboBUnbN+Krf1JacnVlWDi/p4cfbyYkMu+jIx1fg0raMqp7Zy
Z04TLs/AkC/wPcJikVkPaCYtajN0fZHRxaBqjp464oOni9tTsT9WLmFYMRGJ
KubztHZIxGMQ/e7shuxmf7uqm/7jKa+K6jvFD+d1v1ujyislWBKHhLC3A+fL
sJcY00E/bgglojaqb5Z1MmJ/aTv5blVX7vpDuglhM4zwi4X+/Bv74clFG1XM
TiLBiVG0bKjC5CLYxVcG1dxyZWkfmdbVh9NAEFkoFa3A0peQQo5pdI1OXTkd
5Ml6JmqXMAEgFWHA3PAKjhAAtLqRVi+a2BXhhTVo9ZGUPvVlRXQZ5t+Rd0+J
qceANq13dVkZXYL5AhxB3RxdUNbElJWNPb3YHrdtfHNXkql8jm2qH03wofDj
vxX1O/rc8BqyPTqv6qvSSqsSOKl5FrFT/eVYYkultrXa14ayW3XR7r5ecmhC
PTmi8cHhKc04jHt5ZnMSeT6hAY3p0RFlaExhaC9Ob0Li1HDq9/LRjx/AdKP6
5QuJDdS4tqH1NIR21H9v/Ur/i68RF8PK3kq2SK1sKNW3Q6hxVcOOk2MrqhAv
R6qw8QC0cnScY+TdHFfEX+jjY4s8HPu5Gl+Fa1swQ4uWJaScUCp6urgDSX2V
GSDPl3QyMz7q8rGYHiGoUkpqX1thwb25Tfj8/6CKsGBZey6IGD8ogj8lGM5A
dhSPyM+/WdZRflgXROv6dkUXKjAkA65MLs/TB6glAVUgi/bSXRrOvr3xuY2q
80BlNlQ//vhjx/yGyQ/g6t+fcnpOF4nrWkqSg4vBqioIK0IKqCjDYBvS8kiO
Ik+A+hEsLcJchAoQV4vCS8nq8IJcHLheX4tQYF54eZtdfS/QW0gyw71kdbSv
LOvlxz1s6b0ry2KNXTOjS1F8YUPWxz0LyNqY0rK8X3XJ6F9PlvRvIBuiNSYd
WIq4ehBQP3wu24dU5GLoncOrEE6YVII6ph4vIByNb6aQtrJANY/7R5TXuNaD
wuvQ5MbUSlc0GD02qhyDSIB1emJ17tbYF5vfasbwJpQmgG1NKG8ZKHORSS9+
eVxj0yPDSzo8PEyn8slfivj1ykx/uZOq/5gjSqueKS9fKkiQRNA4l+NrwJSa
LX+FuerAZhIbJb/BsqqV3anS76i3vjixPNvZ0A6HIAFXUu/NbUbOIaOwWebV
ss40mq4gUgn8Sr0/QlTMiX+9spsrkSwu79QaYhvCF6qcMC+J47s7BpaUuJH9
5M2qHlRjwO1LVUtImwJRdNe9zexCa8pLbVMqcWjj25VdTMcyticppmf1137S
zUW+PLPJRhMVdaSvHjx4kB1N9CrZgxsGzepE81hSG4nvVkoyQ/NzCh2Of1GI
t6Qoqsi3o/koxYpQ4ezRgASnnBpempof5hJOH6mq1eGm1Ilu5RXq8JPDyxJT
mNNP1NnjMi9yAUhdGRzzK44lZUXfaopjXUnvX59Y2p+vjy7KMfJt49C2ATQ9
jD1V+7l9QEnWK3eOrg08XcGn/rSR0LH12dxuEar/88qm/oTAnB6aWIfNybti
C2ow4EGzySsEah6xyx7S59jocmpS62enEQ5doyQgWZjPIajEQNCtlI7EEVge
U/w+V3l1VakHqrcXdqJXx9k+tLnDK0MCgb0b0+vDRlrbUBu+xyWmLd4qIODy
LdddBSpMZqnf04Ut5Oa0WjxOhUsb9rlzRJ7Pl7SnjXyzymSiYCtxRRptH8ol
pZOiSdl0imWAvCrni8uLlMbyICNAEsb0l9er0ebhSzBxKxUDbC9SmxPQQ9jz
b52NgTd9OKee/PZxmDxd0JhJVSRX4fZ3KSLPDi9zJFUxa2l3IZmVqvpXab6F
24B27t/OVv35n3/JvtE1ZHoPXxK5PtRT1iqdSUHlZHGIaVLCtfINSmNyWBlJ
DaO/J52pajBhEo1IKmg7eFJqG1NQulFDWWirHfaYeZQa4t6+2Wl0xxeKnwHS
h63vCqSbzaOaym1jGqouKiw7+ngpfA2UR/32/82jK3n0oNU8Pq01A9T9Gpwy
lRVmbV3Jo642nxyHYQSK0DLQNGrxbi3sZHttfg0scxPL4owz0WSJUd3bCzsT
SVhNxJ3QQrCYN4l0RxphrJkElnS9GjSiFokUPM8xLO/uONOQDUt3cKlhN8j8
Zk2QvF7emVbzcw3q0KWBHkvkMGHOUDlCgun+vCbyxdJO+hZt+Tyai+6rxjmu
se7B2NxyLa68xrrt5FpaqGye3lvmTOgrI4YOkmtLIuTcaF8ObWCP74/rAuXn
DcGkEhV1TPxuD/3ILIHbEEgl/3JRc57VgmdHsHmkn6c82j3fhhFjlrt37/4Q
jDiDjiQUuuhtGP/9+y+ybVB5WRjopTDmZXEdqdO4wMpMRu1gtamQzOB51OqE
MC2suHprNZ3hZQhjDsKYR01mDQK5UM2n3U2H9qmtkTk1giytrNWR9AENAJ4S
ko08leRKnqszebgU0ruA7OxfTHZNaArycpC8/LJrfGMm64/GNzV+WkkDcUfi
Gsm+YWXMmlQUfoYU508ydKT+E7sioelSwGwaV6MBYwajCKF+QoM+uGm4dKig
GwvakTjSmJJFo4klc/E5qKhT4yuTvCPDSuhv56PqvC1UkStjS3cKJAj4K5jN
XdHDZIVyk8s7sxuZpVlzmpox8v9l0Y0slqabBY83Emuy2ohrIK/S29KFYi/G
j8rL18s7cu7x4viyZi5SWYUl2xPtLof66ueDvXgi4vT8AFmf1Eemj+uvrrq/
LI/vLccXhMvR+WEyc8JAlZBl5XZCZfDoCiBd8hFN9LdjIwKkPIwh1kz/tD5A
vl7WnhO/WNtxTZ87NjCf3No4zmEcnects/HofPbB8Ogp//zLt7JlQDlZEZyH
uwiRTMKqjsmBpk9uRVhhpuqxuDzVCCGZEVYFjR82jxQ7JnLMJwvCy8ma8Pw8
+LAssoSsjyighrC4rO5TVrZE5eF2OBhGO2pMVzaNVfRUVuvLul6+3KClbBqp
45A3eSBvXOCb/T2IpV8WlpbGOTi+FrUN6kiH1FGeja8r11S/nBhXibIWWZlL
cdXk5syG3GKP/COeM729NdmQgf5K7LMCs3Di6O0Fd4gNz8bVUp3kb/TOfAev
rvhE/34gj7CjiEYyC02399D0luuJtWAf3YhmU6J5e5aF5tymNJX/t+cOkIfz
m3LXC3aRP17QlPUflCmRTMeySrD5g9q1H9cHm89VbL9KbaY2LBfrgOjeThkX
KdPHxsr0Ub3lkxm95czCCHm+HKK7u3y/ppv+mm6yY3a0TIjpzJnNXzYGO2zl
sxTMAReUu0k15EZ8JTk/pqRcnlCWtvOZ/mzgewgt8bNyaqiXXE7v5YATyznQ
E/cBOHEaMCMjw0mZe8nfvnkmn8YWk8zg3NwDDHWOQeD5wcXZW5oW5gs0JSm0
KoHE19PCqhPS+eF+dmbeVjU2mx/r38KKSF9Jjqomc3rWkdURRcjkkgENaTNX
9/GTTdGFZVtEDqqclbEVjS3tj8m2/4NVqJzBFbl4decIqBy0qwPTvJYkN7Lc
oX7G4YJvTk7rYO3bXlUwKB9dnN7MVZnt4FJFrmkYeGhoCTk/oaLcm9+CEuLh
wraUxPa2NWSp96tVvTClhtxZ0Fru4MTbbH+5nFiX3ZjHR5TkwkCUzWFJdqM/
Xl9/WK3niXEVHUQfGIRbpB5UPPDn8Pe3eGW1o+Xnja+H6r+RVBe1TZO7LEBX
f3O6adB8kNwSK9BZfUdk+XaVkSxQQ/TpakuvT63K2fLv1gbyvk0Pl3Jk5cGc
+mrg1Bev6yG/ru+hDAfIi8wQ2T61G5dsjhkYJfMn9pMtSeFmcjomr9reUuq3
/U2vEg5Sr+7BWug3yvHiiT1l5ZQo+UX9+E/rA3l6FTnP5xpd/vFphDzWaPPC
uFLy+yehcn8GJsfUy+uP6ReLWrB+uj/GQ87N72ajax8l/OOPP7Kju2fPHsd8
Rh+rkv+ztfooPbggfTzynlMDK+jnuYjuorASMjW0ph1sanwZhvXVqEOBXDvO
BLJrFVnMadrIzu1ZW+b1rKWPtRzoAkdn1bOib1VZ17u4q9rc3PrnXNe7hCzr
V4vfXqIRwVr9GqOWSHUiGwrxs2tMHdnF2SBlFD4flE5owiB058gasmNIOaZD
EZji9UyBh7qwuHNpVgu5ntxZke3oKlfntVMsrs7V0Gwg1t/XlJcrAkgx1lo+
QxSY0c0kcxa1l6s44jXI6lXXsGFfbF4XbvtVg8oGDiurjkw7BAqrqDsiPlLz
gC9hwpE6RPYacMLsHxtVVk5NqCrn4uvI5elN5NqcVhqwtuKfFJYWE+ewulZm
0xUpTXVdaBO+llDLnAxLacWE5rNFrQjwrem16eAxhYbKJVqUkH43AFdRwxkg
p4d7y5M5deW7dSFyc0kob1SnTu4nk4dEyaLxkbJ3drh82r80A4e/bg6UX9Z3
ly/TWsp1NaLw6JBDFyeVV6Ovv+ca/QFQY4sVI5P7B8i+ORFyQQNXLFn4fmVn
hTZM/vZxqLxIbqLBamH9PET+/mk4pRc67h/qDxM2I24LcpFTif42xL/88gvT
Td988012iHEn0RZVBmIf+fbuUW4OTA0qwiULy0IKydxgcw+Kx54UYgSp6K1D
kJoYVgMcM700J7yikpxF78pIH6W3qk2v/s3N64n119kodqN9rW/FBvVlab/a
sjrGjh08ZWN0EcK9pncp+axPIdne14czQ5TuY+vJzuGVZcegUqaspM+jDWUH
bDIa3vt7s0K6b0Ql2Te8Igc2ERrswwRmn/w0iucSGjBkUJLlypw2zCwhYHzO
i16dOc54cXJVNcLdud/8WTrWXAbI9aR6nEDbF5uH+4sep3VQL94Bo+roNU5p
7YaLrS5luMb13oIW3AAHKw6+dyrAFydXYXII2+GODSvGuGSfNXuEOAQ9Mvj5
wWzRWZVAl6dUU0tcT1WWvzxZ1E7lTgd5qT9beB82P/XNw/VuqNNjFO3RvMb6
B/lWma1pdTX1YLESH1+tCuSP/5LR3WT2hAESN3qgLJ3SR1YOqCVHx1TUkKCr
/Li6kxwdWEC+VkGOcOBnyqNgFfUhDBmeLmjEeBUNWViYiOQXttJs6+crI/uG
y+eTmsrvmwKU/FD5TX/dX/XXvV3aVg7q63/bFESi7yRVY0crLhMg3t2mnx8e
XQnbjR1FUyh81KEw6GEhnNv6FlpV7BmQWD7nLe9ufM61X6nB3uasdXAJDnei
iw/6Cwgnh5ZxxLUIH4DwFm6Zzcs41hldxRVX1C10a8uqCG/Z0MsH6BqJ5WHZ
4LrEdGO0t8oxD0gy7Cv+SE0FmvV2qGeAit+FK3f9i8pe1QCfj6wsB8bXlYOT
m3CV86H4FnJoqpqhhDby+ehqtF4aGNCwnktsKAeH+HLN4P4BReSEiqIL05vS
UD5KbUcqn2d05d0vZGsAGowuiMXjzZmNqKXxfTRt4MTrE/Xbz5Z2zQkL7VIH
nxJgrvtQFk+MKikvMKa+FOPtnflyhKm4Q3xrdmNuQUTyCImg8xP85MSIYhpz
e7NGgzYT1NSRP0USHZGI2ev+ETOZaD/+cUOIfGcxicfnywPlRHK4rJraW2aM
6ydxA4Nl5aRgOZMaJa9WBsnlieXk4hhf+X51V45UfrOyC8+OoXSpfLoBUBdf
lVJBVPG/6ON3q7rIQ1VsGCOGkdwd6SIHpraWuXHD5KvVYfL75mAHmt9lqtzU
P/pPa7vRUB8dZO48nhlZTA7ojxZK3QeGl5F///03R3SLtOjVq1f5VcH30bQN
L/Y7GDSLyFdnNkh6d3NxHZFtMrOkLrIkxFtWheYnmhgASQ8rJglhNYnn0rCi
TOgjhFgT6aVYVqEFndOzdg4nKlcqlRt7FQWVOUilF4SWMagayGbGVpb1vYpR
jCFbxdo9duwP85MDExvIoTjFb4qiMbWlHE5obTDUzw/Ft3QDly6l+NSeIWWY
j0Sgqk7f0Kkfl2e1kpPqf/f1LWhGKJVSuHqbQNjOi3FVNcoqTJtqqOwqd+ea
vndsQsAtCcxaoK5DetVF4wRjZxcCKvdTzHbM+xpxIvK8oqJKBT2W/epryhJT
XMUD/UiC4xT1y/T2TJS/XtFVvlzeWc1lB3XwbeSBKqq7s9XuJ9YwY+tqkg73
zyvnRhaVW0k1OT1/cH60pE3pL/FjBspMVfKfzoiWa0vCucPuwcya8hflBptp
YAK/Xd1Nlfz6QP3HyEalO6ksJr/oq3+FAVzeQa5MrsDKEKtKGh+fGlxAMoe1
kJRJ/fhD8bfNhsgf1Qgf07j0u5UdleI63LV0fkwJxK5yc2pl2aquHs2Sv//w
2gZyw4YNjknObEBiCAThLIZAbFv57ECqLOiam64dC2SxBgyt9zOCyxHI1diD
ozIL9hGJUiQ8ASNS+NgMgqPHqN/j+sWKyOKS3BNtfoqn64fRNFqqYJavJ5qV
1J4Wpb9Ht+knfYrKBky+9/NjiwgK7tjsundIaWMlp7bKRSTdSejuAb5yfEx5
uG83BqLFSCW8OTo/kB2DIwVV8Or04hnmUgmMHBYcYGgXND7kQXVPa/+6OXdt
9hvlliu8jtLFDPcCuFz88o6CipgV9hE2Ef77wcLW+J4rX+bJl91Vq4usJdTK
zWk1TcOxxeZXmWhlerOyu0sJ+Vq/fquB5deZXeTYINPxeWNhN8kY7C+T+3SQ
yUOjJb5vJ0mJqSOnklrK6+VdVD0FsKMDbXU3E6rxSI/FJJCkqsIj0kug7tXi
FnDj+nsqma78tJh8uaQV01pIwF+bUlG+XdlJLqrEv5NYRd4tbSWnhhSS+Gh/
Lj9G5IlI9Jf1AXJC44wvUpsyIkXK4br+2lsJVWlUz6rhtC4E2XgePnzYMc6Z
DU9Mhti7GgyeteXRrrmS2jUXW0lQYUIuH717U4Mqs7IEFDPCfGRleCHTnxdR
jHoKz6f0VN0UXVtSe1bifm2z/zCnrIsoIOlRZWVBz+qkE+mALEIbOLBcQYvp
w7y+jeVGLC8eUk/WYj3ssMayfkAVOvTDU5vLwYn1GW7uRGJ0FH4MlE4PG9T4
5vrCgnJGxbfSaRSTMaMQUgcG+XBUDZOUaNLERAW857nxFXjcE8rJ5ANyq8n0
J5yPF3Uwh0A1urRvtSPHeXu2OXCB7Uh08Bld3Gwrqi+7MaMBq+P4Frg/o78d
dtmY15ThzwZARg/S21XdmGvC3gNUNEHs16q132R2o/5+t8osfD+fEigpQ9rL
9NExtJYrp/WTU4ui5YWKQPQZ3ZlaUUEpxGoRqkD3ZtXjI7wEIPteCVWHrn9l
yqr+bZFWpReNH18sbm4YLcH4E1IdcOOtrsVpHKFOG/HobxpLnhldXB6qYf7P
jij54+NAua+Of9qwMPk4XgOCNZ3lb/qa0xqjoPJ5bLAXzexdjT9xKvz3LeEs
ISC3+NOLaw4Hf+vWLce0ZzZgMVmCjv4sYAvKrU0TZWl3dwILWJeFFFDnXkQm
B1VllR5OHFIJRaQ5Eercw31lfUQ+grmwZ2W1mtG1XArrf2vL/OiasqhnRZ6s
snd3ronwkkVRFSRTw9PN0V6yvG91enWYTqwuRkPpxv4VnRhtpH+pa4c2cMnL
r9erWd3RO4/i2Ey9fCvltiWD0F0qmbBL/MD4esbz216/OD5lfIrWp4vTmym4
7Y3nV3ShnNCIg7a3O8ltmUS9Pq0W1Tb2ayDeRC/Sg+TWqroDKG3REocIgKsz
+xVgX5LinHXIrBs3aaJwjpVz0E68cwY6KzCBjwstSO3C5MK2PtG4AdYdUoqa
Dc/r664k1lYp5OM49wOS0d55fHBBebmkrTxaGiinkkNldUK0TB/bTxJHx8rM
AR3kxPxgebNGvfXGQPmryhc82rIHmaqv0lvL7aTqEPCm1laJhzPuK9RoHUGn
009QS5tC+DnCEIWYb/F8YVPuOEZSDJn8byx6Eara6gpjT0/n1pN/bQtXfR8q
/9kWKl+vDZOkUTF0i6+SG6jOL8k6/pN59eWfW5HYqssy7HdqtfdGe9DpfX//
lA0x7lLak6HZIEbdwB5JibWStJeXxsragI+o+RGprlDLOyu4rMQRYk9q+0UR
pWV6RA2ZFVGNe5rSorB0OxcgJsNu4NclPz6nFV4QXUMW96zAgAG7GhBAbNM4
dFuk/rBgNXz/8rJucB2b2hyENh+/XDe4Jnv4DsU1IbCH0XSX0IoQ7x1amjnV
vUNKycG4ZoAXhteQq689MKE+Nf+VOa0Zp4LcYxosQGKfn1JdHizuTHLhth+l
trE2c5nZo8vx1WhwcXMelhJI4g4aIgUMfdxUS+poC/Fz2OCLiiHsLwSXjSMe
0Xh3cnQpGliDbldH9IDwAF/jdVjseW5caflubQCV0TeqjJ4uD5Z1I/1l+uAA
VeoDNBztJ59Mj5ILqSFMvh7un0++Xd5W+QnKwXjTm1j9oErmRkIVTrEj1gQ2
d6dVpbPG14gGEDXc0XjydUZbOT60iEbOFYkoWk0wffxuhQNRF6Ow3IkrNiM/
X9AAmLrK37eE6L/1f7YGy+OVUcx+be5dVHap1oNw+k1/gP7xabi8TGkiJ/S3
QHxxCCvPgnD/aKtNqfPUqEWpp5PMh5a6d++eS1+L0rNzOskWfQfc6kV1YDUu
zARVkTnBpbnKO5WEqobSj4wIXw1R88jcqOqkFXYVlOYgpXlIKQjFAkaY4m0R
7qqS3Lls6ROlc/2g6g57mpNoutPG4gDgobjGwNIVXOo3SajSaYcDmPncN6Iy
aGRIgPNXn4+sKvsHFmGcatx/UdrFG3OaIXOUhpXsV6c3ZAjwPL0TZruXoaSJ
ceB71r64EyNKUCVhB9Ht2U04sY7dr2pAc5BIT7Z/ohKPo31YkwTqXizvYeWT
ylNgGcPqTYN5bqLJ1z7FSln9IUBfPE5kPV4eKnvnRMrCSbE82zx/0gBZN6m7
bB1YlkN236irfqehwquMjky3f72snRMu3g7rhlAAafYzKmN+UmlzXf3tXTWk
//ksSn7/WC3m2q7yerG/3FJpA5lzsF9e6lTkh+Dz4ev/+kk4owEPvrebnBxW
VL5Y2BgYutgc/kOtpqp1ObEgTCYPCuMSuF2RrnJpvP5UZXaQ71Z0kD0436s/
NU/nN5RtgS7y6sxGm0PnYdJsHGLGBBIKMyY2h6c1DP9M/4TYhIeup4yQwrSU
iE+Z9rc4NJYyp6RHlpTZUTXJISxilrXM9x6H2C2yJTK3rOhdVlb2KsmFX+sH
16C1xMVoLAXdMLAK/XvDHE5QbuvpSfoOJ7R0B5Su+Ez/T/aPqa7BqXH0+8fV
0WfbyJ7BpU0ONLERG5FPji4jdxe2o128v6gj13icnVQZg+c5CKGnvMKu/3Sc
XClL6Y6qKhJK2NqBSQ20JHmQwFyMRx8ubMMMEFz2o0XtKPFh45Q+A19HNX2d
OXd0Qu0SdiyeSwmRtJGdZcrQSIlXc7ckro8cnhcpT5YF0ZMj+XhxQhkOc0DZ
QzV98T58BA6PtuZGGh11yhfJjeWPT0IVmCi5Nrm83FaB88+t4fpciOITqvCE
8Wt8fnGcaftH/wiPjQ8oKPdm1laJ34muGlkmDC/h98Ljj+t60Ia+XtxM3yOM
IMKN/7y2i+p1tatDCsrK8T3UjHdnNunMiKJ8X+h6rBC8PKGcfKuQbw3gEpz2
FnVoyYM6Eg4vvwck+p5R38dVS+O+K3E70+GxleXTEBeZEVRWhVMBmal6fl5I
KTO2g4RTeAlJiqglaRElNbj0lDlqGG3jaEHJANR+zIgyG5mw1GZV71KSFltT
UmPrKZzluLxG6YNxVENZi4tucMEAz28cUFHWKZNrhjVysxEdWl+/lU8OjKsJ
Q+lBu5nHhKPx/rJvWDnmSfcOKSO7+xVlzQ/lyytJ9dQydsEEsSKvbOpbYZoY
sScWEb7K7GETCtsFSm/PakizahrcXHnq71VmIO9buJHTmqbReFk3R+Mx1Bby
8fDKRvbXpMR5ubQztyzglO/xecGydEKITOwfJJNG9JVZAzvK7gRFODOY3hpe
G7l2libZwdlDtUlJ5knfoFF0aaf3UIV7/W51V/rFwwPy0/79ZUMPRTBc7WII
fefN+EpyY0oF4Kl/doVVIw5geiexqpxWtE8M8ZK3GS30O6qRUhrKJY0gEGXC
bj6e11DR7M7fB9ii1A/98zajlfz7s0j5dX1Xvj989fU4P/ltfWf552cRsmLa
AJmt6vjS6KLy+8Yeciu+Amt2qED9sKqLbA/CYpwEG9P169fLiRMnPoQpVBQw
xSSJwbSm/Ov3X7mEcHlQHkkIKs/UfGJQRUaY0O8bVS4tDS+m/rs6O0KXRpaQ
WVG13sMUkSUQXaJ6HikoZzwXxdaRxbG1+bi8tx9vb6yjLmpg+3L9ui6Ximzl
YkVP2RxbSsPNusDVvIas5pf9o6sCUCQwFNaKDifPbvoEZEn95eCkRmzs+cxq
p8SEA05jXJ3RiHX6e6nt4dppUmFaofdB6KuVAaSV5cnMHvzcENmFdhabFdBX
B1sLTwhVhLMYWFODfgB48tNjcJ7s5MiSLkVYSaK9VXsMAQZPtzfK3BI4OLqK
7JjWQxbH9SW501RTbJweI59PacklRWg/frqgoQryILZ6qrF1A77qVNn5ubq7
glyCR8xte/tWnSkgpnPX/yVky79d0Z7Qqp11BcH6o4ovb2soajHsSoQ9aG0f
zKwlJ9Vq/rKuC3/1myX+rvLfzyL0N/33tjD5cVV7uT+9Gg0lGvIuTyovbzLa
sAqAQPbr9BZyf0YNOYgoRw3pDyvbuYrsikKZc1eE/LQpjItH06MryE/LW2pg
EMG3YqdpehvZqf9cN9eOcLEpxubFLVu2fIhijEvbkySG4nzyj1+/44X5aT1K
0funhxaR5JASJAAFJsw/L4soJikR5ZihmheFpYtzomq45KJBTetZXrVTedkQ
kT87vW7AV//qAPDSGFxAyANg3WlH81j81lPl5Kf85lN+c8vHfYprjFCL/OLA
4f4Rymoi9sOD3m5qYJurmG+kPFeTvYNLye6+RTQkyGPSq/0Ly+e4Qq368ez4
CpzSRA8JC079C/Gk0JmJleVSYl0Ort+a2UADz0ZkEQPFp8eW5Qok7KjBzBtS
nGAWI5JolkMwi58N/FxAfMA6YQgelVAMq6MytCPChTET+nN39fSQbX19ZOWw
ZpLYr5MM7xMs42O6yJyeNWVVRGGVdSaZhMXIkGk7IzioKW9WdJGvVnTmdCda
ltGubEY7AniH6FtlG0uSMUaCStWrtJYUPM7Bwd+3hOlfPMjNl51cBgr/UMv7
ZC7KSoUU26509qf1PRRd+c92RKL/2hqqv1Y/B8nyz0/1913emgHFYf0ZQ/ML
SktYZH9eg4t3GQrmjghi64rPAO/OSPnvp4E86DOyb5gcHleDUS0YRz8/LDjg
vZLR2wHvuXPnHNt1ssGL2RKckc2C15vNVp/ElpBJPSrw8gIihLUatqLwj2Z9
rAtfGV5Y1oQXkBWRRWl+EbrCBG9SeBGibo7Kq+EpoK0FUlVSgVr8t45kxFTm
+cJ1QyjsXUyUGk50YYY3DKwmn/T25k4npK6w437fkNKq2uvJvuF+6v+9zYFM
jQewIAL3Mw+NqihHJ9aWE4nN5PSMNvrXUo0m0chqc+nvXnJr1UL1mNtHKxTN
MZd1uvMGGrrTcUfg4kQ/1cfVVP/WlodzG8rz1ObyZUY7aw9SD+Yp8Vd9Wl8P
nB/Ma8xjlNjQ9WV6W45dPExuyS7sJSM6aEAQIJOH9Za0yTGyZ2aInMQGKRVe
F1R3w7IhG4V00F6rcPoZMc9Bs4v9Digb4c+Hvj7Etvhzokv/3Ngycm5cGXa8
4McEFavriiMSmEj/KLL6d+uMa1W5OqkcY1gECV+lNZcjGlh8v7I9Hf7ftwS/
h6s7cc1Nc/vnjkg+PptXlz+auAu7v4+n/JDZVmRvL+F0PgjNrS+NkIuj9J9o
SluZMjicp2NvTCpLawythXW35+d3teF0HifNBqdzGdXAmUd+fXGVY5xTA/zY
Lp0W4k040fa8OKw4O/+2YLtTuCc6S6KwWSIjsgStqtn29JFsiiogy2IqWHFA
XUBpAeouS/pUZ9v0+sG1AacH2cxBt79mWGMyiuh1e4SbC7dwqzvC6vjPlcGD
I8vLkQk15URCU27lPTWjtZye2YY84gwMPsfFS8xZPkNuE8tgW3Ov9vNlPbga
HjobGEBS4J//4gQ/trB9vz5IvW+g/IBH6/Pv8IG1HzjBop8/SW7KVlC0bt6f
WUeO9M/L1R8YDrn4//h664Cq8u/7m8Hu7u4Wu2tsHSykO+zW0bFjrLG7GwEL
7AK7O8Du7m4Fhf3stc45V/T7+T1/4IXLvRfkvs7ea+d7qqssHe4t//YLlEG9
O/B81cgJbnJ9ThtaQhypgV4Qq92ZxSbVpBfHVaOlhiXEGDHSP6cGleDJQ7en
1pUbalnRaoqcOlYbI5GKNWDo2cABWcaRHSlYaD83BDWjhopnW7WUimeYs8Jp
SgGDUFQwT/QvqNGRqz5UA8QO6Vlm+r7WlVHT74QmIaFpaVD1M3k4vZbsUyMK
3XBJcdugjiTcTDedUQn7TWWwbPRIYpKqIkh/XAG5Nc5BNoz3U2XbQS4MKyHn
VWk/m9uIXSd7BlW1SE08TWqSmtL8FnpRkIm6c+eOmQFIIq8u71Wlml3+a5sT
xyC0T2enprN9ZhI4un0x0gqPttg1k8x1y8FMPswn8qho/sc6vKWe2WSVW3IJ
cU8niz1zg059rUQqAKIAs6LLO5YFo0Y0lcqmZGFO4fmD/QvIKq+M3IOyxkd/
BzeMC673TKkvsY2nxdST/aMbAdlk+kV9/VVBMJbYnx5VxTzit7l5KnUTpo3g
qJHcRkc89h88XdhSLWJOWilYS0VUlZzCic1aiims4nbfFCyE317gLFtGtZYh
PmoiOrvqhwuXLh2Z4qJhldG5+XwRnbSd0Ymf1javhKE3OGmoTJz8cn9GQ1rj
h4oWnB/miIwO+mVt7XIazc8Y7OCHk7xe4cQFdcxALmsh9yZXl+Nqlbb5pZYo
1SOoHj1W9D4GG5Sqz1f0XInmyX8KM2iHf74zuRqwtAeXdoV+J5M08nZNeyW4
HmN6JK5ujKsocUry/ak15WCvnBrb55NzQ4vJmSFF9Mdn1CCtGg2oXjmG69/g
IReGl5SYocXlW5iTjOveViZ3+lNOKbaXVSHDmO7sbTRGWZmqxKOkv3GKQRRk
ql69emVyml+end3C5lT0VSPKmumUlWdtoiA1vH1pNqZGcDJKzaBrRpniVlim
uhXiOCj4XOmenmJ0ul9ZWeBdQO9Pxzk8rnP0LmJKAFpZfh7mlkpxLcMElV3m
/x9MM8mqDoUktFsF/XBg2QFb4g8Mqylb1dritEJ4/X20tH8mIbZFaXRx5DBS
+Wj7MDYcayQ7pgZjKySosfTg5bI2dLpYI4cpC5TDkdhG19rl8dVoZZ9Z1tWM
3l9rtPxcvdmlGY4yK6CCTBngIwN6BMm4vwMlfKyvHBnXnMWugz1zygO9BJ4u
bpOM9KanYX00/y85ObgU5eXJf4rxSsCPxrwRCH6L5qX5TRnOnBteFgAnw6Vj
l4Vt/FiUB2rjVjkpGm6SoAryy8pWBsF/5zeaVdRvWARDsV4dU1HRyyl7u2ZV
ZVqR+dAkRDZJYmTtjMgqr7xd0pyyBFfDheGl5HNwK/05bvrz3FkiOD+suHxY
2VJ2KMof9fbpgj950WFz2rulzYkrrKqRa8inGLtJzOgq0svHUYJ71mKqC+0p
29Ew9eWDRSwmTJEIuHjx4u/EXr161XaKp0FsJXl4dLXMaq0i0zkZ26mN3P4f
XDiKVuo5zlm5UHSyW1EK0zHuZTWSSicLvfJqyFScERVo/en/HfT+krLUIzu/
B0IXe2rU5lua31up1ndFhxJGbKW6IDig0E9MvS1MHSSkZzUJ6VVDP2pKWMdi
xlm/HXPIkbGN5QgOVfinAjeR4ZDNqAEO9qoMGtgVA7jUBjv6lGQ1yThoo4Va
2WJGGUh1KCwoTJlhutKypGh0cbRh09utqejfS88DMZA0Aqpw4memO6ll9ZJJ
A/xkWO8AGRHUXDaMaivRM9tz0zEql+iJfzK/hRwxT7Y+P6qiHUaNW9kl/XXe
ZHwNewhRNcYY3ESLPkZBMDKHow1Qw0HK8/3K9vJsYQtyYWDcLikxTsrf9s70
BjSgirG9/FjjbFdR4tVQ/iS6tTyYVpM2GcE4Yvm96lIgjM8OLiafV7ZRstsx
gfpDyYQ0iFVjCyGNTNfHFY6qNIpR2MYMKykfl/9Fgn/o479rPIbPQebVceVF
dviqXUelP6/INi/5sd5F73cg3RdGlNLXV/U6TwnvmJG/27eVf8lq/1zSN7C9
LFE+wlUEb+uST2I/vLLFWhhJRbyFr9L/ijKaqq3BFgPlLHIjco4scjSyr9Oc
sssUp1wUBRxgaY/SQDIKAsRWiLNmuebh3ggY0hmK8Cr1/YinEGPZUxNkoqEF
1tAG870LynKPzHycNSCNk4/DvDOzIrDGO8P/xbcnGoT1K33HQnpVl9V+2bnt
ektQVns5PPpPtbJHuHa0vkT1Lck9fTj5a/egqja5u0UN9ZEBJeSihlwItfZA
FGhoBE8MlAHCXQUB2adniiu+hgXGXNt79bwvFjRhBSGiRzlZMcrP6EXuGSRz
B/uobnWVq7NbG01LU2sD3yRYEKIaErsXkKS6PrEW5fO+Hnnk9gxjFh/RmTF5
kkpiRjqoQcePY3eJspmEGGOK70BPLD5GoSoZqwQWyogIXy5F+ep/spyMLGez
sSwR7vJpRStl1zgRAjJ0i09Kto/u65aNlSxUuq6OraAWuC7vA+d4/NnBReWd
6gyTW/2RSq5ddjKM7qkHM2qS17h1TuzEfooE1lYNwrZ4yptlzTgMg2TW9XEV
eB380OtDwwq5Mry4zHHPo/w6SbBLGm6n+/jsjoUuBlgxwfI/0A0PD+e3E6N7
bcskLptGk+DQtsVlkWoGpAjGtC8qE9oX5OmKqGz9514KcRj17XzVB5bFDXFP
Y32tf06gm5boTvGvRD2xwCs/t+Tj/Ia1HilNTMsnxjQpKU2GTyW0R2UWXnmo
V1A2HOGhqKZV46uojqwrO7rlZ7cKDgtDlgArIIEYzhvGMgQTS3u+vVlJ6qUx
lRn5gMp3y1vp37a13FnQVvZMdJOFw/xktEZTo3r5yFjfGrKuf125u7CdvkQr
QycsdlSZml0lajW9r10yEpoKn6pSdpSTGkQh3XVsQDHG+Ef6FeAaURCZlEQm
5Ywd5pORk3gX3M6AMo0JZXN9hzOr8C7JpSOAkf8BhfjG5Nqk6PtqhP+gMiut
l34mj6bXphQ91Du3vFjYSG5NqkyCns2tT4pu/FdB/XxJytJ9qhlwTh6q6RhL
/Q6Kwj1AoQFkDgL5RQ3y7k6Z5OUi9eabPQjh3anV9JrJSEBlk7txv94+mFGL
pQwkn2HgT6Bap78qElYLetSXgf4tZX1gDvn05LrNoCYeY/2NSkyq4Cynn1Sm
k0trhsua1nYyWQ3piHbGiWLYiTayfUke74DaAaic4F5C5rrmRC7ANJxGSnWZ
R1ZZpqpWqbRPlLMyBG45hbKAPiW9PmWVG4Inzj4pnCE9q4LCFAQyOc1maJcy
PIKJJ9YFZIa9NJhMxY3O4PKnljUOhoR8Q1iN0MWwM9lopzBmcXpgIb2w8ytk
7Rm6TxvoJ4N7BbIl3uhBdmYv090pNWWP/u3RTYwSPFIDELE4qzpmVAVFpJ2d
YS/T0F7q11yvdFNVKEJ2jFdtVvG8wSMZ4zvTxf9C5WkN5dF2/36lUxJSmdRW
QUKh8+jfhdCzh56Q34BMQh5T2Kzki3kNyePuzpnl4czakrDBDZnOzZ52ueXK
mHJySEOkhAh97Ba1bpugLdUirmuvCjuHnBxQkM+L1D/ajfGV5GtI2188PW7f
L22pf9R08iWstQGiPj9ePw73zqV62AFW0x53IrGqBvRTqCOjtDODi6iiqs6o
bLMabaQwhvk1kPFdWsqHBxdsbGLfGXJXidhMYX7r+/fvTBZgBCWA9xWUsws7
yvLWf8jgtuqwnZRD5+Q8vAHZAJ6C51KC1QD0AsBaQqv+rFdVlEWqX7G+zKpf
AUxo1MWeuejYw5BU9cknC/1K8PNgv7zMNqwKLACL+RPOGhw/Y2akR1HuHD00
qp4BpwN9u37GfbpoI7fSpNyXOL6qrXEY0vHtMmM5Usys9rKwdyMZ1bWtjOgb
JFP+8ZeIMR6UmchRvV1uPPaV0dLJwwqQPrWSBa80DMJaWoyEvlqGDrk2tmVK
D2Y3kWh12BipR1v8CZW496fXU4vchqObOwMzcK5JwyhlR1G1t0jVF8V6ZhRQ
34e0Z4OSBpwkdclf7PnEt2E3kR24Mr46J/fgLWErLUY/Lm8p51VRopvq4r+l
JW6tEwhVbhTWbEqPuyToB3A8MaCAIoyoXQWA3saHOxPV5/P/lHgNhe5Pr6VI
51GTm1muaPT+cbkjCwEIr3ApwBQnrHe1M5jMRLv5dmlTIvwpxFG/NhAGyl9X
tyH+X1e3Fdnpy599a1o1jSzzS5helgP8HeXAwUM2Vh8+fMj+FfT5/8YqZlIQ
Y2EmxWC1kByf5iwTHDOxRXWhczq2++MABwhTtKmOdCkrS13ScV/KEs8cLPuD
UXA5RW+NOEuFqm9ZmeNdVFZ4ZFSTqQjq7WLfQjInsILMDqoiwZ6Zebjd4k6V
2L+CxaahPapQhCYnsAVoXNd4puWiXJwMjxgKLv0w1zU3tKnRXX+XgUilBOBW
OI1iobE2qBfb0zGDHFJLc21KAzk3y1WCR/qo/w7Q+D1QRgY2le1j2snN+e1I
qOXrXy01hF5rY4hDI6MRZem1r4yvJsfVvqKn/s0KZ3r0qxNqsJSPfn4kGa6P
r4JJDX0vP4Wg6PMh2ImjbWiPvzy6Agc9sdEERx1Be75a2pa29VDvfDzy6EMI
3DeQzUhkX+nlc1DZQfsVpvkvj60ih3rmlHhFFZh+DnZkyB6l/vW8Cr3Poa2A
KfhMSlSzEtUf613lGJJOQ4rya6BqYfp0jurIzbC0nrz/1aImauYL8Ko72b+g
atLmcndydf0VcwHBJDZKPVUgFNOH5jc8vUkojC5KYd/WoEu2pUTqW/Bofj0q
cIi65W4ZpF+3ALl6/YYtd/XmzRvmrp48efI7pWhXBcA4NDfA9PZHJrWVYY55
OZhiHWg3vn0hbu6d6pJfRriU4/4oLMGBnpzvVUBfST/TX3uRZx7qS0T3yPij
03++fykls5LMZrd/JVnkW4R9Yos78YhlCfPKZJwnFkSLSulZzS6vIUA1hIK1
xSKoqIFVjfPkRtVl9H9wRB2J7FmU5G5V1b2rRwHjLGK1rddGl6PvwrlekcMb
yaQuTeWfju2lX2A7mdqjpRyY6sHy1Xb/NPqONEeMnYQ8FlGR2pbmlMlNNBfz
w8n2+U31vFCXW/RXAWuQizhGE4XX88NKy7N5Tcjkt9V4t1z0cxdjoJhDxcbt
lzBXMhutj9/qm4b8PZzdWH8NJ7aRXPzXgaxCCLQzevLTc6yJjdH6xCMqXyFv
IT4g+mBXkR9Crycr8xSOBDUFQU1FVx+rbh7m+Mb4CqTqF0g3ecJGontPNnoo
IW+XtWAlFn8jXIBn1XFDiOoTTWOalC8Su7YdA7bn8xvY85tGGgv2NV7tNTKx
JwcVkiN/55WdHTOwMI1yzL61c2XM+AlImzZM5N9B49WrV38HFYc3WuVWA9QU
bEsd4phf3X4Ort/FLv7JzvnQwqK/4L8upRUlrI6yTk2k+/bIrN9b6ZHRLjnb
+pGWQt10XkA5Aqqg2us/2Io+N8BBrWtqWRFQ0M44bTmZrPTNJWtdk8kar3QS
YlpUI2BqSAkQ1qk4M1RbOuWV3UNqU4TimBGcVrvBXONzaJCDHBteldEk8oIb
O6jP1vh79uAAGaLi829lNHyst1ya7y4Xx1SUnf6p5WifPCqcSjI+f6rBMwoD
8Pc4ZPDezAZya0pt1oxiWC8qLScGFiMf2FqHLnf4ZQTvkCew4jhLG5/v64a4
JS/blcHUMX3OyX+KcPUIVpBc0Z9/TY3urUk1qQ+ezGnMoU18jmh7o2dyimLU
orBgjCGVAsrYX6XJEkd86J8P/6alvMF9sLm4VJGdR5oTATj8OSXpVm8ztkFN
aaN7MvJbkvx+DmvN9qs7k6uy42Rft6zyfN6fAJZpUfVKNLbx4S7ycmFjiR5a
nA4L86gbVXtDg9KGA2NTulqx1e7OmZisMgL+poaVVbR3d8ms12dOOTG4kFwc
V5YFLOxGeHP1oOzee4BUqvm0GJ4xY4atvpruV4YxxbJy5cpEDGeTvSP/lOGt
8rLcCtmKXoC5zllkrks2Ge5SXma45Lbxi1ZpuPul3nnp6meZ6ygwmrJKDeoC
/5Lg184CGMYW24HCPDPyzPDKyvyizlVleWBR41xbHHzSoRDANRj+kwyv9svB
ixQdTHuG18cBzVwPuaNTdjk2rLJET1QtO6ImlfDKfg1lfE8XGdTNSyYPDJQI
5fbGAjduR4jWPzYcKcrirxc3p2pA7RLM4OgEtMqDSaRekWcH2+ARWUfMtp9k
y2gpNi2hA+T2pOryYGY9rhU5pDZuvyoPZDD3ds0mV8ZWkBsTqvKx59Vho68P
LafgGZyiDxr5emQ+IRLQGYIulG1mpwzicbzW9oB06O7qiiEtRF1YVaa/l17j
uzplVtGA5+N5PErXfFvwe5weVFiih5eQmxMqyaNZtVWkNCJo31RIIrZKAFib
POxBuF1pwzQj9FLePwS3ZE320cxaLHKgCUu2eOtT3OTDipaqa8rxv4h5afD7
ZG59/kjuPVV7itgKiVfmBZCwUq5/bHBl8uvGhIoi27xhmtVXZZebEyubf/6M
8nmDk1ye4MBGt02eyeTpOXascM4KHSwJCQnWsc/4EvD+D6aRRdi1a1cipvPI
rhEKRausHK+eZ/a2QOr+51JUxrkUZ6oApQQUZDEkvdinkIR6oMCVhuIA3M4M
qsqwC+NWYF2J5v3zlXEIi6UdSkM82Lhe0rG8rFFQV/rnp6w1jbO9Te3+TGYh
KRA1oDJPskdq/tSo6nJyQlOJHNNa5v3jxj72f3oEyL8dW0hon9ryaKkre0Pj
wtpJ7Kr2+gY1Yzb76dyG7FJC60fcWje1lapVnO3ZyoG+DOiKd8tg/D4Et1Gl
+HFlWxUA7ZQLJxUA7eUrnrvKhbdf8KH3gVO0NCMTf29qTRbeUbq6MrYin/t9
nbtRQWVfX1h7e3ymvvJDcGu2Al4YWZaJ1Y1eyckprjn4GbSzQHFe01gTW1Hu
TK2D22SYsLKrLU9Vs5wYoJeLqs3niu4dtYdXxzuoZi4hxzUGOtwnt4aDmSgF
rGQrdMPRvnmZWL00qozcnlxF3UNdZbaF2k0n5bk2NcA2dV8PZ9RS9qrw0kY8
dmpgIXmol0msyeyPCGd1U9nUfZVSW5tLXq9sLsf1MbDBt9XWx+PyUY5fLW7M
wsHXNW3l8Zw6vA7ANQa0bs2oJnIwSKJHl6J7w+q2xye5OpDnlmO0cPv27XYW
1ImPOzWhTm5+yzqV5fLlyzaoJSFetvevKnPbpOK55Vj+C4ONeA1x2yKXDLLY
PQt7YqwdlVhdAQONhdP4OlRV8UK/YgpyRQU+PRcHzQ6qTLixCitE1cVCdm4D
6mRsQ2RdzDODZajNIkLGRNmwP3hJ7xlSS9YF5JKwHuoQBnnJyF5+0ifIRSZ0
byWHpnlydG+Hvn3P59RXip2TsEMkCTtELowog3fUzugUTcWWu/vTa8ueLlnk
1oQq9NInBhTipgaAqgDr9a842hUkzBgm2UYh3ZTteXFmZ8mDGXVYDEVXwUU1
zO9XtNa4xZWg4zn3ptVm7xQARwYTIgQXztO5f7KQGh/uzu+jRIUoDEkJTFRj
gPSDCuH3wU5JoYj17/VJRTYSzhf+LY0KlNrZ7T52hu0zJStTVLHh7eVTGArP
TeSRsnpzUmW5NLqsnB5cWI5qAHdAmQbfsKk7AtOy1wUs4Q+MAO+B2miwx9eE
rTVzs++UebD+baOzuo0scn9ObZHd/vJsSSPl2riEkYrDc85qkAgpjYLDVr9U
dDtH+ueVhCj9XfcFyLmRJfgz0Wr06EQEpDahfPnyJfNiMTExdg3M+3BA6uTJ
k/8Xw2hYGDVqFOdnfjL8Q3b0rygr2v0hU7D2UkXHcv2Y5pJPJrkUtE0VotcL
nm2JbwEaaBhdGGTMasMor2bOAQuqje/PUwGC/ANmtxd1rgSRgWOPVDHn0H+r
MRcR4puTM91rPVObxrmahPasKmG9qsnqoHwaMWbgEq1RPT2kb0dPGdrTX+YN
dJfQ7hW5cP/xnIacXDqiJgfTwwqu2TeagVV5TL5BQWBQzhoqgQXG5NG30Hby
YWlLVQP5WP/EJJJphfXvBZCTEspHs+ozkvm0so1R0M/Frimw/HBmXQpkGNVz
Q0uQ1Z1mKfXckOKqSGvor+BI/lE+hQHH89ADiCI/DHG8fn5HRQw9uQoUpEM+
EN93TPd+1MjwWL+CcgVl1O0+yYEXFIOn/jFJG2je4Qsidvoiu6r0vV/5l1we
U45iCkb/YJ9cEjMaM+TpaS1lpx9jsiTQBXY5SevTefVlr1pbifKVh3Pr8rk/
tqoa3uUn8ds85PaM6hKpVwGs/pO59ZgRA/08CtMnpbxb7Siyx1dp9ZfTw4rQ
j2/2SiGPT21MYtKHBsSRI0eyXaa+eZ+1FAMLMn+DFXk0ZCgwW2PAWoCzNTg+
dGk7rMLKxTQENixCQeB2jkc+meBZRla7JKVCXuKbX5bqBwwtgJ0bUJZAzfcr
yX2Dq1VxwDADXESCK/wLMgWBxQL4PNg3j4R6ZUE6Auv/3VOqy8aB0Ti3fE0H
BVSl8eIedWRSt5YypENrNa6uMqirp0zwrcodhDh4Ym/vQrJbNdnjOY34bt6a
XItSE9buS6hzMpNXGN27U41vfVCjCFY/Brchq89VVcSvdWWm/b4+BhUpRPRY
TAJfn8zkFarh4qhy7P5U6JKS15Rm6d5ZPXI5Wq3tGrhDrN4YX9mYH9UHoLfO
HJnCk4x2q9REHVfPoV65qXPwUu+XtaR+trasfAhpn8SkVT/ldsobEyuB1hTE
LNNP06iwIi/2emlTjQzLy4FeuSg7TwwqJPdnqxld317h9CJ0TxY3VGAzyDOV
qfrcn7Dqa1xTGXIKmYdIH4nf4UV3f2NyZcIrO4znx212k2uTKrE8ho5KgIpF
wzenaZi4Vy8AmlZ/Oalmfo3TH5Qvz87vTGrSh+WYSDuAvnqJrC2GwdDU9Rus
iSdsDFirSsL3OB4lOqNdZqNTBm3dLll4BMByt/QyzrO8TPEoxmlZ5LqCFbQ5
QZXMHUFJaVFXYZBLw7hQbBhwNcpgsMLs5Ce86ow80nI6EZOyGP5a6V9AgoOK
yirf7BLinUNfs6KM968l/bv4SJ8ufjKkk5NM9ykjwfo9tHejE+vs+PoS1aMg
x/Secs7TWZ4taM7OrStjKnBcD23OyUlrRlpXvNGwurCssMIgEtIApMZxct6F
+bbzagrhPPE6poVNksjA4mXg4dUqGtSltRlKRHeItvZpqIM5k9hVThr1VWD4
fuO/yipKnPHYZHxaJj7t0ax6nGP8GmoI8zj95XB7TYNB/BKXRlc0tgkEO4FZ
bhE60COX3J5SlfqA6Sskmn5B1kVeLGrErBWE9A716qeGFJYHc+vINyCrGMou
RW+ntz34w7ERSuCLZU0okO9MrU6C7W0Ee2kcW1CuTqjAx4HaZ6BdXzZ2kwte
xqAYt/q9T+Ht5MywYjyUFaTHR4Jwb4PgPX4qigtIWBs7Xo8vLu5NZiK5du1a
mTNnDoSrXV3zvsSztb8RnHi6xiC4usR9fiubO+eT0e3yq3lNQVKRfMD8F8gd
6+kg0z0KsWMRkS9OBADBqD2A3gUdysvCDg6yMEi1cGApWRxYUpb6F5a12M+m
dPJgNaUYjTIrgkqoaa3II34XdK0pU7s2khGd2siAwLbSS33/8IAmMq1jLVna
q56s6liUh1hgzSCimL39ivOQCuxgwBAohuZxHAii+m1q7HaR4oq2SXiQbOiE
lDDB8lKjN8CBbhhYPDjm80OLo8ppD5Tt8rLQGa/fej7nT+6Zpvmd34QmF1B/
0g8N6agFUBlO7O/vsxkgBzFGPyowRs8q+vx/rHOVZ6ptscgHzQIYZ/mOqxpI
J6NNfrukBffzfVzRSnHGhvnYVUYztqvGnU2JOxqCsX3ioxpgII3c3n12r3hb
gtQeX6hCiIvApd2QeYNdnQ2aTw8tKg/n15PYjS4GzVGkGXAozhn49Ye1rWVP
t6xy7b8KNv2MOtlh/a1xJVjGN2Gnjxztn0+uTqyIqwKGeweKv5E+6k8QyEEu
fF7fTsWwr8Gw3h4dkI8Cd4t/enl9/bjFMNq9wfDmzZttVhhm9syZM/wq7a8M
Jx6ysRLCP2K/yIauRc0tmvZM/mJD5kL37FiV5emAuQX3/KwDo0qBJu+5gQ5q
jbPRKi/zyy/zOiGpML9jZbti+nlVWeGTW1b7ZJWVPWtISPcqsrqjWnG/bBKs
3E/3c5BBnZylTycv6asfI7o4ydQujWht17qpBfdKrRq3mtHspc9Z65ZMNqh/
wsZrDPfdmFSDqVDwiFLn0zkNoD3l1sRq9PsInC796yDvl7e2sWwEbin4dczw
0gwvwDG0AN4eNJEkJciZbFb5Mmf20krMyDIahLUhyK8Xt+DPfa+iFfCiXwrh
dBRns6rINwRg61zNgZUUhPhraFv2AaLKAHsNbxBLSn8S/DG4FfujQOt39lmB
4Gz4XL7o74J0gaHBq5FelPUeqwilUFWCEaIhxWUgm0n2dM0q50eVlMcLG0jc
pl+RTW0hq/d9jmhHZKNHlCSycfo6eP7r4GbGc2Bl9fZNSHNeBl8inPRrbzvD
iqelBcYlsS0gDekE1gm7fH5Sq18js4/TFd/ejbYwfPfuHVsSTp48abO8iadz
f6N2ypQp1A8/qXVQoftDNnQrodohE4UsuhWCXdNQ3Fo7Xea655YVqiOwzwWa
YH5AGaZ2sYkIWYIFHSqAWf2oREuMPNeqTsVlZQ9DtE7s5iiDurhLr05+8ndn
bxnXqTk7HzAGFuqbS5Z3KsPpHEznslTSoTCXwq8NMI4cwPGpKNrsUbOGmj12
lb1c2BT2Sd//zLbx+8/6DpNeNZvb9fq+NKo8102b9DKPZkVraM8GRQ9n1GNR
KjasXTKCm8GwwGryXi9swtoAR6jVGiNjAEifzWsoRzUCQz4KTaWfV7ZmzV+t
rP6pDWBpcRXap7ONoO743wX46xnrKwBsUgKJuZaHM+oYlhispoflpVF/rAID
1wO2ViHQuz+zpjyYXUdODSrMAOqQBkjXJ1eSd6scwaSitDcQqmK3n83Zq1VM
an4vyicZLWNKU7O6kikIjffBLRmwfdvQ/qewSEpcIVkvjCmD17GRqne/C/uL
yYnt+l7s6pJZbk6H0vUnrQgBN3km5X7o94+uWJlahGTDhg1jSFbHvC/xBK5J
amJzjJDs3r17doG8ryJDsg3dismiduZZLGpjsd/NmA0vx1vsy1rqlpm7XfCY
RX5FmDMI8VTVqqHXCt+8sqCTUtpR/b9fIVnsnVfGdFHf38VT+nb2kcFd3DTE
aiHzujeQ4B7V2beAHECY6oDVvtkMsr0yUgFDT8CmktTAPLZ5cGT672pAjpVS
6Ge2nLPGWezRh6qFrULP850pNdgjiplmVLzeLXO00Yrs7N3JNZmGhABA4I4t
u4pncpKaztYYhRkTZDbxMigqcDpqUBENoFqIbPDkrB91AEdWlU0D0+TE9pPa
TDwYgfZjxTUOMzC4sJJwH8ZNlb8qAOwMPHMbeKrJlwgPea5XAmr/uEiReEbo
gzlCmD5UXSEmkVU9P7KERI8sKZfGlZOLY8tRkCKMuqH43p5eXe7OqiF3Ztag
d3+0oL48XlDfXlVtY7WxL5c3kbehLfnxcU1rWs4Pa9vIgd45mSw70CsH4Kbv
x1lWiueH1Y6KZlr5qDpCjaxhfPVquKeB3359+P6eOCC+juzsmF7erXGkgcXL
7NGXw/kOH5/dtvoRjx8/bgvOaie6zyoG/4YtjnZFkuHNmzcmtsklIf6H7Oxb
RsLaGT3hS90yISDDBrhyKvcQmy10yyaL9CPENbWhBNTrL1Y6wzzSyRL/Ikwa
TO5YV4Z2aif9OrjSjg7t4iKTuzWXJd1rS0iPqkaHjd6uVGpX9qxOxRDcq5be
1pSQLuVkVUBepTe5MeGYX8Jx2L17cvMYa3uWvjBpin2nd6dg7UMTdfyOtFmJ
s0qJt50oynJvai2zPpReBUEZebfUkcNVX0OduX4PGVSI4xfzGhltpgA3h62b
D2YW+bE3i5rJ1dHl6btxaqT1a6E8C12BXpULI0qzV+XVgsbyYXlLzhVA4CKx
BcDB8g8LcLvCBB6i9/bEqtQfmO3GNZeg4OLXghfBzzeCN2dqBPw3cY0h94FW
VuRE1pm/ywav5Jxp3+iVjOXYa1OryDUF+NJ4hVo/YkaXplaIVuDPDi/G5NSp
oUXs5dg/BfTqOfZPfjnUN7f1oX/yntkVnH09svFy2dUlE63wjkDsyFeNoN9D
oRd+78Gc2pJgKAhTMWQi0GeGFeVlZstG6O2JgQVZWMOPeby4AdNp+3uqStvm
Lnu6Z5UT/fLJgf76l3j92DaVawVw+KpWIoMN8pFn+I1yDPDgWxjgsVGeEC+7
BlSUtUo5qmuTPEsA7SSkPIMscc3E3ZwrXNPKBtUxsMezA8rJdJ/SMrCjk/wd
1F76dXST0f71ZbZfGVlKqpGjxV5DZdmuk5JdTVZ2rywhXStIaOdSEhZUWFb5
5ZDV3plkjVd65nbX8SMVy5Nwucgm4b2z+vVPqc7F2Cg6VGEokfgHvgiIkOi/
Pr4SbSBmAj9oFAReUAgA7k9VAiCFEBmUibYauvjVIkPHblWDCzbB0+9sP5vd
QM4NLk4fjp8Hrf0QqfzVbeWR+nPkjTFHcHFkKfb3YzML2sBg0GHIEQQiqMOM
C7q2MbD9eGZdZsdgu6GLwTkMPa4LPA62HBr44siycuqfwrxGEMVBcjyaWU//
DoWMUprqiCvjHVh6OPxPPonsnFGeh/8lB/rlYml2u+rREyoC7syqKfE7NBQ7
EKSePsAQGbt9TWGwC+aXNjjSO4mGZRqE6YMVr/jtHvIDHwpf7DY3uTKxguzu
loWiAULhTUgLRG2KdUb5HN6WVY+3IS3xYswJ7+6aWZ4tbaSXU3G5NqWSJOz1
I9gxY8vwda6MLM01FV8/vEqVSDng4O3Vq1fbWH7y5AmLFxjz/Y1lDPbMmzeP
XxksJzNY7u9AliF9x3FxF0AeJP95luVI71x3FRIeuWWmV3EZFOgoPTv6Sr8g
ZxnesZVMDVRwVcqizWxNYH4GbiFdy0toxxISFpBPAzrzxHccoe2h3hMJBr8s
Eh6UW8I7F5aI7qUkoldFiehbjecgICCIHl6KSyWgN5GUQq1+j/4VEVx9DWnD
EcI3i5pyHOD62Apq3EoQBNQrtyWqm2I4Onp4Sa5SezG/ETMGSLGiRoT2BbTe
oJ55UYM1We/JAO7ZHABcjEEhNC8aCNH3jy5A9hJYrdx6+z3CRS7+W4ag3/yv
koLnzL4Y3GK08dXCRqzHXhlTlg2Lx/rlJawoaQN4dJUf6ZNHoS3ETBrmv/Gz
cbGimofWCwhjo7ScmQb64ugy8np5M6a7ro6vIIcH5JUP25xlR6f0En/UX74f
C5SYyQ56kaaGLZb9vXNpsJaNRvrtqr8MkPdAvvpkYFSW24i7VNFenVRRzv9b
Ur5Hecr1aVVooU+p7QesFNl6HVxQu4/2MmbQ1rXlf/3LRmf1DTjGthBf55PG
h9uD0tGiX9br/MjQShL35aO1nPP9+/eM444ePWpX07wPJTRYWSjm36BdtWoV
bfZPaAsIzujcN6yWLG+fgpBCEeP2P2w/Vo0xyruGjPGtyf6uPkFuMsy/qUz2
cZBpAVXY5rAgsKzM61BJLXMGahC0MeDc4XUeKWUdDtrwz84TScO7FpOIHmUk
AkfH9KshEX/XVOcW0b+2ytHwjvklAlNRvmlodRgsqdWEZUTj1AtzM0qkxl5P
1IKp14Y/i3DHXxweHOPVCjJmVLGG4t6U6nL537KE4YAqARTzLZDRt4NcJM4b
gHVHygseHTOLeAdOqRV9NKuOxBJSDwvSpGjqsqtk8LrZGK6CyuW8CzZfoIeL
TbTuRl8XG2fd2e+VEI4p8HbydklTeaIvjXYbGO2Tej3gv4rQdIt3CjoaOB1Y
s9NDisiTefXl+wYXke0K1U4f1iz29ckpX/d6yftt7SWqayaJP6ZG9XRHkTOd
5UXEX7Jfvx+jkdfL0BZyWjlFp+1hhey2BoHfUS0Dr7t80pPXXMzOgtWzI4uz
1iD7/eXzJmd9alFj15Oy+H2bB2sVYBgtDi+XN6UywEs9XvynGtsskoCMr/J6
f15tY3zFP5UcHlmHqV3rNBksTRgxYoTcvn3broZ5H8Z9cUw8DpT9DVaM9CjX
/CqI/+aU45NbczidYZuXg4z0qSn9A1pJzyBP6dbBV4YGNJNhvn/KPI98XOi2
XoFcrKHcareUsjCgtMzpWFVFch6e/BLerRRPiIG1jPgbQNayJ49J9N9a+JKM
JuG/mfEdPgVNeUihom6PKha4eakGESoSGdkTf+fnZp4HU2vQMMEjv1nUhFOA
8Qg9fw4HJrDf38028IpRg2/qlN8vbcGFP7cnVpGLKl45AKvYIkJCyxeYA6Jx
4Wojt/kYvYebPBCiK6MprBZaDRKrsUcLtvJzSCs2yOpfN8JVhbSt79Bi1exF
TIhwJatfQlvL1THl6Ohjw51oI8nhVk9+jl6bPT2zyZdd+rzTXeRlhKN+nVXi
jwfi0jzZARWKs53lyz4vOTqkIESrvAtvowbRW27O0KizCxZCZpYrGtEx3kJ1
AuIgyicN2cz5K5uoh+3W/+peX37+evVfxBrbQh8trK/BINrwC8glDRLPqZaG
1vikthbMxm5xpalGRheW4O6EihK9wC+dyRm6EYAltspaWELUWqO7Br52Vtkt
Li6OmkB1rl0H3pdNji3sKRNcC0vfACei2KODl/wd0EaGKorIhYW5ppApKmwX
umcza2R2LPrCfi7yL04sl3vnlIigXBIxoB740wgW3GUli+G9K7KaAKQvjq7A
4QP04MIevlNYELEgooFzvzyqDNfwxIa1VXhK0fFeHFGGzl5BS0H+kphCkwxy
oZQb3q8Id478YdQKPaoIWvB0pO+xVuDGhMpsD0zATAv7XdkPmNzCTi3lV7Wa
Z4cWY5YMnd1oaVXMkPNU7JIZ2G0yhgRiRpXS6IORyRYP/H13+MiT+fUZ0ah5
A0Wd9Dd9uqqZHPg7tyScCILmU7LU2Z7uJHKqo1ydU40S+p5G5ZCYCYrI8+Cm
Gj4VpdeGe322rLGaMHfLUyN4UbyS8muEYOdHl4LpSwK+EB/BCurL4CXxmyBb
hlTFeg18b8+swWaX2K1uzNq+ViOLr5+vaMK81nWN4C6tGWZ2gRuHGZiNtnbV
zfsiIiJk3bp1/wstJZCe++fwTUpOQWCwcc6cuTJkUH9iNdC/uYzwqY3ElT18
tXrQyR7FuWxromcZma/x0iolDsYGkwwhnhmVtoKkDF9HdMhDO2cQltqwdOqR
IRm3BWWkh3y+sKXEjCzP8B65xI8rHI3wOA3DB4TbT2fVNZY8rHeXd0uaMbPJ
XieGMwZZqUlbRn6NrjsUfL5vcGXnEhQYPBq6mQ6qJ4WSO9AjO1PhT+c1kFgM
V7GzGrUZs60aNs5UjC8XNWaIA6f+UtWhacFSkrQMNseLb9+ZVs0wXls8SNnz
RQ353r5QoyWnFKVjQby9u6SeHBmUH5wqZsrCqQ40Yi82OMruHlk1Mi8qcTv0
NQ524Pv+Xi3M1ckVZZd6QFii61Mqq2Jrm9iYIYduww0pUYQgylgy4qa/5v4A
+R7pyVQoOmGgAV6HtuTDEzSaQbRz36QbURD0wZn+eeTegeU2zOBEFy1ahJyo
DbO9e/fyvv+BGSJ0JJu+fftmntSemjMMDx48YI0Vxg89WNhfELV7r5yJDGPa
Z65bTiOaMRoDpnoUYdsg1hEjqkFTAMpXKLFiRmGZb14iF+ypRqxDPiBnEJeR
vnSd3rWzUzaJ7JJLTv5TlId8Y70Folr0fiJCRTIc63PgWx9owBGpyHxc1gLS
zw0GJ9xVHk6rSRcMLYa8uykH7Qw7l5TkQRZCY6ntMhqTMtJ9oZrNorqqPLTM
o03u9OCiTLsjd4rZ+WsaFnxc6SjxShNNHlvw0d9k87Q/NHK5Nbkqw3kIAHhP
YxQFIKamyYtd1ZYv+za4heFBFcY3y5uzS//ZmuaAzx4U4j061VluzK0hJ0cW
hYlLbqGoGMYd8ZfzE8rK3u4qOUKaE0Gmz/cHynfF8uGiBnJSLd8WjfPgDJ8t
b8IoGo4UKCb93yjaLJ/ZHIVbvPzZkSVkk8pSqGT2pOwJ4I9EX0vMmNL8sUhO
Ic+FfNuz6EhzZUsSsEVdd+DAAbtq5n1Xrlyxjcj+hiRGD6yjXTxNy4eXUKlI
Y4mK6pAhQ2TBggVy7Ngx9LkYDYZJ5euLO7LZPwO7Asd5lrO3EeogM90LSLBb
WjWR5UloiFsa9lPhzED0VqHgCUJXemSSiE4FgWUqEpqWXnddt5Ky0TetHBta
wTjefm4THlcPSpFTR/4Hp4h8x4J5Y50jQEUEjDTR9zXtjb1N61xoI3FMA5wz
CuVoODEdshoIkFqIChARM4KQ7xHOtkl59Hi8VVYQKRzpm0c+r2rNdSVAEZNK
+B4wPaDOH0jDZKMM+Wh2XSOIgb386a35+YcQR87oRQbCTVex1KCpDlNRGb5Z
3IStTz82upLXT5gy7ZpZ7i9vAEjhiw1gT3eWK9Mry/n/lKYznVIQ2Ix0zwhK
7i7DqZkabP/noO7Z1wAWQO434H2n4u/q5Epqj7NwvuLG1CrydaOzvZkiMpXg
L8AaShC06mvER3nJgwV1Zb+KFqR2duvFgYonMsHIuL4OaUHjeX1KFWZf49XY
wneD2ii1PW/vX8yYKN0zdOhQDnJVNe+DUURBCUe8/gYtTtFCRI2v3ExoUVgF
54iy8TTwvmTJEgKuwboR22SVhPjvsrM3NnD/QdcNe2qVorDafYVbOqXWQWZ5
FCC1EJDoAgz2yior0YQFaj2V2i5FQG1KUpvO8OQ4RFi14nGldk/vQjyA7O0K
JzU9Tlxqgo2qQAmV8jgWa4BuUtpaJH6ww5leBio1pUGwhjNYkIYkKMBHYvyH
4eGTmmYW0vHK6HJsvlRwjVa45GQUUx2XxpRl2yD6Mo1Gj+0++HOaGAP3x3Pq
UjmifRvWF9n7q+MqyPsVLZAcgkrc6k2V6SnPVB7A9UNyvF3azHL9QFLxTcmv
MSx4BNt8tnvJ5zVtZa++5zfn11Q6OxqmVh92vAM0psi5bhKtdjVmYjmRmO6m
uuxgkKz/ibNd5H2kixwckFeO9M/H+FjJs0dQYVf4/1jg44MKscCJlsFXCl9C
pNEEhZAEqf4L48oqkIEEOXarq1xX4Peq+dzTI5vcml1DXoQ0YzoVQ0fbg9LK
qVHFCWzcDk8KTYTb79c46huZhLt4tnbKhSXDmUwqY2JieJQLWgCrmPdhqhvC
EqO0v0E8f/587tXAV86JNCeARX5z+PDhhBiyFfl7DX9SmhAjc3RwTFNu8cIu
Gaueip4r5Owx1DvOs6J+npubC7EIFrkBgAtNOrdDJQn1zMDjWW2mNw1l6L4+
heTchAbcefVgVkNOQwNgnCGOl0CgowGP2eaRjPDCyyPgvje5GtfkJhHGS5AK
yblHCilClOWfza5vyQR7E1/Y3tP/FDJWQW3zNvrg8tsa5dHhgUZ88Am7gnV9
kLAwu8jEv1MTjAb7+A1u5uO95FNYa5UFVeSYBk5RHTOwIwRm+bGaZQ7qqxlO
UPN+eYzR5YJhlB9r24Nde2KclRgj6Y+Zlm/rnXnZXptdzZCsJzrabr/t9ZZH
IU3k9OiSsl1N7XYNeqOV5Tdb2knCSWX8XBcwbUiJFDDSEn8iSC5McWDD9EON
nykl9vjZGVAXTGSh/eTtmlYSPboMk++wsjdUTcft9GJxFur38+b2clZjbjZf
988rj5Y2lB97fCQ2ylP29crB4O0gPlS2PlzRUE7/W4LjAsh1Ij11TV8DEfFm
zySy+5+KilVC5kQBFJpPEEBVNu+DVAWRsNImzFb/NiZg0P6KCZh2vC8VH46D
Y1SJEHaE+pATaCK4e/cui1FpzedfXDVYwlrbYVO8nX0iqbvQLbsscTNO3Vrh
mp6z3dgOZ4znpiXN8zpUlDAPVQ7dy0A9pLBMMqRuJ7UIHTLLxanNZG+fwhxd
xUw2tq1hn8v1CdWZ20H+GjFWMpNq2FjsgkCk9HZxU6KclHa5rKEoVjux8LPN
LxVz3ShsAmzkkWLVvCN1ypFqcyEUZ5bMTtHzw0vQzMIsXlXXjBAJVhpNItDS
ULNImaIpAVfbabVmWMNC3NUkY4r/vgpmrAHE5YBufAw5XJ9QST6GYL1HU5X1
hZg7eDqnnj3lRQ5GZNhn/WBWbe5auzRV3+9zXWmKP+5wlVvza7OeFKVCY1/f
3HJFA/xX29vJk4iWcmpMSd6/v19uuTanunyKcjVMtdpnVRv40xh8Q3moXH4e
8RdTpOc1Kv8Rybw821x87fIaRluZRzR3Z05t7meCkUX5H+OJMMCnhheT52qM
kROVQ0G8PTGkkAqdsnJMb+8sqqtetpDcXlBbYg/583dD1RRJB1Rn8bbt7phO
jk1pl8UUq1akhjZA/dxCOvH0bepfkbYy/KpD7FqbSCMFhbEEbOiCWYcyRukK
eQJ0gCPpmsH8iQ+PrePsLzSqKg17FqXS8ZQtHGE8xaMk+wpXuGc0T32147Au
5rzmBTlwyJxZ+/611IoC6fRGJrRHWU6Jnxlbm8djwVDfnlqHOFtY35hYk1gj
daQoJzephkZGbwhsNZJUWMBrUJ3FWnGuwd9fptpIz6oU7POHpS1YVmQopob5
o2rYmJGlzOHYtDTOSB8lYDPKdqNFzgcZe2QuNebC/V/WYrtGE5J79b8KcmZI
USZ4QDriMzQvQ8JgMPYoK0yZ+DYiucMlhhrfQTezmsXOrFaM7fB7YRXGGUX0
4w4Xua4B3IG/89ASH1Czd21+DXkbpXHAuc4iF7qpyuhm3naVuOMBcj+0kRwb
XkS26usA/ztL6ylSvsQYIlqRTmJTI2ZSdXBBEvsGjSj7A5MR7NyG4YYxV6n9
Rg33br1+YZTfbVCDeFDvPwjloY85ECCXJzog3SFvN7fjT0YuF2rjygwVDme7
yfPVLVQiZ5Io/SsADEizg90yycWwgVkTxXnQuTt27LAZaMBtnTD7G81Q07Dd
aIv5y1QbODLp+vXrlMww3qAZ87lol1HhYlw6WeTd/QvcoxGu2h59L2NNtYHT
Oue45+Phsss1kMNJHr+OnqeU+YHlWAJgul9JTkaSU/zUy97p9O9ZTi7N+Evf
thKYoeYqgDZcu2KS3M7YOonaUwpTM8NAY9cE9hyoZUtOitPZNPNLtd1oEcQA
FyI+/P2Q7QIpIAazeyDxy5o2SqvyiZfc4MKaDz/WO6s6j2iv/lg/5begQuI3
ufHbsRHt5ds6HBrcUh7Pqye3plaVC6NKy8mBhbjVCj8CfwVcgyjN8hwF1z/4
OaBGGRVfb/ROTuj29s4hJ0YVk1tL68qHPXoRnQes3QFpMpCL6/N8F+OuaJXE
u93k+gKVVX1zyW41d0hYPFvXUuKO+FmKw0igQYHg85Md5eaCWjSvd+fgHDM1
wsmJrV7+hzoyu3Z1qlJ0pIM9GEVK4lCgPFhUTyKVwm/7feTarGpqclVzn+0q
0WqGo8eXNZSQqvjL0yrxTeI8mXokkHpv/zLsZSJ7L168oCXFEXGVzPsST9P+
hirKApAe6GNp/pswRhoCGTIYX+xDvHjxIgLE7HxYOo3u4iWqX1n2ASApa5VV
0cQyy8M4iGa+V0GZ5lvOKAe4/mHHww71D7EwoBRPO4joUwl4JjdJXeefTfb0
zCcXp7WQ6EmNZLNvOrn2XzVEdtx0ZZF6a3Jt5mtQ7v9JqiGQ0e+BttHrYx2Q
uDWNbnYbrjC8CWudWW2NDEpnbNtQZlAtDVVVhF4TtA5AMiBxtUcDEayYOIzG
pD652DmPctE+jcD3ds+aEg+0y8O7YFfRKoJuOXxuvQTc7RZVL8jVb/FNyR9n
HY2DHwk815mB/PmJZeVJeEv5dsRXYo/5S8JZZepSD5GL3Q17Gt0VTJ3vktSC
NbqrAasa3beRznJxRiWJ6pZFYcrMNNrbraY8PtvFVlAAuG+3OWkAkoPZgq+o
He0LsDPMaw5mEo4PKig3ZqoMPxxkmFI1qe8i2tBUvtrQWhIUSFxLj0MaM7S8
OrOKnBpZTDWOvv6xDhJ/JFA1jFE6xkgtnM/zS/vtspvkIczCFCJcfsVENFoj
s7+Bij0G1lhMY1MhQAhDCUD0WlEcRO+mTZvk5s2bFL25+djMcmpeoIS2NQzm
VJ7sVY553blcPZeKg1hTfStw3Rx3HKpMQOS02L8o1x5H9KkMUpNaNtUUvDip
GKSC2EMDy8JNK3E/SYVaQCyFrAE69lOS1KK0qW8WN2Nt6/nc+kaJIdEa9C/B
juwBOKMueo/l+lWpoTV0k1qyq1MrycWJ5eW4+scoVXGbFSuEysaxGCkZxRwb
WEBixpaWe/PryNPljeRVmAra8DbyaYOTfFzfTj6sb8uv34e3tpd361onlXdr
W9nlw6fyIaKtfNqoj9PHPtNw/ML4csw74WdzPkRxBl3bOqSV+6sby42ldeTM
f6Vlv8qAnV0ySlR3HGGXT9VsCfU3leXxmmbyQU3pNzWb8ac7GLIASF9IhDRo
hnSIMYiOOxGol0ILmyI+YCrij1FupiLuTKrjjvrLuf/KcB00ymKM6DTKS/L/
ollFwZdtrvz/3F5YR6VHV3m1vpXs0q/jDvgyN313cV05OqgASZajQUz/XZ5W
mVLp9MCCEtm9AHsEc5h4YkzRGpKtYN4H8YocBcK632iGNbaOm/3zN70LemGS
cXFYFVrk7KB385k039o5W7D3DyEaWmNxNh0PRlbBu8I9s0xRkqf4VpRFnrkN
5+iagrfLfPLKGs80KgeqgGaj6p/KqL72LEete3p0TaW5ucbNTXne0eUxGNRz
sikFhHQ4Kwi7Da6Pq0iqU5nHUqDP9NGMurzm3y1piioG7TDy5vDFe1UmXBxb
Vp4ubiixG5D93Omjeh9K4b6GGXJMTccBtXn7fOX7bi/5sLGthiZN5c68WnJp
koOcGlZEDqnKi+yUQXYhRFKzfGRAfjkzorhcnVJJHiysR3i/bnXVUMjTMFuH
9Q081MEIbQ4G8f4XK5sxyXpQNfBuBfWIvtEI3SERDim0b7e3px6F+Xq2pZXI
rT4ilxXWi13l+5kO8m6vqzxe30KuLqghZ8aXkoMD88l2DYEAPZ5zZGhBQn8/
pBFN8tfDvomg7/FTG5sXgE0bDzO08SFq4/qqjX0MjXG+m9xb0YBZj0QJZiOL
kYZpOcxt3ZxVnf/dhP1+tOrnx5cxEn/K8ylVPGdGl7Qzys2p5HFoY/4pybZp
rff2ys4jbvZ3xWmeDdA3I9aaZGuA0cG8z1p4oHLjd7ahbq0xmnqmpMCOD0v9
wkIPGjSI6hdVDlW/hUysX18/JiFI/rqkso4C594DfA4pAaSBNhaA49RkxHDA
eoV3dnZkQeUaDS4G1qbwRQfh4YGlaaSB9rFhlViAe7mklc1YA2uc2IEWtHtT
aqBl1JxWSUtZgXgu3lzXjqkVZA5QLEe3IXKgt6ZVlbehf0nCNuR9I32RvNjh
zbysfiWPVLnu079v/F4fIi77/YxbBCsq/2iXcGt+D/h/2txenoc2k9tzgX8F
jdQ1jNNwC/hDXqJf+aCqklOqKC9NcJCbM6uzGWq3yo6d+hh9v/V9biLvNrel
jNyleN5b8edPNaBYXZxWUU7/V0rkSg978I02/kvdDNqvKqnXev4k/6xFfkuS
j6cdHJiX5EcqMvv65WQPTMzUCnJneX15u7M9yf9xMsgg/VpvKpmPez3kxqJa
+vjEirqF/DgRJJ/3esrRYYXpuj5vdCba7D/c56+I55e78/T3O9JRLmlMd+if
vBJ/NID5wbgDPlTPL9b9ZSCv4uSdxnsQK3JEf/6JTvJmfRu+u4hyN6gCO7/y
bxviCPCs+UaHRPfBpN+6dctC3Fr3gS5aYI75mzom4qiJWKoZTwPmUM3R0dFI
bxQ1rXzsx1eyvnMhme1qDG+hDoKVoqjYmRoEB974OqjIwP67MPdURHylZ0ZZ
65Xe7ONCXPHTdK/1z67OK7dcnNJMLkzVD73d3iELt2q+DXb6P4wj5/5oRp1E
JwqltzGOW/Q+YGYGLf7InkHDYsMmsmloNcKAk+wNhPVODsIR0G1xZ5/+w6UN
lOXAlIAYqWUi7v8T8cOBBvKKOC6FL9tc5OWqFvq0P+XK5IqUMDs7ZWQEBJcc
f1ifezxInoQ2Vewzyql/S8iX/V5GMs0Ss2qp3+9wVpecWWJPBYLfFES56v8b
5XMd5P1+Dxrxa4ry+anl5cA/QDk9jfge1cVH1YjHTDFQfhflQiP9XVFGQHh1
XnXZ0yub6uys+seuIO/UYVydU5VX3v35dc1iSQCRRWD3eFlD5ui+7fOmkviq
t1AT+1Q/M7BDZ4beIqmCnNyPg2odTnaWs2NKse7AzYAaZt3dt9QUtL8ON1rI
Yo3S6dOnTdR+QTbx7E1NE1l04qD3EFk1aGdgq1cAWydUO5fkwzKy+jET0+Y4
q4kdN3/IMo/MNmuMWwR5OBcHOxJgmbGdea1PRonoV93easCBZO4MD5eByTTk
iWGNcTAohk6f4XSY5W0NWHPwIGEURbA6HYNU5vwKNQa6Jd4ubk79caC7pS2y
ypXx5eXVsiaSsMXdsLw7vbnPAsXmB3PqmLOm3ohzthtDfL5ya2o1tpvKAb+M
pDa9Qa1ajXjVIWdHlZBjatW+7nbnWwfaPmx35gjAvr45mQsgiWc6JWF+Nhkb
VePVxu7Xbz/Z0BL0IV2iRDr8XyKv9CCR8dGd5dMhLz7+1rK6cn5KeTkyTLV9
jywkEsb1uBrKGLXXSEdcUdqgryEJYHSPDS1E+YIJmx9qMI+rRj0/phQbZZ+v
aS5P17RgdAYjiZ5gNE+82djGLK50kC9R7tS/33Z7Stx+X8qrTRpTbNYrfL1n
Snlz6zR2FNk6a6xhxfLmfVhMFxkZ+b/IQ6AHshCNVTUfgHIFyhIoT6ABBzIZ
FO7fv58aGOmIMnxsHrmxbZpGbvYarRmJHlpN7yKwkbzFAnuUKYAllh0gcgOC
63wymB2vNU2BW14Fbkq1IdVtAhcMYnUiNmZruKZvHuDLQPjQCIHGELQeooyM
c9nQ+YI+ewSzx/Tivj6pkrxbiW4Xd8vdcx+QByf2veVNcHOWxVARTdjB/uak
fFAyfls1MOedX4Q1g4lko5Qf6jRqLmEaD2nEc2Z0CflxOIDw/TjoK5c18oMt
gcD8Dvd3rmtyqzBwvmtih56VzOlVfLnbr7wpgwkxneWj8vZc5e3t4PoSM72i
nPi3mOxVywfe4NCRnkCshz4DZNcwUwhXgMwLZCr04k61VqhevNjYitYTtUhI
6i/KEVJh3/Z60VJ+2uEqj4IbkasDfTCckZHnsMV9fpfX5ARa0Aqhypn3wRpZ
M7C/YYWwCL4WX1UyDVriZhq8FJKsSAyYzTSGmUwjb++c41maq53NPIzSslyj
plC3NCQJRC3wzI8zZPTH4eTD9Mb4qm8mgya2ElaXdd7p5WD/Er/QdHp0LZ4U
h7PWlSIjakpPoNifwOipPqf4cPAfumvQvIxG+AezazN1T8tlwJTCxpKXfFnX
Vg73zcPB5G8bOGyfNJEduzwOZyHnh3tNnwijtxFtKBSvzarKNwTqCKIQb94B
DQDebneyvGkKy36ZDjWqmzrU03SoEErKUiHDdl0xWbr6k6UvR33lVaSTPFzb
VK7Ory6HhxagM8dxbeAItiR6Unl5FtFSvqsnRRj0clNrPiZSWYiZWJ4hWIJ6
wu/q/ZBZehXRSk4ML8I8BxoEz6kw3D+yAWSFLS6B0UBcUjYRRNb06W/ArF69
WtavX8+vHBKJNsQqSOZbog0xCpyoijaDq9IceYrqW1qWOadWUDJyPwXOzpqL
0958y9MDzvcqICHuaWWFh7EpwAAmswGLur61/jn1us1liDR+GMDs6p6XR0to
jE1KINLwOdZcP5rTmCdb7uXxf+nZ1428NszS3ek1JE7tB957jE3INs/UFi0K
ULxapAv/lqKlMmbGfJMksjxfwp0o5d5vaAtiAIsio7HkoQB5GtyYwvn2QhXb
Z7rIl13uGkuW5kDw/ZUNTXfXGX/f/+vvNv5Ff5eXvOT/6e/Ai37EnQlSm9Na
TmvYHKUWKkpF28HB+dR3pZCdXTPKq81tjHQncjvRXeXU6OL0b2jC/xzlRh6i
J5RjJRUVdwhF5L+erGxsjLyNLSUXVg22ELH2ligqNkSQGbTmM39DZPr06bbz
VcomEkmgCi8DkQQRhZKk2SZitP0ll+hlvSRUYZ/vmY85RGChWt5elZGDXVFq
o8VeeWWeT1Fjd5TSEe6fTSIG1JV1XXDsWTo5/18DEmGRcXZcXe5AfTyvKc8Y
e7HYUe5Mq6cyvCz3RoMIbBhB4wTaLNGChMWJ+3vk4PwG8oDYb4Q1ct8w3LDV
wyBluzp0kJIC0JAWwLRTpYQhknwpkuwt4xLlK9EjS8kZDCgcCkxtkQKRpHL+
Jt4B9RYYjYCGvbOojmzT3+yMvhOGVO8CukwH1U1i1AqcnVgGlNiMSiJIElQM
vd/nzoTi0eGFZFfPLLJXtdY5FURPNmtEcKW7XFlYU85OLisvopwI0Jtt+p+L
7sZ2D2iy+8ENqc9eb2gtsWpM0NR8Z3FdOTGiCNPiJ4YVkdcaKe5RyNHm+TRm
D0fELFmNxMaJEydMBWJ0zIEYDEiaxBidReQLIlwlUalE0gYFQDR1YLgH0gaV
b3wNaQPsDAGeTJ6dj1QS/mAPERrg5nkVZvBXwa6UzPIuyfzGbN/SMtO/vEqb
5AY1gbkkvE9VWe+dhttxEzufS9NbsvUC+5fgZXDaB0/WDUjLgi7LcKvb2Lp9
bC0T24wuncdz65Eey/NjBSbqHtcmVpKPqxwlATKHBGEhlydMzVaslDekTrPf
pY6pwX3k4+rWskOtzZdtzuDGiA6TG7m+A35yeXIFGvxPka7yMVJDc72yMRLx
U1pDP9t8E6KtSPVNSEjAN2UjRgUMjOCb1C/he293u8jluVUZ2W1TuPfrLbB6
u1//F1cVtxu9RW73kTj1X3i9p1tbidz/Wx5uaEHf91npfa+RH/CJPeQn+9Xe
PFI7g7Lcm01tmU+Bnl7dDhbkSXBj/Z0jO6SRQ8Oryfdvn9FfJNYCRWsirLR5
HxoerPHFX5GyMmvPnz8v/pusQTrhf8iauiZNcZ/eyPZeJWSlc3JZ6ZZOZUw2
0lRRoymc3rdCY7bpAZVkun9FWa4SJ5w05aSsOdS/pCrKlqQJ9YwzY+vIwQGl
efo8TpRHVez0oCIapP1JO0N6tvuwz5y7MKFdzR1XaLw5PbgID1TCeVqIzqBy
Mf5wSVXKO3VH8ZvdfiEpKUlKYwodbBLNzcLxN3q4nySd1LgmelwZWB6YL8Uo
NRMMCNVOjygqhwbkYXh2cVIFak2q5GOBkDgZErsrtRQg7ukmR7qrTERIH3Gp
6093pRh9O+lPl3Z6XEm1NFkZjp1Sdf0gvJl8PKK/1jXF7WYfRakX7KW+Unb9
urc80dfd1Tub/LjYReR6T2J2a2V95qzOjCtttL3HdKdruzmvphFZnurMPAfW
y8H9JqgrvjGruqxXSX0h9J/CJjmQK/BDGOQqZd6HhhvkozBf+CtN1p4C9VRF
EmketE9aIvm35l2jHFFAzizoJEvaJWdiiufa+JRXp1ZOwlxTygLvwkqRQdJc
3+KGR3NNylDq9NjarIRFdcurUUJGzkhhOhBxPMQISIDXQgsWxpHRqPJ1bTvD
FoGobXQ9WzyNDYAZbYbqQ2grFv6NpQRZ5IS6NiCCtBNeEHPOb1Y0kx+bXBOj
ZW+RlVgUdcpgiSK6O8x6Yv44LtIDRgmQGGQhDtvuKkcG5GUc9mDFn4yo0eP3
fqez1QCQKbF7m+xgubf0NqgSaSB1bx/2e8hNjfGPjyqi7i1rIvfmKN+jOwEm
o+RwvRd+EwOq673k2KiicmN5XcJE8G7o693rJxdmV6bOfhDSSH9WLzZFQk8b
idAOknA0kDHZXkyzHusgF1U/rWr3hzyL2VXEBAgL5K0RLgsqSGvM1xjUGFAx
x0+7M23aNLtCiSSS1UkLQ/ebRDLKtcXkyZnNbA5A2zcU8hzvYlTQ2Kk5w99B
PyqSKnwOz4fHQP9gDhWjBtfGlJNnc+pJLA41X+/OjiuMUcVpMIRZJyzEO/GP
sZUEbU5o1MP30YWHcQKMEZiEWZ7Pzt6CzFwxiX5WiB28BspS2C3yaH59iVbw
4N1QwUJP7JMF9Y2VkzuZUbKnEUtlaKkZNcyEU21LS7Fx4Nq0ysiBghOFKxXh
+rilvRzUIP/kyGJsGEUo9DC0sU1iZ/nN7UHtWG4vdWK8LLd3rqPp9qrR7e1Q
0A8ovDeWwe2pyb1iuj21UYojTKjilYN4fTjizXLuh8P6p7il37/TV2KjOxKv
HTjGWAOPo4MLSMLZLnJLQwMW+82uFExFoCC42S+l3JxTQ04MKSDbuheVH+oG
iyQyUtb8lsVY4jHBXxlDZgiqPV8iWYUGV5wpCzIhqzB6gwyBJaua8bEZJFYd
4abOBWSuh3Ec3FKPbKyKLvHKLdMCKsssv7KyyDsfD5nHNicU6DHr93ZxUx6e
44mEAgryZrvI09n12IiP1iRjQtjotcPX74JbqCivbnSaqiXCOw9rhPYkNEZ/
WPmXfFvX/qd5S9SlCuC+rGkr1ydU5HpcRPc4L+pbhJO8WNqYO6EwmwKhD8f3
cG4d+Rre7meCACvzgpuzvTjmX5VdkcYCUwREP3Z7w5TZE7aUhO3l6hYS2TmD
7FJts1NvUb83k+nZbL6xE5NK4PCZ6RuT/+4br/70jU/hGzWU263h2f/1jT1t
vjGNZcbUrF1dXEuO/6v+724/+X6pi9wMri+7emWXoyOL8PPIbpnk+OhiKkFK
ykM1aegwROYCnU+QW9uC0rLpdY8+Z5NnCjm3rFcxEyeUGa15rJKJ8kTWCpNf
EcO9+/fvNzPqKW0FeCBlNZwi6kNE+OLFC0c+TCOGOb4yzzkLTxdG5ggOEmHd
Ek8MpKaU1Z7pZGVgQS5XRXYJRztguBQtIN9XO7Epyd7sB01Y58Ji+bMFDWBB
kmCRJ/7U5vi51dD5eRV2qdZj6zKGowAZCjPYy4N1Iq+WGD40fiM3Rmz3gfbc
4cs+Omh+nOm6q3MWuT6pspEz0EjQAKwEO/ZRDMUS8fuzaslXVV/ct6iPQ3Mo
jp3A54gD7s6vbVYp/ZgpeLy8oWzyScF4Ab11L9Y7Go2cZzrlsHziua58J02f
mOQXo/XTJ3486Cm3VzSQ4yMNn7i7VzY5N7mc6RM7/+ITUxOm3IYPNPMKMGDf
VWzt1fDv0YaW8mB9C9mjfvXwsELyfKf+0W/3lQfrmskxBS9eBdnJcSVYfYlS
0NEIiqkXzM2gfI806qPQRqy8PIuOKp4oCgQS6MgvYd6HISh4O6SgfsKFviQo
KzTo5zDhsvo/Ye1QpoGEgzU0+z/b8GGZ5dGpjTS0OL463ExNojt5lXdmCQ4q
Jku7VZXlncqqsbW3rXy/+V8V7pnFu/hoRm1JwCpeUJZELo0srUKrIGDiHKc7
YlqMBwMufOjnaLp8vawpp5Qh27FvxuqZR7cxAPqk2us7zvmI9KflsgJF1G0A
ZSxcYZQf8wnvQ/+SG5MqcVLP6JfPTfA+hDlyGB4dcrBW+3rn/CWJgCmfzb6p
2OIDfS5nuyDtqBRlY7kalRakiFC8s6Uh1Rb9MH3elXmmz1Prd2BgPrm5vJ68
O+hh4AF01J/R7wGlG71xodzsDUJho27ZPuzBCtwOHn6rj/FwNXcJl7tJvJrA
H3qLRARKybuUUjR/PEWTCLKheHkl7eykshI9o6LhQi901sgT+w/tObX3ebeH
nPq3OFUaSDs7prjs7FtW4r68t2GVeLrJwi9xU/FP1Kx0xaNHj+yymqhZ/Zto
l7P6N4Ed5FhsbKwTH5ZTQ9RPsmdQZS7ixc79NR4piRYWPy/tVk2W6MfKgILE
cKNXSqb9Ma6GJVnYrIzxZciylwsacRXDu8VNmaD8xjM4PNIQt2K/2LL4jRrg
hzpyVyecGxpYMRCPHkusTcJZ9MhkwZa9XNJY0S3CveNYkvhRbSDllIkZvr41
pQqjSqxw4mupakNuFAVulJQvTnRgBHt6TEnD013ogUQRbMf5rsjCRHeThFMd
GckjFIxTlJ5taS3n1fLsVZ0PlwZLcSe0obzZ6yZx5zvK95jO8u1skHw+4S+f
jvnKh0Ne8nqPi7za5SzPtrZW69NC7q9tIrdXNpDrS+vIlQU15MLMSlT4p/8r
TRV/dGRhtUwF5dDg/HJwUD7FNa+RpeiYnpnQ+2ubKmvdDJ5YuTEsHR53J6yh
EQEoWy92tmOe5s7ierS7cIlP1zSXS9MqqvX6Qx4cXWuTWmgChsTHPLzlL62J
uadPnyZi6v79+2RKTZZdRlN+QbyhtRjyy5L5v5WL7Vz5WE5I41gzWeydn3Zq
ecfSClU1/ahC+4WdtshkRXbNpd4jjf6PU/FU+Ph1GIlowz0eW3xScRMdDvkE
ZPemV7fGHbZ4pCVaWQxLhqQmlh7QmrlLrLovBAPXJ1Sg6wISrNbp5xfVUl0Z
W55uDT25WFX1Ut2gbKNH3uljhokowtxTRBFhhrv9QYO8QeNRGFx0rKDGdmFq
BbVLMZOx+wwxH9oALup9SeXS9EoqPvAYJB9QSNupigaWC/9pBGowHbBQx/8t
JsfU4QGBff1zayCYk44PnQxISMGSoRi3u3c2BomHVVUfUYcGhM5MKG2YmWkV
5MKsynJ1QU0NKuvJnZA/5V5YI3mwthmRBs4v1QE+396O0cNjqLrbfY1kRQYj
J69Uw5K9iHQiVV/OBMiu3tllo74HIOpF+F+s850dW0q2+CaVw+NbSnzcN5Os
n+M+oaGh+LyoCZc1waY+MhFcOCsS3Y0i1qk4v3Y+Qr4BLggvwGZ1PnqaVuvk
LE+uS8ShCzgnb2nXyobF0tvVXhllvU9anvSxq0c+2d0tDw9xxqFgsauc9cNF
NX4LbvKM5D7YNJyD+bHJjcFhwkY3Wi2kNT1RwgBTO3x42jA+T9DH4YSiByqT
6Ml65WDfNwp4YARtGtDw0OAJyiUyEUib3ppSlcEkrONe5ceSTFsD08i58WXk
snJycUqF9IDILj8+VZQUHxW8l6dXpj7BQxDTnxxVjJNhaP8PcbTjHB+nCn1T
ytaA1EQUL41fh/rALxVxw307FUXgdm1xbSaoXu9yUREfILEaUMbHdLE3m8Au
d0dwesV0sKaTNXRWL+osI4DsAxV9o7c9JVk245tqrgAR2H2vZtFmvvRJMJU7
VGx9PRPI+1Gjhum6pNElGN6GVaL6H0HT7cH++eRZzB5b/h35T5ip3bt320wX
UurIQ+CrFDa6MKiOvkKxNZAbvYcwUXCBSJJh9h244tnqKn35sPTy4eElCQ/I
zg4XVLFxWN2SbtVlWafyEu6ZiqfaA6yjwyrKzo7ZZH/fIpjxs5evoTi+4FuY
ccbFywVNuNkVvYFYyoaT2NQ1cXAqDcS7/l5IxaMwgxOskcHCuAHSYyiyWzuC
lSV72dcju14kqGsdH1JYrs+oKu9QrzvSQWLGl+X9BzU42q0IPmBeuot6tO4U
TslRuUMNC/ed7coOfaSn+P0LPVnX+6GB3odIV3myqhkZOz68iG1CBgHdEQ32
weL9FX9yyPbVhlbMhSPbt8ErGW0CmMPbfWV+dbmrXhL5dqNsk1U/stGsHR1R
WKKnV6RHfKPMfVYU4GnJFQPE3gZXV3uSwdRkMLPe34fP2d0nu3yD6DOEm5qy
NrJfXxcYXVtaW/aorYJ5fYpYQW3ZFv2dDqt5vbuwupxdEGj1EsB9QatjMsay
UegtQKbqV4rg2Kwd8SlMiuAqYbsgqqxKMYgyh2ICzdTDlYgxnCTB8Z1r3FPJ
8s7lZHlQcVnvm54neESpSYqe1Jg+78y/1Tg/cH1sRaBjZ6CUQlHCFIsTBRaU
0YsljZhvejS3jsLzaG5d/RXhnu7NrIEPfa/xb3ved2d6Nbk5uYrcVGUEdXR7
alW5N6OG3J5WjQlSmCpr2yvex21qgr4h63kEfe4djCY9/fz1OkfmCr7t8pAH
qqT29MzOv+kz9QXsGTrTxbhFoup055+cqQr5fliV0S53DdLV9C2ozcQWxgNR
w0VfKmIsJMCvz60uj1c1lU9RbpJwPMhoT8BrKaNf9npxOgVBwW5l6faSumyL
RvPouQll1XSmlQszKjHhRX5ULX0+4iMvtrclhxdnVaGtgzvd2UWDmb45VG0V
kFPjSrEG9GSjo3zSx8edNYOJXzm0I4jJCGImGj/Er/C7qD/K7X6sQZ7W+yDB
dulF8TCiOf1rnIL6Oqo9/7BvN7aWw4MKy+tbZ22NUogYrbEXKzOG2Zbly5f/
RmGnTp1Il+Fkf2ZaLQkGOwb/Cq+JyFIlWEc+TEOkLx+4ohVnxYX4ZJcw7ywS
7JdPtnTKLVu7F1EKc3MKMLJLTtnfp5CcH1eHx7zDUSp9BojJaM+wVjrcNam8
DW6OdDlLNMouTnjIaCShkAGFLt/lz1vkD+6oWjs+ID+XwIA2iK3HyxuxmQ7U
XZlSCZQlYetBXkk4GMBm9PuQsSe7SPx+P7m7oA4LOIcH5peXG9vIDwXk635v
GqL7KxrSMOF7gGqHymaEVsiiwmE+CG4orze1kbhDfsZcngWsMWNqj6w48kPK
2ieNxtC3cFjZwFjWw7DGDD5R/3u/y419Km92tJdDAwvI1qB0cnVhrZ/MmXkH
q7MUpesvx/3lVWR7uasq/cLMynJidHHaQiRi9yiD+wfklpNjSzAqQPfpx8Pe
8u10kD632/+whZRo8Ze6U/nFIKC8+7cGJCXl/DQHqsJHSh1MJCYOEvQSQK73
iF6mt+dVldMLOttGUZDHt3qrrEIShq3gDxNTl1a6d++OcIAJMqtLDyIfe4tQ
6UZJGwTeu3cPxHU17d79w2HsUF0aVFJtn9oY1+SyTUnb2r2ojbZjwyszn39l
WjP9mxeVI73zwG2adi85JRq2SMMFQi5BQmmkl5kFnMxGrwKA0w9kSO/Prk0F
BiV3QIM/JMZQbkTb45etLiLHO7On+PCAfCx9PA9rbg5dKnQ51Np1VA9Rl/Wc
hINGGgIDKLF7vOWCxo3ocENfqFXlhWdEzI5GAsRYn0HH8SATrs4GYMYAKLyv
EpaFX3/e48FmBKQ18HroWonHwGh0V6q5yzOrGOtYNBZFPQmDICg17lT4kbEy
FRjU1qVucFxW96hFntlB+vWERV4juTKvulq6koxfofpgBfcPyEPyri6sodgY
5OE5oFbu9GOWDY9BqQCxKNT/pdlVmANBuvauBhagGsry5txqGr+Wk/ePr1uj
e+iuQl4enZuFzPug6cEMqkoWYSll8ODBtGvoxQKTsGPwquhEVh/d07Rh8T/i
5ND4Fmz7XGVu3Y3sX0m29SimQVVOuTCthQZeTXhS0elRVeWqUoUumuvjKsFw
WTYMa8qxeARjwUhvorMlA4lKZxJl5NKRFn08v77GhIWZtUJ26+bkypy159hn
39zydGUTOIYD/shLHQqSGyrITo8oJo/VHqFiG7vLy3Cg5lBH3G4vtj28UmfK
QZtDAQZmJzoTPdiu99vby48jAT+dH8c0aadgaxWj7DaM4DhvLlLxrvhBK79U
/8Lxz/Nd5fHqphovZpAf1iYUNFDFdOPXNxfX0T9TajmkVgSxILX6lR4pSFS+
X4m63svWIwo7B732MLy5XFtUU06NL0UyQBTIQubrxJjicklpgP7bEpBK1nsm
lyOq/+Ivd1O7FsDw9/7qJkZnvf6JLkwsLZfCR9tGk60GrS1bttiwQQcE5D5m
iyxskklAQAC7joENjp1CM05fM+Pw7l6MrPdKIyFemblWfEfvUrKtJ8ppOZST
5uxq2Kt6HUMSN2Y7ytnRNbky+zX9XXuqLdyiIxO1aqQ+v+MIrm2e6G7Zyu4G
swMBnQvPFjWUs8OKM+MKhXZ5bDl5h+EftVgI9lC0QddiXJQXQLEzBr1TcIb2
waL6hAmAnB9TWo4PLiQJh7hOVu1SUqqwc2rCzvxbEp/bgxpUZpSf56uaU0gl
YKOT8pGBfKSnCYo96MOyNAJF8AIHdmxYYWOg8owxLIlByf+vrvMAr7JK+vil
l4Coi+6qsNa1IejaUFRApUlRUZp0CHUVUdS1LOpawL4qtrUjKh2klwAhoYQS
EkILvQoBQodAgJDMN78551xesn4+T7zcN3nbmT5n5j+gfu9VR155oyQHifUy
Xbt73twO6lvVNM1Hpup4Whdnj9QJSjBe+XOkdj3CK3qsYHkv66jImdBM1mt8
mYWBerqqDLf25pJycHYb0yR7pzxi2mjJW9dZKiTtpWqyUP3g/MN748gKuNqh
syHU0IQQkGacc8M98qS49M/b0YtBJrVpTPg7ExIvUj641vwc+IDmmKVv3K3e
d3mlz/2y/tNmqpOvCpbI+ACnZ+1bt8iCZy41SOF1TAecjssz2UZoTnVWCFKT
6abslk1hGnSX/esa2f11fZeTSuoih4Y9ZLqDPsX9I5q6rZO5XVHlyg5VrRE1
95fGap0uksLkLlKgpod/b2GbRc2T6RHVJ0cnPmaOc/6Mdk5/oEcWdLfj+EgF
8/FzVMJgB6vKNHYAO2PlBzebddn6fT2L2Q5Pa2W5z5JWVeVKxtOVFsvfr8Xf
lTaWKG+H0R5HZ7WTRa9do1xzvmWYzPVZ9/T5xg3nn03Db3QNkttHNjLbla5e
Nu1dm4bWtW2+NV/eqe7KxcZ8bN/N6XehbJn9bUCfw3tlP4RiqEBw8kChlaVs
XAnwH2ls2GPYsGGWohzgPRhzel+8TYa2r2rQcJP6Xqkh6p9lxUeN9XVXfNhI
JYWG1rSXb5L1Q5rLmo8aRQ1G3P1gJ3jPF3UNWCJvRAsEv0xxF0Q/84a3sCE9
jMuhnoRkoUZocpqtEJs20sWMCtUEtC5lf3SrFILrnAqKiaP/3K7W5IeNOD2z
vfWcHBzbwmh9ZEJLF5R5WzJXg/L1NDDTI+vtyMmk9oaddiqlE/SvHKd/L4vt
rRmPXYbMvlYDxZ6v33WABZX+ZYzQOaMaW8+2Nx0cPcsE6pXsNVzYi4yyO0Y1
CvXf5wUmyHbqgE5ZiJw84FLZO1EtU3Y/2T2+mevL0qgo5cXLzPmfp2ZjUpey
Mvdft8vpE0cDbibpGIJqXNTL/TGGtYWuEs8EARCTAjqaTojo16xZ45igjOSu
niujOlaxPbPxXc+HATzxq5gVmPv8dbq8VWXdJw/pcjZVLVvbLAGzHWGA48Me
NRDVff9VDf/y1W5+zFSbGaocUPUclwEnlNrasPPAhheFtLaDeraG3/6e+B2r
suCffzWSG0DNXIBB4pwAPi4l2Xn4rlBdqU/LOuBiBcmdnfZQ4wDwWNxp9ZyA
p0HjWN6MtnBCJeOEip4TusuigVdLxqAbba8Dqq7/8i51CCpYhaNSPM4MaiMo
zsdoQ3TVAChbxwzU16b3lC1D61swM18jjogvUdGY4QKnEdQu4F2CB4CfsP6b
OnImExgLICw0vNN/U6ZL+npc+9LGEPNfrm5TgXcsHBmHJw8uJenfUNAdHYrm
OaK05wicAvZnyedoZPKsP5w17HnLyFAIMq33n0sZM1wlme/Ul4mdE2TFO3WN
GdYpM8x5+gozBTDCSf1xE0Wul5MjHrVcMdVloaIH0d799f3WuDHDRsVcbHsO
R+iNnHxWTZgt0H/DFGx5ARK6XV0Ag9uyUtg4A5xR9xHoUeo0XKOk6w9Oe+kK
8wgsP6NMgKkArGjPL418zqa7nFEGAVpx37gWmP+E4gzwKgxwg2MA9TBPqsYg
+7zui9pQuUywBkpkNuuXDb6Rw+WjDoIakVNp3STrg1rKOgnqDN5oiTxZ7xwE
50yWs5DkjBJ53Xf3yBSNzJa/X1NOLlYuXfMUQrSyL9cj2F3XX/Yoj8EAjI7a
/vMD1pg2b1ATKSw4GWcCDD9MQC1QYAL2zMMegmeCMp7ae/bssVCVSv6cnJxn
7PBf5dSxAzJzQE1zR6Yk/skCB+UDbIOphel9L9E48XpzCNZ+0kRtQ0OzDWyt
sy218Z07DC+O8tYN79xixRB7v28gy1+7znaXaItaM6imHIBDPMVV9EuGMnsr
GHqC3J0V69DJfRwxV78vwTigghSpbTBcwR/v9ygVrm32+JTWZhByXPCxsIcK
44rBNWWJynSgPkXUdFXtBItlWe+KRv2EiPhfZdQvhPqEqEpPNhgwx6eZrKFU
LhMxCPt+a+EMArvwahAqBB0AH2Q5r2DJm9ernrhQss96BaWNBco6/1CNwrYR
DWS2yvnCV6+SA9NAus/uZ47kU1KkKuDE/E56+DFrd1yqgelIFf8s5Zb1/71L
RrUqLXtXJcdHFOEShqr86v5YtI/Dc0FZzwV6yOrtCS2Tk5MdF5wnORlTZXSb
cpZ0pQUnS7kA/M2MwXVlzjNXK1+75MS6T5qaPiCsVONQUo780FyFiaqb/F+Z
Wvi42QibRDqguuz97kFXz+yI7vr/ysedhbwRD8vC56pZCebOHx5whE3pVsno
XjqOt2foJJae0PiysvkCOUMbWG4rf3o7I3Xe5FbW8MmndbWr9segkKD3DTlx
uhemJVqzzDl0X9Zb8jSOBLzFGnmy+tpGgdP9vSwtQQNgzuiHbJs8weheLe4N
Hpj6mCXCZqgjsD04Amv7xRvCjqa2l2Xv1rBNgh0a9J1a0l3yUjvInt+aW8c/
xT0AxLBhQNIe2SeORZ9kqrGY0buSLPyodRiAScUDW4FbtmyJhSZBSgBJGlD9
7Ile3hOdTBVeI37h0aNH+9thtTLf9pExrUuqDP1Zo9CqqvbOl4kq2uQNEPEZ
vS/WqLS+EryZEX3WU9VtFAlGABypXUPuMZT9JJ8U4JNOvSIn5qUiIm7h3we3
Gz71qndrOZ9ORfy8QOp5iZL19o2SqT9Kz1JG6kom7eznAPlV5BvlSVqt+/j2
OJrSEtUYG9Rqq/IuH6i8pKdFgulvXmcFJYVLep4D8JSpGppVVqqyRk7Ba5i3
6uNbJf3tG6B+ZSPwpWdzT8oUdGsSwe+f2coyk6uG3CbjO5YxpwC/Pu21q2x3
COXB5dPVXmz4uo66es1NnFd8eLNl7veqJSK7z8Y5zZaHti4PM3ijJeyhqZj6
KHw5JqJ7wlbwhCVHwFYLafOsrKyn7fCVcvJIrqS8+aD82tyNOUp+9ipZrpK8
5uOmslqlG2tOecHigX83vb76w4Ym4ds/rGPDmbM0gD85/BErQDk1+jHZ/d/6
FsmB3LXvh4YR962jHPm5qYGAEcnlkkf0kVyVQNn5PQzUjc4iJV+csmq9CerY
qdv0RR1L/OT81MDSkYVzOxssRaaSYoWqPaVsOaNsJaNs4aJEC8xIEZ5Z1P0c
tINjSW2t0jaXOD6rb/kgwkrBwzN836aG+qhuR+G/uDTA6n5StKyXUYhe8Uka
4NDbS1ywQGMFrP7mH+vJ3gkPywmgZ4DBA7hjbX85nNTGIjocCeunWP20HJne
WkaqDsz4pk89T8VQR06RSQAqoDwAkSVI95RN8JTNyMgwCaeTMz8/v5+31vmH
98jc1+rKiEdct/fEzpUsTF/2Zh1ZrdZ66et36MNXUY1azfR1+r/vtApLJqLR
GbDni3q2Lw8KLDW3hRPaWXE4bVCZr15rGpmUDVabNA0wvuqQX2DELGW+OZhZ
KoOsqlIywWSSPTEmUB/5raUUKmXJZ+1SaspSNafv32ywmEomn/0t61J6Si5i
LtaNLQylVMlQGal+2OLXrzGgCSVVhagiVkebZF/OqCYRRXypd8T+YfJ6eEZr
ydQrT6WQQY3Cotf/ZhRdrg7aqcVKoWwVlDX9ArahAQ2d0Wtnf3GX31GrKyfn
ddF7PGS7cbxZyr8fkBP7d9SLUI6d8uHDh8flFF+M8Rku3DJqVvLUpBaNzXfE
eNu2bY6a1UDtlmSlJtsDbLGw9TmhY0WNXC+0oQMZb99rWwRTup1vG1GgYgPq
QBzOnD6qdeJz7qmant7ZJkyA0c5GPeUNAGxIWi8E7kKjYhlLruwZ1tACZ7qD
fHZNqVnRQqtNn9/twigVZWJzQ/ta1MuO4zAp9cpECZne2woyCFZOpnaCsCVD
0XSGK84ns3Fo2uMWX1cMCneFU7hLVUmrqDpPqkrcoz6jFnfnyMYG7YBS5V1A
Uz2c1NoIB0Dlkn9fq97YhbL+63ukQHU5OD1P6Q3yUjua2E7XUGDNkNutrwhG
wMcd1aqsrPjlZdrr74840qE2OohmtPzeE/M8T0yQGCgexI1Sd+opO1zdiDn3
9fq2jzO1R1UD86ASYrpa0d86Jpj1hJgTVfGm6HH+jtIGcKVs+jtY+PRZDH9Y
Vr5Rw+BmGeKRPvBv1gkJrtGKQTepd9zKQXaldCPFEKfooTEtTJsWUN6e2s3L
p+vUSSPf9U5N288mLULnzs4fH7C0aCE6awkm11O0h4kmhXLzXqgWKFoqiKYq
27SBV9pOs1IzIaJggcinOv6kw/90ULVIh0+WcHyTitZsiigIfr+6y0DwUl64
TPJS2jvsr0zX3IxYEgPNVqsyW6P835UTtv/awHL11IBwH+JFCpGh6oL3H5UD
G5d6/EOH6ULEu27dujiSEeXuyGiEpAEkmW09wibiI/23I2klUq8q+PVVm16m
NvQac5DYnkPL8omzNL59OTMVY9uVtrpjmy1TW46pNwww0DR6vJ6tJru/f9Am
AjFNFwTCVUoNEKn4vVF1Upyq5wWiqvt7clpb2yI+iZ9bjKgn9Hekz9i9y9CY
Y82Hf5f9o5qZm+L3TUpGicqYjk9vl5TnLpH8lAhRHfVyxzWzVbVi0OV9YgkR
pVukRKfoE8AflT0MgVK28lmlqz9HZrYxpqCkANnbNbqJnFrQ2ZwgymVA7CRr
UsrAOSs7KqsiLlBPeL4qGDbPSK/j6q1830EejGsTk6lPXSObk77WyPdUrJGn
ZCgCxkv6iz8WrTf31D3fU5ciuqlTp5pjlZqa6qhb2WzpvLcbq3ZVd+3pK5Wa
56krfLEaqzqySuOfRQNvte+UybLxOqY1OTYwTc+XrLdqyBGm1jHkyc0VM2ij
TZ/UlmTVVsybPTi6hYYvVyuNLihO4koREhckdbBZVIfGPmwusTX/8uwaxqCl
2b7f/GUdi3QPqIwT9hTY9n1P62E7l7aXBto6FVzObcCqBGJi2SGhIrPATumJ
vlSKlI7vlJlbk9nHdj9KG/0vMl2c/dkdVgYQ3z3zdEdH7xrZxGz1NFVP5MP3
TXrYJBl6s/eeoVEPcJV2D6RbeYtsB6Yb2MvsL2rLNH19JHv9Z7Vl78iHLDU7
oYNGQG0rSOZ3T8qJAztjD3k6R4t1A8Qk4VAYtu5pf6Gn/aZNm8yPGjp0KI70
k8FxPnZQ0v/b00lu21LgIpdU3Z/cH+ZrINmfNJOsd++3cDiUnbGRvuPrenJi
/ONupEfy2WnGhdM7yGw82c8cziCBLPgRTEVgyGHmGze43KYjf8U4+btIoXpY
Kc9cYjANvnVXyd/A3KqV79ayTTB+v+UrxwL5ye09Wokj+9oo2aGNz2LY0JLp
rSR7yB2WUmTsC+VftGrz92mvXmXQoBv+W8dKOw5OaSl5c56Qk+DSkd2wyNZv
vmc5DU6EjB09kaKvv6qfafStGmEnPXWRBUFrv7hTjs1pZ+jQuNTQlzLZ1Z/e
JkUcy+obR5CGd4AwXfLmtfpsZWwrjBgh59eGNhRgQqeyFr/Mfvlu2bd2QTNP
uGIVtQEyN1qu7TkgQO6TDifwRTlojOSk/wo2WWRCt6rmSRvqcBvnfy1WqZ//
Yg0bTUYZGmYcYBGKdQjYUvpfIivUQ973U2M5CThwaqLs1ZiI3SZrkgVZ0zKY
3eTYb4/ZRiZaOvON6w1W1tLbgQVKGZwfIJ4q7Z70t1tsdGaOssWzl2gMfoF+
/sU600CeCZVlgexmniGVkhvAeOJUPGpcpQVq9WkNATkEshEK7xzRWDaquwTW
xBL9jkogyqGWA8MBq9CKze+ov9j8fV3ZP+lROTarnblhKz+6xXCUSXBRdcbv
Ty/q6swApFXDnTvxYWWJP8mWH+oRJTktU1lOauBFjpzQGLmjQJfapp3DHrTX
oS7sl2ZqBXr/VTbO+EJO5x2KtYi4aNB39uzZcZhkanAgKlXUnuYXeZqT8GZH
nAIwddGe9HHx0Zx16qI9YLjc7HeR+JjQqaI9zbznr9WIqaFa0QeN5lQk0zxB
GxH1M2xRGHSwumRbP69j0PtrXbGW0dpgKwPdJ7Q0jc++A9ggh8c87OiuFrxc
iIv1O0VfwFfKwh7ljfaGEGiag9vCchM6l5P9FDNk9pUNX95tFVkGsK5qHZxq
sERmamBHXoG9i6MgAC/zxRLKF0Si0JRBmQawSqVrhiv4KlTrgdoAJGT36Ids
6ADqAjOO200eA7GkIhJHC5Wxb9IjZ5GI+QSEW//9+/BG6t1eIL+PaGhmvVCP
H1L1k2FIyK4InF1t0IrXfXqHgS7h0doueNsysujj9nJs98ZHPW2jFamB3qCh
hbpmt7Phf1Xa+npo1Mcw7Ny509H7KinIPwrkjYxpV07tSQVJ/afKYt9LLTbC
b5utLjl7ntN6XGC9WstfY4jNBZI96GbJ/U7NwKBaVm5FsR6wVCsH3yT71Nsy
Sz7XYzdCV5LReoxUFV4pOvvAyGbub8KmpkuFrH7vFkmnPXhhjwpxQ9/Davow
NPzsGeVIgXNOrd6m7+6zwmNqKTMG1ZC945pL0WJfyxKcODelKp9SB3XaMwbf
6JJeGRjzdAMJWdY7nqVGN9Pwc1R9tuzP7rSrQ5j1aguAksbea4CMnc7oFaCn
VbhJZqEkjmjsdWZZT9n2s4YQ/3Q4pzZYQJmEJp10lIdGhEnqugQPfeZzN8vu
5dNjj0f8NdJW7GwHhH6SHaHm2FP4L/4Le5049JTrqYsXKJyTMVmm9KlunVhA
LMxU6o5p64r61SM36SYDRlvV3m8etMb31P6XWj1T0eT2cnJsK+sxtjEIHcqa
hFOCApAGo1+M0kj3wp6Sr0ETuUv88XlKG8t2pdhEjVKRNCYjvNiXUmGPU9j2
LBMl443rbCuPuApbzNoR3aSpz8uYvAJ2HLK8zQ2TPww9UUl4gxvz7YtVQDVk
Bk3BokTPCH4Ojp7KmMhtPwU7oG7Zq9fInjFNXZZFTTq6HJ2/e8xDZ90y/cRM
p2owtmtUY1mnpJ6jbgfeJuxB+yEiACB0xlvX2663KXE10b91riJrfxtsCru1
J2W0rDLMCqGYN4wk9eS9xH+hZhLhHTJkCEVOjrzXS97ezbLwvYeVNOXi2WnS
XmglSDs18U/6ZBVl4YDLrPGS6towZoBKJBIiTMZg83jbZ/fI9i/ulWUaldGO
jlEOpEaoCbXyp7SRNaqQEWJ2nHYPaxSEOP6ZQ9z83GVgSbtorO65UMULHcz0
ceUWpDooTzgS/2Gx+sgbdXF3qNXbpcaY0bKHVQEf1eiZ7OWJOe3NqGPMC5SQ
Rc5XdzwBiqEaYAz7Cfw9dQTw8VaprM3RSDlZHQbKwe13/P2KpxyCHYyh8k5x
JjYpf14n29EAoRs+JM9GOwwEZe/ToDDJtyRWNlwDqvGoEuQ9SEUs+vgJObQ1
q52nK7vRlF1T4Pgnf0wVt9UsRGh9aSQcI71CDiUzM9PR+jo5c+qErBo5UCZ2
u9AlxNq4/p1xqqgxyMn9r7B0p0ESsH366nXW+s9sZiAFjo14RHK/bWBVZ4d+
bW4wvEVT28uRkS1ky6d3GZwVfIDVAVgCUQaBFiPMi0JvtpWKcOBUJVOWREtS
4ZxOvgKtxlkiqzBD5GPq05NHWfbva61pl/wL90CV0P/BYtKbRCsTEFtUysI7
4InSI0I+2jwvXeA5/S82ScOSo/rxzCjjBucNR32iegJIIw48/I93gEeH4tit
JiNnZGNr/t+nJuPQVKaCHJnRRumRpwHDIrXc81/6qywceKX1RnEuIzV4TtaY
NUVN8vzTDKuyhDHsuLYxSRpQQ7bOHapEKoo9EXHHQm1ioDgijIvGoExP8Wqe
4uh64nWwBONBWG3JXZMqs1+6y1zwUdZ5UcqkPGTPxrcva5TOfOVv9snKmkum
JgYTDbgEkpw7VKV0VleHWZPUxT4LlfKHfm1mc+GhPIodsMfZutrAcfB2+Nc5
GmEfm/CYSfyZ2R1NfPG96SZiS3KxqmbCL6ctLpOV79Sy43lqGNKU+wDoOj7z
CdX4l1tu1CLzZVZFtpj0yyKqVDl4KrmT/mE7OTz5cYPIAsN576imsuvnhrJ2
yJ2GOjnC7GdZsw/YUNoK2atiH4tENGVr/A75HN+hTEni0lgFOw20SKrYoKTN
PHvnJptmveL9m3GsYy43Vc53wyWYKprcuYz6lxVl1fBXAAaJdYwEU5SRLV26
NBYG8UUrTz11q0cCrEi9kaNuVbq21fl6RcZ1rCwjfC8eu4xzNMae0DnBeIyB
d4e/byw7PqljQ+fh65/1b9mOsLZAfdJdlA3O6lLKGiuucEQm7FZCF03rIIeH
t1DVXseGvDEZEyPFrYCUp+F5g4bkS9QQIspUk6HyVykREfUTk9s4C05YntZL
A7F7bAOqYE5Hh3Kc2lV9uhpGm0NKN0mnIGhRDyMu7ecEY7T26E/BvK6SM7yJ
zc9CFWAoIQBN7djxorTukq+6/fDklrLzlwZK8zusKwN1ANwCYocqAFEZ6EYm
6tINSVE9+Fc48hQrEauSjkAfkzMB8n5Gr8oyPbGiLP3kcdm3bmEXT7No8eAF
EckN1aKejpdHgiZcrHOCpmtJq0rq203j9arsDk9JvNCCZR6EIYNHf2pmwyoZ
Gbz2rVoG/W/urBICrLPfv6rrJDTJS6j9u4tJaf74VpI3+lFDmtqk0spkSBzu
0XZuaSMiL0tlxx51yayBIYXpq/MSDZG6W9w0I5QI6r6RTV1VeagDW9BdbfF9
BtO5YygwnX0cCa90JNTlPZ3a2br9wLKiowsZWvbWDYZrlatadfuP98tKlSU0
OBoaEcSUsk/COcQzzLY8pNo3P0lJTlY9Xck25XG73u8/q2VRjxyyU9RDLMRq
KtlVNpWISoBZfVW7v1RLNs38Ss6cPtnNk4zq/+BKBTKSqA41oG66hC8PPVvn
QxtoTk6OI+M1Ung6X520d2Vyn78axv/ox90OYhgQxjZEzpD75JiS8uiPD8ne
L+vLmjdqmCjaICh92M2f3GXjlHeoG7V6cC3DeabIE7mjsJuYOO2F6rLyTTUZ
Q9Tj/uFBOTKiuRwb86gsVpd44YuXyymmjyzoYblP23XqZodXgly6IJG4uCtO
v6rh3BEPWVYFaWCkUuHC7nJwYktLXZAJI6Q0FBkAlzGc7Cuoig9zSyDXlq/v
ld1KViYeABFtcPImwEt6spiUi3NoSS/Zrc4YWZYdPz1otWJcbrgfi4TPwAb3
fBSz2tK5GkZkfN1Tju//PdbDE4GK69DmEQZKk3UMw2w8ma70ZAqFOEhccnKy
S0tVkV2bs+XLJ++XCd2rxu0iT4DGJGTFnaTCBigS5tkyRJFterWLTsebYxAr
Y+nI7Hc15vrufikgTzW7K0ZptuFrzfaiSNZaf4pmdJDVg2paAZbFrfN78Lhz
De5Ng9atX91rq3oaAzmvm7lDRiUvW2FUyoExzY0axJA09MBf+JEICnYLqNy1
qtd2qqDsG9NMTpCsUKpas5DHy7JPRxZK+7v7In7QJfGQwFDFmzIPpaWnjMoj
ansxaO//vFTmva6styall1/2KNJtIAy78aFY0hPmak8YimWAofHFMv+ww9Vl
b+4+eWvwe5K7LVsyv+0r4ztVMQIRZU5Ts4ZaZGIlsAyFo1tJwcjH5Ix+Hvqu
kamxka0cIYFrphoemZnz5EUyT+1Run7HRT08XNdkHCBDHcIw3qTO6Ge1dzu+
vNccoC1KC59GNp13fFJrc15M56W5ojejh9qvU+qYsCOEk4Kzk6T3xAlCvQYF
hN+Pn4Hyy5/9hFt/WqLptFlsnTaOCIt7yO8/uWENlM7PdPCeJqHL1IVeoHLP
FKJ0wDteuUk2TP+cLHufiE+B3aFMrYo/RjInFCt6IlzjiQDNQJv2hS2ul65S
fBj7ydNnOCKHd6yWhR+2Uo+urPkYY71xTOp5PrZI129C+9jtsu2j2jJX15rD
oBoQIqx77+9yakIbOTK8uez88j4bvgR+OPaUElJCSAYSbvzodsn9saEcH9tS
ipQumCqGu9KoWeQHwzJqbM0Hf7dN8lNJ7eXgmBZWkb5IGZI1Z63SX7tWNn9e
xwbF0dXJ39MJz3Ys2c/VH91qZaqEBsgOUM45vzQ0iGmTBz+OQGUlLhdOmcnG
L+4yTx53AJLiAuH+UCmVrDKz7j+3qDt5gyz5VN2P7auf9AseLSI7zx+LVg56
klwbcQ9CRYr6+L39GaCvsnmuFPNnNGCYncx/9xF9mDImI5DkN3Xmt314JxSR
ZS9dbQMKgWSipujwz82sRBwY/XyaBNBPQJtO72jAlId/aWrob9nv3CyLXrjc
bA1bZsgPsrNaXQMSpoteudJG/VDFB9Ye30mgJynPUg24+fO7Zb/qtzOzOrlQ
ziZfuZBuj4b66CnzAfH3fnvUBo3kTW8j276tK8sH1bB8FvRJ1VBxpYZ1uaOb
2ngItw0Xp098aEn2J7cBNx18b1w3xIXHWqTR2Li2JSRl4B2yM31K7Gm/nNT9
hAKwyv4YFh2icMwT5TpPlFBYQgXo9u3bg8qjEYR0SkFBgU+NX0jRqBEFtCWE
H/+MkedU7f0ONtb4djaglFbAwikdXDJUrQvGHkIYQWZ2ZrRWV4+7fxoUDw2v
kZ8M5W+1H+5dE8xyjvBoG5iEdf9RMdKIuiCpY7GpTt28qbnYVBoFR6wRaovY
DJLkaIiEj+ZMQ08pmt9Njk1pJVuVLBQM4ouRvsSVZusY05KvbjeI+dn/udVZ
xPL2wmjgsbrsU7poKNSxjCQ9V1PWTfoITfVMxDSEDcYwF/z48eO2xJTgeQoE
iJdQDUKCUqUmeAMaCJkXdrYE90/MNZfdmdMk+bV6FoGbClY7lvO5esdT1P/8
7D4rmT4zoZ1lrshgUYhF4yXmARNNUf28Zy5R0zC3HwgYFHOxVWH20Lt0iMfK
N2+0NuDFL15pCUsrhv2mHtP9Ys51LnXWdXaNV/r/6iYS1GBT/EVN3j4VF9TX
9u/rWU2eMy3dnanx9CjU0OfIpMdl6zf3qS98g8ablWwzBzHCX2GiCmp1aveK
hlow9okKMm9wc9maMszizgF+zaJFVYH3acMml8Q31+DigaJLG/5NKNpQEUn0
Z1BCSRrxLPDcJVJUeIb+CZkx4CZTSOP0qYhTCse2tuHmTM41KJsZXeTA0CYW
HVPInjHwb2YogJcEvBSYJPKLgLuReVj5Vg3J/aGBnJncjqdzIAAqJ8fHtJSt
SjEmok5Xii7U1SdrcJranPmJYROQc3TVy9uqgwKAkSavRP6JWjqMtTpMFLcn
lmTdTet7ZaOUwK1lWhJKicQc1dLr9TvaZUZPpULvyyT9qx7EcP+MBIAsampq
apy96TEOlWt+kWv4RS5WO9HdnwGIWqilcWgyVa2TYMO0T2VK3yvkl+YxWaAB
/RbV+OycFU5sJ6d/a2Ob6ABw0AIGSGyOBvewdJK6s7A66He2oJPaufW83ume
aR3O/vCdJIB+MlYOVHVgPTG0WSohB0c3l6LkrmdbxJTLT89w7WA208FrnxNT
25rBQZE7hd3LuJk1pRBhrjpqJA1wusiwTE9MkOR+VdVoa7w2oKasnfCB5O3d
8rJfkWjFUYI/RpYTZPLIutb06xrqEhh3mZeX1zXiEn311Vfe3eH/F8ipo/sk
e9wgmdirmkxur+ZdH2DD+7dZzwxMGnqzgauE4TZ8eJvsH9bEeZEE2rOsdHNG
p3KWQqng3H51/8mO7vnuQcnSRaelb46a4pUaMhyf1MrriKpWhgO6jvVTpLqN
EDiUbCmTE7d/X18WKrehVPHHp3YpKwsGXKw6v7JM6qmu1it3ScZ3/WT7/OFs
xw3074lIhwqeiv5YtD7Lr1Ytv1rF9vC7+DNAWwirdZ7nwvyDObJq5GsaQF0k
Y4F8AqGsbcwUz5w+VWTtOzfJ3m/ry4GfGqhf0UQO/dTIPo/oz9HhTeUY8erI
5nJi9CNyYswjJZVNH6NNZvzjUjCxtf60UevYToqmPOG4MamLuSun9TguSpq6
J8mqIdgB2vVTQ9veZVYRa8bcopyh98uqd9WV6H2ebXZbVqVdOQ3Lq8vc1+6T
5T/0k82zvyN+oezlDf+miCC6Di+rgj+mnGbOMIrOr9ctEV8NiQWeQn2ATv4M
kHsCBpSLhBIkb89mWT/lY1nyeWdZ/GkHWfDew7Lw/Udk3tuNJPlVjfteusPY
feZzNfUuSQNuVIciacD1MuvZayWp/9Uy+xnlvGevpjLqmSu4x9PV1OnUn34Y
qZSnL1GapDyljKTGYN7TVWV+/6qS9uzFsuSFS5UelWV4C7eJBIjBWLXOc568
wDatJvW6TGY+f4u6961l7fjBkpM+SQ5uXib5h/YM9m9ZrBakvH/LnTt3mruk
wVtYl7/7M4rtE4eEJzVFNFTyzVXzVrftiAL9OX38sNXTnziwS8V9qxzTn8M7
1sgh/Tm4Zbns37BEcrPny56VybJ75RycOf2ZLDsWjZOt80fI1nnDZWPS17Jp
1jeycfpnsn7SB7Jm9JuSre+0Ze5Peu48fafdDNKJhVAoWu0Q3gpPj2OqZ8Jb
OaSAMgaqWmx/1IPClbJkHuvDt4X+GLlc8rurVq3yHeOumAJmopjCX/52v2gE
xPAeRnX//v1hD2D8+PFx5Zbmj5HoR6uRcQxX5jTa0vhWwl35johxiewE2X5S
SWAMFvtzZ82aFe98LeuPERaGTWJ/vdr+etF9BnXZ2vgz2J/Cq+Pb4sixsGdV
JnK3MEjbX/muiAKK5LjDLic5H5gnemVCV6Bg2BsJV0bdBUAZf+U6/spk8cD9
gFBKhLA9zs2CSV7ijxFD83p0/5f2x6K7Lv7K9/grU9QKo/tE4GP+DBQmKUW+
LY2okkC3MKw2mvH3V77XXzmau1L/t6U/A+Wt8b19C6lJ7hQoGGYJBfZm6oe/
ct0Ir5F8gYIqvw/7M5B0XmP58uWxjMjaBwralUvgCZZgdfxF6/mLhmQCbKbW
I9QU8RbcCyzicNGQK1IeDBcdOnRoCZk8ebK/6P3+osXC4WaRixIOk193g37L
mtZBtvza2NLpC/oLPhBhMbSZD+WaRi7IAhKlL7djZQyG1CNlGV6MSmdYyAb+
asXCkib+akgcLKT8EMvyf8pjcQxO1McsYUYm1tD/Fr8G6adtVL3sxpGFosIK
HN4V/hiSwPhifTR9HMZp+ords24kp6jVDoW8ABDC/MrZsZVuuX/88ccS0rNn
zxK8ZSzWxF+AxATLjRegoh3qvNGKGDpdvPhyo8rgfaqEURSQQ29SwpwNX0fq
lhvny7sUD0ZkjPtgPJx0VLSnRM5wNzAT0JK/gXkgPwunS+MpECoVORqxwaHZ
gGAe5Qs+Q5q/AQxCyM4CwuY8McRDdXI66kMX2he5Nfc34CysOTKuVKrvb0BY
xEvpKsVS7ViCSRxmEZg+JIEn52/gNS6BYwAkEXBEfkpKC89rUeOCQsK41PW3
QlpZDE6b49+FbjUulZKSYshtvCvL8MEHH5iuR270EZ27FnskIvcRGxPa4QCn
RG/CkTMji7V69WojLUwZqIHYkmsn8lZKu43L2KMRHcDtYXQ1NaGRMpoomVJs
sZALOITFQgJ5EAQUlcbz8tauAC32mL8LBgjCeQMUenShH3chGTDBvwb8x+sF
zDpIwcOFdSKMVRXs3BFfNeW4FgfGo8fe7W9A1ojyOIgzxr8GOhMdzs1ZKx6A
Z2OtAs3R+3D65e4urSOsi1jCe/rMtf1dCE6Cgz6i2GIF2WCheDg+8TtYxLBY
LsPuwZBd/B6xTwHtguUNUwl+LiYgWGhsKzTHghD6YzhRgvqubrBBrK2/AaoT
kfJmKmCqwMXBzP/gXwOdwfOA/AaMErwY5rWExWI7Fal14+98LcS5JkutXIDq
gRWhFN++8XdBkfDnUUWCHkfeoTnrzu/hE+fKez/O8S+6xtuwABLF68GjfPsy
slgIgdqsuDaBs5At3CAWS2XMLYff9Hc051m4ibJugMdjdfGV+PbpH2gTPMCo
NkFAgjbBJ3EcGusU4V/+BOKp9QrTmfElQ7fVR/4uypeWXGaxUCTcgQeMKhKM
Ezzv9EWsi79LMeMXYE7RfLA0397zi6ULYQuChMBN3CVoE05HonVBnZGOdfU3
4L48hzeKYX5i1NF8+w+0CcYLakB3PnHyotrEmcVYtwjNI7mXgPnLVRAEvv07
QnP4M0TEUW0CiVAQKiDONsUS/Q3QPxGjGvDQYU0uxLd/RbQJHebBqMJYPFdU
m/AAGGKn1P3G6LnBu54epo8woTZ4iy/+gTaB5iwUBoRPtAk0Z7HgLKcSY70i
/MsDAYOi0hxmA6BJ4FO+PVdMm4Q5hCj2oE14N6yLLpYrb4v19jeImlt9xoCT
G1xTKpX7+9dA8aBN0OGwKgICP7ICQUBgbZxiJ38xt0/2x+Y2wFJyWQiq6xx7
MrJiQaWwYrwHUsI7BSnBXUSlOO6N/SOiuILNVYN5ZeQuwYPtXUylBJvL1YNK
Qc34FXMgq7F4k43yL8znbW7Arwro5+C8dv8DlYIU8QCsFp+sGN5EUCluMzDW
z9+lmM2NzjdlIYiXO/u76HrHVQpb80GlsArFVYq7vN+XOdfw6koEpA2eG0uJ
G9w+olIwuqhOFgsG5i4wPKSF9XS9XdY79kyEfyM2NzQV88jwAph+rSOLxeTE
oFKgRgBehgeCzWWxXNo3FiB/itnc0O2KG80j4gu0jNCctSWjgEqBs3j7YirF
KQifwz83NFSihd5LHBFuAMc3/39UCg4M6gR2CVKChuKhXnd3eT7CupE9+tAH
hm/NI+L6NinGWWQXg0qB7nzCMtAc5x4X8y13lxci/Aszepsb+hDCuBGWN4Rb
YbF4dV3bktBCD0N+bBuyo0vgEgBe2/2PyQ1l0vA5pGQDqp5/C+KnoFHwT4JG
gShRk8ubuyxS7KUI50ZMbijXhAshpV7ZZwwSeKNzlAmcy12CMoHkMB4h9yfu
Li9H9FYxsxsvVuLtETGc7NrFuCvYXZ4ugOji1PA7XTHnbHor9D92N1Rz4LXB
0TzXrf5dIF6wu5iOoFFYuYCpGoTE+YKxgRG68ww+WA3lCux5hI2lWhGNghPN
imEceA2WIGgUVixolO/dXV7zdylmfMOGV3QH4MaIRkFK0CgBbRjG4T2ClKhG
GeZu8Lq/AQ5UxO6GzR5mdoXp8H8rtljz58+3U2C//0+jDHd3eSPCxBG7G5L5
2K7g/oaSJ2Jr6MojK51Lslp6GMoFhZKbm+vil9ibkZMiUW5IfsNjARi8mn8L
dE8I/FGjEItHQ1jDUpFHQKG4/KGX+D9OoYYEJh4dmoJvf4loFcwqC4YlCf4W
i8YCYsdYMFh+srvVIP9CKJuI2Q1pzagLXNXfhXdHTnkytCPkgMMQErSAVyv2
tNPdXUJuvJjttdRBSVgy5P3RKJCcVQ9ZEjiXN4A98DCDRnF4/7F3/bWLWdyQ
MIx6vwkRjYLFRfsSp7BOkIQ34fHgHjQK6iLF3eW9CPviIHuLG5KHVG2FlGs5
f5egTJAPuClQIygTJDSskxthHvvAPsoaoTC7sC/8A/FUj5UqtkoIAHdmlaBA
0CLQHzqzSi5N69VvFVPXCCuRBPRGIqA9Ah7yfCGegfAYIrgXJebSkT4UqmAP
RvCSmJgozz//vPTp0yeO54fs4324LfJYrMT/AYQ6u5s=\
\>"]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Centroids color coded by variable", "Subsection",
 CellChangeTimes->{{3.705224884688384*^9, 3.705224897129682*^9}, {
  3.705248581457491*^9, 3.705248624551947*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"selectVarTau1", "[", 
   RowBox[{"data_", ",", "tau_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"data", ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "\[GreaterEqual]", "tau"}], 
       " ", "&&", " ", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "<", 
        RowBox[{"tau", "+", "dtau"}]}]}], "&"}]}], "]"}], "[", 
   RowBox[{"[", "All", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"selectVarTau", "[", 
   RowBox[{"data_", ",", "tau_"}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "myData", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"myData", " ", "=", " ", 
      RowBox[{"selectVarTau1", "[", 
       RowBox[{"data", ",", "tau"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"Riffle", "[", 
        RowBox[{
         RowBox[{"myData", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], "]"}], ",", 
         RowBox[{"myData", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}], ",", "2"}], 
      "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.705247108606607*^9, 3.7052471431565533`*^9}, {
  3.7052474187548227`*^9, 3.705247525808679*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"myColorFunction", "[", "x_", "]"}], " ", "=", " ", 
     RowBox[{
      RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", "x", 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"myColorFunction", "[", "x_", "]"}], " ", "=", " ", 
     RowBox[{
      RowBox[{"ColorData", "[", "\"\<ThermometerColors\>\"", "]"}], "[", "x", 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"myColorFunction", "[", "x_", "]"}], " ", "=", " ", 
     RowBox[{
      RowBox[{"ColorData", "[", "\"\<DarkBands\>\"", "]"}], "[", "x", "]"}]}],
     ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"myColorFunction", "[", "x_", "]"}], " ", "=", " ", 
    RowBox[{
     RowBox[{"ColorData", "[", "\"\<CMYKColors\>\"", "]"}], "[", "x", "]"}]}],
    ";"}]}]], "Input",
 CellChangeTimes->{{3.705249809161742*^9, 3.705249826541737*^9}, 
   3.705249952267747*^9, {3.7052729301737537`*^9, 3.7052729451147137`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"makePlot", "[", 
    RowBox[{"data_", ",", "tau_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tmp", ",", "varMin", ",", "varMax", ",", "varInt", ",", "plot1", ",", 
       "plot2"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Off", "[", 
       StyleBox[
        RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], 
       StyleBox["]", "MessageName"]}], 
      StyleBox[";", "MessageName"], "\[IndentingNewLine]", 
      RowBox[{"tmp", " ", "=", " ", 
       RowBox[{"selectVarTau", "[", 
        RowBox[{"data", ",", "tau"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"varMin", ",", "varMax"}], "}"}], " ", "=", 
       RowBox[{
        RowBox[{"tmp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}], " ", "//", " ", 
        "MinMax"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Off", "[", 
       StyleBox[
        RowBox[{"Interpolation", "::", "udeg"}], "MessageName"], 
       StyleBox["]", "MessageName"]}], 
      StyleBox[";", "MessageName"], "\[IndentingNewLine]", 
      RowBox[{"varInt", "=", 
       RowBox[{"tmp", "//", "Interpolation"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"On", "[", 
       StyleBox[
        RowBox[{"Interpolation", "::", "udeg"}], "MessageName"], 
       StyleBox["]", "MessageName"]}], 
      StyleBox[";", "MessageName"], 
      StyleBox["\[IndentingNewLine]", "MessageName"], 
      RowBox[{
       StyleBox["plot1", "MessageName"], 
       StyleBox["=", "MessageName"], 
       RowBox[{"DensityPlot", "[", 
        RowBox[{"y", ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "varMin", ",", "varMax"}], "}"}], ",", 
         RowBox[{"ColorFunction", "\[Rule]", "myColorFunction"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "80"}], ",", 
         RowBox[{"Frame", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ",", 
         RowBox[{"FrameTicks", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"False", ",", "Automatic"}], "}"}]}], ",", 
         RowBox[{"AspectRatio", "\[Rule]", "10"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"plot2", "=", 
       RowBox[{"ListPlot3D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"selectTauPos", "[", 
            RowBox[{"centroidData", ",", "tau"}], "]"}], ",", 
           RowBox[{"selectTauNeg", "[", 
            RowBox[{"centroidData", ",", "tau"}], "]"}]}], "}"}], ",", 
         RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "plotrange"}], ",", 
         RowBox[{"AxesLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<rapidity\>\""}], 
           "}"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Mesh", "\[Rule]", "All"}], ","}], "*)"}], 
         RowBox[{"Mesh", "\[Rule]", "None"}], ",", 
         RowBox[{"MeshStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.35", ",", "0.35", ",", "0.35"}], "]"}], "}"}]}], ",", 
         RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
         RowBox[{"ColorFunction", "\[Rule]", 
          RowBox[{"Function", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
            RowBox[{"myColorFunction", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"varInt", "[", 
                 RowBox[{"x", ",", "y", ",", "z"}], "]"}], "-", "varMin"}], 
               ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"varMax", "-", "varMin"}], ")"}]}], "]"}]}], "]"}]}], 
         ",", 
         RowBox[{"PlotLegends", "\[Rule]", "Automatic"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
         RowBox[{"PlotLabel", "\[Rule]", 
          RowBox[{"\"\<\[Tau] = \>\"", "<>", 
           RowBox[{"ToString", "[", "tau", "]"}], "<>", "\"\< fm/c\>\""}]}]}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"On", "[", 
       RowBox[{"InterpolatingFunction", "::", "dmval"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Grid", "[", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"plot2", ",", "plot1"}], "}"}], "}"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.705248669686455*^9, 3.705248822650728*^9}, {
   3.70524885739415*^9, 3.705248880552886*^9}, {3.705248920599906*^9, 
   3.70524892720895*^9}, {3.705249061268065*^9, 3.705249068209757*^9}, {
   3.705249110593113*^9, 3.7052491490227957`*^9}, {3.705249280692295*^9, 
   3.705249367174069*^9}, {3.7052494259680653`*^9, 3.705249452319273*^9}, 
   3.7052495469092607`*^9, {3.70524957887289*^9, 3.7052497518919773`*^9}, {
   3.705249782043336*^9, 3.705249782729048*^9}, 3.705249841641375*^9, 
   3.7052499191351624`*^9, {3.705267686274362*^9, 3.705267694599333*^9}, {
   3.70527019785988*^9, 3.705270207009076*^9}, {3.7052702533008327`*^9, 
   3.7052702536008463`*^9}, 3.705270452052723*^9, {3.705270548390324*^9, 
   3.705270597189638*^9}, {3.705271268780767*^9, 3.705271320960884*^9}, {
   3.705271377825378*^9, 3.705271405631528*^9}, {3.705272679627678*^9, 
   3.705272698245481*^9}, {3.705272734461475*^9, 3.7052727354374323`*^9}, {
   3.705272774188871*^9, 3.705272806426063*^9}, {3.705272850529933*^9, 
   3.705272887422991*^9}, {3.70527295563087*^9, 3.705272992884364*^9}, {
   3.705273078820693*^9, 3.705273081473442*^9}, {3.705273252534505*^9, 
   3.705273281030875*^9}, {3.7052733504139853`*^9, 3.705273385491303*^9}, {
   3.705274115527224*^9, 3.705274118429269*^9}, {3.705281505874815*^9, 
   3.7052815259512997`*^9}, {3.705282013858944*^9, 3.705282057039135*^9}, {
   3.7052820977106037`*^9, 3.7052820999576187`*^9}, {3.705282163683481*^9, 
   3.7052821893202953`*^9}, 3.70528231589349*^9, 3.7052825323592463`*^9, {
   3.705282853241446*^9, 3.705282856406269*^9}, {3.705488290288714*^9, 
   3.70548829825355*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"makePlot", "[", 
  RowBox[{
   RowBox[{"varData", "[", "3", "]"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.70524883934459*^9, 3.705248845272338*^9}, {
   3.705248893463291*^9, 3.7052489033980227`*^9}, {3.705249032018036*^9, 
   3.7052490362254963`*^9}, {3.705249073248601*^9, 3.705249076168219*^9}, {
   3.705249386413645*^9, 3.705249391868729*^9}, {3.7052495594952374`*^9, 
   3.705249575758513*^9}, {3.705249787599167*^9, 3.705249788862562*^9}, 
   3.705249857598303*^9, {3.705250052613658*^9, 3.705250138361258*^9}, {
   3.705250641769928*^9, 3.70525067848739*^9}, {3.705267667574868*^9, 
   3.705267667700776*^9}, {3.705267710013406*^9, 3.705267763282061*^9}, {
   3.705268639715233*^9, 3.7052686445052843`*^9}, {3.7052697031307507`*^9, 
   3.7052697357119703`*^9}, {3.7052699469224358`*^9, 3.705269947078808*^9}, {
   3.705270097330986*^9, 3.705270097554508*^9}, {3.7052702282643137`*^9, 
   3.7052702284062977`*^9}, {3.705270277046829*^9, 3.7052702771647863`*^9}, {
   3.7052706318669786`*^9, 3.705270632050763*^9}, {3.705270823731529*^9, 
   3.705270909349451*^9}, {3.705270949118885*^9, 3.705270972026823*^9}, {
   3.7052710495855217`*^9, 3.70527105160785*^9}, {3.705271191709662*^9, 
   3.705271191832588*^9}, {3.705273395210347*^9, 3.705273397809876*^9}, {
   3.705277999849544*^9, 3.705278009943593*^9}, {3.705282611640842*^9, 
   3.705282612472267*^9}, {3.705283732774798*^9, 3.705283763802353*^9}, {
   3.7053152373550673`*^9, 3.705315237754524*^9}, {3.705315786077982*^9, 
   3.7053158304585*^9}, {3.705316281139637*^9, 3.705316284606655*^9}, {
   3.7053223350947523`*^9, 3.7053223351960583`*^9}, {3.705322467568622*^9, 
   3.705322467647962*^9}, {3.705325865369493*^9, 3.70532586545461*^9}, {
   3.705331373659683*^9, 3.7053313796734667`*^9}, {3.705351699941143*^9, 
   3.705351700091284*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1nHd4VlW2hxOkBCEYSEJIJVawY0dFzw8VO9iFCI6DDhYUmbEgo4AooyID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       "], {{
         {RGBColor[1, 
           NCache[
            Rational[5, 9], 0.5555555555555556], 
           NCache[
            Rational[5, 9], 0.5555555555555556]], Opacity[1], EdgeForm[None], 
          Specularity[
           RGBColor[1, 0.5, 0], 10], 
          StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJxNnHmcjeUbxt/3Pdbsy4x97LuxZp8Zy1jGln1J9hBShERJQglR2aNQUhQi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             "]]],
           Lighting->"Neutral"]}, 
         {RGBColor[1, 
           NCache[
            Rational[5, 9], 0.5555555555555556], 
           NCache[
            Rational[5, 9], 0.5555555555555556]], Opacity[1], EdgeForm[None], 
          Specularity[
           RGBColor[1, 0.5, 0], 10], 
          StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJxdnHmYjtUbx4f3eV5LlsgUJWQtVLJkzRLJniWyztg19kFjmzEx9mXIUrbK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             "]]],
           Lighting->"Neutral"]}, {}, {}, {}, {}, {}}, {
         {GrayLevel[0], 
          Line3DBox[{13, 18, 25, 32, 40, 47, 55, 62, 68, 112, 119, 164, 172, 
           221, 229, 274, 281, 324, 361, 400, 436, 474, 512, 557, 609, 601, 
           665, 656, 720, 711, 775, 767, 838, 831, 824, 816, 809, 801, 794, 
           787, 782, 734, 727, 679, 672, 621, 614, 568, 564, 520, 482, 443, 
           408, 369, 331, 286, 236, 241, 179, 186, 126, 133, 72, 79, 13},
           VertexColors->None]}, 
         {GrayLevel[0], 
          Line3DBox[{858, 864, 872, 879, 887, 894, 902, 909, 914, 961, 968, 
           1015, 1021, 1071, 1078, 1123, 1128, 1172, 1211, 1248, 1285, 1322, 
           1361, 1406, 1457, 1452, 1512, 1506, 1565, 1559, 1619, 1612, 1680, 
           1675, 1668, 1660, 1653, 1645, 1638, 1630, 1623, 1579, 1572, 1528, 
           1519, 1472, 1463, 1419, 1411, 1368, 1330, 1292, 1256, 1218, 1180, 
           1134, 1082, 1090, 1027, 1036, 974, 983, 920, 928, 858},
           VertexColors->None]}}},
       VertexColors->CompressedData["
1:eJzdXXlUjdv7N2ROySzKRegqQyFuhocGpZQpUzJTMsW9ZjLXDckcKjcNKhkz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        "],
       VertexNormals->CompressedData["
1:eJx1vXlcjtv3Pq7Ms8xTZsc8zzwsIjJEMqfM85CZkHmeiRSJElIZM5Q8nU0R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        "]],
      AspectRatio->1,
      Axes->True,
      AxesLabel->{
        FormBox["\"x\"", TraditionalForm], 
        FormBox["\"y\"", TraditionalForm], 
        FormBox["\"rapidity\"", TraditionalForm]},
      BaseStyle->{FontSize -> 14, FontFamily -> "Arial"},
      BoxRatios->{1, 1, 0.4},
      DisplayFunction->Identity,
      FaceGridsStyle->Automatic,
      ImageSize->600,
      Lighting->"Neutral",
      Method->{"DefaultBoundaryStyle" -> Directive[
          GrayLevel[0.3]], "RotationControl" -> "Globe"},
      PlotLabel->FormBox["\"\[Tau] = 2 fm/c\"", TraditionalForm],
      PlotRange->{{-11, 11}, {-11, 11}, {-9, 9}},
      PlotRangePadding->{Automatic, Automatic, Automatic},
      Ticks->{Automatic, Automatic, Automatic}], 
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxl3Guo92tC1vHfVB5iTJNKQUqwzIT9QrKSBGv2pB0HphpSspOlRtEuU8PK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       "], {
        {GrayLevel[0.8], EdgeForm[None], 
         GraphicsGroupBox[PolygonBox[CompressedData["
1:eJw0nXf8zmX7xu/PuPd9k6yWiJQo0UBkZCQlSgpJSSorClEkRKQIUSQqlaTS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           
           "]]]}, {}, {}, {}, {}},
       VertexColors->CompressedData["
1:eJztzvk3Ffgfx3FE0TeyhDIYaqY0Ie2kehOypIUx7YlrkKRpma9JucU5qUab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        "]],
      AspectRatio->10,
      AxesLabel->{None, None},
      DisplayFunction->Identity,
      Frame->{True, True},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->{
        Directive[
         GrayLevel[0], FontSize -> 22, FontFamily -> "Arial", 
         AbsoluteThickness[1]], 
        Directive[
         GrayLevel[0], FontSize -> 22, FontFamily -> "Arial", 
         AbsoluteThickness[1]]},
      FrameTicks->{{Automatic, Automatic}, {False, False}},
      FrameTicksStyle->{
        Directive[
         GrayLevel[0], FontSize -> 20, FontFamily -> "Arial"], 
        Directive[
         GrayLevel[0], FontSize -> 20, FontFamily -> "Arial"]},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->80,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultPlotStyle" -> Automatic, 
        "ScalingFunctions" -> None},
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.02]}},
      Ticks->{Automatic, Automatic}]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.7054882803044777`*^9, 3.705488301602215*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"imgs", "=", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"makePlot", "[", 
       RowBox[{
        RowBox[{"varData", "[", "1", "]"}], ",", "tau"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"tau", ",", "tauMin", ",", "tauMax", ",", "dtau"}], "}"}]}], 
     "]"}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"myMan", "=", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"imgs", "[", 
       RowBox[{"[", "n", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "1", ",", 
        RowBox[{"Length", "[", "imgs", "]"}], ",", "1"}], "}"}]}], "]"}]}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.7052720151293707`*^9, 3.705272018255048*^9}, {
   3.705272062175149*^9, 3.70527206280583*^9}, {3.705272656473895*^9, 
   3.7052726572234592`*^9}, {3.705273010427251*^9, 3.705273011258081*^9}, {
   3.705273212797241*^9, 3.705273213236*^9}, {3.705273418515388*^9, 
   3.705273426112496*^9}, {3.705279027128175*^9, 3.705279045109317*^9}, {
   3.7052807705122833`*^9, 3.7052807909739723`*^9}, 3.705280882133397*^9, {
   3.70528132459621*^9, 3.7052813249542437`*^9}, {3.705281450648327*^9, 
   3.7052814521184893`*^9}, {3.70528167688867*^9, 3.7052816772300367`*^9}, {
   3.705283703030267*^9, 3.705283709307342*^9}, {3.705315853434494*^9, 
   3.705315856457863*^9}, {3.705316296122167*^9, 3.705316297161759*^9}, 
   3.705395139951586*^9}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Export", "[", 
   RowBox[{"\"\<test.mov\>\"", ",", "myMan"}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.705281127834058*^9, 3.7052811589596863`*^9}, 
   3.7052837169902763`*^9, {3.705316937783525*^9, 3.705316939900653*^9}, 
   3.7053307127868843`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Centroids - Delaunay triangulation method (experimental color coding)\
\>", "Subsection",
 CellChangeTimes->{{3.705224884688384*^9, 3.705224897129682*^9}, {
   3.70522964744569*^9, 3.705229649564056*^9}, {3.705229924845533*^9, 
   3.70522992880319*^9}, {3.705246764069357*^9, 3.705246772653866*^9}, {
   3.705248588609192*^9, 3.705248591985148*^9}, 3.705250746687107*^9, {
   3.7053154360523787`*^9, 3.7053154477787533`*^9}, {3.705393602132834*^9, 
   3.705393602491314*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"myVar", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myTau", "=", "0.25"}], ";"}]}], "Input",
 CellChangeTimes->{{3.705395949209731*^9, 3.705395953275943*^9}, {
  3.705395998010799*^9, 3.7053960186731787`*^9}, {3.705396265024313*^9, 
  3.705396265542944*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myColorFunction", "[", "x_", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"ColorData", "[", "\"\<CMYKColors\>\"", "]"}], "[", "x", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"subRule", "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"x", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", " ", 
   RowBox[{"x", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.705397627298318*^9, 3.7053976573363323`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"myVarPlot", "[", 
   RowBox[{"myVar_", ",", "myTau_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "mesh", ",", "cells", ",", "centroids", ",", "tmp", ",", "tmp2", ",", 
      "varMin", ",", "varMax", ",", "varInt", ",", "plot1", ",", "plot2"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"mesh", " ", "=", " ", 
      RowBox[{"RegionBoundary", "@", 
       RowBox[{"(*", 
        RowBox[{"TriangulateMesh", "@"}], "*)"}], 
       RowBox[{"DelaunayMesh", "@", 
        RowBox[{"selectTau", "[", 
         RowBox[{"centroidData", ",", "myTau"}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"cells", "=", 
      RowBox[{"MeshCells", "[", 
       RowBox[{"mesh", ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"centroids", " ", "=", " ", 
      RowBox[{"PropertyValue", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"mesh", ",", "2"}], "}"}], ",", "MeshCellCentroid"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tmp", " ", "=", " ", 
      RowBox[{"selectVarTau", "[", 
       RowBox[{
        RowBox[{"varData", "[", "myVar", "]"}], ",", "myTau"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"varMin", ",", "varMax"}], "}"}], " ", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"varData", "[", "myVar", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], " ", "//", " ", 
       "MinMax"}]}], 
     StyleBox[";", "MessageName"], "\[IndentingNewLine]", 
     RowBox[{"tmp2", "=", 
      RowBox[{"Map", "[", 
       RowBox[{"subRule", ",", "tmp"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"varInt", "[", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], ":=", " ", 
      RowBox[{
       RowBox[{"Nearest", "[", 
        RowBox[{"tmp2", ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//", 
       "First"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"plot1", "=", 
      RowBox[{"DensityPlot", "[", 
       RowBox[{"y", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "varMin", ",", "varMax"}], "}"}], ",", 
        RowBox[{"ColorFunction", "\[Rule]", "myColorFunction"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "50"}], ",", 
        RowBox[{"Frame", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"False", ",", "Automatic"}], "}"}]}], ",", 
        RowBox[{"AspectRatio", "\[Rule]", "10"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"plot2", "=", 
      RowBox[{"BoundaryMeshRegion", "[", 
       RowBox[{
        RowBox[{"MeshCoordinates", "[", "mesh", "]"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"cells", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"myColorFunction", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"varInt", "[", 
                 RowBox[{
                  RowBox[{"centroids", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"centroids", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"centroids", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", "3"}], "]"}], "]"}]}], "]"}], "-", 
                "varMin"}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"varMax", "-", "varMin"}], ")"}]}], "]"}]}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "cells", "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", 
         RowBox[{"\"\<\[Tau] = \>\"", "<>", 
          RowBox[{"ToString", "[", "myTau", "]"}], "<>", "\"\< - \>\"", " ", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"myTau", "+", "dtau"}], "]"}], "<>", "\"\< fm/c\>\""}]}]}],
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Grid", "[", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Show", "[", 
          RowBox[{"plot2", ",", 
           RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
           RowBox[{"Boxed", "\[Rule]", "True"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "plotrange"}]}], "]"}], ",", 
         "plot1"}], "}"}], "}"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7053932097506638`*^9, 3.705393249338296*^9}, {
  3.705393298496518*^9, 3.7053933018792048`*^9}, {3.705393332007093*^9, 
  3.705393434027042*^9}, {3.7053934746574993`*^9, 3.705393480017612*^9}, {
  3.705393894242814*^9, 3.705393905921002*^9}, {3.7053951176670322`*^9, 
  3.705395176888928*^9}, {3.705397606774131*^9, 3.70539760888419*^9}, {
  3.705397670267879*^9, 3.705397677753587*^9}, {3.705397761129355*^9, 
  3.705397761466723*^9}, {3.705397839316969*^9, 3.705397849508501*^9}, {
  3.705398127446412*^9, 3.7053981285820208`*^9}, {3.705398158894356*^9, 
  3.7053981596132593`*^9}, {3.705398215435351*^9, 3.7053982746066837`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myVarPlot", "[", 
  RowBox[{"3", ",", "0.25"}], "]"}]], "Input",
 CellChangeTimes->{{3.7053935842372723`*^9, 3.705393617043324*^9}, {
  3.7053936535623007`*^9, 3.7053936877769423`*^9}, {3.705393797988764*^9, 
  3.705393837179015*^9}, {3.705395187904169*^9, 3.7053952162932253`*^9}, {
  3.705395654620525*^9, 3.705395661434029*^9}, {3.7053977474974957`*^9, 
  3.7053977660629187`*^9}, {3.705398102014503*^9, 3.705398102112205*^9}, {
  3.705398140395941*^9, 3.705398140521492*^9}, {3.7053981810659733`*^9, 
  3.705398181288109*^9}, {3.705398304973584*^9, 3.705398305082272*^9}, {
  3.7054003562503033`*^9, 3.705400398754408*^9}, {3.7054256954595222`*^9, 
  3.7054256956019077`*^9}, {3.705488317924411*^9, 3.705488320171012*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1XX28z1W2/h0O5yjHy3EcOTjnkLwMiptIg/2M1A0pcec2mFImk5fb9VF6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       "], 
       {Hue[0.6, 0.3, 0.85], EdgeForm[Hue[0.6, 0.3, 0.75]], 
        Polygon3DBox[CompressedData["
1:eJxdnHn8TVXXwM+595dMmZOkMg+FEBlCcxpQSfNIg6SJBoooNKCSSpNQiEqD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         "]], {
         {RGBColor[
          0.9448841243020561, 0.7927421633990093, 0.48327279366874965`], 
          Polygon3DBox[CompressedData["
1:eJwtz68PgWEQwPF7X4rGRiFgo7DRFP+FrKCw8dookqKy0RRF0dioiqSw+bFR
TPGP+N6eC5/dc8/tubsn2+zXAl9EMghhS/LGDnckubwRz8QHnkiFRWKI4kot
wd2FuMcHBxQ8kQGGKNE3hzKO5FPMUCQvII2W3WltY7N1bkC+RN9zfSc2J2zz
dQ/tWxU3R/ce++4fa9/tp7t1qA3Rxsr20v0qtoPuEticvOf++rX/6pu6uB4Z
5iUQN3qOoEutgR5G4nI9t+m1wNziyc4X+r7wNnr+4Q8KkTBG
           "]]}, 
         {RGBColor[
          0.9446434056392046, 0.7943738204068794, 0.48357837631195294`], 
          Polygon3DBox[{{688, 640, 687}, {369, 411, 370}, {980, 979, 992}, {
           1042, 1030, 1041}, {367, 410, 368}, {717, 676, 718}, {689, 690, 
           641}, {398, 446, 397}, {44, 56, 43}, {46, 57, 45}, {107, 95, 
           108}, {677, 720, 719}, {105, 94, 106}, {1044, 1031, 1043}, {400, 
           447, 399}, {982, 981, 993}}]}, 
         {RGBColor[0.9355873310628104, 0.8488697526420539, 0.494629226064232],
           Polygon3DBox[{{709, 767, 769}, {766, 708, 768}, {336, 334, 274}, {
           388, 332, 334}, {378, 318, 320}, {319, 379, 321}, {699, 753, 
           755}, {812, 750, 752}, {333, 389, 335}, {267, 317, 319}, {820, 768,
            770}, {754, 752, 698}, {266, 318, 316}, {771, 769, 821}, {275, 
           335, 337}, {753, 751, 813}}]}, 
         {RGBColor[0.936820445449981, 0.8473999865704416, 0.4935093090613223],
           Polygon3DBox[CompressedData["
1:eJwtzzsOQVEQgOE592o0oqAh8UhoKERjIRqNiuYqXAkNexAJCltQIBF7oKGg
oKHSWIb/ZKb4MnPmvGbKvVE7DkSkhBBPFl+8cAh07fM8mzncyS/EMx6h5itb
5xMiaeTMzmo1JzJB3bSc1ir8t0YVSc5mkLV4DTR/E3/4mFOgtR73O+ibudPa
greKKFisWT7FEDM/Kz2VkcWYdYSJ9dEQ7SvirS4GTuf286ewFb3jz8fsVf0c
FpuWH0N93/+z8bPgFurfe+slsreXTvdfduYPym8qTA==
           "]]}, 
         {RGBColor[
          0.9423884187360486, 0.8096587390733604, 0.4864409913252312], 
          Polygon3DBox[{{842, 841, 902}, {892, 893, 961}, {961, 893, 962}, {
           957, 889, 958}, {188, 189, 249}, {249, 189, 250}, {837, 898, 
           838}, {898, 899, 838}, {126, 125, 194}, {195, 126, 194}, {130, 129,
            198}, {199, 130, 198}, {184, 185, 245}, {842, 902, 903}, {245, 
           185, 246}, {888, 889, 957}}]}, 
         {RGBColor[
          0.9432137601492979, 0.7766083061818314, 0.48494301723459987`], 
          Polygon3DBox[{{829, 823, 880}, {236, 277, 283}, {875, 822, 824}, {
           265, 212, 263}, {809, 856, 811}}]}, 
         {RGBColor[
          0.9448574365029914, 0.7929230606084436, 0.4833066727543298], 
          Polygon3DBox[{{748, 750, 810}, {812, 857, 810}, {874, 823, 821}, {
           267, 214, 265}, {315, 317, 265}, {275, 277, 230}, {213, 266, 
           264}, {773, 771, 823}, {264, 316, 314}, {873, 820, 822}, {277, 337,
            339}, {338, 336, 276}, {770, 772, 822}, {274, 229, 276}, {751, 
           749, 811}, {813, 811, 858}}]}, 
         {RGBColor[0.9411614522615497, 0.76406781061903, 0.4871145742769514], 
          Polygon3DBox[{{488, 431, 486}, {605, 607, 660}, {608, 606, 661}, {
           599, 601, 656}, {481, 479, 426}, {600, 657, 602}, {482, 427, 
           480}, {487, 485, 430}}]}, 
         {RGBColor[
          0.22357114761625363`, 0.21368629620040316`, 0.21657597868208875`], 
          Polygon3DBox[{{543, 541, 481}, {544, 484, 482}, {546, 486, 544}, {
           485, 543, 483}, {544, 602, 604}, {542, 544, 482}, {542, 602, 
           544}, {544, 486, 484}, {606, 544, 604}, {546, 544, 606}, {543, 545,
            605}, {541, 543, 601}, {543, 605, 603}, {601, 543, 603}, {545, 
           543, 485}, {543, 481, 483}}]}, 
         {RGBColor[
          0.9377839028837254, 0.7434295120291335, 0.4906883758401036], 
          Polygon3DBox[CompressedData["
1:eJwtkTsvRFEURveZOwUNBY1nMuPRUFyN+QNKlYLGFKYbBaERIqFQaEg8Ev7B
SDwS0ygUJEI0dHQUNNRKzayd/RUr6ztnn3v2vfuWasszSwUzyyGDiWR2j4fl
PEV+pHgA29BgfxVu5DPlXy76gOks/KM8z/P/1OtyNUVuo7YGXfDN2XeYysJf
yt7zSX3dh8pef9OZPuiELWV3B/Qre+2YviOwIx8p78MgbMp7ygOyryd51zF4
tnBFOdeMhlLc7/eNwrjqfu6U3rvwIp8oN+EBykWza+VSMdxU/izETH2Gc9xV
gz8Lzyo3NPsVWNCe1+7wFWzIvl6XL5V9/t36B+525Qvopf+tfJ5Fdvdov6p/
uZjiu/w7X6EFe11Kig==
           "]]}, 
         {RGBColor[
          0.9442763823431555, 0.7968616048019745, 0.4840442975978029], 
          Polygon3DBox[CompressedData["
1:eJw1kStPQ0EQhXfvvYaQgEBWkSARJSE4Kngl0KoCBgkSKKkkwfIXsMX2L2BJ
Kkl4SCyGh+qFhFfCdzIH8eXM7M7OzmN2/6TbK1JKTSjhDKcFWzDKKd3BFPYC
HMMpjAmcq1J6sT6WYev8G5aq0KIK+54cA7jJYUunydPgvx04gD7+JRxBzf0V
fDpuA9rWc9t9xzYdr1jZbXKtQrYu2ta7jt8u46/DGkyk8P9taQe+XL/60Cw2
i5iNajz030PPpGcdej7vfJjR6xy2Zpdd2wxs+w/13vDZns8HntFDjtrVw0qK
PVzAbY56tCPtRecj32kPz96F8nWdU7PUjMbwxN0rvEENLXr8sU7a/i1D5StW
b+arqHfX+/pwb+qxdk7F/AH0UkqK
           "]]}, 
         {RGBColor[
          0.9427260633185527, 0.7736282660141434, 0.4854590516433061], 
          Polygon3DBox[{{381, 423, 425}, {653, 701, 655}, {707, 665, 663}, {
           765, 707, 705}, {703, 701, 757}, {662, 664, 706}, {700, 652, 
           654}, {387, 331, 385}, {387, 433, 435}, {706, 764, 704}, {702, 756,
            700}, {384, 330, 386}, {432, 386, 434}, {383, 323, 381}, {382, 
           380, 322}, {422, 380, 424}}]}, 
         {RGBColor[
          0.9416052243159697, 0.8149674452987471, 0.4874352250842372], 
          Polygon3DBox[{{237, 340, 278}, {881, 937, 875}, {851, 911, 845}, {
           736, 804, 845}, {829, 886, 785}, {139, 207, 201}, {313, 263, 
           206}, {201, 258, 302}, {212, 150, 206}, {165, 237, 231}, {886, 880,
            948}, {809, 747, 850}, {922, 856, 850}, {236, 242, 176}, {881, 
           824, 774}, {242, 283, 351}}]}, 
         {RGBColor[
          0.9452700492356645, 0.7891731286031446, 0.48276724766646295`], 
          Polygon3DBox[{{574, 638, 575}, {1061, 990, 1060}, {1079, 1078, 
           1028}, {461, 462, 413}, {674, 625, 626}, {581, 643, 582}, {506, 
           505, 444}, {1086, 1085, 1033}, {54, 2, 1}, {454, 455, 408}, {8, 59,
            9}, {679, 632, 633}, {20, 92, 19}, {26, 27, 97}, {513, 512, 
           449}, {1067, 1068, 995}}]}, 
         {RGBColor[
          0.9452228743852347, 0.7904460225822258, 0.4828427640874252], 
          Polygon3DBox[{{443, 395, 396}, {685, 726, 686}, {722, 795, 721}, {
           966, 977, 978}, {686, 637, 685}, {1050, 1040, 1039}, {715, 716, 
           788}, {354, 396, 395}, {673, 716, 715}, {42, 41, 30}, {53, 41, 
           42}, {104, 114, 103}, {1027, 1039, 1040}, {680, 722, 721}, {365, 
           407, 366}, {365, 366, 292}, {103, 91, 104}, {977, 989, 978}, {402, 
           450, 401}, {361, 402, 401}}]}, 
         {RGBColor[0.914281131494734, 0.6409622301838397, 0.5161770080456364],
           Polygon3DBox[{{748, 696, 750}, {315, 377, 317}, {859, 857, 812}, {
           871, 820, 873}, {710, 772, 770}, {751, 697, 749}, {336, 338, 
           390}, {266, 213, 215}, {228, 275, 230}, {214, 267, 216}, {773, 711,
            771}, {274, 227, 229}, {316, 376, 314}, {872, 874, 821}, {339, 
           337, 391}, {860, 813, 858}}]}, 
         {RGBColor[
          0.34333798371514784`, 0.33550710321401966`, 0.337796459363487], 
          Polygon3DBox[{{455, 454, 515}, {1078, 1079, 1070}, {1061, 1060, 
           1070}, {462, 461, 521}, {521, 581, 582}, {625, 566, 626}, {505, 
           506, 566}, {632, 572, 633}, {11, 20, 19}, {11, 1, 2}, {9, 17, 8}, {
           574, 575, 515}, {17, 27, 26}, {572, 512, 513}, {1068, 1067, 
           1076}, {1085, 1086, 1076}}]}, 
         {RGBColor[
          0.8284439358708344, 0.8013818222458821, 0.5572402598256577], 
          Polygon3DBox[{{650, 648, 591}, {927, 925, 861}, {931, 869, 933}, {
           419, 472, 421}, {651, 592, 649}, {160, 226, 162}, {615, 668, 
           666}, {436, 438, 495}, {153, 155, 217}, {154, 218, 156}, {669, 616,
            667}, {161, 225, 159}, {420, 471, 418}, {870, 932, 934}, {862, 
           926, 928}, {496, 439, 437}}]}, 
         {RGBColor[
          0.9403923827545113, 0.8231884174898825, 0.4889748785774347], 
          Polygon3DBox[{{694, 696, 748}, {315, 375, 377}, {857, 859, 923}, {
           164, 228, 230}, {871, 873, 935}, {710, 712, 772}, {697, 695, 
           749}, {390, 338, 392}, {213, 151, 215}, {152, 214, 216}, {713, 711,
            773}, {227, 163, 229}, {314, 376, 374}, {874, 872, 936}, {393, 
           339, 391}, {924, 860, 858}}]}, 
         {RGBColor[
          0.9373648817291463, 0.7408691101707731, 0.4911317441790124], 
          Polygon3DBox[{{741, 728, 740}, {308, 297, 309}, {968, 916, 915}, {
           942, 1052, 941}, {731, 742, 743}, {778, 790, 779}, {345, 356, 
           344}, {143, 144, 32}, {146, 35, 145}, {793, 781, 780}, {170, 169, 
           116}, {307, 306, 294}, {944, 1055, 943}, {171, 119, 172}, {346, 
           347, 359}, {971, 918, 917}}]}, 
         {RGBColor[
          0.9442452025383075, 0.7970729500565614, 0.4840838791037282], 
          Polygon3DBox[{{668, 617, 712}, {648, 694, 583}, {923, 925, 1000}, {
           1016, 933, 935}, {470, 419, 375}, {695, 649, 590}, {497, 438, 
           392}, {151, 64, 153}, {162, 164, 87}, {152, 154, 71}, {669, 713, 
           624}, {163, 161, 80}, {418, 463, 374}, {924, 1007, 926}, {936, 934,
            1023}, {439, 504, 393}}]}, 
         {RGBColor[
          0.942142415360511, 0.8113262173108218, 0.48675328269825235`], 
          Polygon3DBox[CompressedData["
1:eJw10D0OQUEQwPF9VCScgSOQcAIqKg0JlQNQUvgMCRUJCVcgIaEiIT4L7kFC
T0XjP9lR/N7M7s7Om2wwX0wVXMaYANw48TljCT9q8GGOGbZuWyPnC9y4HCPG
McAQTdT1rvTwogwPso4xH/6T0/jV/O6yvf59pEcDe853mCNN3Yv4Rg9V9FHR
XPaOOCBEbdixa8lbxDaGiLK+ECPEq7G57A2MrZMaj85cwpO5HkhoLjGJNXUr
TDA1di15xrGzvnX2mc4v77fRN+yig7GSfIQfS7A4Pg==
           "]]}, 
         {RGBColor[
          0.9420636731414882, 0.8118599536317277, 0.4868532427725384], 
          Polygon3DBox[CompressedData["
1:eJwt0DtuwkAQgOGx6Qi5A1yBxxFIAR0Vj44DhBYKW8KRQhleyR0SXilBwkh2
ARdJ4AJJARX/aKf4vDO7O7s7LnR7jWdfRPLI4JFPgBwSpPjGCnvEuLKv44m0
PTdqfsMnvrDDjH1zRFpDvsASbwgxtj26PsQPj6gyPuHXd7nGob1H3xVR84Ip
AjtHz0uRoMhbSp7LNa7gSFxmnIir19qTuHldT6y/DT7windcuL/GWLf4bHmL
mib+rc+t9a1zf+LmD+J61n4fqBkgi7X9x9hyne9jZPfq/XeJbzg+
           "]]}, 
         {RGBColor[0.945223138620869, 0.7904442315207463, 0.4828424286509343],
           Polygon3DBox[{{692, 644, 691}, {299, 371, 372}, {691, 733, 692}, {
           121, 109, 110}, {1057, 1046, 1045}, {48, 60, 47}, {47, 37, 48}, {
           414, 372, 371}, {1045, 1046, 1034}, {983, 996, 984}, {109, 98, 
           110}, {973, 983, 984}}]}, 
         {RGBColor[
          0.9438903340814363, 0.7994783456235973, 0.4845343703109971], 
          Polygon3DBox[CompressedData["
1:eJwt0D2PQUEUxvEzrqwWlQLxUqjQ2kaz30BWu0S7ye72aoWXoCGxPYlt2GAL
tV6zPVq+gsL/5Ezxy8y5d2bOM5NtfdY+QiKSQYB/ijMuSPEhhihGOGDs5zp2
kQiLLBl/8OxEKijiDVk0EOHfE+J+na7f+bNf/Pkn+l1xQ509TbyiT6YBkmKZ
NFua9X/UK6xRwARTLDDHl9+n+zsoc1YJOWfzu1iteTW3c7Zfz+lhT48tNp7O
82HLpznzgfXRfr9imTVv0lkmzdYWu7fevxrYm+h7vOObeohZYHMdj3gAqzYv
Rw==
           "]]}, 
         {RGBColor[
          0.9426593782416958, 0.7732207911340719, 0.4855296114502108], 
          Polygon3DBox[CompressedData["
1:eJwt0MttAkEMgOGZoQpyggNUwhK4IoVwC2wB0AGPBiCRdkMLyUaC0ACPQiC5
BSiA5yW/ZR8+je0d2d4pxr1GNzjnCsihTRKjjKnFUrvghFeMvHN1zHEn3yDF
G1Y4B/0mdx7xQN5EC+94QcdqE6uvcUNifaTHNWj/1OJPeu3w63W/I+fe67mw
+Ga7JjanZLOe8IwxvmyvCDUMMUPVcokHXu9FNlP+Qeb2UUGGH2zx4bW3zMgH
rck3iTO7L73l/Zb2hgevu/15jeX8xj9T9Do8
           "]]}, 
         {RGBColor[
          0.9207989895406729, 0.6624333318310778, 0.5090037270593503], 
          Polygon3DBox[{{829, 880, 886}, {236, 283, 242}, {207, 258, 201}, {
           804, 851, 845}, {212, 206, 263}, {856, 809, 850}, {237, 278, 
           231}, {881, 875, 824}}]}, 
         {RGBColor[
          0.9388712677563563, 0.7500737852601522, 0.48953782973497795`], 
          Polygon3DBox[{{151, 50, 64}, {694, 634, 583}, {986, 923, 1000}, {
           1024, 1016, 935}, {417, 470, 375}, {440, 497, 392}, {617, 670, 
           712}, {647, 695, 590}, {63, 152, 71}, {624, 713, 683}, {88, 163, 
           80}, {374, 463, 404}, {936, 1023, 1037}, {87, 164, 101}, {504, 453,
            393}, {999, 1007, 924}}]}, 
         {RGBColor[
          0.9427972272438554, 0.7740631086100407, 0.4853837527448928], 
          Polygon3DBox[{{665, 610, 663}, {765, 705, 763}, {655, 598, 653}, {
           758, 756, 702}, {703, 757, 759}, {664, 662, 609}, {384, 328, 
           330}, {423, 478, 425}, {329, 385, 331}, {433, 490, 435}, {762, 704,
            764}, {652, 597, 654}, {383, 325, 323}, {477, 422, 424}, {382, 
           322, 324}, {489, 432, 434}}]}, 
         {RGBColor[
          0.9423538038679548, 0.8098933681271815, 0.4864849335055382], 
          Polygon3DBox[{{188, 247, 187}, {128, 127, 196}, {197, 128, 196}, {
           840, 900, 901}, {840, 839, 900}, {187, 247, 246}, {890, 891, 
           959}, {891, 960, 959}}]}, 
         {RGBColor[0.9451322002335049, 0.7883308111271756, 0.482913106371781],
           Polygon3DBox[{{575, 639, 576}, {1062, 991, 1061}, {1080, 1079, 
           1029}, {460, 461, 412}, {675, 626, 627}, {580, 642, 581}, {507, 
           506, 445}, {55, 3, 2}, {7, 58, 8}, {26, 96, 25}, {678, 631, 632}, {
           21, 93, 20}, {455, 456, 409}, {1085, 1084, 1032}, {1066, 1067, 
           994}, {512, 511, 448}}]}, 
         {RGBColor[
          0.9425210315897088, 0.772375432800789, 0.48567599672125195`], 
          Polygon3DBox[{{608, 550, 548}, {659, 657, 761}, {540, 538, 600}, {
           429, 431, 327}, {549, 547, 487}, {661, 659, 761}, {548, 550, 
           488}, {538, 540, 480}, {427, 429, 327}, {658, 660, 760}, {428, 326,
            430}, {549, 607, 547}, {539, 599, 537}, {479, 539, 537}, {658, 
           760, 656}, {426, 326, 428}}]}, 
         {RGBColor[0.554607237455159, 0.5767175744160866, 0.8193020266594883],
           Polygon3DBox[{{817, 864, 866}, {863, 816, 865}, {865, 816, 867}, {
           536, 474, 534}, {614, 554, 552}, {536, 534, 594}, {553, 613, 
           551}, {493, 553, 551}, {270, 219, 221}, {223, 270, 221}, {473, 535,
            533}, {533, 535, 593}, {220, 271, 222}, {222, 271, 224}, {554, 
           494, 552}, {817, 866, 868}}]}, 
         {RGBColor[
          0.13423756222664496`, 0.12282066244018713`, 0.12615812583859126`], 
          Polygon3DBox[{{483, 426, 428}, {548, 546, 608}, {661, 604, 659}, {
           484, 429, 427}, {431, 429, 484}, {483, 428, 430}, {659, 604, 
           657}, {542, 540, 600}, {547, 545, 487}, {607, 545, 547}, {540, 542,
            480}, {546, 548, 488}, {603, 658, 656}, {541, 599, 539}, {479, 
           541, 539}, {660, 658, 603}}]}, 
         {RGBColor[
          0.942812156738674, 0.7741543343294597, 0.48536795577319775`], 
          Polygon3DBox[{{885, 835, 886}, {885, 886, 954}, {846, 798, 845}, {
           882, 881, 830}, {905, 846, 845}, {242, 241, 182}, {242, 289, 
           241}, {882, 949, 881}, {202, 133, 201}, {202, 201, 252}, {206, 205,
            257}, {205, 206, 138}, {238, 284, 237}, {803, 849, 850}, {849, 
           910, 850}, {238, 237, 177}}]}, 
         {RGBColor[
          0.9374584398966771, 0.7414407913457988, 0.49103274982305656`], 
          Polygon3DBox[{{33, 144, 145}, {729, 741, 742}, {345, 346, 358}, {
           779, 792, 780}, {308, 307, 295}, {942, 943, 1054}, {117, 171, 
           170}, {916, 970, 917}}]}, 
         {RGBColor[
          0.8425902410303253, 0.4716051791031232, 0.5897091251005705], 
          Polygon3DBox[{{911, 905, 845}, {881, 774, 830}, {798, 736, 845}, {
           133, 139, 201}, {886, 835, 785}, {252, 201, 302}, {313, 206, 
           257}, {206, 150, 138}, {954, 886, 948}, {747, 803, 850}, {910, 922,
            850}, {237, 165, 177}, {237, 284, 340}, {242, 182, 176}, {881, 
           949, 937}, {289, 242, 351}}]}, 
         {RGBColor[
          0.4474838529523855, 0.4413174187360487, 0.4418487820418978], 
          Polygon3DBox[{{516, 515, 575}, {1071, 1061, 1070}, {1079, 1071, 
           1070}, {1067, 1075, 1076}, {515, 516, 455}, {521, 461, 520}, {521, 
           520, 581}, {566, 506, 567}, {626, 566, 567}, {12, 20, 11}, {17, 26,
            16}, {11, 2, 12}, {8, 17, 16}, {1075, 1085, 1076}, {512, 572, 
           571}, {572, 632, 571}}]}, 
         {RGBColor[
          0.9374121584627391, 0.7411579916156003, 0.49108172043531123`], 
          Polygon3DBox[CompressedData["
1:eJxNkE1KQ1EMhROfugWr+Fel6tBptSjoXKhonTu2ryC4BIUWdC8KFuoSBMHa
TVQFwblCv5ADOvjeyUlu7s1L9bxzXE6Z2TYU0OCzCwfS8FdQQgcG0lL5Q2lD
+YifoAbLcARbsAlN5TdgBepwCXvwydvf8AFd/Il6Ixe1PgzhBl51dsHN5j3j
qqcPVpWPux7V/wVjeI+c3r3QLDW99UbtBUaWPmY4lfYUx8z7sFPkXXHng3q6
lncMNeMzTHtq4RmH/qp+bX+10B+Y9ZxhRhrePb15+pHm7EGLOW7hDBY9/3MO
XdPOY/ct1ZvyoetwpzhqFXqWPHvH2te9tKJ8m3N97S321/4X17WTCeWZQpI=

           "]]}, 
         {RGBColor[0.9143285497649828, 0.8494894490856407, 0.512337974998034],
           Polygon3DBox[CompressedData["
1:eJwtkKtugkEQhXf3d9TBC4AHBw6SH3BcEootqgYUWC6WiwEPLwCeml4s0Edo
fashgeIo8E1mxZdzZvbMZLKJ50697YwxcQhgTrGDDeSsMT0YeMSvYM/bK7zD
LzNVejEYQg3GVt8kM4U3OMCH96Izp3nJrqEEP+yqoEX4xuet3uICvSeNNuHq
VC9O/RY+YQFBoF56I+ZfYOJ3R63ul90PVvd3IQt9+GPmifkjGlJ/kSugEe9D
n5fs0mo26fM3aOEz8O+99MpW/0f+6dHqTXLPibcUmQacndbi77N/OD4=
           "]]}, 
         {RGBColor[
          0.9431490656717502, 0.7762129947310157, 0.4850114707786119], 
          Polygon3DBox[CompressedData["
1:eJwtz0kSwVAQxvGX5CJcydawUGVYsTNcgOAASFCFBAdA5AKGExh2hoP4d71e
/NLfS7+hOltu5hquMSYDD0U+c+RxonGEj6Fr15JvmOPi2n2yP0QFNcRK8hZt
x5g1ulpjzQPOJ0gxwxVneZNeDz4OSNB37B7pBxi59nyq+/d6Zs0MXywxxhR3
rU/NAR54YaJZ/sk7A31L5gt1RrnvrXeu6LXQQeTYteQ6c1ax8WyWusOKMz9E
xuaPrmf0FihoLWn+AyJNPjg=
           "]]}, 
         {RGBColor[0.870829194662053, 0.5273626232282963, 0.5616349438136317],
           Polygon3DBox[{{811, 856, 858}, {851, 810, 857}, {823, 829, 773}, {
           207, 213, 264}, {804, 748, 810}, {809, 811, 749}, {283, 277, 
           339}, {338, 276, 278}, {258, 264, 314}, {315, 265, 263}, {214, 212,
            265}, {231, 276, 229}, {880, 823, 874}, {277, 236, 230}, {822, 
           875, 873}, {772, 824, 822}}]}, 
         {RGBColor[
          0.9452807419891475, 0.7900537801182043, 0.4827693034959197], 
          Polygon3DBox[{{646, 588, 645}, {52, 66, 51}, {1025, 1026, 1018}, {
           99, 85, 100}, {671, 619, 672}, {415, 468, 416}, {62, 69, 61}, {682,
            681, 622}, {442, 499, 441}, {406, 405, 465}, {89, 82, 90}, {636, 
           585, 635}, {987, 1002, 988}, {1036, 1021, 1035}, {998, 997, 
           1005}, {502, 451, 452}}]}, 
         {RGBColor[
          0.9396456528519663, 0.8282499572310914, 0.48992282210069754`], 
          Polygon3DBox[CompressedData["
1:eJwtz6FPAnEYxvH37mwwAkWDbCJBi4Fp1T/CBsmJs8jAYjqqBKuDeldhVoNU
LlFgw8JgI+Hf4ffd7wmfvc+7e+/d+6s/9u97sZmdIcGEZopaEupaeUBN8av6
pVzwbYUtoiOzE8RI2fWEvoUZ/77TTEVzeWR2hUzV+zdUmVuwO0Meh97zHt8Y
Knt9R4NdZZTwwP8/+IhCnqm/4I4m7nCDa5yqXirfWpjzmY7u93e08YqW6rPy
iL1jnKMbhd6z33Osm+b0LyhUP5X/eNMShyTkjfp/s/UuSA==
           "]]}, 
         {RGBColor[
          0.9446362712770784, 0.7944221790668273, 0.48358743309720703`], 
          Polygon3DBox[{{67, 74, 66}, {68, 69, 77}}]}, 
         {RGBColor[
          0.9369739663535119, 0.8463593798508231, 0.49331442046011365`], 
          Polygon3DBox[{{730, 729, 742}, {779, 791, 792}, {729, 730, 688}, {
           357, 345, 358}, {1053, 942, 1054}, {33, 145, 34}, {791, 718, 
           792}, {33, 34, 45}, {117, 106, 118}, {369, 296, 295}, {296, 308, 
           295}, {1042, 1053, 1054}, {916, 969, 970}, {117, 118, 171}, {357, 
           358, 399}, {970, 969, 981}}]}, 
         {RGBColor[
          0.936970531290266, 0.8463826636500571, 0.49331878113449523`], 
          Polygon3DBox[CompressedData["
1:eJwtj8tKQmEUhfd/zpnpqMAKvHQSukCN6kma1TC0QKEUtN6iFPQlCtTeogvU
JEFzXM/ht1n/4GOtvc+/9j47v7o7v03MbBdSmFEsYBn1L/qjYHYGh7DDw234
pv+OjuAtlXf9gXJmNkErmdjI1PN8N2henX0nsAe/zPqHFRTIlWAr6lci3yBz
Ac2gd6+Jcl4/Bn3PmXUc7xmYavdD0z7f5f/uNxShT/0MPWiZavcHzDqFfegE
1e6r3FCDTZim8t57IPMC95G2qXdN5hJugrzrE3yQncNnKu86hjVfEypM
           "]]}, 
         {RGBColor[
          0.9427847859981731, 0.7739870871771914, 0.4853969168879721], 
          Polygon3DBox[{{596, 653, 598}, {595, 597, 652}, {325, 269, 323}, {
           322, 268, 324}, {818, 762, 764}, {814, 756, 758}, {423, 476, 
           478}, {328, 272, 330}, {477, 475, 422}, {611, 664, 609}, {610, 665,
            612}, {491, 489, 434}, {763, 819, 765}, {757, 815, 759}, {331, 
           273, 329}, {490, 492, 435}}]}, 
         {RGBColor[
          0.9439194276043966, 0.7809202418530372, 0.4841963470391453], 
          Polygon3DBox[CompressedData["
1:eJwtkLsSAUEQRWdW6hkREhGx1i9QRWg9UuwuId+L9UhZhFSROFPdwanb3dVz
u3sa0S7cesaYOuTgR9Il6EHRGlOGISzI2+ArAcQwpX8ONUjpO1iJj2gV3aMR
mkALMvInNF2PkRl5Kz7uXQhriD3pCXTe1xO/GUzUb6OeTe1feeJ3MbK3i/vq
n+nMm5U93awzWoIRVGCsM5y/r/e+9ZaT3lNAB/ouNZKXFOdxpfZA71Z2e1nJ
W/qvH7SDJvrHrrZUdfU/4EwmUA==
           "]]}, 
         {RGBColor[
          0.9441772939802912, 0.7975332528568059, 0.4841700862818876], 
          Polygon3DBox[CompressedData["
1:eJwt0L9yAVEUx/Gzu7dBmVLDjFLJNpItPUBKNOhjlGbQ4BVI4080eIVEQ2aU
noA04iF0vmfuKT5zfr+79+6d3Xyr8/4RikgOEYaUBAOjuY+CE/ljwzXyWecF
MTmCcz6H1peByAJno3mOJndk0TKa2/jiji7WWFnWtW/O/OCBKn2MSejzyPrD
9uxR5l0xiFIS3zVX8IqUzTfLW85v0MMu9F1zgCMHf9FgXx0vNmuWTzz7xCzw
WecUab4/QQoZy7p253/9o+j8+w+Bv0O7rt/wBByYLEo=
           "]]}, 
         {RGBColor[
          0.941418145486882, 0.8162355168262687, 0.48767271411978924`], 
          Polygon3DBox[CompressedData["
1:eJwt0DluwkAUxvHn5QRUFDi2oaDiDFlEScUJEC0S0FGAlBSIOIFcJiwGUSQS
FOlo6DkEJSLwf3pT/Dzfm80zk7Z7za4vIgkCbPisscMzXvCKH8aGWGApVmtO
PJEYF7F5kVuXIEYdR99qzVPs8YZPV2uesz7HN0Yo4R0TV2u+4h+/juYy/xb8
0dzE2ppnuYoxMtd+uKz3q4R2xzJSNNB3Z9CzaN/Jt/4ZvpDhzFiL/R+cyLO+
AWOPeEKOFbYohlZrLgQ2T+foe+m7dTzbX/c+4A7KqjND
           "]]}, 
         {RGBColor[
          0.47045892448595616`, 0.46373174934515754`, 0.45444592402620565`], 
          Polygon3DBox[{{456, 516, 517}, {520, 519, 580}, {15, 16, 25}, {568, 
           627, 567}, {13, 21, 12}, {631, 570, 571}}]}, 
         {RGBColor[0.942360145523178, 0.8098503826516723, 0.4864768830297567],
           Polygon3DBox[{{895, 884, 963}, {836, 847, 896}, {191, 240, 251}, {
           124, 203, 192}, {204, 132, 200}, {844, 904, 848}, {239, 183, 
           243}, {883, 887, 955}}]}, 
         {RGBColor[
          0.6376077548440175, 0.4877009553013484, 0.7544353510317168], 
          Polygon3DBox[{{752, 750, 698}, {754, 812, 752}, {755, 753, 813}, {
           751, 753, 699}, {770, 768, 708}, {820, 766, 768}, {317, 379, 
           319}, {332, 274, 334}, {769, 771, 709}, {336, 388, 334}, {267, 319,
            321}, {378, 316, 318}, {318, 266, 320}, {769, 767, 821}, {335, 
           275, 333}, {389, 337, 335}}]}, 
         {RGBColor[
          0.9369795153018323, 0.8463217675597524, 0.4933073762938049], 
          Polygon3DBox[CompressedData["
1:eJwtz9GKQVEUxvF1znE15UKhDMU0KNRcTHkRV8odCjWNMlO8hIjyDmpEXoJC
KWUUl8pr+O/Wuvi1vrXPWau93+rdyrcvIhkE+Ke544Klr73Lr3xM4EjeUjc4
BZqn1qdCIhEkzcLOYtQDc3HqjbrGFUVPpIyC6Xl6luUeH3i3e5WQxkugu9ye
Jv8N0fB018PX3a6vevq9hRraGNkutydruyeib3JvC2NO/4Nfqx3LXebzyFn9
tLxiJsP70sblKAbM/KFvvkTPWnaXMXbMnrHHLNDe5Se8KypM
           "]]}, 
         {RGBColor[
          0.47079466335363884`, 0.46405929400448853`, 0.4546300083360051], 
          Polygon3DBox[{{569, 568, 570}, {518, 516, 519}, {13, 16, 14}, {12, 
           5, 16}, {12, 16, 13}, {518, 520, 517}, {14, 15, 23}, {568, 567, 
           571}, {1064, 1072, 1074}, {1072, 1073, 1074}}]}, 
         {RGBColor[
          0.9397516103008342, 0.7554530618485605, 0.4886063349706909], 
          Polygon3DBox[{{976, 964, 911}, {724, 684, 736}, {1048, 1038, 937}, {
           301, 373, 313}, {786, 774, 714}, {693, 735, 747}, {352, 394, 
           340}, {40, 139, 28}, {39, 150, 49}, {797, 723, 785}, {165, 102, 
           112}, {176, 123, 111}, {302, 364, 290}, {1059, 948, 1047}, {922, 
           975, 985}, {351, 403, 363}}]}, 
         {RGBColor[
          0.9445325321916191, 0.7846665780638449, 0.48354761806820035`], 
          Polygon3DBox[CompressedData["
1:eJw1z7sVQUEUheFxlUABxBQhk2FJ5BIkKIMScJ9zUQJlyFCCDJmM/6zZgm+d
xzzOTHO8GM4j51wDVdwrzpW4os9CF7Uo5CvVCRszPPBBgVK5xYPWMq09ueuN
FmdniDGRf2+Jqd0dhf0nnbnrLXX6gyjEHtaqLU9tBnJ0+MMOG0WrE2wRo+vC
rLbmFdQZBoqJ8hszL/CV8H/LrWdzvGYdscdX0SvPOe8xktSFXqzc3nDmrhc+
ivYey3+RaTo8
           "]]}, 
         {RGBColor[
          0.9331054968573623, 0.7148424124205266, 0.49563862020362115`], 
          Polygon3DBox[CompressedData["
1:eJwt0EsSwUAQgOHJOAIHYM1dkD1RSFhxD27glSBuwFlIpMpjHxzB3zW9+DI9
093zSGM492fWGFNHBRGfMVJUSXTR1nGhcY9cgBgjhDhir/Oj5gJdu3nG5Dh5
bu+D7i9rkqux5wQhmjrKfIWS/Blf+NbVdqyLZVxqT6k1a95wR4Y3EjyxQY4C
U+pbiKyLZVxb1yf9W8R4aPzSWNbkn1w5J1MSpxjwnj4SfJj/cPHc+Tu9Q6Gx
3EVq5A5SJ/9joL1/Wic6PA==
           "]]}, 
         {RGBColor[
          0.9369480712613502, 0.8465349038758189, 0.4933472932362211], 
          Polygon3DBox[{{86, 87, 101}, {70, 63, 71}, {999, 1006, 1007}, {1023,
            1022, 1037}}]}, 
         {RGBColor[
          0.3196405003962328, 0.31140321405627147`, 0.3138113528646703], 
          Polygon3DBox[{{573, 572, 513}, {514, 574, 515}, {1078, 1070, 
           1069}, {565, 505, 566}, {1070, 1060, 1069}, {522, 462, 521}, {572, 
           573, 633}, {522, 521, 582}, {565, 566, 625}, {11, 19, 10}, {10, 1, 
           11}, {1068, 1076, 1077}, {515, 454, 514}, {18, 27, 17}, {18, 17, 
           9}, {1076, 1086, 1077}}]}, 
         {RGBColor[
          0.9420266801526855, 0.8121107022388648, 0.48690020388126337`], 
          Polygon3DBox[CompressedData["
1:eJxN0DkWAUEQxvGmQw7BGTiDLZQROgCxfRfzHpfgPWL77ibcwJb516sKBL+Z
qa+7Z6omWihli0HnXAQeYy5ddPCm/iAfcO5AfcTCa/a1/MHhNFkGG7I1ZriT
J8iSCKGKCuqoIYyt0zOyX76V430v7g00McQZJ8QCWkveQhsdjGyPrF/+1iS/
Os3irN2sluew9VC1WWXmntdZUl7nkf6ld6mXnJtiZaY2p/T7dNrzXObBzuu/
kv+0t9ll7rLXPTvL+/bNCQZWy/MPumg6PA==
           "]]}, 
         {RGBColor[
          0.36476826041244464`, 0.3573049037306345, 0.3594868415009648], 
          Polygon3DBox[CompressedData["
1:eJxNkL0SwVAQhW8ikcagEYxKhU5UiMLfE3gED0AheEXBG/kZ3849heKbPbt3
d8/O7e+Pu0PonOtBBS4kM7hCAmvYWC1ybg4ZnNVjvWXg3A1i9Er9NrdUngjb
sYUOHg3owjTye21nSt6COrTVY70FMyf5mW8hzYiLoQZN6So8uOWueyyW0s/A
v5lO/3xe1N6Qhz5+pEcYDGES+dpX9QH5WG8L3Z6LTH/0AxBMGtc=
           "]]}, 
         {RGBColor[
          0.9423477264483657, 0.8099345625412111, 0.4864926485448287], 
          Polygon3DBox[{{889, 890, 958}, {838, 899, 839}, {960, 892, 961}, {
           248, 188, 249}, {247, 188, 248}, {129, 128, 197}, {127, 126, 
           195}, {127, 195, 196}, {198, 129, 197}, {185, 186, 246}, {841, 901,
            902}, {841, 840, 901}, {839, 899, 900}, {186, 187, 246}, {892, 
           960, 891}, {958, 890, 959}}]}, 
         {RGBColor[
          0.9427654829862014, 0.8071028943420424, 0.48596232345272733`], 
          Polygon3DBox[CompressedData["
1:eJwt0D8IQVEUx/H7PCNWK5sVO6UMyvRKsQoLPZOFnbJi9WfFqthZTMSCnVIm
ZVDK9/TO8Omc333v3Nu90XLTcX3GmAhstAkd5LDUXtZKfCvCwYMf73jhhiue
OGgva1/ZzG+MpaQPYWYZM8VZq+QWkvySQQITzhujrlXyHiv00FXS57FmfoO3
Vsl93VP2iyGFNLLaxzUvmJ/D1Sr5hC3zA+ws7+41vf+RPMJQa0P7MHcLIqD1
Z3t9hZkqmsbrC5rl/eQdL/hY3nly1h+JDjRC
           "]]}, 
         {RGBColor[
          0.9391116326350366, 0.8318696924812621, 0.49060073924879166`], 
          Polygon3DBox[{{828, 834, 835}, {953, 879, 954}, {805, 799, 798}, {
           133, 208, 134}, {289, 288, 282}, {182, 235, 181}, {949, 876, 
           950}, {905, 906, 852}, {211, 138, 137}, {253, 259, 252}, {257, 262,
            256}, {825, 830, 831}, {910, 855, 909}, {802, 808, 803}, {178, 
           232, 177}, {284, 279, 285}}]}, 
         {RGBColor[
          0.9427738377019727, 0.7739201883162843, 0.4854085013338818], 
          Polygon3DBox[{{761, 817, 763}, {326, 270, 328}, {536, 598, 538}, {
           550, 610, 552}, {816, 760, 762}, {597, 535, 537}, {549, 551, 
           609}, {324, 270, 326}, {551, 549, 489}, {536, 538, 478}, {329, 271,
            327}, {760, 816, 758}, {535, 477, 537}, {325, 327, 271}, {490, 
           550, 552}, {759, 817, 761}}]}, 
         {RGBColor[
          0.9369483354969844, 0.8465331128143394, 0.4933469577997302], 
          Polygon3DBox[{{683, 623, 624}, {583, 634, 584}, {1001, 986, 1000}, {
           1017, 1016, 1024}, {470, 417, 469}, {618, 670, 617}, {589, 647, 
           590}, {497, 440, 498}, {65, 64, 50}, {81, 88, 80}, {463, 464, 
           404}, {504, 503, 453}}]}, 
         {RGBColor[
          0.9446907038177451, 0.7940532204020398, 0.4835183331800831], 
          Polygon3DBox[{{687, 728, 688}, {720, 793, 719}, {968, 979, 980}, {
           1052, 1042, 1041}, {297, 369, 370}, {45, 35, 46}, {718, 790, 
           717}, {689, 731, 690}, {356, 398, 397}, {44, 43, 32}, {105, 106, 
           116}, {367, 368, 294}, {1055, 1044, 1043}, {119, 107, 108}, {359, 
           400, 399}, {971, 981, 982}}]}, 
         {RGBColor[
          0.9306351631146896, 0.6997475967139927, 0.49825249245343517`], 
          Polygon3DBox[{{531, 533, 593}, {474, 532, 534}, {865, 867, 929}, {
           863, 865, 929}, {158, 220, 222}, {613, 553, 555}, {534, 532, 
           594}, {554, 556, 494}, {555, 553, 493}, {556, 554, 614}, {221, 219,
            157}, {223, 221, 157}, {533, 531, 473}, {158, 222, 224}, {930, 
           866, 864}, {930, 868, 866}}]}, 
         {RGBColor[0.9426076226596575, 0.772904541973419, 0.4855843742854205],
           Polygon3DBox[{{599, 700, 654}, {384, 386, 430}, {386, 487, 430}, {
           702, 700, 656}, {700, 599, 656}, {663, 608, 707}, {707, 608, 
           661}, {707, 661, 705}, {655, 701, 600}, {703, 657, 701}, {701, 657,
            600}, {385, 431, 387}, {387, 431, 488}, {487, 386, 432}, {662, 
           706, 607}, {607, 706, 660}, {706, 704, 660}, {433, 387, 488}, {381,
            427, 383}, {427, 381, 480}, {381, 425, 480}, {479, 380, 426}, {
           380, 382, 426}, {380, 479, 424}}]}, 
         {RGBColor[
          0.9448395821350578, 0.7865427870265628, 0.4832227270170047], 
          Polygon3DBox[CompressedData["
1:eJxNkU1KA0EQhTsTtwGv4AkScgF/IMaII0kg6jrgQgXj2gt4AddC1l7AC7g2
gnHhBdSACY7kT0j0e/QDXXy8V9XVVT01a+1O8zwJIZQgD5cENdiBjMQMvq1z
+wG8wLt5c25gn7k2rMT6fi6ELjxBkb6f6FcuamZ/Sv4Ezox80f4miecLehXo
uXRP9Xs28qvU7MEVpMlfvG9N7TXzznOnMIF72OLJm1C2Kt4w8rtQgXXYBi3u
AjpWxWW4tVe+Sd0RNHxfcd3asO8x+wEejXyBu1X/h5q9VPme665hnI97+bEu
7fW+qt9bsU+hBYdwYG39yyt3HOI3aCcz72ZqP6TvB4ysY/tXxzr/BUnkVn4=

           "]]}, 
         {RGBColor[0.9276281753101805, 0.8491017631437265, 0.501259271736829],
           Polygon3DBox[CompressedData["
1:eJwt0D1OAlEQwPF5uxR0W0hMVCCAH4mRYjvvYWFH4TYEE5ZAbPQKhgJiwQ0o
jBSEK0BjMIEEQ6MFnbfwP5kpfnnz9V4mr5717vJIRGqI8UGywzcOfmo+p9ko
iNSxIh5h6Tax1U7pJThx715rBpFb3LinYLUS/SN88n7RY639ki/w4/4iqz1w
5x6Zew1Wq7L3NSoYiuUav2CGZzwyN0YHl+RvuBKL9UwxRR8DnLFHGUls8Tay
vO19nbvgrRTn6AbLNdY/0r86xhd31tjHto/ukovt0Qq218RndPYfU14qTA==

           "]]}, 
         {RGBColor[
          0.9283269874475975, 0.6872320321281008, 0.5007187285414412], 
          Polygon3DBox[{{694, 748, 736}, {857, 923, 911}, {935, 873, 937}, {
           313, 375, 315}, {712, 774, 772}, {695, 747, 749}, {338, 340, 
           392}, {151, 213, 139}, {150, 214, 152}, {785, 713, 773}, {163, 165,
            229}, {314, 374, 302}, {948, 874, 936}, {176, 164, 230}, {339, 
           393, 351}, {922, 924, 858}}]}, 
         {RGBColor[
          0.9424795800298837, 0.8090408228629158, 0.48632526573587326`], 
          Polygon3DBox[{{887, 888, 956}, {893, 894, 962}, {962, 894, 963}, {
           894, 895, 963}, {190, 191, 251}, {250, 190, 251}, {189, 190, 
           250}, {843, 842, 903}, {843, 904, 844}, {836, 897, 837}, {897, 898,
            837}, {897, 836, 896}, {131, 130, 199}, {955, 887, 956}, {193, 
           124, 192}, {194, 125, 193}, {125, 124, 193}, {132, 131, 200}, {200,
            131, 199}, {904, 843, 903}, {244, 184, 245}, {183, 184, 244}, {
           243, 183, 244}, {956, 888, 957}}]}, 
         {RGBColor[0.9392059647564833, 0.8312302835330628, 0.490480988421543],
           Polygon3DBox[{{71, 79, 78}, {1009, 1008, 1016}, {1000, 1008, 
           1009}, {530, 470, 529}, {617, 557, 558}, {530, 529, 590}, {558, 
           557, 497}, {72, 64, 73}, {624, 563, 564}, {72, 73, 80}, {524, 463, 
           523}, {583, 524, 523}, {1015, 1014, 1023}, {79, 87, 78}, {564, 563,
            504}, {1014, 1015, 1007}}]}, 
         {RGBColor[
          0.9446497472944279, 0.7943308349313702, 0.4835703258361715], 
          Polygon3DBox[{{688, 689, 640}, {688, 730, 689}, {44, 33, 45}, {44, 
           45, 57}, {718, 676, 719}, {792, 718, 719}, {398, 357, 399}, {368, 
           369, 295}, {369, 368, 411}, {1042, 1054, 1043}, {1042, 1043, 
           1030}, {118, 106, 107}, {106, 94, 107}, {447, 398, 399}, {981, 980,
            993}, {969, 980, 981}}]}, 
         {RGBColor[
          0.4708012464686917, 0.46406571644878936`, 0.4546336178322758], 
          Polygon3DBox[{{631, 569, 570}, {1063, 1071, 1072}, {14, 16, 15}, {
           516, 576, 519}, {520, 518, 519}, {1071, 1080, 1073}, {1072, 1071, 
           1073}, {21, 13, 14}, {627, 568, 569}, {516, 518, 517}, {520, 460, 
           517}, {567, 507, 571}, {570, 568, 571}, {1074, 1073, 1075}, {1073, 
           1084, 1075}, {1065, 1074, 1075}}]}, 
         {RGBColor[
          0.9435083688470542, 0.7784084937117002, 0.48463129032648344`], 
          Polygon3DBox[{{379, 423, 381}, {701, 653, 699}, {665, 707, 709}, {
           765, 767, 707}, {701, 755, 757}, {664, 708, 706}, {698, 652, 
           700}, {331, 387, 333}, {389, 387, 435}, {764, 706, 766}, {756, 754,
            700}, {386, 330, 332}, {386, 388, 434}, {381, 323, 321}, {380, 
           320, 322}, {380, 422, 378}}]}, 
         {RGBColor[
          0.9420324933366403, 0.8120712988863146, 0.4868928242784637], 
          Polygon3DBox[{{779, 780, 891}, {943, 942, 959}, {247, 346, 345}, {
           187, 170, 171}, {145, 144, 128}, {307, 308, 196}, {916, 917, 
           900}, {742, 741, 840}}]}, 
         {RGBColor[
          0.9445360157404102, 0.7846878640650427, 0.4835439321081382], 
          Polygon3DBox[{{556, 624, 564}, {1016, 1008, 929}, {1008, 1000, 
           929}, {470, 530, 532}, {555, 557, 617}, {532, 530, 590}, {555, 497,
            557}, {463, 531, 523}, {64, 72, 157}, {157, 72, 80}, {531, 583, 
           523}, {930, 1015, 1023}, {79, 158, 87}, {71, 158, 79}, {556, 564, 
           504}, {1015, 930, 1007}}]}, 
         {RGBColor[
          0.9427922507455824, 0.774032700036901, 0.48538901840212456`], 
          Polygon3DBox[{{707, 767, 709}, {708, 766, 706}, {386, 332, 388}, {
           380, 378, 320}, {379, 381, 321}, {701, 699, 755}, {389, 333, 
           387}, {700, 754, 698}}]}, 
         {RGBColor[
          0.9447792227552372, 0.7934532148063906, 0.48340596195563407`], 
          Polygon3DBox[CompressedData["
1:eJwt0C9PglEUx/EDlyTBzcAIuAkEZ2AjQNM3YZTiIBAYjwYa0CDRCND80x6C
jYRNbQQGMxhkFngffs+eX/jsnPPce8+9zyk2H26jtJldIOCNYohvxYHyWcps
jhJi6nM274hfxF/ssQ1J7Xk6Y5ZHEM9PsWHtBwc806uCJ8We8mvecYkbvHLH
GXtfFL1e4w9jjLBU7fk959+xwkLvjPV9orUr+tZRUKwpr+pev7+PCE10OPOB
KdrUj2iI53eWzKar+eT4zzJOFLPKvVdLvb3np/oeQzIXn8k/icsuSA==
           "]]}, 
         {RGBColor[
          0.3644389980400102, 0.3569699945918804, 0.3591535827762888], 
          Polygon3DBox[{{12, 3, 4}, {516, 456, 455}, {516, 575, 576}, {1063, 
           1062, 1071}, {1062, 1061, 1071}, {1080, 1071, 1079}, {520, 580, 
           581}, {461, 460, 520}, {12, 21, 20}, {627, 626, 567}, {506, 507, 
           567}, {16, 6, 7}, {12, 2, 3}, {16, 7, 8}, {16, 26, 25}, {511, 512, 
           571}, {632, 631, 571}, {510, 511, 571}, {1067, 1066, 1075}, {1084, 
           1085, 1075}, {1066, 1065, 1075}}]}, 
         {RGBColor[
          0.9370523576376076, 0.7389594517776018, 0.4914624274531629], 
          Polygon3DBox[{{740, 727, 739}, {967, 915, 914}, {941, 1051, 940}, {
           309, 298, 310}, {777, 789, 778}, {732, 743, 744}, {344, 355, 
           343}, {347, 348, 360}, {142, 143, 31}, {36, 146, 147}, {794, 782, 
           781}, {168, 115, 169}, {306, 305, 293}, {945, 1056, 944}, {172, 
           120, 173}, {919, 918, 972}}]}, 
         {RGBColor[
          0.9440948524623881, 0.7980920640384256, 0.48427474246704616`], 
          Polygon3DBox[{{736, 748, 804}, {922, 858, 856}, {236, 176, 230}, {
           937, 873, 875}, {749, 747, 809}, {340, 338, 278}, {857, 911, 
           851}, {214, 150, 212}, {283, 339, 351}, {785, 773, 829}, {139, 213,
            207}, {258, 314, 302}, {313, 315, 263}, {880, 874, 948}, {229, 
           165, 231}, {772, 774, 824}}]}, 
         {RGBColor[0.9452451667443, 0.7890210857374462, 0.48279357595262146`],
           Polygon3DBox[{{529, 470, 528}, {1009, 1016, 1010}, {1000, 1009, 
           1010}, {617, 558, 559}, {529, 528, 590}, {624, 562, 563}, {558, 
           497, 559}, {64, 74, 73}, {73, 74, 80}, {463, 524, 525}, {524, 583, 
           525}, {1014, 1013, 1023}, {1013, 1014, 1007}, {71, 78, 77}, {78, 
           87, 77}, {563, 562, 504}}]}, 
         {RGBColor[
          0.943908302104569, 0.7993565534429878, 0.48451156062961637`], 
          Polygon3DBox[CompressedData["
1:eJwt0K9PQlEUwPHzfrA9SAYpJAwWDCZ8m+BI/gNUddOXKD43KBR0U6KFBGzI
hmxAohjFDSgUCFJMwKb8FSS+7p7w2c6599x7zr1HwUM+tEUkCQePJE/I4RLP
eMGxK7KhYA2f2EUEC0vkDS1MMUENp9yVRQbC+bHuvRMX0cWOfIQvXZ+jgwJH
rnCNM/jmCqnqLB+4Iw9wj3Pt4/2/gZkOdL4+dT2UbRMP8I00dSm9+0b7HOKT
OV51pjZK+rYZmmhY5n8qGCIkr+v6Sv9miTi9Y4jiAp7Gt/RIiJn9hPyP2l9s
8eOYfA/W6i9H
           "]]}, 
         {RGBColor[
          0.9364778389360402, 0.8488437942131912, 0.4938874252935448], 
          Polygon3DBox[{{923, 986, 911}, {634, 694, 736}, {302, 374, 404}, {
           1024, 935, 937}, {313, 417, 375}, {440, 392, 340}, {774, 712, 
           670}, {695, 647, 747}, {151, 139, 50}, {150, 152, 63}, {683, 713, 
           785}, {165, 163, 88}, {948, 936, 1037}, {922, 999, 924}, {164, 176,
            101}, {351, 393, 453}}]}, 
         {RGBColor[0.852632603017416, 0.8193507841773184, 0.5469204090933839],
           Polygon3DBox[{{29, 41, 28}, {685, 724, 725}, {965, 964, 977}, {
           1048, 1049, 1039}, {300, 372, 301}, {787, 786, 715}, {797, 796, 
           722}, {735, 692, 734}, {353, 395, 352}, {39, 48, 38}, {362, 363, 
           402}, {112, 103, 113}, {365, 291, 290}, {1058, 1059, 1046}, {122, 
           110, 123}, {974, 984, 975}}]}, 
         {RGBColor[
          0.9437196378616756, 0.8006353713393867, 0.4847510622841138], 
          Polygon3DBox[CompressedData["
1:eJxN0SlPQ0EUhuG5t4ULkgQEEoOApEHBZREIfgG6rK5JQxMQOFZNUslSDKVF
kqBZHQISEhIkS/kZCHi/zCcQT+7Mmcy555wZWq3Nr6UhhDEUUMI0pnDJwQ62
cZKE0MB6EveKz+KVSx/4xHAxfrXvZt2FPuReK3bM/RqO8OScyt0mVwubaGID
5/bs2BX2sIsZcmXowZxjOvsh1w1uTesD5PQzgVF/c/er+/3oxQg6BL+w73z6
Z9F9qIdJz0jzabq2szTGFcuwhGVUUUEZCyH2feje1e8FXvDL/g73GP9XY9vn
msu1+1A/i843EOK64v2p36fhN9pK4xs+JnHu+u+730fvlrl3zUD1rrjmQdev
Ph5cV9011r3/5v5bIc6r47Xm9gd+2UiM
           "]]}, 
         {RGBColor[
          0.9432142577991253, 0.7766113470391455, 0.4849424906688767], 
          Polygon3DBox[{{804, 810, 851}, {207, 264, 258}, {231, 278, 
           276}}]}, 
         {RGBColor[
          0.8870567000308517, 0.5597568604051855, 0.5454608162812222], 
          Polygon3DBox[{{317, 267, 265}, {751, 811, 813}, {812, 810, 750}, {
           277, 275, 337}, {266, 316, 264}, {823, 771, 821}, {336, 274, 
           276}, {820, 770, 822}}]}, 
         {RGBColor[
          0.20050396655314062`, 0.19022351882255456`, 0.19322882459907942`], 
          Polygon3DBox[{{606, 604, 661}, {605, 660, 603}, {542, 600, 602}, {
           608, 546, 606}, {601, 603, 656}, {484, 427, 482}, {657, 604, 
           602}, {431, 484, 486}, {546, 488, 486}, {542, 482, 480}, {605, 545,
            607}, {481, 426, 483}, {487, 545, 485}, {485, 483, 430}, {541, 
           479, 481}, {541, 601, 599}}]}, 
         {RGBColor[
          0.9446360070414441, 0.7944239701283067, 0.4835877685336979], 
          Polygon3DBox[{{1003, 1002, 1010}, {1010, 1018, 1019}, {468, 467, 
           528}, {499, 500, 559}, {619, 559, 620}, {528, 587, 588}, {622, 621,
            562}, {74, 83, 82}, {586, 525, 585}, {465, 525, 466}, {1013, 1020,
            1021}, {1004, 1013, 1005}, {85, 84, 77}, {562, 501, 502}}]}, 
         {RGBColor[
          0.9436778886314554, 0.8009183590531556, 0.48480406124967484`], 
          Polygon3DBox[{{509, 446, 447}, {640, 641, 578}, {689, 641, 640}, {
           992, 1064, 993}, {446, 398, 447}, {94, 23, 95}, {56, 44, 57}, {56, 
           57, 5}, {629, 677, 676}, {676, 677, 719}, {458, 411, 410}, {411, 
           368, 410}, {1030, 1043, 1031}, {1082, 1030, 1031}, {94, 95, 107}, {
           980, 992, 993}}]}, 
         {RGBColor[
          0.9452098336065623, 0.7888051848681543, 0.48283096211896653`], 
          Polygon3DBox[CompressedData["
1:eJwt0MkRQUEQxvF51ghsNy62CN7DwRaBAKgSAAfblTS4kgZXWxDEYf13zXf4
1XxdXnebKY2ng0nMOVdEHHuKORZoY42OWO6iknDuwcdlzgghUmiotnwNnLth
p/OubPNn2pFn3wg59DR7g37M15aXWOGAD/1vHHW+lEP6E/r/KURIY4is5kf6
LalvQ+WFdtj8L7NO+AW+z/ozuAT+PlucA19brjGojmfcv4e9SxVNvUUaLdWW
C7qv3fujXbbTemqa8wdOOCpM
           "]]}, 
         {RGBColor[0.6373608833866684, 0.487923497540939, 0.7546266474075508],
           Polygon3DBox[{{867, 818, 869}, {595, 650, 593}, {863, 861, 814}, {
           474, 476, 421}, {611, 613, 666}, {596, 594, 651}, {491, 436, 
           493}, {475, 473, 420}, {219, 268, 217}, {218, 269, 220}, {667, 614,
            612}, {272, 223, 225}, {868, 870, 819}, {273, 226, 224}, {492, 
           494, 437}, {864, 815, 862}}]}, 
         {RGBColor[
          0.9432212248967072, 0.7766539190415408, 0.48493511874875234`], 
          Polygon3DBox[{{527, 522, 582}, {1060, 1011, 1069}, {1011, 1078, 
           1069}, {462, 522, 527}, {505, 565, 560}, {565, 625, 560}, {10, 75, 
           1}, {18, 9, 76}, {75, 10, 19}, {454, 526, 514}, {514, 526, 574}, {
           18, 76, 27}, {573, 513, 561}, {561, 633, 573}, {1086, 1012, 
           1077}, {1012, 1068, 1077}}]}, 
         {RGBColor[
          0.9443855116601233, 0.7961218964109203, 0.48390576232706417`], 
          Polygon3DBox[{{1011, 1003, 1010}, {1011, 1010, 1019}, {467, 527, 
           528}, {559, 500, 560}, {620, 559, 560}, {527, 587, 528}, {74, 67, 
           75}, {621, 561, 562}, {75, 83, 74}, {525, 586, 526}, {466, 525, 
           526}, {1012, 1020, 1013}, {1013, 1004, 1012}, {76, 68, 77}, {84, 
           76, 77}, {561, 501, 562}}]}, 
         {RGBColor[
          0.9411788700055049, 0.7641742406250188, 0.48709614447664046`], 
          Polygon3DBox[{{123, 191, 122}, {797, 895, 796}, {725, 724, 836}, {
           964, 965, 896}, {28, 124, 29}, {291, 192, 290}, {301, 200, 300}, {
           38, 132, 39}, {963, 1059, 1058}, {113, 183, 112}, {735, 734, 
           844}, {352, 243, 353}, {1049, 1048, 955}, {787, 887, 786}, {362, 
           251, 363}, {904, 974, 975}}]}, 
         {RGBColor[
          0.9416498801381672, 0.8146647559087031, 0.48737853631727635`], 
          Polygon3DBox[CompressedData["
1:eJwtzztOgkEQwPH99mslgRvoBSSBG2AHndAhFPKssIULYKLSI7YKPY8ELiBH
ANSGRweldJDwn8wUv8zs7O7s7M3j033DO+euEaLEoocuChTy+Cf/Cpz7wyDQ
9W2o+3L2286vuH/Ffgo19io4eY0Jy18xQwc5W0v+y51P9DFl/YI3/NBziTvq
bYwxxAgTPKMV6Hwy2zt35vjwmkssIxJoL+kjvbPWX95s2rtRrDmTJi6c/idl
ta3V5f29zVDlT3WcvUqGWouxl8HGadw5zQ82s8xe5FwcR6+5xAfiBUq0Ojw=

           "]]}, 
         {RGBColor[
          0.9292248235041468, 0.6911298070862094, 0.4997447797128978], 
          Polygon3DBox[CompressedData["
1:eJwtj7FqQkEQRfdlzT/EQnxJYf5Bi4BYiqCQ9wH2PiEQ0ghaBFHBnxFUxMJA
GhFeoX+hhSCWIniGvcXZmXtnZ2b3td1tpU/OuRg8pBwr+IcKfENfMZVfVc38
Ez0X2EAD/QkD6KH3sFM9Hzl30725C33mxfJ/6PmCMpR8mFWDonRNsyeav6Tn
CDMXdg21L8e8O/FPu01bnsEBfmELDv9ZZPKsPtadd3a8Qd2H3GITppDASCTy
z3qPvesKBea+RME3bbn97cOHv3b03zUspC1/APHiM0M=
           "]]}, 
         {RGBColor[
          0.9420760922163005, 0.8117757737421888, 0.4868374772574664], 
          Polygon3DBox[{{885, 884, 895}, {884, 885, 963}, {241, 240, 191}, {
           847, 846, 896}, {203, 124, 202}, {240, 241, 251}, {882, 887, 
           883}, {846, 847, 836}, {203, 202, 192}, {204, 205, 132}, {205, 204,
            200}, {844, 848, 849}, {848, 904, 849}, {238, 183, 239}, {239, 
           243, 238}, {882, 883, 955}}]}, 
         {RGBColor[
          0.9452979176259928, 0.7893434166127266, 0.4827377599859655], 
          Polygon3DBox[{{684, 634, 736}, {785, 723, 683}, {986, 976, 911}, {
           1047, 948, 1037}, {1038, 1024, 937}, {647, 693, 747}, {313, 373, 
           417}, {774, 670, 714}, {340, 394, 440}, {50, 139, 40}, {49, 150, 
           63}, {102, 165, 88}, {364, 302, 404}, {999, 922, 985}, {101, 176, 
           111}, {351, 453, 403}}]}, 
         {RGBColor[
          0.9448265209337777, 0.7931326148015511, 0.48334591882376426`], 
          Polygon3DBox[CompressedData["
1:eJwtkStPA1EQhee2TbAEhWDb7iJQBCSKR/sPSLCEYEkAj+bRpTQYBH8AgSFQ
ujw0HlNPsPyGAv0mc8S358y9Z5K5s/n+0fZhzcxWoQ7XfD6gB/MNswp9gS3I
oANtGNPUUrZU3u9noQuL8EWmUOZSOe/7hmY9+sfyHfV77zFzPMGjxQz3nI1g
L5ntwAI0U9SZ1+TO4NzCn6p231f9B79QkJ+gKym8n010XqJL0INl6jVIKbyr
ybv+IzfKl+pxfwF3Fm/w+TPN6TO/8oY3300j9F3edSj/U4u9+f4K7TDXToba
SwUjOJE+yz/ozv0MPXOwrv/o+6tU+/mGcL8JOfPtwgG0U9TuW6rd35IbwCdc
QV9+oNr9FMiDQJQ=
           "]]}}}],
      Boxed->True,
      ImageSize->400,
      Lighting->{{"Ambient", 
         GrayLevel[0.45]}, {"Directional", 
         GrayLevel[0.3], 
         ImageScaled[{2, 0, 2}]}, {"Directional", 
         GrayLevel[0.33], 
         ImageScaled[{2, 2, 2}]}, {"Directional", 
         GrayLevel[0.3], 
         ImageScaled[{0, 2, 2}]}},
      PlotLabel->FormBox["\"\[Tau] = 0.25 - 0.45 fm/c\"", TraditionalForm],
      PlotRange->{{-11, 11}, {-11, 11}, {-9, 9}},
      ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], 
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxl1H3sr3Vdx/EPyIxVslnpGjOYTA5ETUAUqZinkljcaIZNkUyDRJvBuSE4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       "], {
        {GrayLevel[0.8], EdgeForm[None], 
         GraphicsGroupBox[PolygonBox[CompressedData["
1:eJw0nXf8zmX7xu/PuPd9k6yWiJQo0UBkZCQlSgpJSSorClEkRKQIUSQqlaTS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           
           "]]]}, {}, {}, {}, {}},
       VertexColors->CompressedData["
1:eJztzulXFPQex3F2xYuAo6wKiRpisrgki6JfZUnQDCE0RS/iIJAkuFSaCkUn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        "]],
      AspectRatio->10,
      AxesLabel->{None, None},
      DisplayFunction->Identity,
      Frame->{True, True},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->{
        Directive[
         GrayLevel[0], FontSize -> 22, FontFamily -> "Arial", 
         AbsoluteThickness[1]], 
        Directive[
         GrayLevel[0], FontSize -> 22, FontFamily -> "Arial", 
         AbsoluteThickness[1]]},
      FrameTicks->{{Automatic, Automatic}, {False, False}},
      FrameTicksStyle->{
        Directive[
         GrayLevel[0], FontSize -> 20, FontFamily -> "Arial"], 
        Directive[
         GrayLevel[0], FontSize -> 20, FontFamily -> "Arial"]},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->50,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultPlotStyle" -> Automatic, 
        "ScalingFunctions" -> None},
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.02]}},
      Ticks->{Automatic, Automatic}]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.7053936602070503`*^9, 3.7053936897029448`*^9}, {
   3.705393807634048*^9, 3.705393839235469*^9}, 3.705393909492277*^9, {
   3.7053951573689938`*^9, 3.705395222522966*^9}, {3.705395656878977*^9, 
   3.705395670438438*^9}, 3.70539768751552*^9, {3.705397756136812*^9, 
   3.705397773563181*^9}, 3.705397858969191*^9, {3.705397891302218*^9, 
   3.7053979167755747`*^9}, 3.705398034293874*^9, 3.7053981121597977`*^9, {
   3.705398149218946*^9, 3.705398188693884*^9}, 3.705398224739737*^9, {
   3.705398283979883*^9, 3.705398313273388*^9}, {3.705400364704925*^9, 
   3.705400407367015*^9}, {3.705425691048533*^9, 3.705425699100195*^9}, {
   3.7054883177337017`*^9, 3.705488328237097*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"myFigs", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"myVarPlot", "[", 
       RowBox[{"3", ",", "t"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0.25", ",", "13.75", ",", "dtau"}], "}"}]}], 
     "]"}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{"\"\<temp.gif\>\"", ",", "myFigs", ",", 
     RowBox[{"\"\<DisplayDurations\>\"", "\[Rule]", "0.5"}]}], "]"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.705393641981461*^9, 3.7053936518501787`*^9}, {
  3.7053936964495497`*^9, 3.705393709273199*^9}, {3.70539383063597*^9, 
  3.705393854898302*^9}, {3.705393953494903*^9, 3.7053939589651527`*^9}, {
  3.705398203610409*^9, 3.70539821092174*^9}, {3.7053982955910254`*^9, 
  3.705398297740168*^9}, {3.705398340626773*^9, 3.705398347730822*^9}, {
  3.705425710043684*^9, 3.705425712817255*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Do freeze-out!", "Section",
 CellChangeTimes->{{3.705224841322744*^9, 3.7052248728109913`*^9}, {
  3.7053288049233503`*^9, 3.705328808833517*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"m", "  ", "=", " ", "0.14"}], ";"}], " ", 
  RowBox[{"(*", " ", "pion", " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.705329306958754*^9, 3.705329307183446*^9}, {
  3.705329350685873*^9, 3.705329356333727*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"mt", " ", 
     RowBox[{"Cosh", "[", "y", "]"}]}], ",", 
    RowBox[{"pt", " ", 
     RowBox[{"Cos", "[", "phi", "]"}]}], ",", " ", 
    RowBox[{"pt", " ", 
     RowBox[{"Sin", "[", "phi", "]"}]}], ",", 
    RowBox[{"mt", " ", 
     RowBox[{"Sinh", "[", "y", "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7053261782501993`*^9, 3.705326215114744*^9}, {
  3.705327710848881*^9, 3.705327723511685*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SqrtBox[
     RowBox[{"0.019600000000000003`", "\[VeryThinSpace]", "+", 
      SuperscriptBox["pt", "2"]}]], " ", 
    RowBox[{"Cosh", "[", "y", "]"}]}], ",", 
   RowBox[{"pt", " ", 
    RowBox[{"Cos", "[", "phi", "]"}]}], ",", 
   RowBox[{"pt", " ", 
    RowBox[{"Sin", "[", "phi", "]"}]}], ",", 
   RowBox[{
    SqrtBox[
     RowBox[{"0.019600000000000003`", "\[VeryThinSpace]", "+", 
      SuperscriptBox["pt", "2"]}]], " ", 
    RowBox[{"Sinh", "[", "y", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.705326215480032*^9, 3.705327726357362*^9, 
  3.7053278990650473`*^9, 3.7053294355799503`*^9, 3.7053294763131647`*^9, 
  3.7053295231937943`*^9, 3.705351623081973*^9, 3.705351975860662*^9, 
  3.705361777453409*^9, 3.705363734919671*^9, 3.705400313600315*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"u", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u0", " ", 
      RowBox[{"Cosh", "[", "t", "]"}]}], ",", "ux", ",", "uy", ",", 
     RowBox[{"u0", " ", 
      RowBox[{"Sinh", "[", "t", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"up", " ", 
      RowBox[{"Cosh", "[", "t", "]"}]}], ",", 
     RowBox[{"u0", " ", 
      RowBox[{"ux", "/", "up"}]}], ",", 
     RowBox[{"u0", " ", 
      RowBox[{"uy", "/", "up"}]}], ",", 
     RowBox[{"up", " ", 
      RowBox[{"Sinh", "[", "t", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Y", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{"-", "uy"}], "/", "up"}], ",", 
     RowBox[{"ux", "/", "up"}], ",", "0"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Z", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sinh", "[", "t", "]"}], ",", "0", ",", "0", ",", 
     RowBox[{"Cosh", "[", "t", "]"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.7053262203679132`*^9, 3.705326245409482*^9}, 
   3.705326312985229*^9, {3.705326387158291*^9, 3.7053264596516848`*^9}, {
   3.70532651580061*^9, 3.705326529928088*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", 
      RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.70532624825639*^9, 3.705326270288929*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.705326270740286*^9, 3.705329435665512*^9, 
  3.705329476402933*^9, 3.70532952328341*^9, 3.705351623199937*^9, 
  3.705351975965612*^9, 3.705361777594646*^9, 3.705363735010475*^9, 
  3.705400313718809*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pdu", " ", "=", " ", 
   RowBox[{"p", ".", "g", ".", "u"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pdX", " ", "=", " ", 
   RowBox[{"p", ".", "g", ".", "X"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pdY", " ", "=", " ", 
   RowBox[{"p", ".", "g", ".", "Y"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pdZ", " ", "=", " ", 
   RowBox[{"p", ".", "g", ".", "Z"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.7053262731526413`*^9, 3.705326280472501*^9}, {
  3.705326536657776*^9, 3.705326551271277*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"avg", "[", 
    RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"ax", "^", "2"}]}], "+", 
      RowBox[{"1", "/", 
       RowBox[{"ay", "^", "2"}]}], "+", 
      RowBox[{"1", "/", 
       RowBox[{"az", "^", "2"}]}]}], ")"}], "/", "3"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xix", "[", 
    RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"ax", "^", "2"}]}], " ", "-", " ", 
    RowBox[{"avg", "[", 
     RowBox[{"ax", ",", "ay", ",", "az"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xiy", "[", 
    RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"ay", "^", "2"}]}], " ", "-", " ", 
    RowBox[{"avg", "[", 
     RowBox[{"ax", ",", "ay", ",", "az"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xiz", "[", 
    RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"az", "^", "2"}]}], " ", "-", " ", 
    RowBox[{"avg", "[", 
     RowBox[{"ax", ",", "ay", ",", "az"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.705327144133857*^9, 3.705327247295617*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mt", " ", "=", " ", 
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"m", "^", "2"}], "+", 
     RowBox[{"pt", "^", "2"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"u0", " ", "=", " ", 
   RowBox[{"Sqrt", "[", 
    RowBox[{"1", "+", 
     RowBox[{"up", "^", "2"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"up", " ", "=", " ", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"ux", "^", "2"}], "+", 
      RowBox[{"uy", "^", "2"}]}], "]"}], "+", 
    RowBox[{"10", "^", 
     RowBox[{"(", 
      RowBox[{"-", "10"}], ")"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.705327837757895*^9, 3.705327847514968*^9}, {
  3.70532790676229*^9, 3.705327921104561*^9}, {3.705328554220193*^9, 
  3.705328565266408*^9}, {3.705329359861744*^9, 3.705329371701261*^9}, {
  3.7053295076910152`*^9, 3.7053295126959457`*^9}, {3.7053519604158373`*^9, 
  3.7053519697352247`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"pSigmap", "[", 
    RowBox[{
    "ax_", ",", "ay_", ",", "az_", ",", "ux_", ",", "uy_", ",", "t_", ",", 
     "pt_", ",", "y_", ",", "phi_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"avg", "[", 
      RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], "*", 
     RowBox[{"pdu", "^", "2"}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{"xix", "[", 
      RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], 
     RowBox[{"pdX", "^", "2"}]}], "+", 
    RowBox[{
     RowBox[{"xiy", "[", 
      RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], 
     RowBox[{"pdY", "^", "2"}]}], "+", " ", 
    RowBox[{
     RowBox[{"xiz", "[", 
      RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], 
     RowBox[{"pdZ", "^", "2"}]}], " ", "-", " ", 
    RowBox[{
     RowBox[{"m", "^", "2"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"avg", "[", 
        RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], "-", "1"}], ")"}]}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7053272781454487`*^9, 3.705327284334153*^9}, {
   3.7053273183650312`*^9, 3.705327334525899*^9}, {3.705327436594389*^9, 
   3.705327441136774*^9}, {3.7053275948449793`*^9, 3.705327603267377*^9}, {
   3.705327654778946*^9, 3.7053278101004543`*^9}, {3.705327851490909*^9, 
   3.7053278633386717`*^9}, 3.7053279320818863`*^9, {3.705328182651235*^9, 
   3.705328187049501*^9}, 3.7053293785906277`*^9, 3.705329519000351*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"hbarc", "=", "0.197326960277"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
    "ax_", ",", "ay_", ",", "az_", ",", "ux_", ",", "uy_", ",", "t_", ",", 
     "\[Lambda]_", ",", "pt_", ",", "y_", ",", "phi_"}], "]"}], " ", "=", " ", 
   RowBox[{"1", "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"pSigmap", "[", 
          RowBox[{
          "ax", ",", "ay", ",", "az", ",", "ux", ",", "uy", ",", "t", ",", 
           "pt", ",", "y", ",", "phi"}], "]"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "*", "hbarc"}], ")"}]}], "]"}], "-", "1"}], 
     ")"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.705327972872518*^9, 3.705328039589115*^9}, {
   3.7053282354083843`*^9, 3.705328244095731*^9}, {3.7053293841186543`*^9, 
   3.7053293878926907`*^9}, {3.705353011578087*^9, 3.705353033954707*^9}, {
   3.705361683321341*^9, 3.7053616948379917`*^9}, 3.705361735799347*^9, {
   3.705362248882763*^9, 3.705362253599897*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fVal", "[", 
   RowBox[{"n_", ",", "pt_", ",", "y_", ",", "phi_"}], "]"}], " ", ":=", " ", 
  
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"varDataRaw", "[", "1", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"varDataRaw", "[", "2", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"varDataRaw", "[", "3", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"varDataRaw", "[", "4", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"varDataRaw", "[", "5", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"varDataRaw", "[", "6", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"varDataRaw", "[", "7", "]"}], "[", 
     RowBox[{"[", "n", "]"}], "]"}], ",", "pt", ",", "y", ",", "phi"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.70532844996382*^9, 3.705328497684926*^9}, {
   3.705328534779525*^9, 3.705328540371456*^9}, {3.705328595179008*^9, 
   3.705328608715514*^9}, {3.705328662704689*^9, 3.705328682567936*^9}, {
   3.705329391708761*^9, 3.705329396708446*^9}, 3.705353021794413*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fVal", "[", 
  RowBox[{"1000", ",", "0.1", ",", "0", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.7053285455605793`*^9, 3.705328548572177*^9}, {
  3.705328617496706*^9, 3.705328628152252*^9}, {3.705328697582218*^9, 
  3.705328725956585*^9}, {3.7053294844197617`*^9, 3.705329491960733*^9}}],

Cell[BoxData["3.8512635810300844`*^-32"], "Output",
 CellChangeTimes->{{3.7053285489338093`*^9, 3.705328577206833*^9}, {
   3.705328611358367*^9, 3.7053286286217003`*^9}, {3.7053287139605637`*^9, 
   3.705328726148375*^9}, 3.705329435837061*^9, {3.705329476571146*^9, 
   3.705329492302424*^9}, 3.7053295234411993`*^9, 3.7053516233266897`*^9, 
   3.705351976159206*^9, {3.705353025578313*^9, 3.705353038034936*^9}, 
   3.705361740316496*^9, 3.705361777762026*^9, 3.705362259887919*^9, 
   3.705363735177474*^9, 3.705400313918241*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"dSig", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"dSig0", ",", "dSigx", ",", "dSigy", ",", "dSigz"}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7053289486315613`*^9, 3.705328970651703*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"pDSigma", "[", 
   RowBox[{
   "dSig0_", ",", "dSigx_", ",", "dSigy_", ",", "dSigz_", ",", "pt_", ",", 
    "y_", ",", "phi_"}], "]"}], " ", "=", " ", 
  RowBox[{"p", ".", "g", ".", "dSig"}]}]], "Input",
 CellChangeTimes->{{3.705328925265629*^9, 3.705328941212743*^9}, {
  3.705328973331558*^9, 3.7053289914762506`*^9}, {3.7053290632910013`*^9, 
  3.7053290664738417`*^9}, {3.705329244243703*^9, 3.7053292478336973`*^9}, {
  3.705329398276703*^9, 3.705329399476218*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "dSigx"}], " ", "pt", " ", 
   RowBox[{"Cos", "[", "phi", "]"}]}], "+", 
  RowBox[{"dSig0", " ", 
   SqrtBox[
    RowBox[{"0.019600000000000003`", "\[VeryThinSpace]", "+", 
     SuperscriptBox["pt", "2"]}]], " ", 
   RowBox[{"Cosh", "[", "y", "]"}]}], "-", 
  RowBox[{"dSigy", " ", "pt", " ", 
   RowBox[{"Sin", "[", "phi", "]"}]}], "-", 
  RowBox[{"dSigz", " ", 
   SqrtBox[
    RowBox[{"0.019600000000000003`", "\[VeryThinSpace]", "+", 
     SuperscriptBox["pt", "2"]}]], " ", 
   RowBox[{"Sinh", "[", "y", "]"}]}]}]], "Output",
 CellChangeTimes->{
  3.7053289773947372`*^9, {3.705329068380711*^9, 3.705329091944805*^9}, 
   3.705329138696347*^9, 3.705329179885743*^9, 3.705329253203107*^9, 
   3.705329404258301*^9, 3.705329435923759*^9, 3.705329476664661*^9, 
   3.7053295235340548`*^9, 3.7053516234062767`*^9, 3.7053519762692957`*^9, 
   3.705353042075616*^9, 3.705361777877553*^9, 3.7053637352624826`*^9, 
   3.705400314001705*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fVal", "[", 
  RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.705351726951618*^9, 3.7053517323300743`*^9}}],

Cell[BoxData["1.3299854102903151`*^-26"], "Output",
 CellChangeTimes->{3.7053517328427143`*^9, 3.705351976352461*^9, 
  3.70535304382638*^9, 3.70536177795989*^9, 3.705363735330854*^9, 
  3.705400314081554*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "centroidData", "]"}]], "Input"],

Cell[BoxData["115117"], "Output",
 CellChangeTimes->{3.7053518599774733`*^9, 3.70535197643626*^9, 
  3.7053530464129543`*^9, 3.705361778043268*^9, 3.705363735397751*^9, 
  3.705400314164267*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"fVal", "[", 
  RowBox[{"115117", ",", "1", ",", "0", ",", "0"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"pDSigmaVal", "[", 
  RowBox[{"115117", ",", "1", ",", "0", ",", "0"}], "]"}]}], "Input",
 CellChangeTimes->{{3.705351720411867*^9, 3.705351723298526*^9}, {
  3.7053518497617273`*^9, 3.7053519014405193`*^9}}],

Cell[BoxData["0.0018283106362361452`"], "Output",
 CellChangeTimes->{
  3.7053517240499773`*^9, {3.70535185017404*^9, 3.7053519018515463`*^9}, 
   3.705351976517839*^9, 3.705353047920409*^9, 3.705361778124969*^9, 
   3.70536373546697*^9, 3.705400314248663*^9}],

Cell[BoxData["0.010146133700246392`"], "Output",
 CellChangeTimes->{
  3.7053517240499773`*^9, {3.70535185017404*^9, 3.7053519018515463`*^9}, 
   3.705351976517839*^9, 3.705353047920409*^9, 3.705361778124969*^9, 
   3.70536373546697*^9, 3.705400314258585*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"pDSigmaVal", "[", 
   RowBox[{"n_", ",", "pt_", ",", "y_", ",", "phi_"}], "]"}], " ", ":=", " ", 
  
  RowBox[{
   RowBox[{"pDSigma", "[", 
    RowBox[{
     RowBox[{"normalData", "[", 
      RowBox[{"[", 
       RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
     RowBox[{"normalData", "[", 
      RowBox[{"[", 
       RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"normalData", "[", 
      RowBox[{"[", 
       RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", 
     RowBox[{"normalData", "[", 
      RowBox[{"[", 
       RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "pt", ",", "y", ",", 
     "phi"}], "]"}], " ", 
   RowBox[{"HeavisideTheta", "[", 
    RowBox[{"pDSigma", "[", 
     RowBox[{
      RowBox[{"normalData", "[", 
       RowBox[{"[", 
        RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
      RowBox[{"normalData", "[", 
       RowBox[{"[", 
        RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
      RowBox[{"normalData", "[", 
       RowBox[{"[", 
        RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", 
      RowBox[{"normalData", "[", 
       RowBox[{"[", 
        RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "pt", ",", "y", ",", 
      "phi"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.705329093412624*^9, 3.705329113522995*^9}, {
  3.70532914932657*^9, 3.705329204725276*^9}, {3.705329256385619*^9, 
  3.705329262665999*^9}, {3.705329416467759*^9, 3.705329420019609*^9}, {
  3.705330240166933*^9, 3.705330246014728*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dNdp", "[", 
   RowBox[{"pt_", ",", "y_", ",", "phi_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"3", "/", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "Pi"}], ")"}], "^", "3"}]}], 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"pDSigmaVal", "[", 
       RowBox[{"n", ",", "pt", ",", "y", ",", "phi"}], "]"}], 
      RowBox[{"fVal", "[", 
       RowBox[{"n", ",", "pt", ",", "y", ",", "phi"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", 
       RowBox[{"Length", "[", "centroidData", "]"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.705329539721692*^9, 3.705329673195554*^9}, {
  3.705329734353424*^9, 3.705329739431862*^9}, {3.705329988010591*^9, 
  3.705330015951786*^9}, {3.705363339016673*^9, 3.705363339093915*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"2", "Pi", " ", 
  RowBox[{"dNdp", "[", 
   RowBox[{"0.1", ",", "0", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.705351763106638*^9, 3.705351774364188*^9}, {
  3.705351912937207*^9, 3.705351915662772*^9}, {3.70535306616813*^9, 
  3.7053530710473948`*^9}, {3.705363018994012*^9, 3.705363022240017*^9}, {
  3.705363070681917*^9, 3.705363070905643*^9}, {3.705363426040834*^9, 
  3.705363427321857*^9}}],

Cell[BoxData["25.487272614120148`"], "Output",
 CellChangeTimes->{
  3.7053517871334133`*^9, 3.705351928272892*^9, 3.705351989583942*^9, {
   3.705353066078573*^9, 3.705353086244739*^9}, 3.705361791702318*^9, 
   3.705363035973083*^9, 3.705363084697517*^9, 3.7053633554713306`*^9, 
   3.705363749575953*^9, 3.7054003286555843`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pt", ",", 
      RowBox[{"2", "Pi", " ", 
       RowBox[{"dNdp", "[", 
        RowBox[{"pt", ",", "0", ",", "0"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"pt", ",", "0.1", ",", "3.1", ",", "0.5"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.705329615815626*^9, 3.7053296201319637`*^9}, {
  3.705329764065505*^9, 3.7053297652233973`*^9}, {3.705329837301597*^9, 
  3.705329868811043*^9}, {3.7053610356516953`*^9, 3.705361035801033*^9}, {
  3.705363416929482*^9, 3.705363434592924*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{{3.705329622862117*^9, 3.705329655235074*^9}, 
   3.7053296864077168`*^9, 3.705329748641646*^9, {3.705329866823007*^9, 
   3.7053298917794857`*^9}, 3.705330010186344*^9, 3.705330297946924*^9, 
   3.7053516830942717`*^9, 3.705352031494018*^9, 3.70535209460855*^9, 
   3.705360909408813*^9, 3.705361124231008*^9, 3.7053618872350616`*^9, 
   3.705363431045895*^9, 3.705363532545063*^9, 3.705363847040533*^9, 
   3.705400341825313*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLogPlot", "[", 
  RowBox[{"res", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.705330308191119*^9, 3.705330321938406*^9}, {
  3.705361002882661*^9, 3.7053610087944527`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.012833333333333334`],
      AbsoluteThickness[1.6], 
     LineBox[{{0.1, 3.2381792143941817`}, {0.6, 0.5990507958145016}, {
      1.1, -1.7213957539067102`}, {1.6, -3.828871480384194}, {
      2.1, -5.8443007886368}, {2.6, -7.814784017711145}, {
      3.1, -9.757573338910095}}]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -10.700813443585405`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{{{-9.210340371976182, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-6.907755278982137, 
       FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox["1", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {2.302585092994046, 
       FormBox["10", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-10.819778284410283`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-10.41431317630212, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-10.126631103850338`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.903487552536127, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.721165995742174, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.567015315914915, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.433483923290392, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.315700887634009, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-8.517193191416238, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-8.111728083308073, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-7.824046010856292, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-7.600902459542082, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-7.418580902748128, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-7.264430222920869, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-7.1308988302963465`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-7.013115794639964, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-6.214608098422191, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-5.809142990314028, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-5.521460917862246, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-5.298317366548036, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-5.115995809754082, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.961845129926823, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.710530701645918, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.912023005428146, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.506557897319982, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.995732273553991, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.659260036932778, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.916290731874155, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0.6931471805599453, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.791759469228055, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.995732273553991, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.4011973816621555`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.6888794541139363`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.912023005428146, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.0943445622221, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.248495242049359, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.382026634673881, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.499809670330265, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.0106352940962555`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.298317366548036, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.521460917862246, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{538.3671875, Automatic},
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Part[{{Identity, Identity}, {Log, Exp}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Log, Exp}}, 2, 2][#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Part[{{Identity, Identity}, {Log, Exp}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Log, Exp}}, 2, 2][#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 3.1}, {-10.479559591871443`, 3.2381792143941817`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, {{-9.210340371976182, 
      FormBox[
       TemplateBox[{"10", 
         RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm], {0.01, 0.}, {
       AbsoluteThickness[0.1]}}, {-6.907755278982137, 
      FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
       AbsoluteThickness[0.1]}}, {-4.605170185988091, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}]& ], TraditionalForm], {0.01, 0.}, {
       AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}]& ], TraditionalForm], {0.01, 0.}, {
       AbsoluteThickness[0.1]}}, {0., 
      FormBox["1", TraditionalForm], {0.01, 0.}, {
       AbsoluteThickness[0.1]}}, {2.302585092994046, 
      FormBox["10", TraditionalForm], {0.01, 0.}, {
       AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-10.819778284410283`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-10.41431317630212, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-10.126631103850338`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-9.903487552536127, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-9.721165995742174, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-9.567015315914915, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-9.433483923290392, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-9.315700887634009, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-8.517193191416238, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-8.111728083308073, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-7.824046010856292, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-7.600902459542082, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-7.418580902748128, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-7.264430222920869, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-7.1308988302963465`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-7.013115794639964, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-6.214608098422191, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-5.809142990314028, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-5.521460917862246, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-5.298317366548036, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-5.115995809754082, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-4.961845129926823, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-4.710530701645918, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-3.912023005428146, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-3.506557897319982, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-2.995732273553991, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-2.659260036932778, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-0.916290731874155, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {0.6931471805599453, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {1.791759469228055, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {2.995732273553991, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {3.4011973816621555`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {3.6888794541139363`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {3.912023005428146, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {4.0943445622221, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {4.248495242049359, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {4.382026634673881, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {4.499809670330265, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {4.605170185988092, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {5.0106352940962555`, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {5.298317366548036, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}, {5.521460917862246, 
      FormBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[{0, 0}]], TraditionalForm], {0.005, 0.}, {
       AbsoluteThickness[0.1]}}}}]], "Output",
 CellChangeTimes->{{3.705330312001487*^9, 3.705330322585114*^9}, 
   3.7053516832095623`*^9, 3.705352094720346*^9, 3.70535294263446*^9, 
   3.70536100926258*^9, 3.705361637255485*^9, {3.705361887400586*^9, 
   3.705361894399741*^9}, 3.705363847212667*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1090, 832},
WindowMargins->{{78, Automatic}, {-118, Automatic}},
FrontEndVersion->"10.4 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 11, \
2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 96, 1, 64, "Section"],
Cell[CellGroupData[{
Cell[701, 27, 171, 4, 28, "Input"],
Cell[875, 33, 611, 9, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1535, 48, 105, 1, 64, "Section"],
Cell[1643, 51, 584, 12, 28, "Input"],
Cell[2230, 65, 3538, 90, 216, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5805, 160, 140, 2, 64, "Section"],
Cell[5948, 164, 3065, 84, 80, "Input"],
Cell[CellGroupData[{
Cell[9038, 252, 552, 16, 28, "Input"],
Cell[9593, 270, 845, 14, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10475, 289, 1504, 46, 97, "Input"],
Cell[11982, 337, 990, 21, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13021, 364, 113, 1, 64, "Section"],
Cell[CellGroupData[{
Cell[13159, 369, 163, 2, 44, "Subsection"],
Cell[13325, 373, 1332, 25, 46, "Input"],
Cell[CellGroupData[{
Cell[14682, 402, 362, 8, 28, "Input"],
Cell[15047, 412, 2244, 42, 422, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[17340, 460, 161, 2, 36, "Subsection"],
Cell[17504, 464, 1446, 28, 46, "Input"],
Cell[CellGroupData[{
Cell[18975, 496, 427, 9, 28, "Input"],
Cell[19405, 507, 2152, 41, 418, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[21606, 554, 345, 4, 36, "Subsection"],
Cell[21954, 560, 1125, 25, 28, "Input"],
Cell[23082, 587, 1560, 29, 46, "Input"],
Cell[CellGroupData[{
Cell[24667, 620, 165, 3, 28, "Input"],
Cell[24835, 625, 148149, 2445, 405, 32739, 551, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[173033, 3076, 170, 2, 36, "Subsection"],
Cell[173206, 3080, 1560, 44, 80, "Input"],
Cell[174769, 3126, 1042, 26, 80, "Input"],
Cell[175814, 3154, 6280, 135, 318, "Input"],
Cell[CellGroupData[{
Cell[182119, 3293, 1843, 27, 28, "Input"],
Cell[183965, 3322, 128237, 2143, 587, "Output"]
}, Open  ]],
Cell[312217, 5468, 1426, 31, 46, "Input"],
Cell[313646, 5501, 297, 6, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[313980, 5512, 485, 8, 44, "Subsection"],
Cell[314468, 5522, 314, 7, 46, "Input"],
Cell[314785, 5531, 516, 14, 46, "Input"],
Cell[315304, 5547, 5551, 130, 352, "Input"],
Cell[CellGroupData[{
Cell[320880, 5681, 750, 11, 28, "Input"],
Cell[321633, 5694, 297283, 4942, 435, "Output"]
}, Open  ]],
Cell[618931, 10639, 908, 20, 46, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[619888, 10665, 152, 2, 64, "Section"],
Cell[620043, 10669, 258, 6, 28, "Input"],
Cell[CellGroupData[{
Cell[620326, 10679, 490, 13, 28, "Input"],
Cell[620819, 10694, 822, 20, 43, "Output"]
}, Open  ]],
Cell[621656, 10717, 1297, 39, 80, "Input"],
Cell[CellGroupData[{
Cell[622978, 10760, 541, 15, 28, "Input"],
Cell[623522, 10777, 658, 17, 28, "Output"]
}, Open  ]],
Cell[624195, 10797, 574, 14, 80, "Input"],
Cell[624772, 10813, 1400, 44, 80, "Input"],
Cell[626175, 10859, 961, 26, 63, "Input"],
Cell[627139, 10887, 1429, 36, 46, "Input"],
Cell[628571, 10925, 1101, 26, 46, "Input"],
Cell[629675, 10953, 1239, 32, 46, "Input"],
Cell[CellGroupData[{
Cell[630939, 10989, 319, 5, 28, "Input"],
Cell[631261, 10996, 533, 7, 32, "Output"]
}, Open  ]],
Cell[631809, 11006, 236, 6, 28, "Input"],
Cell[CellGroupData[{
Cell[632070, 11016, 505, 10, 28, "Input"],
Cell[632578, 11028, 988, 23, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[633603, 11056, 168, 3, 28, "Input"],
Cell[633774, 11061, 209, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[634020, 11069, 70, 1, 28, "Input"],
Cell[634093, 11072, 194, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[634324, 11080, 341, 7, 46, "Input"],
Cell[634668, 11089, 260, 4, 28, "Output"],
Cell[634931, 11095, 259, 4, 28, "Output"]
}, Open  ]],
Cell[635205, 11102, 1487, 40, 63, "Input"],
Cell[636695, 11144, 829, 22, 28, "Input"],
Cell[CellGroupData[{
Cell[637549, 11170, 431, 8, 28, "Input"],
Cell[637983, 11180, 331, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[638351, 11190, 615, 15, 28, "Input"],
Cell[638969, 11207, 486, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[639492, 11219, 244, 5, 28, "Input"],
Cell[639739, 11226, 39338, 941, 352, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

