(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20159,        534]
NotebookOptionsPosition[     19252,        502]
NotebookOutlinePosition[     19593,        517]
CellTagsIndexPosition[     19550,        514]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
    "Not", " ", "properly", " ", "synced", " ", "with", " ", "hfunc_data"}], 
    " ", "..."}], " ", "do", " ", "not", " ", "use", " ", "without", " ", 
   RowBox[{"modification", "!"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6592883139032507`*^9, 3.659288327938904*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"file", "=", 
  RowBox[{
   RowBox[{"ParentDirectory", "[", 
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "<>", 
   "\"\</input/hfuncs/hfuncs.bin\>\""}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "201"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aMin", " ", "=", " ", 
   RowBox[{"10", "^", 
    RowBox[{"(", 
     RowBox[{"-", "4"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aMax", " ", "=", " ", 
   RowBox[{"4", "+", "aMin"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"dA", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"aMax", "-", "aMin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"num", "-", "1"}], ")"}]}], " ", "//", "N"}]}]}], "Input",
 CellChangeTimes->{{3.658147573880793*^9, 3.658147621412135*^9}, {
   3.658207035975429*^9, 3.658207114312862*^9}, {3.658207824233302*^9, 
   3.658207825313341*^9}, 3.65820894948024*^9, {3.658373662466576*^9, 
   3.658373676654131*^9}, 3.658968635914546*^9, {3.6653976933952312`*^9, 
   3.6653977710352993`*^9}}],

Cell[BoxData["\<\"/home/radoslaw/repos/ahydro3p1/input/hfuncs/hfuncs.bin\"\>"]\
, "Output",
 CellChangeTimes->{
  3.665397612511552*^9, {3.665397728327379*^9, 3.665397738211643*^9}, 
   3.665397771310418*^9}],

Cell[BoxData["0.02`"], "Output",
 CellChangeTimes->{
  3.665397612511552*^9, {3.665397728327379*^9, 3.665397738211643*^9}, 
   3.665397771311961*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"metaData", "=", 
    RowBox[{"Take", "[", 
     RowBox[{
      RowBox[{"BinaryReadList", "[", 
       RowBox[{"file", ",", "\"\<Real64\>\""}], "]"}], ",", "9"}], "]"}]}], 
   ";"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.658929337548101*^9, 3.658929350972994*^9}, {
  3.658959328677236*^9, 3.658959331549795*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rawData", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"file", ",", "\"\<Real64\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData2", " ", "=", "  ", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{"rawData", ",", "9"}], "]"}], ",", "16"}], "]"}], ",", 
         "num"}], "]"}], ",", "num"}], "]"}], ",", "num"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"hInt", "[", "l", "]"}], "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"aMin", " ", "+", " ", 
                RowBox[{"dA", "*", 
                 RowBox[{"(", 
                  RowBox[{"i", "-", "1"}], ")"}]}]}], ",", 
               RowBox[{"aMin", " ", "+", " ", 
                RowBox[{"dA", "*", 
                 RowBox[{"(", 
                  RowBox[{"j", "-", "1"}], ")"}]}]}], ",", 
               RowBox[{"aMin", " ", "+", " ", 
                RowBox[{"dA", "*", 
                 RowBox[{"(", 
                  RowBox[{"k", "-", "1"}], ")"}]}]}], ",", 
               RowBox[{"rawData2", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "i", ",", "j", ",", "k", ",", "l"}], "]"}],
                 "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "num"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "num"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", "2"}],
           "]"}], "]"}]}], ",", "\n", " ", 
       RowBox[{"{", 
        RowBox[{"l", ",", " ", "1", ",", " ", "16"}], "}"}]}], "]"}], 
     "\[IndentingNewLine]", 
     RowBox[{"min", " ", "=", " ", 
      RowBox[{
       RowBox[{"hInt", "[", "1", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", " ", "1", ",", " ", "1"}], "]"}], "]"}]}]}], ";", 
    "\n", 
    RowBox[{"max", " ", "=", " ", 
     RowBox[{
      RowBox[{"hInt", "[", "1", "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", " ", "1", ",", " ", "2"}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.658207033299036*^9, 3.658207033653298*^9}, {
  3.658207202543378*^9, 3.658207232756225*^9}, {3.658207542087639*^9, 
  3.6582075431261463`*^9}, {3.658208068415366*^9, 3.658208079519937*^9}, {
  3.658208766567231*^9, 3.6582087667192593`*^9}, {3.658208901776142*^9, 
  3.658208904712298*^9}, {3.658208965924917*^9, 3.658208966142901*^9}, {
  3.658373891188586*^9, 3.65837389903386*^9}, {3.658373992249774*^9, 
  3.658373999431679*^9}, {3.6589293675568123`*^9, 3.658929392274551*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryReadList", "::", "\<\"nffil\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"File not found during \\\\\\\
\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(BinaryReadList[\\(\\(\
\\\"/Users/mstrick6/Desktop/aHydro3p1-7-hfunc-3/input/hfuncs/hfuncs.bin\\\", \
\\\"Real64\\\"\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\".\\\\\\\"\\\", \\\"MT\\\
\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/nffil\\\", ButtonNote -> \
\\\"BinaryReadList::nffil\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.665397619110787*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Drop", "::", "\<\"normal\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Nonatomic expression \
expected at position \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\(1\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \
\\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Drop[\\(\\($Failed, \
9\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\".\\\\\\\"\\\", \\\"MT\\\
\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/normal\\\", ButtonNote -> \
\\\"Drop::normal\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.665397619112502*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Drop", "::", "\<\"argm\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Drop\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" called with \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(0\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" arguments; \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(1\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" or more arguments are \
expected.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\
\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/argm\\\", ButtonNote -> \
\\\"Drop::argm\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.6653976191135798`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Drop", "::", "\<\"argm\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Drop\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" called with \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(0\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" arguments; \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(1\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" or more arguments are \
expected.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\
\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/argm\\\", ButtonNote -> \
\\\"Drop::argm\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.66539761911452*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Drop", "::", "\<\"argm\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Drop\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" called with \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(0\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" arguments; \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(1\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" or more arguments are \
expected.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\
\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/argm\\\", ButtonNote -> \
\\\"Drop::argm\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.665397619115432*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Drop :: \\\"argm\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be suppressed \
during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.665397619116418*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mydata", "[", "1", "]"}], " ", "=", " ", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"aMin", " ", "+", " ", 
          RowBox[{"dA", "*", 
           RowBox[{"(", 
            RowBox[{"i", "-", "1"}], ")"}]}]}], ",", 
         RowBox[{"aMin", " ", "+", " ", 
          RowBox[{"dA", "*", 
           RowBox[{"(", 
            RowBox[{"j", "-", "1"}], ")"}]}]}], ",", 
         RowBox[{"aMin", " ", "+", " ", 
          RowBox[{"dA", "*", 
           RowBox[{"(", 
            RowBox[{"k", "-", "1"}], ")"}]}]}], ",", 
         RowBox[{"rawData2", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "i", ",", "j", ",", "k", ",", "1"}], "]"}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "num"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "num"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hInt", "[", "1", "]"}], "=", 
  RowBox[{"Interpolation", "[", 
   RowBox[{"mydata", "[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"min", " ", "=", " ", 
   RowBox[{
    RowBox[{"hInt", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", " ", "1", ",", " ", "1"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"max", " ", "=", " ", 
   RowBox[{
    RowBox[{"hInt", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", " ", "1", ",", " ", "2"}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.658373973987007*^9, 3.6583739769133167`*^9}, {
   3.658374432620126*^9, 3.658374432979618*^9}, {3.65893682496126*^9, 
   3.658936833624284*^9}, {3.658950286121036*^9, 3.65895028921459*^9}, 
   3.658952101773789*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Clear", "[", 
    RowBox[{"nterms", ",", "fitp", ",", "c"}], "]"}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{"nterms", " ", "=", " ", "6"}], ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p1", "[", 
     RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
    RowBox[{"SymmetricPolynomial", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"ax", ",", "ay", ",", "az"}], "}"}]}], "]"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p2", "[", 
     RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", " ", "=", " ", 
    RowBox[{"SymmetricPolynomial", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"ax", ",", "ay", ",", "az"}], "}"}]}], "]"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p3", "[", 
     RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
    RowBox[{"SymmetricPolynomial", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"ax", ",", "ay", ",", "az"}], "}"}]}], "]"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fitp", "[", 
     RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], "=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{
         RowBox[{"m", "*", 
          RowBox[{"(", 
           RowBox[{"nterms", "+", "1"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"nterms", "+", "1"}], ")"}]}], " ", "+", " ", 
         RowBox[{"n", "*", 
          RowBox[{"(", 
           RowBox[{"nterms", "+", "1"}], ")"}]}], " ", "+", "l"}], "]"}], " ", 
       RowBox[{
        RowBox[{"p1", "[", 
         RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], "^", "m"}], " ", 
       RowBox[{
        RowBox[{"p2", "[", 
         RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], "^", "n"}], " ", 
       RowBox[{
        RowBox[{"p3", "[", 
         RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], "^", "l"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", "0", ",", "nterms"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "nterms"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"l", ",", "0", ",", "nterms"}], "}"}]}], "]"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{"vars", " ", "=", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"c", "[", "n", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"nterms", "+", "1"}], ")"}], "^", "3"}], "-", "1"}]}], 
       "}"}]}], "]"}]}], ";"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.65895056527604*^9, 3.658950591120153*^9}, {
  3.658950770577063*^9, 3.6589507823081493`*^9}, {3.658950840423484*^9, 
  3.6589508468619432`*^9}, {3.658950895646366*^9, 3.65895089713437*^9}, {
  3.658951279202936*^9, 3.6589512792717876`*^9}, {3.658951341710992*^9, 
  3.658951347878109*^9}, {3.658952054437665*^9, 3.65895205476468*^9}, {
  3.658959340343294*^9, 3.658959351436964*^9}, {3.658964180924973*^9, 
  3.658964181641986*^9}, {3.658966364739915*^9, 3.658966364853409*^9}, {
  3.659288215826703*^9, 3.659288218959589*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"fittedp", "[", 
     RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}], " ", "=", " ", 
    RowBox[{
     RowBox[{"fitp", "[", 
      RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], " ", "/.", " ", "fit"}]}], 
   ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fittedp", "[", 
     RowBox[{"0", ",", "0", ",", "0"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"fittedp", "[", 
       RowBox[{"0.2", ",", "0.2", ",", "0.2"}], "]"}], ",", 
      RowBox[{
       RowBox[{"hInt", "[", "1", "]"}], "[", 
       RowBox[{"0.2", ",", "0.2", ",", "0.2"}], "]"}]}], "}"}], 
    "\[IndentingNewLine]", 
    RowBox[{"fittedp", "[", 
     RowBox[{"1", ",", "1", ",", "1"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"aztest", " ", "=", " ", "1.5"}]}], ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Plot3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"hInt", "[", "1", "]"}], "[", 
          RowBox[{"ax", ",", "ay", ",", "aztest"}], "]"}], ",", 
         RowBox[{"fittedp", "[", 
          RowBox[{"ax", ",", "ay", ",", "aztest"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ax", ",", "min", ",", "max"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ay", ",", "min", ",", "max"}], "}"}]}], "]"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Plot3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"hInt", "[", "1", "]"}], "[", 
          RowBox[{"ax", ",", "ay", ",", "aztest"}], "]"}], "-", 
         RowBox[{"fittedp", "[", 
          RowBox[{"ax", ",", "ay", ",", "aztest"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ax", ",", "min", ",", "max"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ay", ",", "min", ",", "max"}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], " ", 
     "\[IndentingNewLine]", 
     RowBox[{"fittedpd1", "[", 
      RowBox[{"ax_", ",", "ay_", ",", "az_"}], "]"}]}], " ", "=", " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"fittedp", "[", 
       RowBox[{"ax", ",", "ay", ",", "az"}], "]"}], ",", "ax"}], "]"}]}], ";",
    "\[IndentingNewLine]", 
   RowBox[{"Plot3D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"fittedpd1", "[", 
       RowBox[{"ax", ",", "ay", ",", "aztest"}], "]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ax", ",", "min", ",", "max"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ay", ",", "min", ",", "max"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{
  3.658951360571134*^9, {3.658962107574885*^9, 3.658962109693047*^9}, {
   3.659288244896182*^9, 3.659288273374566*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"aztest", " ", "=", " ", "1.5"}], ";", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Plot3D", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"hInt", "[", "i", "]"}], "[", 
        RowBox[{"ax", ",", "ay", ",", "aztest"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"ax", ",", "min", ",", "max"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ay", ",", "min", ",", "max"}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "16"}], "}"}]}], "]"}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.6581477345601482`*^9, 3.65814774647036*^9}, {
  3.658147785524745*^9, 3.658147809955649*^9}, {3.658147905311592*^9, 
  3.6581479537084713`*^9}, {3.658148166331517*^9, 3.658148267078925*^9}, {
  3.6582081487384977`*^9, 3.658208148810234*^9}, {3.6583744404592524`*^9, 
  3.658374443762184*^9}}]
},
WindowSize->{1268, 1028},
WindowMargins->{{260, Automatic}, {-10, Automatic}},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 350, 8, 32, "Input"],
Cell[CellGroupData[{
Cell[933, 32, 1101, 28, 121, "Input"],
Cell[2037, 62, 208, 4, 31, "Output"],
Cell[2248, 68, 149, 3, 31, "Output"]
}, Open  ]],
Cell[2412, 74, 377, 10, 32, "Input"],
Cell[CellGroupData[{
Cell[2814, 88, 3111, 79, 231, "Input"],
Cell[5928, 169, 707, 13, 24, "Message"],
Cell[6638, 184, 749, 15, 24, "Message"],
Cell[7390, 201, 793, 14, 24, "Message"],
Cell[8186, 217, 790, 14, 24, "Message"],
Cell[8979, 233, 791, 14, 24, "Message"],
Cell[9773, 249, 626, 11, 24, "Message"]
}, Open  ]],
Cell[10414, 263, 1915, 53, 121, "Input"],
Cell[12332, 318, 3156, 81, 187, "Input"],
Cell[15491, 401, 2781, 74, 231, "Input"],
Cell[18275, 477, 973, 23, 99, "Input"]
}
]
*)

(* End of internal cache information *)
