(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    244688,       6339]
NotebookOptionsPosition[    239046,       6149]
NotebookOutlinePosition[    239422,       6166]
CellTagsIndexPosition[    239379,       6163]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["`"], "Input",
 CellChangeTimes->{3.689160077992032*^9}],

Cell[BoxData["+"], "Input",
 CellChangeTimes->{3.6482085248265*^9}],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       StyleBox["\[IndentingNewLine]",
        FontSize->14], 
       StyleBox[
        StyleBox[
         RowBox[{"\t", 
          StyleBox["\t\t\t\t\t",
           FontSize->24]}]],
        FontSize->14], 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"About", " ", "the", " ", "code"}],
          FontSize->24], 
         StyleBox["\[IndentingNewLine]",
          FontSize->24], 
         StyleBox["\t\t\t\t",
          FontSize->24], 
         StyleBox["Designed",
          FontSize->24], 
         StyleBox[" ",
          FontSize->24], 
         StyleBox["by",
          FontSize->24], 
         StyleBox[" ",
          FontSize->24], 
         StyleBox["Mohammad",
          FontSize->24], 
         StyleBox[" ",
          FontSize->24], 
         StyleBox["Nopoush",
          FontSize->24], 
         StyleBox["\[IndentingNewLine]",
          FontSize->24], 
         StyleBox["\[IndentingNewLine]",
          FontSize->24], 
         StyleBox[" ",
          FontSize->18], 
         StyleBox["This",
          FontSize->18], 
         StyleBox[" ",
          FontSize->18], 
         StyleBox["version",
          FontSize->18], 
         StyleBox[" ",
          FontSize->18], 
         StyleBox["includes",
          FontSize->18], 
         StyleBox[" ",
          FontSize->18], 
         StyleBox["the",
          FontSize->18], 
         StyleBox[" ",
          FontSize->18], 
         StyleBox["0",
          FontSize->18]}], 
        StyleBox["+",
         FontSize->18], 
        StyleBox[
         RowBox[{"1", "d", " ", "equation", " ", "for", " ", "two", " ", 
          RowBox[{"cases", ":", "\[IndentingNewLine]", " ", "1"}]}],
         FontSize->18]}], 
       StyleBox[")",
        FontSize->18]}], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["massive",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["M",
       FontSize->18], 
      StyleBox[
       RowBox[{"(", "T", ")"}],
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["using",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["the",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["data",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["form",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["realistic",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["EoS",
       FontSize->18], 
      StyleBox[" ",
       FontSize->18], 
      StyleBox["\[IndentingNewLine]",
       FontSize->18], 
      StyleBox["\t ",
       FontSize->18], 
      StyleBox["2",
       FontSize->18]}], 
     StyleBox[")",
      FontSize->18]}], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["massless",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["case",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["using",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["the",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["data",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["form",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["realistic",
     FontSize->18], 
    StyleBox[" ",
     FontSize->18], 
    StyleBox["EoS",
     FontSize->18]}], 
   StyleBox[" ",
    FontSize->18], "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.640783123593521*^9, 3.640783165182291*^9}, {
   3.642159013647853*^9, 3.642159190013838*^9}, 3.642336738419469*^9}],

Cell[CellGroupData[{

Cell["Numerical Part", "Title",
 CellChangeTimes->{{3.643468950578372*^9, 3.64346896091686*^9}}],

Cell[CellGroupData[{

Cell["Setup", "Section",
 CellChangeTimes->{{3.640519371290308*^9, 3.6405193896602182`*^9}}],

Cell[CellGroupData[{

Cell["working directory", "Subsection",
 CellChangeTimes->{3.6405194012043*^9}],

Cell[BoxData[
 RowBox[{"wd", "=", 
  RowBox[{"SetDirectory", "@", 
   RowBox[{"NotebookDirectory", "[", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.640519361405725*^9, 3.6405194265702133`*^9}, {
  3.640540705413918*^9, 3.640540706118558*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constants", "Subsection",
 CellChangeTimes->{3.640540603912467*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nf", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Nc", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ndof", "=", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Pi]", "4"], "45"], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["Nc", "2"], "-", "1", "+", 
       RowBox[{
        FractionBox["7", "4"], "Nc", " ", "Nf"}]}], ")"}]}]}], ";"}], "    ", 
  
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "This", " ", "is", " ", "the", " ", "same", " ", "as", " ", "Z", " ", 
     "defined", " ", "in", " ", "the", " ", "paper", " ", "and", " ", "is", 
     " ", "related", " ", "to", " ", "the", " ", "pressure", " ", "as", " ", 
     SubscriptBox["P", "iso"]}], "=", 
    RowBox[{
     FractionBox[
      SubscriptBox["N", "dof"], 
      SuperscriptBox["\[Pi]", "2"]], 
     SuperscriptBox["T", "4"]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sFac", "=", 
    RowBox[{"3", "*", 
     RowBox[{"Ndof", "/", 
      SuperscriptBox["\[Pi]", "2"]}]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    SubscriptBox["E", "iso"], " ", "=", " ", 
    RowBox[{"sFac", " ", 
     SuperscriptBox["T", "4"]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Nt", "=", 
   RowBox[{"Ndof", "/", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", " ", "\[Pi]"}], ")"}], "^", "3"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hbarc", "=", "0.197326938"}], ";"}], "                          ", 
  RowBox[{"(*", 
   RowBox[{"GeV", " ", "fm"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.640540607640567*^9, 3.6405406888832912`*^9}, {
   3.643466906487664*^9, 3.643466938548711*^9}, {3.643468722989697*^9, 
   3.6434687249660053`*^9}, {3.643500547296687*^9, 3.643500547991069*^9}, {
   3.643501212564657*^9, 3.643501215556119*^9}, {3.643502145517083*^9, 
   3.6435021492727337`*^9}, {3.64529024775712*^9, 3.6452902493315783`*^9}, 
   3.645290441219673*^9, {3.6453575453927917`*^9, 3.645357545479928*^9}, 
   3.645359218195799*^9, {3.645359851825522*^9, 3.645359852976564*^9}, {
   3.6453655883391943`*^9, 3.645365589509851*^9}, {3.645366315782091*^9, 
   3.645366316196349*^9}, {3.645440827409562*^9, 3.645440828016067*^9}, {
   3.645442679701387*^9, 3.64544267977956*^9}, {3.6495242288986187`*^9, 
   3.6495242434422283`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functions", "Subsection",
 CellChangeTimes->{{3.641557915087513*^9, 3.641557924048304*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"K0", "[", "x_", "]"}], ":=", 
   RowBox[{"BesselK", "[", 
    RowBox[{"0", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"K1", "[", "x_", "]"}], ":=", 
   RowBox[{"BesselK", "[", 
    RowBox[{"1", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"K2", "[", "x_", "]"}], ":=", 
   RowBox[{"BesselK", "[", 
    RowBox[{"2", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"K3", "[", "x_", "]"}], ":=", 
   RowBox[{"BesselK", "[", 
    RowBox[{"3", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"STm1", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"StruveL", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "x"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ST0", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"StruveL", "[", 
     RowBox[{"0", ",", "x"}], "]"}], "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6421622519058857`*^9, 3.642162433025062*^9}, {
  3.6421625539850807`*^9, 3.6421625571923857`*^9}, {3.6429406691291533`*^9, 
  3.642940682999682*^9}, {3.642955152023334*^9, 3.6429551525361757`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["styles and custom colormaps", "Subsection",
 CellChangeTimes->{3.640519413660001*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"styles", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "1.3", "]"}]}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0.9", ",", "0", ",", "0"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"3", ",", "5"}], "}"}], "]"}]}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0", ",", "0", ",", "0.5"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5"}], "}"}], "]"}]}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0", ",", "0.5", ",", "0"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5", ",", "2", ",", "5"}], "}"}], "]"}]}], "]"}],
       ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"1", ",", "0.5", ",", "0.0"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "4"}], "}"}], "]"}]}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0.5", ",", "0.5", ",", "0.5"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "4"}], "}"}], "]"}]}], "]"}]}], "}"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FrameTicksFontSize", "=", "20"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FrameFontSize", "=", "20"}], ";", 
  RowBox[{"PlotOptions", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameTicksFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameTicksFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}], 
       "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}]}], "}"}]}], 
     ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogLogPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogLinearPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"PolarPlot", ",", "PlotOptions"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.640540586719592*^9, 3.64054059654042*^9}, {
   3.643466860836813*^9, 3.643466868973473*^9}, {3.6434768336298933`*^9, 
   3.643476833799199*^9}, 3.643479265579411*^9, {3.6435010441143103`*^9, 
   3.643501044161168*^9}, 3.650114373695038*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Special Functions", "Section",
 CellChangeTimes->{{3.639851192630246*^9, 3.639851202031461*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"H2", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{"2", " ", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "+", 
        RowBox[{"z", "^", "2"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"y", "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"y", "^", "2"}], "-", "1"}], "]"}]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"z", "^", "2"}]}], ")"}], " ", 
         RowBox[{"ArcTanh", "[", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "^", "2"}], "+", 
              RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}], "]"}]}], "+", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "^", "2"}], "+", 
            RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}]}], ")"}]}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2T", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{"4", "/", 
      RowBox[{"(", 
       RowBox[{"3", " ", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"1", "+", 
          RowBox[{"z", "^", "2"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{
      RowBox[{"y", "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"3", "/", "2"}], ")"}]}]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"z", "^", "2"}], "+", 
           RowBox[{"2", " ", 
            RowBox[{"y", "^", "2"}]}], "-", "1"}], ")"}], " ", 
         RowBox[{"ArcTanh", "[", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "^", "2"}], "+", 
              RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}], "]"}]}], "-", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "^", "2"}], "+", 
            RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}]}], ")"}]}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2L", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{"2", "/", 
      RowBox[{"(", 
       RowBox[{"3", " ", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"1", "+", 
          RowBox[{"z", "^", "2"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"y", "^", "3"}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"3", "/", "2"}], ")"}]}]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"z", "^", "2"}]}], ")"}]}], " ", 
         RowBox[{"ArcTanh", "[", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "^", "2"}], "+", 
              RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}], "]"}]}], "+", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "^", "2"}], "-", "1"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "^", "2"}], "+", 
            RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}]}], ")"}]}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dH2dy", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{
      RowBox[{"2", "/", "3"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"4", "+", 
         RowBox[{"3", " ", 
          RowBox[{"z", "^", "2"}]}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"1", "+", 
         RowBox[{"z", "^", "2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"1", "/", "y"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"H2", "[", 
         RowBox[{"y", ",", "z"}], "]"}], "+", 
        RowBox[{"H2L", "[", 
         RowBox[{"y", ",", "z"}], "]"}]}], ")"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dH2dz", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"2", " ", "z"}], ")"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "+", 
        RowBox[{"z", "^", "2"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"1", "/", "z"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"H2", "[", 
         RowBox[{"y", ",", "z"}], "]"}], "-", 
        RowBox[{"H2T", "[", 
         RowBox[{"y", ",", "z"}], "]"}], "-", 
        RowBox[{"H2L", "[", 
         RowBox[{"y", ",", "z"}], "]"}]}], ")"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dH2Tdy", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], "/", "15"}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"5", " ", 
          RowBox[{"z", "^", "2"}]}], "+", "4"}], ")"}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"z", "^", "2"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"3", "/", "2"}], ")"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"y", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"y", "^", "2"}], "-", "1"}], ")"}]}], ")"}]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", 
         RowBox[{"H2L", "[", 
          RowBox[{"y", ",", "z"}], "]"}]}], "-", 
        RowBox[{"H2T", "[", 
         RowBox[{"y", ",", "z"}], "]"}]}], ")"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dH2Tdz", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], "/", "3"}], " ", 
      RowBox[{"z", "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"z", "^", "2"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"3", "/", "2"}], ")"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", " ", "z"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"y", "^", "2"}], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"z", "^", "2"}]}], ")"}]}], ")"}]}], ")"}]}], " ", 
      RowBox[{"H2L", "[", 
       RowBox[{"y", ",", "z"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H2B", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{"2", " ", "/", 
      SqrtBox[
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"]}]]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"H2T", "[", 
        RowBox[{"y", ",", "z"}], "]"}], "/", "y"}], "+", 
      RowBox[{
       RowBox[{"H2L", "[", 
        RowBox[{"y", ",", "z"}], "]"}], "/", 
       SuperscriptBox["y", "3"]}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dH2Bdy", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{"-", 
      FractionBox["2", 
       RowBox[{"3", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["z", "2"]}], ")"}], 
         RowBox[{"3", "/", "2"}]]}]]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"y", "/", 
          SqrtBox[
           RowBox[{
            SuperscriptBox["y", "2"], "+", 
            SuperscriptBox["z", "2"]}]]}]}], "-", 
        RowBox[{
         RowBox[{"H2L", "[", 
          RowBox[{"y", ",", "z"}], "]"}], "/", 
         SuperscriptBox["y", "2"]}], "-", 
        RowBox[{"H2T", "[", 
         RowBox[{"y", ",", "z"}], "]"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["y", "2"], "-", "1"}], ")"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dH2Bdz", "[", 
    RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "z"}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox["z", "2"]}], ")"}], 
        RowBox[{"3", "/", "2"}]]]}], ",", 
     RowBox[{
      RowBox[{"-", "2"}], 
      RowBox[{
       RowBox[{"z", "/", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["z", "2"], "+", "1"}], ")"}]}], "/", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["y", "2"], "+", 
         SuperscriptBox["z", "2"]}]]}]}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6398512336272497`*^9, 3.639851314289263*^9}, {
   3.639851386505226*^9, 3.6398513920490837`*^9}, {3.6398514334567223`*^9, 
   3.639851442458667*^9}, {3.6398520472224407`*^9, 3.639852138293648*^9}, {
   3.6398602044695263`*^9, 3.6398602571975403`*^9}, {3.639860289711317*^9, 
   3.6398603032074537`*^9}, {3.639860360746369*^9, 3.6398603707856817`*^9}, 
   3.639860822670916*^9, 3.639860868518692*^9, 3.639910470390381*^9, {
   3.640022903604869*^9, 3.640022941934601*^9}, {3.645276850952482*^9, 
   3.6452768974216223`*^9}, {3.647695160602067*^9, 3.647695188890544*^9}, {
   3.647782079804763*^9, 3.6477822094331837`*^9}, {3.64779328939223*^9, 
   3.647793298413467*^9}, {3.647793346623816*^9, 3.647793355071453*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"H3", "[", 
     RowBox[{
      RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
      RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
      RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", 
    RowBox[{"2", " ", "\[Pi]", " ", "Nt", " ", 
     SuperscriptBox["\[Alpha]x", "4"], " ", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"p", "^", "3"}], " ", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"p", "^", "2"}], "+", 
            RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
        RowBox[{"H2", "[", 
         RowBox[{
          RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
          RowBox[{"mh", "/", 
           RowBox[{"(", 
            RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
   ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"H3T", "[", 
     RowBox[{
      RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
      RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
      RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", 
    RowBox[{"\[Pi]", " ", "Nt", " ", 
     SuperscriptBox["\[Alpha]x", "4"], " ", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"p", "^", "3"}], " ", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"p", "^", "2"}], "+", 
            RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
        RowBox[{"H2T", "[", 
         RowBox[{
          RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
          RowBox[{"mh", "/", 
           RowBox[{"(", 
            RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
   ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H3L", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
     RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", 
   RowBox[{"2", " ", "\[Pi]", " ", "Nt", " ", 
    SuperscriptBox["\[Alpha]x", "4"], " ", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "^", "3"}], " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"p", "^", "2"}], "+", 
           RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
       RowBox[{"H2L", "[", 
        RowBox[{
         RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
         RowBox[{"mh", "/", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
      RowBox[{"AccuracyGoal", "\[Rule]", "20"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H3m", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
     RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", 
   RowBox[{"2", " ", "\[Pi]", " ", "Nt", " ", 
    SuperscriptBox["\[Alpha]x", "4"], " ", 
    SuperscriptBox["mh", "2"], " ", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"p", "^", "3"}], 
        SqrtBox[
         RowBox[{
          SuperscriptBox["p", "2"], "+", 
          SuperscriptBox["mh", "2"]}]]], " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"p", "^", "2"}], "+", 
           RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
       RowBox[{"H2", "[", 
        RowBox[{
         RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
         RowBox[{"mh", "/", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H3B", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
     RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", " ", 
   RowBox[{"2", "\[Pi]", " ", "Nt", " ", "\[Alpha]x", " ", "\[Alpha]z", " ", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{"p", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"p", "^", "2"}], "+", 
           RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
       RowBox[{"H2B", "[", 
        RowBox[{
         RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
         RowBox[{"mh", "/", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dH3Bdax", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
     RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", " ", 
   RowBox[{"2", "\[Pi]", " ", "Nt", " ", "\[Alpha]x", " ", "\[Alpha]z", " ", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{"p", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"p", "^", "2"}], "+", 
           RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"H2B", "[", 
           RowBox[{
            RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
            RowBox[{"mh", "/", 
             RowBox[{"(", 
              RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", 
          "\[Alpha]x"}], "-", 
         RowBox[{"\[Alpha]z", "*", 
          RowBox[{
           RowBox[{"dH2Bdy", "[", 
            RowBox[{
             RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
             RowBox[{"mh", "/", 
              RowBox[{"(", 
               RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", 
           SuperscriptBox["\[Alpha]x", "2"]}]}], "-", 
         RowBox[{"mh", "*", 
          RowBox[{
           RowBox[{
            RowBox[{"dH2Bdz", "[", 
             RowBox[{
              RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
              RowBox[{"mh", "/", 
               RowBox[{"(", 
                RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", "p"}],
            "/", 
           SuperscriptBox["\[Alpha]x", "2"]}]}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dH3Bdaz", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
     RowBox[{"mh_", "?", "NumericQ"}]}], "]"}], ":=", 
   RowBox[{"2", "\[Pi]", " ", "Nt", " ", "\[Alpha]x", " ", "\[Alpha]z", " ", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{"p", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"p", "^", "2"}], "+", 
           RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"H2B", "[", 
           RowBox[{
            RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
            RowBox[{"mh", "/", 
             RowBox[{"(", 
              RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", 
          "\[Alpha]z"}], "+", 
         RowBox[{
          RowBox[{"dH2Bdy", "[", 
           RowBox[{
            RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
            RowBox[{"mh", "/", 
             RowBox[{"(", 
              RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", 
          "\[Alpha]x"}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dH3BdL", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
     RowBox[{"mh_", "?", "NumericQ"}], ",", 
     RowBox[{"L_", "?", "NumericQ"}]}], "]"}], ":=", 
   RowBox[{"2", "\[Pi]", " ", "Nt", " ", "\[Alpha]x", " ", "\[Alpha]z", " ", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{"p", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"p", "^", "2"}], "+", 
           RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], "  ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"-", "mh"}], "/", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["mh", "2"], "+", 
             SuperscriptBox["p", "2"]}]]}], " ", 
          RowBox[{"H2B", "[", 
           RowBox[{
            RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
            RowBox[{"mh", "/", 
             RowBox[{"(", 
              RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], "+", 
         RowBox[{
          RowBox[{
           RowBox[{"dH2Bdz", "[", 
            RowBox[{
             RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
             RowBox[{"mh", "/", 
              RowBox[{"(", 
               RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", 
           "\[Alpha]x"}], "/", "p"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "mh"}], "/", "L"}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"dH3Bdm", "[", 
     RowBox[{
      RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
      RowBox[{"\[Alpha]z_", "?", "NumericQ"}], ",", 
      RowBox[{"mh_", "?", "NumericQ"}], ",", 
      RowBox[{"L_", "?", "NumericQ"}]}], "]"}], ":=", 
    RowBox[{
    "2", "\[Pi]", " ", "Nt", " ", "\[Alpha]x", " ", "\[Alpha]z", " ", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{"p", " ", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"p", "^", "2"}], "+", 
            RowBox[{"mh", "^", "2"}]}], "]"}]}], "]"}], "  ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "mh"}], "/", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["mh", "2"], "+", 
              SuperscriptBox["p", "2"]}]]}], " ", 
           RowBox[{"H2B", "[", 
            RowBox[{
             RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
             RowBox[{"mh", "/", 
              RowBox[{"(", 
               RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}]}], "+", 
          RowBox[{
           RowBox[{
            RowBox[{"dH2Bdz", "[", 
             RowBox[{
              RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], ",", 
              RowBox[{"mh", "/", 
               RowBox[{"(", 
                RowBox[{"\[Alpha]x", " ", "p"}], ")"}]}]}], "]"}], "/", 
            "\[Alpha]x"}], "/", "p"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "/", "L"}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"p", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OT", "[", 
    RowBox[{"\[Alpha]x_", ",", "\[Alpha]z_", ",", "mh_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"H3", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}], "+", 
    RowBox[{"H3T", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OL", "[", 
    RowBox[{"\[Alpha]x_", ",", "\[Alpha]z_", ",", "mh_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"H3", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}], "+", 
    RowBox[{"H3L", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Om", "[", 
    RowBox[{"\[Alpha]x_", ",", "\[Alpha]z_", ",", "mh_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"H3", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}], "-", 
    RowBox[{"H3L", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"H3T", "[", 
      RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}]}], "-", 
    RowBox[{"H3m", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z", ",", "mh"}], "]"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.6399104929247503`*^9, 3.639910492926877*^9}, {
   3.639910608481854*^9, 3.6399106086333103`*^9}, {3.639910736373353*^9, 
   3.6399109459551163`*^9}, {3.6399115046813383`*^9, 3.639911555587413*^9}, {
   3.6399116062614326`*^9, 3.639911661151567*^9}, {3.639911726046647*^9, 
   3.639911818804249*^9}, {3.639912424726323*^9, 3.639912481089575*^9}, {
   3.639913251149002*^9, 3.639913317397097*^9}, {3.6399137339806213`*^9, 
   3.6399137489937*^9}, {3.63991886744967*^9, 3.63991886861712*^9}, {
   3.640551971072392*^9, 3.6405519817051277`*^9}, {3.643120404721692*^9, 
   3.6431204137679787`*^9}, {3.6431204487018843`*^9, 3.643120460654129*^9}, {
   3.6431209577999783`*^9, 3.643120962879088*^9}, {3.645274837925623*^9, 
   3.64527489522908*^9}, {3.645274997743169*^9, 3.6452750028918543`*^9}, {
   3.6452768411554003`*^9, 3.6452768425334578`*^9}, {3.6452769098348827`*^9, 
   3.645276917838359*^9}, {3.645276988468054*^9, 3.6452770393977222`*^9}, 
   3.6452770768199778`*^9, {3.645277224784584*^9, 3.645277225343864*^9}, {
   3.645277872610392*^9, 3.645277872841504*^9}, 3.647691335048068*^9, {
   3.647782275899994*^9, 3.647782322621211*^9}, {3.647782404814517*^9, 
   3.6477824122954273`*^9}, {3.6477824577010202`*^9, 
   3.6477825491122913`*^9}, {3.647782609659196*^9, 3.647782612810526*^9}, 
   3.647782644029428*^9, {3.647782730301478*^9, 3.6477828112996902`*^9}, {
   3.6477828540400267`*^9, 3.647782897081975*^9}, {3.64778306823357*^9, 
   3.647783093638126*^9}, {3.6477831272147284`*^9, 3.647783165264696*^9}, {
   3.64778319943839*^9, 3.647783209037615*^9}, {3.647783248773884*^9, 
   3.647783298938271*^9}, {3.6477835109917994`*^9, 3.6477835613526087`*^9}, {
   3.647783593737301*^9, 3.6477836084310904`*^9}, {3.647783672072978*^9, 
   3.647783751457081*^9}, {3.647789626039073*^9, 3.6477896708286247`*^9}, 
   3.6477897130085087`*^9, {3.6477928094940643`*^9, 3.647792819232979*^9}, {
   3.647967955291376*^9, 3.6479679555612164`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Special Function - 2", "Section",
 CellChangeTimes->{3.641397179705118*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"H2b", "[", "y_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", "2", ",", 
     RowBox[{
      FractionBox[
       RowBox[{"y", " "}], 
       SqrtBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["y", "2"]}]]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["y", "2"]}]]}], "+", 
        RowBox[{"ArcTanh", "[", 
         FractionBox[
          SqrtBox[
           RowBox[{
            SuperscriptBox["y", "2"], "-", "1"}]], "y"], "]"}]}], ")"}]}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2Tb", "[", "y_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     FractionBox["4", "3"], ",", 
     RowBox[{
      FractionBox[
       RowBox[{"y", " "}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["y", "2"]}], ")"}], 
        RowBox[{"3", "/", "2"}]]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "y"}], 
         SqrtBox[
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["y", "2"]}]]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["y", "2"]}]}], ")"}], " ", 
         RowBox[{"ArcTanh", "[", 
          FractionBox[
           SqrtBox[
            RowBox[{
             SuperscriptBox["y", "2"], "-", "1"}]], "y"], "]"}]}]}], 
       ")"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2Lb", "[", "y_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"y", "\[Equal]", "1"}], ",", 
     FractionBox["2", "3"], ",", 
     RowBox[{
      FractionBox[
       SuperscriptBox["y", "3"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["y", "2"]}], ")"}], 
        RowBox[{"3", "/", "2"}]]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", 
         SqrtBox[
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"y", "^", "2"}]}]]}], "-", 
        RowBox[{"ArcTanh", "[", 
         FractionBox[
          SqrtBox[
           RowBox[{
            SuperscriptBox["y", "2"], "-", "1"}]], "y"], "]"}]}], ")"}]}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2bp", "[", "y_", "]"}], ":=", 
   RowBox[{
    FractionBox[
     RowBox[{"y", " "}], 
     SqrtBox[
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["y", "2"]}]]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["y", "2"]}]]}], "+", 
      RowBox[{"ArcTanh", "[", 
       FractionBox[
        SqrtBox[
         RowBox[{
          SuperscriptBox["y", "2"], "-", "1"}]], "y"], "]"}]}], ")"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2Tbp", "[", "y_", "]"}], ":=", 
   RowBox[{
    FractionBox[
     RowBox[{"y", " "}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["y", "2"]}], ")"}], 
      RowBox[{"3", "/", "2"}]]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "y"}], 
       SqrtBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["y", "2"]}]]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["y", "2"]}]}], ")"}], " ", 
       RowBox[{"ArcTanh", "[", 
        FractionBox[
         SqrtBox[
          RowBox[{
           SuperscriptBox["y", "2"], "-", "1"}]], "y"], "]"}]}]}], ")"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H2Lbp", "[", "y_", "]"}], ":=", 
   RowBox[{
    FractionBox[
     SuperscriptBox["y", "3"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["y", "2"]}], ")"}], 
      RowBox[{"3", "/", "2"}]]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y", 
       SqrtBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"y", "^", "2"}]}]]}], "-", 
      RowBox[{"ArcTanh", "[", 
       FractionBox[
        SqrtBox[
         RowBox[{
          SuperscriptBox["y", "2"], "-", "1"}]], "y"], "]"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H3b", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}]}], "]"}], "=", 
   RowBox[{"12", " ", "\[Pi]", " ", "Nt", " ", 
    RowBox[{"\[Alpha]x", "^", "4"}], " ", 
    RowBox[{"H2b", "[", 
     RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H3Tb", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}]}], "]"}], "=", 
   RowBox[{"6", " ", "\[Pi]", " ", "Nt", " ", 
    RowBox[{"\[Alpha]x", "^", "4"}], " ", 
    RowBox[{"H2Tb", "[", 
     RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H3Lb", "[", 
    RowBox[{
     RowBox[{"\[Alpha]x_", "?", "NumericQ"}], ",", 
     RowBox[{"\[Alpha]z_", "?", "NumericQ"}]}], "]"}], "=", 
   RowBox[{"12", " ", "\[Pi]", " ", "Nt", " ", 
    RowBox[{"\[Alpha]x", "^", "4"}], " ", 
    RowBox[{"H2Lb", "[", 
     RowBox[{"\[Alpha]z", "/", "\[Alpha]x"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OTb", "[", 
    RowBox[{"\[Alpha]x_", ",", "\[Alpha]z_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"H3b", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}], "+", 
    RowBox[{"H3Tb", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OLb", "[", 
    RowBox[{"\[Alpha]x_", ",", "\[Alpha]z_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"H3b", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}], "+", 
    RowBox[{"H3Lb", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Omb", "[", 
    RowBox[{"\[Alpha]x_", ",", "\[Alpha]z_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"H3b", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}], "-", 
    RowBox[{"H3Lb", "[", 
     RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"H3Tb", "[", 
      RowBox[{"\[Alpha]x", ",", "\[Alpha]z"}], "]"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.641397158562894*^9, 3.641397171314002*^9}, {
  3.643121629043743*^9, 3.643121943425551*^9}, {3.643121996508189*^9, 
  3.643122070519066*^9}, {3.649514923894306*^9, 3.649514946838011*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Realistic EoS", "Section",
 CellChangeTimes->{{3.64042971558075*^9, 3.640429731252598*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Parameters for EoS",
 FontColor->RGBColor[
  0.7803921568627451, 0.4235294117647059, 0.1607843137254902]]], "Subsection",\

 CellChangeTimes->{{3.640429795152104*^9, 3.640429803390563*^9}, {
   3.6405272086148767`*^9, 3.640527215966357*^9}, 3.640531108418304*^9, {
   3.640540615788096*^9, 3.640540619940824*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"h0", "=", "0.1396"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"h1", "=", 
   RowBox[{"\[Minus]", "0.1800"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"h2", "=", "0.0350"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f0", "=", "2.76"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f1", "=", "6.79"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f2", "=", 
   RowBox[{"\[Minus]", "5.29"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g1", "=", 
   RowBox[{"\[Minus]", "0.47"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g2", "=", "1.04"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6404298100885468`*^9, 3.640429901568861*^9}, {
  3.640434048667605*^9, 3.640434049301581*^9}, {3.6404569055167837`*^9, 
  3.640456946093067*^9}, {3.640517814191119*^9, 3.640517912311289*^9}, {
  3.640517980302885*^9, 3.6405180099906063`*^9}, {3.640518052143297*^9, 
  3.640518094454129*^9}, {3.640540632374094*^9, 3.6405406477910023`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Function",
 FontColor->RGBColor[
  0.7803921568627451, 0.4235294117647059, 0.1607843137254902]]], "Subsection",\

 CellChangeTimes->{{3.64042995152281*^9, 3.64042996370689*^9}, {
  3.6405300521618347`*^9, 3.640530053393956*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Defenitions",
 FontFamily->"Lato",
 FontSize->16,
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.6405269836069927`*^9, 3.640526992116522*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"st", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{"t", "/", "0.2"}], "*", "hbarc"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ip", "[", "tm_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], "/", 
       RowBox[{"st", "[", "tm", "]"}]}], "-", 
      RowBox[{"h2", "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"st", "[", "tm", "]"}], "^", "2"}], ")"}]}]}], "]"}], 
    RowBox[{"(", 
     RowBox[{
      FractionBox["h0", 
       RowBox[{"1", "+", 
        RowBox[{".01", " ", 
         SuperscriptBox[
          RowBox[{"st", "[", "tm", "]"}], "2"]}]}]], "+", 
      FractionBox[
       RowBox[{"f0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Tanh", "[", 
           RowBox[{
            RowBox[{"f1", "*", 
             RowBox[{"st", "[", "tm", "]"}]}], "+", "f2"}], "]"}], "+", "1"}],
          ")"}]}], 
       RowBox[{"1", "+", 
        RowBox[{"g1", "*", 
         RowBox[{"st", "[", "tm", "]"}]}], "+", 
        RowBox[{"g2", "*", 
         SuperscriptBox[
          RowBox[{"st", "[", "tm", "]"}], "2"]}]}]]}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.640429974187586*^9, 3.640429990344204*^9}, {
   3.640430023824304*^9, 3.64043017480999*^9}, 3.640430271018036*^9, {
   3.640430416049457*^9, 3.640430416136861*^9}, 3.640430628247632*^9, {
   3.6404312396034718`*^9, 3.640431245554255*^9}, {3.6404314358093*^9, 
   3.640431477417079*^9}, {3.64043152016912*^9, 3.640431539905205*^9}, {
   3.6404315780721617`*^9, 3.6404316540324497`*^9}, {3.640431790223575*^9, 
   3.640431869773134*^9}, {3.640434868945838*^9, 3.640434871201112*^9}, {
   3.640435247166518*^9, 3.640435268746132*^9}, {3.640524578300283*^9, 
   3.6405245793444653`*^9}, {3.640527567187522*^9, 3.64052756769834*^9}, 
   3.640610939097486*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Regularization of I(T) for low T In LOG scale",
 FontFamily->"Lato",
 FontSize->16,
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640524590239677*^9, 3.640524688329178*^9}, {
  3.640525617514292*^9, 3.64052562663411*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RGd", "=", ".01"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RGmax", "=", 
   RowBox[{"-", "1.3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Islop", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", 
       RowBox[{"10", ",", 
        RowBox[{"Ip", "[", 
         RowBox[{"10", "^", 
          RowBox[{"(", 
           RowBox[{"RGmax", "+", "RGd"}], ")"}]}], "]"}]}], "]"}], "-", 
      RowBox[{"Log", "[", 
       RowBox[{"10", ",", 
        RowBox[{"Ip", "[", 
         RowBox[{"10", "^", 
          RowBox[{"(", "RGmax", ")"}]}], "]"}]}], "]"}]}], ")"}], "/", 
    "RGd"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IpLogRG", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"10", ",", 
      RowBox[{"Ip", "[", 
       RowBox[{"10", "^", 
        RowBox[{"(", "RGmax", ")"}]}], "]"}]}], "]"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", "-", "RGmax"}], ")"}], "*", "Islop"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "IpRG", "]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"IpRG", "[", "lT_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Ip", "[", "lT", "]"}], "/;", 
    RowBox[{"lT", "\[GreaterEqual]", 
     RowBox[{"10", "^", "RGmax"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IpRG", "[", "lT_", "]"}], ":=", 
    RowBox[{
     RowBox[{"10", "^", 
      RowBox[{"IpLogRG", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"10", ",", "lT"}], "]"}], "]"}]}], "/;", 
     RowBox[{
      RowBox[{"Log", "[", 
       RowBox[{"10", ",", "lT"}], "]"}], "<", "RGmax"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"smallT", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"Log", "[", 
         RowBox[{"10", ",", 
          RowBox[{"Ip", "[", "x", "]"}]}], "]"}]}], ",", 
       RowBox[{"10", "^", 
        RowBox[{"IpLogRG", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "x"}], "]"}], "]"}]}], ",", 
       RowBox[{"IpRG", "[", "x", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"10", "^", 
        RowBox[{"(", 
         RowBox[{"-", "5"}], ")"}]}], ",", ".05"}], "}"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Original Func (good for Large T)\>\"", ",", 
        "\"\<Regularized (good for small T)\>\"", ",", 
        "\"\<Full Regularized function\>\""}], "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LargeT", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"Log", "[", 
         RowBox[{"10", ",", 
          RowBox[{"Ip", "[", "x", "]"}]}], "]"}]}], ",", 
       RowBox[{"10", "^", 
        RowBox[{"IpLogRG", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "x"}], "]"}], "]"}]}], ",", 
       RowBox[{"IpRG", "[", "x", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", ".01", ",", ".1"}], "}"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Original Func\>\"", ",", "\"\<Regularized (good for small T)\>\"",
         ",", "\"\<Full Regularized function  (good for Large T)\>\""}], 
       "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"smallT", ",", "LargeT"}], "}"}], "}"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.640524702660432*^9, 3.6405248492516317`*^9}, {
   3.640524985386642*^9, 3.640525286432942*^9}, {3.6405254583206673`*^9, 
   3.640525555338258*^9}, {3.640525585600286*^9, 3.640525600079092*^9}, {
   3.640525667856122*^9, 3.640525809982213*^9}, {3.6405258764743977`*^9, 
   3.640525934567782*^9}, {3.640525970664501*^9, 3.64052597492527*^9}, 
   3.64052601972766*^9, {3.6405260752620897`*^9, 3.6405261547076693`*^9}, {
   3.640526200356244*^9, 3.640526398000061*^9}, {3.6405264871276817`*^9, 
   3.64052651732857*^9}, {3.640526552715481*^9, 3.640526665175048*^9}, {
   3.6405267021073303`*^9, 3.6405267968335342`*^9}, {3.640562577472765*^9, 
   3.640562609074451*^9}, {3.640562689287181*^9, 3.640562709166251*^9}, {
   3.640602559806613*^9, 3.6406025971460648`*^9}, {3.64060264750486*^9, 
   3.640602692814446*^9}, {3.640603153599758*^9, 3.640603166358189*^9}, 
   3.640606303495247*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox[
  RowBox[{"Calculation", " ", "of", " ", 
   SubscriptBox["P", "iso"], " ", "and", " ", 
   SubscriptBox["\[CurlyEpsilon]", "iso"]}],
  FontFamily->"Lato",
  FontSize->16,
  FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640526861777834*^9, 3.64052689445863*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"sPis", ",", "sEis", ",", "Pis", ",", "Eis", ",", "Ifunc"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sPis", "[", "lT_", "]"}], ":=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"IpRG", "[", "tm", "]"}], "tm"], ",", 
     RowBox[{"{", 
      RowBox[{"tm", ",", 
       RowBox[{"10", "^", 
        RowBox[{"(", 
         RowBox[{"-", "5"}], ")"}]}], ",", "lT"}], "}"}]}], "]"}], "/;", 
   RowBox[{"lT", "<", "10"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sPis", "[", "lT_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      FractionBox[
       RowBox[{"IpRG", "[", "tm", "]"}], "tm"], ",", 
      RowBox[{"{", 
       RowBox[{"tm", ",", 
        RowBox[{"10", "^", 
         RowBox[{"(", 
          RowBox[{"-", "5"}], ")"}]}], ",", "10"}], "}"}]}], "]"}], "+", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      FractionBox[
       RowBox[{"IpRG", "[", "tm", "]"}], "tm"], ",", 
      RowBox[{"{", 
       RowBox[{"tm", ",", "10", ",", "lT"}], "}"}]}], "]"}]}], "/;", 
   RowBox[{"lT", ">", "10"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ifunc", "[", "tm_", "]"}], ":=", 
   RowBox[{
    RowBox[{"IpRG", "[", "tm", "]"}], "*", 
    SuperscriptBox["tm", "4"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Pis", "[", "lT_", "]"}], ":=", 
   RowBox[{
    RowBox[{"sPis", "[", "lT", "]"}], "*", 
    SuperscriptBox["lT", "4"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Eis", "[", "lT_", "]"}], ":=", 
   RowBox[{
    RowBox[{"3", " ", 
     RowBox[{"Pis", "[", "lT", "]"}]}], "+", 
    RowBox[{"Ifunc", "[", "lT", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sEis", "[", "lT_", "]"}], ":=", 
   RowBox[{
    RowBox[{"3", " ", 
     RowBox[{"sPis", "[", "lT", "]"}]}], "+", 
    RowBox[{"IpRG", "[", "lT", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Pis", "[", "y", "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"sFac", "/", "3"}], "*", 
        SuperscriptBox["y", "4"]}], ")"}]}], ",", 
     RowBox[{
      RowBox[{"Eis", "[", "y", "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"sFac", "*", 
        SuperscriptBox["y", "4"]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", ".05", ",", "10"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<\!\(\*SubscriptBox[\(P\), \(iso\)]\)/\!\(\*SubscriptBox[\(P\), \(SB\
\)]\)\>\"", ",", 
      "\"\<\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \
\(iso\)]\)/\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \(SB\)]\)\>\""}], "}"}]}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Axes", "\[Rule]", "False"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<T [1/fm]\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"LineLegend", "[", 
       RowBox[{"styles", ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<E/\\!\\(\\*SubscriptBox[\\(E\\), \\(SB\\)]\\)\>\"", ",", 
          "\"\<P/\\!\\(\\*SubscriptBox[\\(P\\), \\(SB\\)]\\)\>\""}], "}"}], 
        ",", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
        RowBox[{"LegendMarkerSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"45", ",", "4"}], "}"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.75", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.640430887272266*^9, 3.6404308892416983`*^9}, {
   3.640431267655884*^9, 3.6404312887511263`*^9}, {3.640431707061056*^9, 
   3.640431754797186*^9}, {3.64043187309205*^9, 3.64043192169184*^9}, {
   3.640432884461884*^9, 3.640432894852358*^9}, {3.640434009692959*^9, 
   3.6404340110210447`*^9}, {3.6404353095246696`*^9, 3.640435310203393*^9}, {
   3.6404354202913237`*^9, 3.640435469465308*^9}, {3.640435515795149*^9, 
   3.640435528554863*^9}, {3.6404359173679857`*^9, 3.640435984411997*^9}, {
   3.64043608447505*^9, 3.6404361162024813`*^9}, {3.6404439673251*^9, 
   3.640443975238023*^9}, {3.640448625936404*^9, 3.6404486401703672`*^9}, {
   3.6404486788351583`*^9, 3.640448739930036*^9}, {3.640448786163555*^9, 
   3.640448797081944*^9}, {3.640517964424856*^9, 3.6405179663202763`*^9}, 
   3.640519231775885*^9, 3.6405194703631487`*^9, 3.640519556339056*^9, {
   3.6405275214899273`*^9, 3.640527529301869*^9}, {3.6405275781140137`*^9, 
   3.640527582759602*^9}, {3.640552220692381*^9, 3.640552221002912*^9}, {
   3.640610723207107*^9, 3.640610728079009*^9}, 3.640610763093935*^9, 
   3.6406107959430933`*^9, {3.6406124871386642`*^9, 3.640612489505102*^9}, 
   3.6406125549058037`*^9, {3.640612639762027*^9, 3.640612640062639*^9}, {
   3.640612717241214*^9, 3.6406127238957253`*^9}, {3.640612763268631*^9, 
   3.640612787344125*^9}, {3.6406254770219517`*^9, 3.640625478535664*^9}, {
   3.640625867350417*^9, 3.640625885318781*^9}, {3.640625966661539*^9, 
   3.6406259748443823`*^9}, {3.640626114354574*^9, 3.640626117362041*^9}, {
   3.6489862201951942`*^9, 3.648986221475678*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interpolations", "Subsection",
 CellChangeTimes->{{3.640448824401534*^9, 3.640448836433029*^9}, {
  3.640448892292045*^9, 3.640448893803585*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Logarithmic Interpolations for Piso",
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640448861988687*^9, 3.6404488751281424`*^9}, {
  3.640612863755127*^9, 3.640612868891745*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"logtmin", ",", "logtmax", ",", "logtN", ",", "logtd"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmin", "=", 
   RowBox[{"-", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtN", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtd", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"logtmax", "-", "logtmin"}], ")"}], "/", "logtN"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TableLogPis", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", "lT"}], ",", 
       RowBox[{"Pis", "[", 
        SuperscriptBox["10", "lT"], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lT", ",", "logtmin", ",", "logtmax", ",", "logtd"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IntLogPis", "=", 
  RowBox[{"Interpolation", "[", "TableLogPis", "]"}]}]}], "Input",
 CellChangeTimes->{{3.640515258522608*^9, 3.6405152590264482`*^9}, {
   3.640540782141634*^9, 3.640540786519899*^9}, {3.6405411756289873`*^9, 
   3.640541181932859*^9}, 3.640612829385396*^9, {3.640612930319306*^9, 
   3.640612957911871*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Logarithmic Interpolations for Eiso",
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640448861988687*^9, 3.6404488751281424`*^9}, {
  3.640612863755127*^9, 3.640612882147647*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"logtmin", ",", "logtmax", ",", "logtN", ",", "logtd"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmin", "=", 
   RowBox[{"-", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtN", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtd", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"logtmax", "-", "logtmin"}], ")"}], "/", "logtN"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TableLogEis", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", "lT"}], ",", 
       RowBox[{"Eis", "[", 
        SuperscriptBox["10", "lT"], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lT", ",", "logtmin", ",", "logtmax", ",", "logtd"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IntLogEis", "=", 
  RowBox[{"Interpolation", "[", "TableLogEis", "]"}]}]}], "Input",
 CellChangeTimes->{{3.640515258522608*^9, 3.6405152590264482`*^9}, {
   3.640540782141634*^9, 3.640540786519899*^9}, {3.6405411756289873`*^9, 
   3.640541181932859*^9}, 3.640612829385396*^9, {3.6406129699750423`*^9, 
   3.640612971048127*^9}, {3.640613001582871*^9, 3.64061301912673*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Logarithmic Interpolations for sPiso",
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640448861988687*^9, 3.6404488751281424`*^9}, {
  3.640612863755127*^9, 3.640612886691478*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"logtmin", ",", "logtmax", ",", "logtN", ",", "logtd"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmin", "=", 
   RowBox[{"-", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtN", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtd", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"logtmax", "-", "logtmin"}], ")"}], "/", "logtN"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TableLogsPis", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", "lT"}], ",", 
       RowBox[{"sPis", "[", 
        SuperscriptBox["10", "lT"], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lT", ",", "logtmin", ",", "logtmax", ",", "logtd"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IntLogsPis", "=", 
  RowBox[{"Interpolation", "[", "TableLogsPis", "]"}]}]}], "Input",
 CellChangeTimes->{{3.640515258522608*^9, 3.6405152590264482`*^9}, {
   3.640540782141634*^9, 3.640540786519899*^9}, {3.6405411756289873`*^9, 
   3.640541181932859*^9}, 3.640612829385396*^9, {3.640612978942926*^9, 
   3.640612980927369*^9}, {3.640613031606707*^9, 3.6406130383086433`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Logarithmic Interpolations for sEiso",
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640448861988687*^9, 3.6404488751281424`*^9}, {
  3.640612863755127*^9, 3.640612893106859*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"logtmin", ",", "logtmax", ",", "logtN", ",", "logtd"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmin", "=", 
   RowBox[{"-", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtN", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtd", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"logtmax", "-", "logtmin"}], ")"}], "/", "logtN"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TableLogsEis", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", "lT"}], ",", 
       RowBox[{"sEis", "[", 
        SuperscriptBox["10", "lT"], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lT", ",", "logtmin", ",", "logtmax", ",", "logtd"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IntLogsEis", "=", 
  RowBox[{"Interpolation", "[", "TableLogsEis", "]"}]}]}], "Input",
 CellChangeTimes->{{3.640515258522608*^9, 3.6405152590264482`*^9}, {
   3.640540782141634*^9, 3.640540786519899*^9}, {3.6405411756289873`*^9, 
   3.640541181932859*^9}, 3.640612829385396*^9, {3.640612985903082*^9, 
   3.64061298639937*^9}, {3.640613049574963*^9, 3.640613066861989*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Plots for Comparison",
 FontColor->RGBColor[0.5, 0, 0.5]]], "Subsubsection",
 CellChangeTimes->{{3.640448902499522*^9, 3.6404489166651897`*^9}, 
   3.640613087553941*^9, 3.640613268545189*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"IntLogPis", "[", "y", "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"sFac", "/", "3"}], "*", 
          SuperscriptBox["y", "4"]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"IntLogEis", "[", "y", "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "*", 
          SuperscriptBox["y", "4"]}], ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", ".05", ",", "10"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(P\), \(iso\)]\)/\!\(\*SubscriptBox[\(P\), \
\(SB\)]\)\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \
\(iso\)]\)/\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \(SB\)]\)\>\""}], "}"}]}], 
     ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<T [GeV]\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<E/\\!\\(\\*SubscriptBox[\\(E\\), \\(SB\\)]\\)\>\"", ",", 
            "\"\<P/\\!\\(\\*SubscriptBox[\\(P\\), \\(SB\\)]\\)\>\""}], "}"}], 
          ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"45", ",", "4"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.75", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"IntLogsPis", "[", "y", "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "/", "3"}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"IntLogsEis", "[", "y", "]"}], "/", 
        RowBox[{"(", "sFac", ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", ".05", ",", "10"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(P\), \(iso\)]\)/\!\(\*SubscriptBox[\(P\), \
\(SB\)]\)\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \
\(iso\)]\)/\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \(SB\)]\)\>\""}], "}"}]}], 
     ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<T [GeV]\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<E/\\!\\(\\*SubscriptBox[\\(E\\), \\(SB\\)]\\)\>\"", ",", 
            "\"\<P/\\!\\(\\*SubscriptBox[\\(P\\), \\(SB\\)]\\)\>\""}], "}"}], 
          ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"45", ",", "4"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.75", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"p1", ",", "p2"}], "}"}], "}"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.640442043687935*^9, 3.6404420997129297`*^9}, {
   3.640442286752447*^9, 3.640442328503788*^9}, {3.640442359864175*^9, 
   3.6404423616790943`*^9}, {3.640442401169128*^9, 3.640442450628236*^9}, {
   3.640442502992318*^9, 3.6404425118634863`*^9}, {3.640443932404688*^9, 
   3.640443951876042*^9}, {3.640444405673706*^9, 3.6404444571124277`*^9}, {
   3.640445956765417*^9, 3.6404459624313707`*^9}, {3.640448098177032*^9, 
   3.6404481334867163`*^9}, {3.640448179098435*^9, 3.640448179322701*^9}, {
   3.640448261698154*^9, 3.640448274908462*^9}, {3.6404483397707157`*^9, 
   3.640448339899778*^9}, {3.640448385249098*^9, 3.640448468165097*^9}, {
   3.640448503349956*^9, 3.640448610570837*^9}, {3.640448956513115*^9, 
   3.640449000409857*^9}, {3.640514906216216*^9, 3.640514920524002*^9}, {
   3.640515307495096*^9, 3.640515345059759*^9}, {3.640519215359864*^9, 
   3.640519218159491*^9}, {3.640540814914712*^9, 3.640540926006817*^9}, {
   3.640540981162966*^9, 3.640540990306444*^9}, {3.6405410560010843`*^9, 
   3.640541114052259*^9}, {3.6405411624958267`*^9, 3.640541162661401*^9}, {
   3.64054132965409*^9, 3.640541423197818*^9}, 3.64055316053578*^9, {
   3.640602829044455*^9, 3.6406028476138783`*^9}, {3.64061085818814*^9, 
   3.640610886907302*^9}, {3.640610974395953*^9, 3.640611001175301*^9}, {
   3.6406131702514753`*^9, 3.640613250988256*^9}, 3.640613629474799*^9}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Final Defenitions and Tests", "Subsection",
 CellChangeTimes->{{3.6404361422999363`*^9, 3.64043616725883*^9}, {
   3.640441627755413*^9, 3.640441774130659*^9}, {3.640441907521224*^9, 
   3.640441936489087*^9}, {3.640444668426917*^9, 3.640444823221491*^9}, {
   3.640445117491715*^9, 3.640445170876938*^9}, {3.640445301379167*^9, 
   3.6404453242916193`*^9}, 3.6404480774213676`*^9, {3.640448226663229*^9, 
   3.64044822922211*^9}, {3.6404483084255543`*^9, 3.640448311436406*^9}, 
   3.640448848524151*^9, {3.640515354982895*^9, 3.640515368441592*^9}, {
   3.640613621902112*^9, 3.640613624805656*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IPis", "[", "x_", "]"}], ":=", 
   RowBox[{"IntLogPis", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IEis", "[", "x_", "]"}], ":=", 
   RowBox[{"IntLogEis", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsPis", "[", "x_", "]"}], ":=", 
   RowBox[{"IntLogsPis", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsEis", "[", "x_", "]"}], ":=", 
   RowBox[{"IntLogsEis", "[", "x", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640515375816532*^9, 3.6405154735071793`*^9}, {
  3.640613434675254*^9, 3.640613500130451*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"IPis", "[", 
         RowBox[{"y", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"sFac", "/", "3"}], "*", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y", "/", "hbarc"}], ")"}], "4"]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"IEis", "[", 
         RowBox[{"y", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "*", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y", "/", "hbarc"}], ")"}], "4"]}], ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", ".01", ",", "2"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(P\), \(iso\)]\)/\!\(\*SubscriptBox[\(P\), \
\(SB\)]\)\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \
\(iso\)]\)/\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \(SB\)]\)\>\""}], "}"}]}], 
     ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<T [GeV]\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<E/\\!\\(\\*SubscriptBox[\\(E\\), \\(SB\\)]\\)\>\"", ",", 
            "\"\<P/\\!\\(\\*SubscriptBox[\\(P\\), \\(SB\\)]\\)\>\""}], "}"}], 
          ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"45", ",", "4"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.75", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"IsPis", "[", 
         RowBox[{"y", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "/", "3"}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"IsEis", "[", 
         RowBox[{"y", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", "sFac", ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", ".01", ",", "2"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(P\), \(iso\)]\)/\!\(\*SubscriptBox[\(P\), \
\(SB\)]\)\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \
\(iso\)]\)/\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \(SB\)]\)\>\""}], "}"}]}], 
     ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<T [GeV]\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<E/\\!\\(\\*SubscriptBox[\\(E\\), \\(SB\\)]\\)\>\"", ",", 
            "\"\<P/\\!\\(\\*SubscriptBox[\\(P\\), \\(SB\\)]\\)\>\""}], "}"}], 
          ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"45", ",", "4"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.75", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"p1", ",", "p2"}], "}"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.6406135088024397`*^9, 3.640613534207037*^9}, {
   3.6406135845141907`*^9, 3.640613617842298*^9}, 3.6406262389301863`*^9, {
   3.642942425902624*^9, 3.642942491898378*^9}, {3.6501264192303667`*^9, 
   3.650126419355322*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.5, 0.5, 0.5], AbsoluteThickness[2], Opacity[1.], 
    AbsoluteDashing[{1, 4}], LineBox[CompressedData["
1:eJwV13c81d8bAHAySyppGJWZlRUaKOcJhZIdEpK93XvtsrncK1skiYa9EoUo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     "]]}},
  AspectRatio->0.75,
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->{
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times", 
     AbsoluteThickness[1]], 
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times", 
     AbsoluteThickness[1]]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  FrameTicksStyle->{
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times"], 
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times"]},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution for M (T)", "Section",
 CellChangeTimes->{{3.640515132584017*^9, 3.640515142971263*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"M", 
    RowBox[{"(", "T", ")"}], " ", "is", " ", "calculated", " ", "by", " ", 
    "FindRoot", " ", "down", " ", "to", " ", 
    RowBox[{"T", "~", "0.0035"}], " ", 
    RowBox[{"1", "/", "fm"}]}], " ", "=", " ", 
   RowBox[{"0.0007", " ", "GeV"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.6406262677700787`*^9, 3.6406262706981087`*^9}, {
  3.640626420131152*^9, 3.640626453610121*^9}, {3.6406269530947227`*^9, 
  3.6406269927908897`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"Mt", "[", "lT_", "]"}], ":=", 
     RowBox[{"lM", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"IsEis", "[", "lT", "]"}], "+", 
          RowBox[{"IsPis", "[", "lT", "]"}]}], "\[Equal]", 
         RowBox[{
          FractionBox["Ndof", 
           RowBox[{"2", " ", 
            SuperscriptBox["\[Pi]", "2"]}]], 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lM", "lT"], ")"}], "3"], 
          RowBox[{"K3", "[", 
           RowBox[{"lM", "/", "lT"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"lM", ",", ".45"}], "}"}], ",", 
        RowBox[{"AccuracyGoal", "\[Rule]", "Infinity"}]}], "]"}]}]}], ";"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Mt", "[", "lT_", "]"}], ":=", 
     RowBox[{"lM", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"IsEis", "[", "lT", "]"}], "+", 
          RowBox[{"IsPis", "[", "lT", "]"}]}], "\[Equal]", 
         RowBox[{
          FractionBox["Ndof", 
           RowBox[{"2", " ", 
            SuperscriptBox["\[Pi]", "2"]}]], 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lM", "lT"], ")"}], "3"], 
          RowBox[{"K3", "[", 
           RowBox[{"lM", "/", "lT"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"lM", ",", ".45"}], "}"}], ",", 
        RowBox[{"AccuracyGoal", "\[Rule]", "40"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hbarc", "*", 
       RowBox[{"Mt", "[", 
        RowBox[{"lM", "/", "hbarc"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lM", ",", ".001", ",", ".1"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.640616005206514*^9, 3.640616006129367*^9}, {
   3.640616761981534*^9, 3.6406167865020647`*^9}, {3.640620924865342*^9, 
   3.640620924904711*^9}, {3.640621270478936*^9, 3.640621284377392*^9}, {
   3.640621345404182*^9, 3.640621450594509*^9}, {3.640621549770219*^9, 
   3.640621551866461*^9}, {3.6406258350302687`*^9, 3.6406258475542793`*^9}, {
   3.6406258921713133`*^9, 3.640625897033969*^9}, 3.640626768485285*^9, {
   3.6406268909315567`*^9, 3.6406269123948593`*^9}, 3.643467984152378*^9, {
   3.6434680767838707`*^9, 3.643468080023337*^9}, {3.645359491529181*^9, 
   3.64535950566393*^9}, 3.648986278172283*^9, {3.649448615173409*^9, 
   3.649448629640911*^9}, {3.649448741157076*^9, 3.6494487815506687`*^9}, {
   3.649449104594377*^9, 3.649449105690007*^9}}],

Cell[CellGroupData[{

Cell["Regularization of M (T) for T < 0.01", "Subsection",
 CellChangeTimes->{{3.6405617746374826`*^9, 3.640561808853763*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RGd", "=", "0.001"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"RGmax", "=", 
     RowBox[{"-", "2.44"}]}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RGmax", "=", 
    RowBox[{"-", "0.6020"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Note", ":", " ", 
     RowBox[{
      RowBox[{"because", " ", "M", 
       RowBox[{"(", "T", ")"}], " ", "is", " ", "a", " ", "decreasing", " ", 
       "function", " ", "for", " ", "0.36"}], "<", "T", "<", 
      RowBox[{
      "0.07", " ", "the", " ", "current", " ", "definition", " ", "of", " ", 
       "Mslop", " ", "has", " ", "to", " ", "be", " ", "inverted", " ", "for",
        " ", "that", " ", "range", " ", "to", " ", "give", " ", "a", " ", 
       "falling", " ", "function", " ", "back", " ", "to", " ", "zero", " ", 
       "at", " ", "T"}]}]}], "=", "0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mslop", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", 
       RowBox[{"10", ",", 
        RowBox[{"Mt", "[", 
         RowBox[{"10", "^", 
          RowBox[{"(", 
           RowBox[{"RGmax", "+", "RGd"}], ")"}]}], "]"}]}], "]"}], "-", 
      RowBox[{"Log", "[", 
       RowBox[{"10", ",", 
        RowBox[{"Mt", "[", 
         RowBox[{"10", "^", 
          RowBox[{"(", "RGmax", ")"}]}], "]"}]}], "]"}]}], ")"}], "/", 
    "RGd"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MLogRG", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"10", ",", 
      RowBox[{"Mt", "[", 
       RowBox[{"10", "^", 
        RowBox[{"(", "RGmax", ")"}]}], "]"}]}], "]"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", "-", "RGmax"}], ")"}], "*", "Mslop"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "MRG", "]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MRG", "[", "lT_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Mt", "[", "lT", "]"}], "/;", 
    RowBox[{"lT", "\[GreaterEqual]", 
     RowBox[{"10", "^", "RGmax"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"MRG", "[", "lT_", "]"}], ":=", 
  RowBox[{
   RowBox[{"10", "^", 
    RowBox[{"MLogRG", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"10", ",", "lT"}], "]"}], "]"}]}], "/;", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"10", ",", "lT"}], "]"}], "<", 
    "RGmax"}]}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.640524702660432*^9, 3.6405248492516317`*^9}, {
   3.640524985386642*^9, 3.640525286432942*^9}, {3.6405254583206673`*^9, 
   3.640525555338258*^9}, {3.640525585600286*^9, 3.640525600079092*^9}, {
   3.640525667856122*^9, 3.640525809982213*^9}, {3.6405258764743977`*^9, 
   3.640525934567782*^9}, {3.640525970664501*^9, 3.64052597492527*^9}, 
   3.64052601972766*^9, {3.6405260752620897`*^9, 3.6405261547076693`*^9}, {
   3.640526200356244*^9, 3.640526398000061*^9}, {3.6405264871276817`*^9, 
   3.64052651732857*^9}, {3.640526552715481*^9, 3.640526665175048*^9}, {
   3.6405267021073303`*^9, 3.6405267968335342`*^9}, {3.640561825030816*^9, 
   3.6405620060898447`*^9}, {3.6405620402567577`*^9, 3.640562089200131*^9}, {
   3.640562235124153*^9, 3.640562237866789*^9}, {3.6405622902583437`*^9, 
   3.640562316055881*^9}, {3.640562346215797*^9, 3.640562395517572*^9}, {
   3.640562528239601*^9, 3.640562532407056*^9}, 3.640603032159082*^9, {
   3.640603320931486*^9, 3.640603322092663*^9}, 3.640603368385708*^9, {
   3.640604831610188*^9, 3.640604834550948*^9}, {3.6406051874614897`*^9, 
   3.6406052298931503`*^9}, {3.640605616348304*^9, 3.640605648631267*^9}, 
   3.6406057539067163`*^9, {3.640606448321184*^9, 3.64060644949717*^9}, {
   3.640606624525715*^9, 3.640606662426508*^9}, {3.6406069111624327`*^9, 
   3.640606926101028*^9}, {3.640606966097823*^9, 3.64060705010902*^9}, {
   3.640609194019596*^9, 3.64060920933097*^9}, 3.640609594506617*^9, {
   3.640609779968514*^9, 3.6406097806020527`*^9}, {3.640613843620831*^9, 
   3.6406138438928013`*^9}, {3.640627104571413*^9, 3.640627119916389*^9}, 
   3.640627169059417*^9, {3.6415620307155*^9, 3.6415620595624437`*^9}, 
   3.641562108223775*^9, {3.649448648258238*^9, 3.649448656454463*^9}, {
   3.649448979029723*^9, 3.649448981955041*^9}, {3.6494491634181757`*^9, 
   3.6494491967695227`*^9}, {3.6494493102160063`*^9, 3.649449313084976*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"smallT", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Mt", "[", "x", "]"}], ",", 
       RowBox[{"10", "^", 
        RowBox[{"MLogRG", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "x"}], "]"}], "]"}]}], ",", 
       RowBox[{"MRG", "[", "x", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"10", "^", 
        RowBox[{"(", 
         RowBox[{"-", "4"}], ")"}]}], ",", "2"}], "}"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Original function\>\"", ",", 
        "\"\<Regularized (good for small T)\>\"", ",", 
        "\"\<Full Regularized function\>\""}], "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.640609243199535*^9, 3.640609253815909*^9}, {
   3.6406096283256607`*^9, 3.640609636541712*^9}, {3.6406097844843283`*^9, 
   3.640609789584682*^9}, {3.640609856789732*^9, 3.6406098578427362`*^9}, 
   3.6406155069038754`*^9, {3.640615543414863*^9, 3.640615558222039*^9}, {
   3.640615589518751*^9, 3.640615607868586*^9}, {3.640627210692292*^9, 
   3.6406273573113203`*^9}, {3.649449516182124*^9, 3.6494495232145844`*^9}, {
   3.64944955371377*^9, 3.6494495634421787`*^9}, 3.649449675493074*^9}],

Cell[CellGroupData[{

Cell["Logarithmic Interpolations", "Subsubsection",
 CellChangeTimes->{{3.640521857454762*^9, 3.640521878402391*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"logtmin", "=", 
   RowBox[{"-", "4"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtmax", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtN", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logtd", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"logtmax", "-", "logtmin"}], ")"}], "/", "logtN"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TableLogM", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"10", "^", "lT"}], ",", 
       RowBox[{"MRG", "[", 
        SuperscriptBox["10", "lT"], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lT", ",", "logtmin", ",", "logtmax", ",", "logtd"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IntLogM", "=", 
  RowBox[{"Interpolation", "[", "TableLogM", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", "M", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", "x_", "]"}], ":=", 
   RowBox[{"IntLogM", "[", "x", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6405219161218224`*^9, 3.640521973897613*^9}, {
   3.640530155318843*^9, 3.640530155461775*^9}, {3.640541527001919*^9, 
   3.640541538665698*^9}, {3.6405569798168373`*^9, 3.6405570511184483`*^9}, {
   3.640560737541358*^9, 3.640560740482731*^9}, {3.6405608630633297`*^9, 
   3.6405608633504477`*^9}, {3.640604900298876*^9, 3.640604902251142*^9}, {
   3.640607909275498*^9, 3.640607914169291*^9}, 3.64139628627427*^9}],

Cell[BoxData[{
 RowBox[{"p", "=", 
  RowBox[{"LogLinearPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"M", "[", 
       RowBox[{"x", "/", "hbarc"}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"x", "/", "hbarc"}], ")"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", ".01", ",", "2"}], "}"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<T[GeV]\>\"", ",", "\"\<M(T)/T\>\""}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"wd", "<>", "\"\</m-over-T\>\"", "<>", "\"\<.pdf\>\""}], ",", 
     "p", ",", 
     RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.640516505316223*^9, 3.6405165551035137`*^9}, {
   3.640518159868821*^9, 3.640518184891671*^9}, {3.640519127405953*^9, 
   3.640519130772462*^9}, {3.6405191893482113`*^9, 3.6405191995558167`*^9}, {
   3.640519565906763*^9, 3.640519567032832*^9}, {3.640519598914753*^9, 
   3.6405196634101763`*^9}, {3.640519756067124*^9, 3.6405197963612413`*^9}, {
   3.640519836370645*^9, 3.640519889009755*^9}, {3.640519954707903*^9, 
   3.640520064743767*^9}, {3.6405397983692627`*^9, 3.640539829640366*^9}, {
   3.640604955027952*^9, 3.640604988482644*^9}, 3.640605159028585*^9, {
   3.640607712967181*^9, 3.640607713166212*^9}, {3.640627443471548*^9, 
   3.6406274832697372`*^9}, {3.6406325952942038`*^9, 3.6406326007851458`*^9}, 
   3.641396342331815*^9, {3.6413964619999332`*^9, 3.6413964901221437`*^9}, {
   3.642939568614661*^9, 3.642939608249423*^9}, {3.6429396983437967`*^9, 
   3.64293973799127*^9}, {3.642939780105105*^9, 3.642939863466683*^9}, {
   3.642939902868031*^9, 3.6429400272785273`*^9}, {3.642941625859942*^9, 
   3.6429416288017883`*^9}, {3.6429416607325153`*^9, 3.642941674665934*^9}, {
   3.6434710282995663`*^9, 3.6434710317220182`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.5, 0.5, 0.5], AbsoluteThickness[2], Opacity[1.], 
    AbsoluteDashing[{1, 4}], LineBox[CompressedData["
1:eJwVznk0FOofBvBZbE2WmRHGGkJRNLZMlt4vcZUkLZaSUmghCV0qSlGUiyRb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     "]]}},
  AspectRatio->0.75,
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{-5.135001792888183, Automatic},
  BaseStyle->{FontSize -> 16},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"M(T)/T\"", TraditionalForm], None}, {
     FormBox["\"T[GeV]\"", TraditionalForm], None}},
  FrameStyle->{
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times", 
     AbsoluteThickness[1]], 
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times", 
     AbsoluteThickness[1]]},
  FrameTicks->FrontEndValueCache[{{Automatic, Automatic}, {
      Charting`ScaledTicks[{Log, Exp}], 
      Charting`ScaledFrameTicks[{Log, Exp}]}}, {{
     Automatic, Automatic}, {{{-4.605170185988091, 
        FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.995732273553991, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.05\"", 0.05, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 2.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.10\"", 0.1, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 2.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 2.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0., 
        FormBox["1", TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.298317366548036, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.115995809754082, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.961845129926823, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.710530701645918, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.912023005428146, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.506557897319982, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.659260036932778, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.916290731874155, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.6931471805599453, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.791759469228055, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.302585092994046, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}}, {{-4.605170185988091, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.995732273553991, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0., 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.298317366548036, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.115995809754082, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.961845129926823, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.710530701645918, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.912023005428146, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.506557897319982, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.659260036932778, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.916290731874155, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.6931471805599453, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.791759469228055, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.302585092994046, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}}}}],
  FrameTicksStyle->{
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times"], 
    Directive[
     GrayLevel[0], FontSize -> 20, FontFamily -> "Times"]},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-5.135001792888183, 1.222978787460038}, {1.1379365133440562`, 
   21.239504357172486`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{
    Charting`ScaledTicks[{Log, Exp}], Automatic}]], "Input"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution for B (T)", "Section",
 CellChangeTimes->{{3.639913626372409*^9, 3.63991364791481*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Temp0", "=", ".0001"}], ";"}], "  "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tempf", "=", "50"}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"1", "/", "fm"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"Bfn", "/.", 
    RowBox[{
     RowBox[{"NDSolve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"Bfn", "[", "x", "]"}], ",", "x"}], "]"}], "==", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"Ndof", " ", 
              SuperscriptBox[
               RowBox[{"M", "[", "x", "]"}], "2"], "x"}], 
             RowBox[{"2", " ", 
              SuperscriptBox["\[Pi]", "2"]}]]}], 
           RowBox[{"K1", "[", 
            FractionBox[
             RowBox[{"M", "[", "x", "]"}], "x"], "]"}], 
           RowBox[{
            RowBox[{"M", "'"}], "[", "x", "]"}]}]}], ",", 
         RowBox[{
          RowBox[{"Bfn", "[", "0.0001", "]"}], "\[Equal]", "0"}]}], "}"}], 
       ",", "Bfn", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "Temp0", ",", "Tempf"}], "}"}], ",", 
       RowBox[{"AccuracyGoal", "\[Rule]", "40"}], ",", 
       RowBox[{"Method", "\[Rule]", "\"\<ExplicitRungeKutta\>\""}]}], "]"}], 
     "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6399136993769484`*^9, 3.6399138102241297`*^9}, {
   3.639913976662046*^9, 3.639914019103731*^9}, {3.639914059662362*^9, 
   3.6399140737655773`*^9}, {3.639914315229718*^9, 3.639914325860442*^9}, {
   3.6399189770414248`*^9, 3.639918983041698*^9}, {3.639919052017679*^9, 
   3.6399190523371477`*^9}, {3.6399196087004128`*^9, 3.639919610820475*^9}, {
   3.639919884394224*^9, 3.639919921833785*^9}, {3.6399199558984957`*^9, 
   3.639920005616337*^9}, {3.639920047264522*^9, 3.639920071463388*^9}, {
   3.6399201099991283`*^9, 3.639920110207309*^9}, 3.6401077364209747`*^9, {
   3.640109097477631*^9, 3.640109103795739*^9}, {3.6401091435775547`*^9, 
   3.640109145225964*^9}, {3.640358688253705*^9, 3.6403586900208473`*^9}, {
   3.640358812660666*^9, 3.640358826765134*^9}, 3.640358943660325*^9, {
   3.640365103526182*^9, 3.6403651138697863`*^9}, {3.64036522229364*^9, 
   3.640365223413414*^9}, {3.640366997041695*^9, 3.640367014785075*^9}, {
   3.6405201162710037`*^9, 3.640520153726685*^9}, {3.64052018714314*^9, 
   3.640520218774191*^9}, {3.640520351080195*^9, 3.6405203554309387`*^9}, {
   3.640529856778673*^9, 3.640529864776925*^9}, {3.640530274893958*^9, 
   3.64053027558945*^9}, {3.640541579034977*^9, 3.640541586498116*^9}, {
   3.640541902577981*^9, 3.64054190615701*^9}, {3.6405422861861897`*^9, 
   3.640542287569862*^9}, {3.640542563404594*^9, 3.640542609923884*^9}, {
   3.640542655156358*^9, 3.640542687738702*^9}, {3.6405427195569*^9, 
   3.640542720531369*^9}, {3.640542936872644*^9, 3.640542937120804*^9}, 
   3.6406077324883432`*^9, {3.6406080795094023`*^9, 3.6406081204800167`*^9}, {
   3.6406282547687893`*^9, 3.6406282622049007`*^9}, {3.6406297605581617`*^9, 
   3.640629764237137*^9}, {3.6406326211687098`*^9, 3.640632623016577*^9}, {
   3.640709428555189*^9, 3.6407094298595533`*^9}, {3.640709620312096*^9, 
   3.6407096220257998`*^9}, {3.640710238238471*^9, 3.64071023960248*^9}, {
   3.640778580607031*^9, 3.6407785826948547`*^9}, {3.641393907679693*^9, 
   3.641393935728919*^9}, {3.641394215813856*^9, 3.64139421614203*^9}, {
   3.641394255679286*^9, 3.641394256505638*^9}, {3.641394307677079*^9, 
   3.641394335205269*^9}, {3.641395310731061*^9, 3.641395329490802*^9}, {
   3.6413953811768723`*^9, 3.64139539842526*^9}, {3.641395629404454*^9, 
   3.641395630717099*^9}, {3.641395787189687*^9, 3.641395810131918*^9}, {
   3.641395893488124*^9, 3.6413959117594357`*^9}, {3.64139614966965*^9, 
   3.641396152677176*^9}, 3.641396503588133*^9, 3.641564197639159*^9, {
   3.642941206926468*^9, 3.642941223642323*^9}, {3.6494497188784647`*^9, 
   3.649449719082782*^9}, {3.649599917420446*^9, 3.64959991772219*^9}, {
   3.6496001613363657`*^9, 3.649600175584194*^9}, {3.64960021753752*^9, 
   3.6496002297534246`*^9}}],

Cell[BoxData[{
 RowBox[{"p", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"B", "[", 
       RowBox[{"x", "/", "hbarc"}], "]"}]}], "/", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"x", "/", "hbarc"}], ")"}], "4"]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", ".001", ",", "2"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "15"}], "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<T (GeV)\>\"", ",", 
       "\"\<B(T)/\!\(\*SuperscriptBox[\(T\), \(4\)]\)\>\""}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"wd", "<>", "\"\</B-over-T4\>\"", "<>", "\"\<.pdf\>\""}], ",", 
     "p", ",", 
     RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.63991368179564*^9, 3.6399136934408627`*^9}, 
   3.6399139663676643`*^9, {3.6399140263910103`*^9, 3.639914032269866*^9}, {
   3.6399141540632133`*^9, 3.639914230732717*^9}, 3.6399142966455584`*^9, {
   3.639918991289111*^9, 3.639919034800438*^9}, {3.639919942583675*^9, 
   3.639919945230804*^9}, 3.639919996806251*^9, {3.640005432000103*^9, 
   3.6400054341190243`*^9}, {3.640025123892559*^9, 3.640025124187757*^9}, {
   3.640107264918293*^9, 3.640107299300199*^9}, {3.640107405820991*^9, 
   3.6401074255474873`*^9}, {3.640107486324646*^9, 3.6401074952597322`*^9}, {
   3.6401075851642103`*^9, 3.640107717540744*^9}, {3.64010911628109*^9, 
   3.6401091508572273`*^9}, 3.640358697556752*^9, {3.640365236908759*^9, 
   3.640365317476426*^9}, {3.6403670428473577`*^9, 3.64036704363832*^9}, {
   3.64054271372078*^9, 3.640542725120532*^9}, {3.640608057287731*^9, 
   3.640608067277712*^9}, {3.640608132635253*^9, 3.64060813406074*^9}, {
   3.640628290134849*^9, 3.6406283629602547`*^9}, {3.642940065892264*^9, 
   3.642940228007856*^9}, {3.642940438437911*^9, 3.642940445163746*^9}, {
   3.642940944566579*^9, 3.642940954309269*^9}, {3.642940996760021*^9, 
   3.6429410086934*^9}, 3.6429410772932587`*^9, {3.6429414116901827`*^9, 
   3.642941412373776*^9}, {3.642941459831396*^9, 3.642941487343175*^9}, {
   3.642941585798592*^9, 3.642941598938342*^9}, {3.6434709842660437`*^9, 
   3.643470986922039*^9}, {3.649449708039163*^9, 3.649449749730237*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dB", "[", 
    RowBox[{"ax_", ",", "az_", ",", "L_", ",", "T_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox["L", "2"]}], 
    RowBox[{"M", "[", "T", "]"}], " ", 
    RowBox[{
     RowBox[{"M", "'"}], "[", "T", "]"}], " ", 
    RowBox[{"H3B", "[", 
     RowBox[{"ax", ",", "az", ",", 
      RowBox[{
       RowBox[{"M", "[", "T", "]"}], "/", "L"}]}], "]"}]}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.645277447301981*^9, 3.645277456352147*^9}, {
   3.6452775378796053`*^9, 3.645277547648027*^9}, {3.6452777808308563`*^9, 
   3.645277788958585*^9}, {3.645277895926187*^9, 3.645277909822535*^9}, 
   3.6452779744458427`*^9, {3.6452781040931168`*^9, 3.645278165084928*^9}, 
   3.647691339496681*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Parameters", "Section",
 CellChangeTimes->{{3.639913414674055*^9, 3.6399134286602163`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"teq0", ",", "teq1", ",", "teq2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Mh", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{"T", "[", "t", "]"}], "]"}], "/", 
    RowBox[{"L", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Mheq", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{"T", "[", "t", "]"}], "]"}], "/", 
    RowBox[{"T", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ki1", "[", "x_", "]"}], ":=", 
   RowBox[{
    FractionBox["\[Pi]", "2"], 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"x", " ", 
       RowBox[{"K0", "[", "x", "]"}], 
       RowBox[{"STm1", "[", "x", "]"}]}], "-", 
      RowBox[{"x", " ", 
       RowBox[{"K1", "[", "x", "]"}], 
       RowBox[{"ST0", "[", "x", "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"teq0", "[", "t_", "]"}], ":=", 
   FractionBox[
    RowBox[{"5", " ", "etabar"}], 
    RowBox[{" ", 
     RowBox[{"T", "[", "t", "]"}]}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"teq1", "[", "t_", "]"}], ":=", 
   RowBox[{
    FractionBox[
     RowBox[{"5", " ", "etabar"}], 
     RowBox[{" ", 
      RowBox[{"4", " ", 
       RowBox[{"T", "[", "t", "]"}]}]}]], 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      FractionBox[
       RowBox[{"IEis", "[", 
        RowBox[{"T", "[", "t", "]"}], "]"}], 
       RowBox[{"IPis", "[", 
        RowBox[{"T", "[", "t", "]"}], "]"}]]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"teq2", "[", "t_", "]"}], ":=", 
   RowBox[{
    FractionBox[
     RowBox[{"15", " ", "etabar"}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Mheq", "[", "t", "]"}], "3"], 
      RowBox[{"T", "[", "t", "]"}]}]], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       FractionBox[
        RowBox[{"IEis", "[", 
         RowBox[{"T", "[", "t", "]"}], "]"}], 
        RowBox[{"IPis", "[", 
         RowBox[{"T", "[", "t", "]"}], "]"}]]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["3", 
         SuperscriptBox[
          RowBox[{"Mheq", "[", "t", "]"}], "2"]], 
        FractionBox[
         RowBox[{"K3", "[", 
          RowBox[{"Mheq", "[", "t", "]"}], "]"}], 
         RowBox[{"K2", "[", 
          RowBox[{"Mheq", "[", "t", "]"}], "]"}]]}], "-", 
       FractionBox["1", 
        RowBox[{"Mheq", "[", "t", "]"}]], "+", 
       FractionBox[
        RowBox[{"K1", "[", 
         RowBox[{"Mheq", "[", "t", "]"}], "]"}], 
        RowBox[{"K2", "[", 
         RowBox[{"Mheq", "[", "t", "]"}], "]"}]], "-", 
       FractionBox[
        RowBox[{"Ki1", "[", 
         RowBox[{"Mheq", "[", "t", "]"}], "]"}], 
        RowBox[{"K2", "[", 
         RowBox[{"Mheq", "[", "t", "]"}], "]"}]]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EtaZeta", "[", "x_", "]"}], ":=", 
    RowBox[{
     FractionBox["5", "3"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"K1", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}], 
         RowBox[{"K2", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]], "-", 
        FractionBox[
         RowBox[{"Ki1", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}], 
         RowBox[{"K2", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]], "-", 
        FractionBox[
         RowBox[{"K2", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}], 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"K3", "[", 
            RowBox[{
             RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"M", "[", "x", "]"}], "/", "x"}], ")"}], 
           RowBox[{"K2", "[", 
            RowBox[{
             RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]}]}]]}], ")"}], 
      "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["3", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"M", "[", "x", "]"}], "/", "x"}], ")"}], "2"]], 
         FractionBox[
          RowBox[{"K3", "[", 
           RowBox[{
            RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}], 
          RowBox[{"K2", "[", 
           RowBox[{
            RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]]}], "-", 
        FractionBox["1", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], ")"}]], "+", 
        FractionBox[
         RowBox[{"K1", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}], 
         RowBox[{"K2", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]], "-", 
        FractionBox[
         RowBox[{"Ki1", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}], 
         RowBox[{"K2", "[", 
          RowBox[{
           RowBox[{"M", "[", "x", "]"}], "/", "x"}], "]"}]]}], ")"}]}]}]}], 
   ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"teq", "[", "t_", "]"}], ":=", 
     RowBox[{"5", "*", 
      RowBox[{"etabar", "/", 
       RowBox[{"T", "[", "t", "]"}]}]}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Alpha]", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"ax", "[", "t", "]"}], "^", "2"}], " ", 
    RowBox[{"az", "[", "t", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dt", "[", "f_", "]"}], ":=", 
   RowBox[{"D", "[", 
    RowBox[{"f", ",", "t"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xi", "=", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"2", "/", "3"}], ")"}]}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{
         RowBox[{"ax", "[", "t", "]"}], "^", "2"}]}], "-", 
       RowBox[{"1", "/", 
        RowBox[{
         RowBox[{"az", "[", "t", "]"}], "^", "2"}]}]}], ")"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t0", "=", "0.3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tf", "=", "10.3"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"etabar", "=", 
   RowBox[{"1", "/", 
    RowBox[{"(", 
     RowBox[{"4", "\[Pi]"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Eta]bar", "=", "\"\<3\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ti", "=", 
   RowBox[{".553", "/", "hbarc"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Xi]i", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalPhi]i", "=", "0"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.639913431581698*^9, 3.639913479194604*^9}, {
   3.63991356348096*^9, 3.639913574257258*^9}, {3.639918857761642*^9, 
   3.639918872560441*^9}, {3.639918930104014*^9, 3.639918970110463*^9}, {
   3.639936339412739*^9, 3.6399363401407967`*^9}, {3.640004909834401*^9, 
   3.640004920289938*^9}, {3.6400053445280848`*^9, 3.640005350063589*^9}, {
   3.640005382126893*^9, 3.640005400070095*^9}, {3.640018300073001*^9, 
   3.640018303015863*^9}, 3.640018832606022*^9, 3.640021851313608*^9, 
   3.6400218953376493`*^9, {3.640022257798443*^9, 3.640022257877226*^9}, {
   3.64002469538407*^9, 3.640024715559042*^9}, {3.6400843087821083`*^9, 
   3.6400843100374527`*^9}, 3.640084378188931*^9, {3.640085889604162*^9, 
   3.640085917610737*^9}, {3.64009466776118*^9, 3.6400946900242434`*^9}, {
   3.640094891175753*^9, 3.640094902846863*^9}, {3.640094956981698*^9, 
   3.6400949936043243`*^9}, 3.640095103861824*^9, {3.640095154093707*^9, 
   3.6400951642289743`*^9}, {3.640096042887431*^9, 3.640096043270918*^9}, 
   3.640096724924294*^9, {3.640097391119174*^9, 3.64009739764609*^9}, {
   3.6401021699499826`*^9, 3.640102177429874*^9}, 3.6401023881110687`*^9, {
   3.640102531540773*^9, 3.640102532195569*^9}, 3.640105456361003*^9, {
   3.640105492256604*^9, 3.640105499904131*^9}, {3.640105624878965*^9, 
   3.6401056699574957`*^9}, {3.640105861687791*^9, 3.640105867006146*^9}, {
   3.640106304126112*^9, 3.640106305325506*^9}, {3.640106428895795*^9, 
   3.640106430822628*^9}, {3.640106957585177*^9, 3.640106959498468*^9}, {
   3.6401070506256866`*^9, 3.6401070537463083`*^9}, {3.640107107672423*^9, 
   3.640107108656437*^9}, 3.640107158969331*^9, {3.640107287633205*^9, 
   3.640107287681787*^9}, {3.640107337595715*^9, 3.640107339496481*^9}, {
   3.640107847845808*^9, 3.640107849266683*^9}, {3.6401081604110947`*^9, 
   3.64010816312246*^9}, 3.640108627005311*^9, {3.640109037163302*^9, 
   3.640109055748328*^9}, {3.640357823595433*^9, 3.6403578274030857`*^9}, 
   3.640358586432664*^9, 3.640358846045702*^9, {3.6403653419912663`*^9, 
   3.640365347326291*^9}, {3.64036544311335*^9, 3.6403654735557213`*^9}, 
   3.640366841796102*^9, 3.640366900063231*^9, {3.640366991139924*^9, 
   3.640366992964821*^9}, 3.6403670241709023`*^9, 3.6403674516513433`*^9, {
   3.640372287235345*^9, 3.640372289226769*^9}, 3.640372702224862*^9, {
   3.640429688118121*^9, 3.640429689534211*^9}, {3.640434952507597*^9, 
   3.640434979313583*^9}, {3.640530845524117*^9, 3.640530898186914*^9}, {
   3.6405406702119007`*^9, 3.6405406713860397`*^9}, {3.640541496861169*^9, 
   3.640541500596532*^9}, {3.640541553220806*^9, 3.640541556978628*^9}, {
   3.640542228447895*^9, 3.640542232166789*^9}, {3.640542283770748*^9, 
   3.640542292729845*^9}, {3.640778608552743*^9, 3.640778635299294*^9}, {
   3.640778668908366*^9, 3.640778672099402*^9}, {3.64077871427361*^9, 
   3.6407787195555677`*^9}, 3.640780987212388*^9, 3.640781129264822*^9, {
   3.641393944602399*^9, 3.6413939586693907`*^9}, {3.64139402172997*^9, 
   3.641394051962596*^9}, {3.641394209777752*^9, 3.641394210497843*^9}, {
   3.641396525212742*^9, 3.641396529599689*^9}, 3.641396603567326*^9, 
   3.6415557901971684`*^9, {3.641557951950368*^9, 3.641557952878302*^9}, {
   3.641558222025648*^9, 3.641558222228525*^9}, {3.6415630947884073`*^9, 
   3.641563098403969*^9}, 3.64156319183519*^9, {3.641563360793632*^9, 
   3.641563360976653*^9}, {3.64157202534988*^9, 3.6415720259403887`*^9}, 
   3.641572341072537*^9, 3.641572521753981*^9, 3.641572692960433*^9, {
   3.641572789304183*^9, 3.641572789607668*^9}, 3.6415777857386103`*^9, {
   3.6415778821727743`*^9, 3.641577882247113*^9}, {3.6417322748387403`*^9, 
   3.6417322911278553`*^9}, 3.641733083763335*^9, {3.6417331575132437`*^9, 
   3.641733157586096*^9}, 3.641733205507032*^9, 3.641733263378909*^9, {
   3.6417333133635263`*^9, 3.641733313480627*^9}, 3.641733722359868*^9, 
   3.641733806943213*^9, {3.641733850395887*^9, 3.641733852003297*^9}, 
   3.6417340100856943`*^9, 3.641734061381134*^9, {3.641734124829131*^9, 
   3.641734125169639*^9}, 3.6421618435562973`*^9, {3.6421619491313133`*^9, 
   3.642161960974618*^9}, {3.6421620262224407`*^9, 3.642162099463327*^9}, {
   3.642162584913188*^9, 3.6421626147861147`*^9}, {3.642162660417823*^9, 
   3.6421629025156918`*^9}, {3.6421643918487597`*^9, 3.642164485569009*^9}, 
   3.6429539130884523`*^9, {3.642954077803976*^9, 3.6429540798357*^9}, {
   3.64302062803115*^9, 3.643020679773843*^9}, {3.643020826016407*^9, 
   3.643020833494618*^9}, {3.643020990916518*^9, 3.6430210670988903`*^9}, {
   3.643021196559134*^9, 3.643021218749913*^9}, {3.643106718470583*^9, 
   3.643106750929418*^9}, {3.643126211084742*^9, 3.643126211346682*^9}, {
   3.643128426829015*^9, 3.643128428044652*^9}, {3.643468701911924*^9, 
   3.643468713424127*^9}, {3.64347472272992*^9, 3.643474727185358*^9}, {
   3.645204014046631*^9, 3.645204206809845*^9}, {3.6452042685365667`*^9, 
   3.6452043707621603`*^9}, {3.645204745632519*^9, 3.6452047976897497`*^9}, {
   3.6452050994329567`*^9, 3.645205101175289*^9}, {3.6452764165266848`*^9, 
   3.645276437061633*^9}, 3.645292299840611*^9, 3.6453578206922073`*^9, {
   3.6453585279681377`*^9, 3.6453585342174187`*^9}, {3.6453630702332697`*^9, 
   3.645363072051746*^9}, {3.645445951725165*^9, 3.645445952021476*^9}, {
   3.6454533666531363`*^9, 3.645453367882107*^9}, {3.646741659862932*^9, 
   3.646741664739555*^9}, {3.646742531675396*^9, 3.646742563612441*^9}, {
   3.646742771929429*^9, 3.646742774460843*^9}, {3.6477919321837273`*^9, 
   3.6477919384526987`*^9}, {3.648209786295782*^9, 3.6482097866800003`*^9}, {
   3.648228765877536*^9, 3.648228765943425*^9}, {3.64945081254315*^9, 
   3.649450813454565*^9}, 3.649507094610198*^9, {3.6495227716074877`*^9, 
   3.6495227725524883`*^9}, {3.649523952076686*^9, 3.6495239823723917`*^9}, 
   3.649524130164111*^9, {3.6495241681321507`*^9, 3.649524195001648*^9}, {
   3.649524256249276*^9, 3.649524261968581*^9}, {3.649524901308395*^9, 
   3.649524901458962*^9}, {3.6495918828699703`*^9, 3.64959189029142*^9}, 
   3.6496005964023123`*^9, 3.6496031144648848`*^9, {3.649604871424733*^9, 
   3.649604871479641*^9}, {3.6496053810431833`*^9, 3.6496053861057777`*^9}, {
   3.649605503282774*^9, 3.649605504641038*^9}, {3.649605602249983*^9, 
   3.649605606200809*^9}, {3.649605715696788*^9, 3.649605716311611*^9}, {
   3.649605837221863*^9, 3.649605837740994*^9}, {3.649605937238797*^9, 
   3.649605938309657*^9}, {3.649606030100586*^9, 3.649606030340481*^9}, {
   3.649606474473641*^9, 3.6496064768162813`*^9}, {3.6496069206374474`*^9, 
   3.6496069213163137`*^9}, {3.649607078259302*^9, 3.649607078594026*^9}, {
   3.6496124905428677`*^9, 3.649612490637102*^9}, {3.6496766665170393`*^9, 
   3.6496766691046343`*^9}, {3.649684551911783*^9, 3.6496845524217367`*^9}, 
   3.6496850104156733`*^9, 3.649688241595688*^9, {3.64976527564843*^9, 
   3.649765286121356*^9}, {3.649771986467003*^9, 3.649771988258725*^9}, {
   3.6497720515231028`*^9, 3.649772052786313*^9}, {3.6497741754872017`*^9, 
   3.6497741771655273`*^9}, {3.649774427454939*^9, 3.6497744300724087`*^9}, {
   3.6497753806594048`*^9, 3.649775382050115*^9}, {3.6497756281522837`*^9, 
   3.649775629582473*^9}, {3.6497961859038973`*^9, 3.649796188045871*^9}, {
   3.6497966945146637`*^9, 3.649796697000968*^9}, {3.6497970306445627`*^9, 
   3.649797039834689*^9}, {3.6501091816449842`*^9, 3.650109187723781*^9}, {
   3.6501111769285717`*^9, 3.6501111780640306`*^9}, 3.650111353126358*^9, {
   3.65011154363722*^9, 3.6501115443482122`*^9}, {3.6501117072770367`*^9, 
   3.6501117074745197`*^9}, 3.650111824162064*^9, 3.6501119743448887`*^9, {
   3.650114458672904*^9, 3.650114460264538*^9}, 3.650114753365823*^9, 
   3.650114997306806*^9, {3.650115065947914*^9, 3.650115066226098*^9}, 
   3.65011524839307*^9, 3.650115414519762*^9, 3.650115652302689*^9, 
   3.650115865107601*^9, {3.650116213951745*^9, 3.650116215765925*^9}, 
   3.650116368062166*^9, {3.650116527341529*^9, 3.650116528443589*^9}, 
   3.6501207679306583`*^9, 3.6501211514636383`*^9, {3.650121294710835*^9, 
   3.6501212947883463`*^9}, 3.6501217173704367`*^9, {3.65012186701048*^9, 
   3.6501218677999563`*^9}, 3.650122028182487*^9, {3.650122212181716*^9, 
   3.6501222125560617`*^9}, {3.650122369060988*^9, 3.6501223698907557`*^9}, {
   3.650122514795047*^9, 3.650122523561379*^9}, {3.650122707585108*^9, 
   3.650122712157474*^9}, 3.650122865487934*^9, 3.650123022421489*^9, {
   3.650123185546269*^9, 3.650123185650922*^9}, 3.6501235749365463`*^9, {
   3.650123758998494*^9, 3.650123760845208*^9}, {3.6501242795773697`*^9, 
   3.650124285416271*^9}, {3.65012445971975*^9, 3.650124460774313*^9}, {
   3.65013298568189*^9, 3.6501329943928003`*^9}, {3.650133341104763*^9, 
   3.6501333463994827`*^9}, {3.650133511166897*^9, 3.6501335193081503`*^9}, {
   3.650133674829818*^9, 3.6501336843085737`*^9}, {3.6508032897620077`*^9, 
   3.65080328997779*^9}, {3.6556596770087748`*^9, 3.655659682100561*^9}, {
   3.655659740865553*^9, 3.6556597409517603`*^9}, {3.655660031182613*^9, 
   3.6556600332218227`*^9}, {3.6579870225706663`*^9, 3.657987030016439*^9}, {
   3.657989698465991*^9, 3.657989698857082*^9}, {3.657992858368539*^9, 
   3.657992858440316*^9}, 3.6580575382290783`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Quasiparticle", "Section",
 CellChangeTimes->{{3.640085696190393*^9, 3.640085725641433*^9}, {
  3.640102719943676*^9, 3.640102728055521*^9}, {3.641557992627665*^9, 
  3.641558009995406*^9}, {3.642951764221335*^9, 3.642951767285563*^9}, {
  3.642951898935478*^9, 3.642951903103921*^9}, {3.645278321528878*^9, 
  3.645278324328793*^9}, {3.6453628817454*^9, 3.645362886072157*^9}, {
  3.649522196490898*^9, 3.649522231365437*^9}}],

Cell[CellGroupData[{

Cell["Setup", "Subsection",
 CellChangeTimes->{{3.6478867467463083`*^9, 3.647886755016931*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Li", ",", "axi", ",", "azi"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"axi", "=", 
   SqrtBox[
    RowBox[{"1", "+", "\[CapitalPhi]i"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"azi", "=", 
   RowBox[{
    RowBox[{"axi", "/", 
     SqrtBox[
      RowBox[{"1", "+", "\[Xi]i"}]]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Li", "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"lL", "/.", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"H3", "[", 
          RowBox[{"axi", ",", "azi", ",", 
           RowBox[{
            RowBox[{"M", "[", "Ti", "]"}], "/", "lL"}]}], "]"}], " ", 
         RowBox[{"lL", "^", "4"}]}], "\[Equal]", 
        RowBox[{"4", " ", "\[Pi]", " ", "Nt", " ", 
         RowBox[{"Ti", "^", "2"}], " ", 
         RowBox[{
          RowBox[{"M", "[", "Ti", "]"}], "^", "2"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", 
            RowBox[{"BesselK", "[", 
             RowBox[{"2", ",", 
              RowBox[{
               RowBox[{"M", "[", "Ti", "]"}], "/", "Ti"}]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"M", "[", "Ti", "]"}], "/", "Ti"}], ")"}], " ", 
            RowBox[{"BesselK", "[", 
             RowBox[{"1", ",", 
              RowBox[{
               RowBox[{"M", "[", "Ti", "]"}], "/", "Ti"}]}], "]"}]}]}], 
          ")"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"lL", ",", "Ti"}], "}"}]}], "]"}]}], "]"}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.6478867385285673`*^9, 3.6478867445370626`*^9}, {
   3.64945079530777*^9, 3.649450826662315*^9}, 3.649514705513751*^9, {
   3.649522789281856*^9, 3.649522800808003*^9}, {3.649523805650753*^9, 
   3.649523816649976*^9}, {3.649523848905088*^9, 3.649523867016508*^9}, {
   3.649523936630431*^9, 3.649523940527626*^9}, {3.649524090366539*^9, 
   3.649524115962178*^9}, {3.649524482332657*^9, 3.649524487658978*^9}, {
   3.649765312789184*^9, 3.649765314909576*^9}, {3.650812383814989*^9, 
   3.650812388878722*^9}, 3.6508128362021837`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Main Equations", "Subsection",
 CellChangeTimes->{{3.640613761858169*^9, 3.6406137711289797`*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"Eq1", ",", "Eq2", ",", "Eq3", ",", "Eq4", ",", "Eq4p"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"OT", "[", 
      RowBox[{
       RowBox[{"ax", "[", "t", "]"}], ",", 
       RowBox[{"az", "[", "t", "]"}], ",", 
       RowBox[{"Mh", "[", "t", "]"}]}], "]"}], 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"ax", "[", "t", "]"}], "2"], "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"OL", "[", 
      RowBox[{
       RowBox[{"ax", "[", "t", "]"}], ",", 
       RowBox[{"az", "[", "t", "]"}], ",", 
       RowBox[{"Mh", "[", "t", "]"}]}], "]"}], 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"az", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", 
        RowBox[{"H3", "[", 
         RowBox[{
          RowBox[{"ax", "[", "t", "]"}], ",", 
          RowBox[{"az", "[", "t", "]"}], ",", 
          RowBox[{"Mh", "[", "t", "]"}]}], "]"}]}], "-", 
       RowBox[{"Om", "[", 
        RowBox[{
         RowBox[{"ax", "[", "t", "]"}], ",", 
         RowBox[{"az", "[", "t", "]"}], ",", 
         RowBox[{"Mh", "[", "t", "]"}]}], "]"}]}], ")"}], 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"Om", "[", 
      RowBox[{
       RowBox[{"ax", "[", "t", "]"}], ",", 
       RowBox[{"az", "[", "t", "]"}], ",", 
       RowBox[{"Mh", "[", "t", "]"}]}], "]"}], 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"M", "[", 
        RowBox[{"T", "[", "t", "]"}], "]"}], "]"}], "]"}]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"dB", "[", 
       RowBox[{
        RowBox[{"ax", "[", "t", "]"}], ",", 
        RowBox[{"az", "[", "t", "]"}], ",", 
        RowBox[{"L", "[", "t", "]"}], ",", 
        RowBox[{"T", "[", "t", "]"}]}], "]"}], 
      RowBox[{"dt", "[", 
       RowBox[{"T", "[", "t", "]"}], "]"}]}], 
     SuperscriptBox[
      RowBox[{"L", "[", "t", "]"}], "4"]], "+", 
    FractionBox[
     RowBox[{"OL", "[", 
      RowBox[{
       RowBox[{"ax", "[", "t", "]"}], ",", 
       RowBox[{"az", "[", "t", "]"}], ",", 
       RowBox[{"Mh", "[", "t", "]"}]}], "]"}], "t"]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq2", "=", 
   RowBox[{
    RowBox[{"4", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"ax", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"az", "[", "t", "]"}], "]"}], "]"}], "+", 
    RowBox[{"5", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Mh", "[", "t", "]"}], "3"], 
       RowBox[{"K3", "[", 
        RowBox[{"Mh", "[", "t", "]"}], "]"}]}], "]"}], "]"}], "+", 
    FractionBox["1", "t"], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"teq2", "[", "t", "]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"ax", "[", "t", "]"}], "4"], 
          RowBox[{"az", "[", "t", "]"}]}]], 
        FractionBox[
         SuperscriptBox[
          RowBox[{"T", "[", "t", "]"}], "2"], 
         SuperscriptBox[
          RowBox[{"L", "[", "t", "]"}], "2"]], 
        FractionBox[
         RowBox[{"K3", "[", 
          RowBox[{"Mheq", "[", "t", "]"}], "]"}], 
         RowBox[{"K3", "[", 
          RowBox[{"Mh", "[", "t", "]"}], "]"}]]}], "-", "1"}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq3", "=", 
   RowBox[{
    RowBox[{"2", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"ax", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"3", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"az", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"5", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Mh", "[", "t", "]"}], "3"], 
       RowBox[{"K3", "[", 
        RowBox[{"Mh", "[", "t", "]"}], "]"}]}], "]"}], "]"}], "+", 
    FractionBox["3", "t"], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"teq2", "[", "t", "]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"ax", "[", "t", "]"}], "2"], 
          SuperscriptBox[
           RowBox[{"az", "[", "t", "]"}], "3"]}]], 
        FractionBox[
         SuperscriptBox[
          RowBox[{"T", "[", "t", "]"}], "2"], 
         SuperscriptBox[
          RowBox[{"L", "[", "t", "]"}], "2"]], 
        FractionBox[
         RowBox[{"K3", "[", 
          RowBox[{"Mheq", "[", "t", "]"}], "]"}], 
         RowBox[{"K3", "[", 
          RowBox[{"Mh", "[", "t", "]"}], "]"}]]}], "-", "1"}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq4", "=", 
   RowBox[{
    RowBox[{"4", " ", "\[Pi]", " ", "Nt", " ", 
     SuperscriptBox[
      RowBox[{"Mheq", "[", "t", "]"}], "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"dt", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"M", "[", 
            RowBox[{"T", "[", "t", "]"}], "]"}], "]"}], "]"}]}], " ", 
        RowBox[{"Mheq", "[", "t", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Mheq", "[", "t", "]"}], 
           RowBox[{"K0", "[", 
            RowBox[{"Mheq", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{"K1", "[", 
           RowBox[{"Mheq", "[", "t", "]"}], "]"}]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"dt", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"T", "[", "t", "]"}], "]"}], "]"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"12", 
           RowBox[{"K2", "[", 
            RowBox[{"Mheq", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{"5", " ", 
           RowBox[{"Mheq", "[", "t", "]"}], " ", 
           RowBox[{"K1", "[", 
            RowBox[{"Mheq", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Mheq", "[", "t", "]"}], "2"], 
           RowBox[{"K0", "[", 
            RowBox[{"Mheq", "[", "t", "]"}], "]"}]}]}], ")"}]}]}], ")"}]}], 
    "+", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"L", "[", "t", "]"}], 
        RowBox[{"T", "[", "t", "]"}]], ")"}], "4"], 
     FractionBox[
      RowBox[{"OL", "[", 
       RowBox[{
        RowBox[{"ax", "[", "t", "]"}], ",", 
        RowBox[{"az", "[", "t", "]"}], ",", 
        RowBox[{"Mh", "[", "t", "]"}]}], "]"}], "t"]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"dB", "[", 
       RowBox[{
        RowBox[{"ax", "[", "t", "]"}], ",", 
        RowBox[{"az", "[", "t", "]"}], ",", 
        RowBox[{"L", "[", "t", "]"}], ",", 
        RowBox[{"T", "[", "t", "]"}]}], "]"}], 
      RowBox[{"dt", "[", 
       RowBox[{"T", "[", "t", "]"}], "]"}]}], 
     SuperscriptBox[
      RowBox[{"T", "[", "t", "]"}], "4"]]}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6400032590844088`*^9, 3.640003263204825*^9}, {
   3.640003308876696*^9, 3.6400033280367413`*^9}, {3.640003385244814*^9, 
   3.64000345553406*^9}, {3.640003485908846*^9, 3.6400035742782087`*^9}, {
   3.6400036174459953`*^9, 3.6400037152644787`*^9}, {3.640003748472246*^9, 
   3.640003823872957*^9}, {3.640003996287966*^9, 3.640004330804693*^9}, {
   3.640004658340548*^9, 3.640004693775199*^9}, {3.6400047575342712`*^9, 
   3.6400048576060467`*^9}, {3.640008870807048*^9, 3.6400090324178457`*^9}, {
   3.640009195912249*^9, 3.640009297258247*^9}, {3.640017676571072*^9, 
   3.6400177370916*^9}, {3.6400248420927153`*^9, 3.640024870192038*^9}, {
   3.640025030499646*^9, 3.6400250363269577`*^9}, {3.640025194076442*^9, 
   3.64002522287199*^9}, 3.64002614335047*^9, {3.6400855331234627`*^9, 
   3.640085533933407*^9}, {3.640085767365499*^9, 3.640085772633787*^9}, {
   3.640086673541206*^9, 3.640086674178609*^9}, {3.6400963129438267`*^9, 
   3.640096316463934*^9}, {3.6401023038411283`*^9, 3.6401023108959103`*^9}, 
   3.640109645995026*^9, {3.6403567612111263`*^9, 3.640356776134014*^9}, {
   3.640357907517645*^9, 3.640357914342371*^9}, {3.6405302840528927`*^9, 
   3.6405302925240173`*^9}, {3.640613724631822*^9, 3.64061375404248*^9}, {
   3.640709366045586*^9, 3.6407093891114407`*^9}, {3.6407787695131693`*^9, 
   3.640778781181622*^9}, {3.641558322136582*^9, 3.641558329042091*^9}, {
   3.643107309537821*^9, 3.6431073217945757`*^9}, {3.6452783452395983`*^9, 
   3.645278406116007*^9}, {3.645279044038229*^9, 3.6452790577605133`*^9}, {
   3.645279571494569*^9, 3.645279616703754*^9}, {3.64528879277277*^9, 
   3.645288794353424*^9}, {3.6452890325866003`*^9, 3.6452890373856573`*^9}, 
   3.6452894153439913`*^9, {3.645448461609035*^9, 3.6454484691929817`*^9}, {
   3.645448500402541*^9, 3.645448507515913*^9}, {3.645453296349126*^9, 
   3.6454532997209377`*^9}, 3.645454869312108*^9, {3.645457609378474*^9, 
   3.645457616613813*^9}, {3.6454654916933317`*^9, 3.645465496718904*^9}, {
   3.645533796273479*^9, 3.6455337991225233`*^9}, 3.64674067276842*^9, {
   3.646741032431382*^9, 3.6467410358002462`*^9}, {3.646741443230583*^9, 
   3.646741446223361*^9}, {3.646741762933762*^9, 3.646741779283716*^9}, 
   3.646742291677718*^9, {3.647691436183419*^9, 3.647691487844714*^9}, {
   3.647694333286216*^9, 3.647694382463646*^9}, {3.647695093316318*^9, 
   3.647695095723734*^9}, {3.6476956717841043`*^9, 3.647695760023756*^9}, {
   3.647695833376296*^9, 3.6476958365044527`*^9}, {3.647699237359931*^9, 
   3.6476992738002*^9}, {3.647702343962297*^9, 3.647702346731957*^9}, {
   3.647791582641903*^9, 3.647791605866544*^9}, {3.6477916541724243`*^9, 
   3.647791875594619*^9}, 3.6477924062212*^9, {3.647792436230399*^9, 
   3.647792531138929*^9}, {3.6477927195024137`*^9, 3.647792767569809*^9}, {
   3.647792923490725*^9, 3.6477929264722767`*^9}, {3.647966530663189*^9, 
   3.647966544453258*^9}, {3.647966594250108*^9, 3.6479665978124847`*^9}, {
   3.647966680534915*^9, 3.64796669192696*^9}, 3.6479683519782953`*^9, {
   3.647968478367238*^9, 3.6479685045497913`*^9}, {3.648223297764311*^9, 
   3.648223298061078*^9}, {3.648223349549735*^9, 3.6482233782195387`*^9}, {
   3.648226897784957*^9, 3.648226923781871*^9}, {3.649524277625902*^9, 
   3.649524284351655*^9}, {3.649680787725078*^9, 3.649681003043755*^9}, {
   3.650801920566972*^9, 3.650801940747449*^9}, {3.6508019714273577`*^9, 
   3.650802074570096*^9}, {3.650803201990672*^9, 3.6508032298212337`*^9}, {
   3.650807901117631*^9, 3.6508079054646273`*^9}, {3.650808112269376*^9, 
   3.650808121260544*^9}, {3.650808313716525*^9, 3.6508083220558453`*^9}, {
   3.6508087622048607`*^9, 3.650808780837748*^9}, {3.6508089474361877`*^9, 
   3.650808989051759*^9}, {3.650809126494041*^9, 3.650809138124866*^9}, {
   3.65080932977085*^9, 3.650809369407633*^9}, {3.65080939949645*^9, 
   3.650809431047624*^9}, {3.650812375212667*^9, 3.650812376031486*^9}, {
   3.650812798873863*^9, 3.6508128494557858`*^9}, {3.6508131162985764`*^9, 
   3.650813116717844*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solutions", "Subsection",
 CellChangeTimes->{{3.640613781206086*^9, 3.64061378805682*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"axSol3", ",", "azSol3", ",", "LSol3", ",", "TSol3"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"axSol3", ",", "azSol3", ",", "LSol3", ",", "TSol3"}], "}"}], "=", 
  
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ax", ",", "az", ",", "L", ",", "T"}], "}"}], "/.", 
   RowBox[{
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Eq1", "\[Equal]", "0"}], ",", 
        RowBox[{"Eq2", "\[Equal]", "0"}], ",", 
        RowBox[{"Eq3", "\[Equal]", "0"}], ",", 
        RowBox[{"Eq4", "\[Equal]", "0"}], ",", 
        RowBox[{
         RowBox[{"ax", "[", "t0", "]"}], "\[Equal]", "axi"}], ",", 
        RowBox[{
         RowBox[{"az", "[", "t0", "]"}], "\[Equal]", "azi"}], ",", 
        RowBox[{
         RowBox[{"L", "[", "t0", "]"}], "\[Equal]", "Li"}], ",", 
        RowBox[{
         RowBox[{"T", "[", "t0", "]"}], "\[Equal]", "Ti"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"ax", ",", "az", ",", "L", ",", "T"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "t0", ",", "tf"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.64000575037584*^9, 3.640005808772297*^9}, {
   3.6400090687509737`*^9, 3.640009101816228*^9}, 3.640017928526084*^9, {
   3.6400179764137506`*^9, 3.640017978684435*^9}, {3.64001821727704*^9, 
   3.640018241954743*^9}, {3.6400183205246973`*^9, 3.640018353451597*^9}, {
   3.6400183949392347`*^9, 3.6400184513554497`*^9}, {3.640018526842731*^9, 
   3.6400185352279367`*^9}, {3.640018717433139*^9, 3.640018719360923*^9}, {
   3.6400217945207043`*^9, 3.64002180210893*^9}, {3.640024989952428*^9, 
   3.64002499153517*^9}, {3.6400843279061737`*^9, 3.640084330656419*^9}, {
   3.640086069292775*^9, 3.6400860718295603`*^9}, 3.640086784384317*^9, 
   3.640096214217579*^9, {3.6407813533681583`*^9, 3.6407813583815193`*^9}, {
   3.64139397553862*^9, 3.6413939778977737`*^9}, {3.642952519309889*^9, 
   3.642952524068562*^9}, 3.643120503303378*^9, {3.6452912450491123`*^9, 
   3.645291245199864*^9}, {3.645292294930786*^9, 3.645292295027301*^9}, {
   3.645362893558669*^9, 3.645362899997827*^9}, 3.6476943158651953`*^9, 
   3.647792535568535*^9, {3.64779268392338*^9, 3.647792686938827*^9}, {
   3.648213425650426*^9, 3.648213434906155*^9}, {3.648214656418331*^9, 
   3.64821466057026*^9}, {3.648214876447961*^9, 3.6482148793597116`*^9}, {
   3.648223386176708*^9, 3.6482233894788847`*^9}, 3.648223881028667*^9, 
   3.648224560368012*^9, {3.648225448490196*^9, 3.648225450897422*^9}, 
   3.648226174077237*^9, 3.6482269344319553`*^9, {3.649450860563773*^9, 
   3.6494508645722437`*^9}, {3.6495091507515793`*^9, 3.649509152438579*^9}, {
   3.6495092306053257`*^9, 3.649509363388935*^9}, {3.649514126647094*^9, 
   3.649514188377346*^9}, {3.649681160583108*^9, 3.649681170246428*^9}, {
   3.65012387067577*^9, 3.6501238710955267`*^9}, {3.6501239280499887`*^9, 
   3.650123928145088*^9}, 3.650802086740087*^9, 3.6508031898591948`*^9, {
   3.65080325357617*^9, 3.6508032682958508`*^9}, 3.650804712701105*^9, 
   3.650807179449942*^9, 3.650809238414453*^9, 3.6508095304470253`*^9, 
   3.650812554261902*^9, {3.650812872754532*^9, 3.65081288980274*^9}, 
   3.6508129941215563`*^9, {3.655659703109439*^9, 3.655659706116392*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Definitions", "Subsection",
 CellChangeTimes->{{3.6495223485536213`*^9, 3.649522359380666*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ed3", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"LSol3", "[", "t", "]"}], "4"], "*", 
     RowBox[{"H3", "[", 
      RowBox[{
       RowBox[{"axSol3", "[", "t", "]"}], ",", 
       RowBox[{"azSol3", "[", "t", "]"}], ",", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"TSol3", "[", "t", "]"}], "]"}], "/", 
        RowBox[{"LSol3", "[", "t", "]"}]}]}], "]"}]}], "+", 
    RowBox[{"Bnew", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pT3", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"LSol3", "[", "t", "]"}], "4"], "*", 
     RowBox[{"H3T", "[", 
      RowBox[{
       RowBox[{"axSol3", "[", "t", "]"}], ",", 
       RowBox[{"azSol3", "[", "t", "]"}], ",", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"TSol3", "[", "t", "]"}], "]"}], "/", 
        RowBox[{"LSol3", "[", "t", "]"}]}]}], "]"}]}], "-", 
    RowBox[{"Bnew", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pL3", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"LSol3", "[", "t", "]"}], "4"], "*", 
     RowBox[{"H3L", "[", 
      RowBox[{
       RowBox[{"axSol3", "[", "t", "]"}], ",", 
       RowBox[{"azSol3", "[", "t", "]"}], ",", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"TSol3", "[", "t", "]"}], "]"}], "/", 
        RowBox[{"LSol3", "[", "t", "]"}]}]}], "]"}]}], "-", 
    RowBox[{"Bnew", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"peq3", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{"4", " ", "\[Pi]", " ", "Nt", " ", 
     RowBox[{
      RowBox[{"M", "[", 
       RowBox[{"TSol3", "[", "t", "]"}], "]"}], "^", "2"}], 
     RowBox[{
      RowBox[{"TSol3", "[", "t", "]"}], "^", "2"}], " ", 
     RowBox[{"BesselK", "[", 
      RowBox[{"2", ",", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"TSol3", "[", "t", "]"}], "]"}], "/", 
        RowBox[{"TSol3", "[", "t", "]"}]}]}], "]"}]}], "-", 
    RowBox[{"B", "[", 
     RowBox[{"TSol3", "[", "t", "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"\[CapitalPi]3", "[", "t_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"pL3", "[", "t", "]"}], "+", 
        RowBox[{"2", "*", 
         RowBox[{"pT3", "[", "t", "]"}]}]}], ")"}], "/", "3"}], "-", 
     RowBox[{"peq3", "[", "t", "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", 
  RowBox[{"Bnew", ",", "Bfn"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bnew", "=", 
   RowBox[{"Bfn", "/.", 
    RowBox[{
     RowBox[{"NDSolve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"Bfn", "[", "x", "]"}], ",", "x"}], "]"}], "==", 
          RowBox[{
           RowBox[{"dB", "[", 
            RowBox[{
             RowBox[{"axSol3", "[", "x", "]"}], ",", 
             RowBox[{"azSol3", "[", "x", "]"}], ",", 
             RowBox[{"LSol3", "[", "x", "]"}], ",", 
             RowBox[{"TSol3", "[", "x", "]"}]}], "]"}], 
           RowBox[{
            RowBox[{"TSol3", "'"}], "[", "x", "]"}]}]}], ",", 
         RowBox[{
          RowBox[{"Bfn", "[", "tf", "]"}], "\[Equal]", 
          RowBox[{"B", "[", 
           RowBox[{"TSol3", "[", "tf", "]"}], "]"}]}]}], "}"}], ",", "Bfn", 
       ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "tf", ",", "t0"}], "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Bnew", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "t0", ",", "tf"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pT", "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"LSol3", "[", "t0", "]"}], "4"], "*", 
      RowBox[{"H3T", "[", 
       RowBox[{
        RowBox[{"axSol3", "[", "t0", "]"}], ",", 
        RowBox[{"azSol3", "[", "t0", "]"}], ",", 
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"TSol3", "[", "t0", "]"}], "]"}], "/", 
         RowBox[{"LSol3", "[", "t0", "]"}]}]}], "]"}]}], "-", 
     RowBox[{"Bnew", "[", "t0", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pL", "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"LSol3", "[", "t0", "]"}], "4"], "*", 
      RowBox[{"H3L", "[", 
       RowBox[{
        RowBox[{"axSol3", "[", "t0", "]"}], ",", 
        RowBox[{"azSol3", "[", "t0", "]"}], ",", 
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"TSol3", "[", "t0", "]"}], "]"}], "/", 
         RowBox[{"LSol3", "[", "t0", "]"}]}]}], "]"}]}], "-", 
     RowBox[{"Bnew", "[", "t0", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pLT", "=", 
   RowBox[{"Re", "[", 
    RowBox[{"pL", "/", "pT"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"peq", "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{"4", " ", "\[Pi]", " ", "Nt", " ", 
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"TSol3", "[", "t0", "]"}], "]"}], "^", "2"}], 
      RowBox[{
       RowBox[{"TSol3", "[", "t0", "]"}], "^", "2"}], " ", 
      RowBox[{"BesselK", "[", 
       RowBox[{"2", ",", 
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"TSol3", "[", "t0", "]"}], "]"}], "/", 
         RowBox[{"TSol3", "[", "t0", "]"}]}]}], "]"}]}], "-", 
     RowBox[{"B", "[", 
      RowBox[{"TSol3", "[", "t0", "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalPi]", "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"pL", "+", 
        RowBox[{"2", "*", "pT"}]}], ")"}], "/", "3"}], "-", "peq"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.649522376173706*^9, 3.649522376518003*^9}, {
   3.649522720338491*^9, 3.6495227207548733`*^9}, {3.6495245492711363`*^9, 
   3.649524557125987*^9}, {3.649595787992736*^9, 3.649595797090003*^9}, {
   3.6495958370658216`*^9, 3.649595838878223*^9}, {3.649595881041835*^9, 
   3.649595883793674*^9}, {3.649595938243541*^9, 3.649595941841928*^9}, {
   3.6495961325852547`*^9, 3.649596132981668*^9}, {3.6495965240920057`*^9, 
   3.649596524218544*^9}, 3.649599043739678*^9, 3.649599114025486*^9, {
   3.6495992441223373`*^9, 3.6495992482235622`*^9}, {3.6495994868623*^9, 
   3.649599497055327*^9}, {3.649599535958796*^9, 3.649599536315858*^9}, 
   3.649599719102257*^9, {3.649600550844633*^9, 3.649600582636073*^9}, {
   3.649600747442958*^9, 3.649600766348956*^9}, {3.6496010295049*^9, 
   3.649601032991468*^9}, {3.6496010669291563`*^9, 3.6496010772918673`*^9}, {
   3.64960117525498*^9, 3.649601194877593*^9}, {3.649601649169582*^9, 
   3.649601658157659*^9}, {3.6496020350860443`*^9, 3.649602037977703*^9}, {
   3.6496025039616833`*^9, 3.649602505475195*^9}, {3.649602710016498*^9, 
   3.6496027110146713`*^9}, {3.649604425256267*^9, 3.6496044531970882`*^9}, {
   3.649604509647126*^9, 3.6496046086234627`*^9}, {3.649604675244195*^9, 
   3.6496046901343737`*^9}, 3.649604784080186*^9, 3.650111083483919*^9, 
   3.650132960549238*^9, {3.650133005574233*^9, 3.6501330133361273`*^9}, {
   3.650813092168634*^9, 3.650813092343689*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Massless Realistic", "Section",
 CellChangeTimes->{{3.641397260779482*^9, 3.641397273775364*^9}, {
  3.641558012267256*^9, 3.641558013963632*^9}, {3.6415582864096117`*^9, 
  3.641558291121492*^9}, {3.6429517552216454`*^9, 3.6429517617414722`*^9}, {
  3.6429518875994873`*^9, 3.6429518946638813`*^9}, {3.64952221850609*^9, 
  3.6495222294176702`*^9}}],

Cell[CellGroupData[{

Cell["Setup - 2", "Subsection",
 CellChangeTimes->{{3.6579870486705837`*^9, 3.657987059849468*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"axi", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"azi", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Li", "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"lL", "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"IEis", "[", "lL", "]"}], "2"], " ", 
        SuperscriptBox["axi", "4"], 
        RowBox[{"H2b", "[", 
         RowBox[{"azi", "/", "axi"}], "]"}]}], "\[Equal]", 
       RowBox[{"IEis", "[", "Ti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"lL", ",", "Ti"}], "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.657987084053997*^9, 3.657987139528461*^9}, 
   3.657989657731042*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Main Equations", "Subsection",
 CellChangeTimes->{{3.641397303698731*^9, 3.641397309287036*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EQ1p", "=", 
   RowBox[{
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], "]"}], "+", 
    RowBox[{"3", " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    FractionBox["1", "t"], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"teq1", "[", "t", "]"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"\[Alpha]", "[", "t", "]"}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"T", "[", "t", "]"}], 
           RowBox[{"L", "[", "t", "]"}]], ")"}], "3"]}], "-", "1"}], 
      ")"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EQ1", "=", 
   RowBox[{
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], "]"}], "-", " ", 
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"L", "[", "t", "]"}], "]"}], "]"}], "+", 
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"IPis", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}], "]"}], "+", 
    FractionBox["1", "t"], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"teq1", "[", "t", "]"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"L", "[", "t", "]"}], 
         RowBox[{
          RowBox[{"\[Alpha]", "[", "t", "]"}], " ", 
          RowBox[{"T", "[", "t", "]"}]}]], " ", 
        FractionBox[
         RowBox[{"IPis", "[", 
          RowBox[{"T", "[", "t", "]"}], "]"}], 
         RowBox[{"IPis", "[", 
          RowBox[{"L", "[", "t", "]"}], "]"}]]}], "-", "1"}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EQ2", "=", 
   RowBox[{
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"IEis", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}], "]"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       FractionBox[
        RowBox[{"H2Lb", "[", 
         RowBox[{
          RowBox[{"az", "[", "t", "]"}], "/", 
          RowBox[{"ax", "[", "t", "]"}]}], "]"}], 
        RowBox[{"H2b", "[", 
         RowBox[{
          RowBox[{"az", "[", "t", "]"}], "/", 
          RowBox[{"ax", "[", "t", "]"}]}], "]"}]]}], ")"}], " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"az", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", "-", 
       FractionBox[
        RowBox[{"H2Lb", "[", 
         RowBox[{
          RowBox[{"az", "[", "t", "]"}], "/", 
          RowBox[{"ax", "[", "t", "]"}]}], "]"}], 
        RowBox[{"H2b", "[", 
         RowBox[{
          RowBox[{"az", "[", "t", "]"}], "/", 
          RowBox[{"ax", "[", "t", "]"}]}], "]"}]]}], ")"}], " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"ax", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    FractionBox["1", "t"], "+", 
    FractionBox[
     RowBox[{"3", " ", 
      RowBox[{"IPis", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"H2Lb", "[", 
       RowBox[{
        RowBox[{"az", "[", "t", "]"}], "/", 
        RowBox[{"ax", "[", "t", "]"}]}], "]"}]}], 
     RowBox[{"t", " ", 
      RowBox[{"IEis", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"H2b", "[", 
       RowBox[{
        RowBox[{"az", "[", "t", "]"}], "/", 
        RowBox[{"ax", "[", "t", "]"}]}], "]"}]}]]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EQ3", "=", 
   RowBox[{
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"ax", "[", "t", "]"}], "/", 
       RowBox[{"az", "[", "t", "]"}]}], "]"}], "]"}], "+", 
    RowBox[{
     FractionBox["3", "4"], 
     FractionBox["1", 
      RowBox[{"teq1", "[", "t", "]"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"T", "[", "t", "]"}], 
        RowBox[{"L", "[", "t", "]"}]], ")"}], "5"], " ", 
     FractionBox["xi", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"ax", "[", "t", "]"}], "2"], " ", 
       RowBox[{"az", "[", "t", "]"}]}]]}], "-", 
    FractionBox["1", "t"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EQ4", "=", 
   RowBox[{
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"IEis", "[", 
       RowBox[{"T", "[", "t", "]"}], "]"}], "]"}], "]"}], "+", 
    FractionBox["1", "t"], "+", 
    FractionBox[
     RowBox[{"3", " ", 
      RowBox[{"IPis", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"H2Lb", "[", 
       RowBox[{
        RowBox[{"az", "[", "t", "]"}], "/", 
        RowBox[{"ax", "[", "t", "]"}]}], "]"}]}], 
     RowBox[{"t", " ", 
      RowBox[{"IEis", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"H2b", "[", 
       RowBox[{
        RowBox[{"az", "[", "t", "]"}], "/", 
        RowBox[{"ax", "[", "t", "]"}]}], "]"}]}]]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EQ3p", "=", 
   RowBox[{
    RowBox[{"4", " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"ax", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"dt", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"az", "[", "t", "]"}], "]"}], "]"}], "+", 
    RowBox[{"5", " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"1", "/", "t"}], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"teq1", "[", "t", "]"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox[
         SuperscriptBox[
          RowBox[{"T", "[", "t", "]"}], "5"], 
         SuperscriptBox[
          RowBox[{"L", "[", "t", "]"}], "5"]], 
        FractionBox["1", 
         RowBox[{
          RowBox[{
           RowBox[{"ax", "[", "t", "]"}], "^", "4"}], " ", 
          RowBox[{"az", "[", "t", "]"}]}]]}], "-", "1"}], ")"}]}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"EQ3pp", "=", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"ax", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"3", " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"az", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"5", " ", 
     RowBox[{"dt", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"L", "[", "t", "]"}], "]"}], "]"}]}], "+", 
    RowBox[{"3", "/", "t"}], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"teq1", "[", "t", "]"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox[
         SuperscriptBox[
          RowBox[{"T", "[", "t", "]"}], "5"], 
         SuperscriptBox[
          RowBox[{"L", "[", "t", "]"}], "5"]], " ", 
        FractionBox["1", 
         RowBox[{
          RowBox[{
           RowBox[{"ax", "[", "t", "]"}], "^", "2"}], " ", 
          RowBox[{
           RowBox[{"az", "[", "t", "]"}], "^", "3"}]}]]}], "-", "1"}], 
      ")"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.641397316869967*^9, 3.641397337345542*^9}, {
   3.641555015035141*^9, 3.641555018356443*^9}, {3.6415564248188066`*^9, 
   3.6415564884589453`*^9}, 3.641556555144559*^9, {3.641556662115676*^9, 
   3.641556858658524*^9}, {3.641556905391966*^9, 3.641556906583785*^9}, {
   3.641558108322648*^9, 3.641558133982689*^9}, {3.641558230268272*^9, 
   3.6415582464526033`*^9}, {3.641558311044582*^9, 3.641558313469664*^9}, {
   3.641562914471867*^9, 3.641562946057*^9}, {3.641563104632077*^9, 
   3.641563104821373*^9}, {3.6415702351422653`*^9, 3.641570351881809*^9}, {
   3.641728891476124*^9, 3.641728910251731*^9}, {3.641728945194181*^9, 
   3.641728951404531*^9}, {3.64173177991963*^9, 3.6417317832087317`*^9}, {
   3.642952227057205*^9, 3.642952228682076*^9}, {3.643021229814205*^9, 
   3.64302123799175*^9}, {3.643107280497526*^9, 3.643107287432773*^9}, {
   3.64967996000003*^9, 3.649679960431939*^9}, {3.649688703158389*^9, 
   3.649688766740642*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.641397344237543*^9, 3.641397356573599*^9}, {
  3.6415549456740313`*^9, 3.641554950820972*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"axSol1", ",", "azSol1", ",", "LSol1", ",", "TSol1"}], "}"}], "=", 
  
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ax", ",", "az", ",", "L", ",", "T"}], "}"}], "/.", 
   RowBox[{
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EQ2", "\[Equal]", "0"}], ",", 
        RowBox[{"EQ3p", "\[Equal]", "0"}], ",", 
        RowBox[{"EQ3pp", "\[Equal]", "0"}], ",", 
        RowBox[{"EQ4", "\[Equal]", "0"}], ",", 
        RowBox[{
         RowBox[{"ax", "[", "t0", "]"}], "\[Equal]", "axi"}], ",", 
        RowBox[{
         RowBox[{"az", "[", "t0", "]"}], "\[Equal]", "azi"}], ",", 
        RowBox[{
         RowBox[{"L", "[", "t0", "]"}], "\[Equal]", "Li"}], ",", 
        RowBox[{
         RowBox[{"T", "[", "t0", "]"}], "\[Equal]", "Ti"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"ax", ",", "az", ",", "L", ",", "T"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "t0", ",", "tf"}], "}"}], ",", 
      RowBox[{"Method", "\[Rule]", "\"\<Automatic\>\""}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6415584038233957`*^9, 3.641558418845522*^9}, 
   3.6415703615478163`*^9, 3.641570489891962*^9, {3.641571813802616*^9, 
   3.641571814369595*^9}, {3.641572010096723*^9, 3.641572010185569*^9}, 
   3.6415778115096607`*^9, 3.641642949183544*^9, 3.641645330414012*^9, 
   3.641728092426074*^9, {3.641729044518865*^9, 3.641729052139098*^9}, 
   3.641731716000399*^9, 3.6417317862572613`*^9, 3.641733214921219*^9, 
   3.641733737087091*^9, 3.641734019579803*^9, 3.642952232107726*^9, 
   3.64295230668708*^9, {3.642952534932873*^9, 3.6429525384851713`*^9}, {
   3.643020539582848*^9, 3.643020544503276*^9}, 3.649525204061234*^9, 
   3.6496124330815363`*^9, 3.649677366897674*^9, 3.649677653278754*^9, 
   3.649677912755712*^9, {3.6496799740629883`*^9, 3.649679992878627*^9}, 
   3.649680149070745*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Definition", "Subsection",
 CellChangeTimes->{{3.649522485819446*^9, 3.649522493659484*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ed1", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"IEis", "[", 
      RowBox[{"LSol1", "[", "t", "]"}], "]"}], "/", "2"}], " ", 
    SuperscriptBox[
     RowBox[{"axSol1", "[", "t", "]"}], "4"], 
    RowBox[{"H2b", "[", 
     RowBox[{
      RowBox[{"azSol1", "[", "t", "]"}], "/", 
      RowBox[{"axSol1", "[", "t", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pT1", "[", "t_", "]"}], ":=", 
   RowBox[{"3", "*", 
    RowBox[{
     RowBox[{"IPis", "[", 
      RowBox[{"LSol1", "[", "t", "]"}], "]"}], "/", "4"}], " ", 
    SuperscriptBox[
     RowBox[{"axSol1", "[", "t", "]"}], "4"], 
    RowBox[{"H2Tb", "[", 
     RowBox[{
      RowBox[{"azSol1", "[", "t", "]"}], "/", 
      RowBox[{"axSol1", "[", "t", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pL1", "[", "t_", "]"}], ":=", 
   RowBox[{"3", "*", 
    RowBox[{
     RowBox[{"IPis", "[", 
      RowBox[{"LSol1", "[", "t", "]"}], "]"}], "/", "2"}], " ", 
    SuperscriptBox[
     RowBox[{"axSol1", "[", "t", "]"}], "4"], 
    RowBox[{"H2Lb", "[", 
     RowBox[{
      RowBox[{"azSol1", "[", "t", "]"}], "/", 
      RowBox[{"axSol1", "[", "t", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"peq1", "[", "t_", "]"}], ":=", 
   RowBox[{"IPis", "[", 
    RowBox[{"TSol1", "[", "t", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalPi]1", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"pL1", "[", "t", "]"}], "+", 
       RowBox[{"2", "*", 
        RowBox[{"pT1", "[", "t", "]"}]}]}], ")"}], "/", "3"}], "-", 
    RowBox[{"peq1", "[", "t", "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.6495224982117243`*^9, {3.649523291088372*^9, 3.649523292261901*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Export", "Subsection",
 CellChangeTimes->{{3.6579929404382687`*^9, 3.65799295798*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"tn", ",", "Ax", ",", "Az", ",", "Lambda"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ax", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tn", "=", 
   RowBox[{"{", "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.657993752630702*^9, 3.657993796568198*^9}, {
  3.657993904140435*^9, 3.657994006211875*^9}, {3.657994043196046*^9, 
  3.657994047555097*^9}, {3.6579940935391273`*^9, 3.657994177859017*^9}, {
  3.657994224051115*^9, 3.657994345754237*^9}, {3.657994759126511*^9, 
  3.657994759325183*^9}, {3.657994803077924*^9, 3.657994808669752*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ax", "=", 
   RowBox[{"ToString", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"t", ",", 
        RowBox[{"axSol1", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "t0", ",", "tf", ",", ".01"}], "}"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Az", "=", 
   RowBox[{"ToString", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"t", ",", 
        RowBox[{"azSol1", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "t0", ",", "tf", ",", ".01"}], "}"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Lambda", "=", 
   RowBox[{"ToString", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"t", ",", 
        RowBox[{"LSol1", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "t0", ",", "tf", ",", ".01"}], "}"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</Ax.txt\>\""}], ",", "Ax"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</Az.txt\>\""}], ",", "Az"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</Lambda.txt\>\""}], ",", "Lambda"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.65799440723324*^9, 3.6579944493204317`*^9}, {
  3.657994570104539*^9, 3.6579945752156057`*^9}, {3.6579947626310873`*^9, 
  3.65799485015723*^9}, {3.657994888272345*^9, 3.657994891064584*^9}, {
  3.657996129792156*^9, 3.657996135095331*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Plots and Outputs", "Title",
 CellChangeTimes->{{3.64172908073799*^9, 3.6417291120036783`*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"axSol1", "[", "t", "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "1.1", ",", "1.4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.655659948876815*^9, 3.655659986462995*^9}, {
  3.657987186615711*^9, 3.657987194455785*^9}, {3.6579892687695436`*^9, 
  3.657989330048729*^9}, {3.657989384224646*^9, 3.657989388815693*^9}, {
  3.6579895926176977`*^9, 3.6579896156498413`*^9}, {3.6579897246814337`*^9, 
  3.65798978244803*^9}}],

Cell[CellGroupData[{

Cell["Eos - related plots", "Subsection",
 CellChangeTimes->{{3.643471056829131*^9, 3.64347106108012*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"p1", ",", "p2", ",", "p3", ",", "p4", ",", "p5"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"IEis", "[", 
          RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"sFac", "*", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"T", "/", "hbarc"}], ")"}], "4"]}], ")"}]}], ")"}], ",", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Eideal", "[", 
          RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"sFac", "*", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"T", "/", "hbarc"}], ")"}], "4"]}], ")"}]}], ")"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"T", ",", ".01", ",", "2"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "350"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<T [GeV]\>\"", ",", 
        "\"\<\[CurlyEpsilon]/\!\(\*SubscriptBox[\(\[CurlyEpsilon]\), \
\(SB\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(a)\>\"", ",", "16"}], "]"}]}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Realistic EoS\>\"", ",", "\"\<Quasiparticle EoS\>\""}], "}"}],
           ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FontSize", "\[Rule]", "15"}], "}"}]}], ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"40", ",", "6"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.65", ",", "0.45"}], "}"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"IPis", "[", 
         RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "*", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"T", "/", "hbarc"}], ")"}], "4"], "/", "3"}]}], ")"}]}], 
       ",", 
       RowBox[{
        RowBox[{"Pideal", "[", 
         RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "*", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"T", "/", "hbarc"}], ")"}], "4"], "/", "3"}]}], 
         ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"T", ",", ".01", ",", "2"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "350"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<T [GeV]\>\"", ",", 
        "\"\<P/\!\(\*SubscriptBox[\(P\), \(SB\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(b)\>\"", ",", "16"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"p3", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"p1", ",", "p2"}], "}"}], "}"}], "]"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"wd", "<>", "\"\</E-P\>\"", "<>", "\"\<.pdf\>\""}], ",", "p3", 
     ",", 
     RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.642942069085217*^9, 3.642942082105645*^9}, {
   3.642942199758443*^9, 3.642942207951765*^9}, {3.642942240670779*^9, 
   3.642942278421647*^9}, {3.6429423385045958`*^9, 3.642942355103273*^9}, {
   3.64294252601054*^9, 3.64294266023332*^9}, {3.6429427012179537`*^9, 
   3.642942712554407*^9}, {3.64294279136043*^9, 3.642942805993915*^9}, {
   3.64294380903329*^9, 3.642943872922634*^9}, {3.6429439047872553`*^9, 
   3.6429439704939413`*^9}, {3.642947126525049*^9, 3.642947187005701*^9}, {
   3.642947405461314*^9, 3.6429474159115562`*^9}, {3.643467771776496*^9, 
   3.643467793576037*^9}, 3.643467834160647*^9, {3.6434678904395647`*^9, 
   3.643467947770206*^9}, {3.643468099735211*^9, 3.643468169325469*^9}, {
   3.643468216171053*^9, 3.6434682969020023`*^9}, {3.64346903639433*^9, 
   3.6434691103221292`*^9}, {3.643469186969823*^9, 3.643469207559751*^9}, {
   3.643469237985889*^9, 3.643469320119635*^9}, {3.643469385052361*^9, 
   3.6434694201192303`*^9}, {3.6434694739845324`*^9, 
   3.6434694801377497`*^9}, {3.6434695179405003`*^9, 3.643469520212316*^9}, 
   3.643469552125658*^9, 3.643469611145136*^9, {3.64346968385157*^9, 
   3.643469748843309*^9}, {3.643469786753677*^9, 3.643469811221471*^9}, {
   3.6434698796006613`*^9, 3.643469895696835*^9}, {3.643470165539219*^9, 
   3.643470203939706*^9}, {3.643470234886731*^9, 3.643470284767847*^9}, {
   3.6434703153721037`*^9, 3.6434703398179827`*^9}, {3.643470444622205*^9, 
   3.643470475618123*^9}, {3.643470556578446*^9, 3.643470620556903*^9}, {
   3.643470674626328*^9, 3.643470729942573*^9}, {3.643470840872347*^9, 
   3.643470842738303*^9}, {3.6434709157253733`*^9, 3.6434709224914217`*^9}, 
   3.6434712529392977`*^9, {3.643472338865234*^9, 3.643472393030367*^9}, {
   3.643474818896907*^9, 3.64347483325496*^9}, {3.643475138614688*^9, 
   3.643475142219701*^9}, {3.643500084629918*^9, 3.6435000909745073`*^9}, {
   3.643500127710558*^9, 3.64350017517834*^9}, {3.643500207549904*^9, 
   3.6435002111213493`*^9}, {3.6435002480095577`*^9, 3.64350035901665*^9}, {
   3.643500599968934*^9, 3.6435006239263763`*^9}, {3.6435008501352873`*^9, 
   3.643500882817107*^9}, {3.6435014682539454`*^9, 3.643501469317321*^9}, {
   3.643502069459786*^9, 3.643502070867302*^9}, {3.650126531409939*^9, 
   3.650126577535973*^9}, {3.650127203122381*^9, 3.6501272149427223`*^9}, {
   3.6501328414584293`*^9, 3.650132843480688*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"p4", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"IsEis", "[", 
         RowBox[{"y", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", "sFac", ")"}]}], ",", 
       RowBox[{
        RowBox[{"IsPis", "[", 
         RowBox[{"y", "/", "hbarc"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"sFac", "/", "3"}], ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", ".01", ",", "2"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "450"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<T [GeV]\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(eq\)]\)/ \
\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(SB\)]\)\>\"", ",", 
            "\"\<\!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(eq\)]\)/ \
\!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(SB\)]\)\>\""}], "}"}], ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FontSize", "\[Rule]", "20"}], ",", 
             RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "}"}]}], 
          ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"40", ",", "6"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.65", ",", "0.35"}], "}"}]}], "]"}]}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(a)\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
       "]"}]}]}], "]"}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</E-P\>\"", "<>", "\"\<.pdf\>\""}], ",", "p4", ",", 
   RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.650126778812748*^9, {3.650126814443369*^9, 3.650126891601952*^9}, {
   3.650126978332079*^9, 3.650126991626802*^9}, {3.650127039141445*^9, 
   3.650127089155149*^9}, {3.6501271506937733`*^9, 3.65012716242651*^9}, {
   3.650127197106309*^9, 3.650127221702325*^9}, {3.650384440838191*^9, 
   3.6503844449007893`*^9}, {3.6507278417527018`*^9, 3.6507278420338783`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Speed of Sound", "Subsection",
 CellChangeTimes->{{3.6501328090048428`*^9, 3.650132818494029*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PE", "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"IEis", "[", 
         RowBox[{"x", "/", "hbarc"}], "]"}], ",", 
        RowBox[{"IPis", "[", 
         RowBox[{"x", "/", "hbarc"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", ".01", ",", "2", ",", ".0001"}], "}"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PEp", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"PE", "'"}], "[", 
    RowBox[{"IEis", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"p5", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"PEp", "[", 
     RowBox[{"T", "/", "hbarc"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"T", ",", ".01", ",", "2"}], "}"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<T [GeV]\>\"", ",", 
       "\"\<\!\(\*SuperscriptBox[SubscriptBox[\(c\), \(s\)], \(2\)]\)\>\""}], 
      "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"styles", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "450"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<T [GeV]\>\"", ",", 
       "\"\<P/\!\(\*SubscriptBox[\(P\), \(SB\)]\)\>\""}], "}"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<(b)\>\"", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
      "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</cs2\>\"", "<>", "\"\<.pdf\>\""}], ",", "p5", ",", 
   RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQ3R+UIy1o9NrRl9VWBkTnrDN0AdFLNr50A9EfMk0y
QXTDujXFINqgmKcRRPestwDTnwUS+kC03IHjk0D0LE6ZXyD6ddgVMK33/DqT
EJBWEu9iAdEbHkZxgGimLzfBtEHQCh4QvfEPKy+ILrqqLQaiU+sfioPoWv3E
pSD606+FYHpW5MbVILpNZvIaEH3v5akNINoz8guYFpkWux1EWwdngukDi3cf
ANFTDhofAtG7BNaeBdFnLvpfAtHzHul+B9GGOXPBdNEOAy5hIC2TkACmTSX3
moNojmADKxC9pHt+OYh+0xRbAaI7LMxemBoD/bHfEUxzOT5+D6LbUpg+gmgA
oLaWsg==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["M(T) and B(T)", "Subsection",
 CellChangeTimes->{{3.643468979533228*^9, 3.643468991685082*^9}, {
  3.643471070276104*^9, 3.643471079339231*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Eideal", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{"4", " ", "\[Pi]", " ", "Nt", " ", 
     SuperscriptBox["t", "4"], 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"M", "[", "t", "]"}], "t"], ")"}], "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        RowBox[{"K2", "[", 
         FractionBox[
          RowBox[{"M", "[", "t", "]"}], "t"], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         FractionBox[
          RowBox[{"M", "[", "t", "]"}], "t"], ")"}], 
        RowBox[{"K1", "[", 
         FractionBox[
          RowBox[{"M", "[", "t", "]"}], "t"], "]"}]}]}], ")"}]}], "+", 
    RowBox[{"B", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Pideal", "[", "t_", "]"}], ":=", 
   RowBox[{
    RowBox[{"4", " ", "\[Pi]", " ", "Nt", " ", 
     SuperscriptBox["t", "4"], 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"M", "[", "t", "]"}], "t"], ")"}], "2"], 
     RowBox[{"K2", "[", 
      FractionBox[
       RowBox[{"M", "[", "t", "]"}], "t"], "]"}]}], "-", 
    RowBox[{"B", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tini", "=", ".01"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tfin", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"p1", "=", " ", 
  RowBox[{"LogLinearPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"M", "[", 
       RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"T", "/", "hbarc"}], ")"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"T", ",", "Tini", ",", "Tfin"}], "}"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "]"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<T [GeV]\>\"", ",", "\"\<m/ T\>\""}], "}"}]}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<(a)\>\"", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
      "]"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{".008", ",", "2.2"}], "}"}], ",", "Automatic"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "440"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"p2", "=", 
  RowBox[{"LogLinearPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "[", 
       RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"T", "/", "hbarc"}], ")"}], "4"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"T", ",", "Tini", ",", "Tfin"}], "}"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "460"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "]"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "15"}], "}"}]}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<T [GeV]\>\"", ",", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(eq\)]\)/ \!\(\*SuperscriptBox[\(T\), \
\(4\)]\)\>\""}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{".008", ",", "2.2"}], "}"}], ",", "Automatic"}], "}"}]}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<(b)\>\"", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
      "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p3", "=", 
   RowBox[{"LogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"B", "[", 
        RowBox[{"T", "/", "hbarc"}], "]"}], "/", 
       RowBox[{"Eideal", "[", 
        RowBox[{"T", "/", "hbarc"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"T", ",", "Tini", ",", "Tfin"}], "}"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "460"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", 
        RowBox[{"AbsoluteThickness", "[", "1.3", "]"}]}], "]"}]}], ",", 
     RowBox[{"LabelStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "15"}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<T [GeV]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(B\), \(eq\)]\)/ \!\(\*SubscriptBox[\(\
\[ScriptCapitalE]\), \(eq\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{".008", ",", "2.2"}], "}"}], ",", "Automatic"}], "}"}]}], 
     ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(a)\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
       "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</MT\>\"", "<>", "\"\<.pdf\>\""}], ",", "p1", ",", 
   
   RowBox[{"ImageResolution", "\[Rule]", "300"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</BT4\>\"", "<>", "\"\<.pdf\>\""}], ",", "p2", ",", 
   RowBox[{"ImageResolution", "\[Rule]", "300"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"wd", "<>", "\"\</Be\>\"", "<>", "\"\<.pdf\>\""}], ",", "p3", 
     ",", 
     RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.643471116249539*^9, 3.643471150824562*^9}, {
   3.6434711879450407`*^9, 3.643471208528522*^9}, {3.643471291400358*^9, 
   3.64347133358276*^9}, {3.643471373927845*^9, 3.643471385133103*^9}, {
   3.643471463432328*^9, 3.643471519726506*^9}, {3.643471638333806*^9, 
   3.6434716761963387`*^9}, {3.643471720515176*^9, 3.643471752149687*^9}, {
   3.643471782172072*^9, 3.643471865439859*^9}, {3.6434718983878603`*^9, 
   3.643471949565884*^9}, {3.643471993877763*^9, 3.643472035781344*^9}, {
   3.64347208260981*^9, 3.643472105613559*^9}, {3.643472145003096*^9, 
   3.643472152561648*^9}, {3.643474850147468*^9, 3.643474852870023*^9}, {
   3.643475148959988*^9, 3.643475156663745*^9}, {3.64347518889464*^9, 
   3.643475248185058*^9}, {3.64350090437253*^9, 3.643500923083585*^9}, {
   3.6435014615749598`*^9, 3.64350146347715*^9}, {3.643502061860074*^9, 
   3.643502065178896*^9}, {3.649780574291789*^9, 3.649780608429575*^9}, {
   3.649780643666328*^9, 3.649780764207299*^9}, {3.649780852405243*^9, 
   3.649780853192922*^9}, {3.649780917401967*^9, 3.6497809433745203`*^9}, {
   3.6497814348572598`*^9, 3.64978145131152*^9}, {3.6497815604121037`*^9, 
   3.6497815607950153`*^9}, {3.64978159671386*^9, 3.649781613749073*^9}, {
   3.649781652838092*^9, 3.649781820903459*^9}, {3.6497818570432177`*^9, 
   3.649781915596656*^9}, {3.6497822568334103`*^9, 3.6497822849371243`*^9}, {
   3.649782321307465*^9, 3.649782350495138*^9}, {3.649782411359083*^9, 
   3.649782448137619*^9}, {3.649782502205494*^9, 3.649782511508235*^9}, {
   3.6497825566592407`*^9, 3.649782743965087*^9}, {3.64978277967418*^9, 
   3.649782840252993*^9}, {3.6497834749791403`*^9, 3.649783503536614*^9}, {
   3.649783603897175*^9, 3.64978364481498*^9}, {3.64978370193399*^9, 
   3.6497837328813763`*^9}, {3.649783961546945*^9, 3.649784061873597*^9}, {
   3.649791808200959*^9, 3.649791808570952*^9}, {3.64979185942096*^9, 
   3.649791890290004*^9}, {3.649792769406952*^9, 3.6497927967349*^9}, 
   3.649793118025687*^9, {3.649793148336102*^9, 3.649793197905675*^9}, {
   3.649794447433702*^9, 3.6497944475364447`*^9}, {3.649795087179495*^9, 
   3.649795213154916*^9}, {3.649795245119573*^9, 3.649795309727975*^9}, {
   3.649795340326765*^9, 3.649795340564724*^9}, {3.6497954337840347`*^9, 
   3.649795455374405*^9}, {3.649795489170083*^9, 3.649795490443591*^9}, {
   3.649795587639316*^9, 3.649795591117385*^9}, {3.649795650042396*^9, 
   3.649795656961596*^9}, {3.649795728983491*^9, 3.649795766632307*^9}, {
   3.6497958251816053`*^9, 3.649795862510167*^9}, {3.650043484200303*^9, 
   3.650043495967268*^9}, {3.650109313580593*^9, 3.6501093145817947`*^9}, {
   3.650109348417529*^9, 3.650109348610326*^9}, {3.650109383044386*^9, 
   3.650109414444075*^9}, {3.650109871854465*^9, 3.650109882864122*^9}, {
   3.650109990596024*^9, 3.650110042159503*^9}, {3.650110075592512*^9, 
   3.650110088060298*^9}, {3.650110388098529*^9, 3.650110389118623*^9}, {
   3.650114110317972*^9, 3.650114128059351*^9}, {3.6501143075433493`*^9, 
   3.650114309567487*^9}, 3.650204525651165*^9, {3.650204670377357*^9, 
   3.6502046933818293`*^9}, {3.650207295071187*^9, 3.650207296247452*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Other quantities", "Subsection",
 CellChangeTimes->{{3.643472205344082*^9, 3.64347224819656*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"p1", ",", "p2", ",", "p3", ",", "p4"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"TSol3", "[", "t", "]"}], "/", "Ti"}], ",", " ", 
       RowBox[{
        RowBox[{"TSol1", "[", "t", "]"}], "/", "Ti"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "t0", ",", "tf"}], "}"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "450"}], ",", 
     RowBox[{"Axes", "->", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\[Tau] [fm/c]\>\"", ",", 
        "\"\<T/ \!\(\*SubscriptBox[\(T\), \(0\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{
        RowBox[{"LineLegend", "[", 
         RowBox[{"styles", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Quasiparticle EoS \>\"", ",", "\"\<Standard EoS\>\""}], "}"}],
           ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FontSize", "\[Rule]", "20"}], ",", 
             RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "}"}]}], 
          ",", 
          RowBox[{"LegendMarkerSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"35", ",", "6"}], "}"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.65", ",", "0.8"}], "}"}]}], "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(a)\>\"", ",", "16"}], "]"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.19", ",", "600"}], "}"}], ",", "Automatic"}], "}"}]}], 
     ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Inset", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<4\[Pi]\[Eta]/s=\>\"", "<>", "\[Eta]bar"}], ",", 
           RowBox[{"FontSize", "\[Rule]", "20"}], ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{".1", ",", 
           RowBox[{"-", "1.3"}]}], "}"}]}], "]"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2", "=", 
   RowBox[{"LogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["t", "t0"], ")"}], 
         RowBox[{"4", "/", "3"}]], 
        FractionBox[
         RowBox[{"ed3", "[", "t", "]"}], 
         RowBox[{"ed3", "[", "t0", "]"}]]}], " ", ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["t", "t0"], ")"}], 
         RowBox[{"4", "/", "3"}]], 
        FractionBox[
         RowBox[{"ed1", "[", "t", "]"}], 
         RowBox[{"ed1", "[", "t0", "]"}]]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "t0", ",", "tf"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.19", ",", "600"}], "}"}], ",", "Automatic"}], "}"}]}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "460"}], ",", 
     RowBox[{"Axes", "->", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\[Tau] [fm/c]\>\"", ",", 
        "\"\<(\[Tau]/ \!\(\*SubscriptBox[\(\[Tau]\), \
\(0\)]\)\!\(\*SuperscriptBox[\()\), \(4/3\)]\) \[ScriptCapitalE]/ \
\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(0\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(b)\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
       "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p3", "=", 
   RowBox[{"LogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"pL3", "[", "t", "]"}], 
        RowBox[{"pT3", "[", "t", "]"}]], ",", 
       FractionBox[
        RowBox[{"pL1", "[", "t", "]"}], 
        RowBox[{"pT1", "[", "t", "]"}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "t0", ",", "tf"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.19", ",", "600"}], "}"}], ",", "Automatic"}], "}"}]}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "450"}], ",", 
     RowBox[{"Axes", "->", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\[Tau] [fm/c]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(L\)]\)/ \
\!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(T\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<(c)\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
       "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"p4", "=", 
    RowBox[{"LogLinearPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalPi]3", "[", "t", "]"}], "/", 
         RowBox[{"peq3", "[", "t", "]"}]}], ",", 
        RowBox[{
         RowBox[{"\[CapitalPi]1", "[", "t", "]"}], "/", 
         RowBox[{"peq1", "[", "t", "]"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "t0", ",", "tf"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.19", ",", "600"}], "}"}], ",", "Automatic"}], "}"}]}], 
      ",", 
      RowBox[{"ImageSize", "\[Rule]", "490"}], ",", 
      RowBox[{"Axes", "->", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"FontSize", "\[Rule]", "16"}], "}"}]}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<\[Tau] [fm/c]\>\"", ",", 
         "\"\<\[CapitalPi]/ \!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(eq\)]\
\)\>\""}], "}"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<(d)\>\"", ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "16"}], 
        "]"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"p", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p1", ",", "p2"}], "}"}], ",", 
      RowBox[{"{", "Null", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"p3", ",", "p4"}], "}"}]}], "}"}], ",", 
    RowBox[{"Spacings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2.1", ",", "0"}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "wd", "<>", "\"\</plot-\>\"", "<>", "\[Eta]bar", "<>", 
    "\"\<-aniso.pdf\>\""}], ",", "p", ",", 
   RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.641730461278221*^9, 3.6417304909834948`*^9}, {
   3.6417305822388477`*^9, 3.641730621404663*^9}, {3.641730850300424*^9, 
   3.641730950407632*^9}, {3.6417316042969933`*^9, 3.641731608800638*^9}, {
   3.641731795143053*^9, 3.641731797106709*^9}, {3.641732071793803*^9, 
   3.64173211959437*^9}, {3.64173219382726*^9, 3.641732207085328*^9}, {
   3.641732243488173*^9, 3.641732251726508*^9}, {3.641732312782045*^9, 
   3.6417323192600594`*^9}, {3.641732375338619*^9, 3.641732424616555*^9}, {
   3.641732473480938*^9, 3.641732478681905*^9}, 3.641732539401246*^9, 
   3.64173271031271*^9, {3.641733073680334*^9, 3.641733097465406*^9}, {
   3.641733167038499*^9, 3.6417331749924927`*^9}, {3.641733232418673*^9, 
   3.641733244204316*^9}, {3.64173327625679*^9, 3.641733278728088*^9}, {
   3.641733325546283*^9, 3.641733330707057*^9}, {3.641733553529294*^9, 
   3.641733555687923*^9}, {3.64173365208039*^9, 3.641733705644909*^9}, {
   3.641733770177731*^9, 3.641733772626392*^9}, {3.641733814705427*^9, 
   3.641733829924436*^9}, {3.641733871433744*^9, 3.641733873934917*^9}, {
   3.641734026235942*^9, 3.641734031130892*^9}, {3.6417340686429768`*^9, 
   3.6417340710108347`*^9}, {3.641734133490142*^9, 3.641734136488906*^9}, {
   3.643108973990749*^9, 3.643109007250721*^9}, {3.643109080412073*^9, 
   3.643109088219883*^9}, {3.643110311756474*^9, 3.6431103699551992`*^9}, {
   3.643110514584927*^9, 3.643110564807282*^9}, 3.6431106213394527`*^9, {
   3.643110686834674*^9, 3.6431107001947737`*^9}, {3.643110996264433*^9, 
   3.643111022058238*^9}, {3.6431263047201567`*^9, 3.643126307899086*^9}, {
   3.6431278523961887`*^9, 3.643127980384034*^9}, {3.6431281561957912`*^9, 
   3.643128188072794*^9}, {3.643128691511818*^9, 3.6431286965399933`*^9}, {
   3.643129657090844*^9, 3.643129712659299*^9}, {3.643129745348407*^9, 
   3.6431297573816643`*^9}, {3.643129797970593*^9, 3.643129879016006*^9}, {
   3.643468682071432*^9, 3.643468683218424*^9}, {3.643475290489773*^9, 
   3.643475293070703*^9}, {3.643475403192937*^9, 3.643475412054002*^9}, 
   3.643475486251377*^9, {3.643476095817307*^9, 3.6434760974567623`*^9}, 
   3.643476953586607*^9, {3.643477777499757*^9, 3.643477793824233*^9}, 
   3.643477946465508*^9, 3.643478130289938*^9, {3.643478362417481*^9, 
   3.6434783677103977`*^9}, 3.6434787032303953`*^9, {3.643500949008499*^9, 
   3.6435009984231873`*^9}, {3.643501584966337*^9, 3.643501602561233*^9}, 
   3.643502024753725*^9, 3.6435023327843246`*^9, {3.645363330688837*^9, 
   3.645363394211638*^9}, {3.6453634585201902`*^9, 3.645363468591174*^9}, {
   3.645363986972755*^9, 3.6453639884919157`*^9}, 3.645364286249914*^9, 
   3.645364409839334*^9, {3.6453645166358624`*^9, 3.6453645203224087`*^9}, {
   3.645365010794457*^9, 3.64536503695179*^9}, {3.6453651302918997`*^9, 
   3.6453651387622004`*^9}, 3.6453652312349377`*^9, {3.647796726727113*^9, 
   3.647796728999173*^9}, {3.649522094505509*^9, 3.6495220961340227`*^9}, {
   3.649523362856484*^9, 3.649523414471711*^9}, {3.649523445262542*^9, 
   3.64952346698877*^9}, {3.64952465401856*^9, 3.6495246543603983`*^9}, {
   3.649524692842475*^9, 3.649524699261682*^9}, {3.649524825987878*^9, 
   3.64952484975528*^9}, 3.649524949545394*^9, {3.649525076147883*^9, 
   3.649525086739214*^9}, {3.649601974942007*^9, 3.649601976697591*^9}, {
   3.649603355217956*^9, 3.649603360611251*^9}, {3.649612710462048*^9, 
   3.6496127126818037`*^9}, 3.649613230211501*^9, {3.649613270635652*^9, 
   3.649613283639818*^9}, {3.6497653679390297`*^9, 3.649765469769937*^9}, {
   3.649765540031814*^9, 3.649765543597863*^9}, {3.649765583365698*^9, 
   3.649765656101734*^9}, {3.649765825364182*^9, 3.649765825705488*^9}, {
   3.649765906765304*^9, 3.649765932840238*^9}, {3.649769922572047*^9, 
   3.649769950403595*^9}, {3.6497701203209143`*^9, 3.649770127807835*^9}, {
   3.6497703089514303`*^9, 3.6497703329065113`*^9}, {3.649770412232465*^9, 
   3.649770438931252*^9}, {3.649770535639172*^9, 3.649770562404621*^9}, {
   3.649770893298983*^9, 3.649770972094223*^9}, {3.649771052948433*^9, 
   3.649771071591226*^9}, {3.649771615513925*^9, 3.649771624128048*^9}, {
   3.64977165486797*^9, 3.649771675106453*^9}, {3.649771757394216*^9, 
   3.649771776238003*^9}, 3.649771827586884*^9, {3.64977188792408*^9, 
   3.649771924974053*^9}, {3.6497720083229227`*^9, 3.6497720340383177`*^9}, {
   3.6497725764963093`*^9, 3.6497725839921913`*^9}, {3.649772651772588*^9, 
   3.6497726535743933`*^9}, {3.64977471421824*^9, 3.649774740341563*^9}, {
   3.649775236488841*^9, 3.649775257206993*^9}, {3.649775340021599*^9, 
   3.649775340336535*^9}, {3.649775579519628*^9, 3.649775580344143*^9}, {
   3.6497756593815393`*^9, 3.649775665313829*^9}, {3.649795514898912*^9, 
   3.649795518497282*^9}, {3.649795965934104*^9, 3.649795968195291*^9}, {
   3.6497960096667767`*^9, 3.649796084980295*^9}, {3.6497966412448273`*^9, 
   3.6497966418032722`*^9}, {3.649796957665655*^9, 3.649796963632882*^9}, {
   3.64979704950666*^9, 3.649797049722987*^9}, {3.6497972869170647`*^9, 
   3.6497972876032677`*^9}, {3.650112115640133*^9, 3.650112119531727*^9}, {
   3.650112151428677*^9, 3.65011219746012*^9}, 3.650113513225453*^9, {
   3.650113547051189*^9, 3.650113554829027*^9}, {3.650113616975751*^9, 
   3.6501136514672813`*^9}, {3.650114080777034*^9, 3.650114082374071*^9}, {
   3.650114145942916*^9, 3.650114146230441*^9}, 3.650114287563196*^9, {
   3.650116095443042*^9, 3.650116098103829*^9}, {3.6501161631332397`*^9, 
   3.650116164761936*^9}, {3.650124271609977*^9, 3.650124272057744*^9}, {
   3.650133125845491*^9, 3.650133133071344*^9}, {3.65013327179263*^9, 
   3.650133273718904*^9}, {3.6501336986910477`*^9, 3.6501336991867*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{"x", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p3", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     SuperscriptBox["x", "3"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p4", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     SuperscriptBox["x", "4"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p1", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Null", ",", "Null"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"p3", ",", "p4"}], "}"}]}], "}"}], ",", 
   RowBox[{"Spacings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2.1", ",", "0"}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.650133170651647*^9, 3.650133263712019*^9}, {
  3.650207210305955*^9, 3.650207220288787*^9}}]
}, Open  ]]
}, Closed]]
},
WindowSize->{1172, 558},
WindowMargins->{{73, Automatic}, {Automatic, 9}},
ShowSelection->True,
FrontEndVersion->"10.4 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 11, \
2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 69, 1, 28, "Input"],
Cell[630, 23, 67, 1, 28, "Input"],
Cell[700, 26, 3752, 150, 193, "Input"],
Cell[CellGroupData[{
Cell[4477, 180, 96, 1, 92, "Title"],
Cell[CellGroupData[{
Cell[4598, 185, 92, 1, 64, "Section"],
Cell[CellGroupData[{
Cell[4715, 190, 79, 1, 45, "Subsection"],
Cell[4797, 193, 241, 5, 32, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5075, 203, 73, 1, 44, "Subsection"],
Cell[5151, 206, 2374, 62, 200, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7562, 273, 97, 1, 44, "Subsection"],
Cell[7662, 276, 1263, 37, 143, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[8962, 318, 91, 1, 37, "Subsection"],
Cell[9056, 321, 4628, 113, 363, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[13733, 440, 102, 1, 50, "Section"],
Cell[13838, 443, 10770, 345, 327, "Input"],
Cell[24611, 790, 14829, 394, 519, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[39477, 1189, 81, 1, 50, "Section"],
Cell[39561, 1192, 6897, 234, 640, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[46495, 1431, 97, 1, 50, "Section"],
Cell[CellGroupData[{
Cell[46617, 1436, 337, 6, 44, "Subsection"],
Cell[46957, 1444, 1023, 24, 187, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[48017, 1473, 252, 5, 36, "Subsection"],
Cell[CellGroupData[{
Cell[48294, 1482, 195, 4, 32, "Subsubsection"],
Cell[48492, 1488, 1901, 51, 70, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[50430, 1544, 275, 5, 26, "Subsubsection"],
Cell[50708, 1551, 4914, 133, 301, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[55659, 1689, 316, 8, 28, "Subsubsection"],
Cell[55978, 1699, 5774, 143, 311, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61801, 1848, 151, 2, 45, "Subsection"],
Cell[CellGroupData[{
Cell[61977, 1854, 232, 3, 35, "Subsubsection"],
Cell[62212, 1859, 1284, 35, 137, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[63533, 1899, 232, 3, 29, "Subsubsection"],
Cell[63768, 1904, 1331, 35, 168, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[65136, 1944, 233, 3, 29, "Subsubsection"],
Cell[65372, 1949, 1336, 35, 137, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[66745, 1989, 233, 3, 29, "Subsubsection"],
Cell[66981, 1994, 1333, 35, 137, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[68351, 2034, 216, 3, 29, "Subsubsection"],
Cell[68570, 2039, 6138, 144, 210, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[74757, 2189, 607, 8, 44, "Subsection"],
Cell[75367, 2199, 678, 18, 99, "Input"],
Cell[76048, 2219, 5218, 136, 215, "Input"],
Cell[81269, 2357, 12231, 218, 273, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[93549, 2581, 103, 1, 50, "Section"],
Cell[93655, 2584, 499, 11, 32, "Input"],
Cell[94157, 2597, 2664, 68, 121, "Input"],
Cell[CellGroupData[{
Cell[96846, 2669, 126, 1, 45, "Subsection"],
Cell[96975, 2672, 4362, 99, 231, "Input"],
Cell[101340, 2773, 1577, 36, 77, "Input"],
Cell[CellGroupData[{
Cell[102942, 2813, 117, 1, 35, "Subsubsection"],
Cell[103062, 2816, 1542, 39, 190, "Input"],
Cell[104607, 2857, 2225, 45, 55, "Input"],
Cell[106835, 2904, 27774, 654, 303, "Input"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[134670, 3565, 102, 1, 50, "Section"],
Cell[134775, 3568, 4185, 80, 107, "Input"],
Cell[138963, 3650, 2544, 52, 59, "Input"],
Cell[141510, 3704, 766, 20, 34, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[142313, 3729, 97, 1, 50, "Section"],
Cell[142413, 3732, 16346, 356, 539, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[158796, 4093, 433, 6, 64, "Section"],
Cell[CellGroupData[{
Cell[159254, 4103, 95, 1, 45, "Subsection"],
Cell[159352, 4106, 2181, 58, 116, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[161570, 4169, 104, 1, 45, "Subsection"],
Cell[161677, 4172, 11408, 283, 330, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173122, 4460, 96, 1, 44, "Subsection"],
Cell[173221, 4463, 3347, 61, 77, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[176605, 4529, 101, 1, 44, "Subsection"],
Cell[176709, 4532, 7495, 204, 351, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[184253, 4742, 356, 5, 50, "Section"],
Cell[CellGroupData[{
Cell[184634, 4751, 99, 1, 44, "Subsection"],
Cell[184736, 4754, 733, 21, 83, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[185506, 4780, 102, 1, 44, "Subsection"],
Cell[185611, 4783, 7917, 236, 310, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[193565, 5024, 147, 2, 44, "Subsection"],
Cell[193715, 5028, 1949, 42, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195701, 5075, 98, 1, 44, "Subsection"],
Cell[195802, 5078, 1895, 60, 125, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[197734, 5143, 92, 1, 36, "Subsection"],
Cell[197829, 5146, 646, 14, 63, "Input"],
Cell[198478, 5162, 1685, 49, 114, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[200224, 5218, 101, 1, 92, "Title"],
Cell[200328, 5221, 517, 11, 32, "Input"],
Cell[CellGroupData[{
Cell[200870, 5236, 106, 1, 45, "Subsection"],
Cell[200979, 5239, 7069, 168, 197, "Input"],
Cell[208051, 5409, 2967, 70, 122, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[211055, 5484, 104, 1, 37, "Subsection"],
Cell[211162, 5487, 2641, 70, 126, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[213840, 5562, 150, 2, 37, "Subsection"],
Cell[213993, 5566, 9698, 224, 354, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[223728, 5795, 103, 1, 37, "Subsection"],
Cell[223834, 5798, 13791, 298, 376, "Input"],
Cell[237628, 6098, 1390, 47, 152, "Input"]
}, Open  ]]
}, Closed]]
}
]
*)

