(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     35961,        906]
NotebookOptionsPosition[     33978,        837]
NotebookOutlinePosition[     34355,        854]
CellTagsIndexPosition[     34312,        851]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Constants", "Section",
 CellChangeTimes->{{3.5962107218783092`*^9, 3.596210726827827*^9}, {
   3.5962111378015213`*^9, 3.596211143639701*^9}, 3.596211764959023*^9, {
   3.596214000608802*^9, 3.596214004239328*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"hbarc", "=", "0.197326938"}], ";"}]], "Input",
 CellChangeTimes->{{3.5963843443414516`*^9, 3.5963843459316597`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["aHydro2p1 - xi ", "Section",
 CellChangeTimes->{{3.5962107218783092`*^9, 3.596210726827827*^9}, {
   3.5962111378015213`*^9, 3.596211143639701*^9}, 3.596211764959023*^9, {
   3.596505332328547*^9, 3.59650533439809*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", " ", "=", " ", "\"\<1.950\>\""}], ";"}]], "Input",
 CellChangeTimes->CompressedData["
1:eJwdzU8oQwEcwPHhJSaS/2JKHLaURuLi4M3SJmHjIIdlam17YV6J1doWSrLM
ZAfmsFLDZZnan5wo2hJjx3kHU1OrWVqM/Gnm/X6Hb5/jt3laJ1flczgcHhs4
UWAs5t0myYsOF2q71481sebWDKhn/HcqxMpouUpQ0jNHvrBSfCuqjosToDC6
g/orXNwUq5sMonfvNdVgjulDU4xdAFKF52hYKu0GRU4Dqll0iNKs15IbdLvh
WwtSYoICT0SBDLisL/sA53WZR2M4SS60VMVAeWqr1cT657WjQZmyHUxnZ9CD
RlsXeEQ40BLTay84SH+hs3mjA+BQqRm1jggU4OVmG2q3eDWg8NSPEqsKGpzM
baAyyrkCHtJRNOLb2wWXHvbRYUE0ANLu8jP89AuDoGS9E7Ucv0VAX30WLXq+
ioFPVAIl+KpP0BNXo5Whn1ozK0MTdeA/Nu8INA==
  "]],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "dataDir", " ", "=", 
   "\"\</Users/michael/Documents/code/aHydro2p1b/data/snapshot\>\""}], 
  ";"}]], "Input"],

Cell[CellGroupData[{

Cell["lambda", "Subsection",
 CellChangeTimes->{{3.5962107218783092`*^9, 3.596210726827827*^9}, {
   3.5962111378015213`*^9, 3.596211143639701*^9}, 3.596211764959023*^9, {
   3.596505335725835*^9, 3.596505337069746*^9}, 3.59654325499669*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"var", " ", "=", " ", "\"\<phard\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
    "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<_\>\"", "<>", "t", 
     "<>", "\"\<.dat\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"intData", " ", "=", " ", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Riffle", "[", 
      RowBox[{
       RowBox[{"rawData", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
       RowBox[{"rawData", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "3"}], "]"}], "]"}]}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myInt1", " ", "=", " ", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"intData", ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"range", " ", "=", " ", 
    RowBox[{"Max", "[", 
     RowBox[{"rawData", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plot1", " ", "=", " ", 
  RowBox[{"Plot3D", "[", 
   RowBox[{
    RowBox[{"myInt1", "[", 
     RowBox[{"x", ",", "y"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "var"}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Lighter", "[", 
      RowBox[{"Lighter", "[", "Blue", "]"}], "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.596211796362603*^9, 3.596211842605845*^9}, {
   3.596211901621965*^9, 3.596211906932805*^9}, {3.596211936934146*^9, 
   3.5962120067249002`*^9}, {3.596213596574868*^9, 3.5962136623609657`*^9}, {
   3.596213748225075*^9, 3.596213781422119*^9}, {3.5962140600660343`*^9, 
   3.5962140619530497`*^9}, {3.5962144508200493`*^9, 3.596214452746604*^9}, {
   3.596214652667364*^9, 3.596214652949778*^9}, {3.596214819701792*^9, 
   3.596214819812545*^9}, {3.596220953692124*^9, 3.596220953758472*^9}, {
   3.5962210631230383`*^9, 3.5962210631860943`*^9}, {3.596221443300435*^9, 
   3.59622144520455*^9}, {3.596384992506332*^9, 3.596385024464295*^9}, {
   3.596385093273389*^9, 3.596385093631531*^9}, {3.596543288001457*^9, 
   3.5965432959994907`*^9}, {3.5970993802457113`*^9, 3.59709940499942*^9}, {
   3.597141054384534*^9, 3.597141066266097*^9}, 3.597513699479292*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["xi ", "Subsection",
 CellChangeTimes->{{3.5962107218783092`*^9, 3.596210726827827*^9}, {
   3.5962111378015213`*^9, 3.596211143639701*^9}, 3.596211764959023*^9, {
   3.596505332328547*^9, 3.59650533439809*^9}, 3.5965432340464354`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<xi\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
    "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<_\>\"", "<>", "t", 
     "<>", "\"\<.dat\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"intData", " ", "=", " ", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Riffle", "[", 
      RowBox[{
       RowBox[{"rawData", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
       RowBox[{"rawData", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "3"}], "]"}], "]"}]}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myInt1", " ", "=", " ", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"intData", ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"range", " ", "=", " ", 
    RowBox[{"Max", "[", 
     RowBox[{"rawData", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plot1", " ", "=", " ", 
  RowBox[{"Plot3D", "[", 
   RowBox[{
    RowBox[{"myInt1", "[", 
     RowBox[{"x", ",", "y"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "var"}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Lighter", "[", 
      RowBox[{"Lighter", "[", "Blue", "]"}], "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.596211796362603*^9, 3.596211842605845*^9}, {
   3.596211901621965*^9, 3.596211906932805*^9}, {3.596211936934146*^9, 
   3.5962120067249002`*^9}, {3.596213596574868*^9, 3.5962136623609657`*^9}, {
   3.596213748225075*^9, 3.596213781422119*^9}, {3.5962140600660343`*^9, 
   3.5962140619530497`*^9}, {3.5962144508200493`*^9, 3.596214452746604*^9}, {
   3.596214652667364*^9, 3.596214652949778*^9}, {3.596214819701792*^9, 
   3.596214819812545*^9}, {3.596220953692124*^9, 3.596220953758472*^9}, {
   3.5962210631230383`*^9, 3.5962210631860943`*^9}, {3.596221443300435*^9, 
   3.59622144520455*^9}, {3.596384992506332*^9, 3.596385024464295*^9}, {
   3.596385093273389*^9, 3.596385093631531*^9}, {3.596543266767435*^9, 
   3.596543274215302*^9}, {3.596675139605852*^9, 3.596675141588522*^9}, {
   3.597099279924872*^9, 3.5970992883984413`*^9}, {3.5970993501504087`*^9, 
   3.597099354864688*^9}, {3.597099408717532*^9, 3.5970994142115097`*^9}, {
   3.5970996935216007`*^9, 3.59709971386893*^9}, {3.59709974847493*^9, 
   3.597099784528632*^9}, 3.59710774931124*^9, {3.597140906691854*^9, 
   3.597140921042119*^9}, 3.597141047108739*^9, {3.597513706653132*^9, 
   3.5975137069490833`*^9}}],

Cell[BoxData[
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"myInt1", "[", 
     RowBox[{"x", ",", "0"}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.597099120690527*^9, {3.5970994922463093`*^9, 3.597099493437904*^9}, {
   3.597099544027442*^9, 3.597099553269986*^9}, 3.597099730787793*^9, {
   3.597398587498829*^9, 3.5973985906524477`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["aHydro3p1 - xi ", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
   3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
   3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
   3.596069566028297*^9, 3.596069574396153*^9}, {3.596073008790386*^9, 
   3.59607301699444*^9}, 3.596505149010524*^9, {3.5965053473433237`*^9, 
   3.596505348885892*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "dataDir", " ", "=", 
   "\"\</Users/michael/Documents/code/aHydro3p1/output/tsv/test\>\""}], 
  ";"}]], "Input"],

Cell[CellGroupData[{

Cell["Import Data", "Subsection",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.5960695624935637`*^9, 3.596069564541923*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<xi\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"var", "\[Equal]", "\"\<lambda\>\""}], ",", 
    RowBox[{"fac", "=", "hbarc"}], ",", 
    RowBox[{"fac", "=", "1"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
    "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<_z_0.tsv\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"range", " ", "=", " ", 
   RowBox[{"Max", "[", 
    RowBox[{"rawData", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.596069512661998*^9, 3.59606952063155*^9}, {
   3.5960695511340427`*^9, 3.596069552135378*^9}, {3.5960695890000362`*^9, 
   3.596069601784707*^9}, 3.5960730383608828`*^9, {3.5960736803274937`*^9, 
   3.596073683999836*^9}, {3.596073836515772*^9, 3.5960739310848103`*^9}, {
   3.596074984975366*^9, 3.596075038716188*^9}, {3.596079980914237*^9, 
   3.596079983247178*^9}, {3.596193501725919*^9, 3.5961935231901484`*^9}, 
   3.5961936025489187`*^9, {3.596193854094726*^9, 3.596193854580999*^9}, {
   3.596209549140502*^9, 3.596209551564127*^9}, {3.596209592659112*^9, 
   3.5962095946035547`*^9}, {3.596505071270359*^9, 3.5965050970940723`*^9}, {
   3.596505207186119*^9, 3.596505207457259*^9}, {3.597141079230278*^9, 
   3.5971410801091413`*^9}, {3.597141118037284*^9, 3.5971411213557043`*^9}, {
   3.5975137163583117`*^9, 3.597513720333933*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iniFileName", " ", "=", " ", "\"\<../../bin/test/test.ini\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
     "\"\<XPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
     "\"\<YPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nt", " ", "=", " ", 
   RowBox[{"XPts", "*", "YPts"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"np", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.597110052394505*^9, 3.597110120052286*^9}, {
  3.597112244919615*^9, 3.5971122602963543`*^9}, {3.5971123029344254`*^9, 
  3.597112364391485*^9}, {3.597141007182068*^9, 3.597141022238804*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"rawData", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"nt", "*", "i"}]}], ";;", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"int", "[", "i", "]"}], " ", "=", " ", 
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Riffle", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"slice", "[", "i", "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
           RowBox[{"fac", "*", 
            RowBox[{
             RowBox[{"slice", "[", "i", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "3"}], "]"}], "]"}]}]}], "]"}], ",", "2"}], 
        "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "np"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.596122444384178*^9, 3.5961225188417387`*^9}, {
  3.596129333536104*^9, 3.5961293337051077`*^9}, {3.5965052283173933`*^9, 
  3.596505271101028*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Show Data", "Subsection",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.5960695624935637`*^9, 3.596069564541923*^9}, {3.596069655557906*^9, 
  3.596069658580268*^9}, {3.596069797595901*^9, 3.596069798569024*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotvars", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "i", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "np"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{"plotvars", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.596079852476934*^9, 3.5960798648749313`*^9}, {
   3.5961227314499607`*^9, 3.596122733416498*^9}, {3.5961228572629547`*^9, 
   3.596122885428877*^9}, {3.596122934057198*^9, 3.5961229752736273`*^9}, {
   3.596166174647422*^9, 3.596166175007278*^9}, {3.5961936981382627`*^9, 
   3.5961937105953836`*^9}, {3.596193865749256*^9, 3.596193866071891*^9}, {
   3.59619423579206*^9, 3.596194263998372*^9}, {3.596505239219718*^9, 
   3.596505242722176*^9}, {3.596505878682946*^9, 3.596505882112939*^9}, {
   3.596511882546474*^9, 3.596511883153041*^9}, {3.596543531730085*^9, 
   3.596543532960619*^9}, 3.596543898921328*^9, {3.597017020642952*^9, 
   3.5970170209821672`*^9}, {3.597017791846404*^9, 3.597017794498592*^9}, {
   3.5970181246957693`*^9, 3.597018130291153*^9}, {3.597023982268283*^9, 
   3.597023982602724*^9}, 3.597109945795363*^9, {3.597141171903178*^9, 
   3.597141177007288*^9}}],

Cell[BoxData[
 RowBox[{"plot2", "=", 
  RowBox[{"Plot3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"int", "[", "np", "]"}], "[", 
      RowBox[{"x", ",", "y"}], "]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"Lighter", "[", 
        RowBox[{"Lighter", "[", "Red", "]"}], "]"}], ",", 
       RowBox[{"Specularity", "[", 
        RowBox[{"Orange", ",", "10"}], "]"}], ",", 
       RowBox[{"Opacity", "[", "1", "]"}]}], "]"}]}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "60"}], ",", 
    RowBox[{"MeshStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Opacity", "[", "0.5", "]"}], "}"}]}], ",", 
    RowBox[{"Mesh", "\[Rule]", "16"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.596075574638094*^9, 3.59607559322164*^9}, {
   3.596075637302088*^9, 3.5960756420607862`*^9}, {3.596075709652191*^9, 
   3.596075828009963*^9}, {3.596075941280859*^9, 3.596075941515025*^9}, {
   3.5960759904166193`*^9, 3.5960759906319017`*^9}, {3.596076108431444*^9, 
   3.596076200149984*^9}, {3.596076667057324*^9, 3.596076667854683*^9}, {
   3.5960767059305468`*^9, 3.596076763234857*^9}, {3.596076872508143*^9, 
   3.596076882575554*^9}, {3.5961142980430813`*^9, 3.596114358099599*^9}, {
   3.5961143955155983`*^9, 3.596114570428102*^9}, {3.596114668241577*^9, 
   3.596114762685286*^9}, {3.5961293535812073`*^9, 3.5961293544118757`*^9}, {
   3.5961294156897583`*^9, 3.596129430359344*^9}, {3.5961661531197443`*^9, 
   3.596166157483634*^9}, {3.5965051230849743`*^9, 3.596505127520701*^9}, 
   3.596505165555174*^9, {3.596505281042363*^9, 3.596505287260729*^9}, {
   3.596511890018981*^9, 3.5965118927774754`*^9}, {3.5965123545758257`*^9, 
   3.59651235495041*^9}, {3.596543783116849*^9, 3.596543783419321*^9}, 
   3.596543903624839*^9, {3.5970239952500067`*^9, 3.597023995640244*^9}, {
   3.597141187284416*^9, 3.597141189439184*^9}}],

Cell[BoxData[
 RowBox[{"DensityPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Log", "[", 
     RowBox[{"10", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"int", "[", "np", "]"}], "[", 
        RowBox[{"x", ",", "y"}], "]"}], "+", "1"}]}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"PlotPoints", "\[Rule]", "60"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<SunsetColors\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5974389036950274`*^9, 3.597438912653207*^9}, {
  3.597509017341552*^9, 3.5975090560598288`*^9}, {3.5975093397927*^9, 
  3.597509345876183*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Show", "[", 
   RowBox[{"plot1", ",", "plot2"}], "]"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5965051796331587`*^9, 3.596505184632534*^9}, {
  3.597509536635552*^9, 3.597509539168128*^9}}],

Cell[BoxData[
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"int", "[", "np", "]"}], "[", 
     RowBox[{"0", ",", "y"}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5970240413114347`*^9, 3.597024057540944*^9}, {
   3.597024174932438*^9, 3.5970241893166037`*^9}, {3.5970242850436497`*^9, 
   3.597024286899461*^9}, {3.597093785530567*^9, 3.5970937972702017`*^9}, {
   3.597093933105801*^9, 3.597093933383871*^9}, {3.597098868484033*^9, 
   3.59709887386163*^9}, {3.597107961134933*^9, 3.5971079663718243`*^9}, 
   3.597141203282485*^9, {3.597398058871685*^9, 3.597398085468626*^9}, {
   3.597398532956801*^9, 3.597398546227501*^9}, {3.5973986065314703`*^9, 
   3.597398607505125*^9}, {3.597398643290888*^9, 3.597398644161522*^9}, {
   3.597398727550724*^9, 3.5973987454922447`*^9}, {3.597399512266295*^9, 
   3.597399519571719*^9}, {3.597399611627735*^9, 3.597399611899472*^9}, {
   3.59739970143097*^9, 3.597399708285738*^9}, {3.5973998212170553`*^9, 
   3.597399831367679*^9}, {3.597400002902885*^9, 3.5974000080384083`*^9}, {
   3.597400273907221*^9, 3.597400277706977*^9}, {3.5974384049611607`*^9, 
   3.597438405103032*^9}, {3.597501726381873*^9, 3.597501741707983*^9}, {
   3.597501787319709*^9, 3.597501791944166*^9}, {3.597501883864649*^9, 
   3.597501886340022*^9}, {3.597502521025172*^9, 3.5975025375191603`*^9}, {
   3.597509127144341*^9, 3.597509133935182*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"LogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "np", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}], ",", 
      RowBox[{"myInt1", "[", 
       RowBox[{"x", ",", "0"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5970240413114347`*^9, 3.597024057540944*^9}, {
   3.597024174932438*^9, 3.5970241893166037`*^9}, {3.5970242850436497`*^9, 
   3.597024286899461*^9}, {3.597093785530567*^9, 3.5970937972702017`*^9}, {
   3.597093933105801*^9, 3.597093933383871*^9}, {3.597098868484033*^9, 
   3.59709887386163*^9}, {3.597107961134933*^9, 3.5971079663718243`*^9}, 
   3.597141203282485*^9, {3.597398058871685*^9, 3.597398085468626*^9}, {
   3.597398532956801*^9, 3.597398546227501*^9}, {3.5973986065314703`*^9, 
   3.597398607505125*^9}, {3.597398643290888*^9, 3.597398644161522*^9}, {
   3.597398727550724*^9, 3.5973987454922447`*^9}, {3.597399512266295*^9, 
   3.597399519571719*^9}, {3.597399611627735*^9, 3.597399611899472*^9}, {
   3.59739970143097*^9, 3.597399708285738*^9}, {3.5973998212170553`*^9, 
   3.597399831367679*^9}, {3.597400002902885*^9, 3.5974000080384083`*^9}, {
   3.597400273907221*^9, 3.597400277706977*^9}, {3.597509151322432*^9, 
   3.59750915169473*^9}, {3.5975095425368643`*^9, 3.597509546125404*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["aHydro3p1 - lambda ", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
   3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
   3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
   3.596069566028297*^9, 3.596069574396153*^9}, {3.596073008790386*^9, 
   3.59607301699444*^9}, 3.596505149010524*^9, {3.5965053473433237`*^9, 
   3.596505348885892*^9}, {3.597142437856978*^9, 3.5971424396638193`*^9}}],

Cell[CellGroupData[{

Cell["Import Data", "Subsection",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.5960695624935637`*^9, 3.596069564541923*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<lambda\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"var", "\[Equal]", "\"\<lambda\>\""}], ",", 
    RowBox[{"fac", "=", "hbarc"}], ",", 
    RowBox[{"fac", "=", "1"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
    "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<_z_0.tsv\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"range", " ", "=", " ", 
   RowBox[{"Max", "[", 
    RowBox[{"rawData", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.596069512661998*^9, 3.59606952063155*^9}, {
   3.5960695511340427`*^9, 3.596069552135378*^9}, {3.5960695890000362`*^9, 
   3.596069601784707*^9}, 3.5960730383608828`*^9, {3.5960736803274937`*^9, 
   3.596073683999836*^9}, {3.596073836515772*^9, 3.5960739310848103`*^9}, {
   3.596074984975366*^9, 3.596075038716188*^9}, {3.596079980914237*^9, 
   3.596079983247178*^9}, {3.596193501725919*^9, 3.5961935231901484`*^9}, 
   3.5961936025489187`*^9, {3.596193854094726*^9, 3.596193854580999*^9}, {
   3.596209549140502*^9, 3.596209551564127*^9}, {3.596209592659112*^9, 
   3.5962095946035547`*^9}, {3.596505071270359*^9, 3.5965050970940723`*^9}, {
   3.596505207186119*^9, 3.596505207457259*^9}, {3.597141079230278*^9, 
   3.5971410801091413`*^9}, {3.597141118037284*^9, 3.5971411213557043`*^9}, {
   3.597142474306449*^9, 3.597142475265626*^9}, 3.59751372737746*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iniFileName", " ", "=", " ", "\"\<../../bin/test/test.ini\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
     "\"\<XPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
     "\"\<YPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nt", " ", "=", " ", 
   RowBox[{"XPts", "*", "YPts"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"np", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.597110052394505*^9, 3.597110120052286*^9}, {
  3.597112244919615*^9, 3.5971122602963543`*^9}, {3.5971123029344254`*^9, 
  3.597112364391485*^9}, {3.597141007182068*^9, 3.597141022238804*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"rawData", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"nt", "*", "i"}]}], ";;", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"int", "[", "i", "]"}], " ", "=", " ", 
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Riffle", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"slice", "[", "i", "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
           RowBox[{"fac", "*", 
            RowBox[{
             RowBox[{"slice", "[", "i", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "3"}], "]"}], "]"}]}]}], "]"}], ",", "2"}], 
        "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "np"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.596122444384178*^9, 3.5961225188417387`*^9}, {
  3.596129333536104*^9, 3.5961293337051077`*^9}, {3.5965052283173933`*^9, 
  3.596505271101028*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Show Data", "Subsection",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.5960695624935637`*^9, 3.596069564541923*^9}, {3.596069655557906*^9, 
  3.596069658580268*^9}, {3.596069797595901*^9, 3.596069798569024*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotvars", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "i", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "np"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{"plotvars", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.596079852476934*^9, 3.5960798648749313`*^9}, {
   3.5961227314499607`*^9, 3.596122733416498*^9}, {3.5961228572629547`*^9, 
   3.596122885428877*^9}, {3.596122934057198*^9, 3.5961229752736273`*^9}, {
   3.596166174647422*^9, 3.596166175007278*^9}, {3.5961936981382627`*^9, 
   3.5961937105953836`*^9}, {3.596193865749256*^9, 3.596193866071891*^9}, {
   3.59619423579206*^9, 3.596194263998372*^9}, {3.596505239219718*^9, 
   3.596505242722176*^9}, {3.596505878682946*^9, 3.596505882112939*^9}, {
   3.596511882546474*^9, 3.596511883153041*^9}, {3.596543531730085*^9, 
   3.596543532960619*^9}, 3.596543898921328*^9, {3.597017020642952*^9, 
   3.5970170209821672`*^9}, {3.597017791846404*^9, 3.597017794498592*^9}, {
   3.5970181246957693`*^9, 3.597018130291153*^9}, {3.597023982268283*^9, 
   3.597023982602724*^9}, 3.597109945795363*^9, {3.597141171903178*^9, 
   3.597141177007288*^9}}],

Cell[BoxData[
 RowBox[{"plot2", "=", 
  RowBox[{"Plot3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"int", "[", "np", "]"}], "[", 
      RowBox[{"x", ",", "y"}], "]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"Lighter", "[", 
        RowBox[{"Lighter", "[", "Red", "]"}], "]"}], ",", 
       RowBox[{"Specularity", "[", 
        RowBox[{"Orange", ",", "10"}], "]"}], ",", 
       RowBox[{"Opacity", "[", "1", "]"}]}], "]"}]}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "60"}], ",", 
    RowBox[{"MeshStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Opacity", "[", "0.5", "]"}], "}"}]}], ",", 
    RowBox[{"Mesh", "\[Rule]", "16"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.596075574638094*^9, 3.59607559322164*^9}, {
   3.596075637302088*^9, 3.5960756420607862`*^9}, {3.596075709652191*^9, 
   3.596075828009963*^9}, {3.596075941280859*^9, 3.596075941515025*^9}, {
   3.5960759904166193`*^9, 3.5960759906319017`*^9}, {3.596076108431444*^9, 
   3.596076200149984*^9}, {3.596076667057324*^9, 3.596076667854683*^9}, {
   3.5960767059305468`*^9, 3.596076763234857*^9}, {3.596076872508143*^9, 
   3.596076882575554*^9}, {3.5961142980430813`*^9, 3.596114358099599*^9}, {
   3.5961143955155983`*^9, 3.596114570428102*^9}, {3.596114668241577*^9, 
   3.596114762685286*^9}, {3.5961293535812073`*^9, 3.5961293544118757`*^9}, {
   3.5961294156897583`*^9, 3.596129430359344*^9}, {3.5961661531197443`*^9, 
   3.596166157483634*^9}, {3.5965051230849743`*^9, 3.596505127520701*^9}, 
   3.596505165555174*^9, {3.596505281042363*^9, 3.596505287260729*^9}, {
   3.596511890018981*^9, 3.5965118927774754`*^9}, {3.5965123545758257`*^9, 
   3.59651235495041*^9}, {3.596543783116849*^9, 3.596543783419321*^9}, 
   3.596543903624839*^9, {3.5970239952500067`*^9, 3.597023995640244*^9}, {
   3.597141187284416*^9, 3.597141189439184*^9}}],

Cell[BoxData[
 RowBox[{"DensityPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"int", "[", "np", "]"}], "[", 
     RowBox[{"x", ",", "y"}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"PlotPoints", "\[Rule]", "60"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<SunsetColors\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5974389036950274`*^9, 3.597438912653207*^9}, {
  3.597509017341552*^9, 3.5975090560598288`*^9}, {3.5975095882196617`*^9, 
  3.5975095974097633`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Show", "[", 
   RowBox[{"plot1", ",", "plot2"}], "]"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5965051796331587`*^9, 3.596505184632534*^9}, {
  3.597509604363975*^9, 3.597509607126006*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"LogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "np", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}], ",", 
      RowBox[{"myInt1", "[", 
       RowBox[{"x", ",", "0"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5970240413114347`*^9, 3.597024057540944*^9}, {
   3.597024174932438*^9, 3.5970241893166037`*^9}, {3.5970242850436497`*^9, 
   3.597024286899461*^9}, {3.597093785530567*^9, 3.5970937972702017`*^9}, {
   3.597093933105801*^9, 3.597093933383871*^9}, {3.597098868484033*^9, 
   3.59709887386163*^9}, {3.597107961134933*^9, 3.5971079663718243`*^9}, 
   3.597141203282485*^9, {3.597142512629218*^9, 3.597142538394929*^9}, {
   3.597509613585102*^9, 3.597509616427614*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"int", "[", "np", "]"}], "[", 
    RowBox[{"x", ",", "0"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.597509625456251*^9, 3.597509631747158*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{852, 950},
WindowMargins->{{97, Automatic}, {Automatic, 1}},
ShowSelection->True,
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 220, 3, 80, "Section"],
Cell[802, 27, 151, 3, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[990, 35, 225, 3, 80, "Section"],
Cell[1218, 40, 600, 12, 28, "Input"],
Cell[1821, 54, 149, 5, 28, "Input"],
Cell[CellGroupData[{
Cell[1995, 63, 241, 3, 44, "Subsection"],
Cell[2239, 68, 2865, 69, 165, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5141, 142, 240, 3, 44, "Subsection"],
Cell[5384, 147, 3147, 73, 148, "Input"],
Cell[8534, 222, 529, 13, 28, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9112, 241, 424, 6, 80, "Section"],
Cell[9539, 249, 150, 5, 28, "Input"],
Cell[CellGroupData[{
Cell[9714, 258, 299, 4, 44, "Subsection"],
Cell[10016, 264, 1584, 33, 80, "Input"],
Cell[11603, 299, 1067, 27, 97, "Input"],
Cell[12673, 328, 1546, 45, 80, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14256, 378, 392, 5, 44, "Subsection"],
Cell[14651, 385, 1438, 29, 46, "Input"],
Cell[16092, 416, 2195, 44, 63, "Input"],
Cell[18290, 462, 849, 23, 46, "Input"],
Cell[19142, 487, 241, 5, 28, "Input"],
Cell[19386, 494, 1565, 27, 28, "Input"],
Cell[20954, 523, 1504, 28, 28, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22507, 557, 476, 6, 80, "Section"],
Cell[CellGroupData[{
Cell[23008, 567, 299, 4, 44, "Subsection"],
Cell[23310, 573, 1607, 33, 80, "Input"],
Cell[24920, 608, 1067, 27, 97, "Input"],
Cell[25990, 637, 1546, 45, 80, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27573, 687, 392, 5, 44, "Subsection"],
Cell[27968, 694, 1438, 29, 46, "Input"],
Cell[29409, 725, 2195, 44, 63, "Input"],
Cell[31607, 771, 760, 20, 46, "Input"],
Cell[32370, 793, 241, 5, 28, "Input"],
Cell[32614, 800, 962, 21, 28, "Input"],
Cell[33579, 823, 371, 10, 28, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
