(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     94583,       2342]
NotebookOptionsPosition[     90493,       2207]
NotebookOutlinePosition[     90950,       2225]
CellTagsIndexPosition[     90907,       2222]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Import", "[", 
  RowBox[{
   RowBox[{"ParentDirectory", "[", 
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "<>", 
   "\"\</output/bin/runs\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.6152182993791933`*^9, 3.615218316241405*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Import", "::", "nffil"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"File not found during \[NoBreak]\\!\\(Import\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Import/nffil\\\", \
ButtonNote -> \\\"Import::nffil\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.652193132028442*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.615218316702162*^9, 3.6152193061995707`*^9, 
  3.652193132029698*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"name", "=", "\"\<3E25BA4A\>\""}], ";"}]], "Input",
 CellChangeTimes->{3.652193144497303*^9}],

Cell[CellGroupData[{

Cell["Setup and Definitions", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"dataDir", " ", "=", 
     RowBox[{
      RowBox[{"ParentDirectory", "[", 
       RowBox[{"ParentDirectory", "[", 
        RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "<>", 
      "\"\</output/bin/\>\"", "<>", "name"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"iniFileName", " ", "=", " ", 
     RowBox[{"\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.596668567479659*^9, 3.596668568133739*^9}, {
   3.596674569561119*^9, 3.596674579672914*^9}, {3.596675495907507*^9, 
   3.596675496738446*^9}, 3.597487205612895*^9, {3.5987127519180937`*^9, 
   3.598712823405628*^9}, 3.598712877549583*^9, {3.6152183246047897`*^9, 
   3.6152183638708477`*^9}, 3.615219312744348*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"hbarc", "=", "0.197326938"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"wd", " ", "=", 
   RowBox[{"SetDirectory", "@", 
    RowBox[{"NotebookDirectory", "[", "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{3.59749963947488*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"R", "[", "xi_", "]"}], "=", 
   RowBox[{
    RowBox[{"1", "/", "2"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"1", "+", "xi"}], ")"}]}], " ", "+", " ", 
      RowBox[{
       RowBox[{"ArcTan", "[", 
        RowBox[{"Sqrt", "[", "xi", "]"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", "xi", "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rt", "[", "xi_", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"3", "/", 
     RowBox[{"(", 
      RowBox[{"2", "xi"}], ")"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", " ", "+", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xi", "^", "2"}], "-", "1"}], ")"}], 
        RowBox[{"R", "[", "xi", "]"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "+", "xi"}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rl", "[", "xi_", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"3", "/", "xi"}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", "xi"}], ")"}], 
        RowBox[{"R", "[", "xi", "]"}]}], "-", "1"}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "+", "xi"}], ")"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.48524461277042*^9, 3.485244615518735*^9}, {
  3.485245410156925*^9, 3.4852454154429817`*^9}, {3.485602216587295*^9, 
  3.485602227988896*^9}, {3.532627493531522*^9, 3.532627495010388*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Import params from ini file", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.59749233530936*^9, 3.597492348795422*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"iniFile", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}], ",", 
     "\"\<XPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}], ",", 
     "\"\<YPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}], ",", 
     "\"\<ZPts\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}], ",", 
     "\"\<XSpacing\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}], ",", 
     "\"\<YSpacing\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToExpression", "[", 
   RowBox[{"FindList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "name", "<>", "\"\<.ini\>\""}], ",", 
     "\"\<ZSpacing\>\""}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Importing Variables From INI File\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<{XPts,YPts,ZPts} = \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"{", 
      RowBox[{"XPts", ",", "YPts", ",", "ZPts"}], "}"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<{XSpacing,YSpacing,YSpacing} = \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"{", 
      RowBox[{"XSpacing", ",", "YSpacing", ",", "YSpacing"}], "}"}], "]"}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Lx", "=", 
     RowBox[{"XPts", "*", "XSpacing"}]}], ",", 
    RowBox[{"Ly", "=", 
     RowBox[{"YPts", "*", "YSpacing"}]}], ",", 
    RowBox[{"Lz", "=", 
     RowBox[{"ZPts", "*", "ZSpacing"}]}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nt", " ", "=", " ", 
    RowBox[{"XPts", "*", "YPts", "*", "ZPts"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Print", "[", "\"\<Creating Grid\>\"", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"pts", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"XSpacing", "*", 
              RowBox[{"(", 
               RowBox[{"i", "-", 
                RowBox[{"1", "/", "2"}]}], ")"}]}], "-", " ", 
             RowBox[{"Lx", "/", "2"}]}], ",", 
            RowBox[{
             RowBox[{"YSpacing", "*", 
              RowBox[{"(", 
               RowBox[{"j", "-", 
                RowBox[{"1", "/", "2"}]}], ")"}]}], " ", "-", " ", 
             RowBox[{"Ly", "/", "2"}]}], ",", 
            RowBox[{
             RowBox[{"ZSpacing", "*", 
              RowBox[{"(", 
               RowBox[{"k", "-", 
                RowBox[{"1", "/", "2"}]}], ")"}]}], "-", " ", 
             RowBox[{"Lz", "/", "2"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "100"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", "100"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "1", ",", "100"}], "}"}]}], "]"}], "]"}], ",", 
       "3"}], "]"}]}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5966749816712837`*^9, 3.5966749820070477`*^9}, {
  3.5966755317992563`*^9, 3.596675549360551*^9}, {3.597487502702009*^9, 
  3.597487512668762*^9}, {3.597499750422509*^9, 3.597499810417509*^9}, {
  3.597499844868307*^9, 3.5974998453931427`*^9}, {3.615219401495696*^9, 
  3.615219418586918*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Importing Variables From INI File\"\>"], "Print",
 CellChangeTimes->{3.598712835890421*^9, 3.613918270642055*^9, 
  3.6152183695603743`*^9, 3.615219321935216*^9, 3.6152194194094152`*^9, 
  3.652193151580613*^9}],

Cell[BoxData["\<\"{XPts,YPts,ZPts} = {100, 100, 100}\"\>"], "Print",
 CellChangeTimes->{3.598712835890421*^9, 3.613918270642055*^9, 
  3.6152183695603743`*^9, 3.615219321935216*^9, 3.6152194194094152`*^9, 
  3.652193151582012*^9}],

Cell[BoxData["\<\"{XSpacing,YSpacing,YSpacing} = {0.2, 0.2, 0.2}\"\>"], \
"Print",
 CellChangeTimes->{3.598712835890421*^9, 3.613918270642055*^9, 
  3.6152183695603743`*^9, 3.615219321935216*^9, 3.6152194194094152`*^9, 
  3.6521931515836*^9}],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{3.598712835890421*^9, 3.613918270642055*^9, 
  3.6152183695603743`*^9, 3.615219321935216*^9, 3.6152194194094152`*^9, 
  3.652193151585058*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Render 3d volume - Lambda (new)\
\>", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.5974923293037357`*^9, 3.597492332427025*^9}, {
  3.597511794591144*^9, 3.597511795781822*^9}, {3.652193170275528*^9, 
  3.652193171489547*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<ax\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Reading Data\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<.bin\>\""}], ",", 
     "\"\<Real32\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", " ", "=", " ", 
   RowBox[{"Max", "[", "rawData", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.596672824939918*^9, 3.596672866215172*^9}, 
   3.596673046127954*^9, {3.596674531981619*^9, 3.596674552381793*^9}, {
   3.5966749945047493`*^9, 3.596674997783239*^9}, {3.596675210520149*^9, 
   3.596675253622038*^9}, 3.5966754166660624`*^9, {3.59667553688673*^9, 
   3.5966755945474787`*^9}, {3.596675648249877*^9, 3.5966756483511057`*^9}, {
   3.596675710293535*^9, 3.596675712843453*^9}, {3.59667811444718*^9, 
   3.596678120528205*^9}, {3.59667984114441*^9, 3.596679841877277*^9}, {
   3.5969850847210407`*^9, 3.59698508553067*^9}, {3.59701647869418*^9, 
   3.5970164790367403`*^9}, {3.597487271691505*^9, 3.597487316997909*^9}, {
   3.597487520802096*^9, 3.597487534637588*^9}, {3.597488164603915*^9, 
   3.5974881987379837`*^9}, {3.597488318009859*^9, 3.597488318259902*^9}, {
   3.597490516701819*^9, 3.5974905236163397`*^9}, 3.597490607329743*^9, {
   3.59749064244622*^9, 3.597490646410692*^9}, {3.597511311112033*^9, 
   3.5975113566151657`*^9}, {3.59871288851062*^9, 3.598712888925363*^9}, {
   3.613918299962022*^9, 3.613918301656481*^9}, {3.615218749386503*^9, 
   3.615218749729012*^9}, {3.6521931757074823`*^9, 3.65219317848354*^9}, {
   3.6521932256117687`*^9, 3.652193225922257*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Reading Data\"\>"], "Print",
 CellChangeTimes->{{3.5987128623350782`*^9, 3.598712889330928*^9}, {
   3.613918270691946*^9, 3.6139183044794693`*^9}, {3.6152187468889723`*^9, 
   3.615218750115058*^9}, 3.615219347647725*^9, 3.615219422187407*^9, 
   3.652193179972052*^9, 3.6521932275422983`*^9}],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{{3.5987128623350782`*^9, 3.598712889330928*^9}, {
   3.613918270691946*^9, 3.6139183044794693`*^9}, {3.6152187468889723`*^9, 
   3.615218750115058*^9}, 3.615219347647725*^9, 3.615219422187407*^9, 
   3.652193179972052*^9, 3.6521932275940943`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Imported \>\"", "<>", 
   RowBox[{"ToString", "[", 
    RowBox[{"np", "+", "1"}], "]"}], "<>", "\"\< time slices\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{"rawData", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"nt", "*", "i"}]}], ";;", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}]}], 
  "     ", 
  RowBox[{"(*", " ", 
   RowBox[{"i", " ", "=", " ", 
    RowBox[{"0", " ", "\[Rule]", " ", "np"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vals", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"Partition", "[", " ", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"slice", "[", "i", "]"}], ",", "XPts"}], "]"}], ",", "YPts"}], 
    "]"}], "/", "max"}]}]}], "Input",
 CellChangeTimes->{{3.5974906100887213`*^9, 3.59749063104626*^9}, {
   3.597490884786809*^9, 3.597490944029231*^9}, {3.597491248500845*^9, 
   3.597491301263914*^9}, {3.597492902058387*^9, 3.5974929055457077`*^9}, {
   3.597501351032816*^9, 3.597501359975918*^9}, {3.597510424061507*^9, 
   3.597510424245982*^9}, {3.5975112405009117`*^9, 3.5975112412193317`*^9}, {
   3.597511372220533*^9, 3.597511375626848*^9}, 3.597562799194271*^9, 
   3.5975630229185667`*^9}],

Cell[BoxData["\<\"Imported 2 time slices\"\>"], "Print",
 CellChangeTimes->{
  3.598712902331249*^9, {3.613918270872656*^9, 3.613918304828938*^9}, {
   3.615218747107201*^9, 3.6152187584845533`*^9}, 3.615219371009219*^9, 
   3.615219429573599*^9, 3.6521931819258842`*^9, 3.652193228730598*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "max", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{"Max", "[", 
   RowBox[{"slice", "[", "i", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vals", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"Partition", "[", " ", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"slice", "[", "i", "]"}], ",", "XPts"}], "]"}], ",", "YPts"}], 
    "]"}], "/", 
   RowBox[{"max", "[", "i", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.597563005166265*^9, 3.5975630467353477`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0.00688365"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", 
              "0.106195"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.66", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.66234"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.5961654302334013`*^9, 3.596165436524679*^9}, {
  3.596165584832552*^9, 3.596165588503154*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Tuned", " ", "1", "\[IndentingNewLine]", "cf"}], "=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Blend", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "0.953384", ",", " ", "1.", ",", " ", "0.915618", ",", " ", 
               "0."}], "]"}]}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"0.218264", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "0.935393", ",", " ", "0.37023", ",", " ", "0.173083", ",", " ",
                "0."}], "]"}]}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"0.66", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
               "0.66234"}], "]"}]}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"1.", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}],
               "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
      " ", ")"}]}], ";"}], "*)"}], " "}]], "Input",
 CellChangeTimes->{{3.596165210215095*^9, 3.5961652170806093`*^9}, 
   3.5961655303308687`*^9, {3.596165602480178*^9, 3.59616560591861*^9}, {
   3.597491455379321*^9, 3.5974914566579638`*^9}, {3.59751043910571*^9, 
   3.5975104482074137`*^9}, {3.597511403261318*^9, 3.59751140631996*^9}, 
   3.597511497710903*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Tuned", " ", "2"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0."}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.0516456", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", "0."}], 
             "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.327323", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.274958"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.597511499547318*^9, 3.5975115108364487`*^9}, 
   3.597511565251265*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Tuned", " ", "3"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0."}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.0516456", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", "0."}], 
             "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.309146", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.26847"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.", ",", " ", "0.", ",", " ", "0.653696", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.59756339552207*^9, 3.597563405233819*^9}, {
   3.615218840526845*^9, 3.6152188564866056`*^9}, 3.6152193433886557`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"img", "[", "i_", "]"}], ":=", 
  RowBox[{"Image3D", "[", 
   RowBox[{
    RowBox[{"vals", "[", "i", "]"}], ",", 
    RowBox[{"ClipRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ZPts", "/", "2"}], ",", "ZPts"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"YPts", "/", "2"}], ",", "0"}], "}"}], ",", "All"}], "}"}]}],
     ",", 
    RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5974909457613583`*^9, 3.597490977028947*^9}, {
   3.5974910739840403`*^9, 3.59749107451075*^9}, {3.59749143132237*^9, 
   3.597491432030519*^9}, {3.5974929456975527`*^9, 3.597492976343258*^9}, {
   3.5974930279333887`*^9, 3.5974930339936533`*^9}, 3.597493373287657*^9, {
   3.597493473323586*^9, 3.5974934746031227`*^9}, {3.597499498109767*^9, 
   3.597499499034821*^9}, {3.597510518496359*^9, 3.597510524391694*^9}, {
   3.597511404556858*^9, 3.5975114090786467`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotrange", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"25", ",", "75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25", ",", "75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25", ",", "75"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"img", "[", "np", "]"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
   
   RowBox[{"PlotRange", "\[Rule]", "plotrange"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.597493389255402*^9, 3.597493400852713*^9}, {
  3.597494672972208*^9, 3.5974946733394957`*^9}, {3.597501366956215*^9, 
  3.59750136737152*^9}, {3.5975105367389917`*^9, 3.5975105558254843`*^9}, {
  3.597511525118513*^9, 3.5975115289129333`*^9}, {3.597511580750698*^9, 
  3.5975115811585913`*^9}, {3.59756282515047*^9, 3.597562830095276*^9}, {
  3.597563421707737*^9, 3.597563429334729*^9}, {3.597597608484479*^9, 
  3.59759760935596*^9}, {3.597604083388632*^9, 3.5976040905536947`*^9}, {
  3.5976073626776333`*^9, 3.5976073630521812`*^9}}],

Cell[BoxData[
 Graphics3DBox[Raster3DBox[CompressedData["
1:eJzsxUEJACAABMEDk5jEDkYQfVvdCD78GGIWlqlj91WSzO/XaSRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJkiRJ
kiRJkiRJkiRJkrztxTEJAAAAwKD+rZdjoI+2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2
bdu2bdu2bdu2bdu2bdu2bdu2bdu2bdu2bX8POJt7iQ==
   "], {{0, 0, 0}, {100, 100, 
   100}}, {0., 1.},
   ClipRange->{{50, 100}, {50, 0}, All},
   ColorFunction->(Blend[{{0., 
       RGBColor[0.05635, 0.081, 0.07687, 0.]}, {0.0516456, 
       RGBColor[0.8877, 0.2636, 0., 0.]}, {0.309146, 
       RGBColor[1., 0.9658, 0.4926, 0.26847]}, {1., 
       RGBColor[0., 0., 0.653696, 1.]}}, #]& ),
   Method->{"FastRendering" -> True}],
  AutomaticImageSize->True,
  Axes->True,
  AxesLabel->{
    FormBox["\"z\"", TraditionalForm], 
    FormBox["\"y\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->{381.20226711247346`, 405.8658904430721},
  PlotRange->{{25, 75}, {25, 75}, {25, 75}},
  ViewPoint->{1.7765852072108095`, -2.1325175814034507`, 1.9354879918317502`},
  
  ViewVertical->{0.024710423085851578`, -0.00998791680191824, 
   0.9996447551549883}]], "Output",
 CellChangeTimes->{3.652193190416523*^9, 3.652193236877718*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Render 3d volume - Lambda", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.5974923293037357`*^9, 3.597492332427025*^9}, {
  3.597511794591144*^9, 3.597511795781822*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<lnt\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Reading Data\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{
     RowBox[{
     "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<.bin\>\""}], ",", 
     "\"\<Real32\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", " ", "=", " ", 
   RowBox[{"Max", "[", "rawData", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.596672824939918*^9, 3.596672866215172*^9}, 
   3.596673046127954*^9, {3.596674531981619*^9, 3.596674552381793*^9}, {
   3.5966749945047493`*^9, 3.596674997783239*^9}, {3.596675210520149*^9, 
   3.596675253622038*^9}, 3.5966754166660624`*^9, {3.59667553688673*^9, 
   3.5966755945474787`*^9}, {3.596675648249877*^9, 3.5966756483511057`*^9}, {
   3.596675710293535*^9, 3.596675712843453*^9}, {3.59667811444718*^9, 
   3.596678120528205*^9}, {3.59667984114441*^9, 3.596679841877277*^9}, {
   3.5969850847210407`*^9, 3.59698508553067*^9}, {3.59701647869418*^9, 
   3.5970164790367403`*^9}, {3.597487271691505*^9, 3.597487316997909*^9}, {
   3.597487520802096*^9, 3.597487534637588*^9}, {3.597488164603915*^9, 
   3.5974881987379837`*^9}, {3.597488318009859*^9, 3.597488318259902*^9}, {
   3.597490516701819*^9, 3.5974905236163397`*^9}, 3.597490607329743*^9, {
   3.59749064244622*^9, 3.597490646410692*^9}, {3.597511311112033*^9, 
   3.5975113566151657`*^9}, {3.59871288851062*^9, 3.598712888925363*^9}, {
   3.613918299962022*^9, 3.613918301656481*^9}, {3.615218749386503*^9, 
   3.615218749729012*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Reading Data\"\>"], "Print",
 CellChangeTimes->{{3.5987128623350782`*^9, 3.598712889330928*^9}, {
   3.613918270691946*^9, 3.6139183044794693`*^9}, {3.6152187468889723`*^9, 
   3.615218750115058*^9}, 3.615219347647725*^9, 3.615219422187407*^9}],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{{3.5987128623350782`*^9, 3.598712889330928*^9}, {
   3.613918270691946*^9, 3.6139183044794693`*^9}, {3.6152187468889723`*^9, 
   3.615218750115058*^9}, 3.615219347647725*^9, 3.615219426446372*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Imported \>\"", "<>", 
   RowBox[{"ToString", "[", 
    RowBox[{"np", "+", "1"}], "]"}], "<>", "\"\< time slices\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{"rawData", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"nt", "*", "i"}]}], ";;", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}]}], 
  "     ", 
  RowBox[{"(*", " ", 
   RowBox[{"i", " ", "=", " ", 
    RowBox[{"0", " ", "\[Rule]", " ", "np"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vals", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"Partition", "[", " ", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"slice", "[", "i", "]"}], ",", "XPts"}], "]"}], ",", "YPts"}], 
    "]"}], "/", "max"}]}]}], "Input",
 CellChangeTimes->{{3.5974906100887213`*^9, 3.59749063104626*^9}, {
   3.597490884786809*^9, 3.597490944029231*^9}, {3.597491248500845*^9, 
   3.597491301263914*^9}, {3.597492902058387*^9, 3.5974929055457077`*^9}, {
   3.597501351032816*^9, 3.597501359975918*^9}, {3.597510424061507*^9, 
   3.597510424245982*^9}, {3.5975112405009117`*^9, 3.5975112412193317`*^9}, {
   3.597511372220533*^9, 3.597511375626848*^9}, 3.597562799194271*^9, 
   3.5975630229185667`*^9}],

Cell[BoxData["\<\"Imported 151 time slices\"\>"], "Print",
 CellChangeTimes->{
  3.598712902331249*^9, {3.613918270872656*^9, 3.613918304828938*^9}, {
   3.615218747107201*^9, 3.6152187584845533`*^9}, 3.615219371009219*^9, 
   3.615219429573599*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "max", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{"Max", "[", 
   RowBox[{"slice", "[", "i", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vals", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"Partition", "[", " ", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"slice", "[", "i", "]"}], ",", "XPts"}], "]"}], ",", "YPts"}], 
    "]"}], "/", 
   RowBox[{"max", "[", "i", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.597563005166265*^9, 3.5975630467353477`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0.00688365"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", 
              "0.106195"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.66", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.66234"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.5961654302334013`*^9, 3.596165436524679*^9}, {
  3.596165584832552*^9, 3.596165588503154*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Tuned", " ", "1", "\[IndentingNewLine]", "cf"}], "=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Blend", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "0.953384", ",", " ", "1.", ",", " ", "0.915618", ",", " ", 
               "0."}], "]"}]}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"0.218264", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "0.935393", ",", " ", "0.37023", ",", " ", "0.173083", ",", " ",
                "0."}], "]"}]}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"0.66", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
               "0.66234"}], "]"}]}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"1.", ",", " ", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
              "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}],
               "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
      " ", ")"}]}], ";"}], "*)"}], " "}]], "Input",
 CellChangeTimes->{{3.596165210215095*^9, 3.5961652170806093`*^9}, 
   3.5961655303308687`*^9, {3.596165602480178*^9, 3.59616560591861*^9}, {
   3.597491455379321*^9, 3.5974914566579638`*^9}, {3.59751043910571*^9, 
   3.5975104482074137`*^9}, {3.597511403261318*^9, 3.59751140631996*^9}, 
   3.597511497710903*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Tuned", " ", "2"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0."}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.0516456", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", "0."}], 
             "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.327323", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.274958"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.597511499547318*^9, 3.5975115108364487`*^9}, 
   3.597511565251265*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Tuned", " ", "3"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0."}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.0516456", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", "0."}], 
             "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.309146", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.26847"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.", ",", " ", "0.", ",", " ", "0.653696", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.59756339552207*^9, 3.597563405233819*^9}, {
   3.615218840526845*^9, 3.6152188564866056`*^9}, 3.6152193433886557`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"img", "[", "i_", "]"}], ":=", 
  RowBox[{"Image3D", "[", 
   RowBox[{
    RowBox[{"vals", "[", "i", "]"}], ",", 
    RowBox[{"ClipRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ZPts", "/", "2"}], ",", "ZPts"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"YPts", "/", "2"}], ",", "0"}], "}"}], ",", "All"}], "}"}]}],
     ",", 
    RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5974909457613583`*^9, 3.597490977028947*^9}, {
   3.5974910739840403`*^9, 3.59749107451075*^9}, {3.59749143132237*^9, 
   3.597491432030519*^9}, {3.5974929456975527`*^9, 3.597492976343258*^9}, {
   3.5974930279333887`*^9, 3.5974930339936533`*^9}, 3.597493373287657*^9, {
   3.597493473323586*^9, 3.5974934746031227`*^9}, {3.597499498109767*^9, 
   3.597499499034821*^9}, {3.597510518496359*^9, 3.597510524391694*^9}, {
   3.597511404556858*^9, 3.5975114090786467`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotrange", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"25", ",", "75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25", ",", "75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25", ",", "75"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"img", "[", "np", "]"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
   
   RowBox[{"PlotRange", "\[Rule]", "plotrange"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.597493389255402*^9, 3.597493400852713*^9}, {
  3.597494672972208*^9, 3.5974946733394957`*^9}, {3.597501366956215*^9, 
  3.59750136737152*^9}, {3.5975105367389917`*^9, 3.5975105558254843`*^9}, {
  3.597511525118513*^9, 3.5975115289129333`*^9}, {3.597511580750698*^9, 
  3.5975115811585913`*^9}, {3.59756282515047*^9, 3.597562830095276*^9}, {
  3.597563421707737*^9, 3.597563429334729*^9}, {3.597597608484479*^9, 
  3.59759760935596*^9}, {3.597604083388632*^9, 3.5976040905536947`*^9}, {
  3.5976073626776333`*^9, 3.5976073630521812`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"span\"\>"}], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\(\\(1 + \\(\\(XPts\\\\ YPts\\\
\\ \\(\\((\\(\\(-1\\)\\) + 151000000\\/\\(XPts\\\\ YPts\\\\ \
ZPts\\))\\)\\)\\\\ ZPts\\)\\)\\)\\) ;; 151000000\\), \\\"MT\\\"]\\)\[NoBreak]\
\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a valid Span specification. A Span \
specification should be 1, 2, or 3 integers separated by ;;. (Any of the \
integers can be omitted, or replaced with All.)\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Part\\\", ButtonNote -> \
\\\"Part::span\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.613918270961604*^9, 3.613918304917745*^9}, {
  3.615218747296994*^9, 3.615218758596208*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Partition", "::", "\<\"ilsmp\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Single or list of positive \
machine-size integers expected at position \\\\\\\"\\\", \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\!\\(2\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" of \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Partition[\\(\\(\\(\\(\\(\\({\
0.000014975534213590436`, 0.000018489752619643696`, 0.000022724676455254667`, \
0.000027793685148935765`, 0.000033823627745732665`, 0.00004095400799997151`, \
0.000049336085794493556`, 0.000059131754824193195`, 0.00007051194552332163`, \
\\(\\(\[LeftSkeleton] 33 \[RightSkeleton]\\)\\), 0.0013456812594085932`, \
0.0013456812594085932`, 0.0013456812594085932`, 0.0013456812594085932`, \
0.0013456812594085932`, 0.0013456812594085932`, 0.0013456812594085932`, \
0.0013456812594085932`, \\(\\(\[LeftSkeleton] 150999950 \
\[RightSkeleton]\\)\\)}\\)\\) \[LeftDoubleBracket] \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\) \[RightDoubleBracket]\\)\\), \\(\\(\[LeftSkeleton] 4 \
\[RightSkeleton]\\)\\)\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\".\\\\\\\"\\\", \\\"MT\\\
\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/ilsmp\\\", ButtonNote -> \
\\\"Partition::ilsmp\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.613918270961604*^9, 3.613918304917745*^9}, {
  3.615218747296994*^9, 3.615218761928832*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Partition", "::", "\<\"ilsmp\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Single or list of positive \
machine-size integers expected at position \\\\\\\"\\\", \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\!\\(2\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" of \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\".\\\\\\\"\\\", \\\"MT\\\
\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/ilsmp\\\", ButtonNote -> \
\\\"Partition::ilsmp\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.613918270961604*^9, 3.613918304917745*^9}, 
   3.615218747296994*^9, 3.6152188261687326`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"span\"\>"}], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\(\\(1 + \\(\\(XPts\\\\ YPts\\\
\\ \\(\\((\\(\\(-1\\)\\) + 151000000\\/\\(XPts\\\\ YPts\\\\ \
ZPts\\))\\)\\)\\\\ ZPts\\)\\)\\)\\) ;; 151000000\\), \\\"MT\\\"]\\)\[NoBreak]\
\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a valid Span specification. A Span \
specification should be 1, 2, or 3 integers separated by ;;. (Any of the \
integers can be omitted, or replaced with All.)\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Part\\\", ButtonNote -> \
\\\"Part::span\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.613918270961604*^9, 3.613918304917745*^9}, 
   3.615218747296994*^9, 3.615218868030669*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Render 3d volume - Xi", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.5974923293037357`*^9, 3.597492332427025*^9}, {
  3.597511794591144*^9, 3.597511795781822*^9}, {3.5975119870618258`*^9, 
  3.597512017000799*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"func", "[", "x_", "]"}], " ", "=", " ", 
   RowBox[{"Log", "[", 
    RowBox[{"1", "+", "x"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.597512080030925*^9, 3.597512106299238*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<xi\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Reading Data\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", "=", 
   RowBox[{"Map", "[", 
    RowBox[{"func", ",", 
     RowBox[{"BinaryReadList", "[", 
      RowBox[{
       RowBox[{
       "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<.bin\>\""}], 
       ",", "\"\<Real32\>\""}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", " ", "=", " ", 
   RowBox[{"Max", "[", "rawData", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.596672824939918*^9, 3.596672866215172*^9}, 
   3.596673046127954*^9, {3.596674531981619*^9, 3.596674552381793*^9}, {
   3.5966749945047493`*^9, 3.596674997783239*^9}, {3.596675210520149*^9, 
   3.596675253622038*^9}, 3.5966754166660624`*^9, {3.59667553688673*^9, 
   3.5966755945474787`*^9}, {3.596675648249877*^9, 3.5966756483511057`*^9}, {
   3.596675710293535*^9, 3.596675712843453*^9}, {3.59667811444718*^9, 
   3.596678120528205*^9}, {3.59667984114441*^9, 3.596679841877277*^9}, {
   3.5969850847210407`*^9, 3.59698508553067*^9}, {3.59701647869418*^9, 
   3.5970164790367403`*^9}, {3.597487271691505*^9, 3.597487316997909*^9}, {
   3.597487520802096*^9, 3.597487534637588*^9}, {3.597488164603915*^9, 
   3.5974881987379837`*^9}, {3.597488318009859*^9, 3.597488318259902*^9}, {
   3.597490516701819*^9, 3.5974905236163397`*^9}, 3.597490607329743*^9, {
   3.59749064244622*^9, 3.597490646410692*^9}, {3.597511311112033*^9, 
   3.5975113566151657`*^9}, {3.597512022626766*^9, 3.597512022698423*^9}, {
   3.597512092618294*^9, 3.597512112799963*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Reading Data\"\>"], "Print",
 CellChangeTimes->{3.613918319054598*^9}],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{3.6139183328072643`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Imported \>\"", "<>", 
   RowBox[{"ToString", "[", 
    RowBox[{"np", "+", "1"}], "]"}], "<>", "\"\< time slices\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{"rawData", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"nt", "*", "i"}]}], ";;", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}]}], 
  "     ", 
  RowBox[{"(*", " ", 
   RowBox[{"i", " ", "=", " ", 
    RowBox[{"0", " ", "\[Rule]", " ", "np"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vals", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Partition", "[", " ", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"slice", "[", "i", "]"}], ",", "XPts"}], "]"}], ",", "YPts"}],
      "]"}], "/", "max"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5974906100887213`*^9, 3.59749063104626*^9}, {
  3.597490884786809*^9, 3.597490944029231*^9}, {3.597491248500845*^9, 
  3.597491301263914*^9}, {3.597492902058387*^9, 3.5974929055457077`*^9}, {
  3.597501351032816*^9, 3.597501359975918*^9}, {3.597510424061507*^9, 
  3.597510424245982*^9}, {3.5975112405009117`*^9, 3.5975112412193317`*^9}, {
  3.597511372220533*^9, 3.597511375626848*^9}, {3.59756450269143*^9, 
  3.5975645031849194`*^9}}],

Cell[BoxData["\<\"Imported 11 time slices\"\>"], "Print",
 CellChangeTimes->{3.613918333101693*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0.00688365"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", 
              "0.106195"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.66", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.66234"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.5961654302334013`*^9, 3.596165436524679*^9}, {
  3.596165584832552*^9, 3.596165588503154*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tuned", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0."}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.0667927", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", 
              "0.404712"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.584824", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", "0."}], 
             "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "0."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.597512639229063*^9, 3.597512645962842*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"img", "[", "i_", "]"}], ":=", 
  RowBox[{"Image3D", "[", 
   RowBox[{
    RowBox[{"vals", "[", "i", "]"}], ",", 
    RowBox[{"ClipRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ZPts", "/", "2"}], ",", "ZPts"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"YPts", ",", "0"}], "}"}], ",", "All"}], "}"}]}], ",", 
    RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5974909457613583`*^9, 3.597490977028947*^9}, {
   3.5974910739840403`*^9, 3.59749107451075*^9}, {3.59749143132237*^9, 
   3.597491432030519*^9}, {3.5974929456975527`*^9, 3.597492976343258*^9}, {
   3.5974930279333887`*^9, 3.5974930339936533`*^9}, 3.597493373287657*^9, {
   3.597493473323586*^9, 3.5974934746031227`*^9}, {3.597499498109767*^9, 
   3.597499499034821*^9}, {3.597510518496359*^9, 3.597510524391694*^9}, {
   3.597511404556858*^9, 3.5975114090786467`*^9}, {3.59751244788133*^9, 
   3.597512448056828*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotrange", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"10", ",", "90"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "90"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "90"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"img", "[", "np", "]"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
   
   RowBox[{"PlotRange", "\[Rule]", "plotrange"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.597493389255402*^9, 3.597493400852713*^9}, {
  3.597494672972208*^9, 3.5974946733394957`*^9}, {3.597501366956215*^9, 
  3.59750136737152*^9}, {3.5975105367389917`*^9, 3.5975105558254843`*^9}, {
  3.597511525118513*^9, 3.5975115289129333`*^9}, {3.597511580750698*^9, 
  3.5975115811585913`*^9}, {3.597512036934122*^9, 3.597512051489517*^9}, {
  3.59751216374785*^9, 3.597512174470457*^9}, {3.597512298204205*^9, 
  3.5975123912800407`*^9}, {3.59751251607652*^9, 3.597512516484564*^9}, {
  3.597512668768305*^9, 3.59751268520397*^9}, {3.5975648206589327`*^9, 
  3.5975648253564672`*^9}, {3.5976074015731916`*^9, 3.5976074243957453`*^9}, {
  3.597607525252092*^9, 3.597607525954904*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Show", "::", "\<\"gtype\"\>"}], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Image3D\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a type of graphics.\\\\\\\"\\\
\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\
\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Show/gtype\\\", ButtonNote -> \
\\\"Show::gtype\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.613918333422265*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   PanelBox[GridBox[{
      {
       StyleBox[
        StyleBox[
         DynamicBox[ToBoxes[
           FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
           StandardForm],
          ImageSizeCache->{278., {2., 8.}}],
         StripOnInput->False,
         DynamicUpdating->True], "Panel",
        StripOnInput->False,
        Background->None]},
      {
       ItemBox[
        TagBox[
         RowBox[{"Show", "[", 
          RowBox[{
           RowBox[{"Image3D", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "}"}], 
             ",", 
             RowBox[{"ClipRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"50", ",", "100"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"100", ",", "0"}], "}"}], ",", "All"}], "}"}]}], ",", 
             RowBox[{"ColorFunction", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Blend", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.05635`", ",", "0.081`", ",", "0.07687`", ",", "0.`"}], 
                    "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.0667927`", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.8877`", ",", "0.2636`", ",", "0.`", ",", "0.404712`"}],
                     "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.584824`", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "1.`", ",", "0.9658`", ",", "0.4926`", ",", "0.`"}], 
                    "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1.`", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "1.`", ",", "0.6436`", ",", "0.03622`", ",", "0.`"}], 
                    "]"}]}], "}"}]}], "}"}], ",", "#1"}], "]"}], "&"}], 
               ")"}]}]}], "]"}], ",", 
           RowBox[{"Axes", "\[Rule]", "True"}], ",", 
           RowBox[{"AxesLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\<\"z\"\>", ",", "\<\"y\"\>", ",", "\<\"x\"\>"}], 
             "}"}]}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"10", ",", "90"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"10", ",", "90"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"10", ",", "90"}], "}"}]}], "}"}]}]}], "]"}],
         Short[#, 5]& ],
        Background->GrayLevel[1],
        BaseStyle->{Deployed -> False},
        Frame->True,
        FrameStyle->GrayLevel[0, 0.2],
        StripOnInput->False]},
      {
       RowBox[{
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
             StandardForm],
            ImageSizeCache->{49., {1., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 97, 23684080357397957780, 5/2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
             StandardForm],
            ImageSizeCache->{52., {1., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 97, 23684080357397957780, 5 2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
             StandardForm],
            ImageSizeCache->{82., {2., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 97, 23684080357397957780, Infinity],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
             StandardForm],
            ImageSizeCache->{74., {1., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>FrontEndExecute[{
            FrontEnd`SetOptions[
            FrontEnd`$FrontEnd, 
             FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
            FrontEnd`FrontEndToken["PreferencesDialog"]}],
         Evaluator->None,
         Method->"Preemptive"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[1.2]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    DefaultBaseStyle->{},
    FrameMargins->5],
   Deploy,
   DefaultBaseStyle->{Deployed -> True}],
  Out[97]]], "Output",
 CellChangeTimes->{3.61391833744786*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Render 3d volume - PL/PT", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.5974923293037357`*^9, 3.597492332427025*^9}, {
  3.597511794591144*^9, 3.597511795781822*^9}, {3.5975119870618258`*^9, 
  3.597512017000799*^9}, {3.597564925117393*^9, 3.59756494966772*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"func", "[", "x_", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"Rl", "[", "x", "]"}], "/", 
    RowBox[{"Rt", "[", "x", "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.597512080030925*^9, 3.597512106299238*^9}, {
  3.597564957097248*^9, 3.597564980212356*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"var", " ", "=", " ", "\"\<xi\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Reading Data\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rawData", "=", 
   RowBox[{"Map", "[", 
    RowBox[{"func", ",", 
     RowBox[{"BinaryReadList", "[", 
      RowBox[{
       RowBox[{
       "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", "\"\<.bin\>\""}], 
       ",", "\"\<Real32\>\""}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", " ", "=", " ", 
   RowBox[{"Max", "[", "rawData", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.596672824939918*^9, 3.596672866215172*^9}, 
   3.596673046127954*^9, {3.596674531981619*^9, 3.596674552381793*^9}, {
   3.5966749945047493`*^9, 3.596674997783239*^9}, {3.596675210520149*^9, 
   3.596675253622038*^9}, 3.5966754166660624`*^9, {3.59667553688673*^9, 
   3.5966755945474787`*^9}, {3.596675648249877*^9, 3.5966756483511057`*^9}, {
   3.596675710293535*^9, 3.596675712843453*^9}, {3.59667811444718*^9, 
   3.596678120528205*^9}, {3.59667984114441*^9, 3.596679841877277*^9}, {
   3.5969850847210407`*^9, 3.59698508553067*^9}, {3.59701647869418*^9, 
   3.5970164790367403`*^9}, {3.597487271691505*^9, 3.597487316997909*^9}, {
   3.597487520802096*^9, 3.597487534637588*^9}, {3.597488164603915*^9, 
   3.5974881987379837`*^9}, {3.597488318009859*^9, 3.597488318259902*^9}, {
   3.597490516701819*^9, 3.5974905236163397`*^9}, 3.597490607329743*^9, {
   3.59749064244622*^9, 3.597490646410692*^9}, {3.597511311112033*^9, 
   3.5975113566151657`*^9}, {3.597512022626766*^9, 3.597512022698423*^9}, {
   3.597512092618294*^9, 3.597512112799963*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Imported \>\"", "<>", 
   RowBox[{"ToString", "[", 
    RowBox[{"np", "+", "1"}], "]"}], "<>", "\"\< time slices\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{"rawData", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"nt", "*", "i"}]}], ";;", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}]}], 
  "     ", 
  RowBox[{"(*", " ", 
   RowBox[{"i", " ", "=", " ", 
    RowBox[{"0", " ", "\[Rule]", " ", "np"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vals", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Partition", "[", " ", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"slice", "[", "i", "]"}], ",", "XPts"}], "]"}], ",", "YPts"}],
      "]"}], "/", "max"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5974906100887213`*^9, 3.59749063104626*^9}, {
   3.597490884786809*^9, 3.597490944029231*^9}, {3.597491248500845*^9, 
   3.597491301263914*^9}, {3.597492902058387*^9, 3.5974929055457077`*^9}, {
   3.597501351032816*^9, 3.597501359975918*^9}, {3.597510424061507*^9, 
   3.597510424245982*^9}, {3.5975112405009117`*^9, 3.5975112412193317`*^9}, {
   3.597511372220533*^9, 3.597511375626848*^9}, {3.59756450269143*^9, 
   3.5975645031849194`*^9}, 3.597565475760907*^9, {3.59756559074255*^9, 
   3.597565591353314*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0.00688365"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", 
              "0.106195"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.66", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", 
              "0.66234"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "1."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.5961654302334013`*^9, 3.596165436524679*^9}, {
  3.596165584832552*^9, 3.596165588503154*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tuned", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"cf", " ", "=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Blend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.05635", ",", " ", "0.081", ",", " ", "0.07687", ",", " ", 
              "0."}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.0667927", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "0.8877", ",", " ", "0.2636", ",", " ", "0.", ",", " ", 
              "0.404712"}], "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0.584824", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.9658", ",", " ", "0.4926", ",", " ", "0."}], 
             "]"}]}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"1.", ",", " ", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
             "1.", ",", " ", "0.6436", ",", " ", "0.03622", ",", " ", "0."}], 
             "]"}]}], "}"}]}], "}"}], ",", " ", "#1"}], "]"}], " ", "&"}], 
     " ", ")"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.597512639229063*^9, 3.597512645962842*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"img", "[", "i_", "]"}], ":=", 
  RowBox[{"Image3D", "[", 
   RowBox[{
    RowBox[{"vals", "[", "i", "]"}], ",", 
    RowBox[{"ClipRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ZPts", "/", "2"}], ",", "ZPts"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"YPts", ",", "0"}], "}"}], ",", "All"}], "}"}]}], ",", 
    RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5974909457613583`*^9, 3.597490977028947*^9}, {
   3.5974910739840403`*^9, 3.59749107451075*^9}, {3.59749143132237*^9, 
   3.597491432030519*^9}, {3.5974929456975527`*^9, 3.597492976343258*^9}, {
   3.5974930279333887`*^9, 3.5974930339936533`*^9}, 3.597493373287657*^9, {
   3.597493473323586*^9, 3.5974934746031227`*^9}, {3.597499498109767*^9, 
   3.597499499034821*^9}, {3.597510518496359*^9, 3.597510524391694*^9}, {
   3.597511404556858*^9, 3.5975114090786467`*^9}, {3.59751244788133*^9, 
   3.597512448056828*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotrange", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"10", ",", "90"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "90"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "90"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"img", "[", "np", "]"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
   
   RowBox[{"PlotRange", "\[Rule]", "plotrange"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.597493389255402*^9, 3.597493400852713*^9}, {
  3.597494672972208*^9, 3.5974946733394957`*^9}, {3.597501366956215*^9, 
  3.59750136737152*^9}, {3.5975105367389917`*^9, 3.5975105558254843`*^9}, {
  3.597511525118513*^9, 3.5975115289129333`*^9}, {3.597511580750698*^9, 
  3.5975115811585913`*^9}, {3.597512036934122*^9, 3.597512051489517*^9}, {
  3.59751216374785*^9, 3.597512174470457*^9}, {3.597512298204205*^9, 
  3.5975123912800407`*^9}, {3.59751251607652*^9, 3.597512516484564*^9}, {
  3.597512668768305*^9, 3.59751268520397*^9}, {3.5975648206589327`*^9, 
  3.5975648253564672`*^9}, {3.597565506484818*^9, 3.597565540030302*^9}, {
  3.597565671905356*^9, 3.597565676018023*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Dynamic Slicer", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.5974923293037357`*^9, 3.597492332427025*^9}, {
  3.597492992616871*^9, 3.597492995743327*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Need", " ", "to", " ", "tweak", " ", "values", " ", "below", " ", "to", 
   " ", "reflect", " ", "ini", " ", "file", " ", "params"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.597493001231966*^9, 3.597493016741411*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"num", " ", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"Image3D", "[", 
       RowBox[{
        RowBox[{"vals", "[", "num", "]"}], ",", 
        RowBox[{"ClipRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"100", "-", "size"}], ",", "200"}], "}"}], ",", "All", 
           ",", "All"}], "}"}]}], ",", 
        RowBox[{"Axes", "\[Rule]", "True"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], 
        ",", 
        RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"size", ",", "0", ",", "100", ",", "1"}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"Image3D", "[", 
       RowBox[{
        RowBox[{"vals", "[", "num", "]"}], ",", 
        RowBox[{"ClipRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", 
           RowBox[{"{", 
            RowBox[{"size", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", "All"}], "}"}]}], ",", 
        RowBox[{"Axes", "\[Rule]", "True"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], 
        ",", 
        RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"size", ",", "0", ",", "100", ",", "1"}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"Image3D", "[", 
       RowBox[{
        RowBox[{"vals", "[", "num", "]"}], ",", 
        RowBox[{"ClipRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"100", "-", "size"}], ",", "200"}], "}"}]}], "}"}]}], 
        ",", 
        RowBox[{"Axes", "\[Rule]", "True"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], 
        ",", 
        RowBox[{"ColorFunction", "\[Rule]", "cf"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"size", ",", "0", ",", "100", ",", "1"}], "}"}]}], "]"}]}]}], 
  " ", "*)"}]], "Input",
 CellChangeTimes->{{3.597491421659135*^9, 3.597491429278216*^9}, {
   3.597492650292872*^9, 3.597492658274938*^9}, {3.597492808053237*^9, 
   3.597492815317006*^9}, 3.597493047364819*^9, {3.597500018280541*^9, 
   3.59750003058217*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Animation", "Section",
 CellChangeTimes->{{3.5873169696384583`*^9, 3.5873169699241533`*^9}, {
  3.587317022252425*^9, 3.587317024426628*^9}, {3.5873393526446123`*^9, 
  3.58733935591698*^9}, {3.596069498643725*^9, 3.596069511629538*^9}, {
  3.596069566028297*^9, 3.596069574396153*^9}, {3.597487541863472*^9, 
  3.597487556437538*^9}, {3.5974923293037357`*^9, 3.597492332427025*^9}, {
  3.597492829152925*^9, 3.597492830625227*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"plots", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"img", "[", "i", "]"}], ",", 
       RowBox[{"Axes", "\[Rule]", "True"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<z\>\"", ",", "\"\<y\>\"", ",", "\"\<x\>\""}], "}"}]}], 
       ",", 
       RowBox[{"PlotRange", "\[Rule]", "plotrange"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "np"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5974928840303383`*^9, 3.597492885574031*^9}, {
   3.59749292416411*^9, 3.59749292472519*^9}, {3.59749341876378*^9, 
   3.597493424714857*^9}, {3.5974947887506027`*^9, 3.59749479569879*^9}, {
   3.59749950687854*^9, 3.597499514689477*^9}, {3.597511705345841*^9, 
   3.5975117186128674`*^9}, 3.597512399735428*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"ListAnimate", "[", 
   RowBox[{"plots", ",", 
    RowBox[{"AnimationRunning", "\[Rule]", "False"}]}], "]"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.597499994975253*^9, 3.597499997653411*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"wd", "<>", "\"\</animate.gif\>\""}], ",", "plots"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.597499914829802*^9, 3.5974999196457977`*^9}}]
}, Closed]]
},
WindowSize->{1084, 952},
WindowMargins->{{58, Automatic}, {Automatic, 24}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 307, 7, 28, "Input"],
Cell[889, 31, 438, 9, 24, "Message"],
Cell[1330, 42, 125, 2, 28, "Output"]
}, Open  ]],
Cell[1470, 47, 127, 3, 28, "Input"],
Cell[CellGroupData[{
Cell[1622, 54, 209, 3, 80, "Section"],
Cell[1834, 59, 834, 19, 63, "Input"],
Cell[2671, 80, 81, 2, 28, "Input"],
Cell[2755, 84, 190, 5, 28, "Input"],
Cell[2948, 91, 1543, 49, 63, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4528, 145, 404, 5, 80, "Section"],
Cell[CellGroupData[{
Cell[4957, 154, 4476, 123, 301, "Input"],
Cell[CellGroupData[{
Cell[9458, 281, 229, 3, 22, "Print"],
Cell[9690, 286, 230, 3, 21, "Print"],
Cell[9923, 291, 242, 4, 22, "Print"],
Cell[10168, 297, 200, 3, 21, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10429, 307, 517, 9, 80, "Section"],
Cell[CellGroupData[{
Cell[10971, 320, 1861, 35, 97, "Input"],
Cell[CellGroupData[{
Cell[12857, 359, 312, 4, 22, "Print"],
Cell[13172, 365, 304, 4, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13525, 375, 1591, 43, 80, "Input"],
Cell[15119, 420, 293, 4, 22, "Print"]
}, Open  ]],
Cell[15427, 427, 613, 16, 63, "Input"],
Cell[16043, 445, 1427, 37, 80, "Input"],
Cell[17473, 484, 1671, 41, 80, "Input"],
Cell[19147, 527, 1399, 38, 80, "Input"],
Cell[20549, 567, 1460, 38, 80, "Input"],
Cell[22012, 607, 1010, 23, 28, "Input"],
Cell[CellGroupData[{
Cell[23047, 634, 1216, 28, 46, "Input"],
Cell[24266, 664, 16803, 283, 421, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41118, 953, 454, 6, 80, "Section"],
Cell[CellGroupData[{
Cell[41597, 963, 1760, 33, 97, "Input"],
Cell[CellGroupData[{
Cell[43382, 1000, 262, 3, 22, "Print"],
Cell[43647, 1005, 254, 3, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43950, 1014, 1591, 43, 80, "Input"],
Cell[45544, 1059, 249, 4, 22, "Print"]
}, Open  ]],
Cell[45808, 1066, 613, 16, 63, "Input"],
Cell[46424, 1084, 1427, 37, 80, "Input"],
Cell[47854, 1123, 1671, 41, 80, "Input"],
Cell[49528, 1166, 1399, 38, 80, "Input"],
Cell[50930, 1206, 1460, 38, 80, "Input"],
Cell[52393, 1246, 1010, 23, 28, "Input"],
Cell[CellGroupData[{
Cell[53428, 1273, 1216, 28, 46, "Input"],
Cell[54647, 1303, 830, 13, 78, "Message"],
Cell[55480, 1318, 1548, 24, 58, "Message"],
Cell[57031, 1344, 851, 15, 24, "Message"],
Cell[57885, 1361, 829, 13, 78, "Message"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[58763, 1380, 501, 7, 50, "Section"],
Cell[59267, 1389, 232, 6, 28, "Input"],
Cell[CellGroupData[{
Cell[59524, 1399, 1785, 36, 97, "Input"],
Cell[CellGroupData[{
Cell[61334, 1439, 88, 1, 22, "Print"],
Cell[61425, 1442, 82, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61556, 1449, 1612, 44, 80, "Input"],
Cell[63171, 1495, 99, 1, 22, "Print"]
}, Open  ]],
Cell[63285, 1499, 1427, 37, 80, "Input"],
Cell[64715, 1538, 1370, 36, 80, "Input"],
Cell[66088, 1576, 1024, 22, 28, "Input"],
Cell[CellGroupData[{
Cell[67137, 1602, 1363, 30, 46, "Input"],
Cell[68503, 1634, 499, 9, 24, "Message"],
Cell[69005, 1645, 6551, 178, 164, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[75605, 1829, 549, 7, 50, "Section"],
Cell[76157, 1838, 311, 8, 28, "Input"],
Cell[76471, 1848, 1785, 36, 97, "Input"],
Cell[78259, 1886, 1689, 45, 80, "Input"],
Cell[79951, 1933, 1427, 37, 80, "Input"],
Cell[81381, 1972, 1370, 36, 80, "Input"],
Cell[82754, 2010, 1024, 22, 28, "Input"],
Cell[83781, 2034, 1359, 30, 46, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[85177, 2069, 443, 6, 50, "Section"],
Cell[85623, 2077, 274, 6, 28, "Input"],
Cell[85900, 2085, 2768, 71, 182, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[88705, 2161, 438, 6, 50, "Section"],
Cell[89146, 2169, 877, 20, 32, "Input"],
Cell[90026, 2191, 246, 6, 32, "Input"],
Cell[90275, 2199, 202, 5, 32, "Input"]
}, Closed]]
}
]
*)

(* End of internal cache information *)
