(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    233715,       4495]
NotebookOptionsPosition[    227175,       4333]
NotebookOutlinePosition[    227587,       4349]
CellTagsIndexPosition[    227544,       4346]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["GRAPHICS", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.5993151510458117`*^9, 3.599315162793589*^9}, 
   3.5993181597645493`*^9, 3.599322598094571*^9, {3.61588766953754*^9, 
   3.615887674975727*^9}},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PlotOptions", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "12"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}], 
        ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "12"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}]}], 
       "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "12"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}], 
        ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "12"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}]}], 
       "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", 
      RowBox[{"3", "/", "4"}]}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogLogPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogLinearPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ContourPlot", ",", "PlotOptions"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"DensityPlot", ",", "PlotOptions"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Style0", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Brown", ",", 
     "DotDashed"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Style1", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Black"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Style2", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Red"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Style3", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Black", ",", "Dashed"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Style4", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Red", ",", "Dashed"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Style5", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue", ",", "Dotted"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Style6", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", 
     RowBox[{"Darker", "[", 
      RowBox[{"Green", ",", "0.6"}], "]"}], ",", 
     RowBox[{"Dashing", "[", 
      RowBox[{"{", 
       RowBox[{"0.04", ",", "0.02", ",", "0.005", ",", "0.02"}], "}"}], 
      "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Style7", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue", ",", 
     RowBox[{"Dashing", "[", 
      RowBox[{"{", 
       RowBox[{"0.04", ",", "0.02", ",", "0.005", ",", "0.02"}], "}"}], 
      "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Style8", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue", ",", "Dashed"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Style9", "=", 
    RowBox[{"Directive", "[", 
     RowBox[{
      RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Brown"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"PlotStyle1", "=", 
   RowBox[{"{", 
    RowBox[{"Style1", ",", "Style3"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PlotStyle2", "=", 
    RowBox[{"{", 
     RowBox[{"Style1", ",", "Style2", ",", "Style3", ",", "Style4"}], "}"}]}],
    ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Stylea", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Brown"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Styleb", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue", ",", "Dashed"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Stylec", "=", 
   RowBox[{"Directive", "[", 
    RowBox[{
     RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Styled", "=", 
    RowBox[{"Directive", "[", 
     RowBox[{
      RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue", ",", "Dashed"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"PlotStylec", "=", 
   RowBox[{"{", 
    RowBox[{
    "Stylea", ",", "Styled", ",", "Stylea", ",", "Styled", ",", "Stylea", ",",
      "Styled", ",", "Stylea", ",", "Styled"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PlotStylec2", "=", 
    RowBox[{"{", 
     RowBox[{"Style9", ",", "Style8"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"PlotStyleh", "=", 
   RowBox[{"{", "Style1", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PlotStylee", "=", 
    RowBox[{"{", "Style3", "}"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"PlotStyler", "=", 
   RowBox[{"{", 
    RowBox[{"Style2", ",", "Style0", ",", "Style8"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PlotStylem", "=", 
    RowBox[{"{", 
     RowBox[{"Style0", ",", "Style4", ",", "Style5", ",", "Style6"}], "}"}]}],
    ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"PlotStyler2", "=", 
   RowBox[{"{", 
    RowBox[{"Style2", ",", "Style3", ",", "Style7"}], "}"}]}], 
  ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.6158055371683683`*^9, 3.6158055398095818`*^9}, 
   3.615887674975772*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["SET PARAMS AND FUNCTIONS", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.5993151510458117`*^9, 3.599315162793589*^9}, 
   3.5993181597645493`*^9, 3.599322598094571*^9, {3.6158876792563553`*^9, 
   3.615887688231688*^9}, 3.6158877190792847`*^9, {3.615892216969586*^9, 
   3.615892220056476*^9}},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"hbarc", "=", "0.197326960277"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TFO", "=", "0.15"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g0", "=", "16"}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.599305533272863*^9, 3.599305571542037*^9}, {
   3.599309012361339*^9, 3.599309019599308*^9}, {3.5993149829356956`*^9, 
   3.59931498479152*^9}, 3.599315162793685*^9, {3.599317308554344*^9, 
   3.599317311269085*^9}, 3.599318159764625*^9, 3.5993215532711554`*^9, 
   3.599322598094695*^9, {3.6155637724667263`*^9, 3.615563780689904*^9}, {
   3.615826617704464*^9, 3.615826620608005*^9}, 3.6158877190793324`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"R", "[", "\[Xi]_", "]"}], "=", 
   RowBox[{
    RowBox[{"1", "/", "2"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"1", "+", "\[Xi]"}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"ArcTan", "[", 
        RowBox[{"Sqrt", "[", "\[Xi]", "]"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", "\[Xi]", "]"}]}]}], ")"}]}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{3.615887719079358*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", 
    RowBox[{"l_", ",", "xi_"}], "]"}], ":=", 
   RowBox[{
    FractionBox["g0", 
     SuperscriptBox["\[Pi]", "2"]], 
    FractionBox[
     SuperscriptBox["l", "3"], 
     SqrtBox[
      RowBox[{"1", "+", "xi"}]]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"l_", ",", "xi_"}], "]"}], ":=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"R", "[", "xi", "]"}], 
     RowBox[{"1", "/", "4"}]], "l"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Epsilon]", "[", "T_", "]"}], ":=", 
   RowBox[{
    FractionBox[
     RowBox[{"3", " ", "g0"}], 
     SuperscriptBox["\[Pi]", "2"]], 
    RowBox[{"(", 
     FractionBox[
      SuperscriptBox["\[Pi]", "4"], "90"], ")"}], 
    SuperscriptBox["T", "4"]}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.615564481286706*^9, 3.615564489771864*^9}, {
  3.615564545580413*^9, 3.615564575119122*^9}, {3.615565240715006*^9, 
  3.61556525876998*^9}, {3.6158877190793858`*^9, 3.6158877252829113`*^9}, {
  3.615892223570882*^9, 3.6158922308518476`*^9}, {3.615892348922185*^9, 
  3.6158923815511208`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["IMPORT AHYDRO", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.5993151510458117`*^9, 3.599315162793589*^9}, 
   3.5993181597645493`*^9, 3.599322598094571*^9, {3.6158876792563553`*^9, 
   3.615887688231688*^9}, 3.6158877190792847`*^9, {3.6158882424141083`*^9, 
   3.6158882694829407`*^9}, {3.615888610368142*^9, 3.615888638256031*^9}},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FileN1", "=", "\"\<D4751CC3\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cut1", "=", "\"\<z\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{"val1", "=", "\"\<0\>\""}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.5993180654487743`*^9, 3.5993180684663467`*^9}, {
   3.599318159764678*^9, 3.59931821319604*^9}, {3.59931830100432*^9, 
   3.5993183116890993`*^9}, {3.599318612358245*^9, 3.599318613632132*^9}, {
   3.599321058272462*^9, 3.5993210906335907`*^9}, {3.599322024335084*^9, 
   3.599322025599567*^9}, {3.5993223659727707`*^9, 3.599322367381442*^9}, 
   3.599322430528762*^9, 3.599322598096489*^9, {3.615555975327342*^9, 
   3.615555995357464*^9}, 3.615556098134433*^9, {3.6155569374231987`*^9, 
   3.6155569689725323`*^9}, {3.615557312266136*^9, 3.615557312601372*^9}, {
   3.6155637879058237`*^9, 3.615563858794395*^9}, 3.615566213355773*^9, 
   3.615566894413065*^9, 3.6158023128543*^9, 3.6158056174372797`*^9, 
   3.615888269483019*^9, {3.615888347051384*^9, 3.615888358222726*^9}, {
   3.615888610368216*^9, 3.615888638256103*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FileDir", "=", 
   RowBox[{
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"ParentDirectory", "[", 
      RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "<>", 
    "\"\</output/tsv/\>\"", "<>", "FileN1", "<>", "\"\</\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fieldsa", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<lambda\>\"", ",", "\"\<xi\>\"", ",", "\"\<ux\>\"", ",", "\"\<uy\>\"",
      ",", "\"\<rap\>\""}], "}"}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.598798782503592*^9, 3.598798787255459*^9}, {
   3.5987988816387997`*^9, 3.5987989085628443`*^9}, 3.598799192630767*^9, 
   3.5987995463129272`*^9, 3.5987998641945267`*^9, {3.5988079370229*^9, 
   3.598807961049296*^9}, {3.59887646441988*^9, 3.598876466009851*^9}, 
   3.598876507000236*^9, {3.5988765780191183`*^9, 3.598876619792615*^9}, 
   3.598876995721487*^9, {3.599232594280101*^9, 3.599232609106069*^9}, 
   3.5992327157792*^9, {3.599232791201819*^9, 3.5992327999862013`*^9}, 
   3.5992343289366703`*^9, {3.599304276482736*^9, 3.599304289894823*^9}, {
   3.5993043287902603`*^9, 3.599304401970366*^9}, {3.599304460398178*^9, 
   3.5993044954106703`*^9}, 3.599304539815095*^9, {3.599304619820257*^9, 
   3.5993046211957607`*^9}, {3.599316226556095*^9, 3.599316228054343*^9}, 
   3.5993166590876913`*^9, {3.59931817299613*^9, 3.59931817508806*^9}, 
   3.599318208774529*^9, 3.59931831509303*^9, 3.599321206423551*^9, 
   3.5993225980982523`*^9, 3.61556386797552*^9, 3.615888607800538*^9, 
   3.615888638256156*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lTab", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileDir", "<>", 
      RowBox[{"Fieldsa", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", "cut1", "<>", 
      "\"\<_\>\"", "<>", "val1", "<>", "\"\<.tsv\>\""}], ",", "\"\<TSV\>\""}],
     "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"xiTab", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileDir", "<>", 
      RowBox[{"Fieldsa", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", "cut1", "<>", 
      "\"\<_\>\"", "<>", "val1", "<>", "\"\<.tsv\>\""}], ",", "\"\<TSV\>\""}],
     "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{"Interpolation", "[", "lTab", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"xi1", "=", 
   RowBox[{"Interpolation", "[", "xiTab", "]"}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{
  3.59887699572153*^9, {3.599232678646215*^9, 3.599232689775723*^9}, {
   3.599304378818083*^9, 3.5993044403943787`*^9}, 3.5993045398151197`*^9, {
   3.59930458040315*^9, 3.599304583052752*^9}, {3.5993048128982687`*^9, 
   3.5993048297097807`*^9}, 3.599306745185219*^9, 3.599316713026128*^9, {
   3.5993179210429363`*^9, 3.599317968388591*^9}, {3.599318329979074*^9, 
   3.599318343965554*^9}, 3.599321206423575*^9, 3.5993225277273273`*^9, 
   3.599322598099847*^9, {3.615563872945704*^9, 3.615563888594358*^9}, 
   3.615888607800646*^9, 3.6158886382562027`*^9}],

Cell[BoxData[
 RowBox[{"{", "Null", "}"}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.599322503385406*^9, 3.5993225311263113`*^9}, 
   3.5993225981001873`*^9, 3.615888607800716*^9, 3.615888638256255*^9}],

Cell[BoxData[
 RowBox[{"tauf1", "=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{"StringTake", "[", 
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"T", "[", 
            RowBox[{
             RowBox[{"l1", "[", 
              RowBox[{"t", ",", "0", ",", "0"}], "]"}], ",", 
             RowBox[{"xi1", "[", 
              RowBox[{"t", ",", "0", ",", "0"}], "]"}]}], "]"}], "hbarc"}], 
          "\[Equal]", "TFO"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "1"}], "}"}]}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "]"}], ",", "5"}], 
    "]"}], "]"}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.6155565916719017`*^9, 3.6155566294171677`*^9}, {
   3.615556670760462*^9, 3.615556671720051*^9}, {3.615564058380205*^9, 
   3.6155640598853903`*^9}, {3.615564090199183*^9, 3.6155640906996403`*^9}, {
   3.615802654278563*^9, 3.615802693210765*^9}, {3.6158027637228127`*^9, 
   3.6158027804441843`*^9}, {3.6158028522460337`*^9, 3.615802867800995*^9}, {
   3.6158029179545813`*^9, 3.615802940335273*^9}, {3.615803015733417*^9, 
   3.615803031887293*^9}, 3.615805635358244*^9, {3.6158885792264223`*^9, 
   3.61588860780077*^9}, 3.615888638256302*^9}],

Cell[BoxData["4.144`"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{
  3.6155566307621517`*^9, 3.615556672228739*^9, 3.6155640608488703`*^9, 
   3.615564098813738*^9, 3.61556691118259*^9, 3.615802337014448*^9, {
   3.615802665646163*^9, 3.61580269546904*^9}, 3.615802780775432*^9, {
   3.615802864912383*^9, 3.615802868269906*^9}, 3.6158029263862047`*^9, {
   3.615803023945565*^9, 3.615803032508842*^9}, 3.615805690490386*^9, 
   3.6158886078008337`*^9, 3.615888638256349*^9}],

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{"tauf", " ", 
    RowBox[{"n", "[", 
     RowBox[{
      RowBox[{"l1", "[", 
       RowBox[{"x", ",", "y", ",", "z"}], "]"}], ",", 
      RowBox[{"xi1", "[", 
       RowBox[{"x", ",", "y", ",", "z"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615556681061762*^9, 3.615556683645957*^9}, {
   3.6155568738048286`*^9, 3.615556909710339*^9}, {3.615556996062223*^9, 
   3.615557042238913*^9}, {3.615557104782506*^9, 3.615557105749692*^9}, {
   3.615564041199119*^9, 3.615564045502479*^9}, {3.615564580667664*^9, 
   3.6155645969360323`*^9}, {3.615564802183688*^9, 3.615564846686124*^9}, {
   3.615802513959631*^9, 3.615802514979723*^9}, {3.615802576147931*^9, 
   3.615802593161531*^9}, {3.615803053625123*^9, 3.615803054575369*^9}, 
   3.615888607800893*^9, 3.615888638256393*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NIntegrate", "::", "\<\"slwcon\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Numerical integration converging \
too slowly; suspect one of the following: singularity, value of the \
integration is 0, highly oscillatory integrand, or WorkingPrecision too \
small.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/NIntegrate/slwcon\\\", \
ButtonNote -> \\\"NIntegrate::slwcon\\\"]\\)\"\>"}]], "Message", "MSG",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{
  3.615557043462839*^9, 3.615557106715189*^9, 3.6155573599675093`*^9, 
   3.6155640471239367`*^9, 3.615564811299143*^9, 3.6155648492553453`*^9, 
   3.615565019892149*^9, 3.615566393513564*^9, 3.615567057756688*^9, {
   3.6158025942434177`*^9, 3.615802601172185*^9}, 3.6158030553786697`*^9, 
   3.615803102903154*^9, 3.615805826905058*^9, 3.615805948687698*^9, 
   3.615888607800971*^9, 3.6158886382564497`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NIntegrate", "::", "\<\"eincr\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The global error of the strategy \
GlobalAdaptive has increased more than \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\
\\!\\(\\*StyleBox[\\!\\(2000\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\
\"\\\\\\\" times. The global error is expected to decrease monotonically \
after a number of integrand evaluations. Suspect one of the following: the \
working precision is insufficient for the specified precision goal; the \
integrand is highly oscillatory or it is not a (piecewise) smooth function; \
or the true value of the integral is 0. Increasing the value of the \
GlobalAdaptive option MaxErrorIncreases might lead to a convergent numerical \
integration. NIntegrate obtained \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\
\\*StyleBox[\\!\\(1472.9076009102596`\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" and \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(0.010907936017313718`\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" for the integral and \
error estimates.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/NIntegrate/eincr\\\", ButtonNote -> \
\\\"NIntegrate::eincr\\\"]\\)\"\>"}]], "Message", "MSG",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{
  3.615557043462839*^9, 3.615557106715189*^9, 3.6155573599675093`*^9, 
   3.6155640471239367`*^9, 3.615564811299143*^9, 3.6155648492553453`*^9, 
   3.615565019892149*^9, 3.615566393513564*^9, 3.615567057756688*^9, {
   3.6158025942434177`*^9, 3.615802601172185*^9}, 3.6158030553786697`*^9, 
   3.615803102903154*^9, 3.615805826905058*^9, 3.615805971191889*^9, 
   3.615888607801033*^9, 3.615888638256497*^9}],

Cell[BoxData["1472.9076009102596`"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615557040446542*^9, 3.615557068506386*^9}, 
   3.615557106760838*^9, 3.6155573851172113`*^9, 3.615564053725861*^9, 
   3.6155648343551407`*^9, 3.615564873077772*^9, 3.615565045195937*^9, 
   3.61556641872069*^9, 3.6155670830701*^9, {3.6158025942515087`*^9, 
   3.6158026239971313`*^9}, 3.615803058869091*^9, 3.6158031247234917`*^9, 
   3.61580584126519*^9, 3.615805971240217*^9, 3.615888607801094*^9, 
   3.615888638256544*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"xmin", "=", " ", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xmax", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ymin", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ymax", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zmin", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "3", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zmax", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "3", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615802493492606*^9, 3.615802562170986*^9}, {
   3.615886337174244*^9, 3.61588634168688*^9}, 3.615887882958119*^9, {
   3.615888630823934*^9, 3.615888638256588*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["IMPORT PERFECT", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{{3.5993151510458117`*^9, 3.599315162793589*^9}, 
   3.5993181597645493`*^9, 3.599322598094571*^9, {3.6158876792563553`*^9, 
   3.615887688231688*^9}, 3.6158877190792847`*^9, {3.6158882424141083`*^9, 
   3.6158882694829407`*^9}, {3.61588837282058*^9, 3.615888374610121*^9}, 
   3.61588862161602*^9, 3.615888846285911*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FileN1", "=", "\"\<11F6D516\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cut1", "=", "\"\<z\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{"val1", "=", "\"\<0\>\""}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{{3.6158884954558973`*^9, 3.615888495958083*^9}, 
   3.6158886216161013`*^9, 3.615888846285997*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FileDir", "=", 
   RowBox[{
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"ParentDirectory", "[", 
      RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "<>", 
    "\"\</output/tsv/\>\"", "<>", "FileN1", "<>", "\"\</\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fieldsa", "=", 
   RowBox[{"{", "\"\<lnt\>\"", "}"}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{{3.598798782503592*^9, 3.598798787255459*^9}, {
   3.5987988816387997`*^9, 3.5987989085628443`*^9}, 3.598799192630767*^9, 
   3.5987995463129272`*^9, 3.5987998641945267`*^9, {3.5988079370229*^9, 
   3.598807961049296*^9}, {3.59887646441988*^9, 3.598876466009851*^9}, 
   3.598876507000236*^9, {3.5988765780191183`*^9, 3.598876619792615*^9}, 
   3.598876995721487*^9, {3.599232594280101*^9, 3.599232609106069*^9}, 
   3.5992327157792*^9, {3.599232791201819*^9, 3.5992327999862013`*^9}, 
   3.5992343289366703`*^9, {3.599304276482736*^9, 3.599304289894823*^9}, {
   3.5993043287902603`*^9, 3.599304401970366*^9}, {3.599304460398178*^9, 
   3.5993044954106703`*^9}, 3.599304539815095*^9, {3.599304619820257*^9, 
   3.5993046211957607`*^9}, {3.599316226556095*^9, 3.599316228054343*^9}, 
   3.5993166590876913`*^9, {3.59931817299613*^9, 3.59931817508806*^9}, 
   3.599318208774529*^9, 3.59931831509303*^9, 3.599321206423551*^9, 
   3.5993225980982523`*^9, 3.61556386797552*^9, 3.615563904018033*^9, {
   3.615805657658617*^9, 3.615805666100732*^9}, 3.615888621616158*^9, 
   3.6158888462860603`*^9, 3.6158888836242437`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lTab", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileDir", "<>", 
      RowBox[{"Fieldsa", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", "cut1", "<>", 
      "\"\<_\>\"", "<>", "val1", "<>", "\"\<.tsv\>\""}], ",", "\"\<TSV\>\""}],
     "]"}]}], ";"}], "\n", 
 RowBox[{"l2", "=", 
  RowBox[{"Interpolation", "[", "lTab", "]"}]}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{
  3.59887699572153*^9, {3.599232678646215*^9, 3.599232689775723*^9}, {
   3.599304378818083*^9, 3.5993044403943787`*^9}, 3.5993045398151197`*^9, {
   3.59930458040315*^9, 3.599304583052752*^9}, {3.5993048128982687`*^9, 
   3.5993048297097807`*^9}, 3.599306745185219*^9, 3.599316713026128*^9, {
   3.5993179210429363`*^9, 3.599317968388591*^9}, {3.599318329979074*^9, 
   3.599318343965554*^9}, 3.599321206423575*^9, 3.5993225277273273`*^9, 
   3.599322598099847*^9, {3.615563872945704*^9, 3.6155639114043007`*^9}, {
   3.615805669287745*^9, 3.615805672926764*^9}, 3.615888621616209*^9, 
   3.6158888462861233`*^9, {3.615888889673676*^9, 3.6158888904566393`*^9}, 
   3.615888957742824*^9}]
}, Open  ]],

Cell[BoxData[
 TagBox[
  RowBox[{"InterpolatingFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.3`", ",", "8.3`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "9.9`"}], ",", "9.9`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "9.9`"}], ",", "9.9`"}], "}"}]}], "}"}], 
    ",", "\<\"<>\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellChangeTimes->{3.6158889657890882`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{"n", "[", 
    RowBox[{
     RowBox[{"l2", "[", 
      RowBox[{"x", ",", "y", ",", "z"}], "]"}], ",", "0"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{{3.615565052293008*^9, 3.615565055397018*^9}, 
   3.61580583729195*^9, {3.615805987771055*^9, 3.6158060157379837`*^9}, 
   3.615888621616311*^9, 3.615888846286203*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NIntegrate", "::", "\<\"slwcon\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Numerical integration converging \
too slowly; suspect one of the following: singularity, value of the \
integration is 0, highly oscillatory integrand, or WorkingPrecision too \
small.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/NIntegrate/slwcon\\\", \
ButtonNote -> \\\"NIntegrate::slwcon\\\"]\\)\"\>"}]], "Message", "MSG",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{
  3.615565059321148*^9, 3.6155664194122868`*^9, 3.61556708377067*^9, 
   3.615805841481988*^9, {3.615805977552417*^9, 3.6158060175289707`*^9}, 
   3.615888621616396*^9, 3.6158888462862797`*^9}],

Cell[BoxData["739.580744553571`"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{
  3.6155650836040573`*^9, 3.6155664434798326`*^9, 3.6155671079574966`*^9, 
   3.615805841499744*^9, {3.6158059775802298`*^9, 3.615806018335512*^9}, 
   3.6158886216164417`*^9, 3.6158888462863493`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"xmin", "=", " ", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xmax", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xmin", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xmax", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ymin", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "3", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ymax", "=", 
   RowBox[{"l2", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "3", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{{3.615802493492606*^9, 3.615802562170986*^9}, {
   3.615886337174244*^9, 3.61588634168688*^9}, 3.615887882958119*^9, 
   3.615888630823934*^9, 3.615888846286405*^9, {3.615888993754828*^9, 
   3.6158889976290417`*^9}}],

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"l2", "[", 
    RowBox[{"0.3", ",", "x", ",", "y"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", "Full"}]}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 CellChangeTimes->{{3.6158888462864637`*^9, 3.6158888571719*^9}}]
}, Open  ]],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1nHlcjVsXx49OiRTpoBRF5jkZS/c+O1PmeZ5F5qGMcc1j5rlLZEiIigwZ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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJw1mXfgT9X/x9/3nnOVhlKpiLKVvRNZRWYDUTIzUkraJGW1tCPJaBhNGigr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         "]], Polygon3DBox[CompressedData["
1:eJw1mnfgV9Mfxu8ZXxkVKRGZSVSkFJpGRguVlJ0KDSM0SESD/H72yig7UbJX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         "]], Polygon3DBox[CompressedData["
1:eJwt13fc1fMeAPDnec5zJGlpk8ZVyW3SQJpS0ZaK0C40n9LW3gMl0dIisiIV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         "]], 
        Polygon3DBox[{{996, 585, 707, 1162, 835, 836}, {1119, 626, 424, 423, 
         718, 1058}, {1043, 696, 333, 334, 697, 1044}, {1047, 700, 348, 349, 
         701, 1048}, {1111, 598, 394, 393, 710, 1054}, {1114, 612, 409, 408, 
         714, 1056}}]}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwt0ssqhVEUB/CNc3AOxzVRQie3ERPFhCegyJCSzEhMkamQOTLHC/AEPIH7
/bgdt6mQCX5fGaz9+3/11Vprt9Nj04NTOSGEBVUoRDnmeOBVbghlfGMDv9ke
/ZcXQg+r2ccWDrOTXWpCHuQsR7nEKa5xnltc4S43uM/mWAjvTOp9yHz+8JpH
vOExMzzhLU95xzPe85wPfFQXcpaXfOIVn3nNF97wlZloP97y0H4fLPJ9xwL+
cteMB9zmHte5w2Vuco6rnOQiRzjDAfarcbmDQ2xiL6vYHe3JNn7pXc8K95Bl
Qu9SxvnFVpZE98QUG1nMNIvYwCTrmGAtC1nDalUQ9WQ+KxlnObULpTRGSNEY
4cjx+f8e/gBfej8F
       "]]}, {
      Line3DBox[{732, 1040, 491, 731, 1164, 950, 733, 1165, 951, 734, 1166, 
       952, 735, 1167, 953, 736, 1168, 954, 737, 1169, 1067, 1261, 738, 1170, 
       955, 739, 1171, 956, 740, 1172, 957, 741, 1173, 958, 742, 1174, 959, 
       743, 1175, 960, 744, 1353, 1041, 961, 1042}], 
      Line3DBox[{746, 1068, 1262, 745, 506, 747, 1176, 962, 748, 1177, 963, 
       749, 1178, 964, 750, 1179, 965, 751, 1180, 1069, 1263, 752, 1070, 1264,
        753, 1181, 966, 754, 1182, 967, 755, 1183, 968, 756, 1184, 969, 757, 
       1185, 970, 758, 1186, 971, 759}], 
      Line3DBox[{761, 1071, 1265, 760, 1072, 1266, 762, 522, 763, 1187, 972, 
       764, 1188, 973, 765, 1189, 974, 766, 1190, 1073, 1267, 767, 1074, 1268,
        768, 1075, 1269, 769, 1191, 975, 770, 1192, 976, 771, 1193, 977, 772, 
       1194, 978, 773, 1195, 979, 774}], 
      Line3DBox[{776, 1076, 1270, 775, 1077, 1271, 777, 1078, 1272, 778, 538, 
       779, 1196, 980, 780, 1197, 981, 781, 1198, 1079, 1273, 782, 1080, 1274,
        783, 1081, 1275, 784, 1082, 1276, 785, 546, 786, 1199, 982, 787, 1200,
        983, 788, 1201, 984, 789}], 
      Line3DBox[{791, 1083, 1277, 790, 1084, 1278, 792, 1085, 1279, 793, 1086,
        1280, 794, 554, 795, 1202, 985, 796, 1354, 1043, 1044, 1366, 797, 
       1045, 1046, 1355, 798, 1087, 1281, 799, 1088, 1282, 800, 1089, 1283, 
       801, 561, 802, 1203, 986, 803, 1204, 987, 804}], 
      Line3DBox[{806, 1090, 1284, 805, 1091, 1285, 807, 1092, 1286, 808, 1093,
        1287, 809, 1094, 1288, 810, 569, 811, 1356, 1047, 1048, 1367, 812, 
       1049, 1050, 1357, 813, 1095, 1289, 814, 1096, 1290, 815, 1097, 1291, 
       816, 1098, 1292, 817, 1205, 988, 818, 1206, 989, 819}], 
      Line3DBox[{823, 1207, 990, 821, 1208, 991, 825, 1209, 992, 827, 1210, 
       993, 829, 1211, 994, 831, 1212, 995, 833, 1161, 1213, 584, 1063, 1053, 
       1214, 996, 836, 1215, 997, 838, 1216, 998, 840, 1217, 999, 842, 1218, 
       1000, 844, 1219, 1001, 846, 1221, 1003, 848}], 
      Line3DBox[{847, 1002, 1220, 845, 1304, 1109, 843, 1303, 1108, 841, 1302,
        1107, 839, 1301, 1106, 837, 1300, 1105, 835, 1162, 1299, 1052, 834, 
       1368, 1051, 704, 832, 1298, 1104, 830, 1297, 1103, 828, 1296, 1102, 
       826, 1295, 1101, 824, 1294, 1100, 820, 1293, 1099, 822}], 
      Line3DBox[{850, 1110, 1305, 849, 1222, 1004, 851, 1223, 1005, 852, 1224,
        1006, 853, 1225, 1007, 854, 1226, 1008, 855, 1359, 1054, 1111, 1358, 
       1064, 1055, 599, 856, 1227, 1009, 857, 1228, 1010, 858, 1229, 1011, 
       859, 1230, 1012, 860, 1231, 1013, 861, 1232, 1014, 862}], 
      Line3DBox[{864, 1112, 1306, 863, 1113, 1307, 865, 1233, 1015, 866, 1234,
        1016, 867, 1235, 1017, 868, 1236, 1018, 869, 1361, 1056, 1114, 1360, 
       1065, 1057, 1115, 1362, 870, 614, 871, 1237, 1019, 872, 1238, 1020, 
       873, 1239, 1021, 874, 1240, 1022, 875, 1241, 1023, 876}], 
      Line3DBox[{878, 1116, 1308, 877, 1117, 1309, 879, 1118, 1310, 880, 1242,
        1024, 881, 1243, 1025, 882, 1244, 1026, 883, 1364, 1058, 1119, 1363, 
       1066, 1059, 1120, 1365, 884, 1121, 1311, 885, 629, 886, 1245, 1027, 
       887, 1246, 1028, 888, 1247, 1029, 889, 1248, 1030, 890}], 
      Line3DBox[{892, 1122, 1312, 891, 1123, 1313, 893, 1124, 1314, 894, 637, 
       895, 1249, 1031, 896, 1250, 1032, 897, 1251, 1125, 1315, 898, 1126, 
       1316, 899, 1127, 1317, 900, 1128, 1318, 901, 645, 902, 1252, 1033, 903,
        1253, 1034, 904, 1254, 1035, 905}], 
      Line3DBox[{907, 1129, 1319, 906, 1130, 1320, 908, 1131, 1321, 909, 1132,
        1322, 910, 653, 911, 1255, 1036, 912, 1256, 1133, 1323, 913, 1134, 
       1324, 914, 1135, 1325, 915, 1136, 1326, 916, 1137, 1327, 917, 661, 918,
        1257, 1037, 919, 1258, 1038, 920}], 
      Line3DBox[{922, 1138, 1328, 921, 1139, 1329, 923, 1140, 1330, 924, 1141,
        1331, 925, 1142, 1332, 926, 1143, 1333, 927, 1259, 1144, 1334, 928, 
       1145, 1335, 929, 1146, 1336, 930, 1147, 1337, 931, 1148, 1338, 932, 
       1149, 1339, 933, 677, 934, 1260, 1039, 935}], 
      Line3DBox[{949, 1062, 721, 948, 1352, 1160, 947, 1351, 1159, 946, 1350, 
       1158, 945, 1349, 1157, 944, 1348, 1156, 943, 1347, 1155, 942, 1346, 
       685, 941, 1345, 1154, 940, 1344, 1153, 939, 1343, 1152, 938, 1342, 
       1151, 937, 1341, 1150, 936, 1163, 1340, 1060, 1061}]}, {
      Line3DBox[{269, 492, 1164, 270, 506, 298, 1266, 521, 313, 1271, 536, 
       328, 1278, 551, 343, 1285, 565, 358, 1294, 579, 1208, 373, 593, 1222, 
       388, 1307, 607, 403, 1309, 621, 418, 1313, 635, 433, 1320, 650, 448, 
       1329, 665, 463, 1341, 680, 478}], 
      Line3DBox[{271, 493, 1165, 272, 507, 1176, 299, 522, 314, 1272, 537, 
       329, 1279, 552, 344, 1286, 566, 359, 1295, 580, 1209, 374, 594, 1223, 
       389, 608, 1233, 404, 1310, 622, 419, 1314, 636, 434, 1321, 651, 449, 
       1330, 666, 464, 1342, 681, 479}], 
      Line3DBox[{273, 494, 1166, 274, 508, 1177, 300, 523, 1187, 315, 538, 
       330, 1280, 553, 345, 1287, 567, 360, 1296, 581, 1210, 375, 595, 1224, 
       390, 609, 1234, 405, 623, 1242, 420, 637, 435, 1322, 652, 450, 1331, 
       667, 465, 1343, 682, 480}], 
      Line3DBox[{275, 495, 1167, 276, 509, 1178, 301, 524, 1188, 316, 539, 
       1196, 331, 554, 346, 1288, 568, 361, 1297, 582, 1211, 376, 596, 1225, 
       391, 610, 1235, 406, 624, 1243, 421, 638, 1249, 436, 653, 451, 1332, 
       668, 466, 1344, 683, 481}], 
      Line3DBox[{277, 496, 1168, 278, 510, 1179, 302, 525, 1189, 317, 540, 
       1197, 332, 555, 1202, 347, 569, 362, 1298, 583, 1212, 377, 597, 1226, 
       392, 611, 1236, 407, 625, 1244, 422, 639, 1250, 437, 654, 1255, 452, 
       1333, 669, 467, 1345, 684, 482}], 
      Line3DBox[{279, 497, 1169, 281, 511, 1180, 303, 526, 1190, 318, 541, 
       1198, 333, 696, 1354, 698, 348, 700, 1356, 702, 363, 704, 706, 1213, 
       378, 708, 1359, 710, 393, 712, 1361, 714, 408, 716, 1364, 718, 423, 
       640, 1251, 438, 655, 1256, 453, 670, 1259, 468, 685, 483}], 
      Line3DBox[{283, 499, 1170, 284, 1264, 513, 305, 1268, 528, 320, 1274, 
       543, 335, 699, 1355, 557, 350, 703, 1357, 571, 365, 1299, 707, 585, 
       1214, 380, 711, 599, 395, 715, 1362, 613, 410, 719, 1365, 627, 425, 
       1316, 642, 440, 1324, 657, 455, 1335, 672, 470, 1347, 687, 485}], 
      Line3DBox[{285, 500, 1171, 286, 514, 1181, 306, 1269, 529, 321, 1275, 
       544, 336, 1281, 558, 351, 1289, 572, 366, 1300, 586, 1215, 381, 600, 
       1227, 396, 614, 411, 1311, 628, 426, 1317, 643, 441, 1325, 658, 456, 
       1336, 673, 471, 1348, 688, 486}], 
      Line3DBox[{287, 501, 1172, 288, 515, 1182, 307, 530, 1191, 322, 1276, 
       545, 337, 1282, 559, 352, 1290, 573, 367, 1301, 587, 1216, 382, 601, 
       1228, 397, 615, 1237, 412, 629, 427, 1318, 644, 442, 1326, 659, 457, 
       1337, 674, 472, 1349, 689, 487}], 
      Line3DBox[{289, 502, 1173, 290, 516, 1183, 308, 531, 1192, 323, 546, 
       338, 1283, 560, 353, 1291, 574, 368, 1302, 588, 1217, 383, 602, 1229, 
       398, 616, 1238, 413, 630, 1245, 428, 645, 443, 1327, 660, 458, 1338, 
       675, 473, 1350, 690, 488}], 
      Line3DBox[{291, 503, 1174, 292, 517, 1184, 309, 532, 1193, 324, 547, 
       1199, 339, 561, 354, 1292, 575, 369, 1303, 589, 1218, 384, 603, 1230, 
       399, 617, 1239, 414, 631, 1246, 429, 646, 1252, 444, 661, 459, 1339, 
       676, 474, 1351, 691, 489}], 
      Line3DBox[{293, 504, 1175, 294, 518, 1185, 310, 533, 1194, 325, 548, 
       1200, 340, 562, 1203, 355, 576, 1205, 370, 1304, 590, 1219, 385, 604, 
       1231, 400, 618, 1240, 415, 632, 1247, 430, 647, 1253, 445, 662, 1257, 
       460, 677, 475, 1352, 692, 490}], 
      Line3DBox[{295, 694, 1353, 695, 296, 519, 1186, 311, 534, 1195, 326, 
       549, 1201, 341, 563, 1204, 356, 577, 1206, 371, 591, 1220, 1221, 386, 
       605, 1232, 401, 619, 1241, 416, 633, 1248, 431, 648, 1254, 446, 663, 
       1258, 461, 678, 1260, 476, 721, 722, 723}], 
      Line3DBox[{477, 679, 720, 1340, 462, 664, 1328, 447, 649, 1319, 432, 
       634, 1312, 417, 620, 1308, 402, 606, 1306, 387, 592, 1305, 372, 1207, 
       578, 1293, 357, 564, 1284, 342, 550, 1277, 327, 535, 1270, 312, 520, 
       1265, 297, 505, 1262, 268, 491, 693, 724}], 
      Line3DBox[{484, 686, 1346, 469, 671, 1334, 454, 656, 1323, 439, 641, 
       1315, 424, 626, 1363, 730, 717, 409, 612, 1360, 729, 713, 394, 598, 
       1358, 728, 709, 379, 584, 727, 1368, 705, 364, 570, 726, 1367, 701, 
       349, 556, 725, 1366, 697, 334, 542, 1273, 319, 527, 1267, 304, 512, 
       1263, 282, 498, 1261, 280}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJxsfHc81u/3P8qKpBIVLUmakjSIUxJp0CCVNIzSUApZZSYz2Vv2DFHZ47L3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    "]],
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->{{-9.9, 9.9}, {-9.9, 9.9}, {0.0018686533164793341`, 
   2.4164782812500003`}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.615888858095702*^9, 3.61588891469985*^9, {3.615888980112851*^9, 
   3.6158889993976583`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"l2", "[", 
   RowBox[{"0.3", ",", "0", ",", "0"}], "]"}], "hbarc"}]], "Input",
 CellChangeTimes->{{3.615895802247168*^9, 3.6158958057256327`*^9}}],

Cell[BoxData["0.4768363138144521`"], "Output",
 CellChangeTimes->{{3.615895803118881*^9, 3.6158958061132183`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["VISCOUS HYDRO - IMPORT IC", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.599304516572014*^9, 3.599304539815049*^9}, {
   3.599304606831417*^9, 3.599304608095489*^9}, 3.599321206423506*^9, 
   3.5993225980981417`*^9, {3.6158207080011253`*^9, 3.615820712736506*^9}, {
   3.61588803215711*^9, 3.615888035164618*^9}, {3.615888069052721*^9, 
   3.615888087684194*^9}, 3.615888124347682*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[
 RowBox[{
  RowBox[{"FileDir", "=", 
   RowBox[{
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"ParentDirectory", "[", 
      RowBox[{"ParentDirectory", "[", 
       RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "]"}], "<>", 
    "\"\</vhydro2p1/data/inited.dat\>\""}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.615820725499279*^9, 3.61582079218664*^9}, 
   3.615888124347724*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FileIN", "=", 
   RowBox[{
    RowBox[{"Import", "[", "FileDir", "]"}], "\[LeftDoubleBracket]", "1", 
    "\[RightDoubleBracket]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.6158208073206797`*^9, 3.615820853984771*^9}, {
   3.6158231356709013`*^9, 3.615823138540485*^9}, {3.615823218118662*^9, 
   3.615823260410894*^9}, 3.615888124347755*^9, {3.615894044104748*^9, 
   3.6158940468477077`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NUM", "=", "109"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AT", "=", 
   RowBox[{"0.9", " ", "hbarc"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AT2", "=", 
   RowBox[{"AT", "/", "hbarc"}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.615821000666974*^9, 3.615821004431594*^9}, {
   3.615823696084494*^9, 3.61582372842773*^9}, {3.6158251350413427`*^9, 
   3.615825163799822*^9}, 3.615825308623727*^9, 3.615825406136904*^9, {
   3.6158254788798027`*^9, 3.615825479076427*^9}, 3.615826103491639*^9, 
   3.615886292561907*^9, {3.6158863788969727`*^9, 3.6158863799676867`*^9}, 
   3.615886764398978*^9, 3.61588812434778*^9, {3.615888776013074*^9, 
   3.61588877699448*^9}, {3.615908753802867*^9, 3.615908771905283*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Arr", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"FileIN", ",", "NUM"}], "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.6158208640752487`*^9, 3.615820950024416*^9}, {
   3.6158209924877863`*^9, 3.6158210580248127`*^9}, {3.615823292197884*^9, 
   3.615823294295767*^9}, 3.615888124347803*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ArrI", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.615822912097625*^9, 3.61582291792143*^9}, 
   3.6158881243478317`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"i", ",", "j"}], "]"}], 
  StyleBox[";",
   FontWeight->"Plain"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", "1"}], ",", 
    RowBox[{"i", "<", 
     RowBox[{"NUM", "+", "1"}]}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"j", "=", "1"}], ",", 
      RowBox[{"j", "<", 
       RowBox[{"NUM", "+", "1"}]}], ",", 
      RowBox[{"j", "++"}], ",", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"i", "-", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"(", 
                RowBox[{"NUM", "-", "1"}], ")"}], "2"], "+", "1"}], ")"}]}], 
           ")"}], "AT"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"j", "-", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"(", 
                RowBox[{"NUM", "-", "1"}], ")"}], "2"], "+", "1"}], ")"}]}], 
           ")"}], "AT"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"ArrI", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", ",", "y"}], "}"}], ",", 
            RowBox[{"Arr", "\[LeftDoubleBracket]", 
             RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]}], "}"}]}], 
         "]"}], ";"}], "\[IndentingNewLine]", "}"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"i", ",", "j"}], "]"}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.615821154350168*^9, 3.615821218343693*^9}, 
   3.615822480908834*^9, {3.615822831753703*^9, 3.615822953530308*^9}, {
   3.6158230339622793`*^9, 3.615823041762364*^9}, 3.615823347641679*^9, {
   3.615823688715617*^9, 3.615823690687434*^9}, {3.615823731502634*^9, 
   3.615823738500054*^9}, {3.615823844444786*^9, 3.6158238485218067`*^9}, {
   3.6158865955963097`*^9, 3.61588660244361*^9}, 3.615888124347856*^9}],

Cell[BoxData[
 RowBox[{"f", "=", 
  RowBox[{"Interpolation", "[", "ArrI", "]"}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.615823318851779*^9, 3.615823332691964*^9}, {
   3.615823405400908*^9, 3.6158234073022747`*^9}, 3.615888124347884*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"InterpolatingFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "9.5900902694622`"}], ",", "9.5900902694622`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "9.5900902694622`"}], ",", "9.5900902694622`"}], "}"}]}],
      "}"}], ",", "\<\"<>\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.615823333524673*^9, 3.615823366544012*^9}, 
   3.615823745156848*^9, 3.615823855758232*^9, 3.615824879501238*^9, 
   3.615824996620007*^9, 3.615825415965921*^9, {3.615825486650865*^9, 
   3.6158254884703207`*^9}, 3.61588630888253*^9, 3.615886385931126*^9, {
   3.6158866048055487`*^9, 3.61588662134739*^9}, 3.615886668522869*^9, 
   3.615886773770994*^9, 3.615887077986808*^9, {3.615887118251601*^9, 
   3.61588713062263*^9}, 3.615887187694124*^9, 3.6158872490932426`*^9, {
   3.615888124347913*^9, 3.615888129603242*^9}, {3.615888741939809*^9, 
   3.615888780223112*^9}}],

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"x", ",", "y"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", "Full"}]}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.6158240801540413`*^9, 3.6158254990344954`*^9, 
  3.6158881243479357`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"InterpolatingFunction", "::", "\<\"dmval\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Input value \\\\\\\"\\\", \\\
\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\(\\(-9.8985843`\\)\\), \
\\(\\(-9.8985843`\\)\\)}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\
\\\\\" lies outside the range of data in the interpolating function. \
Extrapolation will be used.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\
\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/InterpolatingFunction/dmval\\\", \
ButtonNote -> \\\"InterpolatingFunction::dmval\\\"]\\)\"\>"}]], "Message", \
"MSG",
 CellChangeTimes->{3.615888780269565*^9, 3.615889024723117*^9}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJyFnHeYFUXWxtu5MAS5ClwZRmDIQVEWBAQZ8HaJiGQQEAEVhjQCi+RgAj8R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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwtmXfgjtUbxt/nOeeNMjPKSJI0jTKL7JlklbQ0VSRRSgMhK6tBk6Z2EaVI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         "]], Polygon3DBox[CompressedData["
1:eJwtmWXA5kS6RNPpMAODuw0wuPvi7u7uyyCLu7s7LO7u7u7u7u7uLA4XuOdM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         "]], Polygon3DBox[CompressedData["
1:eJwt13e8FcUVAODHvRcEAQuIBGlSDVWpGhCINA01UiPNSNMoTSkSKRZ6tQCC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         "]]}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwt0jkvRUEYgOFjX68loiUaoqAUBaUoqEQUdERBQSIKSoXQ6fgFtEToJXT2
fd8iItbCvoZnEsV7n8k9kzvf5J6i1u6Grrgoigb1qrB+1IWm46Moh3Ms5CrL
ecJq3rOe32xhZkIUxdRpXcp+VnKYtRxjEyfYzln2coEPvOK7NvWsOy0aaItL
3OYyd7jC3TAT97jGfa5zQwfhd3jILR5xm8fc4Ql3eco9nnHSPa75oXO9hDtq
xGwbHOA8ezjDNo6zkaOs4RAr2McSFqvDOo3N/HRGHW9ZxSOWhXuxINzZvku+
KVtPYa/yzZjFPMaYy8ywhxmMMZ0ZTAvnMZXJTFKKdQKTw38cvuOvEvUTnulL
xoimfNz8vw9/yG9K8w==
       "]]}, {
      Line3DBox[{690, 1002, 473, 689, 1108, 912, 691, 1109, 913, 692, 1110, 
       914, 693, 1111, 915, 694, 1112, 916, 695, 1113, 1008, 1210, 696, 1114, 
       917, 697, 1115, 918, 698, 1116, 919, 699, 1117, 920, 700, 1118, 921, 
       701, 1119, 922, 702, 1312, 1003, 923, 1004}], 
      Line3DBox[{704, 1009, 1211, 703, 488, 705, 1120, 924, 706, 1121, 925, 
       707, 1122, 926, 708, 1123, 927, 709, 1124, 1010, 1212, 710, 1011, 1213,
        711, 1125, 928, 712, 1126, 929, 713, 1127, 930, 714, 1128, 931, 715, 
       1129, 932, 716, 1130, 933, 717}], 
      Line3DBox[{719, 1012, 1214, 718, 1013, 1215, 720, 504, 721, 1131, 934, 
       722, 1132, 935, 723, 1133, 936, 724, 1134, 1014, 1216, 725, 1015, 1217,
        726, 1016, 1218, 727, 1135, 937, 728, 1136, 938, 729, 1137, 939, 730, 
       1138, 940, 731, 1139, 941, 732}], 
      Line3DBox[{734, 1017, 1219, 733, 1018, 1220, 735, 1019, 1221, 736, 520, 
       737, 1140, 942, 738, 1141, 943, 739, 1142, 1020, 1222, 740, 1021, 1223,
        741, 1022, 1224, 742, 1023, 1225, 743, 528, 744, 1143, 944, 745, 1144,
        945, 746, 1145, 946, 747}], 
      Line3DBox[{749, 1024, 1226, 748, 1025, 1227, 750, 1026, 1228, 751, 1027,
        1229, 752, 536, 753, 1146, 947, 754, 1147, 1028, 1230, 755, 1029, 
       1231, 756, 1030, 1232, 757, 1031, 1233, 758, 1032, 1234, 759, 544, 760,
        1148, 948, 761, 1149, 949, 762}], 
      Line3DBox[{764, 1033, 1235, 763, 1034, 1236, 765, 1035, 1237, 766, 1036,
        1238, 767, 1037, 1239, 768, 552, 769, 1150, 1038, 1240, 770, 1039, 
       1241, 771, 1040, 1242, 772, 1041, 1243, 773, 1042, 1244, 774, 1043, 
       1245, 775, 1151, 950, 776, 1152, 951, 777}], 
      Line3DBox[{781, 1153, 952, 779, 1154, 953, 783, 1155, 954, 785, 1156, 
       955, 787, 1157, 956, 789, 1158, 957, 791, 1159, 569, 793, 1160, 958, 
       795, 1161, 959, 797, 1162, 960, 799, 1163, 961, 801, 1164, 962, 803, 
       1165, 963, 805, 1167, 965, 807}], 
      Line3DBox[{806, 964, 1166, 804, 1258, 1055, 802, 1257, 1054, 800, 1256, 
       1053, 798, 1255, 1052, 796, 1254, 1051, 794, 1253, 1050, 792, 1252, 
       568, 790, 1251, 1049, 788, 1250, 1048, 786, 1249, 1047, 784, 1248, 
       1046, 782, 1247, 1045, 778, 1246, 1044, 780}], 
      Line3DBox[{809, 1056, 1259, 808, 1168, 966, 810, 1169, 967, 811, 1170, 
       968, 812, 1171, 969, 813, 1172, 970, 814, 1173, 1057, 1260, 815, 585, 
       816, 1174, 971, 817, 1175, 972, 818, 1176, 973, 819, 1177, 974, 820, 
       1178, 975, 821, 1179, 976, 822}], 
      Line3DBox[{824, 1058, 1261, 823, 1059, 1262, 825, 1180, 977, 826, 1181, 
       978, 827, 1182, 979, 828, 1183, 980, 829, 1184, 1060, 1263, 830, 1061, 
       1264, 831, 601, 832, 1185, 981, 833, 1186, 982, 834, 1187, 983, 835, 
       1188, 984, 836, 1189, 985, 837}], 
      Line3DBox[{839, 1062, 1265, 838, 1063, 1266, 840, 1064, 1267, 841, 1190,
        986, 842, 1191, 987, 843, 1192, 988, 844, 1193, 1065, 1268, 845, 1066,
        1269, 846, 1067, 1270, 847, 617, 848, 1194, 989, 849, 1195, 990, 850, 
       1196, 991, 851, 1197, 992, 852}], 
      Line3DBox[{854, 1068, 1271, 853, 1069, 1272, 855, 1070, 1273, 856, 625, 
       857, 1198, 993, 858, 1199, 994, 859, 1200, 1071, 1274, 860, 1072, 1275,
        861, 1073, 1276, 862, 1074, 1277, 863, 633, 864, 1201, 995, 865, 1202,
        996, 866, 1203, 997, 867}], 
      Line3DBox[{869, 1075, 1278, 868, 1076, 1279, 870, 1077, 1280, 871, 1078,
        1281, 872, 641, 873, 1204, 998, 874, 1205, 1079, 1282, 875, 1080, 
       1283, 876, 1081, 1284, 877, 1082, 1285, 878, 1083, 1286, 879, 649, 880,
        1206, 999, 881, 1207, 1000, 882}], 
      Line3DBox[{884, 1084, 1287, 883, 1085, 1288, 885, 1086, 1289, 886, 1087,
        1290, 887, 1088, 1291, 888, 1089, 1292, 889, 1208, 1090, 1293, 890, 
       1091, 1294, 891, 1092, 1295, 892, 1093, 1296, 893, 1094, 1297, 894, 
       1095, 1298, 895, 665, 896, 1209, 1001, 897}], 
      Line3DBox[{911, 1007, 685, 910, 1311, 1106, 909, 1310, 1105, 908, 1309, 
       1104, 907, 1308, 1103, 906, 1307, 1102, 905, 1306, 1101, 904, 1305, 
       673, 903, 1304, 1100, 902, 1303, 1099, 901, 1302, 1098, 900, 1301, 
       1097, 899, 1300, 1096, 898, 1107, 1299, 1005, 1006}]}, {
      Line3DBox[{251, 474, 1108, 252, 488, 280, 1215, 503, 295, 1220, 518, 
       310, 1227, 533, 325, 1236, 548, 340, 1247, 563, 1154, 355, 578, 1168, 
       370, 1262, 593, 385, 1266, 608, 400, 1272, 623, 415, 1279, 638, 430, 
       1288, 653, 445, 1300, 668, 460}], 
      Line3DBox[{253, 475, 1109, 254, 489, 1120, 281, 504, 296, 1221, 519, 
       311, 1228, 534, 326, 1237, 549, 341, 1248, 564, 1155, 356, 579, 1169, 
       371, 594, 1180, 386, 1267, 609, 401, 1273, 624, 416, 1280, 639, 431, 
       1289, 654, 446, 1301, 669, 461}], 
      Line3DBox[{255, 476, 1110, 256, 490, 1121, 282, 505, 1131, 297, 520, 
       312, 1229, 535, 327, 1238, 550, 342, 1249, 565, 1156, 357, 580, 1170, 
       372, 595, 1181, 387, 610, 1190, 402, 625, 417, 1281, 640, 432, 1290, 
       655, 447, 1302, 670, 462}], 
      Line3DBox[{257, 477, 1111, 258, 491, 1122, 283, 506, 1132, 298, 521, 
       1140, 313, 536, 328, 1239, 551, 343, 1250, 566, 1157, 358, 581, 1171, 
       373, 596, 1182, 388, 611, 1191, 403, 626, 1198, 418, 641, 433, 1291, 
       656, 448, 1303, 671, 463}], 
      Line3DBox[{259, 478, 1112, 260, 492, 1123, 284, 507, 1133, 299, 522, 
       1141, 314, 537, 1146, 329, 552, 344, 1251, 567, 1158, 359, 582, 1172, 
       374, 597, 1183, 389, 612, 1192, 404, 627, 1199, 419, 642, 1204, 434, 
       1292, 657, 449, 1304, 672, 464}], 
      Line3DBox[{261, 479, 1113, 263, 493, 1124, 285, 508, 1134, 300, 523, 
       1142, 315, 538, 1147, 330, 553, 1150, 345, 568, 1159, 360, 583, 1173, 
       375, 598, 1184, 390, 613, 1193, 405, 628, 1200, 420, 643, 1205, 435, 
       658, 1208, 450, 673, 465}], 
      Line3DBox[{265, 481, 1114, 266, 1213, 495, 287, 1217, 510, 302, 1223, 
       525, 317, 1231, 540, 332, 1241, 555, 347, 1253, 570, 1160, 362, 585, 
       377, 1264, 600, 392, 1269, 615, 407, 1275, 630, 422, 1283, 645, 437, 
       1294, 660, 452, 1306, 675, 467}], 
      Line3DBox[{267, 482, 1115, 268, 496, 1125, 288, 1218, 511, 303, 1224, 
       526, 318, 1232, 541, 333, 1242, 556, 348, 1254, 571, 1161, 363, 586, 
       1174, 378, 601, 393, 1270, 616, 408, 1276, 631, 423, 1284, 646, 438, 
       1295, 661, 453, 1307, 676, 468}], 
      Line3DBox[{269, 483, 1116, 270, 497, 1126, 289, 512, 1135, 304, 1225, 
       527, 319, 1233, 542, 334, 1243, 557, 349, 1255, 572, 1162, 364, 587, 
       1175, 379, 602, 1185, 394, 617, 409, 1277, 632, 424, 1285, 647, 439, 
       1296, 662, 454, 1308, 677, 469}], 
      Line3DBox[{271, 484, 1117, 272, 498, 1127, 290, 513, 1136, 305, 528, 
       320, 1234, 543, 335, 1244, 558, 350, 1256, 573, 1163, 365, 588, 1176, 
       380, 603, 1186, 395, 618, 1194, 410, 633, 425, 1286, 648, 440, 1297, 
       663, 455, 1309, 678, 470}], 
      Line3DBox[{273, 485, 1118, 274, 499, 1128, 291, 514, 1137, 306, 529, 
       1143, 321, 544, 336, 1245, 559, 351, 1257, 574, 1164, 366, 589, 1177, 
       381, 604, 1187, 396, 619, 1195, 411, 634, 1201, 426, 649, 441, 1298, 
       664, 456, 1310, 679, 471}], 
      Line3DBox[{275, 486, 1119, 276, 500, 1129, 292, 515, 1138, 307, 530, 
       1144, 322, 545, 1148, 337, 560, 1151, 352, 1258, 575, 1165, 367, 590, 
       1178, 382, 605, 1188, 397, 620, 1196, 412, 635, 1202, 427, 650, 1206, 
       442, 665, 457, 1311, 680, 472}], 
      Line3DBox[{277, 682, 1312, 683, 278, 501, 1130, 293, 516, 1139, 308, 
       531, 1145, 323, 546, 1149, 338, 561, 1152, 353, 576, 1166, 1167, 368, 
       591, 1179, 383, 606, 1189, 398, 621, 1197, 413, 636, 1203, 428, 651, 
       1207, 443, 666, 1209, 458, 685, 686, 687}], 
      Line3DBox[{459, 667, 684, 1299, 444, 652, 1287, 429, 637, 1278, 414, 
       622, 1271, 399, 607, 1265, 384, 592, 1261, 369, 577, 1259, 354, 1153, 
       562, 1246, 339, 547, 1235, 324, 532, 1226, 309, 517, 1219, 294, 502, 
       1214, 279, 487, 1211, 250, 473, 681, 688}], 
      Line3DBox[{466, 674, 1305, 451, 659, 1293, 436, 644, 1282, 421, 629, 
       1274, 406, 614, 1268, 391, 599, 1263, 376, 584, 1260, 361, 569, 1252, 
       346, 554, 1240, 331, 539, 1230, 316, 524, 1222, 301, 509, 1216, 286, 
       494, 1212, 264, 480, 1210, 262}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJztXXk8V1vXl7E0SKZUNCiigaRB2Cei4WrUPGmeByRSyExpMIQ0GhqUDJVM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    "]],
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  ImageSize->{360., 271.7241670536488},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->{{-9.9, 9.9}, {-9.9, 9.9}, {5.150596428668811*^-9, 0.000331428}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]},
  ViewPoint->{1.3519567604190985`, -2.3036776018440692`, 2.077325786851716},
  ViewVertical->{0., 0., 1.}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{
  3.615824080598474*^9, {3.615824616723236*^9, 3.615824632699583*^9}, 
   3.615824880506311*^9, 3.615824998469178*^9, 3.615825418953264*^9, {
   3.615825490899249*^9, 3.615825499774618*^9}, 3.615886312152494*^9, 
   3.615886353221447*^9, {3.6158866064673567`*^9, 3.615886622307866*^9}, 
   3.615886669657489*^9, 3.615886773830483*^9, {3.615887069814816*^9, 
   3.6158870791986923`*^9}, {3.615887120957766*^9, 3.615887132323453*^9}, 
   3.6158871914642878`*^9, 3.615887250157011*^9, {3.6158881243479652`*^9, 
   3.615888129647018*^9}, {3.615888741999763*^9, 3.615888780343704*^9}, 
   3.615889024774012*^9}],

Cell[CellGroupData[{

Cell["VISCOUS HYDRO -GENERATE AND EXPORT IC", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.599304516572014*^9, 3.599304539815049*^9}, {
   3.599304606831417*^9, 3.599304608095489*^9}, 3.599321206423506*^9, 
   3.5993225980981417`*^9, {3.6158207080011253`*^9, 3.615820712736506*^9}, {
   3.61588803215711*^9, 3.615888035164618*^9}, {3.615888069052721*^9, 
   3.615888087684194*^9}, 3.615888124347682*^9, {3.615889155509482*^9, 
   3.615889158019188*^9}, {3.6158935253609047`*^9, 3.6158935301664953`*^9}, 
   3.6159064891959763`*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[
 RowBox[{
  RowBox[{"FileDir", "=", 
   RowBox[{
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"ParentDirectory", "[", 
      RowBox[{"ParentDirectory", "[", 
       RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "]"}], "<>", 
    "\"\</vhydro2p1/data/inited.dat\>\""}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.615820725499279*^9, 3.61582079218664*^9}, 
   3.615888124347724*^9, 3.6159064891960497`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ArrIC", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"i", ",", "j", ",", "x", ",", "y"}], "]"}], 
  StyleBox[";",
   FontWeight->"Plain"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", "1"}], ",", 
    RowBox[{"i", "<", 
     RowBox[{"NUM", "+", "1"}]}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"j", "=", "1"}], ",", 
      RowBox[{"j", "<", 
       RowBox[{"NUM", "+", "1"}]}], ",", 
      RowBox[{"j", "++"}], ",", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"i", "-", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"(", 
                RowBox[{"NUM", "-", "1"}], ")"}], "2"], "+", "1"}], ")"}]}], 
           ")"}], "AT"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"j", "-", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"(", 
                RowBox[{"NUM", "-", "1"}], ")"}], "2"], "+", "1"}], ")"}]}], 
           ")"}], "AT"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"ArrIC", ",", 
          RowBox[{
           RowBox[{"\[Epsilon]", "[", 
            RowBox[{"(", 
             RowBox[{"l2", "[", 
              RowBox[{"0.3", ",", "x", ",", "y"}], "]"}], ")"}], "]"}], 
           SuperscriptBox["hbarc", "4"], 
           SuperscriptBox["AT2", "4"]}]}], "]"}], ";"}], 
       "\[IndentingNewLine]", "}"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"i", ",", "j", ",", "x", ",", "y"}], "]"}], 
  StyleBox[";",
   FontWeight->"Plain"]}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.615821154350168*^9, 3.615821218343693*^9}, 
   3.615822480908834*^9, {3.615822831753703*^9, 3.615822953530308*^9}, {
   3.6158230339622793`*^9, 3.615823041762364*^9}, 3.615823347641679*^9, {
   3.615823688715617*^9, 3.615823690687434*^9}, {3.615823731502634*^9, 
   3.615823738500054*^9}, {3.615823844444786*^9, 3.6158238485218067`*^9}, {
   3.6158865955963097`*^9, 3.61588660244361*^9}, 3.615888124347856*^9, {
   3.615889305061636*^9, 3.615889355330473*^9}, 3.615891917271574*^9, {
   3.615893591711536*^9, 3.615893617573299*^9}, {3.6158939646684427`*^9, 
   3.615893999218214*^9}, 3.615895958843307*^9, {3.615902902910831*^9, 
   3.615902954010601*^9}, 3.6159030223918543`*^9, {3.615906318896831*^9, 
   3.6159063203008413`*^9}, {3.615906386083913*^9, 3.615906387719537*^9}, 
   3.6159064891960993`*^9, {3.615908499175766*^9, 3.615908527389076*^9}, {
   3.615908598196789*^9, 3.61590861247541*^9}, {3.61590870683566*^9, 
   3.6159087105390997`*^9}, {3.6159087860807734`*^9, 3.6159087871112337`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"FileDir", ",", "ArrIC", ",", "\"\<TSV\>\""}], "]"}], 
  ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.615894089292141*^9, 3.6158940953802557`*^9}, 
   3.615906489196147*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Epsilon]", "[", 
     RowBox[{"(", 
      RowBox[{"l2", "[", 
       RowBox[{"0.3", ",", "x", ",", "0"}], "]"}], ")"}], "]"}], 
    SuperscriptBox["hbarc", "4"], 
    SuperscriptBox[
     RowBox[{"(", "AT", ")"}], "4"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"(", 
            RowBox[{"NUM", "-", "1"}], ")"}], "2"], "+", "1"}], ")"}]}], 
       ")"}], "AT"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"NUM", "-", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"(", 
            RowBox[{"NUM", "-", "1"}], ")"}], "2"], "+", "1"}], ")"}]}], 
       ")"}], "AT"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.615906840426002*^9, 3.615906894485938*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtm3k4Vd/3x83zPE+Xe68hM1dCcvfZSYUGQ2UoUxKSRCSZlQwVkoyfzFMo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     "]]}},
  AspectRatio->NCache[
    Rational[3, 4], 0.75],
  AxesOrigin->{0, 0},
  Frame->True,
  FrameStyle->{
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"], 
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"]},
  FrameTicksStyle->{
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"], 
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"]},
  PlotRange->{{-9.5900902694622, 9.5900902694622}, {0., 
   0.00027070193294989554`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.615906890829211*^9, 3.615906894958646*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["VISCOUS HYDRO -GENERATE EOS FILE", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.599304516572014*^9, 3.599304539815049*^9}, {
   3.599304606831417*^9, 3.599304608095489*^9}, 3.599321206423506*^9, 
   3.5993225980981417`*^9, {3.6158207080011253`*^9, 3.615820712736506*^9}, {
   3.61588803215711*^9, 3.615888035164618*^9}, {3.615888069052721*^9, 
   3.615888087684194*^9}, 3.615888124347682*^9, {3.615889155509482*^9, 
   3.615889158019188*^9}, {3.615892541552237*^9, 3.61589254399102*^9}, 
   3.6158931641603537`*^9},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FileDir", "=", 
   RowBox[{
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"ParentDirectory", "[", 
      RowBox[{"ParentDirectory", "[", 
       RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], "]"}], "<>", 
    "\"\</vhydro2p1/idEOS.dat\>\""}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FileIN", "=", 
   RowBox[{"Import", "[", "FileDir", "]"}]}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.615892427406021*^9, 3.615892448889009*^9}, 
   3.615893164160441*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"LengthEOS", "=", "496"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ArrEOS", "=", 
   RowBox[{"{", "LengthEOS", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dT", "=", "0.002"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"i", ",", "j", ",", "x", ",", "y"}], "]"}], 
  StyleBox[";",
   FontWeight->"Plain"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", "0"}], ",", 
    RowBox[{"i", "<", "LengthEOS"}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Temp", "=", 
      RowBox[{"0.01", "+", 
       RowBox[{"i", " ", "dT"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"ArrEOS", ",", 
       RowBox[{"{", 
        RowBox[{"Temp", ",", 
         RowBox[{
          FractionBox[
           RowBox[{" ", 
            RowBox[{"3", "g0"}]}], 
           SuperscriptBox["\[Pi]", "2"]], 
          RowBox[{"(", 
           FractionBox[
            SuperscriptBox["\[Pi]", "4"], "90."], ")"}]}], ",", 
         RowBox[{
          FractionBox["g0", 
           SuperscriptBox["\[Pi]", "2"]], 
          RowBox[{"(", 
           FractionBox[
            SuperscriptBox["\[Pi]", "4"], "90."], ")"}]}], ",", 
         RowBox[{"1", "/", "3."}]}], "}"}]}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"i", ",", "j", ",", "x", ",", "y"}], "]"}], 
  StyleBox[";",
   FontWeight->"Plain"]}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.615892723539444*^9, 3.615892776077311*^9}, {
   3.615892806395523*^9, 3.615892965868999*^9}, 3.615893012071937*^9, {
   3.6158930523655663`*^9, 3.615893066343606*^9}, 3.6158931641605043`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"FileDir", ",", "ArrEOS", ",", "\"\<TSV\>\""}], "]"}], 
  ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.6158931357714*^9, 3.615893164160564*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["PARTICLE PRODUCTION - AHYDRO @ LHC", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615887986878264*^9, 3.615888016548771*^9}},
 Background->RGBColor[0.88, 1, 0.88]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"etasTab", "=", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "6", ",", "8", ",", "10", ",", 
     "20"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tfTab", "=", 
   RowBox[{"{", 
    RowBox[{
    "4.144", ",", "4.207", ",", "4.245", ",", "4.27", ",", "4.301", ",", 
     "4.318", ",", "4.33", ",", "4.354"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NTab", "=", 
   RowBox[{"{", 
    RowBox[{
    "1471.52", ",", "1526.72", ",", "1550.29", ",", "1558.81", ",", "1555.51",
      ",", "1541.88", ",", "1525.02", ",", "1450.83"}], "}"}]}], 
  ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615803480398457*^9, 3.615803524993967*^9}, {
   3.615803587128326*^9, 3.615803601133246*^9}, {3.615803631877754*^9, 
   3.615803651146055*^9}, {3.6158037215762377`*^9, 3.615803725544379*^9}, {
   3.615803834645001*^9, 3.6158038509800177`*^9}, {3.6158039029160213`*^9, 
   3.61580402997229*^9}, {3.615804083723406*^9, 3.615804176806201*^9}, {
   3.6158042211322203`*^9, 3.615804248897111*^9}, {3.6158047538318863`*^9, 
   3.615804766084749*^9}, 3.615888008460734*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tfIDEAL", "=", "4.013"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NIDEAL", "=", "739.58"}], ";"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.61580425518795*^9, 3.615804268773933*^9}, {
   3.615806045258054*^9, 3.615806073729951*^9}, 3.615888008460762*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Nf", "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
        "etasTab", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{
        "NTab", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "etasTab", "]"}]}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615804290973501*^9, 3.615804353743176*^9}, 
   3.615888008460784*^9}],

Cell[BoxData[
 RowBox[{"Plotn", "=", 
  RowBox[{"LogLinearPlot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Nf", "[", "etas", "]"}], "/", "NIDEAL"}], "-", "1"}], ",", 
    RowBox[{"{", 
     RowBox[{"etas", ",", 
      RowBox[{"First", "[", "etasTab", "]"}], ",", 
      RowBox[{"Last", "[", "etasTab", "]"}]}], "}"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", "PlotStyle2"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<4\[Pi]\[Eta]/S\>\"", ",", 
       "\"\<n(\!\(\*SubscriptBox[\(\[Tau]\), \(f\)]\))/\!\(\*SubscriptBox[\(n\
\), \(ideal\)]\)(\!\(\*SubscriptBox[\(\[Tau]\), \(f\)]\))-1\>\""}], "}"}]}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<@LHC\>\"", ",", "Black", ",", "16", ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", "14", "]"}], ",", "1.08"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
      "}"}]}]}], "]"}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615804355813575*^9, 3.615804385798008*^9}, {
   3.615804533574524*^9, 3.6158045365661087`*^9}, {3.615805557564723*^9, 
   3.6158055711073933`*^9}, {3.615806084016893*^9, 3.6158060861257973`*^9}, {
   3.61580615439977*^9, 3.615806154525309*^9}, {3.615806233039686*^9, 
   3.615806348656164*^9}, {3.615806397157982*^9, 3.6158063991767282`*^9}, 
   3.615888008460807*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"InterpolatingFunction", "::", "\<\"dmval\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Input value \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({0.00006119853073117439`}\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" lies outside the range \
of data in the interpolating function. Extrapolation will be \
used.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/InterpolatingFunction/dmval\\\", \
ButtonNote -> \\\"InterpolatingFunction::dmval\\\"]\\)\"\>"}]], "Message", \
"MSG",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{
  3.615804537300337*^9, 3.6158047689802732`*^9, {3.615805548859971*^9, 
   3.615805571570051*^9}, {3.615806080523692*^9, 3.615806086542459*^9}, 
   3.615806155068307*^9, 3.6158062841687613`*^9, {3.615806333264132*^9, 
   3.615806349023079*^9}, 3.615806399781928*^9, 3.61588800846084*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[1, 0, 0], Thickness[0.004], Dashing[{Small, Small}], 
    LineBox[CompressedData["
1:eJwV13k81FsUAHCVjKZNSDKRVMSTRNJrcX5IliTkZalsyRIPUZIoW+UJlZCQ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     "]]}},
  AspectRatio->NCache[
    Rational[3, 4], 0.75],
  AxesOrigin->{0, 0.9616944792001172},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  Epilog->{
    InsetBox[
     FormBox[
      StyleBox["\"@LHC\"", 
       GrayLevel[0], 16, FontFamily -> "Helvetica", StripOnInput -> False], 
      TraditionalForm], 
     NCache[{
       Log[14], 1.08}, {2.6390573296152584`, 1.08}], {0, 0}]},
  Frame->True,
  FrameLabel->{
    FormBox["\"4\[Pi]\[Eta]/S\"", TraditionalForm], 
    FormBox[
    "\"n(\\!\\(\\*SubscriptBox[\\(\[Tau]\\), \
\\(f\\)]\\))/\\!\\(\\*SubscriptBox[\\(n\\), \
\\(ideal\\)]\\)(\\!\\(\\*SubscriptBox[\\(\[Tau]\\), \\(f\\)]\\))-1\"", 
     TraditionalForm]},
  FrameStyle->{
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"], 
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"]},
  FrameTicks->{{Automatic, Automatic}, {{{0., 
       FormBox[
        TagBox[
         InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.302585092994046, 
       FormBox[
        TagBox[
         InterpretationBox["\"10.0\"", 10., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.6094379124341003`, 
       FormBox[
        TagBox[
         InterpretationBox["\"5.0\"", 5., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {3.912023005428146, 
       FormBox[
        TagBox[
         InterpretationBox["\"50.0\"", 50., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"2.0\"", 2., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.995732273553991, 
       FormBox[
        TagBox[
         InterpretationBox["\"20.0\"", 20., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.0986122886681098`, 
       FormBox[
        TagBox[
         InterpretationBox["\"3.0\"", 3., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {3.4011973816621555`, 
       FormBox[
        TagBox[
         InterpretationBox["\"30.0\"", 30., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0.4054651081081644, 
       FormBox[
        TagBox[
         InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {2.70805020110221, 
       FormBox[
        TagBox[
         InterpretationBox["\"15.0\"", 15., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.9459101490553132`, 
       FormBox[
        TagBox[
         InterpretationBox["\"7.0\"", 7., AutoDelete -> True], NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {4.248495242049359, 
       FormBox[
        TagBox[
         InterpretationBox["\"70.0\"", 70., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0.09531017980432493, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.1823215567939548, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.26236426446749106`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.336472236621213, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.47000362924573563`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5306282510621705, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5877866649021191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6418538861723948, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.3978952727983707`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.4849066497880004`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.5649493574615367`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.6390573296152584`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.772588722239781, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.833213344056216, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.8903717578961645`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.9444389791664403`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{0., 
       FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm]}, {0.4054651081081644, 
       FormBox["\"\"", TraditionalForm]}, {2.70805020110221, 
       FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm]}, {0.09531017980432493, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.1823215567939548, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.26236426446749106`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.336472236621213, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.47000362924573563`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5306282510621705, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.5877866649021191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6418538861723948, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.3978952727983707`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.4849066497880004`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.5649493574615367`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.6390573296152584`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.772588722239781, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.833213344056216, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.8903717578961645`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {2.9444389791664403`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  FrameTicksStyle->{
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"], 
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"]},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{0, 
      Log[20]}, {0.9616944792001172, 1.1094484578854855`}}, {{
     0, 2.995732273553991}, {0.9616944792001172, 1.1094484578854855`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{0., 
      FormBox[
       TagBox[
        InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.302585092994046, 
      FormBox[
       TagBox[
        InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.6094379124341003`, 
      FormBox[
       TagBox[
        InterpretationBox["\"5.0\"", 5., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {3.912023005428146, 
      FormBox[
       TagBox[
        InterpretationBox["\"50.0\"", 50., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0.6931471805599453, 
      FormBox[
       TagBox[
        InterpretationBox["\"2.0\"", 2., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.995732273553991, 
      FormBox[
       TagBox[
        InterpretationBox["\"20.0\"", 20., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.0986122886681098`, 
      FormBox[
       TagBox[
        InterpretationBox["\"3.0\"", 3., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {3.4011973816621555`, 
      FormBox[
       TagBox[
        InterpretationBox["\"30.0\"", 30., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0.4054651081081644, 
      FormBox[
       TagBox[
        InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {2.70805020110221, 
      FormBox[
       TagBox[
        InterpretationBox["\"15.0\"", 15., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.9459101490553132`, 
      FormBox[
       TagBox[
        InterpretationBox["\"7.0\"", 7., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {4.248495242049359, 
      FormBox[
       TagBox[
        InterpretationBox["\"70.0\"", 70., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 1}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0.09531017980432493, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.1823215567939548, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.26236426446749106`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.336472236621213, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.47000362924573563`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.5306282510621705, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.5877866649021191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.6418538861723948, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.3862943611198906`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.791759469228055, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.0794415416798357`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.1972245773362196`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.3978952727983707`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.4849066497880004`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.5649493574615367`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.6390573296152584`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.772588722239781, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.833213344056216, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.8903717578961645`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {2.9444389791664403`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.6888794541139363`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.0943445622221, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{
  3.6158043867982283`*^9, 3.6158045374175453`*^9, 3.6158047689916067`*^9, {
   3.615805548990861*^9, 3.6158055715897837`*^9}, {3.615806080539033*^9, 
   3.615806086562989*^9}, 3.61580615508836*^9, 3.61580628422298*^9, {
   3.615806333321823*^9, 3.615806349045394*^9}, 3.61580639980928*^9, 
   3.615888008460865*^9}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<partprod.pdf\>\""}], 
   ",", "Plotn", ",", "\"\<PDF\>\""}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615806387034215*^9, 3.615806406708585*^9}, 
   3.615888008460887*^9}],

Cell[BoxData["\<\"/home/ryblewski/Desktop/ahydro_dileptons_fixed/ahydro3p1/\
addons/visualization/partprod.pdf\"\>"], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615806403390274*^9, 3.615806408882331*^9}, 
   3.615888008460909*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tff", "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
        "etasTab", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{
        "tfTab", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "etasTab", "]"}]}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.6158046672042837`*^9, 3.6158046733885508`*^9}, 
   3.61588800846093*^9}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"tff", "[", "etas", "]"}], "/", "tfIDEAL"}], ",", 
   RowBox[{"{", 
    RowBox[{"etas", ",", 
     RowBox[{"First", "[", "etasTab", "]"}], ",", 
     RowBox[{"Last", "[", "etasTab", "]"}]}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", "PlotStyle2"}]}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.615804681547834*^9, 3.6158046862284527`*^9}, 
   3.615805582012908*^9, 3.615806131840994*^9, 3.615806172973398*^9, 
   3.615888008460952*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[1, 0, 0], Thickness[0.004], Dashing[{Small, Small}], 
    LineBox[CompressedData["
1:eJwV1Hs01dkXAPB7pdxMdyShIty+SBivb1HI3rkVtyLkUSJKFCVTpCTGK5lM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     "]]}},
  AspectRatio->NCache[
    Rational[3, 4], 0.75],
  AxesOrigin->{5., 1.04},
  Frame->True,
  FrameStyle->{
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"], 
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"]},
  FrameTicksStyle->{
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"], 
    Directive[
     GrayLevel[0], FontSize -> 12, FontFamily -> "Helvetica"]},
  PlotRange->{{1, 20}, {1.0326439149829376`, 1.0849738348249385`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 CellChangeTimes->{{3.6158046820805607`*^9, 3.615804686765675*^9}, 
   3.6158048492426*^9, 3.615805582463669*^9, 3.61580617352422*^9, 
   3.6158880084609737`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"0.158", "/", "0.9"}]], "Input",
 CellChangeTimes->{{3.615904450506837*^9, 3.6159044525863*^9}, {
  3.615905437237809*^9, 3.615905461737947*^9}, {3.6159057866080713`*^9, 
  3.615905816516296*^9}}],

Cell[BoxData["0.17555555555555558`"], "Output",
 CellChangeTimes->{
  3.615904452990725*^9, {3.615905438409605*^9, 3.615905462180944*^9}, {
   3.6159058000067577`*^9, 3.615905817022463*^9}}]
}, Open  ]]
},
WindowSize->{1855, 1056},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "iso8859-1"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 282, 5, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[852, 29, 6405, 195, 857, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Closed]],
Cell[CellGroupData[{
Cell[7294, 229, 375, 6, 45, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[7672, 237, 715, 13, 87, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[8390, 252, 530, 16, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[8923, 270, 1212, 36, 147, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[10172, 311, 414, 6, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[10589, 319, 1135, 19, 87, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[11727, 340, 1602, 30, 65, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[13332, 372, 1493, 34, 109, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[14828, 408, 296, 6, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[15127, 416, 1370, 30, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[16500, 448, 515, 8, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[17018, 458, 1136, 24, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[18157, 484, 1046, 17, 24, "Message",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[19206, 503, 1870, 28, 85, "Message",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[21079, 533, 549, 8, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[21631, 543, 1314, 34, 153, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}]
}, Closed]],
Cell[CellGroupData[{
Cell[22982, 582, 461, 7, 45, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[23446, 591, 401, 9, 87, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[23850, 602, 1594, 28, 65, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[25447, 632, 1179, 23, 65, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}]
}, Open  ]],
Cell[26641, 658, 488, 17, 41, "Output"],
Cell[CellGroupData[{
Cell[27154, 679, 664, 16, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[27821, 697, 829, 14, 24, "Message",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[28653, 713, 318, 5, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[28974, 720, 1364, 35, 153, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}],
Cell[30341, 757, 464, 11, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.}]
}, Open  ]],
Cell[30820, 771, 79699, 1299, 324, "Output"],
Cell[CellGroupData[{
Cell[110544, 2074, 181, 4, 42, "Input"],
Cell[110728, 2080, 114, 1, 41, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110879, 2086, 467, 7, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[111349, 2095, 459, 11, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[111811, 2108, 483, 10, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[112297, 2120, 827, 16, 87, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[113127, 2138, 385, 8, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[113515, 2148, 235, 6, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[113753, 2156, 2254, 60, 266, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[116010, 2218, 285, 5, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[116298, 2225, 1077, 25, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[117378, 2252, 480, 12, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[117873, 2267, 767, 13, 24, "Message"],
Cell[118643, 2282, 49669, 810, 297, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[CellGroupData[{
Cell[168337, 3096, 607, 9, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[168947, 3107, 483, 11, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[169433, 3120, 3039, 74, 288, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[172475, 3196, 281, 7, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[172793, 3208, 932, 31, 65, "Input"],
Cell[173728, 3241, 18133, 309, 269, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[191898, 3555, 597, 9, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[192498, 3566, 569, 14, 65, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[193070, 3582, 1851, 51, 260, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[194924, 3635, 252, 6, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[195213, 3646, 207, 3, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[195423, 3651, 1206, 28, 87, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[196632, 3681, 347, 7, 65, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[196982, 3690, 672, 20, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[197657, 3712, 1696, 39, 109, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[199356, 3753, 1028, 18, 24, "Message",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[200387, 3773, 20957, 419, 314, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[221347, 4194, 340, 8, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[221690, 4204, 272, 4, 41, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[221965, 4210, 677, 20, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[222645, 4232, 567, 13, 42, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}],
Cell[223215, 4247, 3495, 69, 292, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10003.}]
}, Closed]],
Cell[CellGroupData[{
Cell[226747, 4321, 219, 4, 39, "Input"],
Cell[226969, 4327, 190, 3, 41, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
