(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     49049,       1116]
NotebookOptionsPosition[     47030,       1061]
NotebookOutlinePosition[     47385,       1077]
CellTagsIndexPosition[     47342,       1074]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["setup", "Section",
 CellChangeTimes->{{3.5962107218783092`*^9, 3.596210726827827*^9}, {
   3.5962111378015213`*^9, 3.596211143639701*^9}, 3.596211764959023*^9, {
   3.596214000608802*^9, 3.596214004239328*^9}, 3.6582737674273567`*^9, {
   3.6583139734305153`*^9, 
   3.65831397464795*^9}},ExpressionUUID->"1df2b639-cf42-4be6-9bbb-\
90e678a340b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"run", " ", "=", " ", "\"\<test\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.658236733481309*^9, 3.658236738251505*^9}, {
   3.658237612237472*^9, 3.658237612667603*^9}, 3.6734383472033157`*^9, {
   3.673442372422802*^9, 
   3.673442373036085*^9}},ExpressionUUID->"9ce7f5ac-4ab3-4593-9134-\
8ae96cf6f792"],

Cell[BoxData[
 RowBox[{"dataDir", " ", "=", 
  RowBox[{
   RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../output/tsv/\>\"",
    "<>", "run"}]}]], "Input",
 CellChangeTimes->{
  3.658065098206181*^9, {3.658236741806139*^9, 3.658236743827581*^9}, 
   3.6582367914776993`*^9, {3.6582604590342693`*^9, 3.658260480526161*^9}, {
   3.658260575627202*^9, 3.658260576547091*^9}, {3.6583140034868717`*^9, 
   3.65831401089154*^9}, {3.690162533174801*^9, 3.690162536982276*^9}, {
   3.6903082819903584`*^9, 
   3.6903082826540422`*^9}},ExpressionUUID->"882e0a15-d27c-43d5-ac34-\
7524d2769bd4"],

Cell[BoxData[
 RowBox[{"iniFileName", " ", "=", " ", 
  RowBox[{
  "\"\<../../bin/\>\"", "<>", "run", "<>", "\"\</\>\"", "<>", "run", "<>", 
   "\"\<.ini\>\""}]}]], "Input",
 CellChangeTimes->{{3.658236746963625*^9, 3.658236771754937*^9}, {
  3.6582605686048203`*^9, 3.658260585258986*^9}, {3.658260636232573*^9, 
  3.658260636863302*^9}, {3.658260670586012*^9, 3.658260675653449*^9}, {
  3.658260797424121*^9, 
  3.658260801271888*^9}},ExpressionUUID->"e04e06e2-da9b-4c82-8d33-\
00f6e5c66499"]
}, Open  ]],

Cell[CellGroupData[{

Cell["styles and custom colormaps", "Section",
 CellChangeTimes->{{3.5918865845730343`*^9, 3.5918865902552633`*^9}, {
  3.616235567035328*^9, 
  3.616235570065833*^9}},ExpressionUUID->"9c1eaf7f-660e-487f-bbf8-\
06714b29a1af"],

Cell[BoxData[
 RowBox[{
  RowBox[{"styles", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}], ",", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0.9", ",", "0", ",", "0"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"3", ",", "5"}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0.5"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"10", ",", "5"}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0.5", ",", "0"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"10", ",", "5", ",", "2", ",", "5"}], "}"}], "]"}]}], "]"}], 
     ",", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "0.5", ",", "0.0"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0.5", ",", "0.5", ",", "0.5"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6304010997371197`*^9, 3.6304010999052362`*^9}, {
  3.63206564626169*^9, 3.632065710636176*^9}, {3.632084124485467*^9, 
  3.632084132156164*^9}, {3.638483648126431*^9, 3.638483658883576*^9}, {
  3.638484327905541*^9, 
  3.638484328008301*^9}},ExpressionUUID->"db23522d-304e-4c41-b865-\
67fc0af53837"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FrameTicksFontSize", "=", "18"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FrameFontSize", "=", "18"}], ";", 
  RowBox[{"PlotOptions", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameTicksFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameTicksFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}], 
       "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}]}], "}"}]}], 
     ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.75"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "styles"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot", ",", "PlotOptions"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogPlot", ",", "PlotOptions"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogLogPlot", ",", "PlotOptions"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogLinearPlot", ",", "PlotOptions"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", "PlotOptions"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"PolarPlot", ",", "PlotOptions"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PlotOptions3D", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"Lighter", "[", 
         RowBox[{"Lighter", "[", "Red", "]"}], "]"}], ",", 
        RowBox[{"Specularity", "[", 
         RowBox[{"Orange", ",", "10"}], "]"}], ",", 
        RowBox[{"Opacity", "[", "1", "]"}]}], "]"}]}], ",", 
     RowBox[{"PlotPoints", "\[Rule]", "60"}], ",", 
     RowBox[{"MeshStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Opacity", "[", "0.5", "]"}], "}"}]}], ",", 
     RowBox[{"Mesh", "\[Rule]", "16"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontSize", "\[Rule]", "12"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "}"}]}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot3D", ",", "PlotOptions3D"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DensityPlotOptions", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PlotPoints", "\[Rule]", "60"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", "\"\<SunsetColors\>\""}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameTicksFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameTicksFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}], 
       "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Black", ",", 
          RowBox[{"FontSize", "\[Rule]", "FrameFontSize"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"AbsoluteThickness", "[", "1", "]"}]}], "]"}]}], "}"}]}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"DensityPlot", ",", "DensityPlotOptions"}], "]"}], ";"}]}], "Input",\

 CellChangeTimes->{{3.632065774926132*^9, 3.632065775299766*^9}, {
   3.632065939693016*^9, 3.632065941644858*^9}, {3.6320659850600977`*^9, 
   3.6320660163072443`*^9}, {3.632066078662655*^9, 3.632066131911647*^9}, {
   3.632066185106216*^9, 3.632066189945898*^9}, {3.632076729757353*^9, 
   3.632076732424034*^9}, 3.6320820073279552`*^9, {3.6320827064779663`*^9, 
   3.632082707700131*^9}, {3.6320828878100557`*^9, 3.632082890104762*^9}, {
   3.6320894630659237`*^9, 3.632089465553356*^9}, {3.6384846775477047`*^9, 
   3.638484684593937*^9}, {3.638484734427775*^9, 3.6384847509045057`*^9}, {
   3.6384876397665987`*^9, 3.638487644043013*^9}, {3.638550869479618*^9, 
   3.638550886691169*^9}, {3.6385744931168127`*^9, 3.638574497671212*^9}, {
   3.641150277368146*^9, 3.6411502832820597`*^9}, {3.6582738726218367`*^9, 
   3.6582739139966393`*^9}, {3.6582740332883387`*^9, 3.658274048966495*^9}, {
   3.658274081606331*^9, 3.658274171785255*^9}, {3.658274953742207*^9, 
   3.658274997189042*^9}, {3.658275032442876*^9, 3.658275047265272*^9}, {
   3.658275115030777*^9, 3.658275115062131*^9}, {3.6592608152373857`*^9, 
   3.659260815508918*^9}, {3.659260891497444*^9, 3.659260915975142*^9}, {
   3.659260977478982*^9, 3.659260977564356*^9}, {3.6592610344924517`*^9, 
   3.659261034779147*^9}},ExpressionUUID->"314273b6-f9e9-4c6b-b85c-\
cde20d18f251"]
}, Closed]],

Cell[CellGroupData[{

Cell["routines", "Section",
 CellChangeTimes->{{3.5918865845730343`*^9, 3.5918865902552633`*^9}, {
   3.616235567035328*^9, 3.616235570065833*^9}, {3.659175062480856*^9, 
   3.659175063799026*^9}, {3.659186108755921*^9, 3.659186109738276*^9}, 
   3.659201837075161*^9, 3.66364232500177*^9, 
   3.699391547928673*^9},ExpressionUUID->"979a83b9-9eb4-40c8-a738-\
bb7b328536d7"],

Cell[BoxData[{
 RowBox[{"loadParams", " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ToExpression", "[", 
      RowBox[{"FindList", "[", 
       RowBox[{
        RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
        "\"\<XPts\>\""}], "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ToExpression", "[", 
      RowBox[{"FindList", "[", 
       RowBox[{
        RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
        "\"\<YPts\>\""}], "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ToExpression", "[", 
      RowBox[{"FindList", "[", 
       RowBox[{
        RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
        "\"\<TauStepSize\>\""}], "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ToExpression", "[", 
      RowBox[{"FindList", "[", 
       RowBox[{
        RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
        "\"\<TauMin\>\""}], "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ToExpression", "[", 
      RowBox[{"FindList", "[", 
       RowBox[{
        RowBox[{"dataDir", "<>", "\"\</\>\"", "<>", "iniFileName"}], ",", 
        "\"\<RecordingFrequency\>\""}], "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"RecordingFrequency", " ", "=", " ", 
      RowBox[{"Abs", "[", "RecordingFrequency", "]"}]}], ";"}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"loadInts", "[", "snap_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "vars", ",", "rawData", ",", "nt", ",", "np", ",", "slice", ",", "x", 
      ",", "y", ",", "delta"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vars", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
       "\"\<temp\>\"", ",", "\"\<lambda\>\"", ",", "\"\<ax\>\"", ",", 
        "\"\<ay\>\"", ",", "\"\<az\>\"", ",", "\"\<ux\>\"", ",", 
        "\"\<uy\>\""}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"nt", " ", "=", " ", 
      RowBox[{"XPts", "*", "YPts"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"np", " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "rawData", "]"}], "/", "nt"}], "-", "1"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"var", " ", "=", " ", 
         RowBox[{"vars", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<Loading \>\"", "<>", " ", "var"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"var", "\[Equal]", "\"\<lambda\>\""}], " ", "||", " ", 
           RowBox[{"var", "\[Equal]", "\"\<temp\>\""}]}], ",", 
          RowBox[{"fac", "=", "hbarc"}], ",", 
          RowBox[{"fac", "=", "1"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"rawData", " ", "=", " ", 
         RowBox[{"Import", "[", 
          RowBox[{
          "dataDir", "<>", "\"\</\>\"", "<>", "var", "<>", 
           "\"\<_z_0.tsv\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"range", " ", "=", " ", 
         RowBox[{"Max", "[", 
          RowBox[{"rawData", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"slice", "[", "i_", "]"}], " ", ":=", " ", 
         RowBox[{
          RowBox[{"rawData", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", "+", 
              RowBox[{"nt", "*", "i"}]}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "+", "i"}], ")"}], "*", "nt"}]}], "]"}], "]"}], 
          "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"int", "[", "var", "]"}], " ", "=", " ", 
         RowBox[{"Interpolation", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Riffle", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"slice", "[", "snap", "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
               RowBox[{"fac", "*", 
                RowBox[{
                 RowBox[{"slice", "[", "snap", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "3"}], "]"}], "]"}]}]}], "]"}], ",", 
             "2"}], "]"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "3"}]}], "]"}]}], ";"}], 
       "\[IndentingNewLine]", ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<vt\>\"", "]"}], "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], " ", "=", " ", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<ux\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "^", "2"}], " ", "+", 
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<uy\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "^", "2"}]}], " ", "]"}], "/", " ", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"1", "+", 
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<ux\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "^", "2"}], " ", "+", 
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<uy\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "^", "2"}]}], " ", "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"delta", "=", " ", 
      RowBox[{"10", "^", 
       RowBox[{"(", 
        RowBox[{"-", "4"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"ed", " ", "in", " ", 
       RowBox[{"GeV", "^", "4"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<ed\>\"", "]"}], "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], " ", "=", " ", 
      RowBox[{
       RowBox[{"hbarc", "^", "4"}], " ", 
       RowBox[{"H3", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "+", "delta"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "]"}], "*", 
       RowBox[{"edInt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"int", "[", "\"\<lambda\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], "/", "hbarc"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<px\>\"", "]"}], "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], " ", "=", " ", 
      RowBox[{
       RowBox[{"hbarc", "^", "4"}], " ", 
       RowBox[{"H3x", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "+", "delta"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "]"}], "*", 
       RowBox[{"PInt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"int", "[", "\"\<lambda\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], "/", "hbarc"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<py\>\"", "]"}], "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], " ", "=", " ", 
      RowBox[{
       RowBox[{"hbarc", "^", "4"}], " ", 
       RowBox[{"H3y", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "+", "delta"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "]"}], "*", 
       RowBox[{"PInt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"int", "[", "\"\<lambda\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], "/", "hbarc"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<pz\>\"", "]"}], "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], " ", "=", " ", 
      RowBox[{
       RowBox[{"hbarc", "^", "4"}], " ", 
       RowBox[{"H3L", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
           RowBox[{"x", ",", "y"}], "]"}], "+", "delta"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{
          RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "]"}], "*", 
       RowBox[{"PInt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"int", "[", "\"\<lambda\>\"", "]"}], "[", 
          RowBox[{"x", ",", "y"}], "]"}], "/", "hbarc"}], "]"}]}]}], ";"}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 CellChangeTimes->{{3.659179820369761*^9, 3.659179859855896*^9}, {
   3.659179904139098*^9, 3.6591800673702917`*^9}, 3.659180129529119*^9, {
   3.659180301931609*^9, 3.659180319449737*^9}, {3.659180398039515*^9, 
   3.659180398366167*^9}, {3.659180505610461*^9, 3.659180585773332*^9}, {
   3.659181570229106*^9, 3.6591815969154587`*^9}, {3.65918582777859*^9, 
   3.6591858855880613`*^9}, {3.659201713577739*^9, 3.659201780917233*^9}, {
   3.659202065128887*^9, 3.659202075870595*^9}, {3.659203423981038*^9, 
   3.659203434145814*^9}, {3.6592044549787703`*^9, 3.659204479445077*^9}, {
   3.659205067182858*^9, 3.65920511769242*^9}, {3.659205202002618*^9, 
   3.659205215151063*^9}, {3.659205500913022*^9, 3.659205603939617*^9}, {
   3.6592239968281527`*^9, 3.659224000770615*^9}, {3.659224792996346*^9, 
   3.659224799195215*^9}, {3.6592260469114237`*^9, 3.6592260769416723`*^9}, {
   3.659226116059277*^9, 3.659226147617181*^9}, {3.688866123963722*^9, 
   3.68886612965798*^9}, {3.688866375315075*^9, 
   3.688866381186318*^9}},ExpressionUUID->"51a31ef6-8db6-4c2c-8900-\
1706edfbd9e5"]
}, Closed]],

Cell[CellGroupData[{

Cell["snapshot time", "Section",
 CellChangeTimes->{{3.5918865845730343`*^9, 3.5918865902552633`*^9}, {
   3.616235567035328*^9, 3.616235570065833*^9}, {3.659175062480856*^9, 
   3.659175063799026*^9}, 3.659201840658772*^9, {3.659260753055419*^9, 
   3.659260760541833*^9}, 
   3.688573391657887*^9},ExpressionUUID->"cd894222-4171-4ef3-8daa-\
00c404046506"],

Cell[BoxData[
 RowBox[{
  RowBox[{"time", " ", "=", " ", "\"\<15.250\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.659186176484333*^9, 3.65918618023083*^9}, {
   3.6591863583594217`*^9, 3.659186362654978*^9}, {3.6591865566172247`*^9, 
   3.659186556870216*^9}, {3.659188063516634*^9, 3.659188063594574*^9}, {
   3.659188343648333*^9, 3.6591883830120153`*^9}, {3.659204682105769*^9, 
   3.659204682359983*^9}, {3.659205733116963*^9, 3.6592057332591047`*^9}, 
   3.659206587743794*^9, {3.659206641109951*^9, 3.659206641204774*^9}, {
   3.659214066096912*^9, 3.659214066191846*^9}, {3.659222206786584*^9, 
   3.659222207184444*^9}, {3.659222332027782*^9, 3.6592223353746347`*^9}, {
   3.659222682259985*^9, 3.659222682379696*^9}, {3.659223298169504*^9, 
   3.659223298448331*^9}, {3.659223688707787*^9, 3.659223697121498*^9}, {
   3.6592244864137783`*^9, 3.659224486508564*^9}, {3.659225428845697*^9, 
   3.659225428915759*^9}, {3.659260429495255*^9, 3.659260437077495*^9}, {
   3.659260736112368*^9, 3.659260736183097*^9}, {3.6592618344606543`*^9, 
   3.6592618353785553`*^9}, {3.6592629256343822`*^9, 3.659262926017288*^9}, {
   3.659263665779398*^9, 3.659263674273973*^9}, {3.659266232183455*^9, 
   3.659266286995328*^9}, {3.659266500953874*^9, 3.659266507256674*^9}, {
   3.659267208200095*^9, 3.659267221830202*^9}, {3.659267401479856*^9, 
   3.65926740393504*^9}, {3.6592675380894423`*^9, 3.659267538447879*^9}, 
   3.659267661250248*^9, {3.6592687638399143`*^9, 3.659268764070833*^9}, {
   3.659269022874794*^9, 3.659269024393032*^9}, {3.659269280172988*^9, 
   3.659269282123684*^9}, {3.659269400694759*^9, 3.659269401917406*^9}, 
   3.659269666328855*^9, {3.659270074899406*^9, 3.65927007497078*^9}, {
   3.6592724504726048`*^9, 3.659272451118684*^9}, 3.659273609782605*^9, {
   3.659274290595463*^9, 3.659274290985858*^9}, {3.659274492541057*^9, 
   3.659274492802815*^9}, {3.659275073647439*^9, 3.65927507843756*^9}, {
   3.659277470361394*^9, 3.65927747080014*^9}, 3.659280455525741*^9, 
   3.659281787196394*^9, {3.659281829410748*^9, 3.659281829465392*^9}, {
   3.659282242697554*^9, 3.659282243311661*^9}, {3.659282317636642*^9, 
   3.659282317796445*^9}, 3.6592828271831284`*^9, {3.659284447828649*^9, 
   3.6592844478813553`*^9}, {3.659285635222788*^9, 3.659285635525889*^9}, {
   3.6617800311935987`*^9, 3.661780032711652*^9}, {3.661780080239752*^9, 
   3.661780082789805*^9}, {3.6617832174094877`*^9, 3.661783218440295*^9}, {
   3.661783426135229*^9, 3.661783427726243*^9}, {3.661783806900195*^9, 
   3.66178380709905*^9}, 3.661783985059183*^9, {3.663626906723941*^9, 
   3.663626906932753*^9}, {3.663627637102242*^9, 3.663627637149207*^9}, {
   3.663636673912745*^9, 3.663636674391913*^9}, {3.663637311347975*^9, 
   3.663637314474812*^9}, {3.66363801631218*^9, 3.6636380164551563`*^9}, {
   3.6636395160069427`*^9, 3.663639517733841*^9}, {3.6636420186827993`*^9, 
   3.663642020488678*^9}, {3.6636423648055067`*^9, 3.663642366045216*^9}, 
   3.663643599329846*^9, {3.663643762646249*^9, 3.6636437671330833`*^9}, {
   3.6636439157070427`*^9, 3.663643931305717*^9}, {3.663644190447826*^9, 
   3.663644192310198*^9}, {3.66364527947256*^9, 3.663645279718812*^9}, {
   3.663645464633271*^9, 3.663645464720086*^9}, {3.6636456595739727`*^9, 
   3.663645659956029*^9}, {3.673438315737871*^9, 3.673438317375955*^9}, {
   3.673442382307962*^9, 3.6734423833075542`*^9}, {3.688491983125373*^9, 
   3.6884919932992773`*^9}, {3.688492133806242*^9, 3.688492134189315*^9}, {
   3.688492254775931*^9, 3.6884922553839207`*^9}, {3.688492695397229*^9, 
   3.688492695964959*^9}, {3.688568276460925*^9, 3.6885682787630253`*^9}, {
   3.688569787522266*^9, 3.688569789176087*^9}, {3.6885698383670483`*^9, 
   3.688569839813809*^9}, {3.6885732863218613`*^9, 3.688573287620582*^9}, {
   3.6885782720051737`*^9, 3.688578277307858*^9}, {3.688638687907967*^9, 
   3.688638689426115*^9}, 3.688640834564939*^9, {3.688641578933771*^9, 
   3.688641581251917*^9}, {3.688665138759706*^9, 3.688665138862006*^9}, {
   3.688665701530716*^9, 3.688665704321257*^9}, {3.688667367570269*^9, 
   3.6886673697053127`*^9}, {3.688669488150598*^9, 3.688669488773307*^9}, {
   3.688669733747363*^9, 3.688669734162364*^9}, {3.688670194818001*^9, 
   3.6886701948888702`*^9}, {3.688670225264481*^9, 3.688670225351432*^9}, {
   3.688670274982024*^9, 3.688670275092967*^9}, {3.68867033412335*^9, 
   3.6886703342262297`*^9}, {3.688670400359478*^9, 3.6886704007424803`*^9}, {
   3.6886738360616617`*^9, 3.68867383749264*^9}, {3.688678152076323*^9, 
   3.688678156321925*^9}, {3.68867874598911*^9, 3.688678747932336*^9}, {
   3.688739074326651*^9, 3.688739075560133*^9}, {3.6887391565255613`*^9, 
   3.688739156580638*^9}, {3.6887392737618647`*^9, 3.688739274144125*^9}, {
   3.6887406264401913`*^9, 3.6887406278620787`*^9}, {3.688741484018671*^9, 
   3.688741484969584*^9}, {3.688741735895301*^9, 3.688741737438218*^9}, {
   3.6887419173436337`*^9, 3.688741918006431*^9}, {3.688742169156781*^9, 
   3.688742170171607*^9}, {3.68874248691934*^9, 3.6887424869414177`*^9}, {
   3.688742706565889*^9, 3.688742708172661*^9}, {3.6887429842257137`*^9, 
   3.688742984617469*^9}, {3.688744099545786*^9, 3.688744102544626*^9}, {
   3.6887506618326187`*^9, 3.68875066299065*^9}, {3.688750806962288*^9, 
   3.6887508090646276`*^9}, {3.688751239063869*^9, 3.688751240206081*^9}, {
   3.688753485864107*^9, 3.688753486909978*^9}, {3.68875372583781*^9, 
   3.688753725892047*^9}, {3.6888171444953012`*^9, 3.6888171463147087`*^9}, {
   3.6888390209118967`*^9, 3.6888390222068243`*^9}, {3.688839059998296*^9, 
   3.688839060069539*^9}, {3.688839096156884*^9, 3.6888390962438173`*^9}, {
   3.6888391361792097`*^9, 3.688839137025996*^9}, {3.688839330211503*^9, 
   3.688839331354061*^9}, {3.688839587874032*^9, 3.688839589624371*^9}, {
   3.688839916196192*^9, 3.688839917163082*^9}, {3.6888402376067657`*^9, 
   3.688840238725629*^9}, {3.688840623855197*^9, 3.6888406256781063`*^9}, {
   3.6888410409111156`*^9, 3.688841043309862*^9}, {3.6888412771023197`*^9, 
   3.6888412785011263`*^9}, {3.688841689743561*^9, 3.688841691374208*^9}, {
   3.688842493552314*^9, 3.688842495047566*^9}, 3.688862693294547*^9, {
   3.68886275126385*^9, 3.6888627513184557`*^9}, {3.688862821676174*^9, 
   3.688862821771297*^9}, {3.6888628656581984`*^9, 3.688862865785191*^9}, {
   3.688862927101685*^9, 3.68886292776458*^9}, {3.688862988771097*^9, 
   3.688862989129983*^9}, 3.688863467293686*^9, {3.6888635260761137`*^9, 
   3.6888635532488613`*^9}, {3.688863624127211*^9, 3.688863624198295*^9}, {
   3.688863770784273*^9, 3.688863770871224*^9}, {3.688863857452582*^9, 
   3.688863857467251*^9}, {3.688863946456499*^9, 3.688863946607245*^9}, {
   3.6888640267570257`*^9, 3.688864027139791*^9}, {3.688864149775502*^9, 
   3.688864151302422*^9}, {3.688864239571663*^9, 3.688864239650537*^9}, {
   3.688864301248907*^9, 3.688864301303729*^9}, {3.688864454428475*^9, 
   3.68886445486509*^9}, {3.688866149200179*^9, 3.6888661494310703`*^9}, {
   3.688866849348352*^9, 3.688866849434361*^9}, {3.688868095559259*^9, 
   3.688868095941429*^9}, {3.6888696727499113`*^9, 3.6888696730609093`*^9}, {
   3.688873253361663*^9, 3.688873253751894*^9}, {3.688911047198248*^9, 
   3.688911047437366*^9}, {3.688911083181383*^9, 3.688911083739781*^9}, {
   3.6889111416184397`*^9, 3.688911141713585*^9}, {3.688911206319977*^9, 
   3.688911206734749*^9}, {3.6889112668918753`*^9, 3.688911267274939*^9}, {
   3.688911335585002*^9, 3.6889113380479307`*^9}, {3.688911407262025*^9, 
   3.688911407364911*^9}, 3.688911854355966*^9, {3.6889120507906837`*^9, 
   3.6889120508535748`*^9}, {3.6889121020362186`*^9, 3.68891210207517*^9}, {
   3.688912454297585*^9, 3.6889124543845253`*^9}, {3.68891258084345*^9, 
   3.6889125811384907`*^9}, {3.688912668417177*^9, 3.688912668736006*^9}, {
   3.6889130819156513`*^9, 3.688913083330926*^9}, {3.688913171303361*^9, 
   3.6889131714072123`*^9}, {3.688913361257305*^9, 3.688913361328247*^9}, {
   3.6889135423708763`*^9, 3.6889135424816236`*^9}, 3.688913628328566*^9, 
   3.6889143557134647`*^9, {3.688924009625853*^9, 3.688924010007854*^9}, {
   3.6889264252203007`*^9, 3.688926425634709*^9}, {3.688973575560508*^9, 
   3.688973596270114*^9}, {3.688973698754965*^9, 3.688973698841907*^9}, {
   3.6889742149087887`*^9, 3.688974215244074*^9}, {3.688974362350066*^9, 
   3.688974362676942*^9}, {3.68897446381779*^9, 3.688974463968342*^9}, {
   3.688974817154114*^9, 3.688974817233127*^9}, {3.6889833365003357`*^9, 
   3.6889833369075127`*^9}, {3.688984366757079*^9, 3.688984367244133*^9}, {
   3.688985279463409*^9, 3.6889852797022877`*^9}, {3.68899139884418*^9, 
   3.688991398931156*^9}, {3.688991516645813*^9, 3.6889915167016973`*^9}, {
   3.688991634763618*^9, 3.6889916348560753`*^9}, {3.688991926604973*^9, 
   3.688991926812827*^9}, {3.689097612189205*^9, 3.689097612302614*^9}, {
   3.689097918350547*^9, 3.689097918453574*^9}, {3.6890980820783*^9, 
   3.689098082158127*^9}, {3.689100244892741*^9, 3.6891002452044373`*^9}, {
   3.6891013954435673`*^9, 3.689101395713985*^9}, {3.689101514926195*^9, 
   3.689101514988545*^9}, {3.689105556873577*^9, 3.689105557288076*^9}, {
   3.689105702378909*^9, 3.6891057024332523`*^9}, 3.6891083356414623`*^9, {
   3.689108627483778*^9, 3.68910862756279*^9}, {3.689108764773237*^9, 
   3.689108765116249*^9}, 3.689109616389278*^9, {3.689114253284904*^9, 
   3.689114253602948*^9}, 3.689115138243395*^9, {3.6891156383888474`*^9, 
   3.6891156384757347`*^9}, {3.689117715655902*^9, 3.689117726574101*^9}, {
   3.6891378896233664`*^9, 3.689137889926037*^9}, {3.689159011153079*^9, 
   3.689159011368135*^9}, {3.689159288756316*^9, 3.68915928881129*^9}, {
   3.689159690753725*^9, 3.689159690824634*^9}, {3.689159734822998*^9, 
   3.6891597350865602`*^9}, {3.689988443640339*^9, 3.689988444079278*^9}, {
   3.689988976428503*^9, 3.689988976770932*^9}, {3.6901028381624937`*^9, 
   3.6901028403060083`*^9}, {3.690104418621977*^9, 3.690104419819228*^9}, {
   3.6901047525607653`*^9, 3.690104752647786*^9}, {3.690104877832168*^9, 
   3.690104877895976*^9}, {3.690105428804482*^9, 3.690105429155488*^9}, {
   3.690106082634837*^9, 3.690106084352816*^9}, {3.690107576000058*^9, 
   3.690107576022976*^9}, {3.690111604502419*^9, 3.690111606428706*^9}, {
   3.6901169716054363`*^9, 3.690116971708342*^9}, 3.690123464564411*^9, 
   3.690124721846085*^9, {3.690136168918885*^9, 3.690136170661352*^9}, {
   3.690137174919333*^9, 3.6901371762702*^9}, {3.690144428792035*^9, 
   3.690144431182884*^9}, {3.690150869633725*^9, 3.690150871208703*^9}, {
   3.690155842498378*^9, 3.6901558429533043`*^9}, {3.690158741838151*^9, 
   3.690158742349086*^9}, {3.690160299219894*^9, 3.6901603009876547`*^9}, {
   3.690161941142599*^9, 3.690161942909437*^9}, {3.690162474795824*^9, 
   3.690162474859969*^9}, {3.690162546061934*^9, 3.6901625480296783`*^9}, {
   3.6903082539879503`*^9, 3.690308258359363*^9}, {3.69030830983782*^9, 
   3.690308310068432*^9}, {3.690308382763447*^9, 3.690308384289304*^9}, {
   3.690389709821685*^9, 3.690389710074354*^9}, {3.690389792158667*^9, 
   3.690389792757444*^9}, {3.6903898318128777`*^9, 3.690389833155786*^9}, {
   3.690389951290526*^9, 3.690389951721572*^9}, {3.6903900192396307`*^9, 
   3.6903900193666143`*^9}, {3.690390723127995*^9, 3.690390726343759*^9}, {
   3.690390932180382*^9, 3.6903909334503527`*^9}, {3.690391283045713*^9, 
   3.690391283108231*^9}, {3.6903921217863903`*^9, 3.6903921235052347`*^9}, {
   3.690393078383185*^9, 3.6903930805576963`*^9}, {3.690396054038452*^9, 
   3.6903960553408957`*^9}, {3.690396298000627*^9, 3.690396299711495*^9}, {
   3.6903965039598227`*^9, 3.690396507526657*^9}, {3.690396850845406*^9, 
   3.690396852820348*^9}, {3.6903979703410263`*^9, 3.690397971339973*^9}, {
   3.6903994679684353`*^9, 3.6903994698390703`*^9}, {3.69041704975203*^9, 
   3.690417051371092*^9}, {3.690420440690398*^9, 3.6904204410495*^9}, {
   3.690421479929805*^9, 3.690421481465221*^9}, {3.690424005649371*^9, 
   3.690424007649066*^9}, {3.690453112445949*^9, 3.6904531147488728`*^9}, {
   3.690460348515074*^9, 3.690460350138764*^9}, {3.690462384145939*^9, 
   3.690462384217252*^9}, {3.6904630548327703`*^9, 3.690463058711603*^9}, {
   3.690463295508116*^9, 3.690463295563087*^9}, {3.690463518415078*^9, 
   3.690463519917858*^9}, {3.690463788294821*^9, 3.690463792229505*^9}, {
   3.6904640302340384`*^9, 3.690464030689929*^9}, {3.6904643155547533`*^9, 
   3.6904643159377613`*^9}, {3.690464667216728*^9, 3.690464668560398*^9}, {
   3.690464911981709*^9, 3.690464912076694*^9}, {3.6904651770144663`*^9, 
   3.690465178429406*^9}, {3.690465720210018*^9, 3.69046572168974*^9}, {
   3.690466553683082*^9, 3.6904665554818153`*^9}, {3.690481825918076*^9, 
   3.690481827309063*^9}, {3.690482442647491*^9, 3.69048244520647*^9}, {
   3.690482503869334*^9, 3.690482503964272*^9}, {3.690482654672955*^9, 
   3.690482654727859*^9}, {3.690482814885353*^9, 3.6904828149642963`*^9}, {
   3.690482947511742*^9, 3.690482947878683*^9}, {3.6904830404535933`*^9, 
   3.690483040762652*^9}, {3.690483277693362*^9, 3.6904832779962883`*^9}, {
   3.690483358513794*^9, 3.6904833585768137`*^9}, {3.690483537699668*^9, 
   3.690483537778584*^9}, {3.6904837920198*^9, 3.690483792154146*^9}, {
   3.6905561419437933`*^9, 3.6905561422700577`*^9}, {3.6992715127624474`*^9, 
   3.699271514259944*^9}, {3.6992725404968987`*^9, 3.699272543055669*^9}, {
   3.699272776387844*^9, 3.6992727781380568`*^9}, {3.699276919289814*^9, 
   3.699276921815611*^9}, {3.699391530737571*^9, 3.699391533103647*^9}, {
   3.6994447287109537`*^9, 3.69944473100889*^9}, {3.699444844009535*^9, 
   3.699444844809094*^9}},ExpressionUUID->"ba65b7b4-5b40-43e8-aebb-\
1e29ef1ab9c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["plots", "Section",
 CellChangeTimes->{{3.5918865845730343`*^9, 3.5918865902552633`*^9}, {
   3.616235567035328*^9, 3.616235570065833*^9}, {3.659175062480856*^9, 
   3.659175063799026*^9}, 
   3.659201840658772*^9},ExpressionUUID->"4b469471-cfff-4d04-9656-\
79c890eba19c"],

Cell[BoxData[{"loadParams", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"snap", " ", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ToExpression", "[", "time", "]"}], " ", "-", " ", "TauMin"}], 
      ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"RecordingFrequency", "*", "TauStepSize"}], ")"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Snap = \>\"", ",", "snap"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"loadInts", "[", "snap", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"range", " ", "=", " ", 
   RowBox[{
    RowBox[{"int", "[", "\"\<lambda\>\"", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.659180147758308*^9, 3.659180188927787*^9}, {
  3.6591807149221687`*^9, 3.6591807155364237`*^9}, {3.659186161043413*^9, 
  3.659186182375678*^9}, {3.659186365583695*^9, 3.659186380477849*^9}, {
  3.659204483330688*^9, 
  3.659204519176653*^9}},ExpressionUUID->"339a6697-8aed-46dd-9451-\
546019ae9d54"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tempPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<temp\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<x [fm]\>\"", ",", "\"\<T [GeV]\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lambdaPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<lambda\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<x [fm]\>\"", ",", "\"\<\[Lambda] [GeV]\>\""}], "}"}]}], 
     ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"axPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[Alpha]\), \(x\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ayPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[Alpha]\), \(y\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"azPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[Alpha]\), \(z\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uxPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<ux\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(x\)]\)\>\""}], 
       "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uyPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"int", "[", "\"\<uy\>\"", "]"}], "[", 
      RowBox[{"x", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(y\)]\)\>\""}], 
       "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ";", 
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tempPlot", ",", "lambdaPlot"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"axPlot", ",", "ayPlot", ",", "azPlot"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"uxPlot", ",", "uyPlot"}], "}"}]}], "}"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.659175049590795*^9, 3.65917505501539*^9}, {
  3.659180089488059*^9, 3.659180104582346*^9}, {3.659180163463586*^9, 
  3.6591801825589247`*^9}, {3.659180227550828*^9, 3.6591802935388317`*^9}, {
  3.659180347288608*^9, 3.659180365846306*^9}, {3.659180434284747*^9, 
  3.659180486544876*^9}, {3.659202086085396*^9, 3.659202093662407*^9}, {
  3.688866334237543*^9, 3.6888663485686207`*^9}, {3.699271546081068*^9, 
  3.699271573182275*^9}, {3.6992728272778263`*^9, 
  3.699272835793777*^9}},ExpressionUUID->"3ddbaf83-0269-4d7b-a2e0-\
1360f040fa3a"],

Cell[BoxData[
 RowBox[{"vtPlot", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"int", "[", "\"\<vt\>\"", "]"}], "[", 
     RowBox[{"x", ",", "0"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "range"}], "}"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<x [fm]\>\"", ",", 
       "\"\<transverse velocity (\!\(\*SubscriptBox[\(v\), \(T\)]\))\>\""}], 
      "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"styles", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.659185967353175*^9, 3.6591859812082787`*^9}, 
   3.6591862584460382`*^9, {3.659203523740514*^9, 
   3.65920354138614*^9}},ExpressionUUID->"8b5bb86e-4f50-4764-9922-\
da85f97993d4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rat1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}], "/", 
      RowBox[{
       RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[Alpha]\), \(x\)]\)/\!\(\*SubscriptBox[\(\
\[Alpha]\), \(y\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rat2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}], "/", 
      RowBox[{
       RowBox[{"int", "[", "\"\<ax\>\"", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[Alpha]\), \(z\)]\)/\!\(\*SubscriptBox[\(\
\[Alpha]\), \(x\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rat3", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"int", "[", "\"\<az\>\"", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}], "/", 
      RowBox[{
       RowBox[{"int", "[", "\"\<ay\>\"", "]"}], "[", 
       RowBox[{"x", ",", "0"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "range"}], ",", "range"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x [fm]\>\"", ",", 
        "\"\<\!\(\*SubscriptBox[\(\[Alpha]\), \(z\)]\)/\!\(\*SubscriptBox[\(\
\[Alpha]\), \(y\)]\)\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"styles", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"rat1", ",", "rat2", ",", "rat3"}], "}"}], "}"}], "]"}]}], "Input",\

 CellChangeTimes->{{3.659186015848158*^9, 
  3.659186085716782*^9}},ExpressionUUID->"155054d1-7358-4035-a00a-\
338fed6716f8"]
}, Open  ]]
},
WindowSize->{1178, 767},
WindowMargins->{{30, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 16, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 352, 6, 64, "Section", "ExpressionUUID" -> \
"1df2b639-cf42-4be6-9bbb-90e678a340b9"],
Cell[935, 30, 341, 7, 32, "Input", "ExpressionUUID" -> \
"9ce7f5ac-4ab3-4593-9134-8ae96cf6f792"],
Cell[1279, 39, 594, 12, 32, "Input", "ExpressionUUID" -> \
"882e0a15-d27c-43d5-ac34-7524d2769bd4"],
Cell[1876, 53, 494, 10, 32, "Input", "ExpressionUUID" -> \
"e04e06e2-da9b-4c82-8d33-00f6e5c66499"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2407, 68, 225, 4, 64, "Section", "ExpressionUUID" -> \
"9c1eaf7f-660e-487f-bbf8-06714b29a1af"],
Cell[2635, 74, 2274, 57, 114, "Input", "ExpressionUUID" -> \
"db23522d-304e-4c41-b865-67fc0af53837"],
Cell[4912, 133, 6574, 150, 420, "Input", "ExpressionUUID" -> \
"314273b6-f9e9-4c6b-b85c-cde20d18f251"]
}, Closed]],
Cell[CellGroupData[{
Cell[11523, 288, 373, 6, 50, "Section", "ExpressionUUID" -> \
"979a83b9-9eb4-40c8-a738-bb7b328536d7"],
Cell[11899, 296, 11019, 271, 621, "Input", "ExpressionUUID" -> \
"51a31ef6-8db6-4c2c-8900-1706edfbd9e5"]
}, Closed]],
Cell[CellGroupData[{
Cell[22955, 572, 357, 6, 50, "Section", "ExpressionUUID" -> \
"cd894222-4171-4ef3-8daa-00c404046506"],
Cell[23315, 580, 13656, 186, 32, "Input", "ExpressionUUID" -> \
"ba65b7b4-5b40-43e8-aebb-1e29ef1ab9c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37008, 771, 277, 5, 64, "Section", "ExpressionUUID" -> \
"4b469471-cfff-4d04-9656-79c890eba19c"],
Cell[37288, 778, 1081, 26, 117, "Input", "ExpressionUUID" -> \
"339a6697-8aed-46dd-9451-546019ae9d54"],
Cell[38372, 806, 5165, 147, 184, "Input", "ExpressionUUID" -> \
"3ddbaf83-0269-4d7b-a2e0-1360f040fa3a"],
Cell[43540, 955, 787, 21, 32, "Input", "ExpressionUUID" -> \
"8b5bb86e-4f50-4764-9922-da85f97993d4"],
Cell[44330, 978, 2684, 80, 100, "Input", "ExpressionUUID" -> \
"155054d1-7358-4035-a00a-338fed6716f8"]
}, Open  ]]
}
]
*)

